#include <bits/stdc++.h>

using namespace std;

const int T = 1610;
const int Q = 1100000;
const int INF = (int)(1e9);

struct segtree {
    vector<pair<int, int>> vv; int n;
    segtree() {}
    segtree(int n) {
        this->n = n;
        vv = vector<pair<int, int>>(4 * n + 1, {INF, INF});
    }
    void upd(int l, int r, pair<int, int> x) {
        upd(1, 0, n - 1, l, r, x);
    }
    pair<int, int> get(int k) {
        return get(1, 0, n - 1, k);
    }
    void upd(int v, int l, int r, int ql, int qr, pair<int, int> x) {
        if (qr < l || r < ql)
            return;
        if (ql <= l && r <= qr) {
            vv[v] = min(vv[v], x);
            return;
        }
        int mid = (l + r) / 2;
        upd(v * 2 + 0, l, mid, ql, qr, x);
        upd(v * 2 + 1, mid + 1, r, ql, qr, x);
    }
    pair<int, int> get(int v, int l, int r, int k) {
        if (l == r)
            return vv[v];
        int mid = (l + r) / 2;
        pair<int, int> ans = vv[v];
        if (k <= mid)
            ans = min(ans, get(v * 2 + 0, l, mid, k));
        else
            ans = min(ans, get(v * 2 + 1, mid + 1, r, k));
        return ans;
    }
};

bool ans[T][T], to[T], res[Q];
int to_cnt, to_nxt[T], sz1[T], sz2[T], L2[T], V2[T], L1[T], V1[T];
int N, n, M, m, k, q, qx[Q], qy[Q], l1[T], r1[T], t1[T], l2[T], r2[T], t2[T], ld[T], rd[T], ll1[T], rr1[T], ll2[T], rr2[T];
vector<int> s1[T], s2[T], pp[T], qq[T][T];
segtree ss[T];

void solve_fast() {
    for (int i = 1; i < T; i++) {
        s1[i].clear();
        s2[i].clear();
        pp[i].clear();
        for (int j = 1; j < T; j++)
            qq[i][j].clear();
    }
    for (int i = 1; i <= k; i++)
        sz1[i] = 0;
    int SZ = 0;
    for (int i = 1; i <= n; i++) {
        int L = L1[i], V = V1[i];
        l1[i] = sz1[V] + 1;
        r1[i] = sz1[V] + L;
        sz1[V] += L;
        ll1[i] = SZ + 1;
        rr1[i] = SZ + L;
        SZ += L;
        t1[i] = V;
        s1[V].push_back(i);
    }
    for (int i = 1; i <= k; i++)
        sz2[i] = 0;
    SZ = 0;
    for (int i = 1; i <= m; i++) {
        int L = L2[i], V = V2[i];
        l2[i] = sz2[V] + 1;
        r2[i] = sz2[V] + L;
        sz2[V] += L;
        ll2[i] = SZ + 1;
        rr2[i] = SZ + L;
        SZ += L;
        t2[i] = V;
        s2[V].push_back(i);
    }
    for (int i = 1; i <= q; i++) {
        int p1 = upper_bound(ll1 + 1, ll1 + n + 1, qx[i]) - ll1 - 1;
        int p2 = upper_bound(ll2 + 1, ll2 + m + 1, qy[i]) - ll2 - 1;
        //cout << p1 << ':' << p2 << endl;
        qq[p1][p2].push_back(i);
    }
    for (int i = 1; i <= k; i++)
        ld[i] = INF, rd[i] = -INF;
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++) {
            if (t1[i] != t2[j])
                continue;
            ld[t1[i]] = min(ld[t1[i]], l1[i] - r2[j]);
            rd[t1[i]] = max(rd[t1[i]], r1[i] - l2[j]);
            pp[t1[i]].push_back(l1[i] - r2[j]);
            pp[t1[i]].push_back(r1[i] - l2[j]);
        }
    for (int i = 1; i <= k; i++) {
        ld[i] = min(ld[i], rd[i]);
        sort(begin(pp[i]), end(pp[i]));
        pp[i].erase(unique(begin(pp[i]), end(pp[i])), end(pp[i]));
        ss[i] = segtree((int) pp[i].size());
    }
    for (int i = 1; i <= k; i++)
        to_nxt[i] = -1;
    for (int i = n; i >= 1; i--) {
        int cur = t1[i];
        to_nxt[cur] = i;
        //cout << cur << "TT" << endl;
        to_cnt = 0;
        for (int j = 1; j <= k; j++)
            to[j] = false;
        for (int j = m; j >= 1; j--) {
            if (t2[j] != cur) {
                int cur_j = t2[j];
                bool win = false;
                if (to_nxt[cur_j] != -1 && !ans[to_nxt[cur_j]][j])
                    win = true;
                to_cnt -= to[cur_j];
                to[cur_j] = win;
                to_cnt += to[cur_j];
                continue;
            }
            //cout << i << ' ' << j << ' ' << to_cnt << endl;
            if (to_cnt == 0) {
                int diff = l1[i] - l2[j];
                //cout << diff << "TT" << endl;
                diff = upper_bound(begin(pp[cur]), end(pp[cur]), diff) - begin(pp[cur]) - 1;
                //cout << diff << "TT" << endl;
                auto [ti, tj] = ss[cur].get(diff);
                //cout << ti << ' ' << tj << "TT" << endl;
                if (ti == INF)
                    ans[i][j] = min(sz1[cur] - l1[i], sz2[cur] - l2[j]) % 2 != 0;
                else
                    ans[i][j] = max(l1[ti] - l1[i], l2[tj] - l2[j]) % 2 == 0;
                for (int k : qq[i][j]) {
                    int px = qx[k] - ll1[i] + l1[i];
                    int py = qy[k] - ll2[j] + l2[j];
                    int diff = px - py;
                    diff = upper_bound(begin(pp[cur]), end(pp[cur]), diff) - begin(pp[cur]) - 1;
                    auto [ti, tj] = ss[cur].get(diff);
                    if (ti == INF)
                        res[k] = min(sz1[cur] - px, sz2[cur] - py) % 2 == 0;
                    else
                        res[k] = max(l1[ti] - px, l2[tj] - py) % 2 != 0;
                }
            } else {
                for (int k : qq[i][j])
                    res[k] = true;
                //cout << i << ' ' << j << endl;
                ans[i][j] = true;
                int ldiff = l1[i] - r2[j];
                int rdiff = r1[i] - l2[j] + 1;
                //cout << ldiff << ' ' << rdiff << '\n';
                ldiff = lower_bound(begin(pp[cur]), end(pp[cur]), ldiff) - begin(pp[cur]);
                rdiff = lower_bound(begin(pp[cur]), end(pp[cur]), rdiff) - begin(pp[cur]) - 1;
                //cout << ldiff << ' ' << rdiff << '\n';
                ss[cur].upd(ldiff, rdiff, {i, j});
            }
            //if (ans[i][j]) cout << i << "-" << j << endl;
        }
    }
}

vector<int> a, b;
bool res_slow[Q], dp[T][T];

void solve_slow() {
    a.clear();
    b.clear();
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= L1[i]; j++)
            a.push_back(V1[i]);
    for (int i = 1; i <= m; i++)
        for (int j = 1; j <= L2[i]; j++)
            b.push_back(V2[i]);
    for (int i = N; i >= 0; i--)
        for (int j = M; j >= 0; j--) {
            dp[i][j] = false;
            for (int t = 1; t <= k; t++) {
                int px = i;
                while (px < N && a[px] != t)
                    px++;
                int py = j;
                while (py < M && b[py] != t)
                    py++;
                if (px < N && py < M && !dp[px + 1][py + 1])
                    dp[i][j] = true;
            }
        }
    for (int i = 1; i <= q; i++)
        res_slow[i] = dp[qx[i] - 1][qy[i] - 1];
}

void solve() {
    cin >> N >> n >> M >> m >> k >> q;
    for (int i = 1; i <= n; i++)
        cin >> L1[i] >> V1[i];
    for (int i = 1; i <= m; i++)
        cin >> L2[i] >> V2[i];
    for (int i = 1; i <= q; i++) {
        cin >> qx[i] >> qy[i];
        qx[i]++;
        qy[i]++;
    }
    solve_fast();
    for (int i = 1; i <= q; i++)
        if (res[i]) cout << "Yes\n";
        else cout << "No\n";
}

int32_t main() {
    ios::sync_with_stdio(0); cin.tie(0);
    solve();
    return 0;
    int mx; cin >> mx;
    cin >> n >> m >> k >> q;
    int cnt = 0;
    while (true) {
        cout << cnt << '\n';
        cnt++;
        L1[1] = V1[1] = L2[1] = V2[1] = 1;
        for (int i = 2; i <= n; i++)
            L1[i] = rand() % mx + 1, V1[i] = rand() % k + 1;
        for (int i = 2; i <= m; i++) {
            L2[i] = rand() % mx + 1;
            V2[i] = rand() % k + 1;
        }
        N = 0;
        M = 0;
        for (int i = 1; i <= n; i++)
            N += L1[i];
        for (int i = 1; i <= m; i++)
            M += L2[i];
        for (int i = 1; i <= q; i++) {
            qx[i] = qy[i] = 0;
            qx[i]++;
            qy[i]++;
        }
        solve_slow();
        solve_fast();
        bool good = true;
        for (int i = 1; i <= q; i++)
            if (res[i] != res_slow[i])
                good = false;
        if (!good) {
            cout << "UNGOOD\n";
            cout << N << ' ' << n << ' ' << M << ' ' << m << ' ' << k << ' ' << q << '\n';
            for (int i = 1; i <= n; i++)
                cout << L1[i] << ' ' << V1[i] << '\n';
            for (int i = 1; i <= m; i++)
                cout << L2[i] << ' ' << V2[i] << '\n';
            for (int i = 1; i <= q; i++)
                cout << qx[i] - 1 << ' ' << qy[i] - 1 << '\n';
            for (int i = 1; i <= q; i++) {
                if (res[i]) cout << "Yes ";
                else cout << "No ";
                if (res_slow[i]) cout << "Yes\n";
                else cout << "No\n";
            }
            return 0;
        }
    }
}