#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <cmath>
#include <set>
#include <random>
using namespace std;

#define all(x) x.begin(), x.end()
#define sz(x) static_cast<lng>(x.size())

using lng = long long;

void solve() {
	int N, M, n, m, k, q; cin >> N >> n >> M >> m >> k >> q;
	vector<int> a(N), b(M);
	vector<vector<int>> grundy(N + 1, vector<int>(M + 1, 0));
	vector<vector<int>> positions_b(k + 1, vector<int>(0));
	int cur1 = 0, cur2 = 0;
	for (int i = 0; i < n; i++) {
		int len, val; cin >> len >> val;
		for (int j = cur1; j < cur1 + len; j++) {
			a[j] = val;
		}
		cur1 += len;
	}
	for (int i = 0; i < m; i++) {
		int len, val; cin >> len >> val;
		for (int j = cur2; j < cur2 + len; j++) {
			b[j] = val;
			positions_b[b[j]].push_back(j);
		}
		cur2 += len;
	}
	for (int i = N; i >= 0; i--) {
		for (int j = M; j >= 0; j--) {
			vector<int> values;
			vector<int> last(k + 1, -1);
			for (int k = i + 1; k <= N; k++) {
				if (last[a[k - 1]] != -1) {
					continue;
				}
				last[a[k - 1]] = k - 1;
				int p = lower_bound(all(positions_b[a[k - 1]]), j) - positions_b[a[k - 1]].begin();
				if (p < sz(positions_b[a[k - 1]])) {
					values.push_back(grundy[k][positions_b[a[k - 1]][p] + 1]);
				}
			}
			sort(all(values));
			int mex = 0;
			for (int elem : values) {
				if (elem > mex) {
					break;
				}
				if (elem == mex) {
					mex++;
				}
			}
			grundy[i][j] = mex;
		}
	}
	for (int t = 0; t < q; t++) {
		int x, y; cin >> x >> y;
		if (grundy[x][y]) {
			cout << "Yes\n";
		}
		else {
			cout << "No\n";
		}
	}
}

int main() { 
	cin.tie(nullptr)->sync_with_stdio(false);
	int t = 1;
	while (t--) {
		solve();
	}
	return 0;
}
