#include "bits/extc++.h"

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

template<typename T>
istream &operator>>(istream &is, vector<T> &a);

template<typename T>
ostream &operator<<(ostream &os, vector<T> &a);


using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int N, n, M, m, k, q;
    cin >> N >> n >> M >> m >> k >> q;

    vector<int> a;
    vector<int> b;
    for (int i = 0; i < n; ++i) {
        int l, v;
        cin >> l >> v;

        while (l--)a.push_back(v);
    }
    for (int i = 0; i < m; ++i) {
        int l, v;
        cin >> l >> v;

        while (l--)b.push_back(v);
    }

    vector<int> comp;
    for (auto v: a) comp.push_back(v);
    for (auto v: b) comp.push_back(v);
    std::sort(comp.begin(), comp.end());
    comp.erase(std::unique(comp.begin(), comp.end()),comp.end());
    for (int i = 0; i < N; ++i) {
        a[i] = lower_bound(comp.begin(),comp.end(), a[i]) - comp.begin();
    }
    for (int i = 0; i < M; ++i) {
        b[i] = lower_bound(comp.begin(),comp.end(), b[i]) - comp.begin();
    }

    k = comp.size();
    n = N;
    m = M;

    vector<vector<int>> ind1(k);
    vector<vector<int>> ind2(k);
    for (int i = 0; i < n; ++i) {
        ind1[a[i]].push_back(i);
    }
    for (int i = 0; i < m; ++i) {
        ind2[b[i]].push_back(i);
    }
    for (int i = 0; i < k; ++i) {
        ind1[i].push_back(n);
        ind2[i].push_back(m);
    }

    vector<vector<int>> dp(n + 1, vector<int>(m + 1));
    for (int l1 = n - 1; l1 >= 0; --l1) {
        for (int l2 = m - 1; l2 >= 0; --l2) {
            vector<int> vals;
            for (int v = 0; v < k; ++v) {
                int r1 = *lower_bound(ind1[v].begin(), ind1[v].end(), l1);
                int r2 = *lower_bound(ind2[v].begin(), ind2[v].end(), l2);
                if (r1 < n && r2 < m) vals.push_back(dp[r1+1][r2+1]);
            }
            std::sort(vals.begin(), vals.end());
            int mex = 0;
            for (auto v: vals) mex += (v == mex);
            dp[l1][l2] = mex;
        }
    }

    for (int i = 0; i < q; ++i) {
        int x, y;
        cin >> x >> y;

        cout << (dp[x][y] ? "Yes" : "No") << "\n";
    }
}

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &v: a) is >> v;
    return is;
}

template<typename T>
ostream &operator<<(ostream &os, vector<T> &a) {
    for (auto v: a) os << v << " ";
    return (os << "\n");
}
