#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;

using namespace std;

//#define int long long
#define double long double

typedef tree<int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef tree<int, null_type, less_equal <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_multi_set;

int inf = (int)1000 * 1000 * 1000;

struct st //+=, sum
{
    vector <int> t;
    vector <int> p;

    void build(int n)
    {
        t.resize(4 * n, 0);
        p.resize(4 * n, 0);
    }

    void push(int v, int l, int r)
    {
        if (p[v] != 0)
        {
            p[v * 2 + 1] += p[v];
            p[v * 2 + 2] += p[v];
            int m = (l + r) / 2;
            t[v * 2 + 1] += (m - l + 1) * p[v];
            t[v * 2 + 2] += (r - m) * p[v];
            p[v] = 0;
        }
    }

    int get(int v, int l, int r, int ll, int rr)
    {
        if (ll > rr)
        {
            return 0;
        }
        if (l == ll && r == rr)
        {
            return t[v];
        }

        int m = (l + r) / 2;
        push(v, l, r);
        return get(v * 2 + 1, l, m, ll, min(m, rr)) +
               get(v * 2 + 2, m + 1, r, max(m + 1, ll), rr);
    }

    void update(int v, int l, int r, int ll, int rr, int x)
    {
        if (ll > rr)
        {
            return;
        }
        if (l == ll && r == rr)
        {
            t[v] += x * (r - l + 1);
            p[v] += x;
            return;
        }
        int m = (l + r) / 2;
        push(v, l, r);
        update(v * 2 + 1, l, m, ll, min(m, rr), x);
        update(v * 2 + 2, m + 1, r, max(m + 1, ll), rr, x);
        t[v] = t[v * 2 + 1] + t[v * 2 + 2];
    }
};

int mod = 1000 * 1000 * 1000 + 7;

int bin_pow(int a, int x)
{
    if (x == 0)
    {
        return 1;
    }
    if (x % 2 == 0)
    {
        return bin_pow((a * a) % mod, x / 2);
    }
    return (a * bin_pow((a * a) % mod, x / 2)) % mod;
}

int add(int a, int b)
{
    if (a + b >= mod)
    {
        return a + b - mod;
    }
    return a + b;
}

int umn(int a, int b)
{
    return (a * b) % mod;
}

int del(int a, int b)
{
    return umn(a, bin_pow(b, mod - 2));
}

void solve()
{
    int N, n, M, m, k, q;
    cin >> N >> n >> M >> m >> k >> q;

    vector <int> a;
    vector <int> b;

    for (int i = 0; i < n; i ++)
    {
        int l, x;
        cin >> l >> x;
        for (int j = 0; j < l; j ++)
        {
            a.push_back(x);
        }
    }
    for (int i = 0; i < m; i ++)
    {
        int l, x;
        cin >> l >> x;
        for (int j = 0; j < l; j ++)
        {
            b.push_back(x);
        }
    }

    n = N;
    m = M;

    vector <vector <pair <bool, bool>>> dp(n, vector <pair <bool, bool>> (m));

    for (int i = 0; i < m; i ++)
    {
        if (i == 0)
        {
            if (a[0] == b[0])
            {
                dp[0][0] = {true, false};
            }
            else
            {
                dp[0][0] = {false, true};
            }
        }
        else
        {
            if (dp[0][i - 1].first || a[0] == b[i])
            {
                dp[0][i] = {true, false};
            }
            else
            {
                dp[0][i] = {false, true};
            }
        }
    }

    for (int i = 0; i < n; i ++)
    {
        if (i == 0)
        {
            if (a[0] == b[0])
            {
                dp[0][0] = {true, false};
            }
            else
            {
                dp[0][0] = {false, true};
            }
        }
        else
        {
            if (dp[i - 1][0].first || a[i] == b[0])
            {
                dp[i][0] = {true, false};
            }
            else
            {
                dp[i][0] = {false, true};
            }
        }
    }

    for (int i = 1; i < n; i ++)
    {
        for (int j = 1; j < n; j ++)
        {
            if (a[i] != b[j])
            {
                dp[i][j] = {dp[i - 1][j].first || dp[i][j - 1].first,
                            dp[i - 1][j].second || dp[i][j - 1].second};
            }
            else
            {
                dp[i][j] = {dp[i - 1][j - 1].second, dp[i - 1][j - 1].first};
            }
        }
    }

    for (int i = 0; i < q; i ++)
    {
        int x, y;
        cin >> x >> y;
        if (dp[n - x - 1][m - y - 1].first)
        {
            cout << "Yes" << '\n';
        }
        else
        {
            cout << "No" << '\n';
        }
    }

    /*
    for (int i = 0; i < n; i ++)
    {
        for (int j = 0; j < m; j ++)
        {
            cout << dp[i][j].first << " ";
        }
        cout << '\n';
    }
     */
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    int _ = 1;
    //cin >> _;
    while (_ --)
    {
        solve();
    }
}
