#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (T& x : v) in >> x;
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, vector<T>& v) {
    for (T& x : v) out << x << " ";
    return out;
}

template<typename T1, typename T2>
istream& operator>>(istream& in, pair<T1, T2>& p) {
    in >> p.first >> p.second;
    return in;
}

template<typename T1, typename T2>
ostream& operator<<(ostream& out, pair<T1, T2>& p) {
    out << p.first << " " << p.second;
    return out;
}

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
using ll = long long;
using ld = long double;

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

void solve() {
    int N, n, M, m, k, q;
    cin >> N >> n >> M >> m >> k >> q;
    vector<pair<int, int>> sa(n), sb(m);
    for (auto& [a, b] : sa) cin >> a >> b, b--;
    for (auto& [a, b] : sb) cin >> a >> b, b--;
    vector<pair<int, int>> qr(q);
    for (auto& [a, b] : qr) cin >> a >> b;

    if (max(N, M) <= 5000) {
        vector<int> a, b;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < sa[i].first; j++) a.push_back(sa[i].second);
        }
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < sb[i].first; j++) b.push_back(sb[i].second);
        }

//        for (int x : a) cout << x << " ";
//        cout << "\n";
//        for (int x : b) cout << x << " ";
//        cout << "\n";

        vector<vector<bool>> dp(N + 1, vector<bool>(M + 1)), must(N + 1, vector<bool>(M + 1));
        vector<int> mxa(k), mxb(k);
        vector<vector<int>> posa(k), posb(k);
        for (int i = 0; i < N; i++) {
            mxa[a[i]] = i;
            posa[a[i]].push_back(i);
        }
        for (int i = 0; i < M; i++) {
            mxb[b[i]] = i;
            posb[b[i]].push_back(i);
        }

        for (int i = N - 1; i >= 0; i--) {
            for (int j = M - 1; j >= 0; j--) {
                int pos = lower_bound(all(posb[a[i]]), j) - posb[a[i]].begin();
                if (pos < posb[a[i]].size() && !dp[i + 1][posb[a[i]][pos] + 1]) must[i][j] = true;

                pos = lower_bound(all(posa[b[j]]), i) - posa[b[j]].begin();
                if (pos < posa[b[j]].size() && !dp[posa[b[j]][pos] + 1][j + 1]) must[i][j] = true;

                if (max(mxa[a[i]], mxa[b[j]]) + 1 < N && max(mxb[a[i]], mxb[b[j]]) + 1 < M &&
                    !must[max(mxa[a[i]], mxa[b[j]]) + 1][max(mxb[a[i]], mxb[b[j]]) + 1]) must[i][j] = true;

                pos = lower_bound(all(posb[a[i]]), j) - posb[a[i]].begin();
                if (pos < posb[a[i]].size() && !dp[i + 1][posb[a[i]][pos] + 1]) dp[i][j] = true;

                pos = lower_bound(all(posa[b[j]]), i) - posa[b[j]].begin();
                if (pos < posa[b[j]].size() && !dp[posa[b[j]][pos] + 1][j + 1]) dp[i][j] = true;

                if (max(mxa[a[i]], mxa[b[j]]) + 1 < N && max(mxb[a[i]], mxb[b[j]]) + 1 < M &&
                    !must[max(mxa[a[i]], mxa[b[j]]) + 1][max(mxb[a[i]], mxb[b[j]]) + 1]) dp[i][j] = true;
            }
        }

//        for (int i = 0; i <= N; i++) {
//            for (int j = 0; j <= M; j++) {
//                cout << i << " " << j << ": " << dp[i][j] << "\n";
//            }
//        }

        for (auto [a, b] : qr) {
            if (dp[a][b]) cout << "Yes\n";
            else cout << "No\n";
        }
        return;
    }
}

signed main() {
#ifndef LOCAL
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
#endif

    int t = 1;
//    cin >> t;
    while (t--) solve();
}