#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (T& x : v) in >> x;
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, vector<T>& v) {
    for (T& x : v) out << x << " ";
    return out;
}

template<typename T1, typename T2>
istream& operator>>(istream& in, pair<T1, T2>& p) {
    in >> p.first >> p.second;
    return in;
}

template<typename T1, typename T2>
ostream& operator<<(ostream& out, pair<T1, T2>& p) {
    out << p.first << " " << p.second;
    return out;
}

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
using ll = long long;
using ld = long double;

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

void solve() {
    int N, n, M, m, k, q;
    cin >> N >> n >> M >> m >> k >> q;
    vector<pair<int, int>> sa(n), sb(m);
    for (auto& [a, b] : sa) cin >> a >> b, b--;
    for (auto& [a, b] : sb) cin >> a >> b, b--;
    vector<pair<int, int>> qr(q);
    for (auto& [a, b] : qr) cin >> a >> b;

    vector dp(n + 1, vector(m + 1, vector<bool>(k)));
    vector an(n + 1, vector<bool>(m + 1)), al(n + 1, vector<bool>(m + 1));
    vector<int> mxa(k, -1), mxb(k, -1);
    vector<vector<int>> posa(k), posb(k);
    for (int i = 0; i < n; i++) {
        mxa[sa[i].second] = i;
        posa[sa[i].second].push_back(i);
    }
    for (int i = 0; i < m; i++) {
        mxb[sb[i].second] = i;
        posb[sb[i].second].push_back(i);
    }

    for (int i = n - 1; i >= 0; i--) {
        for (int j = m - 1; j >= 0; j--) {
            al[i][j] = true;
            for (int x = 0; x < k; x++) {
                int pos1 = lower_bound(all(posa[x]), i) - posa[x].begin();
                int pos2 = lower_bound(all(posb[x]), j) - posb[x].begin();
                if (pos1 < posa[x].size() && pos2 < posb[x].size()) {
                    if (min(sa[posa[x][pos1]].first, sb[posb[x][pos2]].first) % 2 == 1) {
                        if (!al[posa[x][pos1] + 1][posb[x][pos2] + 1]) dp[i][j][x] = true;
                    } else {
                        if (an[posa[x][pos1] + 1][posb[x][pos2] + 1]) dp[i][j][x] = true;
                    }
                }
                if (dp[i][j][x]) an[i][j] = true;
                else al[i][j] = false;
            }
        }
    }
    for (auto [a, b] : qr) {
        int pos1 = 0, s1 = sa[0].first, pos2 = 0, s2 = sb[0].first;
        while (s1 <= a) {
            pos1++;
            s1 += sa[pos1].first;
        }
        while (s2 <= b) {
            pos2++;
            s2 += sb[pos2].first;
        }
        
        bool is = false;
        for (int x = 0; x < k; x++) {
            if (x == sa[pos1].second) {
                if ((min(sa[pos1].first, sb[pos2].first) % 2 == min(sa[pos1].first - (s1 - (a + 1)), sb[pos2].first - (s2 - (b + 1))) ? dp[pos1][pos2][x] : !dp[pos1][pos2][x])) {
                    is = true;
                }
            } else {
                if (dp[pos1][pos2][x]) is = true;
            }
        }
        
        if (is) cout << "Yes\n";
        else cout << "No\n";
    }
}

signed main() {
#ifndef LOCAL
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
#endif

    int t = 1;
//    cin >> t;
    while (t--) solve();
}