#include <iostream>
#include <random>
#include <numeric>
#include <algorithm>
#include <vector>
#include <map>
#include <set>

using namespace std;
using ll = long long;
using ull = unsigned long long;

constexpr int maxn = 5010;
int N, M, n, m, k;
int a[maxn], b[maxn];
bool dp[maxn][maxn];

void solve() {
    int q;
    cin >> N >> n >> M >> m >> k >> q;
    for (int i = 0, pl = 0, l, v; i < n; ++i) {
        cin >> l >> v;
        for (int j = pl; j < pl + l; ++j) a[j] = v;
        pl += l;
    }
    for (int i = 0, pl = 0, l, v; i < m; ++i) {
        cin >> l >> v;
        for (int j = pl; j < pl + l; ++j) b[j] = v;
        pl += l;
    }
    for (int i = N - 1; i >= 0; --i) {
        for (int j = M - 1; j >= 0; --j) {
            for (int v = 1; v <= k && !dp[i][j]; ++v) {
                int pa = i, pb = j;
                while (pa < N && a[pa] != v) ++pa;
                while (pb < M && b[pb] != v) ++pb;
                if (pa < N && pb < N && !dp[pa + 1][pb + 1]) dp[i][j] = true;
            }
        }
    }
    for (int i = 0, x, y; i < q; ++i) {
        cin >> x >> y;
        if (dp[x][y]) cout << "Yes\n";
        else cout << "No\n";
    }
}

int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);
    ll t = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> t;
#else
#ifdef TEST
    freopen("input.txt", "r", stdin);
#else
#endif
#endif
    while (t--) {
        solve();
        cout << "\n";
    }
    return 0;
}
