#include <iostream>
#include <random>
#include <numeric>
#include <algorithm>
#include <vector>
#include <map>
#include <set>

using namespace std;
using ll = long long;
using ull = unsigned long long;

constexpr int maxn = 5010;
int N, M, n, m, k;
int a[maxn], b[maxn];
bool dp[maxn][maxn];
vector<int> all_vals;
int a_can[maxn * 2], b_can[maxn * 2];
int a_lns[maxn], b_lns[maxn], pfla[maxn], pflb[maxn];

int zip(int x) {
    return lower_bound(all_vals.begin(), all_vals.end(), x) - all_vals.begin();
}

void solve() {
    int q;
    cin >> N >> n >> M >> m >> k >> q;
    for (int i = 0; i < n; ++i) {
        cin >> a_lns[i] >> a[i];
        all_vals.push_back(a[i]);
    }
    for (int i = 0; i < m; ++i) {
        cin >> b_lns[i] >> b[i];
        all_vals.push_back(b[i]);
    }
    for (int i = 0; i < n; ++i) pfla[i + 1] = pfla[i] + a_lns[i];
    for (int i = 0; i < m; ++i) pflb[i + 1] = pflb[i] + b_lns[i];
    sort(all_vals.begin(), all_vals.end());
    all_vals.erase(unique(all_vals.begin(), all_vals.end()), all_vals.end());
    for (int i = 0; i < n; ++i) a[i] = zip(a[i]);
    for (int i = 0; i < m; ++i) b[i] = zip(b[i]);
    k = all_vals.size();
    for (int i = 0; i < k; ++i) a_can[i] = -1;
    for (int i = n - 1; i >= 0; --i) {
        for (int j = 0; j < k; ++j) b_can[j] = -1;
        a_can[a[i]] = i;
        int lose_cnt = 0;
        for (int j = m - 1; j >= 0; --j) {
            if (a_can[b[j]] != -1 && b_can[b[j]] != -1 && !dp[a_can[b[j]] + 1][b_can[b[j]] + 1]) --lose_cnt;
            b_can[b[j]] = j;
            if (a_can[b[j]] != -1 && !dp[a_can[b[j]] + 1][b_can[b[j]] + 1]) ++lose_cnt;
            dp[i][j] = lose_cnt > 0;
        }
    }
    for (int i = 0, x, y; i < q; ++i) {
        cin >> x >> y;
        int abl = upper_bound(pfla, pfla + n + 1, x) - pfla;
        int bbl = upper_bound(pflb, pflb + n + 1, x) - pflb;
        int asz = x - pfla[abl - 1];
        int bsz = y - pflb[bbl - 1];
        if (dp[abl][bbl] || std::min(asz, bsz) % 2 == 1) cout << "Yes\n";
        else cout << "No\n";
    }
}

int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);
    ll t = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> t;
#else
#ifdef TEST
    freopen("input.txt", "r", stdin);
#else
#endif
#endif
    while (t--) {
        solve();
        cout << "\n";
    }
    return 0;
}
