#include <bits/stdc++.h>

#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()

using namespace std;
using ll = long long;
using ld = long double;

const ll infll = (ll) 1e18;
const int inf = (int) 1e9;
const ll MOD = 1e9 + 7;

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

ll mod(ll a) {
    ll r = a % MOD;
    if (r < 0) {
        return r + MOD;
    }
    return r;
}

int lcp(vector<int> &a, vector<int> &b) {
    int n = sz(a), m = sz(b);
    vector<vector<int>> dp(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (i != 0) {
                dp[i][j] = max(dp[i][j], dp[i - 1][j]);
            }
            if (j != 0) {
                dp[i][j] = max(dp[i][j], dp[i][j - 1]);
            }
            if (a[i] == b[j]) {
                int cur = 1;
                if (i != 0 && j != 0) {
                    cur += dp[i - 1][j - 1];
                }
                dp[i][j] = max(dp[i][j], cur);
            }
        }
    }
    return dp[n - 1][m - 1];
}

void solve() {
    int N, n, M, m, k, q;
    cin >> N >> n >> M >> m >> k >> q;
    vector<pair<int, int>> f(n), s(m);
    for (int i = 0; i < n; ++i) {
        cin >> f[i].first >> f[i].second;
    }
    for (int i = 0; i < m; ++i) {
        cin >> s[i].first >> s[i].second;
    }
    for (int _ = 0; _ < q; ++_) {
        int x, y;
        cin >> x >> y;
        vector<int> a, b;
        for (int j = 0; j < n; ++j) {
            if (x >= f[j].first) {
                x -= f[j].first;
            } else {
                int d = f[j].first - x;
                for (int i = 0; i < d; ++i) {
                    a.push_back(f[j].second);
                }
            }
        }
        for (int j = 0; j < m; ++j) {
            if (y >= s[j].first) {
                y -= s[j].first;
            } else {
                int d = s[j].first - y;
                for (int i = 0; i < d; ++i) {
                    b.push_back(s[j].second);
                }
            }
        }
        if (lcp(a, b) % 2) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int T = 1;
    //cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}