#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

//#define int long long
using ll = long long;

typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
const int inf = 1e9 + 7;
const ll inf_ = 1e18 + 7;
const int mod = 998244353;

struct Hash {
    int mod2 = 1e9 + 7, p2 = 239;

    int sum(int a, int b) {
        a += b;
        if (a >= mod2) a -= mod2;
        return a;
    }

    int sub(int a, int b) {
        a -= b;
        if (a < 0) a += mod2;
        return a;
    }

    int mul(int a, int b) {
        return a * 1ll * b % mod2;
    }

    vector<int> h, pr;

    Hash(string s) {
        int n = s.size();
        h.resize(n);
        pr.resize(n + 1);
        h[0] = s[0];
        pr[0] = 1;
        for (int i = 1; i < n; i++)
            h[i] = sum(s[i], mul(h[i - 1], p2));
        for (int i = 1; i <= n; i++)
            pr[i] = mul(pr[i], p2);
    }

    int get(int l, int r) {
        return 0;
    }
};

struct Fast {
    vector<vector<int>> clc(int n, deque<int> a, int m, deque<int> b, int k) {
        vector<vector<int>> dp(n, vector<int>(m, 0));
        vector<int> to_a(k, n), to_b(k, m);
        vector<int> sz_a(k), sz_b(k);
        for (int i = n - 1; i >= 0; i--) {
            to_b.assign(k, m);
            to_a[a[i]] = i;
            set<int> tos;
            for (int j = m - 1; j >= 0; j--) {
                if (to_a[b[j]] != n)
                    tos.insert(b[j]);
                to_b[b[j]] = j;
                if (tos.contains(b[j])) {
                    if (!(to_a[b[j]] + 1 < n && to_b[b[j]] + 1 < m && dp[to_a[b[j]] + 1][to_b[b[j]] + 1] == 0)) {
                        tos.erase(b[j]);
                    }
                }
                if (!(to_a[a[n - 1]] == n || to_b[a[n - 1]] == m) &&
                    (to_a[a[n - 1]] + 1 == n || to_b[a[n - 1]] + 1 == m)) {
                    dp[i][j] = 1;
                    continue;
                }
                if (!(to_a[b[m - 1]] == n || to_b[b[m - 1]] == m) &&
                    (to_a[b[m - 1]] + 1 == n || to_b[b[m - 1]] + 1 == m)) {
                    dp[i][j] = 1;
                    continue;
                }
                if (!tos.empty())
                    dp[i][j] = 1;
            }
        }
        return dp;
    }

    void solve() {
        int N, n, M, m, k, q;
        cin >> N >> n >> M >> m >> k >> q;
        deque<pair<int, int>> a1(n), b1(m);
        for (auto &[x, y]: a1) cin >> x >> y, y--;
        for (auto &[x, y]: b1) cin >> x >> y, y--;
        auto pa = a1.front();
        a1.pop_front();
        auto pb = b1.front();
        b1.pop_front();
        deque<int> a, b;
        for (auto [x, y]: a1)
            while (x--)
                a.push_back(y);
        for (auto [x, y]: b1)
            while (x--)
                b.push_back(y);
        n = a.size(), m = b.size();
        vector<vector<vector<vector<int>>>> w(3, vector<vector<vector<int>>>(3));
        for (int i = 0; i < 3; i++) {
            for (int j = 0; j < 3; j++) {
                int x = i, y = j;
                while (x--) {
                    n++;
                    a.push_front(0);
                }
                while (y--) {
                    m++;
                    b.push_front(0);
                }
                w[i][j] = clc(n, a, m, b, k);
                x = i, y = j;
                while (x--) {
                    n--;
                    a.pop_front();
                }
                while (y--) {
                    m--;
                    b.pop_front();
                }
            }
        }
        while (q--) {
            int x, y;
            cin >> x >> y;
            if (x >= pa.first && y >= pb.first) {
                x -= pa.first;
                y -= pb.first;
                if (w[0][0][x][y]) cout << "Yes\n";
                else cout << "No\n";
                continue;
            }
            if (x >= pa.first) {
                x -= pa.first;
                y = ((y - pb.first) % 2 ? 1 : 2);
                if (w[0][y][x][0]) cout << "Yes\n";
                else cout << "No\n";
                continue;
            }
            if (y >= pb.first) {
                y -= pb.first;
                x = ((x - pa.first) % 2 ? 1 : 2);
                if (w[x][0][0][y]) cout << "Yes\n";
                else cout << "No\n";
                continue;
            }
            x = (abs(x - pa.first) % 2 ? 1 : 2);
            y = (abs(y - pb.first) % 2 ? 1 : 2);
            if (w[x][y][0][0]) cout << "Yes\n";
            else cout << "No\n";
        }
    }
};

signed main() {
    int __ = 1;
    //cin >> __;
    while (__--) {
        Fast().solve();
        cout << '\n';
    }
    return 0;
}
