#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <string>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <sstream>
#include <cmath>
#include <chrono>
#include <random>
#define endl '\n'
#define ALL(v) v.begin(), v.end()
#define current_time chrono::steady_clock().now().time_since_epoch().count()

using namespace std;

template <typename T1, typename T2>
bool rmin(T1& x, const T2& y)
{
	if (y < x)
	{
		x = y;
		return true;
	}
	return false;
}
template <typename T1, typename T2>
bool rmax(T1& x, const T2& y)
{
	if (x < y)
	{
		x = y;
		return true;
	}
	return false;
}

constexpr uint32_t MOD = 998'244'353, MOD_phi = MOD - 1;

struct Mod_int
{
	uint32_t val;

	Mod_int& operator+=(const Mod_int& a)
	{
		if ((val += a.val) >= MOD)
		{
			val -= MOD;
		}
		return *this;
	}
	Mod_int& operator-=(const Mod_int& a)
	{
		if ((val -= a.val) & 0x80'00'00'00)
		{
			val += MOD;
		}
		return *this;
	}
	Mod_int& operator*=(const Mod_int& a)
	{
		val = int64_t(val) * a.val % MOD;
		return *this;
	}

	friend Mod_int operator+(const Mod_int& a, const Mod_int& b)
	{
		return Mod_int(a) += b;
	}
	friend Mod_int operator-(const Mod_int& a, const Mod_int& b)
	{
		return Mod_int(a) -= b;
	}
	friend Mod_int operator*(const Mod_int& a, const Mod_int& b)
	{
		return Mod_int(a) *= b;
	}

	Mod_int pow(uint64_t pow_val) const
	{
		Mod_int ans{ 1 }, mlt{ val };
		while (pow_val)
		{
			if (pow_val & 1)
			{
				ans *= mlt;
			}
			mlt *= mlt;
			pow_val >>= 1;
		}
		return ans;
	}

	Mod_int& operator/=(const Mod_int& a)
	{
		return *this *= a.pow(MOD_phi - 1);
	}

	friend Mod_int operator/(const Mod_int& a, const Mod_int& b)
	{
		return Mod_int(a) /= b;
	}
};

constexpr int32_t INF = 2'000'000'001;
constexpr int64_t INFl = 2'000'000'000'000'000'001;
constexpr uint32_t MAXN = 1'600;

void solve();

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int t = 1;
	//cin >> t;
	for (int i = 0; i < t; i++)
	{
		solve();
		cout << endl;
	}

	return 0;
}

vector<int> bl1[MAXN], bl2[MAXN], st_bl1[MAXN], st_bl2[MAXN];
bool dp[301][301], ans[300][300];
int a[300], b[300];

void solve()
{
	int N, n, M, m, k, q;
	cin >> N >> n >> M >> m >> k >> q;
	vector<int> gran1(n), col1(n), gran2(n), col2(n);
	int last = 0;
	for (int i = 0; i < n; i++)
	{
		int ln, c;
		cin >> ln >> c;
		--c;
		for (int j = last; j < last + ln; j++)
		{
			a[j] = c;
			st_bl1[c].push_back(j);
		}
		gran1[i] = last += ln;
		col1[i] = c;
		bl1[c].push_back(i);
	}
	last = 0;
	for (int i = 0; i < m; i++)
	{
		int ln, c;
		cin >> ln >> c;
		--c;
		for (int j = last; j < last + ln; j++)
		{
			b[j] = c;
			st_bl2[c].push_back(j);
		}
		gran2[i] = last += ln;
		col2[i] = c;
		bl2[c].push_back(i);
	}
	for (int i = 0; i < k; i++)
	{
		bl1[i].push_back(n);
		bl2[i].push_back(m);

		st_bl1[i].push_back(N);
		st_bl2[i].push_back(M);
	}

	for (int i = 0; i < N; i++)
	{
		dp[i][M] = true;
	}
	for (int j = 0; j < M; j++)
	{
		dp[N][j] = true;
	}
	vector<bool> was(k, false);
	for (int i = N - 1; i >= 0; i--)
	{
		for (int j = 0; j < M; j++)
		{
			if (a[i] == b[j])
			{
				for (int nxt_j = j + 1; nxt_j < M; nxt_j++)
				{
					int cur_col = b[nxt_j];
					if (!was[cur_col])
					{
						was[cur_col] = true;
						int nxt_i = *upper_bound(ALL(st_bl1[cur_col]), i);
						if (!dp[nxt_i][nxt_j])
						{
							dp[i][j] = true;
						}
					}
				}
				for (int nxt_j = j + 1; nxt_j < M; nxt_j++)
				{
					int cur_col = b[nxt_j];
					was[cur_col] = false;
				}
			}
		}
	}
	for (int i = 0; i < N; i++)
	{
		for (int j = 0; j < M; j++)
		{
			for (int f_i = i; f_i < N; f_i++)
			{
				int cur_col = a[f_i];
				if (!was[cur_col])
				{
					was[cur_col] = true;
					int f_j = *lower_bound(ALL(st_bl2[cur_col]), j);
					ans[i][j] |= !dp[f_i][f_j];
				}
			}
			for (int f_i = i; f_i < N; f_i++)
			{
				int cur_col = a[f_i];
				was[cur_col] = false;
			}
		}
	}

	for (int i = 0; i < q; i++)
	{
		int x, y;
		cin >> x >> y;
		if (ans[x][y])
		{
			cout << "Yes";
		}
		else
		{
			cout << "No";
		}
		cout << endl;
	}

	return;
}