#include <bits/stdc++.h>
using namespace std;


using ll = long long;
const ll inf = 1e18;


const int N = 3e5;

int n;

int mx[N * 4], mn[N * 4];
int mod[N * 4];

void apply(int node, int x) {
    mx[node] += x;
    mn[node] += x;
    mod[node] += x;
}
void push(int node) {
    apply(node << 1, mod[node]);
    apply(node << 1 | 1, mod[node]);
    mod[node] = 0;
}
void build(int node = 1, int l = 0, int r = n - 1) {
    mx[node] = mn[node] = mod[node] = 0;
    if (l == r) return;
    int m = (l + r) / 2;
    build(node << 1, l, m);
    build(node << 1 | 1, m + 1, r);
}
void update(int ql, int qr, int x, int node = 1, int l = 0, int r = n - 1) {
    if (r < ql || qr < l) return;
    if (ql <= l && r <= qr) {
        apply(node, x);
        return;
    }
    int m = (l + r) / 2;
    push(node);
    update(ql, qr, x, node << 1, l, m);
    update(ql, qr, x, node << 1 | 1, m + 1, r);
    mx[node] = max(mx[node << 1], mx[node << 1 | 1]);
    mn[node] = min(mn[node << 1], mn[node << 1 | 1]);
}
int get_greater(int k, int x, int node = 1, int l = 0, int r = n - 1) {
    if (l > k) return -1;
    if (mx[node] < x) return -1;
    if (l == r) return l;
    int m = (l + r) / 2;
    push(node);
    int ret = get_greater(k, x, node << 1 | 1, m + 1, r);
    if (ret == -1) return get_greater(k, x, node << 1, l, m);
    return ret;
}
int get_less(int k, int x, int node = 1, int l = 0, int r = n - 1) {
    if (l > k) return -1;
    if (mn[node] > x) return -1;
    if (l == r) return l;
    int m = (l + r) / 2;
    push(node);
    int ret = get_less(k, x, node << 1 | 1, m + 1, r);
    if (ret == -1) return get_less(k, x, node << 1, l, m);
    return ret;
}

struct segtree {
    int n;
    vector<pair<int, int>> tr;

    segtree() = default;
    segtree(int _n) : n(_n), tr(2 * _n, {1e9, -1}) {}

    void upd(int k, int x) {
        for (tr[k + n] = {x, k}, k += n; k > 1; k >>= 1, tr[k] = min(tr[k << 1], tr[k << 1 | 1]));
    }

    int get(int l, int r) {
        pair<int, int> ret = {1e9, -1};
        for (l += n, r += n; l <= r; l >>= 1, r >>= 1) {
            if (l & 1) ret = min(ret, tr[l++]);
            if (~r & 1) ret = min(ret, tr[r--]);
        }
        return ret.second;
    }
};

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int tests;
    cin >> tests;
    while (tests--) {
        int m;
        cin >> m >> n;
        int bal = 0;
        vector<int> xs(n);
        for (auto& x : xs) cin >> x;
        build();
        reverse(xs.begin(), xs.end());
        segtree plus(n), minus(n);
        vector<int> coef(n);
        for (int i = 0; i < n; ++i) {
            int &x = xs[i];
            if (x >= 0) {
                update(i, n - 1, 1);
                bal++;
                plus.upd(i, x);
                coef[i] = 1;
            } else {
                x = -x;
                update(i, n - 1, -1);
                bal--;
                minus.upd(i, x);
                coef[i] = -1;
            }
            if (bal > m) {
                int k = get_less(i, 1) + 1;
                k = plus.get(k, i);
                coef[k] = -1;
                update(k, n - 1, -2);
                plus.upd(k, 1e9);
                minus.upd(k, xs[k]);
                bal -= 2;
            } else if (bal < 0) {
                int k = get_greater(i, m - 1) + 1;
                k = minus.get(k, i);
                coef[k] = 1;
                update(k, n - 1, 2);
                minus.upd(k, 1e9);
                plus.upd(k, xs[k]);
                bal += 2;
            }
        }
        ll ans = 0;
        for (int i = 0; i < n; ++i) ans += coef[i] * xs[i];
        cout << ans << '\n';
    }
}