#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define int ll

const int maxn = 300005;
const int INF = 1e9;

pair<int,int> segTree[2][4*maxn];
int p[2][4*maxn];

void build(int l,int r,int indV,int j)
{
    if(l == r)
    {
        segTree[j][indV] = {0,-l};
        return ;
    }
    int m = (l+r)/2;
    build(l,m,indV*2+1,j);
    build(m+1,r,indV*2+2,j);
    segTree[j][indV] = {0,-l};
    return ;
}

void push(int l,int r,int indV,int j)
{
    if(l == r)
    {
        segTree[j][indV].first += p[j][indV];
        p[j][indV] = 0;
        return ;
    }
    p[j][indV*2+1] += p[j][indV];
    p[j][indV*2+2] += p[j][indV];
    segTree[j][indV].first += p[j][indV];
    p[j][indV] = 0;
    return ;
}

void modify(int lx,int rx,int x,int l,int r,int indV,int j)
{
    push(l,r,indV,j);
    if(l > rx || r < lx)
        return ;
    else if(l >= lx && r <= rx)
    {
        p[j][indV] += x;
        push(l,r,indV,j);
        return ;
    }
    int m =(l+r)/2;
    modify(lx,rx,x,l,m,indV*2+1,j);
    modify(lx,rx,x,m+1,r,indV*2+2,j);
    segTree[j][indV] = min(segTree[j][indV*2+1],segTree[j][indV*2+2]);
}
pair<int,int> get(int lx,int rx,int l,int r,int indV,int j)
{
    push(l,r,indV,j);
    if(l > rx || r < lx)
        return {INF,-1};
    else if(l >= lx && r <= rx)
        return segTree[j][indV];
    int m = (l+r)/2;
    pair<int,int> sl = get(lx,rx,l,m,indV*2+1,j);
    pair<int,int> sr = get(lx,rx,m+1,r,indV*2+2,j);
    return min(sl,sr);
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while(t--)
    {
        int n,m;
        cin >> n >> m;
        build(0,m-1,0,0);
        build(0,m-1,0,1);
        int x[m];
        for(int j = 0;j < m;++j)
        {
            cin >> x[j];
        }
        int tp = 0;
        ll ans = 0;
        for(int j = m-1;j >= 0;--j)
        {
            if(tp < n)
            {
                cout << x[j] << "\n";
                ans += x[j];
                tp++;
                modify(0,j,1,0,m-1,0,0);
                modify(j,j,x[j],0,m-1,0,1);
            }
            else
            {
                int pt = m-1;
                //cout << "!!" << pt << endl;
                while(true)
                {
                    pair<int,int> ck = get(j+1,pt,0,m-1,0,0);
                  //  cout << j+1 << ' ' << pt << ' ' << ck.first << ' ' << ck.second << endl;
                    if(ck.first < 2)
                    {
                        pt = -ck.second-1;
                    }
                    else
                        break;
                }
               // cout << pt << ' ';
                if(pt == j)
                {
                    cout << "- " << x[j] << "\n";
                    ans -= x[j];
                    modify(0,j,-1,0,m-1,0,0);
                    modify(j,j,INF,0,m-1,0,1);
                }
                else
                {
                    pair<int,int> c2 = get(j+1,pt,0,m-1,0,1);
                    if(c2.first < x[j])
                    {
                        cout << "! " << x[j] << ' ' << c2.first << "\n";
                        ans += x[j];
                        ans -= 2*c2.first;
                        modify(0,j,1,0,m-1,0,0);
                        modify(j,j,x[j],0,m-1,0,1);
                        modify(-c2.second,-c2.second,INF,0,m-1,0,1);
                        modify(0,-c2.second,-2,0,m-1,0,0);
                    }
                    else
                    {
                        cout << "- " << x[j] << "\n";
                        ans -= x[j];
                        modify(0,j,-1,0,m-1,0,0);
                        modify(j,j,INF,0,m-1,0,1);
                    }
                }
                tp --;
            }
        }
        cout << ans << "\n";
    }
}


