#include <bits/stdc++.h>

using namespace std;

constexpr int R = 1 << 19;

int mx[R * 2], psh[R * 2];

void push(int node) {
    if (psh[node] != 0) {
        mx[node * 2] += psh[node];
        psh[node * 2] += psh[node];
        mx[node * 2 + 1] += psh[node];
        psh[node * 2 + 1] += psh[node];
    }
    psh[node] = 0;
}

void add(int ql, int qr, int val, int node = 1, int nl = 0, int nr = R) {
    if (ql <= nl && nr <= qr) {
        mx[node] += val;
        psh[node] += val;
        return;
    }
    if (qr <= nl || nr <= ql) {
        return;
    }
    push(node);
    int nm = (nl + nr) / 2;
    add(ql, qr, val, node * 2, nl, nm);
    add(ql, qr, val, node * 2 + 1, nm, nr);
    mx[node] = max(mx[node * 2], mx[node * 2 + 1]);
}

int get(int ql, int qr, int node = 1, int nl = 0, int nr = R) {
    if (ql <= nl && nr <= qr) {
        return mx[node];
    }
    if (qr <= nl || nr <= ql) {
        return 0;
    }
    push(node);
    int nm = (nl + nr) / 2;
    int res = max(get(ql, qr, node * 2, nl, nm), get(ql, qr, node * 2 + 1, nm, nr));
    mx[node] = max(mx[node * 2], mx[node * 2 + 1]);
    return res;
}

int find_n(int r, int n, int node = 1, int nl = 0, int nr = R) {
    if (r <= nl || mx[node] < n - 1) {
        return -1;
    }
    if (nl == nr - 1) {
        return nl;
    }
    push(node);
    int nm = (nl + nr) / 2;
    int res = find_n(r, n, node * 2 + 1, nm, nr);
    if (res == -1) {
        res = find_n(r, n, node * 2, nl, nm);
    }
    mx[node] = mx[node * 2], mx[node * 2 + 1];
    return res;
}

void change(int pos, int val) {
    add(pos, pos + 1, val - get(pos, pos + 1));
}

void solve() {
    int n, m;
    cin >> n >> m;
    assert(n > 2);
    vector<int> x(m);
    for (int i = 0; i < m; ++i) {
        cin >> x[i];
    }
    reverse(x.begin(), x.end());
    change(0, n);
    set<pair<int, int>> vals;
    int bal = n;
    long long ans = 0;
    for (int i = 0; i < m; ++i) {
        if (bal > 0) {
            bal--;
            ans += x[i];
            change(i + 1, bal);
            vals.emplace(x[i], i);
        } else {
            int pos_n = find_n(i + 1, n);
            bool change_flag = false;
            while (!vals.empty()) {
                int j = vals.begin()->second;
                if (j < pos_n) {
                    vals.erase(vals.begin());
                } else if (x[j] >= x[i]) {
                    break;
                } else {
                    change_flag = true;
                    ans -= x[j] * 2;
                    ans += x[i];
                    bal++;
                    add(j + 1, R, 2);
                    change(i + 1, bal);
                    vals.erase(vals.begin());
                    vals.emplace(x[i], i);
                    break;
                }
            }
            if (!change_flag) {
                bal++;
                ans -= x[i];
                change(i + 1, bal);
            }
        }
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
