#pragma GCC optimize("O3")

#include <bits/extc++.h>

using namespace std;

constexpr int INF = 1e9;

template<class T>
inline bool set_max(T &a, const T &b) {
    return (b > a) && (a = b, true);
}

void solve1() {
    int n, m;
    cin >> n >> m;
    vector<int> x(m);
    for (int i = 0; i < m; i++) {
        cin >> x[i];
    }
    if (n == 1) {
        cout << (m % 2 == 0 ? 0 : x[0]) << '\n';
        return;
    }
    if (m <= n) {
        cout << x[0] * m << '\n';
        return;
    }
    if (n % 2 != m % 2) {
        cout << x[0] * (n - 1) << '\n';
    } else {
        cout << x[0] * n << '\n';
    }
}

void solve2() {
    int n, m;
    cin >> n >> m;
    vector<int> x(m + 1);
    for (int i = 1; i <= m; i++) {
        cin >> x[i];
    }
    vector dp(2, vector(1001, vector<int>(1001)));
    const int C = 500;
    dp[0][C + 0][C + 0] = 1;
    for (int i = 1; i <= m; i++) {
        for (int a = -500; a <= 500; a++) {
            for (int b = -500; b <= 500; b++) {
                if (dp[0][C + a][C + b] == i) {
                    dp[1][C + (x[i] - a)][C + b] = dp[1][C + a][C + (x[i] - b)] = 1 + i;
                }
            }
        }
        swap(dp[0], dp[1]);
    }
    int ans = -INF * n;
    for (int a = -500; a <= 500; a++) {
        for (int b = -500; b <= 500; b++) {
            if (dp[0][C + a][C + b] == m + 1) {
                ans = max(ans, a + b);
            }
        }
    }
    cout << ans << '\n';
}

void solve3() {
    int n, m;
    cin >> n >> m;
    vector<int> x(m + 1);
    for (int i = 1; i <= m; i++) {
        cin >> x[i];
    }
    vector dp(2, vector<int>(40002, -1));
    const int C = 20000;
    dp[0][C + 0] = 0;
    for (int i = 1; i <= m; i++) {
        for (int a = -C; a <= C; a++) {
            int b = dp[0][C + a];
            if (b != -1) {
                set_max(dp[1][C + a], x[i] - b);
                set_max(dp[1][C + b], x[i] - a);
            }
        }
        swap(dp[0], dp[1]);
        for (int a = -C; a <= C; a++) {
            dp[1][a + C] = -1;
        }
    }
    int ans = -INF * n;
    for (int a = -C; a <= C; a++) {
        int b = dp[0][C + a];
        if (b != -1) {
            set_max(ans, a + b);
        }
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
//    int a = 0;
//    for (int i = 0; i < 50; i++) {
//        int x = (i % 2 == 0 ? 400 : -400);
//        a = x - a;
//        cerr << a << '\n';
//    }
    int t;
    cin >> t;
    while (t--) {
        solve3();
    }
    return 0;
}