#include "bits/extc++.h"

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

template<typename T>
istream &operator>>(istream &is, vector<T> &a);

template<typename T>
ostream &operator<<(ostream &os, vector<T> &a);

using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

void solve() {
    ll n, k;
    cin >> k >> n;

    vector<ll> a(n);
    cin >> a;

    vector dp(n + 1, vector(k + 1, vector(2, (ll) -1e18)));
    dp[0][1][0] = 0;
    for (int i = 0; i < n; ++i) {
        for (int kval = 0; kval <= k; ++kval) {
            dp[i + 1][kval][1] = max(
                    dp[i + 1][kval][1],
                    dp[i][kval][0] + a[i]
            );
            dp[i + 1][kval][0] = max(
                    dp[i + 1][kval][0],
                    dp[i][kval][0] - a[i]
            );
            dp[i + 1][kval][0] = max(
                    dp[i + 1][kval][0],
                    dp[i][kval][1] - a[i]
            );
            if (kval < k)
                dp[i + 1][kval + 1][1] = max(
                        dp[i + 1][kval + 1][1],
                        dp[i][kval][1] + a[i]
                );
        }
    }

    ll ans = -1e18;
    for (int i = 0; i <= k; ++i) {
        for (int flag = 0; flag < 2; flag++) {
            ans = max(ans, dp[n][i][flag]);
        }
    }

    cout << ans << "\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int t;
    cin >> t;

    while (t--) solve();
}

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &v: a) is >> v;
    return is;
}

template<typename T>
ostream &operator<<(ostream &os, vector<T> &a) {
    for (auto v: a) os << v << " ";
    return (os << "\n");
}