#include "bits/extc++.h"

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

template<typename T>
istream &operator>>(istream &is, vector<T> &a);

template<typename T>
ostream &operator<<(ostream &os, vector<T> &a);

using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

void solve() {
    ll n, k;
    cin >> k >> n;

    vector<ll> a(n);
    cin >> a;

    std::reverse(a.begin(), a.end());

    vector dp(n, vector(k + 1, vector(k + 1, (ll) -1e18)));
    // dp[pref][open][chet]
    dp[0][1][0] = a[0];

    for (int i = 1; i < n; ++i) {
        for (int pk = 0; pk <= k; ++pk) {
            for (int ch = 0; ch <= pk; ++ch) {
                // взять
                if (ch > 0) {
                    dp[i][pk][ch - 1] = max(
                            dp[i][pk][ch - 1],
                            dp[i - 1][pk][ch] + a[i]
                    );
                }
                if (pk < k) {
                    dp[i][pk + 1][ch] = max(
                            dp[i][pk + 1][ch],
                            dp[i - 1][pk][ch] + a[i]
                    );
                }
                // не брать
                if (ch < pk) {
                    dp[i][pk][ch + 1] = max(
                            dp[i][pk][ch + 1],
                            dp[i - 1][pk][ch] - a[i]
                    );
                }
            }
        }
    }

    ll ans = -1e18;
    for (int i = 0; i <= k; ++i) {
        for (int j = 0; j <= i; ++j) {
            ans = max(ans, dp[n-1][i][j]);
        }
    }
    cout << ans << "\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int t;
    cin >> t;

    while (t--) solve();
}

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &v: a) is >> v;
    return is;
}

template<typename T>
ostream &operator<<(ostream &os, vector<T> &a) {
    for (auto v: a) os << v << " ";
    return (os << "\n");
}