#include "bits/extc++.h"

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

template<typename T>
istream &operator>>(istream &is, vector<T> &a);

template<typename T>
ostream &operator<<(ostream &os, vector<T> &a);

using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

const int C = 500;

void solve() {
    ll n, k;
    cin >> k >> n;

    vector<ll> a(n);
    cin >> a;

    std::reverse(a.begin(), a.end());

    vector<ll> asort = a;
    std::sort(asort.begin(), asort.end());

    ll kold = k;
    ll nold = n;
    ll ans = -1e18;
    for (int kdel = 0; kdel < min(k,n); ++kdel) {
        n = nold;
        k = kold - kdel;
        if (k > C) continue;
        map<int, int> cnt;
        for (int i = 0; i < kdel; ++i) {
            cnt[asort[i]]++;
        }

        ll ost = 0;
        vector<int> b;
        for (int i = 0; i < n; ++i) {
            if (cnt[a[i]]) {
                ost += a[i];
                cnt[a[i]]--;
            } else {
                b.push_back(a[i]);
            }
        }

        n = b.size();
        vector dp(n, vector(k + 1, vector(k + 1, (ll) -1e18)));
        // dp[pref][open][chet]
        dp[0][1][0] = b[0];

        for (int i = 1; i < n; ++i) {
            for (int pk = 0; pk <= k; ++pk) {
                for (int ch = 0; ch <= pk; ++ch) {
                    // взять
                    if (ch > 0) {
                        dp[i][pk][ch - 1] = max(
                                dp[i][pk][ch - 1],
                                dp[i - 1][pk][ch] + b[i]
                        );
                    }
                    if (pk < k) {
                        dp[i][pk + 1][ch] = max(
                                dp[i][pk + 1][ch],
                                dp[i - 1][pk][ch] + b[i]
                        );
                    }
                    // не брать
                    if (ch < pk) {
                        dp[i][pk][ch + 1] = max(
                                dp[i][pk][ch + 1],
                                dp[i - 1][pk][ch] - b[i]
                        );
                    }
                }
            }
        }

        ll curr = -1e18;
        pair<ll, ll> best = {-1, -1};
        for (int i = 0; i <= k; ++i) {
            for (int j = 0; j <= i; ++j) {
                curr = max(curr, dp[n - 1][i][j]);
            }
        }

        ost += curr;
        ans = max(ans, ost);
    }

    cout << ans << "\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int t;
    cin >> t;

    while (t--) solve();
}

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &v: a) is >> v;
    return is;
}

template<typename T>
ostream &operator<<(ostream &os, vector<T> &a) {
    for (auto v: a) os << v << " ";
    return (os << "\n");
}