#include "bits/extc++.h"

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

template<typename T>
istream &operator>>(istream &is, vector<T> &a);

template<typename T>
ostream &operator<<(ostream &os, vector<T> &a);

using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

const int C = 500;

void solve() {
    ll n, k;
    cin >> k >> n;

    vector<ll> a(n);
    cin >> a;

    std::reverse(a.begin(), a.end());


    auto mx = [&](pair<ll, ll> a, pair<ll, ll> b) {
        if (a.first == b.first) return min(a, b);
        return max(a, b);
    };

    ll l = -1e18, r = 1e18;
    while (r - l > 1) {
        ll lambda = (l + r) / 2;
        vector dp(n, vector(k + 1, pair<ll, ll>{-1e18, 0}));
        // dp[pref][open][chet]
        dp[0][0] = {a[0] - lambda, 1};

        for (int i = 1; i < n; ++i) {
            for (int ch = 0; ch <= k; ++ch) {
                pair<ll, ll> v2 = dp[i - 1][ch];
                v2.first += a[i];
                if (ch > 0) dp[i][ch - 1] = mx(
                            dp[i][ch - 1],
                            v2
                    );

                v2 = dp[i - 1][ch];
                v2.first += a[i] - lambda;
                v2.second++;
                dp[i][ch] = mx(
                        dp[i][ch],
                        v2
                );
                v2 = dp[i - 1][ch];
                v2.first -= a[i];
                if (ch + 1 <= k) dp[i][ch + 1] = mx(
                            dp[i][ch + 1],
                            v2
                    );
            }
        }

        pair<ll, ll> best = {-1e18, -1e9};
        for (int i = 0; i <= k; ++i) {
            best = max(best, dp[n - 1][i]);
        }
        if (best.second <= k) r = lambda;
        else l = lambda;
    }

    ll lambda = r;
    vector dp(n, vector(k + 1, pair<ll, ll>{-1e18, 0}));
    // dp[pref][open][chet]
    dp[0][0] = {a[0] - lambda, 1};

    for (int i = 1; i < n; ++i) {
        for (int ch = 0; ch <= k; ++ch) {
            pair<ll, ll> v2 = dp[i - 1][ch];
            v2.first += a[i];
            if (ch > 0) dp[i][ch - 1] = mx(
                        dp[i][ch - 1],
                        v2
                );

            v2 = dp[i - 1][ch];
            v2.first += a[i] - lambda;
            v2.second++;
            dp[i][ch] = mx(
                    dp[i][ch],
                    v2
            );
            v2 = dp[i - 1][ch];
            v2.first -= a[i];
            if (ch + 1 <= k) dp[i][ch + 1] = mx(
                        dp[i][ch + 1],
                        v2
                );
        }
    }
    pair<ll, ll> best = {-1e18, -1e9};
    for (int i = 0; i <= k; ++i) {
        best = max(best, dp[n - 1][i]);
    }

    cout << best.first + best.second * lambda << "\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int t;
    cin >> t;

    while (t--) solve();
}

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &v: a) is >> v;
    return is;
}

template<typename T>
ostream &operator<<(ostream &os, vector<T> &a) {
    for (auto v: a) os << v << " ";
    return (os << "\n");
}