#include <bits/stdc++.h>

using namespace std;

#define int long long

#define NEUTRAL_MOD 0

struct Segment_tree{
    struct Node{
        int l, r;
        int mn;
        Node() {}
        Node(int x, int ind) {
            l = ind;
            r = ind + 1;
            mn = x;
        }
        Node(Node le, Node ri) : l(le.l), r(ri.r) {
            mn = min(le.mn, ri.mn);
        }
        int mod = NEUTRAL_MOD;
        void add_mod(int mod) {
            this->mod += mod;
        }
        void apply_mod() {
            mn += mod;
            mod = NEUTRAL_MOD;
        }
    };
    vector<Node> tr;
    void build(int i, int l, int r) {
        if (r - l == 1) {
            tr[i] = Node(0, l);
            return;
        }
        int m = (l + r) / 2;
        build(2 * i + 1, l, m);
        build(2 * i + 2, m, r);
        tr[i] = Node(tr[2 * i + 1], tr[2 * i + 2]);
    }
    void push(int i) {
        if (tr[i].mod == NEUTRAL_MOD) return;
        if (tr[i].r - tr[i].l > 1) {
            tr[2 * i + 1].add_mod(tr[i].mod);
            tr[2 * i + 2].add_mod(tr[i].mod);
        }
        tr[i].apply_mod();
    }
    Node get(int l, int r, int i = 0) {
        push(i);
        if (l <= tr[i].l && tr[i].r <= r) return tr[i];
        int m = (tr[i].l + tr[i].r) / 2;
        if (r <= m) return get(l, r, 2 * i + 1);
        if (m <= l) return get(l, r, 2 * i + 2);
        return Node(get(l, r, 2 * i + 1), get(l, r, 2 * i + 2));
    }
    void upd_p(int ind, int x, int i = 0) {
        push(i);
        if (tr[i].r <= ind || tr[i].l > ind) return;
        if (tr[i].r - tr[i].l == 1) {
            tr[i] = Node(x, ind);
            return;
        }
        upd_p(ind, x, 2 * i + 1);
        upd_p(ind, x, 2 * i + 2);
        tr[i] = Node(tr[2 * i + 1], tr[2 * i + 2]);
    }
    void upd(int l, int r, int mod, int i = 0) {
        push(i);
        if (tr[i].l >= r || tr[i].r <= l) return;
        if (l <= tr[i].l && tr[i].r <= r) {
            tr[i].add_mod(mod);
            push(i);
            return;
        }
        upd(l, r, mod, 2 * i + 1);
        upd(l, r, mod, 2 * i + 2);
    }
    Segment_tree(int n) {
        tr.resize(4 * n);
        build(0, 0, n);
    }
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> x(m);
    for (auto &i : x) cin >> i;
    reverse(x.begin(), x.end());
    int ans = 0;
    set<pair<int, int>> s;
    Segment_tree tr(m);
    int bal = 0;
    vector<bool> used(m);
    for (int i = 0; i < m; i++) {
        bal++;
        tr.upd(i, m, 1);
        s.insert({x[i], i});
        if (bal > n) {
            while (true) {
                int j = s.begin()->second;
                s.erase(s.begin());
                if (tr.get(j, m).mn > 1) {
                    //lans.push_back(j);
                    used[j] = true;
                    tr.upd(j, m, -2);
                    bal -= 2;
                    break;
                }
            }
        }
    }
    while (s.size() > 0) {
        int j = s.begin()->second;
        s.erase(s.begin());
        if (x[j] < 0 && tr.get(j, m).mn > 1) {
            //lans.push_back(j);
            used[j] = true;
            tr.upd(j, m, -2);
        }
    }
    int fans = 0;
    for (int i = 0; i < m; i++) {
        if (used[i]) fans -= x[i];
        else fans += x[i]; 
    }
    cout << fans << endl;
}

main() {
    int t;
    cin >> t;
    while (t--) solve();
}