#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (T& x : v) in >> x;
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, vector<T>& v) {
    for (T& x : v) out << x << " ";
    return out;
}

template<typename T1, typename T2>
istream& operator>>(istream& in, pair<T1, T2>& p) {
    in >> p.first >> p.second;
    return in;
}

template<typename T1, typename T2>
ostream& operator<<(ostream& out, pair<T1, T2>& p) {
    out << p.first << " " << p.second;
    return out;
}

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
using ll = long long;
using ld = long double;

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> v(m);
    for (int& x : v) cin >> x;
    reverse(all(v));

    if (*min_element(all(v)) == *max_element(all(v)) && v[0] >= 0) {
        if (n >= m) cout << (ll)m * v[0] << "\n";
        else cout << (ll)(n - 1) * v[0] + ((m - (n - 1)) % 2 == 1 ? v[0] : 0) << "\n";
        return;
    }

    vector<ll> dp(n + 1, -1e18), ndp;
    dp[0] = 0;
    for (int i = 0; i < m; i++) {
        ndp.assign(n + 1, -1e18);
        for (int j = 1; j <= n; j++) {
            ndp[j] = max(ndp[j], dp[j - 1] + v[i]);
        }
        for (int j = 0; j < n; j++) {
            ndp[j] = max(ndp[j], dp[j + 1] - v[i]);
        }
        dp.swap(ndp);
    }

    cout << *max_element(all(dp)) << "\n";

//    vector<ll> pref(m);
//    for (int i = 0; i < m; i++) {
//        pref[i] = v[i];
//        if (i > 0) pref[i] += v[i - 1];
//    }

//    ll res = -1e18;
//    for (int neg = 0; neg < m / 2; neg++) {
//        if (1 + max(0, m - 2 * neg - 1) <= n) res = max(res, (neg == 0 ? 0 : pref[neg - 1]) + pref[m - 1] - (neg == 0 ? 0 : pref[neg - 1]));
//    }
//    cout << res << "\n";
}

signed main() {
#ifndef LOCAL
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
#endif

    int t = 1;
    cin >> t;
    while (t--) solve();
}