#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define int long long
#define db long double

using namespace std;

vector<int> tree, p, ph;

void init(int n, int l, int r) {
    if (r - l == 1) {
        tree[n] = p[l];
        return;
    }

    int m = (l + r) / 2;
    init(2 * n + 1, l, m);
    init(2 * n + 2, m, r);

    tree[n] = min(tree[2 * n + 1], tree[2 * n + 2]);
}

void push(int n, int l, int r) {
    tree[n] += ph[n];

    if (r - l > 1) {
        ph[2 * n + 1] += ph[n];
        ph[2 * n + 2] += ph[n];
    }

    ph[n] = 0;
}

int query(int n, int l, int r, int ql, int qr) {
    push(n, l, r);

    if (ql >= r || l >= qr) return 0;
    if (ql <= l && r <= qr) return tree[n];

    int m = (l + r) / 2;
    return query(2 * n + 1, l, m, ql, qr) + query(2 * n + 2, m, r, ql, qr);
}

void update(int n, int l, int r, int ql, int qr, int val) {
    push(n, l, r);

    if (ql >= r || l >= qr) return;
    if (ql <= l && r <= qr) {
        ph[n] += val;
        push(n, l, r);
        return;
    }

    int m = (l + r) / 2;
    update(2 * n + 1, l, m, ql, qr, val);
    update(2 * n + 2, m, r, ql, qr, val);

    tree[n] = min(tree[2 * n + 1], tree[2 * n + 2]);
}

void solve() {
    int n, m, sm = 0; cin >> n >> m;

    vector<int> a(m); p.resize(m);
    for (int i = 0; i < m; ++i) {
        cin >> a[i];

        sm += a[i];
        p[i] = -i - 1 + n;
    }

    reverse(a.begin(), a.end());

    tree.resize(4 * m), ph.assign(4 * m, 0);
    init(0, 0, m);

    vector<pair<int, int>> arr;
    for (int i = 0; i < m; ++i) {
        arr.emplace_back(a[i], i);
    }

    std::sort(arr.begin(), arr.end());

    int ans = LLONG_MIN;

    if (query(0, 0, m, 0, m) >= 0) {
        ans = max(ans, sm);
    }

    for (auto [wt, i] : arr) {
        sm -= 2 * wt;

        update(0, 0, m, i, m, 2);

        if (query(0, 0, m, 0, m) >= 0) {
            ans = max(ans, sm);
        }
    }

    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int tt; cin >> tt;
    while (tt--) {
        solve();
        cout << "\n";
    }
}