#include <bits/stdc++.h>
#include <random>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;

template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

//int new_tnode(ll x, int tl, int tr, int l = 0, int r = 0);

template<class T>
struct TNode {
    T x;
    int tl, tr;
    int l = 0;
    int r = 0;
    T def;
    function<T(T, T)> sum;

    TNode(T x, T def, function<T(T, T)> sum, int tl, int tr, int l = 0, int r = 0) :
            x(x), def(def), sum(sum), tl(tl), tr(tr), l(l), r(r) {

    }
    // TNode() = default;
    TNode get_l() const {
        return l ? l : TNode<T>(def, tl, (tl + tr) / 2);
    }
    TNode get_r() const {
        return r ? r : TNode<T>(def, (tl + tr) / 2, tr);
    }

    T get(int ll, int rr) {
        if (tr <= ll || rr <= tl) return def;
        if (ll <= tl && tr <= rr) return x;
        return sum(get_l().get(ll, rr), get_r().get(ll, rr));
    }

    void insert(int i, T y) {
        if (tl == i && i + 1 == tr) {
            x = y;
        }
        int tm = (tl + tr) / 2;
        if (i < tm) {
            get_l().insert(i, y);
        } else {
            get_r().insert(i, y);
        }
        x = sum(get_l().x, get_r().x);
    }

};

//vector<TNode> tn(1);

//int new_tnode(ll x, int tl, int tr, int l, int r) {
//    tn.emplace_back(x, tl, tr, l, r);
//    return (int) tn.size() - 1;
//}

//template<class T>
//struct Tree {
//    TNode<T> root;
//    int n, N;
//    T def;
//    function<T(T, T)> sum;
//    Tree(int n, T def, function<T(T, T)> sum): n(n), def(def), sum(sum) {
//        int st = 0;
//        while ((1 << st) < n) ++st;
//        N = (1 << st);
//        root = TNode<T>(def, sum, 0, N);
//    }
//};

bool comp1(const pair<ll, ll> &x, const pair<ll, ll> &y) {
    return x.first + x.second < y.first + y.second;
}
bool comp2(const pair<ll, ll> &x, const pair<ll, ll> &y) {
    return x.first < y.first;
}
bool comp3(const pair<ll, ll> &x, const pair<ll, ll> &y) {
    return x.second < y.second;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<ll> x(m);
    for (int i = 0; i < m; ++i) {
        cin >> x[i];
    }
    vector<pair<ll, ll>> dpmis(m + 1);
    vector<pair<ll, ll>> dpmas(m + 1);
    vector<pair<ll, ll>> dpmie(m + 1);
    vector<pair<ll, ll>> dpmae(m + 1);
    auto s = [&](pair<ll, ll> &a) {
        if (a.first > a.second) {
            swap(a.first, a.second);
        }
    };
    for (int i = 0; i < m; ++i) {
        vector<pair<ll, ll>> vars;
        vars.emplace_back(x[i] - dpmis[i].first, dpmis[i].second);
        vars.emplace_back(dpmis[i].first, x[i] - dpmis[i].second);

        vars.emplace_back(x[i] - dpmas[i].first, dpmas[i].second);
        vars.emplace_back(dpmas[i].first, x[i] - dpmas[i].second);

        vars.emplace_back(x[i] - dpmie[i].first, dpmie[i].second);
        vars.emplace_back(dpmie[i].first, x[i] - dpmie[i].second);

        vars.emplace_back(x[i] - dpmae[i].first, dpmae[i].second);
        vars.emplace_back(dpmae[i].first, x[i] - dpmae[i].second);
        for (auto &a: vars) {
            s(a);
        }
        std::sort(vars.begin(), vars.end(), comp1);
        dpmis[i + 1] = vars[0];
        dpmas[i + 1] = vars.back();
        std::sort(vars.begin(), vars.end(), comp2);
        dpmie[i + 1] = vars[0];
        std::sort(vars.begin(), vars.end(), comp3);
        dpmae[i + 1] = vars.back();
    }
    cout << (dpmas.back().first + dpmas.back().second);
}

int main() {
    int t = 1;
    cin >> t;
    for (int test = 0; test < t; ++test) {
        solve();
        cout << '\n';
    }
    cerr << clock() / 1000.0;
    return 0;
}
