#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag,
        tree_order_statistics_node_update>;
template<class T> using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag,
        tree_order_statistics_node_update>;

#define int long long

struct nm {
    int val, plus, ind;
};

bool cmp(nm s1, nm s2) {
    return s1.val < s2.val;
}

vector<int> t1, t2;

void build(int v, int l, int r) {
    if (l + 1 == r) {
        t1[v] = -1;
        t2[v] = 1;
        return;
    }
    int m = (l + r) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    t1[v] = t1[2 * v + 1] + t1[2 * v + 2];
    t2[v] = t2[2 * v + 1] + t2[2 * v + 2];
}

int get1(int v, int l, int r, int ql, int qr) {
    if (ql >= r || l >= qr) {
        return 0;
    }
    if (ql <= l && r <= qr) {
        return t1[v];
    }
    int m = (l + r) / 2;
    return get1(2 * v + 1, l, m, ql, qr) + get1(2 * v + 2, m, r, ql, qr);
}

int get2(int v, int l, int r, int ql, int qr) {
    if (ql >= r || l >= qr) {
        return 0;
    }
    if (ql <= l && r <= qr) {
        return t2[v];
    }
    int m = (l + r) / 2;
    return get2(2 * v + 1, l, m, ql, qr) + get2(2 * v + 2, m, r, ql, qr);
}

void update1(int v, int l, int r, int k, int x) {
    if (l + 1 == r) {
        t1[v] = x;
        return;
    }
    int m = (l + r) / 2;
    if (k >= m) {
        update1(2 * v + 2, m, r, k, x);
    } else {
        update1(2 * v + 1, l, m, k, x);
    }
}

void update2(int v, int l, int r, int k, int x) {
    if (l + 1 == r) {
        t2[v] = x;
        return;
    }
    int m = (l + r) / 2;
    if (k >= m) {
        update2(2 * v + 2, m, r, k, x);
    } else {
        update2(2 * v + 1, l, m, k, x);
    }
}

int m, n;

bool poss(vector<int> &pl) {
    int l = 0, r = 0;
    for (int i = 0; i < m; ++i) {
        if (pl[i] == 1) {
            l++;
            r++;
        } else if (pl[i] == -1) {
            l--;
            r--;
        } else {
            l--;
            r++;
        }
        if (r > n) {
            r -= 2;
        }
        if (l < 0) {
            l += 2;
        }
        if (r < l) {
            return false;
        }
    }
    return true;
}

signed main() {
    int tst;
    cin >> tst;
    while (tst--) {
        cin >> n >> m;
        vector<int> x(m);
        vector<nm> y(m);
        for (int i = 0; i < m; ++i) {
            cin >> x[i];
            y[i] = {abs(x[i]), 2 * (x[i] > 0) - 1, m - 1 - i};
        }
        if (n == 1) {
            reverse(x.begin(), x.end());
            int s = 0;
            for (int i = 0; i < m; ++i) {
                if (i % 2 == 0) {
                    s += x[i];
                } else {
                    s -= x[i];
                }
            }
            cout << s << '\n';
            continue;
        }
        sort(y.begin(), y.end(), cmp);
        reverse(y.begin(), y.end());
        int s = 0;
        vector<int> pl(m);
        for (int i = 0; i < m; ++i) {
            int ind = y[i].ind, val = y[i].val, plus = y[i].plus;
            pl[ind] = plus;
            if (poss(pl)) {
                s += val;
            } else {
                s -= val;
                pl[ind] = -pl[ind];
            }
        }
        cout << s << '\n';
    }
    return 0;
}
