#include <bits/stdc++.h>

using namespace std;
#define int int64_t
const int INF = 1e18;

struct edge {
    int mn;
    int pl;
};

vector<edge> tree;
vector<edge> p;

edge relax(edge a, edge b) {
    return {max(a.mn, b.mn), min(a.pl, b.pl)};
}

void build(int v, int l, int r) {
    if (l + 1 == r) {
        tree[v] = {-l, l};
        return;
    }
    int m = (l + r) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    tree[v] = relax(tree[2 * v + 1], tree[2 * v + 2]);
}

void push(int v, int l, int r) {
    if (p[v].mn == 0 && p[v].pl == 0) {
        return;
    }
    tree[2 * v + 1].mn += p[v].mn;
    tree[2 * v + 2].pl += p[v].pl;
    tree[2 * v + 1].pl += p[v].pl;
    tree[2 * v + 2].mn += p[v].mn;
    p[2 * v + 1].mn += p[v].mn;
    p[2 * v + 2].mn += p[v].mn;
    p[2 * v + 2].pl += p[v].pl;
    p[2 * v + 1].pl += p[v].pl;
    p[v] = {0, 0};
}

void update(int v, int l, int r, int ql, int qr, edge x) {
    if (ql >= r || l >= qr) {
        return;
    }
    if (ql <= l && r <= qr) {
        tree[v].mn += x.mn;
        tree[v].pl += x.pl;
        p[v].mn += x.mn;
        p[v].pl += x.pl;
        return;
    }
    push(v, l, r);
    int m = (l + r) / 2;
    update(2 * v + 1, l, m, ql, qr, x);
    update(2 * v + 2, m, r, ql, qr, x);
    tree[v] = relax(tree[2 * v + 1], tree[2 * v + 2]);
}

edge get(int v, int l, int r, int ql, int qr) {
    if (l >= qr || ql >= r) {
        return {0, INF};
    }

    if (ql <= l && r <= qr) {
        return tree[v];
    }

    push(v, l, r);
    int m = (l + r) / 2;
    return relax(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
}



void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> x(m);
    for (int i = 0; i < m; i++) {
        cin >> x[i];
    }
    reverse(x.begin(), x.end());
    vector<pair<int,int> > a(m);
    for (int i = 0; i < m; i++) {
        a[i] = {x[i], i + 1};
    }
    sort(a.rbegin(), a.rend());
    tree = vector<edge> (4 * (m + 1));
    p = vector<edge> (4 * (m + 1), {0, 0});
    build(0, 1, m + 1);
    int ans = 0;
    for (int i = 0; i < m; i++) {
        edge f = get(0, 1, m + 1, a[i].second, m + 1);
        if (f.mn + 2 <= n) {
                cout << '+' << " " << a[i].second << endl;
            ans += a[i].first;
            update(0, 1, m + 1, a[i].second, m + 1, {2, 0});
            continue;
        }
        cout << '-' << " " << a[i].second << endl;
        ans -= a[i].first;
        update(0, 1, m + 1, a[i].second, m + 1, {0, -2});
    }
    cout << ans << '\n';
}

int32_t main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}




