#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <string>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <sstream>
#include <cmath>
#include <chrono>
#include <random>
#define endl '\n'
#define ALL(v) v.begin(), v.end()
#define current_time chrono::steady_clock().now().time_since_epoch().count()

using namespace std;

template <typename T1, typename T2>
bool rmin(T1& x, const T2& y)
{
	if (y < x)
	{
		x = y;
		return true;
	}
	return false;
}
template <typename T1, typename T2>
bool rmax(T1& x, const T2& y)
{
	if (x < y)
	{
		x = y;
		return true;
	}
	return false;
}

constexpr uint32_t MOD = 998'244'353, MOD_phi = MOD - 1;

struct Mod_int
{
	uint32_t val;

	Mod_int& operator+=(const Mod_int& a)
	{
		if ((val += a.val) >= MOD)
		{
			val -= MOD;
		}
		return *this;
	}
	Mod_int& operator-=(const Mod_int& a)
	{
		if ((val -= a.val) & 0x80'00'00'00)
		{
			val += MOD;
		}
		return *this;
	}
	Mod_int& operator*=(const Mod_int& a)
	{
		val = int64_t(val) * a.val % MOD;
		return *this;
	}

	friend Mod_int operator+(const Mod_int& a, const Mod_int& b)
	{
		return Mod_int(a) += b;
	}
	friend Mod_int operator-(const Mod_int& a, const Mod_int& b)
	{
		return Mod_int(a) -= b;
	}
	friend Mod_int operator*(const Mod_int& a, const Mod_int& b)
	{
		return Mod_int(a) *= b;
	}

	Mod_int pow(uint64_t pow_val) const
	{
		Mod_int ans{ 1 }, mlt{ val };
		while (pow_val)
		{
			if (pow_val & 1)
			{
				ans *= mlt;
			}
			mlt *= mlt;
			pow_val >>= 1;
		}
		return ans;
	}

	Mod_int& operator/=(const Mod_int& a)
	{
		return *this *= a.pow(MOD_phi - 1);
	}

	friend Mod_int operator/(const Mod_int& a, const Mod_int& b)
	{
		return Mod_int(a) /= b;
	}
};

constexpr int32_t INF = 2'000'000'001;
constexpr int64_t INFl = 2'000'000'000'000'000'001;

void solve();

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int t = 1;
	cin >> t;
	for (int i = 0; i < t; i++)
	{
		solve();
		cout << endl;
	}

	return 0;
}

void solve()
{
	int n, m;
	cin >> n >> m;
	vector<int> mas(m);
	for (int i = 0; i < m; i++)
	{
		cin >> mas[i];
	}
	reverse(ALL(mas));
	vector<int64_t> prev_dp(n / 2 + 1, -INFl), next_dp(n / 2 + 1);
	prev_dp[0] = 0;
	for (int i = 0; i < m; i++)
	{
		if (i & 1)
		{
			for (int j = 1; j < next_dp.size(); j++)
			{
				next_dp[j] = max(prev_dp[j - 1] + mas[i], prev_dp[j] - mas[i]);
			}
			next_dp.front() = prev_dp.front() - mas[i];
		}
		else
		{
			for (int j = 0; j < next_dp.size() - 1; j++)
			{
				next_dp[j] = max(prev_dp[j] + mas[i], prev_dp[j + 1] - mas[i]);
			}
			if (n & 1)
			{
				next_dp.back() = prev_dp.back() + mas[i];
			}
			else
			{
				next_dp.back() = -INFl;
			}
		}
		prev_dp = next_dp;
	}
	int64_t ans = -INFl;
	for (int i = 0; i < prev_dp.size(); i++)
	{
		rmax(ans, prev_dp[i]);
	}
	cout << ans;

	return;
}