#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cstdint>
using namespace std;
#define int long long

void solution();

int32_t main() {
#ifdef LOCAL
    freopen("test", "r", stdin);
    freopen("out", "w", stdout);
#endif

    int t;
    cin >> t;
    while (t--) {
        solution();
    }
}

struct rmq {
    int n;
    vector<pair<int, int>> t;
    vector<int> lad;
    
    rmq(int _n) {
        n = _n;
        t.resize(n * 4);
        lad.resize(n * 4);

        build(0, 0, n);
    }

    pair<int, int> merge(pair<int, int> a, pair<int, int> b) {
        if (a.first < b.first) return a;
        if (a.first > b.first) return b;
        if (a.second > b.second) return a;
        return b;
    }

    void build(int v, int vl, int vr) {
        if (vl + 1 == vr) {
            t[v] = {0, vl};
            return;
        }
        int vm = (vl + vr) / 2;
        build(v * 2 + 1, vl, vm);
        build(v * 2 + 2, vm, vr);
        t[v] = merge(t[v * 2 + 1], t[v * 2 + 2]);
    }

    void push(int v) {
        lad[v * 2 + 1] += lad[v];
        lad[v * 2 + 2] += lad[v];
        t[v * 2 + 1].first += lad[v];
        t[v * 2 + 2].first += lad[v];
        lad[v] = 0;
    }

    void update(int v, int vl, int vr, int l, int r, int x) {
        if (vl >= r || l >= vr) return;
        if (l <= vl && vr <= r) {
            t[v].first += x;
            lad[v] += x;
            return;
        }
        int vm = (vl + vr) / 2;
        push(v);
        update(v * 2 + 1, vl, vm, l, r, x);
        update(v * 2 + 2, vm, vr, l, r, x);
        t[v] = merge(t[v * 2 + 1], t[v * 2 + 2]);
    }

    pair<int, int> get(int v, int vl, int vr, int l, int r) {
        if (l >= vr || vl >= r) return {1e9 + 5, 0};
        if (l <= vl && vr <= r) return t[v];
        push(v);
        int vm = (vl + vr) / 2;
        return merge(get(v * 2 + 1, vl, vm, l, r), get(v * 2 + 2, vm, vr, l, r));
    }
};

void solution() {
    int n, m;
    cin >> n >> m;

    vector<int> a(m);
    for (auto &x : a) {
        cin >> x;
    }

    reverse(a.begin(), a.end());

    rmq t(m + 1);
    // rmq t1(m);
    
    int sm = 0;
    vector<int> d(m);
    // vector<int> p(m);
    int cnt = 0;
    for (int i = 0; i < m; ++i) {
        if (cnt < n) {
            d[i] = 1;
            sm += a[i];
            cnt++;
            t.update(0, 0, m + 1, i + 1, i + 2, cnt);
        } else {
            d[i] = 1;
            sm += a[i];
            cnt++;
            t.update(0, 0, m + 1, i + 1, i + 2, cnt);
            int mn = -1;
            int from = t.get(0, 0, m + 1, 0, i + 2).second + 1;
            for (int j = from; j <= i; ++j) {
                if (d[j] == -1) continue;
                if (mn == -1 || a[j] < a[mn]) mn = j;
            }
            sm -= a[mn] * 2;
            d[mn] = -1;
            t.update(0, 0, m + 1, mn + 1, i + 2, -2);
            // for (int j = mn; j <= i; ++j) {
            //     p[j] = p[j - 1] + d[j];
            // }
            cnt -= 2;
        }
    }

    cout << sm << '\n';
}