#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cstdint>
using namespace std;
#define int long long

void solution();

int32_t main() {
#ifdef LOCAL
    freopen("test", "r", stdin);
    freopen("out", "w", stdout);
#endif

    int t;
    cin >> t;
    while (t--) {
        solution();
    }
}

struct rmq {
    int n;
    vector<int> t;
    vector<int> lad;
    
    rmq(int _n) {
        n = _n;
        t.resize(n * 4);
        lad.resize(n * 4);

        build(0, 0, n);
    }

    void build(int v, int vl, int vr) {
        if (vl + 1 == vr) {
            t[v] = 0;
            return;
        }
        int vm = (vl + vr) / 2;
        build(v * 2 + 1, vl, vm);
        build(v * 2 + 2, vm, vr);
        t[v] = min(t[v * 2 + 1], t[v * 2 + 2]);
    }

    void push(int v) {
        lad[v * 2 + 1] += lad[v];
        lad[v * 2 + 2] += lad[v];
        t[v * 2 + 1] += lad[v];
        t[v * 2 + 2] += lad[v];
        lad[v] = 0;
    }

    void update(int v, int vl, int vr, int l, int r, int x) {
        if (vl >= r || l >= vr) return;
        if (l <= vl && vr <= r) {
            t[v] += x;
            lad[v] += x;
            return;
        }
        int vm = (vl + vr) / 2;
        push(v);
        update(v * 2 + 1, vl, vm, l, r, x);
        update(v * 2 + 2, vm, vr, l, r, x);
        t[v] = min(t[v * 2 + 1], t[v * 2 + 2]);
    }

    int get(int v, int vl, int vr, int l, int r) {
        if (l >= vr || vl >= r) return 1e9 + 5;
        if (l <= vl && vr <= r) return t[v];
        push(v);
        int vm = (vl + vr) / 2;
        return min(get(v * 2 + 1, vl, vm, l, r), get(v * 2 + 2, vm, vr, l, r));
    }
};

void solution() {
    int n, m;
    cin >> n >> m;

    vector<int> a(m);
    for (auto &x : a) {
        cin >> x;
    }

    reverse(a.begin(), a.end());

    rmq t(m + 1);
    // rmq t1(m);
    
    int sm = 0;
    vector<int> d(m);
    int cnt = 0;
    multiset<pair<int, int>> st;
    for (int i = 0; i < m; ++i) {
        if (cnt < n) {
            d[i] = 1;
            sm += a[i];
            cnt++;
            t.update(0, 0, m + 1, i + 1, i + 2, cnt);
            st.emplace(a[i], i);
        } else {
            d[i] = 1;
            sm += a[i];
            cnt++;
            t.update(0, 0, m + 1, i + 1, i + 2, cnt);
            st.emplace(a[i], i);
            int mn = -1;
            while (true) {
                auto [x, ind] = *st.begin();
                if (t.get(0, 0, m + 1, ind + 1, i + 2) <= 1) {
                    st.erase(st.begin());
                    continue;
                }
                mn = ind;
                st.erase(st.begin());
                break;
            }
            sm -= a[mn] * 2;
            d[mn] = -1;
            t.update(0, 0, m + 1, mn + 1, i + 2, -2);
            cnt -= 2;
        }
    }

    cout << sm << '\n';
}