#include <iostream>
#include <unordered_map>
#include <unordered_set>
#include <set>
#include <vector>
#include <map>
#include <cmath>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

template<typename T>
istream& operator>>(istream& in, vector<T>& arr) {
    for (ll i = 0; i < (ll)arr.size(); ++i) {
        in >> arr[i];
    }
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, vector<T>& arr) {
    for (auto el : arr) {
        out << el;
    }
    return out;
}

vector<vector<ll>> g;
vector<bool> used;
vector<ll> dist;

void dfs(ll v) {
    used[v] = true;
    for (auto u : g[v]) {
        if (!used[u]) {
            dist[u] = dist[v] + 1;
            dfs(u);
        }
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    ll t;
    cin >> t;
    while (t--) {
        ll n, m;
        cin >> n >> m;
        vector<ll> x(m);
        cin >> x;
        ll ans = 0;
        for (ll mask = 0; mask < (1 << m); ++mask) {
            ll a = 0, b = 0;
            for (ll i = 0; i < m; ++i) {
                if ((mask >> i) & 1) {
                    a = x[i] - a;
                } else {
                    b = x[i] - b;
                }
            }
            ans = max(ans, a + b);
        }
        cout << ans << '\n';
    }
}