#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <random>
#include <climits>
#include <cmath>
#include <iomanip>

#pragma GCC optimize("O3,unroll-loops")

using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<ll, ll>;

#define all(v) v.begin(), v.end()
#define len(v) (ll)v.size()

mt19937 rnd(525252);

const ll INF = 1e9, SZ = 20, MOD = 1e9 + 7;
const ld eps = 1e-8, pi = acosl(-1);


void solve() {
    ll n, m; cin >> n >> m;
    vector<ll>x(m, 0);
    for (auto &i : x) cin >> i;
    vector<vector<ll>>dp(m + 1, vector<ll>((1 << n), 0));
    for (ll i = 1; i <= m; ++i){
        for (ll j = 0; j < (1 << n); ++j){
            dp[i][j] = -INF;
            bitset<SZ>w(j);
            for (ll b = 0; b < n; ++b){
                if (w[b] == 0){
                    w[b] = 1;
                    dp[i][j] = max(dp[i][j], dp[i-1][(ll)w.to_ullong()] + x[i-1]);
                    w[b] = 0;
                }
                if (w[b] == 1){
                    w[b] = 0;
                    dp[i][j] = max(dp[i][j], dp[i-1][(ll)w.to_ullong()] - x[i-1]);
                    w[b] = 1;
                }
            }
        }
    }
    cout << dp[m][0];
}

int main()
{
	ll t = 1;
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
//	freopen("in.txt", "r", stdin);
//	freopen("out.txt", "w", stdout);
    cin >> t;

	while (t--) {
		solve();
		cout << '\n';
	}
}
