#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <random>
#include <queue>

using namespace std;
using ll = long long;
using ld = long double;
mt19937 rd(328498234);
const ll INF = 1e18;

template<typename T>
struct node {
	int l, r;
	int sz, prior;
	T val;
	node(const T& v = T()) : val(v) {
		sz = 1;
		l = r = -1;
		prior = rd();
	}
};
vector<node<int>> dd;

int getsz(int v) {
	if (v == -1)
		return 0;
	return dd[v].sz;
}

void upd_node(int v) {
	if (v == -1)
		return;

	dd[v].sz = 1;
	if (dd[v].l != -1) {
		dd[v].sz += dd[dd[v].l].sz;
	}
	if (dd[v].r != -1) {
		dd[v].sz += dd[dd[v].r].sz;
	}
}

void push_node(int v) {
	return;
}

int merge(int l, int r) {
	if (l == -1)
		return r;
	if (r == -1)
		return l;
	push_node(l);
	push_node(r);
	if (dd[l].prior < dd[r].prior) {
		dd[r].l = merge(l, dd[r].l);
		upd_node(r);
		return r;
	}
	else {
		dd[l].r = merge(dd[l].r, r);
		upd_node(l);
		return l;
	}
}

pair<int, int> split_sz(int v, int k) { //{<=k, >k}
	if (v == -1)
		return { -1, -1 };
	if (dd[v].sz <= k)
		return { v, -1 };
	if (k <= 0)
		return { -1, v };
	push_node(v);
	if (getsz(dd[v].l) >= k) {
		auto p = split_sz(dd[v].l, k);
		dd[v].l = p.second;
		upd_node(v);
		return { p.first, v };
	}
	else {
		auto p = split_sz(dd[v].r, k - getsz(dd[v].l) - 1);
		dd[v].r = p.first;
		upd_node(v);
		return { v, p.second };
	}
}

pair<int, int> split_val(int v, int val) { // {<=val, >val}
	if (v == -1)
		return { -1, -1 };
	push_node(v);
	if (dd[v].val > val) {
		auto p = split_sz(dd[v].l, val);
		dd[v].l = p.second;
		upd_node(v);
		return { p.first, v };
	}
	else {
		auto p = split_sz(dd[v].r, val);
		dd[v].r = p.first;
		upd_node(v);
		return { v, p.second };
	}
}

int create_node(int val) {
	dd.push_back(val);
	return (int)dd.size() - 1;
}

struct segtree {
	struct node {
		int val;
		node(int val = 0) : val(val) {}
	};

	int sz;
	int ql, qr;
	vector<node> tr;
	vector<int> sizes;
	segtree(int n) {
		sz = 1;
		while (sz < n)
			sz <<= 1;
		tr.assign(sz * 2 - 1, node());
		sizes.assign(sz * 2 - 1, 0);
		sizes[0] = sz;
		for (int i = 1; i < sz * 2 - 1; i++)
			sizes[i] = sizes[(i - 1) / 2] / 2;
		ql = qr = -1;
	}

	void upd(int v) {
		tr[v].val = tr[v * 2 + 1].val + tr[v * 2 + 2].val;
		return;
	}
	void push(int v) {
		return;
	}

	void op_on_seg(int v, int l, int r) {
		if (qr <= l || r <= ql)
			return;
		if (ql <= l && r <= qr) {
			// op
			return;
		}
		push(v);
		op_on_seg(v * 2 + 1, l, (l + r) / 2);
		op_on_seg(v * 2 + 2, (l + r) / 2, r);
		upd(v);
	}

	void get_on_seg(int v, int l, int r) {
		if (qr <= l || r <= ql)
			return;
		if (ql <= l && r <= qr) {
			// get
			return;
		}
		push(v);
		get_on_seg(v * 2 + 1, l, (l + r) / 2);
		get_on_seg(v * 2 + 2, (l + r) / 2, r);
		// merge
		return;
	}
};

ll solve() {
	int n, m;
	cin >> n >> m;
	vector<ll> x(m + 1);
	for (int i = 0; i < m; i++)
		cin >> x[i];
	reverse(x.begin(), x.end());

	vector<vector<ll>> dp(m + 1, vector<ll>(n + 1, -INF));
	dp[0][n] = 0;
	for (int i = 1; i <= m; i++) {
		dp[i][0] = dp[i - 1][1] + x[i];
		dp[i][n] = dp[i - 1][n - 1] - x[i];
		for (int j = 1; j < n; j++)
			dp[i][j] = max(dp[i - 1][j - 1] - x[i], dp[i - 1][j + 1] + x[i]);
	}
	ll ans = -INF;
	for (int i = 0; i <= n; i++)
		ans = max(ans, dp[m][i]);
	return ans;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	int t;
	cin >> t;
	vector<ll> ans(t);
	for (int i = 0; i < t; i++)
		ans[i] = solve();
	for (auto x : ans)
		cout << x << '\n';
}