#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

const long long INF = 1e17;

void solve1() {
    int n, m;
    cin >> m >> n;
    vector<long long> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    reverse(v.begin(), v.end());
    vector<vector<long long>> dp(n + 1, vector<long long>(m + 1, -INF));
    dp[0][m] = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j <= m; j++) {
            if (dp[i][j] == -INF) {
                continue;
            }
            if (j > 0) {
                dp[i + 1][j - 1] = max(dp[i + 1][j - 1], dp[i][j] + v[i]);
            }
            if (j < m) {
                dp[i + 1][j + 1] = max(dp[i + 1][j + 1], dp[i][j] - v[i]);
            }
        }
    }
    long long ans = -INF;
    for (int i = 0; i <= m; i++) {
        ans = max(ans, dp[n][i]);
    }
    cout << ans << '\n';
}

void add(vector<int> &bal, int id, int t) {
    for (int i = id; i < bal.size(); i++) {
        bal[i] += t;
    }
}

int getmin(vector<int> &bal) {
    int mn = 1e9;
    for (int i = 0; i < bal.size(); i++) {
        mn = min(mn, bal[i]);
    }
    return mn;
}

void solve() {
    int n, m;
    cin >> m >> n;
    vector<long long> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    reverse(v.begin(), v.end());
    /*if (m == 1) {
        long long ans = 0;
        for (int i = 0; i < n; i++) {
            if (i % 2 == 0) {
                ans += v[i];
            } else {
                ans -= v[i];
            }
        }
        cout << ans << '\n';
        return;
    }*/
    vector<int> bal(n, 1);
    vector<long long> cur(n, 0);
    set<pair<long long, int>> st;
    vector<int> sgn(n);
    cur[0] = v[0];
    sgn[0] = 1;
    for (int i = 1; i < n; i++) {
        long long x = v[i];
        st.insert({v[i], i});
        add(bal, i, 1);
        sgn[i] = 1;
        if (bal[i] > m) {  
            while (true) {
                auto [x, id] = *(st.begin());
                add(bal, id, -2);
                sgn[id] = -1;
                st.erase(st.begin());
                if (getmin(bal) >= 0) {
                    break;
                } else {
                    add(bal, id, 2);
                    sgn[id] = 1;
                }
            }
        }
    }
    long long ans = 0;
    for (int i = 0; i < n; i++) {
        if (sgn[i] == 1) {
            ans += v[i];
        } else {
            ans -= v[i];
        }
    }
    cout << ans << '\n';
}

int main()
{
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }

    return 0;
}