#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <algorithm>
#include <unordered_map>
#include <assert.h>
using namespace std;

template<typename T1,typename T2>
istream&operator>>(istream&in,pair<T1,T2>&a){
    return in>>a.first>>a.second;
}
template<typename T1,typename T2>
ostream&operator<<(ostream&out,const pair<T1,T2>&a){
    return out<<a.first<<' '<<a.second<<'\n';
}
template<typename T>
istream&operator>>(istream&in,vector<T>&a){
    for (auto &i:a)in>>i;
    return in;
}
template<typename T>
ostream&operator<<(ostream&out,const vector<T>&a){
    for (const auto &i:a)out<<i<<' ';
    return out;
}
template<typename T>
ostream&operator<<(ostream&out,const vector<vector<T>>&a){
    for (const auto &i:a)out<<i<<'\n';
    return out;
}
typedef long long ll;
const int inf =1e9+7;
void print(bool flag){
if (flag)cout<<"YES\n";
else cout<<"NO\n";
}
struct solve{
    int n;
    vector<int>a;
    const int X=101;
    const int Y=50;
    solve(){
        cin>>n>>n;
        a.resize(n);
        cin>>a;
        vector<vector<vector<int>>>dp(n+1,vector<vector<int>>(X,vector<int>(X, -inf)));
        for (int x=0;x<X;x++){
            for (int y=0;y<X;y++){
                int u=x-Y;
                int v=y-Y;
                dp[n][x][y]=u+v;
            }
        }
        for (int i=n-1;i>=0;i--){
            for (int x=0;x<X;x++){
                for (int y=0;y<X;y++){
                    int u=x-Y;
                    int v=y-Y;
                    int t=a[i];
                    int tu=t-u+Y;
                    int tv=t-v+Y;
                    int t1=-inf;
                    int t2=-inf;
                    if (tu>=0 && tu<X)t1=dp[i+1][t-u+Y][v+Y];
                    if (tv>=0 && tv<X)t2=dp[i+1][u+Y][t-v+Y];
                    dp[i][x][y]=max(t1,t2);
                }
            }
        }
        cout<<dp[0][Y][Y]<<'\n';
    }
};
int main()
{
    int t=1;

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin>>t;
    while(t--)solve();
}
