#include <iostream>
#include <vector>

#define int long long

using namespace std;

void build(int v, int l, int r, int ind, int val, vector<int>& tree) {
    if (ind < l || r <= ind) {
        return;
    }
    if (l + 1 == r) {
        tree[v] = val;
        return;
    }
    int m = (l + r) / 2;
    build(2 * v + 1, l, m, ind, val, tree);
    build(2 * v + 2, m, r, ind, val, tree);
    tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
}

int get_max(int v, int l, int r, int lq, int rq, vector<int>& tree) {
    if (rq <= l || r <= lq) {
        return 0;
    }
    if (l <= lq && rq <= r) {
        return tree[v];
    }
    int m = (l + r) / 2;
    return max(get_max(2 * v + 1, l, m, lq, rq, tree), get_max(2 * v + 1, m, r, lq, rq, tree));
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    int t;
    cin >> t;
    for (int _ = 0; _ < t; ++_) {
        int n, m;
        cin >> n >> m;
        vector<int> a(m);
        for (int i = 0; i < m; ++i) {
            cin >> a[i];
        }
        if (m <= n) {
            cout << a[0] * m << endl;
            continue;
        }
        if ((m - n) % 2 == 0) {
            cout << a[0] * n << endl;
        }
        else {
            cout << a[0] * n - a[0] << endl;
        }
    }
}
