#include <bits/stdc++.h>

using namespace std;

template<typename T>
istream& operator>>(istream& is, vector<T>& a) {
    for (auto& x : a) is >> x;
    return is;
}
template<typename T>
ostream& operator<<(ostream& is, vector<T>& a) {
    for (auto& x : a) is << x << ' ';
    cout << '\n';
    return is;
}

template<typename T1, typename T2>
istream& operator>>(istream& is, vector<pair<T1, T2>>& a) {
    for (auto& x : a) is >> x.first >> x.second;
    return is;
}

template<typename T1, typename T2>
ostream& operator<<(ostream& is, vector<pair<T1, T2>>& a) {
    for (auto& x : a) is << x.first << ' ' << x.second << '\n';
    return is;
}


template<typename T1, typename T2>
void amax(T1& a, T2 b) {
    a = max(a, b);
}
template<typename T1, typename T2>
void amin(T1& a, T2 b) {
    a = min(a, b);
}
#ifdef OTKR
bool local = true;
#else
bool local = false;
#endif // OTKR

#define int long long
#define sz(x) (int)(x.size())
#define all(x) x.begin(), x.end()
#define ff first
#define ss second
#define pb emplace_back
#define push emplace

void solve();
void stress();
void precalc();

using vi = vector<int>;
using pi = pair<int, int>;
using vpi = vector<pi>;
using vvi = vector<vi>;
using vvpi = vector<vpi>;

const int ma = 3e5 + 1;
const int INF = 1e18;
const int mod = 1e9 + 7;

struct Mint{
    int x;
    Mint() : x(0) {}
    Mint(int x) : x(x) {}
    Mint operator+(const Mint& b) const {
        int res = x + b.x;
        if (res >= mod) res -= mod;
        return {res};
    }
    Mint operator-(const Mint& b) const {
        int res = x - b.x;
        if (res < 0) res += mod;
        return {res};
    }
    Mint operator*(const Mint& b) const {
        return {x * b.x % mod};
    }
    Mint operator==(const Mint& b) const {
        return x == b.x;
    }
};

struct Segtree{
    struct Node{
        int ma = 0;
        Node operator+(const Node& b) const {
            Node res;
            res.ma = max(ma, b.ma);
            return res;
        }
    };
    Node Make(int x, int i) {
        Node res;
        res.ma = x;
        return res;
    }
    Node N = {-INF};
    vector<Node> t;
    void build(int v, int l, int r, vi& a) {
        if (l + 1 == r) {
            t[v] = Make(a[l], l);
        }
        int m = (l + r) / 2;
        build(v * 2, l, m, a);
        build(v * 2 + 1, m, r, a);
        t[v] = t[v * 2] + t[v * 2 + 1];
    }
    Segtree(int sz) : t(4 * sz) {}
    void upd(int v, int l, int r, int i, int x) {
        if (l + 1 == r) {
            t[v] = Make(x, l);
            return;
        }
        int m = (l + r) / 2;
        if (i < m) {
            upd(v * 2, l, m, i, x);
        } else {
            upd(v * 2 + 1, m, r, i, x);
        }
        t[v] = t[v * 2] + t[v * 2 + 1];
    }
    Node get(int v, int nl, int nr, int ql, int qr) {
        if (nl >= qr || nr <= ql) return N;
        if (ql <= nl && nr <= qr) return t[v];
        int m = (nl + nr) / 2;
        return get(v * 2, nl, m, ql, qr) + get(v * 2 + 1, m, nr, ql, qr);
    }
};

signed main() {
    if (local) {
        freopen("input.txt", "r", stdin);
    }
    int t = 1; cin >> t;
    while (t--) {
        solve();
    }
}

int brut2(int n, int m, vi& a) {
    //n == 2
    int ans = -INF;
    vi cur(n);
    for (int mask = 0; mask < (1 << m); mask++) {
        cur[0] = cur[1] = 0;
        vi f, s;
        for (int i = 0; i < m; i++) {
            if (((mask >> i) & 1) == 1) {
                f.pb(a[i]);
            } else {
                s.pb(a[i]);
            }
        }
        int res = 0;
        for (auto x : f) {
            cur[0] = x - cur[0];
        }
        for (auto x : s) {
            cur[1] = x - cur[1];
        }
        res = cur[0] + cur[1];
        if (ans <= res) {
            ans = res;
        }
    }
    return ans;
}

mt19937 mt(time(0));

void stress() {
    for (int we = 0; we <= 100; we++) {
        int n = 2;
        int m = 1 + mt() % 15;
        vector<int> a(m);
        for (auto& x : a) {
            x = 1 + mt() % 20;
        }
        brut2(n, m, a);
    }
    cout << "GOOOOOOOOOOOOOOOOOOOOOOL" << endl;
}

void solve() {
    //stress();
    int n, m;
    cin >> n >> m;
    vi a(m); cin >> a;
    if (n >= m) {
        cout << a[0] * m << '\n';
    } else {
        int dop = m - n, ans = a[0] * n;
        if (dop % 2 == 1) {
            ans -= a[0];
        }
        cout << ans << '\n';
    }
}









