#include <bits/stdc++.h>

//#pragma GCC optimize("Ofast")

#define int long long

using namespace std;

const int mod = 1e9 + 7;
const int maxn = 2e5 + 1;
const int inf = 4e18;

struct node {
    int val = 0, add = 0, idx = -1;

    node() = default;

    node(int _val, int _idx) {
        val = _val;
        idx = _idx;
    }

    node(int _val) {
        val = _val;
    }
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    vector<int> x(m);
    for (int i = 0; i < m; i++) {
        cin >> x[i];
    }

    vector<node> t(n * 4);
    vector<node> t1(n * 4);

    function<node(node, node)> combine_min = [&](node a, node b) {
        return node(min(a.val, b.val));
    };

    function<node(node, node)> combine_max = [&](node a, node b) {
        return node(max(a.val, b.val));
    };


    function<void(int, int, int)> build = [&](int v, int l, int r) {
        if (r - l == 1) {
            t[v] = node(a[l]);
            return;
        }
        int m = (l + r) / 2;
        build(v * 2, l, m);
        build(v * 2 + 1, m, r);
        t[v] = combine_min(t[v * 2], t[v * 2 + 1]);
        t1[v] = combine_min(t[v * 2], t[v * 2 + 1]);
    };

    function<void(int, int, int, int, int)> update = [&](int key, int val, int v, int l, int r) {
        if (r - l == 1) {
            t[v] = node(key);
            return;
        }
        int m = (l + r) / 2;
        if (m >= key) {
            update(key, val, v * 2 + 1, m, r);
        } else {
            update(key, val, v * 2, l, m);
        }
        t[v] = combine_min(t[v * 2], t[v * 2 + 1]);
    };

    function<void(int, int, int, int, int)> update1 = [&](int key, int val, int v, int l, int r) {
        if (r - l == 1) {
            t1[v] = node(key);
            return;
        }
        int m = (l + r) / 2;
        if (m >= key) {
            update1(key, val, v * 2 + 1, m, r);
        } else {
            update1(key, val, v * 2, l, m);
        }
        t1[v] = combine_max(t1[v * 2], t1[v * 2 + 1]);
    };

    function<int(int, int, int, int, int)> get_min = [&](int ql, int qr, int v, int l, int r) {
        if (ql >= r or qr <= l) {
            return inf;
        }
        if (ql <= l and qr >= r) {
            return t[v].val;
        }
        int m = (l + r) / 2;
        return min(get_min(ql, qr, v * 2, l, m), get_min(ql, qr, v * 2 + 1, m, r));
    };

    function<int(int, int, int, int, int)> get_max = [&](int ql, int qr, int v, int l, int r) {
        if (ql >= r or qr <= l) {
            return -inf;
        }
        if (ql <= l and qr >= r) {
            return t1[v].val;
        }
        int m = (l + r) / 2;
        return min(get_max(ql, qr, v * 2, l, m), get_max(ql, qr, v * 2 + 1, m, r));
    };
    int ans = -inf;
    for (int mask = 0; mask < (1 << m); mask++) {
        array<vector<int>, 2> p;
        for (int i = 0; i < m; i++) {
            int bit = (mask >> i) & 1;
            p[bit].push_back(x[i] * (p[bit].size() % 2 ? -1 : 1));
        }
        int sm = 0;
        for (int j = 0; j < 2; j++) {
            sm += (p[j].size() % 2 ? 1 : -1) * accumulate(p[j].begin(), p[j].end(), 0ll);
        }
        ans = max(ans, sm);
    }
    cout << ans <<  '\n';
}

signed main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
