#include <bits/stdc++.h>

using namespace std;

constexpr int R = 1 << 19, INF = 1e9 + 7;

int mx[R * 2], psh[R * 2];

void push(int node) {
    if (psh[node] != 0) {
        mx[node * 2] += psh[node];
        psh[node * 2] += psh[node];
        mx[node * 2 + 1] += psh[node];
        psh[node * 2 + 1] += psh[node];
    }
    psh[node] = 0;
}

void add(int ql, int qr, int val, int node = 1, int nl = 0, int nr = R) {
    if (ql <= nl && nr <= qr) {
        mx[node] += val;
        psh[node] += val;
        return;
    }
    if (qr <= nl || nr <= ql) {
        return;
    }
    push(node);
    int nm = (nl + nr) / 2;
    add(ql, qr, val, node * 2, nl, nm);
    add(ql, qr, val, node * 2 + 1, nm, nr);
    mx[node] = max(mx[node * 2], mx[node * 2 + 1]);
}

constexpr int maxn = 3e5 + 5;

vector<int> g[maxn];

int p[maxn];

int s[maxn];

int ans[maxn];

int sz[maxn];

void dfs(int v) {
    sz[v] = 1;
    for (auto u : g[v]) {
        dfs(u);
        sz[v] += sz[u];
    }
}

int t = 0;

int tin[maxn], tout[maxn];

int head[maxn];

void build_hld(int v) {
    tin[v] = t++;
    for (int i = 1; i < (int)g[v].size(); ++i) {
        if (sz[g[v][i]] > sz[g[v][0]]) {
            swap(g[v][i], g[v][0]);
        }
    }
    for (int i = 0; i < (int)g[v].size(); ++i) {
        if (i == 0) {
            head[g[v][i]] = head[v];
        } else {
            head[g[v][i]] = g[v][i];
        }
        build_hld(g[v][i]);
    }
    tout[v] = t;
}

void add_to_path(int v, int val) {
    while (true) {
        add(tin[head[v]], tin[v] + 1, val);
        if (head[v] == 0) {
            break;
        }
        v = p[head[v]];
    }
}

void solve() {
    int n, q;
    cin >> n >> q;
    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        p[i]--;
        g[p[i]].push_back(i);
    }
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    vector<int> ord = {0};
    set<pair<int, int>> candidates;
    for (auto v : g[0]) {
        candidates.emplace(s[v], v);
    }
    while (!candidates.empty()) {
        int v = candidates.rbegin()->second;
        candidates.erase(*candidates.rbegin());
        ord.push_back(v);
        for (auto u : g[v]) {
            candidates.emplace(s[u], u);
        }
    }
    dfs(0);
    build_hld(0);
    for (int i = 0; i < n; ++i) {
        int v = ord[i];
        add_to_path(v, -INF);
        ans[v] = i - mx[1];
        add_to_path(v, INF + 1);
    }
    while (q--) {
        int v;
        cin >> v;
        v--;
        cout << ans[v] << ' ';
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
