#ifdef _DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <iomanip>
#include <string>
#include <limits>
#include <stack>
#include <queue>
#include <deque>
#include <vector>
#include <numeric>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <chrono>
#include <random>
#include <assert.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ui = unsigned int;
using ld = long double;
using pii = pair<int, int>;
using pli = pair<long long, int>;
using pil = pair<int, long long>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

const int N = 3e5;
vector<int> g[N];
int par[N];
int s[N];
int cl[N];
int max_win[N];
int t[N];
int tin[N], tout[N];

int timer;

void dfs0(int v) {
	tin[v] = timer++;
	for (int u : g[v])
		dfs0(u);
	tout[v] = timer;
}

bool ancestor(int v, int u) {
	return tin[v] <= tin[u] && tout[u] <= tout[v];
}

int dp[N];

int dfs1(int v, int stop) {
	dp[v] = s[v] >= s[stop];
	if (v == stop)
		return dp[v];
	for (int u : g[v])
		if (s[u] >= s[stop])
			dp[v] += dfs1(u, stop);
	return dp[v];
}

inline void solve() {
	int n, q;
	cin >> n >> q;
	for (int i = 1; i < n; i++) {
		int p;
		cin >> p;
		p--;
		g[p].push_back(i);
		par[i] = p;
	}
	for (int i = 0; i < n; i++) {
		cin >> s[i];
		s[i]--;
	}
	{
		int x = s[0];
		s[0] = 0;
		for (int i = 1; i < n; i++)
			if (s[i] < x)
				s[i]++;
	}
	dfs0(0);
	for (int v = 1; v < n; v++) {
		cl[v] = v;
		while (s[cl[v]] >= s[v])
			cl[v] = par[cl[v]];
		max_win[v] = max_win[cl[v]];
		t[v] = dfs1(cl[v], v) + t[cl[v]];
		int u = v;
		while (u != cl[v]) {
			u = par[u];
			for (int ch : g[u])
				if (!ancestor(ch, v) && s[ch] >= s[v])
					max_win[v] = max(max_win[v], dp[ch]);
		}
	}
	while (q--) {
		int v;
		cin >> v;
		v--;
		cout << t[v] - max_win[v] << ' ';
	}
	cout << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("01.dat", "r", stdin);
#endif
	int tt = 1;
#ifdef _DEBUG
	cin >> tt;
#endif
	for (int test_id = 1; test_id <= tt; test_id++) {
#ifdef _DEBUG
		cout << "TESTCASE# " << test_id << '\n';
#endif
		solve();
	}
	return 0;
}
