#ifdef LOCAL
#pragma optimize("", off)
#include "localstd1.h"
#else
#pragma GCC optimize("Ofast,unroll-loops")
#include <bits/allocator.h>
#pragma GCC target("avx2,bmi,bmi2")
#include <bits/stdc++.h>
#endif

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define all(a) (a).begin(), (a).end()

struct Node {
	vector<int> e;
	int s;
	int val = 0;
	int res = 0;
	int p = -1;

	int vers = -1;
};
vector<Node> graph;

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int n, q; cin >> n >> q;
	graph.assign(n, { });
	for (int i = 1; i < n; i++) {
		int p; cin >> p; p--;
		graph[p].e.push_back(i);
		graph[i].p = p;
	}
	for (int i = 0; i < n; i++) {
		cin >> graph[i].s;
	}

	priority_queue<pair<int, int>> bfs;
	bfs.push({ graph[0].s, 0 });
	int cnt = 0;
	while (bfs.size()) {
		auto [s, u] = bfs.top();
		bfs.pop();
		int v = u;
		while (v != -1) {
			graph[v].val++;
			graph[v].vers = u;
			v = graph[v].p;
		}
		graph[u].res = cnt;
		int mx_ec = 0;
		for (int i = 0; i < n; i++) if (graph[i].vers != u) {
			mx_ec = max(mx_ec, graph[i].val);
		}
		graph[u].res -= mx_ec;
		cnt++;
		for (int to : graph[u].e) {
			bfs.push({ graph[to].s, to });
		}
	}

	while (q--) {
		int u; cin >> u; u--;
		cout << graph[u].res << '\n';
	}
	
	return 0;
}