#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <cmath>
#include <set>
#include <random>
using namespace std;

#define all(x) x.begin(), x.end()
#define sz(x) static_cast<lng>(x.size())

using lng = long long;

vector<vector<int>> g, dist;
vector<set<pair<int, int>, greater<pair<int, int>>>*> gp;
vector<int> cur_comp;

void check(int c) {
	gp.assign(sz(g), nullptr);
	int timer = 0, cur_boss = 0;
	for (int i = 0; i < sz(g); i++) {
		gp[i] = new set<pair<int, int>, greater<pair<int, int>>>{};
		for (int u : g[i]) {
			gp[i]->emplace(cur_comp[u], u);
		}
	}
	while (timer < sz(g)) {
		dist[c][cur_boss] = timer++;
		if (!gp[cur_boss]->empty()) {
			int new_boss = gp[cur_boss]->begin()->second;
			gp[cur_boss]->erase(gp[cur_boss]->begin());
			if (gp[new_boss]->size() < gp[cur_boss]->size()) {
				swap(gp[cur_boss], gp[new_boss]);
			}
			for (auto it = gp[cur_boss]->begin(); it != gp[cur_boss]->end(); it++) {
				gp[new_boss]->insert(*it);
			}
			cur_boss = new_boss;
		}
	}
}

void solve() {
	int n, q; cin >> n >> q;
	g.assign(n, vector<int>(0));
	for (int i = 1; i < n; i++) {
		int p; cin >> p;
		p--;
		g[p].push_back(i);
	}
	dist.assign(n, vector<int>(n, 1e6));
	cur_comp.resize(n);
	for (int c = 0; c < n; c++) {
		cin >> cur_comp[c];
	}
	for (int c = 1; c < n; c++) {
		int x = cur_comp[c];
		cur_comp[c] = 0;
		check(c);
		cur_comp[c] = x;
	}
	for (int t = 0; t < q; t++) {
		int v; cin >> v; --v;
		int ans = 1e6;
		for (int i = 0; i < n; i++) {
			ans = min(ans, dist[i][v]);
		}
		cout << ans << ' ';
	}
}

int main() { 
	cin.tie(nullptr)->sync_with_stdio(false);
	int t = 1;
	while (t--) {
		solve();
	}
	return 0;
}
