#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <cmath>
#include <set>
#include <random>
using namespace std;

#define all(x) x.begin(), x.end()
#define sz(x) static_cast<lng>(x.size())

using lng = long long;

vector<vector<int>> g, dist;
vector<set<pair<int, int>, greater<pair<int, int>>>*> gp;
vector<int> cur_comp, color;

void dfs(int v, int c) {
	color[v] = c;
	for (int u : g[v]) {
		dfs(u, c);
	}
}

void check(int c) {
	gp.assign(sz(g), nullptr);
	int timer = 0, cur_boss = 0;
	for (int i = 0; i < sz(g); i++) {
		gp[i] = new set<pair<int, int>, greater<pair<int, int>>>{};
		for (int u : g[i]) {
			gp[i]->emplace(cur_comp[u], u);
		}
	}
	while (timer < sz(g)) {
		dist[c][cur_boss] = timer++;
		if (!gp[cur_boss]->empty()) {
			int new_boss = gp[cur_boss]->begin()->second;
			gp[cur_boss]->erase(gp[cur_boss]->begin());
			if (gp[new_boss]->size() < gp[cur_boss]->size()) {
				swap(gp[cur_boss], gp[new_boss]);
			}
			for (auto it = gp[cur_boss]->begin(); it != gp[cur_boss]->end(); it++) {
				gp[new_boss]->insert(*it);
			}
			cur_boss = new_boss;
		}
	}
}

void solve() {
	int n, q; cin >> n >> q;
	g.assign(n, vector<int>(0));
	for (int i = 1; i < n - 1; i++) {
		int p; cin >> p;
		p--;
		g[p].push_back(i);
	}
	dist.assign(1, vector<int>(n, 1e6));
	cur_comp.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> cur_comp[i];
	}
	color.assign(n, 0);
	check(0); 
	for (int u : g[0]) {
		dfs(u, u);
	}
	vector<int> order(n);
	for (int i = 0; i < n; i++) {
		order[dist[0][i]] = i;
	}
	vector<int> ans(n, 0);
	vector<int> subtree_sum(n, 0);
	for (int i = 1; i < n; i++) {
		int mx = 0;
		int v = order[i];
		int cur = v / 2, prev = v;
		while (cur != prev) {
			if (prev == 2 * v + 1) {
				mx = max(mx, subtree_sum[2 * v + 2]);
			}
			if (prev == 2 * v + 2) {
				mx = max(mx, subtree_sum[2 * v + 1]);
			}
			prev = cur;
			cur /= 2;
		}
		ans[v] = i - mx;
		for (int u = v; u > 0; u /= 2) {
			subtree_sum[u]++;
		}
		subtree_sum[0]++;
	}
}

int main() { 
	cin.tie(nullptr)->sync_with_stdio(false);
	int t = 1;
	while (t--) {
		solve();
	}
	return 0;
}
