// #pragma GCC optimize("Ofast")
// #pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int N = 1e3 + 1;

int par[N], s[N];
vector<vector<int>> g(N);
int depth[N];

int num[N];
int sim[N][N];

int timer = 0;
int sz[N], tin[N], tout[N];

void dfs(int v) {
    tin[v] = timer++;
    sz[v] = 1;
    for (auto& u: g[v]) {
        dfs(u);
        sz[v] += sz[u];
    }
    tout[v] = timer++;
}

bool upper(int a, int b) {
    return tin[a] <= tin[b] && tout[a] >= tout[b];
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;

    for (int i = 2; i <= n; ++i) {
        cin >> par[i];
        g[par[i]].push_back(i);
    }

    for (int i = 1; i <= n; ++i) {
        cin >> s[i];
    }

    dfs(1);

    for (int del = 1; del <= n; ++del) {
        int prev = s[del];
        s[del] = 0;

        vector<set<pair<int, int>>> f(n + 1);
        for (int i = 1; i <= n; ++i) {
            num[i] = i;

            for (int j = 0; j < g[i].size(); ++j) {
                if (g[i][j] == del) continue;
                f[i].insert({-s[g[i][j]], g[i][j]});
            }
        }

        int root = 1, in = (del == 1 ? n : n - sz[del]);
        int day = 0;
        while (in) {
            sim[del][num[root]] = day;
            --in, ++day;
            
            if (in == 0) break;
            pair<int, int> que = *f[root].begin();
            f[root].erase(f[root].begin());
            int next = que.second;

            if (f[next].size() < f[root].size()) {
                for (auto& u: f[next]) {
                    f[root].insert(u);
                }
                num[root] = next;
            } else {
                for (auto& u: f[root]) {
                    f[next].insert(u);
                }
                root = next;    
            }
        }

        s[del] = prev;
    }

    for (int i = 0; i < q; ++i) {
        int v;
        cin >> v;

        if (v == 1) {
            cout << 0 << "\n";
            continue;
        }

        int ans = n + 1;
        for (int i = 1; i <= n; ++i) {
            if (i == v || (i != 1 && upper(i, v))) continue;
            ans = min(ans, sim[i][v]);
        }

        cout << ans << " ";
    }

    return 0;
}
