//#pragma GCC optimize("unroll-loops,Ofast")
//#pragma GCC target("sse,sse2,avx,avx2")

#include <bits/stdc++.h>

using namespace std;
const int inf = 1e7, N = 300001;
set<pair<int, int>> g[N];
vector<int> g1[N];
int s[N], pr[N], poses[N], PP[N], tin[N], lead[N];

struct segtree {
    int siz;
    struct node {
        int mx, add;
    };
    vector<node> tree;

    inline void init(int n) {
        siz = 1;
        while (siz < n) {
            siz *= 2;
        }
        tree.assign(2 * siz - 1, {0, 0});
    }

    inline node comb(node a, node b) {
        return {max(a.mx, b.mx), 0};
    }

    inline void push(int v, int l, int r) {
        if (r - l == 1 || tree[v].add == 0)return;
        tree[2 * v + 1].add += tree[v].add;
        tree[2 * v + 2].add += tree[v].add;
        tree[2 * v + 1].mx += tree[v].add;
        tree[2 * v + 2].mx += tree[v].add;
        tree[v].add = 0;
    }

    void upd(int v, int l, int r, int ql, int qr, int val) {
        if (r <= ql || qr <= l)return;
        push(v, l, r);
        if (ql <= l && r <= qr) {
            tree[v].add += val;
            tree[v].mx += val;
            return;
        }
        int mid = (l + r) / 2;
        upd(2 * v + 1, l, mid, ql, qr, val);
        upd(2 * v + 2, mid, r, ql, qr, val);
        tree[v] = comb(tree[2 * v + 1], tree[2 * v + 2]);
    }

    node query(int v, int l, int r, int ql, int qr) {
        if (r <= ql || qr <= l)return {-inf, 0};
        push(v, l, r);
        if (ql <= l && r <= qr) {
            return tree[v];
        }
        int mid = (l + r) / 2;
        return comb(query(2 * v + 1, l, mid, ql, qr), query(2 * v + 2, mid, r, ql, qr));
    }
};

int t, n;
struct query {
    int v, i, pos;
};

bool cmp(query a, query b) {
    return a.pos < b.pos;
}

bool cmp1(int u, int v) {
    return s[u] > s[v];
}

inline void get_poses(int v) {
    auto g1 = g;
    if (v) {
        g1[pr[v]].erase({s[v], v});
        g1[pr[v]].insert({0, v});
    }
    int root = 0;
    int tim = 0;
    while (true) {
        poses[root] = tim++;
        if (g1[root].empty())break;
        auto z = --g1[root].end();
        int r1 = z->second;
        g1[root].erase(z);
        if (g1[root].size() > g1[r1].size()) {
            swap(g1[root], g1[r1]);
        }
        for (auto to: g1[root]) {
            g1[r1].insert(to);
        }
        root = r1;
    }
}

void count_sz(int v) {
    s[v] = 1;
    vector<int> por;
    for (int to: g1[v]) {
        por.push_back(to);
        count_sz(to);
        s[v] += s[to];
    }
    sort(por.begin(), por.end(), cmp1);
    g1[v] = por;
}

void dfs(int v, int L) {
    lead[v] = L;
    tin[v] = t++;
    bool e = true;
    for (int to: g1[v]) {
        if (e) {
            dfs(to, L);
            e = false;
        } else {
            dfs(to, to);
        }
    }
}

segtree st;

inline void add_in_path(int v, int val) {
    while (true) {
        int Ld = lead[v];
        st.upd(0, 0, st.siz, tin[Ld], tin[v] + 1, val);
        if (Ld == 0)break;
        v = pr[Ld];
    }
}

inline int get_mx(int v) {
    int L = tin[v], R = tin[v] + s[v] - 1;
    return st.comb(st.query(0, 0, st.siz, 0, L), st.query(0, 0, st.siz, R + 1, n)).mx;
}

void solve() {
    int q;
    cin >> n >> q;
    for (int i = 1; i < n; ++i) {
        cin >> pr[i];
        pr[i]--;
        g1[pr[i]].push_back(i);
    }
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    for (int i = 1; i < n; ++i) {
        g[pr[i]].insert({s[i], i});
    }
    get_poses(0);
    t = 0;
    count_sz(0);
    dfs(0, 0);
    for (int i = 0; i < n; ++i) {
        PP[i] = poses[i];
    }
    vector<query> Q;
    vector<bool> used(n, false);
    for (int i = 0; i < q; ++i) {
        int v;
        cin >> v;
        v--;
        used[v] = true;
        Q.push_back({v, i, PP[v]});
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i])Q.push_back({i, -1, PP[i]});
    }
    sort(Q.begin(), Q.end(), cmp);
    vector<int> ans(q);
    st.init(n);
    for (int i = 0; i < n; ++i) {
        int v = Q[i].v;
        int id = Q[i].i;
        if (id != -1) {
            ans[id] = PP[v];
            if (v) {
                add_in_path(v, -inf);
                int Mx = get_mx(v);
                ans[id] = min(PP[v] - Mx, ans[id]);
                add_in_path(v, inf);
            }
        }
        add_in_path(v, 1);
    }
    for (int i = 0; i < q; ++i) {
        cout << ans[i] << " ";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
