#include<iostream>
#include<vector>
#include<stack>
#include<map>
#include<set>
#include<random>
#include<chrono>

using namespace std;

#pragma GCC optimize("O3")

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

// #define int long long

const int MAX = 3e5 + 1;
vector<int> g[MAX];
int pos[MAX], son[MAX], val[MAX], tin[MAX], tout[MAX];
// vector<int> pos, son, val;


bool cmp(pair<int, int> a, pair<int, int> b) {
    return pos[a.first] < pos[b.first];
}

int tmm = 0;

void dfs(int v, int p, int s) {
    tin[v] = tmm++;
    if (p == 0) {
        s = v;
    }
    son[v] = s;
    for (auto u : g[v]) {
        if (u != p) {
            dfs(u, v, s);
        }
    }
    tout[v] = tmm;
}

bool isanc(int a, int b) {
    return tin[a] <= tin[b] && tout[a] >= tout[b];
}

signed main() {
    // freopen("in.txt", "r", stdin);
    // freopen("out.txt", "w", stdout);
    // cout.precision(20);
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int n, q;
    cin >> n >> q;
    vector<int> p(n, -1);
    for (int i = 0; i < n - 1; ++i) {
        int x;
        cin >> x;
        x--;
        p[i + 1] = x;
        g[x].push_back(i + 1);
    }
    for (int i = 0; i < n; i++) {
        cin >> val[i];
    }
    dfs(0, 0, -1);
    set<pair<int, int>> st;
    st.insert({val[0], 0});
    vector<int> all;
    while (!st.empty()) {
        int v = (*st.rbegin()).second;
        st.erase(st.find(*st.rbegin()));
        all.push_back(v);
        pos[v] = (int)all.size() - 1;
        for (auto u : g[v]) {
            st.insert({val[u], u});
        }
    }
    for (int i = 0; i < q; i++) {
        int num;
        cin >> num;
        num--;
        vector<int> sum(n);
        int pos = -1;
        for (int j = 0; j < n && all[j] != num; j++) {
            pos = j;
            sum[tin[all[j]]]++;
        }
        vector<int> p_s(n + 1);
        for (int i = 0; i < n; i++) {
            p_s[i + 1] = p_s[i] + sum[i];
        }
        int mx = 0;
        for (int i = 1; i < n; i++) {
            if (!isanc(i, num)) {
                mx = max(mx, p_s[tout[i]] - p_s[tin[i]]);
            }
        }
        cout << pos + 1 - mx << '\n';
    }
}
