#include <bits/extc++.h>

using namespace std;

struct fenwick {
    vector<int> t;
    int n;
    void init(int nn) {
        n = nn;
        t.assign(n, 0);
    }
    void upd(int i, int x) {
        while (i < n) {
            t[i] += x;
            i |= i + 1;
        }
    }
    int get(int i) {
        int s = 0;
        while (i >= 0) {
            s += t[i];
            --(i &= i + 1);
        }
        return s;
    }
    int get(int i, int j) {
        return get(j) - get(i - 1);
    }
};

struct sgt {
    vector<int> t;
    void init(int n) {
        t.assign(n << 2, 0);
    }
    void upd(int v, int tl, int tr, int i, int x) {
        if (tl + 1 == tr) {
            t[v] += x;
            return;
        }
        int tm = (tl + tr) >> 1;
        if (i < tm) {
            upd(2 * v + 1, tl, tm, i, x);
        } else {
            upd(2 * v + 2, tm, tr, i, x);
        }
        t[v] = max(t[2 * v + 1], t[2 * v + 2]);
    }
    int get() {
        return t[0];
    }
};

vector<vector<int>> g;
vector<int> tin, tout;
int timer = 0;

void dfs(int v) {
    tin[v] = timer++;
    for (int u : g[v]) {
        dfs(u);
    }
    tout[v] = timer;
}

constexpr int INF = 1e9;

vector<int> ans;
sgt t;
fenwick zz;

int TT = -1, n;

void dfs_solve(int v) {
    TT++;
    zz.upd(tin[v], 1);
    int yy = zz.get(tin[v], tout[v] - 1);
    t.upd(0, 0, n, tin[v], yy - INF);
    ans[v] = TT - t.get();
    for (int u : g[v]) {
        dfs_solve(u);
    }
    t.upd(0, 0, n, tin[v], INF);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int q;
    cin >> n >> q;
    g.resize(n);
    tin.resize(n);
    tout.resize(n);
    vector<int> p(n), h(n);
    for (int i = 1; i < n; i++) {
        cin >> p[i], p[i]--;
    }
    vector<int> s(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    for (int i = 1; i < n; i++) {
        h[i] = h[p[i]] + 1;
        g[p[i]].push_back(i);
    }
    for (int i = 0; i < n; i++) {
        sort(g[i].begin(), g[i].end(), [&](int a, int b) {
            return s[a] > s[b];
        });
    }
    ans.resize(n);
    dfs(0);
    vector<int> ask(n);
    vector<int> qs(q);
    for (int i = 0; i < q; i++) {
        cin >> qs[i], qs[i]--;
        ask[qs[i]] = 1;
    }
    t.init(n);
    zz.init(n);
    dfs_solve(0);

//    while (!lol.empty()) {
//        auto [_, v] = *lol.rbegin();
//        lol.erase(--lol.end());
//        T++;
//        f.upd(tin[v], 1);
//        if (ask[v]) {
//            ans[v] = T;
//            int u = v;
//            while (u != 0) {
//                for (int b : g[p[u]]) {
//                    if (b != u) {
//                        ans[v] = min(ans[v], T - f.get(tin[b], tout[b] - 1));
//                    }
//                }
//                u = p[u];
//            }
//        }
//        for (int u : g[v]) {
//            lol.emplace(s[u], u);
//        }
//    }
    for (int v : qs) {
        cout << ans[v] << ' ';
    }
    return 0;
}
/*

5 4
1 2 2 1
3 5 1 2 4
5 3 1 4

 */