#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <set>
#include <string>
#define endl '\n'
//#define int long long

using namespace std;

vector<int> tin, tout;

int T = 0;

void cnttime(int v, vector<vector<int>> &g) {
    tin[v] = T;
    T++;
    for (auto u : g[v]) {
        cnttime(u, g);
    }
    tout[v] = T;
    T++;
}

bool parent(int v, int u) {
    return (tin[v] <= tin[u] && tout[u] <= tout[v]);
}

int calc = 0;

void dfs(int v, vector<vector<int>> &g, vector<int> &dp, vector<bool> &go, int x) {
    if (!go[v]) {
        return;
    }
    dp[v] = 1;
    for (auto u : g[v]) {
        dfs(u, g, dp, go, x);
        dp[v] += dp[u];
    }
    if (!parent(v, x)) {
        calc = max(calc, dp[v]);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, q;
    cin >> n >> q;
    tin.resize(n);
    tout.resize(n);
    vector<vector<int>> g(n);
    vector<int> pr(n, -1);
    int x;
    for (int i = 1; i < n; ++i) {
        cin >> x;
        x--;
        pr[i] = x;
        if (x == 0) {
            pr[i] = i;
        }
        g[x].push_back(i);
    }
    cnttime(0, g);
    set<pair<int, int>> dd;
    vector<int> ord;
    vector<int> c(n);
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
    }
    dd.insert({c[0], 0});
    while (!dd.empty()) {
        auto it = dd.end();
        it--;
        int v = it -> second;
        ord.push_back(v);
        dd.erase(it);
        for (auto u : g[v]) {
            dd.insert({c[u], u});
        }
    }
    set<pair<int, int>> d;
    vector<int> ask(n, -1);
    for (int i = 0; i < q; ++i) {
        cin >> x;
        x--;
        ask[x] = i;
    }
    vector<pair<int, int>> ans;
    vector<bool> go(n, false);
    if (ask[0] != -1) {
        ans.push_back({ask[0], 0});
    }
    go[0] = true;
    for (int i = 1; i < n; ++i) {
        int u = ord[i];
        go[u] = true;
        if (ask[u] != -1) {
            vector<int> dp(n);
            calc = 0;
            dfs(0, g, dp, go, u);
            ans.push_back({ask[u], i - calc});
        }
    }
    sort(ans.begin(), ans.end());
    for (int i = 0; i < q; ++i) {
        cout << ans[i].second << " ";
    }
    cout << endl;
    return 0;
}
