#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")

using namespace std;
using ll = long long;
using ld = long double;

const int N = (int)3e5 + 5;

vector<int> g[N];
int anc[N], s[N], v[N], ans[N], up[N], tin[N], tout[N], timer = 0, sz[N], depth[N];
int n;

struct SegmentTree {
	vector<int> tree, lazy;
	int size;
	void init(int n) {
		size = 1;
		while (size < n) size *= 2;
		tree.assign(2 * size - 1, 0);
		lazy.assign(2 * size - 1, 0);
	}
	void push(int v, int l, int r) {
		if (lazy[v] == 0) return;
		tree[v] += lazy[v];
		if (l + 1 < r) {
			lazy[2 * v + 1] += lazy[v];
			lazy[2 * v + 2] += lazy[v];
		}
		lazy[v] = 0;
	}
	void add(int lx, int rx, int x, int l, int r, int v) {
		push(v, l, r);
		if (rx <= l || r <= lx) return;
		if (lx <= l && r <= rx) {
			lazy[v] += x;
			return push(v, l, r);
		}
		int m = (l + r) >> 1;
		add(lx, rx, x, l, m, 2 * v + 1);
		add(lx, rx, x, m, r, 2 * v + 2);
		tree[v] = std::max(tree[2 * v + 1], tree[2 * v + 2]);
	}
	void add(int l, int r, int x) {
		add(l, r, x, 0, size, 0);
	}
	int max(int lx, int rx, int l, int r, int v) {
		push(v, l, r);
		if (rx <= l || r <= lx) return 0;
		if (lx <= l && r <= rx) return tree[v];
		int m = (l + r) >> 1;
		return std::max(max(lx, rx, l, m, 2 * v + 1), max(lx, rx, m, r, 2 * v + 2));
	}
	int max(int l, int r) {
		return max(l, r, 0, size, 0);
	}
};

void reorder(int v) {
	sz[v] = 1;
	for (int &to : g[v]) {
		depth[to] = depth[v] + 1;
		reorder(to);
		sz[v] += sz[to];
		if (sz[to] > sz[g[v][0]]) {
			swap(to, g[v][0]);
		}
	}
}

void dfs1(int v) {
	tin[v] = timer++;
	for (int to : g[v]) {
		if (to == g[v][0]) {
			up[to] = up[v];
		} else {
			up[to] = to;
		}
		dfs1(to);
	}
	tout[v] = timer;
}

SegmentTree st;

void add_value(int v) {
	while (true) {
		st.add(tin[up[v]], tin[v] + 1, 1);
		if (up[v] == 0) break;
		v = anc[up[v]];
	}
}

int get_value(int v) {
	int old = v;
	int ans = 0;
	vector<pair<int, int>> segments;
	while (true) {
		segments.emplace_back(tin[up[v]], tin[v]);
		if (up[v] == 0) break;
		v = anc[up[v]];
	}
	sort(segments.begin(), segments.end());
	if (segments.back().second < n - 1) {
		ans = std::max(ans, st.max(segments.back().second + 1, n));
	}
	for (int i = 0; i + 1 < (int)segments.size(); ++i) {
		if (segments[i].second + 1 < segments[i + 1].first) {
			ans = std::max(ans, st.max(segments[i].second + 1, segments[i + 1].first));
		}
	}
	return ans;
}

signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0);

	int temp;
	cin >> n >> temp;
	for (int i = 1; i < n; ++i) {
		cin >> anc[i]; anc[i]--;
		g[anc[i]].push_back(i);
	}
	for (int i = 0; i < n; ++i) {
		cin >> s[i];
	}
	reorder(0);
	dfs1(0);
	st.init(n);

	priority_queue<pair<int, int>> q;
	q.push({s[0], 0});

	int cnt = 0;

	while (!q.empty()) {
		int v = q.top().second;
		q.pop();
		if (v > 0) {
			ans[v] = cnt - get_value(v);
		}
		for (int to : g[v]) {
			q.push({s[to], to});
		}
		add_value(v);
		cnt++;
	}

	for (int i = 0; i < temp; ++i) {
		cin >> v[i];
		v[i]--;
		cout << ans[v[i]] << ' ';
	}
}
