#include <bits/stdc++.h>
using namespace std;
using ll = long long;
//using ll = int;
using ld = long double;
using ull = unsigned long long;
#define pb push_back
#define all(vec) vec.begin(), vec.end()
#define eb emplace_back
#ifdef LOCAL
#define deb(x) cout << #x << " = " << x << '\n'
#else
#define deb(x) 52
#endif
const ll inf = 1e9 + 11;
const long long INF = (long long)2e18 + 11;
const ll P = 73;
const ll MOD = 1e9 + 7;


struct SegTree {
    ll n;
    vector<ll> tree, lazy;

    SegTree(ll n = 0) : n(n) {
        tree.resize(4 * n);
        lazy.resize(4 * n);
    }

    void push(ll v) {
        tree[v] += lazy[v];
        if (v * 2 + 2 < 4 * n) {
            lazy[v * 2 + 1] += lazy[v];
            lazy[v * 2 + 2] += lazy[v];
        }
        lazy[v] = 0;
    }

    void upd(ll l, ll r, ll x, ll tl, ll tr, ll v) {
        push(v);
        if (l >= tr || tl >= r) {
            return;
        }
        if (tl >= l && tr <= r) {
            lazy[v] += x;
            push(v);
            return;
        }
        ll tm = (tr + tl) >> 1;
        upd(l, r, x, tl, tm, v * 2 + 1);
        upd(l, r, x, tm, tr, v * 2 + 2);
        tree[v] = max(tree[v * 2 + 1], tree[v * 2 + 2]);
    }

    void upd(ll l, ll r, ll x) {
        upd(l, r, x, 0, n, 0);
    }

    ll get(ll l, ll r, ll tl, ll tr, ll v) {
        push(v);
        if (l >= tr || tl >= r) {
            return -INF;
        }
        if (tl >= l && tr <= r) {
            return tree[v];
        }
        ll tm = (tr + tl) >> 1;
        return max(get(l, r, tl, tm, v * 2 + 1), get(l, r, tm, tr, v * 2 + 2));
    }

    ll get(ll l, ll r) {
        return get(l, r, 0, n, 0);
    }
};


const ll N = 3e5;
vector<ll> graph[N];
ll a[N];
ll tin[N], tout[N], par[N], head[N], sz[N], d[N];
ll timer = 0;
SegTree tree;
ll n;


ll sizes(ll v) {
    sz[v] = 1;
    for (ll i = 0; i < (ll)graph[v].size(); ++i) {
        ll u = graph[v][i];
        sz[v] += sizes(u);
        if (sz[u] > sz[graph[v][0]]) {
            swap(graph[v][0], graph[v][i]);
        }
    }
    return sz[v];
}


void dfs(ll v) {
    tin[v] = timer++;
    for (ll u : graph[v]) {
        par[u] = v;
        d[u] = d[v] + 1;
        head[u] = (u == graph[v][0] ? head[v] : u);
        dfs(u);
    }
    tout[v] = timer;
}


bool anc(ll v, ll u) {
    return tin[v] <= tin[u] && tout[u] <= tout[v];
}


vector<pair<ll, ll>> get_hld_segs(ll v, ll u) {
    vector<pair<ll, ll>> ans;
    while (head[v] != head[u]) {
        if (d[head[v]] < d[head[u]]) {
            swap(v, u);
        }
        ans.eb(tin[head[v]], tin[v] + 1);
        v = par[head[v]];
    }
    if (tin[v] > tin[u]) {
        swap(v, u);
    }
    ans.eb(tin[v], tin[u]);
    return ans;
}


vector<pair<ll, ll>> get_inv_segs(vector<pair<ll, ll>> segs) {
    vector<pair<ll, ll>> ans;
    sort(all(segs)); // opasno
    if (segs[0].first != 0) {
        ans.eb(0, segs[0].first);
    }
    for (ll i = 0; i < (ll)segs.size() - 1; ++i) {
        if (segs[i].second != segs[i + 1].first) {
            ans.eb(segs[i].second, segs[i + 1].first);
        }
    }
    if (segs.back().second != n) {
        ans.eb(segs.back().second, n);
    }
    return ans;
}


void add(ll v, ll x) {
    ll u = 0;
    while (head[v] != head[u]) {
        if (d[head[v]] < d[head[u]]) {
            swap(v, u);
        }
        tree.upd(tin[head[v]], tin[v] + 1, x);
        v = par[head[v]];
    }
    if (tin[v] > tin[u]) {
        swap(v, u);
    }
    tree.upd(tin[v], tin[u], x);
}


void solve() {
    ll q;
    cin >> n >> q;
    ll x;
    for (ll i = 1; i < n; ++i) {
        cin >> x;
        --x;
        graph[x].pb(i);
    }
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    tree = SegTree(n);
    sizes(0);
    dfs(0);
    par[0] = -1;
    set<pair<ll, ll>> s;
    for (ll u : graph[0]) {
        s.insert({a[u], u});
    }
    vector<ll> ans(n);
    ll cur = 1;
    while (!s.empty()) {
        pair<ll, ll> p = *s.rbegin();
        s.erase(p);
        ll v = p.second;
        ll mx = 0;
        /*for (ll u = 0; u < n; ++u) {
            if (!anc(u, v)) {
                mx = max(mx, sum[u]);
            }
        }*/
        vector<pair<ll, ll>> bad_segs = get_hld_segs(v, 0);
        vector<pair<ll, ll>> good_segs = get_inv_segs(bad_segs);
        for (pair<ll, ll> sg : good_segs) {
            mx = max(mx, tree.get(sg.first, sg.second));
        }
        ans[v] = cur - mx;
        for (ll u : graph[v]) {
            s.insert({a[u], u});
        }
        ++cur;
        add(v, 1);
    }
    for (ll i = 0; i < q; ++i) {
        ll v;
        cin >> v;
        --v;
        cout << ans[v] << ' ';
    }
}


int main() {
#ifdef LOCAL
    freopen("C:/work/untitled/input.txt", "r", stdin);
    freopen("C:/work/untitled/output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll cfmode = 0;
    ll tc = 1;
    if (cfmode) {
        cin >> tc;
    }
    while (tc--) {
        solve();
        if (tc) {
            cout << '\n';
        }
    }
}