#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <math.h>
#include <string>
#include <vector>
#include <chrono>
#include <random>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <assert.h>
#define endl '\n'

using namespace std;
using i64 = long long;
using ld = long double;

const i64 INF = 1e18 + 5;

mt19937 rnd(29);

const i64 S = 1005;
vector <i64> p[S], pRev[S];
i64 val[S];
i64 ans[S][S];

void simulate(i64 sq, i64 ind) {
	i64 t = 0;
	ans[sq][ind] = t++;
	while (p[sq].size()) {
		i64 newSq = 0, vals = -1;
		for (auto x : p[sq]) {
			if (val[x] > vals) {
				vals = val[x];
				newSq = x;
			}
		}
		for (auto x : p[sq]) {
			if (x != newSq) {
				p[newSq].push_back(x);
			}
		}
		p[sq].clear();
		ans[newSq][ind] = t++;
		sq = newSq;
	}
	return;
}

int main() {
	#ifdef _DEBUG
		freopen("input.txt", "r", stdin);
	#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	i64 n, q; cin >> n >> q;

	for (i64 x = 2; x <= n; ++x) {
		i64 pr; cin >> pr;
		p[pr].push_back(x);
	}

	for (i64 x = 1; x <= n; ++x) {
		cin >> val[x];
		pRev[x] = p[x];
	}

	for (i64 x = 1; x <= n; ++x) {
		i64 pre = val[x];
		val[x] = 0;
		simulate(1, x);
		for (i64 y = 1; y <= n; ++y) {
			p[y] = pRev[y];
		}
		val[x] = pre;
	}

	for (i64 x = 1; x <= q; ++x) {
		i64 answer = INF;
		i64 k; cin >> k;
		for (i64 y = 1; y <= n; ++y) {
			answer = min(answer, ans[k][y]);
		}
		cout << answer << " ";
	}
}