#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#pragma GCC target("avx2")
#pragma GCC optimize("O3, bmi, unroll-loops")
#pragma GCC optimize("inline")

using namespace __gnu_pbds;
using namespace std;

template <class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;
typedef long double ld;

//#define int ll
#define ALL(x) x.begin(), x.end()

const int MAXN = 3e5 + 5;
const int INF = 1e9 + 7;
const int MOD = 1e9 + 7;

struct segmentTree
{
    vector<int> t;
    vector<int> lazy;
    int sz = 1;
    void build(int v, int l, int r)
    {
        if(r - l == 1)
        {
            t[v] = 0;
            return;
        }
        int m = (r + l) / 2;
        build(v * 2, l, m);
        build(v * 2 + 1, m, r);
        t[v] = t[v * 2] + t[v * 2 + 1];
    }
    segmentTree(int n)
    {
        sz = n;
        t.resize(sz * 4, 0);
        lazy.resize(sz * 4, 0);
        //build(1, 0, sz);
    }
    void push(int v, int l, int r)
    {
        int m = (l + r) / 2;
        t[v * 2] += lazy[v] * (m - l);
        t[v * 2 + 1] += lazy[v] * (r - m);
        lazy[v * 2] += lazy[v];
        lazy[v * 2 + 1] += lazy[v];
        lazy[v] = 0;
    }
    int get(int v, int l, int r, int L, int R)
    {
        if(r <= L || l >= R)
        {
            return 0;
        }
        if(L <= l && r <= R)
        {
            return t[v];
        }
        push(v, l, r);
        int m = (l + r) / 2;
        return get(v * 2, l, m, L, R) + get(v * 2 + 1, m, r, L, R);
    }
    int get(int l, int r)
    {
        return get(1, 0, sz, l, r);
    }

    void update(int v, int l, int r, int L, int R, int x)
    {
        if(r <= L || l >= R)
        {
            return;
        }
        if(L <= l && r <= R)
        {
            t[v] += x * (r - l);
            lazy[v] += x;
            return;
        }
        push(v, l, r);
        int m = (l + r) / 2;
        update(v * 2, l, m, L, R, x);
        update(v * 2 + 1, m, r, L, R, x);
        t[v] = t[v * 2] + t[v * 2 + 1];
    }

    void update(int l, int r, int x)
    {
        update(1, 0, sz, l, r, x);
    }
};

struct Vec
{
    int x, y;
    Vec()
    {

    }
    Vec(int a, int b)
    {
        x = a;
        y = b;
    }
    int operator %(Vec a)
    {
        return x * a.y - y * a.x;
    }
    int operator *(Vec a)
    {
        return x * a.x + y * a.y;
    }
    Vec operator -(Vec a)
    {
        return {x - a.x, y - a.y};
    }
    Vec operator +(Vec a)
    {
        return {x + a.x, y + a.y};
    }
    Vec operator *(int k)
    {
        return {x * k, y * k};
    }
    int len2(Vec a)
    {
        return (x - a.x) * (x - a.x) + (y - a.y) * (y - a.y);
    }
    ld len(Vec a)
    {
        return sqrtl(len2(a));
    }
};
istream& operator >>(istream& in, Vec& x)
{
    in >> x.x >> x.y;
    return in;
}

ostream& operator <<(ostream& out, Vec& x)
{
    out << x.x << ' ' << x.y;
    return out;
}

struct fenvik
{
    vector<int> fen;
    int sz = 0;
    fenvik(int n)
    {
        sz = n;
        fen.resize(n + 1, 0);
    }

    int get(int pos)
    {
        int ans = 0;
        for (int i = pos; i > 0; i -= i & -i)
        {
            ans += fen[i];
        }
        return ans;
    }

    void change(int pos, int x)
    {
        for (int i = pos; i <= sz; i += i & -i)
        {
            fen[i] += x;
        }
    }
};

int binpow(int base, int exp, int mod = MOD)
{
    if(exp == 0)
    {
        return 1;
    }
    if(exp % 2 == 0)
    {
        auto gg = binpow(base, exp / 2,  mod);
        return gg * gg % mod;
    }
    return base * binpow(base, exp - 1, mod) % mod;
}

vector<int> g[MAXN];

vector<int> s;

int d[MAXN];

void dfs(int x, int deep = 0)
{
    d[x] = deep;
    for (auto i : g[x])
    {
        dfs(i, deep + 1);
    }
}

int anser[MAXN];

int ban = 0;

int cnt[MAXN];

vector<int> nach[MAXN];

vector<int> tek;

int tin[MAXN];
int tout[MAXN];
int timer = 0;

void dfs2(int x)
{
    //tek.push_back(x);
    //nach[x] = tek;
    tin[x] = timer++;
    for(auto i : g[x])
    {
        dfs2(i);
    }
   // tek.pop_back();
    tout[x] = timer;
}

bool isLca(int a, int b)
{
    return tin[a] <= tin[b] && tout[b] <= tout[a];
}

vector<int> zap;
vector<int> pp;
bool used[MAXN];

void solve()
{
    int n, q;
    cin >> n >> q;
    pp.push_back(0);
    for(int i = 1; i < n; i++)
    {
        int p;
        cin >> p;
        p--;
        pp.push_back(p);
        g[p].push_back(i);
    }

    segmentTree stt(n * 2 + 2);
    for(int i = 0; i < n; i++)
    {
        int x;
        cin >> x;

        s.push_back(x);
    }
    dfs2(0);
    fill(anser, anser + MAXN, INF);
    anser[0] = 0;
    set<pair<int, pair<int, int>>> st;

    for (auto j : g[0])
    {
        st.insert({-s[j], {j, j}});
    }
    int day = 1;
    dfs2(0);
    for(int i = 0; i < q; i++)
    {
        int v;
        cin >> v;
        v--;
        used[v] = 1;
        zap.push_back(v);
    }
    while(!st.empty())
    {
        auto [ppp, indd] = *st.begin();
        st.erase(st.begin());
        auto [ind, from] = indd;
        int minus = 0;
        if(used[ind])
        {
            for(int i = 1; i < n; i++)
            {
                if(pp[i] == 0 || pp[pp[i]] == pp[pp[ind]])
                {
                    if (!isLca(i, ind))
                    {
                        minus = max(minus, stt.get(tin[i], tout[i]));
                    }
                }
            }
        }
        anser[ind] =  day - minus;
        day++;
        for(auto i : g[ind])
        {
            st.insert({-s[i], {i, from}});
        }
        stt.update(tin[ind], tin[ind] + 1, 1);
    }
    for(auto v : zap)
    {
        cout << anser[v] << ' ';
    }
}

int32_t main()
{
    cin.tie(0);
    ios_base::sync_with_stdio(0);
    int t = 1;
    //cin >> t;
    while (t--)
    {
        solve();
    }
}
