#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;

struct pa{
    int v, x;
};

bool operator<(pa a, pa b)
{
    if(a.x == b.x) return a.v < b.v;
    return a.x > b.x;
}

const int inf = 1e9;

vector<int> sz, pr;

int root(int v)
{
    if(pr[v] == -1) return v;
    return pr[v] = root(pr[v]);
}

void merge(int u, int v)
{
    u = root(u);
    v = root(v);
    sz[v] += sz[u];
    pr[u] = v;
}

signed main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, q;
    cin >> n >> q;
    vector<int> p(n);
    p[0] = 0;
    for(int i = 1; i < n; ++i){
        cin >> p[i];
        --p[i];
    }
    vector<int> s(n);
    for(int &x : s) cin >> x;
    s[0] = 0;
    vector<pa> a(n);
    for(int i = 0; i < n; ++i) a[i] = {i, s[i]};
    sort(a.begin(), a.end());
    set<pa> d{0};
    sz.resize(n, 1);
    pr.resize(n, -1);
    int sum = 1;
    vector<int> ans(n);
    ans[0] = 0;
    for(int i = 0; i < n - 1; ++i){
        int v = a[i].v, x = a[i].x;
        if(p[v] != 0 && s[v - 1] > x){
            int u = root(v);
            if(p[u] == 0){
                sum -= sz[u];
                d.extract({u, sz[u]});
            }
            merge(p[v], v);
        }
        if(v < n - 1 && p[v + 1] == v && s[v + 1] > x) merge(v, v + 1);
        ans[v] = sum - (*d.begin()).x;
        int u = root(v);
        if(p[u] == 0){
            sum += sz[u];
            d.insert({u, sz[u]});
        }
    }
    vector<int> anss;
    for(int i = 0; i < q; ++i){
        int v;
        cin >> v;
        anss.push_back(ans[v - 1]);
    }
    for(int x : anss) cout << x << ' ';
    cout << endl;
}