#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> g;
vector<int> tin, tout, sz;
int timer = 0;

void dfs(int v) {
    tin[v] = timer++;
    for(auto t : g[v]) {
        dfs(t);
        sz[v] += sz[t];
    }
    tout[v] = timer;
}

bool isAnc(int a, int b) {
    return (tin[a] <= tin[b] && tout[b] <= tout[a]);
}

vector<int> tree;

void update(int v, int l, int r, int i, int x) {
    if(r - l == 1) {
        tree[v] = x;
        return;
    }
    int m = (l + r) / 2;
    if(i < m) update(v * 2 + 1, l, m, i, x);
    else update(v * 2 + 2, m, r, i, x);
    tree[v] = tree[v * 2 + 1] + tree[v * 2 + 2];
}

int query(int v, int l, int r, int ql, int qr) {
    if(l >= qr || r <= ql) return 0;
    if(l >= ql && r <= qr) return tree[v];
    int m = (l + r) / 2;
    return query(v * 2 + 1, l, m, ql, qr) + query(v * 2 + 2, m, r, ql, qr);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q;
    cin >> n >> q;
    g.resize(n);
    sz.resize(n, 1);
    tin.resize(n);
    tout.resize(n);
    for(int i = 1; i < n; i++) {
        int p;
        cin >> p;
        p--;
        g[p].push_back(i);
    }
    vector<int> arr(n);
    for(int i = 0; i < n; i++) cin >> arr[i];

    // vector<int> anss1(n, INT32_MAX);
    vector<int> anss1, anss1r(n);

    multiset<pair<int, int>> cs;
    cs.insert({-arr[0], 0});
    while(cs.size()) {
        int v = cs.begin()->second;
        cs.erase(cs.begin());
        // anss1[v] = min(anss1[v], ca);
        anss1r[v] = anss1.size();
        anss1.push_back(v);
        for(auto t : g[v]) {
            cs.insert({-arr[t], t});
        }
    }

    dfs(0);
    tree.resize(n * 4);

    // cout << ">> "; for(auto i : anss1) cout << i + 1 << ' '; cout << '\n';
    vector<pair<int, int>> qq(q);
    for(int i = 0; i < q; i++) {
        cin >> qq[i].first;
        qq[i].first--;
        qq[i].second = i;
    }
    sort(qq.begin(), qq.end(), [&](pair<int, int> a, pair<int, int> b) {
        if(a.first == b.first) return a.second < b.second;
        return anss1r[a.first] < anss1r[b.first];
    });
    int cur = 0;
    vector<int> anss(q);

    for(auto [tt, qi] : qq) {
        while(cur < n && anss1[cur] != tt) {
            update(0, 0, n, tin[anss1[cur]], 1);
            cur++;
        }
        int idx = find(anss1.begin(), anss1.end(), tt) - anss1.begin();
        int msub = 0;
        for(int i = 0; i < idx; i++) {
            if(isAnc(anss1[i], tt)) continue;
            // cout << ">> " << i << ' ' << anss1[i] + 1 << ' ' << sz[anss1[i]] << '\n';
            msub = max(msub, query(0, 0, n, tin[anss1[i]], tout[anss1[i]]));
        }
        // int ans = anss[tt];
        anss[qi] = idx - msub;
        // cout << idx - msub << '\n';
    }
    for(auto i : anss) cout << i << ' ';
    cout << '\n';
}
