#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector")

#include <bits/stdc++.h>

#pragma GCC target("avx,avx2,bmi,bmi2,sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,abm,mmx,tune=native")

using namespace std;

vector<vector<int>> g;
vector<int> tin, tout, sz, pr;
int timer = 0;

void dfs(int v) {
    tin[v] = timer++;
    for(auto t : g[v]) {
        dfs(t);
        sz[v] += sz[t];
    }
    tout[v] = timer;
}

bool isAnc(int a, int b) {
    return (tin[a] <= tin[b] && tout[b] <= tout[a]);
}

vector<int> tree, mod;

void push(int v) {
    if(mod[v] == 0) return;
    mod[v * 2 + 1] += mod[v];
    mod[v * 2 + 2] += mod[v];
    tree[v * 2 + 1] += mod[v];
    tree[v * 2 + 2] += mod[v];
    mod[v] = 0;
}

void addSeg(int v, int l, int r, int ql, int qr, int x) {
    if(l >= qr || r <= ql) return;
    if(l >= ql && r <= qr) {
        tree[v] += x;
        mod[v] += x;
        return;
    }
    push(v);
    int m = (l + r) / 2;
    addSeg(v * 2 + 1, l, m, ql, qr, x);
    addSeg(v * 2 + 2, m, r, ql, qr, x);
    tree[v] = max(tree[v * 2 + 1], tree[v * 2 + 2]);
}

void addPt(int v, int l, int r, int i, int x) {
    if(r - l == 1) {
        tree[v] += x;
        return;
    }
    push(v);
    int m = (l + r) / 2;
    if(i < m) addPt(v * 2 + 1, l, m, i, x);
    else addPt(v * 2 + 2, m, r, i, x);
    tree[v] = max(tree[v * 2 + 1], tree[v * 2 + 2]);
}

int query(int v, int l, int r, int ql, int qr) {
    if(l >= qr || r <= ql) return 0;
    if(l >= ql && r <= qr) return tree[v];
    int m = (l + r) / 2;
    return query(v * 2 + 1, l, m, ql, qr) + query(v * 2 + 2, m, r, ql, qr);
}

void upd(int i, int x) {
    while(i < tree.size()) {
        tree[i] += x;
        i = i | (i + 1);
    }
}

int pref(int i) {
    int ans = 0;
    while(i >= 0) {
        ans += tree[i];
        i = (i & (i + 1)) - 1;
    }
    return ans;
}

int n, q;

// void upd(int i, int x) {
//     while(i != -1) {
//         tree[i] += x;
//         // addPt(0, 0, n, i, x);
//         i = pr[i];
//     }
// }

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> q;
    pr.resize(n, -1);
    g.resize(n);
    sz.resize(n, 1);
    tin.resize(n);
    tout.resize(n);
    for(int i = 1; i < n; i++) {
        int p;
        cin >> p;
        p--;
        g[p].push_back(i);
        pr[i] = p;
    }
    vector<int> arr(n);
    for(int i = 0; i < n; i++) cin >> arr[i];

    // vector<int> anss1(n, INT32_MAX);
    vector<int> anss1, anss1r(n);

    multiset<pair<int, int>> cs;
    cs.insert({-arr[0], 0});
    while(cs.size()) {
        int v = cs.begin()->second;
        cs.erase(cs.begin());
        // anss1[v] = min(anss1[v], ca);
        anss1r[v] = anss1.size();
        anss1.push_back(v);
        for(auto t : g[v]) {
            cs.insert({-arr[t], t});
        }
    }

    dfs(0);
    // tree.resize(n * 4);
    // mod.resize(n * 4);
    tree.resize(n);

    // cout << ">> "; for(auto i : anss1) cout << i + 1 << ' '; cout << '\n';
    vector<pair<int, int>> qq(q);
    for(int i = 0; i < q; i++) {
        cin >> qq[i].first;
        qq[i].first--;
        qq[i].second = i;
    }
    sort(qq.begin(), qq.end(), [&](pair<int, int> a, pair<int, int> b) {
        if(a.first == b.first) return a.second < b.second;
        return anss1r[a.first] < anss1r[b.first];
    });
    int cur = 0;
    vector<int> anss(q);
    // vector<int> arr2(n);

    for(auto [tt, qi] : qq) {
        while(cur < n && anss1[cur] != tt) {
            upd(tin[anss1[cur]], 1);
            cur++;
        }
        int idx = anss1r[tt];
        int msub = 0;
        upd(tin[tt], -10000000);
        for(int i = 0; i < idx; i++) {
            // if(isAnc(anss1[i], tt)) continue;
            msub = max(msub, pref(tout[anss1[i]] - 1) - pref(tin[anss1[i]] - 1));
        }
        upd(tin[tt], 10000000);
        // msub = max(0, tree[0]);
        // for(auto i : tree) msub = max(msub, i);
        anss[qi] = idx - msub;
    }
    for(auto i : anss) cout << i << ' ';
    cout << '\n';
}
