#include <bits/stdc++.h>

using namespace std;

using ll = long long;
#define x first
#define y second

void solve();

int main() {
	cin.tie(nullptr)->sync_with_stdio(false);
	cout << fixed << setprecision(30);
	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
}

struct segment_tree {
	vector<int> st;
	size_t sz;
	segment_tree(int n = 0) {
		sz = 1;
		while (sz < n) sz <<= 1;
		st.resize(2 * sz, 0);
	}
	void update(int i, int v) {
		i += sz;
		while (i) {
			st[i] = max(st[i], v);
			i >>= 1;
		}
	}
	int get(int l, int r) {
		l += sz; r += sz;
		int res = 0;
		while (l <= r) {
			if (l & 1) res = max(res, st[l++]);
			if (~r & 1) res = max(res, st[r--]);
			l >>= 1;
			r >>= 1;
		}
		return res;
	}
};

struct segment_tree_sum {
	vector<int> st;
	size_t sz;
	segment_tree_sum(int n = 0) {
		sz = 1;
		while (sz < n) sz <<= 1;
		st.resize(2 * sz, 0);
	}
	void update(int i, int v) {
		i += sz;
		while (i) {
			st[i] += v;
			i >>= 1;
		}
	}
	int get(int l, int r) {
		l += sz; r += sz;
		int res = 0;
		while (l <= r) {
			if (l & 1) res += st[l++];
			if (~r & 1) res += st[r--];
			l >>= 1;
			r >>= 1;
		}
		return res;
	}
};

const int N = 300300;
vector<int> g[N];
segment_tree st[N], st2[N];
int val[N], ans[N], sz[N], num[N], pr[N], head[N], dist[N], tin[N], tout[N], timer;

void calc_sz(int s) {
	sz[s] = 1;
	for (int i : g[s]) {
		calc_sz(i);
		sz[s] += sz[i];
	}
}

void hld_prepare(int s) {
	for (int &i : g[s]) {
		hld_prepare(i);
		if (sz[i] > sz[g[s][0]]) {
			swap(i, g[s][0]);
		}
	}
}

void calc_num(int s) {
	int nm = 0;
	tin[s] = timer++;
	for (int i : g[s]) {
		calc_num(i);
		num[i] = nm++;
	}
	tout[s] = timer - 1;
}

void calc_head(int s, int h, int d) {
	head[s] = h;
	dist[s] = d;
	int ok = 1;
	for (int i : g[s]) {
		if (ok) {
			ok = 0;
			calc_head(i, h, d + 1);
		} else {
			calc_head(i, i, 0);
		}
	}
}

segment_tree_sum sts;

void update(int s) {
	s = head[s];
	if (!s) return;
	int p = pr[s];
	int s_have = sts.get(tin[s], tout[s]);
	st2[p].update(num[s], s_have);
	int ph = head[p];
	st[ph].update(dist[p], s_have);
	update(p);
}

int _get(int s) {
	if (!s) return 0;
	int sh = head[s];
	int res = st[sh].get(0, dist[s] - 1);
	s = sh;
	if (!s) return res;
	int p = pr[s];
	res = max(res, sts.get(tin[g[p][0]], tout[g[p][0]]));
	res = max(res, st2[p].get(0, num[s] - 1));
	res = max(res, st2[p].get(num[s] + 1, g[p].size() - 1));
	return max(res, _get(p));
}

void solve() {
	int n, q;
	cin >> n >> q;
	pr[0] = -1;
	for (int i = 1; i < n; i++) {
		int p;
		cin >> p; p--;
		g[p].push_back(i);
		pr[i] = p;
	}
	for (int i = 0; i < n; i++) {
		cin >> val[i]; val[i] = n - val[i];
	}
	sts = segment_tree_sum(n);
	calc_sz(0);
	hld_prepare(0);
	calc_num(0);
	calc_head(0, 0, 0);
	for (int i = 0; i < n; i++) {
		st2[i] = segment_tree(g[i].size());
	}
	vector<int> mx_d(n, 0);
	for (int i = 0; i < n; i++) {
		mx_d[head[i]] = max(mx_d[head[i]], dist[i]);
	}
	for (int i = 0; i < n; i++) {
		st[i] = segment_tree(mx_d[i] + 1);
	}
	set<pair<int, int>> now;
	now.emplace(val[0], 0);
	int iter = 0;
	while (!now.empty()) {
		auto [tr, s] = *now.begin();
		now.erase(now.begin());
		for (int i : g[s]) {
			now.emplace(val[i], i);
		}
		sts.update(tin[s], 1);
		ans[s] = _get(s);
		update(s);
		ans[s] = iter - ans[s];
		iter++;
	}
	while (q--) {
		int v;
		cin >> v; v--;
		cout << ans[v] << ' ';
	}
	cout << '\n';
}
