#ifndef LOCAL
#include <bits/allocator.h>
#pragma GCC optimize("O3,unroll-loops,no-stack-protector")
#pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt,tune=native")
#else
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using i128 = __int128_t;

#define all(x) (x).begin(), (x).end()

const int MAX_N = 3e5;

vector<int> graph[MAX_N];
int lvl[MAX_N], queries[MAX_N], par[MAX_N], normal_time[MAX_N];
int tin[MAX_N], tout[MAX_N], first_large_par[MAX_N];

int n, q;

void dfs(int v, int &timer) {
    tin[v] = ++timer;
    for (int x : graph[v]) {
        dfs(x, timer);
    }
    tout[v] = timer;
}

int get_large_par(int i) {
    if (first_large_par[i] == -1) return -1;
    if (graph[first_large_par[i]].size() > 1) return first_large_par[i];
    return first_large_par[i] = get_large_par(first_large_par[i]);
}

vector<int> merge(const vector<int> &a, const vector<int> &b) {
    vector<int> c(a.size() + b.size());
    merge(all(a), all(b), c.begin());
    return c;
}

struct SegTree {
    int len;
    vector<int> tree[1 << 20];

    void init(const vector<int> &arr) {
        len = (int) __bit_ceil(arr.size());
        for (int i = 0; i < (int) arr.size(); ++i) {
            tree[i + len] = {arr[i]};
        }
        for (int i = len - 1; i > 0; --i) {
            tree[i] = merge(tree[i * 2], tree[i * 2 + 1]);
        }
    }

    int get(int l, int r, int x) {
        l += len, r += len;
        int ans = 0;
        while (l <= r) {
            if ((l & 1) == 1) {
                if (tree[l].size() > 16) {
                    ans += int(lower_bound(all(tree[l]), x) - tree[l].begin());
                } else {
                    for (int y : tree[l]) {
                        ans += y < x;
                    }
                }
                l++;
            }
            if ((r & 1) == 0) {
                if (tree[l].size() > 16) {
                    ans += int(lower_bound(all(tree[r]), x) - tree[r].begin());
                } else {
                    for (int y : tree[r]) {
                        ans += y < x;
                    }
                }
                r--;
            }
            l >>= 1, r >>= 1;
        }
        return ans;
    }
};

SegTree tree;

void solve() {
    cin >> n >> q;
    par[0] = -1;
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        --p;
        par[i] = p;
        graph[p].push_back(i);
    }
    for (int i = 0; i < n; ++i) {
        cin >> lvl[i];
    }
    for (int i = 0; i < q; ++i) {
        cin >> queries[i];
        --queries[i];
    }
    priority_queue<pair<int, int>> que;
    que.emplace(0, 0);
    int curr_time = 0;
    while (!que.empty()) {
        int v = que.top().second;
        normal_time[v] = curr_time++;
        que.pop();
        for (int x : graph[v]) {
            que.emplace(lvl[x], x);
        }
    }
    curr_time = -1;
    dfs(0, curr_time);
    for (int i = 0; i < n; ++i) {
        first_large_par[i] = par[i];
    }
    for (int i = 1; i < n; ++i) {
        get_large_par(i);
    }
    vector<int> normal_time_tins(n);
    for (int i = 0; i < n; ++i) {
        normal_time_tins[tin[i]] = normal_time[i];
    }
    tree.init(normal_time_tins);
    for (int qi = 0; qi < q; ++qi) {
        int qv = queries[qi];
        int ans = normal_time[qv];
        for (int v = first_large_par[qv]; v != -1; v = first_large_par[v]) {
            for (int x : graph[v]) {
                if (tin[x] <= tin[qv] && tout[qv] <= tout[x])
                    continue;
//                int subtree_cnt = 0;
//                vector<int> st{x};
//                while (!st.empty()) {
//                    int v1 = st.back();
//                    st.pop_back();
//                    subtree_cnt += normal_time[v1] < normal_time[qv];
//                    for (int x1 : graph[v1]) {
//                        st.push_back(x1);
//                    }
//                }
                int subtree_cnt = tree.get(tin[x], tout[x], normal_time[qv]);
                ans = min(ans, normal_time[qv] - subtree_cnt);
            }
        }
        cout << ans << " ";
    }
    cout << "\n";
}

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}