#include <bits/stdc++.h>
#define pb push_back

using namespace std;
using ll = long long;
using vi = vector<int>;
using ld = long double;
using pi = pair<int, int>;

vector<vi> g;
vi ans;
vi tin, tout;
vi up;
vi s;
vi par;
vi sz;
int timer = 0;

struct SegTree {
    int n;

    vi t, push;

    void init(int n_) {
        n = n_;
        t.resize(4 * n);
        push.resize(4 * n);
    }

    void upd(int v) {
        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }

    void make_push(int v) {
        if (push[v] == 0) return;

        push[v * 2] += push[v];
        push[v * 2 + 1] += push[v];

        t[v * 2] += push[v];
        t[v * 2 + 1] += push[v];

        push[v] = 0;
    }

    int get(int v, int vl, int vr, int l, int r) {
        if (vl > r || vr < l) return 0;
        else if (l <= vl && vr <= r) return t[v];
        else {
            make_push(v);
            int mid = (vl + vr) / 2;
            int m1 = get(v * 2, vl, mid, l, r);
            int m2 = get(v * 2 + 1, mid + 1, vr, l, r);
            return max(m1, m2);
        }
    }

    void add(int v, int vl, int vr, int l, int r, int x) {
        if (vl > r || vr < l) return;
        else if (l <= vl && vr <= r) {
            push[v] = x;
            t[v] += x;
        } else {
            make_push(v);
            int mid = (vl + vr) / 2;

            add(v * 2, vl, mid, l, r, x);
            add(v * 2 + 1, mid + 1, vr, l, r, x);

            upd(v);
        }
    }

    int get(int l, int r) {
        return get(1, 0, n - 1, l, r);
    }

    void add(int l, int r, int x) {
        add(1, 0, n - 1, l, r, x);
    }
};  

SegTree tr;

bool cmp(int u, int v) {
    return s[u] > s[v];
}
 
void dfs(int v) {
    sz[v] = 1;

    for (int u : g[v]) {
        dfs(u);
        sz[v] += sz[u];
    }

    int l = g[v].size();

    for (int i = 0; i < l; ++i) {
        int u = g[v][i];
        int c = g[v][0];

        if (sz[u] > sz[c]) {
            swap(g[v][i], g[v][0]);
        }
    }
}

void dfsHld(int v) {
    tin[v] = timer++;
    for (int u : g[v]) {
        if (u == g[v][0]) up[u] = up[v];
        else up[u] = u;

        dfsHld(u);
    }

    tout[v] = timer - 1;
}

void addHld(int v) {
    while (1) {
        int u = up[v];

        tr.add(tin[u], tin[v], 1);

        if (u == 0) break;
        v = par[u];
    }
}

vector<pi> getSegs(int v) {
    vector<pi> segs;
    while (1) {
        int u = up[v];

        segs.pb({tin[u], tin[v]});

        if (u == 0) break;
        v = par[u];
    }

    reverse(segs.begin(), segs.end());

    return segs;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, q;
    cin >> n >> q;

    g.resize(n);
    s.resize(n);
    tin.resize(n);
    tout.resize(n);
    up.resize(n);
    par.resize(n);
    sz.resize(n);
    ans.resize(n);

    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        --p;
        g[p].pb(i);
        par[i] = p;
        // g[i].pb(p);
    }

    for (int i = 0; i < n; ++i) cin >> s[i];

    // for (int i = 0; i < n; ++i) {
    //     sort(g[i].begin(), g[i].end(), cmp);
    // }

    dfs(0);
    dfsHld(0);

    tr.init(n);

    set<pi, greater<pi>> st;

    st.insert({s[0], 0});

    timer = 0;

    while (!st.empty()) {
        auto [skill, v] = *st.begin();
        st.erase(st.begin());

        for (int u : g[v]) {
            st.insert({s[u], u});
        }

        addHld(v);

        vector<pi> segs = getSegs(v);

        int last = 0;

        int cur = 0;

        for (auto [l, r] : segs) {
            if (l != last) {
                cur = max(cur, tr.get(last, l - 1));
            }

            last = r + 1;
        }

        if (last < n) {
            cur = max(cur, tr.get(last, n - 1));
        }

        ans[v] = timer - cur;

        ++timer;
    }

    for (int rr = 0; rr < q; ++rr) {
        int v;
        cin >> v;
        --v;

        cout << ans[v] << ' ';
    }
}