#include <bits/stdc++.h>
#include <bits/extc++.h>

#ifndef LOCAL
#pragma GCC optimize("O3")
#pragma GCC target("avx2")
#pragma GCC optimize("unrool-looops")
#endif

std::random_device rd;
std::mt19937_64 gen(rd());

using namespace __gnu_pbds;
using ll = long long;

template<class T>
using ordered_set = tree<T, null_type, std::less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int N = 1e3;

std::array<int, N> s, tin, tout, ans, order, indx;
std::array<std::vector<int>, N> g, all;

int timer = 0;

void dfs(int v) {
    tin[v] = timer++;
    all[v].emplace_back(v);
    for (auto &to: g[v]) {
        dfs(to);
        for (auto &i: all[to]) {
            all[v].emplace_back(i);
        }
    }
    tout[v] = timer++;
}

bool parent(int v, int u) { // v -> .. -> u
    return tin[v] <= tin[u] && tin[u] < tout[v];
}

void not_main() {
    int n, q;
    std::cin >> n >> q;
    for (int i = 1; i < n; ++i) {
        int p;
        std::cin >> p;
        --p;
        g[p].emplace_back(i);
    }
    for (int i = 0; i < n; ++i) {
        std::cin >> s[i];
    }
    std::vector<int> children = g[0];
    for (int i = 1; i < n; ++i) {
        int max = 0, who = -1;
        for (auto &c: children) {
            if (max < s[c]) {
                max = s[c];
                who = c;
            }
        }
        order[i] = who;
        indx[who] = i;
        children.erase(std::ranges::find(children, who));
        for (auto &to: g[who]) {
            children.emplace_back(to);
        }
    }
    ans.fill(-1);
    ans[0] = 0;
    for (int i = 0; i < q; ++i) {
        int v;
        std::cin >> v;
        --v;
        if (ans[v] != -1) {
            std::cout << ans[v] << ' ';
            continue;
        }
        int answer = (int) (std::ranges::find(order, v) - order.begin());
        for (int kill = 1; kill < n; ++kill) {
            if (parent(kill, v)) {
                continue;
            }
            int cnt = 0;
            for (auto &c: all[kill]) {
                if (indx[c] < indx[v]) {
                    ++cnt;
                }
            }
            answer = std::min(answer, indx[v] - cnt);
        }
        ans[v] = answer - 1;
        std::cout << ans[v] << ' ';
    }
    std::cout << '\n';
}

signed main() {
    std::ios_base::sync_with_stdio(false);
#ifndef LOCAL
    std::cin.tie(nullptr);
#endif
    int tests = 1;
    // std::cin >> tests;
    while (tests--) {
        not_main();
    }
    return 0;
}