#include <bits/stdc++.h>
#include <bits/extc++.h>

#ifndef LOCAL
#pragma GCC optimize("O3")
#pragma GCC target("avx2")
#pragma GCC optimize("unrool-looops")
#endif

std::random_device rd;
std::mt19937_64 gen(rd());

using namespace __gnu_pbds;
using ll = long long;

template<class T>
using ordered_set = tree<T, null_type, std::less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int N = 3e5;

std::array<int, N> s, ans, indx, tin, tout, wh;
std::array<std::vector<int>, N> g;
int timer = 0;

void calc(int v) {
    tin[v] = timer++;
    for (auto &to: g[v]) {
        calc(to);
    }
    tout[v] = timer++;
}

bool parent(int v, int u) { // v -> ... -> u
    return tin[v] <= tin[u] && tin[u] < tout[v];
}

int dfs(int v, int first) {
    int sz = !parent(v, first), mx = 0;
    for (auto &to: g[v]) {
        if (indx[to] < indx[first] && to != first) {
            if (!parent(v, first)) {
                int res = dfs(to, first);
                if (!parent(to, first)) {
                    sz += res;
                }
            } else {
                mx = std::max(mx, dfs(to, first));
            }
        }
    }
    if (!parent(v, first)) {
        return sz;
    }
    return mx;
}

struct SegmentTree {
    struct node {
        int max = 0, ver = 0;

        node() = default;

        node(int _max, int _ver) : max(_max), ver(_ver) {}

        bool operator<(const node &other) const {
            return max < other.max;
        }
    };

    std::array<node, 4 * N> t;

    void update(int v, int l, int r, int i, int val, int ver) {
        if (l + 1 == r) {
            t[v] = {val, ver};
            return;
        }
        int m = (r + l) / 2;
        if (i < m) {
            update(2 * v, l, m, i, val, ver);
        } else {
            update(2 * v + 1, m, r, i, val, ver);
        }
        t[v] = std::max(t[2 * v], t[2 * v + 1]);
    }
};

SegmentTree t;

void not_main() {
    int n, q;
    std::cin >> n >> q;
    for (int i = 1; i < n; ++i) {
        int p;
        std::cin >> p;
        --p;
        g[p].emplace_back(i);
    }
    for (int i = 0; i < n; ++i) {
        std::cin >> s[i];
    }
    calc(0);
    int sz = 1;
    for (auto &to: g[0]) {
        wh[to] = sz++;
        t.update(1, 0, n, wh[to], s[to], to);
    }
    for (int i = 1; i < n; ++i) {
        int who = t.t[1].ver;
        indx[who] = i;
        t.update(1, 0, n, wh[who], 0, 0);
        for (auto &to: g[who]) {
            wh[to] = sz++;
            t.update(1, 0, n, wh[to], s[to], to);
        }
    }
    ans.fill(-1);
    ans[0] = 0;
    for (int i = 0; i < q; ++i) {
        int v;
        std::cin >> v;
        --v;
        if (ans[v] != -1) {
            std::cout << ans[v] << ' ';
            continue;
        }
        ans[v] = indx[v] - dfs(0, v);
        std::cout << ans[v] << ' ';
    }
    std::cout << '\n';
}

signed main() {
    std::ios_base::sync_with_stdio(false);
#ifndef LOCAL
    std::cin.tie(nullptr);
#endif
    int tests = 1;
    // std::cin >> tests;
    while (tests--) {
        not_main();
    }
    return 0;
}