#include <bits/stdc++.h>
#include <bits/extc++.h>

#ifndef LOCAL
#pragma GCC optimize("O3")
#pragma GCC target("avx2")
#pragma GCC optimize("unrool-looops")
#endif

std::random_device rd;
std::mt19937_64 gen(rd());

using namespace __gnu_pbds;
using ll = long long;

template<class T>
using ordered_set = tree<T, null_type, std::less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int N = 3e5;

int n, q;
std::array<int, N> s, ans, indx, wh, order, par, size;
std::array<std::vector<int>, N> g;
int timer = 0;

struct SegmentTree {
    struct node {
        int max = 0, ver = 0;

        node() = default;

        node(int _max, int _ver) : max(_max), ver(_ver) {}

        bool operator<(const node &other) const {
            return max < other.max;
        }
    };

    std::array<node, 4 * N> t;

    void update(int v, int l, int r, int i, int val, int ver) {
        if (l + 1 == r) {
            t[v] = {val, ver};
            return;
        }
        int m = (r + l) / 2;
        if (i < m) {
            update(2 * v, l, m, i, val, ver);
        } else {
            update(2 * v + 1, m, r, i, val, ver);
        }
        t[v] = std::max(t[2 * v], t[2 * v + 1]);
    }
};

SegmentTree t;

void not_main() {
    std::cin >> n >> q;
    par[0] = -1;
    for (int i = 1; i < n; ++i) {
        int p;
        std::cin >> p;
        --p;
        par[i] = p;
        g[p].emplace_back(i);
    }
    for (int i = 0; i < n; ++i) {
        std::cin >> s[i];
    }
    int sz = 1;
    for (auto &to: g[0]) {
        wh[to] = sz++;
        t.update(1, 0, n, wh[to], s[to], to);
    }
    for (int i = 1; i < n; ++i) {
        int who = t.t[1].ver;
        indx[who] = i;
        order[i] = who;
        t.update(1, 0, n, wh[who], 0, 0);
        for (auto &to: g[who]) {
            wh[to] = sz++;
            t.update(1, 0, n, wh[to], s[to], to);
        }
    }
    for (int i = 0; i < n; ++i) {
        t.update(1, 0, n, i, 0, 0);
        std::ranges::sort(g[i], [](int x, int y) {
            return indx[x] < indx[y];
        });
    }
    for (int i = 0; i < n; ++i) {
        int v = order[i], v1 = v;
        while (v1 >= 0) {
            t.update(1, 0, n, v1, 0, 0);
            v1 = par[v1];
        }
        ans[v] = timer++ - t.t[1].max;
        v1 = v;
        while (v1 >= 0) {
            ++size[v1];
            t.update(1, 0, n, v1, size[v1], v1);
            v1 = par[v1];
        }
    }
    for (int i = 0; i < q; ++i) {
        int v;
        std::cin >> v;
        --v;
        std::cout << ans[v] << ' ';
    }
    std::cout << '\n';
}

/*
22 22
1 1 1 2 2 3 5 5 6 7 7 7 10 10 10 13 13 17 17 18 18
8 9 12 11 1 10 13 2 3 4 15 14 16 5 6 7 17 20 18 17 21 22
1 3 7 13 18 22 21 17 19 20 11 12 4 2 6 10 16 15 14 5 9 8
 */

signed main() {
    std::ios_base::sync_with_stdio(false);
#ifndef LOCAL
    std::cin.tie(nullptr);
#endif
    int tests = 1;
    // std::cin >> tests;
    while (tests--) {
        not_main();
    }
    return 0;
}