#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (T& x : v) in >> x;
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, vector<T>& v) {
    for (T& x : v) out << x << " ";
    return out;
}

template<typename T1, typename T2>
istream& operator>>(istream& in, pair<T1, T2>& p) {
    in >> p.first >> p.second;
    return in;
}

template<typename T1, typename T2>
ostream& operator<<(ostream& out, pair<T1, T2>& p) {
    out << p.first << " " << p.second;
    return out;
}

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
using ll = long long;
using ld = long double;

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

struct fenwick {

    fenwick() {}
    fenwick(int n) : n(n) {
        v.resize(n);
    }

    void add(int r, int x) {
        for (; r < n; r = r | (r + 1)) v[r] += x;
    }

    int get(int r) {
        int s = 0;
        for (; r >= 0; r = (r & (r + 1)) - 1) s += v[r];
        return s;
    }

    int get(int l, int r) {
        return get(r) - get(l - 1);
    }

    int n;
    vector<int> v;

};

struct segtree {

    segtree() {}
    segtree(int n) : n(n) {
        v.resize(n * 4);
        ps.resize(n * 4, -1e9);
    }

    void push(int pos, int tl, int tr) {
        v[pos * 2 + 1] = max(v[pos * 2 + 1], ps[pos]);
        v[pos * 2 + 2] = max(v[pos * 2 + 2], ps[pos]);
        ps[pos * 2 + 1] = max(ps[pos * 2 + 1], ps[pos]);
        ps[pos * 2 + 2] = max(ps[pos * 2 + 2], ps[pos]);
        ps[pos] = -1e9;
    }

    int get(int l, int r) {
        return get(l, r, 0, 0, n - 1);
    }

    void upd(int l, int r, int x) {
        upd(l, r, x, 0, 0, n - 1);
    }

    int get(int l, int r, int pos, int tl, int tr) {
        if (tr < l || r < tl) return -1e9;
        if (l <= tl && tr <= r) return v[pos];
        push(pos, tl, tr);
        int m = (tl + tr) / 2;
        return max(get(l, r, pos * 2 + 1, tl, m), get(l, r, pos * 2 + 2, m + 1, tr));
    }

    void upd(int l, int r, int x, int pos, int tl, int tr) {
        if (r < tl || tr < l) return;
        if (l <= tl && tr <= r) {
            v[pos] = max(v[pos], x);
            ps[pos] = max(ps[pos], x);
            return;
        }
        push(pos, tl, tr);
        int m = (tl + tr) / 2;
        upd(l, r, x, pos * 2 + 1, tl, m);
        upd(l, r, x, pos * 2 + 2, m + 1, tr);
        v[pos] = max(v[pos * 2 + 1], v[pos * 2 + 2]);
    }

    int n;
    vector<int> v, ps;

};

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> p(n);
    vector<vector<int>> g(n);
    for (int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        g[p[i]].push_back(i);
    }
    vector<int> a(n), qr(q);
    cin >> a >> qr;
    for (int &x: qr) x--;

    vector<int> ord, pos(n);
    {
        set<pair<int, int>> s;
        s.emplace(a[0], 0);
        while (!s.empty()) {
            int i = prev(s.end())->second;
            pos[i] = ord.size();
            s.erase(prev(s.end()));
            ord.push_back(i);
            for (int to : g[i]) s.emplace(a[to], to);
        }
    }

//    for (int x : p) cout << x << " ";
//    cout << "\n";

    vector<vector<int>> v;
    vector<int> ans = pos;
    for (int i = 1; i < n; i++) {
        if (p[i] == 0) v.emplace_back();
        v.back().push_back(i);
    }

//    cout << v.size() << "\n";
//    for (auto x : v) {
//        for (auto y : x) cout << y << " ";
//        cout << "\n";
//    }

//    for (int x : pos) cout << x << " ";
//    cout << "\n";

    segtree st(n);
    for (int i = 0; i < v.size(); i++) {
        for (int x : v[i]) {
            ans[x] = min(ans[x], pos[x] - st.get(pos[x], pos[x]));
//            cout << i << ": " << st.get(x, x) << "\n";
        }
        sort(all(v[i]), [&](int a, int b) {
            return pos[a] < pos[b];
        });
        for (int j = 0; j < v[i].size(); j++) {
            st.upd(pos[v[i][j]], n - 1, j + 1);
        }
    }

    st = segtree(n);
    reverse(all(v));
    for (int i = 0; i < v.size(); i++) {
        for (int x : v[i]) ans[x] = min(ans[x], pos[x] - st.get(pos[x], pos[x]));
        for (int j = 0; j < v[i].size(); j++) {
            st.upd(pos[v[i][j]], n - 1, j + 1);
        }
    }

    for (int x : qr) cout << ans[x] << " ";
}

//5 5
//1 1 1 1
//1 2 3 4 5
//1 2 3 4 5

signed main() {
#ifndef LOCAL
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
#endif

    int t = 1;
//    cin >> t;
    while (t--) solve();
}