#include <iostream>
#include <random>
#include <numeric>
#include <algorithm>
#include <vector>
#include <map>
#include <set>

using namespace std;
using ll = long long;
using ull = unsigned long long;

constexpr int maxn = 3e5 + 10, inf = 1e9;
int n;
int par[maxn];
int prior[maxn];
pair<int, int> ques[maxn];
int ans[maxn];
vector<int> g[maxn];
int order[maxn];
bool ready[maxn], enabled[maxn];
int min_to_root[maxn];
int prp[maxn];
int rcs[maxn];
int depth[maxn];
int glob_enabled_cnt = 0;
set<pair<int, int>> root_childs;

void enable(int v) {
    if (!v || !enabled[par[v]] || enabled[v] || !ready[v]) return;
    enabled[v] = true;
    int crc = prp[v];
    root_childs.erase(make_pair(rcs[crc], crc));
    ++rcs[crc];
    ++glob_enabled_cnt;
    root_childs.emplace(rcs[crc], crc);
    for (auto u: g[v]) enable(u);
}

void dfs1(int v, int cmv = inf) {
    min_to_root[v] = cmv;
    if (v) min_to_root[v] = std::min(min_to_root[v], prior[v]);\
    for (auto u: g[v]) dfs1(u, min_to_root[v]);
}

void dfs2(int v, int cprp = 0) {
    prp[v] = cprp;
    for (auto u: g[v]) {
        if (v) dfs2(u, cprp);
        else dfs2(u, u);
    }
}

void dfs3(int v, int d) {
    depth[v] = d;
    for (auto u: g[v]) dfs3(u, d + 1);
}

void solve() {
    int q;
    cin >> n >> q;
    for (int i = 1; i < n; ++i) cin >> par[i], --par[i], g[par[i]].push_back(i);
    for (int i = 0; i < n; ++i) cin >> prior[i];
    for (int i = 0; i < q; ++i) cin >> ques[i].first, --ques[i].first, ques[i].second = i;
    dfs1(0);
    dfs2(0);
    dfs3(0, 0);
    iota(order, order + n, 0);
    sort(order, order + n, [](int a, int b) { return prior[a] > prior[b]; });
    sort(ques, ques + q,
         [](const pair<int, int> &a, const pair<int, int> &b) { return min_to_root[a.first] > min_to_root[b.first]; });
    ready[0] = enabled[0] = true;
    int qid = 0;
    while (qid < q && min_to_root[ques[qid].first] == inf) ans[ques[qid].second] = 0, ++qid;
    for (int _ = 0; _ < n; ++_) {
        int v = order[_];
        if (!v) continue;
        ready[v] = true;
        enable(v);
        while (qid < q && min_to_root[ques[qid].first] == prior[v]) {
            auto u = ques[qid].first;
            int cans = glob_enabled_cnt - rcs[prp[u]] + depth[u];
            if (!root_childs.empty()) {
                if (root_childs.rbegin()->second != prp[u]) cans -= root_childs.rbegin()->first;
                else if (root_childs.size() >= 2) cans -= next(root_childs.rbegin())->first;
            }
            ans[ques[qid].second] = cans;
            ++qid;
        }
    }
    while (qid < q) ans[ques[qid].second] = 0, ++qid;
    for (int i = 0; i < q; ++i) cout << ans[i] << "\n";
}

int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);
    ll t = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> t;
#else
#ifdef TEST
    freopen("input.txt", "r", stdin);
#else
#endif
#endif
    while (t--) {
        solve();
        cout << "\n";
    }
    return 0;
}
