#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <fstream>
#include <unordered_map>
#include <algorithm>
#include <queue>
using namespace std;

using ll = long long;

const int maxn = 3e5;
const int inf = 1e9 + 239;
vector<vector<int>> g(maxn, vector<int>(0));

vector<int> ans(maxn, inf);

void dijkstra(int n, int v, vector<int>& s) {
  int save = s[v];
  s[v] = 0;
  priority_queue<pair<int, int>> q;
  q.push({ s[0], 0 });
  int cur = -1;
  while (!q.empty()) {
    cur++;
    int u = q.top().second;
    q.pop();
    ans[u] = min(ans[u], cur);
    for (int w : g[u]) {
      q.push({s[w], w});
    }
  }
  s[v] = save;
}



void solve() {
  int n, q;
  cin >> n >> q;
  vector<int> s(n);
  vector<int> p(n);
  for (int i = 1; i < n; i++) {
    cin >> p[i];
    p[i]--;
    g[p[i]].push_back(i);
  }
  for (int i = 0; i < n; i++) {
    cin >> s[i];
  }
  for (int v = 0; v < n; v++) {
    dijkstra(n, v, s);
  }
  while (q--) {
    int v;
    cin >> v;
    cout << ans[v - 1] << '\n';
  }
}

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  solve();
}
