#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

// #pragma GCC target("sse4.2,bmi,bmi2,popcnt,lzcnt,avx2")

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef __int128_t d128;
typedef int dgt;
typedef pair<dgt, dgt> pdd;
const dgt MOD = 1e9 + 7;
const dgt INF = 1e9 + 1;
const ll INFLL = 1e18 + 1;
const ld EPS = 1e-9;

// typedef tree<dgt, null_type, less<dgt>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define all(x) x.begin(), x.end()

template<typename T1, typename T2>
istream& operator >> (istream&, pair<T1, T2>&);

template<typename T1, typename T2>
ostream& operator << (ostream&, const pair<T1, T2>&);

template<typename T>
istream& operator >> (istream& is, vector<T>& arr) {
    for (T& el: arr)
        is >> el;
    return is;
}

template<typename T>
ostream& operator << (ostream& os, const vector<T>& arr) {
    for (const T& el: arr)
        os << el << ' ';
    return os;
}

template<typename T1, typename T2>
istream& operator >> (istream& is, pair<T1, T2>& pr) {
    return is >> pr.first >> pr.second;
}

template<typename T1, typename T2>
ostream& operator << (ostream& os, const pair<T1, T2>& pr) {
    return os << pr.first << ' ' << pr.second;
}

// struct segtree {
//     vector<dgt> tree;
//     dgt size;

//     segtree(dgt n) {
//         build(n);
//     }

//     void build(dgt n) {
//         size = n;
//         tree.assign(2 * size, 0);
//     }

//     void add(dgt l, dgt r, dgt x) {
//         l += size, r += size;
//         while (l != r) {
//             if (l & 1)
//                 tree[l++] += x;
//             if (r & 1)
//                 tree[--r] += x;
//             l >>= 1, r >>= 1;
//         }
//     }

//     dgt get(dgt pos) {
//         pos += size;
//         dgt res = 0;
//         while (pos > 0) {
//             res += tree[pos];
//             pos >>= 1;
//         }
//         return res;
//     }
// };

// struct segtree {
//     struct Node {
//         dgt sum;
//     };

//     Node DEFAULT = {0};

//     vector<Node> tree;
//     dgt size;

//     segtree(const vector<dgt>& src) {
//         build(src);
//     }

//     void build(const vector<dgt>& src) {
//         for (size = 1; size < src.size(); size *= 2);
//         tree.assign(2 * size - 1, DEFAULT);
//         _build(0, 0, size, src);
//     }

//     Node _merge(Node a, Node b) {
//         return {a.sum + b.sum};
//     }

//     void _build(dgt v, dgt l, dgt r, const vector<dgt>& src) {
//         if (l >= src.size())
//             return;
//         if (l + 1 == r) {
//             tree[v] = {src[l]};
//             return;
//         }
//         dgt m = (l + r) / 2;
//         _build(2 * v + 1, l, m, src);
//         _build(2 * v + 2, m, r, src);
//         tree[v] = _merge(tree[2 * v + 1], tree[2 * v + 2]);
//     }

//     void _addx(dgt v, dgt l, dgt r, dgt pos, dgt x) {
//         if (l + 1 == r) {
//             tree[v].sum += x;
//         }
//         dgt m = (l + r) / 2;
//         if (pos < m)
//             _addx(2 * v + 1, l, m, pos, x);
//         else
//             _addx(2 * v + 2, m, r, pos, x);
//         tree[v] = _merge(tree[2 * v + 1], tree[2 * v + 2]);
//     }

//     void addx(dgt pos, dgt x) {
//         return _addx(0, 0, size, pos, x);
//     }

//     Node _get(dgt v, dgt l, dgt r, dgt ql, dgt qr) {
//         if (qr <= l || ql >= r)
//             return;
//         if (ql <= l && qr >= r) {
//             return tree[v];
//         }
//         dgt m = (l + r) / 2;
//         return _merge(_get(2 * v + 1, l, m, ql, qr), _get(2 * v + 2, m, r, ql, qr));
//     }

//     Node get(dgt ql, dgt qr) {
//         return _get(0, 0, size, ql, qr);
//     }

//     dgt sum(dgt ql, dgt qr) {
//         return get(ql, qr).sum;
//     }
// };

struct segtree {
    struct Node {
        dgt max;
        dgt add;
    };

    Node DEFAULT = {-INF, 0};

    vector<Node> tree;
    dgt size;

    segtree(const vector<dgt>& src) {
        build(src);
    }

    void build(const vector<dgt>& src) {
        for (size = 1; size < src.size(); size *= 2);
        tree.assign(2 * size - 1, DEFAULT);
        _build(0, 0, size, src);
    }

    Node _merge(Node a, Node b) {
        return {std::max(a.max, b.max), DEFAULT.add};
    }

    void _push(dgt v, dgt l, dgt r) {
        if (l + 1 < r) {
            for (dgt i = 1; i <= 2; ++i) {
                if (tree[v].add != DEFAULT.add) {
                    tree[2 * v + i].max += tree[v].add;
                    tree[2 * v + i].add += tree[v].add;
                }
            }
            tree[v].add = DEFAULT.add;
        }
    }

    void _build(dgt v, dgt l, dgt r, const vector<dgt>& src) {
        if (l >= src.size())
            return;
        if (l + 1 == r) {
            tree[v] = {src[l], DEFAULT.add};
            return;
        }
        dgt m = (l + r) / 2;
        _build(2 * v + 1, l, m, src);
        _build(2 * v + 2, m, r, src);
        tree[v] = _merge(tree[2 * v + 1], tree[2 * v + 2]);
    }

    void _addx(dgt v, dgt l, dgt r, dgt ql, dgt qr, dgt x) {
        if (qr <= l || ql >= r)
            return;
        if (ql <= l && qr >= r) {
            tree[v].max += x;
            tree[v].add += x;
            return;
        }
        dgt m = (l + r) / 2;
        _push(v, l, r);
        _addx(2 * v + 1, l, m, ql, qr, x);
        _addx(2 * v + 2, m, r, ql, qr, x);
        tree[v] = _merge(tree[2 * v + 1], tree[2 * v + 2]);
    }

    void addx(dgt ql, dgt qr, dgt x) {
        return _addx(0, 0, size, ql, qr, x);
    }

    Node _get(dgt v, dgt l, dgt r, dgt ql, dgt qr) {
        if (qr <= l || ql >= r)
            return DEFAULT;
        if (ql <= l && qr >= r) {
            return tree[v];
        }
        dgt m = (l + r) / 2;
        _push(v, l, r);
        return _merge(_get(2 * v + 1, l, m, ql, qr), _get(2 * v + 2, m, r, ql, qr));
    }

    Node get(dgt ql, dgt qr) {
        return _get(0, 0, size, ql, qr);
    }

    dgt max(dgt ql, dgt qr) {
        return get(ql, qr).max;
    }
};


vector<vector<dgt>> g;
vector<dgt> p, h, ch, heavy, sz, top, num;
// tin, tout;
vector<dgt> s;
dgt n, t;
dgt cnt, glb;

void dfs(dgt v) {
    // tin[v] = t++;
    sz[v] = 1;
    dgt max_u = -1;
    for (dgt u: g[v]) {
        h[u] = h[v] + 1;
        dfs(u);
        sz[v] += sz[u];
        if (max_u == -1 || sz[max_u] < sz[u])
            max_u = u;
    }
    heavy[v] = max_u;
    // tout[v] = t;
}

void hld(dgt v, dgt c) {
    ch[v] = c;
    num[v] = ++glb;
    if (heavy[v] != -1)
        hld(heavy[v], c);
    for (dgt u: g[v]) {
        if (u != heavy[v]) {
            top.push_back(u);
            hld(u, ++cnt);
        }
    }
}

void solve() {
    t = 0;
    dgt q;
    cin >> n >> q;
    p.assign(n, -1);
    g.clear();
    g.resize(n);
    for (dgt i = 1; i < n; ++i) {
        dgt pr;
        cin >> pr;
        --pr;
        p[i] = pr;
        g[pr].push_back(i);
    }
    s.resize(n);
    cin >> s;
    h.assign(n, 0);
    sz.resize(n);
    heavy.resize(n);
    ch.resize(n);
    top.clear();
    num.resize(n);
    cnt = -1;
    glb = -1;
    // tin.resize(n), tout.resize(n);
    dfs(0);
    top.push_back(0);
    hld(0, ++cnt);
    vector<dgt> ans(n);
    vector<dgt> src(n, 0);
    segtree sg(src);
    priority_queue<pdd> pqu;
    pqu.emplace(s[0], 0);
    vector<pdd> segs;
    for (dgt i = 0; i < n; ++i) {
        auto [sv, v] = pqu.top();
        pqu.pop();
        ans[v] = i;
        dgt mx = 0;
        segs.clear();
        {
            dgt u = v;
            while (u != -1) {
                segs.emplace_back(num[top[ch[u]]], num[u]);
                u = p[top[ch[u]]];
            }
            reverse(all(segs));
            dgt curr = 0;
            for (pdd se: segs) {
                mx = max(mx, sg.max(curr, se.first));
                curr = se.second + 1;
            }
            mx = max(mx, sg.max(curr, n));
        }
        ans[v] -= mx;
        for (dgt u: g[v])
            pqu.emplace(s[u], u);
        while (v != -1) {
            dgt nmv = num[v];
            dgt start = top[ch[v]];
            sg.addx(num[start], nmv + 1, 1);
            v = p[start];
        }
    }
    for (; q > 0; --q) {
        dgt v;
        cin >> v;
        --v;
        cout << ans[v] << ' ';
    }
    cout << '\n';
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int reps = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> reps;
#endif

    for (int i = 0; i < reps; ++i) {
#ifdef LOCAL
        cout << "Test case #" << i << " ===========================\n";
#endif
        solve();
#ifdef LOCAL
        cout << "End test ===============================\n";
#endif
    }

    return 0;
}

// g++ -std=c++23 -Wall -Wextra -Wshadow -O2 -DLOCAL -D_GLIBCXX_DEBUG -D_GLIBCXX_DEBUG_PEDANTIC -fsanitize=address,undefined
