#ifndef LOCAL
#pragma GCC optimize("O3")
#endif

#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;
using oset = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
const ll nMax = (1 << 19);
ll p[nMax];
vector<int> g[nMax];
ll cost[nMax];
ll s[nMax];
ll ans[nMax];
struct segtree{
    struct node{
        ll val = 0;
        node operator+(node oth){
            return node{max(val,oth.val)};
        }
    };
    vector<node> t;
    vector<int> push;
    segtree(){
        t.resize(nMax*2,node{});
        push.resize(nMax*2,0);
    }
    void add(int v, int l, int r, int ql, int qr, ll val){
        if(qr<=l || ql >=r)return;
        if(ql <= l && r <= qr){
            push[v]+=val;
            t[v].val+=val;
            return;
        }
        int m = (l+r)/2;
        add(v*2,l,m,ql,qr,val);
        add(v*2+1,m,r,ql,qr,val);
        t[v]=t[v*2]+t[v*2+1];
        t[v].val += push[v];
    }
    ll get(int v, int l, int r, int ql, int qr){
        if(qr<=l || ql >=r){
            return 0;
        }
        if(ql <=l && r <= qr){
            return t[v].val;
        }

        int m = (l+r)/2;
        return max(get(v*2,l,m,ql,qr),get(v*2+1,m,r,ql,qr)) + push[v];
    }
}st;
int tin[nMax],tout[nMax],sz[nMax], timer = 1;
void dfs1(int v){
    sz[v]=1;
    for(auto u : g[v]){
        dfs1(u);
        sz[v]+=sz[u];
    }
}
int head[nMax];
void dfs2(int v){
    sort(g[v].begin(),g[v].end(),[&](auto f, auto s){return sz[f] > sz[s];});
    tin[v] = timer++;
    if(g[v].size()){
        head[g[v][0]] = head[v];
        for(int i = 1; i < g[v].size();i++)head[g[v][i]] = g[v][i];
        for(auto u : g[v]) dfs2(u);
    }
    tout[v] = timer;
}
void addOnRoute(int v){
    while(v != 0){
        st.add(1,0,nMax,tin[head[v]],tin[v]+1,1);
        v = p[head[v]];
    }
}
int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(0)->sync_with_stdio(0);
    ll n, q;
    cin >> n >> q;
    for(int i = 2; i <= n; i++){
        cin >> p[i];
        g[p[i]].push_back(i);
    }
    for(int i = 1; i <=n; i++){
        cin >> s[i];
    }
    dfs1(1);
    head[1] = 1;
    dfs2(1);

    set<pair<int,int>>  qq;
    qq.insert({-s[1],1});
    int ord = 0;
    while(!qq.empty()){
        auto [curS,curU] = *qq.begin();
        qq.erase(qq.begin());
        for(auto v : g[curU]){
            if(v == p[curU]) continue;
            qq.insert({-s[v],v});
        }
        vector<int> ps;
        int tmp =curU;
        ps.push_back(0);

        while(tmp){
            ps.push_back(tin[head[tmp]]);
            ps.push_back(tin[tmp]+1);
            tmp = p[head[tmp]];
        }
        ps.push_back(nMax);
        sort(ps.begin(),ps.end());
        ll bst = 0;
        for(int i = 0; i < ps.size(); i+=2){
            bst = max(bst, st.get(1,0,nMax,ps[i],ps[i+1]));
        }
        ans[curU] = ord++ - bst;
        addOnRoute(curU);
    }
for(int i = 0; i < q; i++){
    int u;
    cin >> u;
    cout << ans[u] << ' ';
}
}