#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <random>
#include <ctime>
#include <chrono>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
#include <queue>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7;

struct segtree
{
	long long n;
	vector<long long> t, p;

	segtree() {}

	segtree(long long in)
	{
		n = in;
		t.resize(n * 4);
		p.resize(n * 4);
	}

	void upd_seg(long long v, long long tl, long long tr, long long l, long long r, long long val)
	{
		if (tr < l || r < tl)
		{
			return;
		}
		if (l <= tl && tr <= r)
		{
			p[v] += val;
			return;
		}

		long long tm = (tl + tr) / 2;
		upd_seg(v * 2 + 1, tl, tm, l, r, val);
		upd_seg(v * 2 + 2, tm + 1, tr, l, r, val);
		t[v] = max(t[v * 2 + 1] + p[v * 2 + 1], t[v * 2 + 2] + p[v * 2 + 2]);
	}

	void upd(long long l, long long r, long long val)
	{
		upd_seg(0, 0, n - 1, l, r, val);
	}

	long long get_seg(long long v, long long tl, long long tr, long long l, long long r)
	{
		if (tr < l || r < tl)
		{
			return -INF;
		}
		if (l <= tl && tr <= r)
		{
			return t[v];
		}

		long long tm = (tl + tr) / 2;
		return max(get_seg(v * 2 + 1, tl, tm, l, r) + p[v * 2 + 1], get_seg(v * 2 + 2, tm + 1, tr, l, r) + p[v * 2 + 2]);
	}

	long long get(long long l, long long r)
	{
		return get_seg(0, 0, n - 1, l, r) + p[0];
	}
};

long long n;
vector<long long> g[300000], par, val, sz, head, tin;
long long tmr = 0;

void sizes(long long v)
{
	sz[v] = 1;
	if (!g[v].size())
	{
		return;
	}

	long long best = 0, idx = 0;
	for (auto& i : g[v])
	{
		sizes(i);
		sz[v] += sz[i];
		if (sz[g[v][idx]] > sz[g[v][best]])
		{
			best = idx;
		}
		idx++;
	}
	swap(g[v][0], g[v][best]);
}

void hld(long long v)
{
	tin[v] = tmr++;
	for (auto& i : g[v])
	{
		head[i] = (i == g[v][0] ? head[v] : i);
		hld(i);
	}
}

vector<pair<long long, long long>> get_path(long long v)
{
	vector<pair<long long, long long>> res;
	while (v != -1)
	{
		long long up = head[v];
		res.push_back({ tin[up], tin[v] });
		v = par[up];
	}
	reverse(res.begin(), res.end());
	return res;
}

void solve()
{
	long long q;
	cin >> n >> q;
	par.resize(n, -1);
	for (long long i = 1; i < n; i++)
	{
		long long pv;
		cin >> pv;
		pv--;
		g[pv].push_back(i);
		par[i] = pv;
	}
	val.resize(n);
	for (long long i = 0; i < n; i++)
	{
		cin >> val[i];
	}

	sz.resize(n);
	head.resize(n);
	tin.resize(n);
	sizes(0);
	hld(0);

	priority_queue<pair<long long, long long>> st;
	vector<long long> ord;
	ord.reserve(n);
	ord.push_back(0);
	for (auto& i : g[0])
	{
		st.push({ val[i], i });
	}
	while (st.size())
	{
		long long ver = st.top().second;
		ord.push_back(ver);
		st.pop();
		for (auto& i : g[ver])
		{
			st.push({ val[i], i });
		}
	}

	vector<long long> ans(n, -1);
	segtree sgt(n);
	long long day = 0;
	for (auto& ver : ord)
	{
		vector<pair<long long, long long>> path = get_path(ver);
		for (auto& [a, b] : path)
		{
			sgt.upd(a, b, 1);
		}
		path.push_back({ n, n });
		long long best = 0;
		for (long long i = 0; i < path.size(); i++)
		{
			long long left = 0, right = path[i].first - 1;
			if (i)
			{
				left = path[i - 1].second + 1;
			}
			if (left <= right)
			{
				best = max(best, sgt.get(left, right));
			}
		}
		ans[ver] = day - best;
		day++;
	}
	while (q--)
	{
		long long ver;
		cin >> ver;
		ver--;
		cout << ans[ver] << " ";
	}
	cout << "\n";
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int t = 1;
	//cin >> t;
	while (t--)
	{
		solve();
	}

	return 0;
}

/*

























*/
