#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using namespace std;
using ll = long long;
using ld = long double;

//#include <ext/pb_ds/assoc_container.hpp>
//using namespace __gnu_pbds;
//template<typename T>
//using oset = tree<T, null_type, greater<T>, rb_tree_tag, tree_order_statistics_node_update>;

// #define int ll

const int MAXN = 300'000;

vector<vector<int>> graph;
vector<int> p, s, clr;
vector<vector<int>> places;
int l, r;

void dfs(int start, int fx) {
    for (auto child : graph[start])
        dfs(child, fx);

    places[fx].push_back(clr[start]);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);

    int n, q;
    cin >> n >> q;

    p.resize(n);
    s.resize(n);
    clr.resize(n);
    graph.resize(n);
    places.resize(n);

    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        p[i]--;
        graph[p[i]].push_back(i);
    }

    for (int i = 0; i < n; ++i)
        cin >> s[i];

    set<pair<int, int>> st;
    st.insert({-s[0], 0});

    int ci = 0;
    while (not st.empty()) {
        int now = st.begin()->second;
        st.erase(st.begin());
        clr[now] = ci++;

        for (auto child : graph[now]) {
            st.insert({-s[child], child});
        }
    }

    l = graph[0][0], r = -1;
    if (graph[0].size() > 1)
        r = graph[0][1];

    if (r != -1) {
        dfs(l, l);
        dfs(r, r);

        std::sort(places[l].begin(), places[l].end());
        std::sort(places[r].begin(), places[r].end());
    }

    int v;
    for (int _ = 0; _ < q; ++_) {
        cin >> v;
        v--;

        if (r == -1 or v == 0) {
            cout << clr[v] << ' ';
            continue;
        }

        auto px = std::lower_bound(places[l].begin(), places[l].end(), clr[v]);
        if (px == places[l].end() or *px != clr[v])
            cout << clr[v] - (px - places[l].begin());

        px = std::lower_bound(places[r].begin(), places[r].end(), clr[v]);
        if (px == places[r].end() or *px != clr[v])
            cout << clr[v] - (px - places[r].begin());

        cout << ' ';
    }
}
