#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using namespace std;
using ll = long long;
using ld = long double;

//#include <ext/pb_ds/assoc_container.hpp>
//using namespace __gnu_pbds;
//template<typename T>
//using oset = tree<T, null_type, greater<T>, rb_tree_tag, tree_order_statistics_node_update>;

// #define int ll

const int MAXN = 300'000;

vector<vector<int>> graph;
vector<int> p, s, clr;
vector<vector<int>> places;
int l, r;

void dfs(int start, int fx) {
    for (auto child : graph[start])
        dfs(child, fx);

    places[fx].push_back(clr[start]);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);

    int n, q;
    cin >> n >> q;

    p.resize(n);
    s.resize(n);
    clr.resize(n);
    graph.resize(n);
    places.resize(n);

    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        p[i]--;
        graph[p[i]].push_back(i);
    }

    for (int i = 0; i < n; ++i)
        cin >> s[i];

    set<pair<int, int>> st;
    st.insert({-s[0], 0});

    int ci = 0;
    while (not st.empty()) {
        int now = st.begin()->second;
        st.erase(st.begin());
        clr[now] = ci++;

        for (auto child : graph[now]) {
            st.insert({-s[child], child});
        }
    }

    int bf = graph[0][0];
    int bax = n;
    for (auto child : graph[0])
        if (not graph[child].empty()) {
            bf = child;
        }

    dfs(bf, bf);

    for (auto child : graph[0])
        if (graph[child].empty()) {
            bax = min(bax, clr[bax]);
        }

    int v;
    for (int _ = 0; _ < q; ++_) {
        cin >> v;
        v--;

        auto px = std::lower_bound(places[bf].begin(), places[bf].end(), clr[v]);
        if (px != places[bf].end() and *px == clr[v]) {
            cout << clr[v] - (bax < clr[v]);
        } else {
            cout << clr[v] - max(int(bax < clr[v]), int(std::lower_bound(places[bf].begin(), places[bf].end(), clr[v]) - places[bf].begin()));
        }
        cout << ' ';
    }
}
