#define _GLIBCXX_DEBUG

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using namespace std;
using ll = long long;
using ld = long double;

//#include <ext/pb_ds/assoc_container.hpp>
//using namespace __gnu_pbds;
//template<typename T>
//using oset = tree<T, null_type, greater<T>, rb_tree_tag, tree_order_statistics_node_update>;

// #define int ll

const int MAXN = 300'000;

int n, q;

vector<vector<int>> graph;
vector<int> p, s, clr, qtr, tin, tout;
vector<pair<int, int>> qs;
vector<vector<int>> places;

int Time = 0;

void dfs(int start) {
    tin[start] = Time++;
    for (auto child : graph[start])
        dfs(child);
    tout[start] = Time;

    places[start].push_back(clr[start]);
    for (auto child : graph[start])
        for (int i = 0; i < q; ++i)
            places[start][i] += places[child][i];

    for (int i = qtr[clr[start]]; i < q; ++i) {
        places[start][i]++;
    }
}

bool is_p(int u, int v) {
    return tin[u] <= tin[v] and tout[v] <= tout[u];
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);

    cin >> n >> q;

    p.resize(n);
    s.resize(n);
    clr.resize(n);
    graph.resize(n);
    places.resize(n, vector<int> (q + 1));
    tin.resize(n);
    tout.resize(n);
    qs.resize(q);
    qtr.resize(n, q);

    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        p[i]--;
        graph[p[i]].push_back(i);
    }

    for (int i = 0; i < n; ++i)
        cin >> s[i];

    for (int i = 0; i < q; ++i) {
        cin >> qs[i].first;
        qs[i].first--;
        qs[i].second = i;
    }
    std::sort(qs.begin(), qs.end());

    for (int j = 0; j < q; ++j) {
        auto el = qs[j];
        for (int i = el.first; i >= 0 and qtr[i] == q; --i) {
            qtr[i] = j;
        }
    }

    set<pair<int, int>> st;
    st.insert({-s[0], 0});

    int ci = 0;
    while (not st.empty()) {
        int now = st.begin()->second;
        st.erase(st.begin());
        clr[now] = ci++;

        for (auto child : graph[now]) {
            st.insert({-s[child], child});
        }
    }

    dfs(0);

    vector<int> res(q, n);
    for (int j = 0; j < q; ++j) {
        for (int i = 0; i < n; ++i)
            if (not is_p(i, qs[j].first)) {
                res[qs[j].second] = min(res[qs[j].second], clr[qs[j].first] - places[i][j]);
            }
    }

    for (auto el : res)
        cout << el << ' ';
}
