#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pii = pair<ll, ll>;
#define all(a) a.begin(), a.end()
#define node ll v, ll l, ll r
#define root 0, 0, n
#define lv 2 * v + 1
#define rv 2 * v + 2
#define LSon lv, l, m
#define RSon rv, m, r

const ll INF = 1e9;

ll n, q;
vector<vector<ll>> g;
vector<ll> up, par, sz;
vector<ll> tin, tout;
ll timer = -1;
vector<ll> t, add;

void dfs(ll v) {
    sz[v] = 1;
    for (ll &to : g[v]) {
        dfs(to);
        sz[v] += sz[to];
        if (sz[to] > sz[g[v][0]])
            swap(to, g[v][0]);
    }
}

void dfsHld(ll v) {
    tin[v] = ++timer;
    for (auto to : g[v]) {
        if (to == g[v][0]) {
            up[to] = up[v];
        } else {
            up[to] = to;
        }
        dfsHld(to);
    }
    tout[v] = timer;
}

void push(ll v) {
    if (add[v] == 0) return;
    t[lv] += add[v];
    add[lv] += add[v];
    t[rv] += add[v];
    add[rv] += add[v];
    add[v] = 0;
}

void update(node, ll ql, ll qr, ll x) {
    if (l >= qr || r <= ql) return;
    if (l >= ql && r <= qr) {
        t[v] += x;
        add[v] += x;
        return;
    }
    push(v);
    ll m = (l + r) / 2;
    update(LSon, ql, qr, x);
    update(RSon, ql, qr, x);
    t[v] = max(t[lv], t[rv]);
}

ll query(node, ll ql, ll qr) {
    if (l >= qr || r <= ql) return -INF;
    if (l >= ql && r <= qr) return t[v];
    push(v);
    ll m = (l + r) / 2;
    return max(query(LSon, ql, qr), query(RSon, ql, qr));
}

void updHld(ll u, ll v, ll x) {
    while (up[u] != up[v]) {
        update(root, tin[up[v]], tin[v] + 1, x);
        v = par[up[v]];
    }
    update(root, tin[u], tin[v] + 1, x);
}

ll getHld(ll u, ll v) {
    vector<pii> seg;
    while (up[u] != up[v]) {
        seg.push_back({tin[up[v]], tin[v] + 1});
        v = par[up[v]];
    }
    seg.push_back({tin[u], tin[v] + 1});
    sort(all(seg));
    vector<pii> seg1;
    ll last = 0;
    for (auto [l, r] : seg) {
        if (last != l) {
            seg1.push_back({last, l});
        }
        last = r;
    }
    if (last != n)
        seg1.push_back({last, n});
    ll ans = 0;
    for (auto [ql, qr] : seg1) {
        ans = max(ans, query(root, ql, qr));
    }
    return ans;
}

int main() {
    cin >> n >> q;
    g.resize(n);
    up.resize(n);
    par.resize(n);
    sz.resize(n);
    tin.resize(n);
    tout.resize(n);
    t.resize(4 * n);
    add.resize(4 * n, 0);
    for (ll i = 1; i < n; ++i) {
        cin >> par[i];
        --par[i];
        g[par[i]].push_back(i);
    }
    dfs(0);
    dfsHld(0);
    vector<ll> s(n);
    for (ll i = 0; i < n; ++i) {
        cin >> s[i];
    }
    vector<ll> ans(n, INF);
    priority_queue<pii> pq;
    pq.push({s[0], 0});
    ll cnt = 0;
    while (!pq.empty()) {
        auto [c, v] = pq.top();
        pq.pop();
        ans[v] = cnt - getHld(0, v);
        ++cnt;
        updHld(0, v, 1);
        for (auto to : g[v]) {
            pq.push({s[to], to});
        }
//        cout << v << "\n";
//        for (auto el : t) {
//            cout << el << " ";
//        }
//        cout << "\n";
    }
    while (q--) {
        ll v;
        cin >> v;
        cout << ans[v - 1] << " ";
    }
}
