// semenInRussia 2025
#include <cstdint>
#include <iostream>
#include <queue>
#include <vector>
using namespace std;

const int N = 3e5 + 10;
int answ[N];
int tin[N];
int tout[N];
vector<int> g[N];

int s[N];
int ti = 0;

void dfs(int x, int fa = -1) {
  tin[x] = ti++;
  for (int y : g[x]) {
    if (y != fa) {
      dfs(y, x);
    }
  }
  tout[x] = ti++;
}

bool par(int x, int y) { return tin[x] <= tin[y] && tin[y] <= tout[x]; }

void solve(int j) {
  int old = s[j];
  s[j] = 0;

  priority_queue<pair<int, int>> q;
  q.push({s[0], 0});

  int ti = 0;
  while (!q.empty()) {
    auto [dx, x] = q.top();
    q.pop();
    answ[x] = min(answ[x], ti++);
    for (int y : g[x]) {
      q.push({s[y], y});
    }
  }

  s[j] = old;
}

int idx[N];

void indexs() {
  priority_queue<pair<int, int>> q;
  q.push({s[0], 0});

  int ti = 0;
  while (!q.empty()) {
    auto [dx, x] = q.top();
    q.pop();
    idx[x] = ti++;
    for (int y : g[x]) {
      q.push({s[y], y});
    }
  }
}

int main() {
  int n, q;
  cin >> n >> q;
  for (int i = 1; i < n; i++) {
    int p;
    cin >> p;
    --p;
    g[p].push_back(i);
  }

  for (int i = 0; i < n; i++) {
    cin >> s[i];
  }

  for (int i = 0; i < n; i++) {
    answ[i] = n + 1;
  }

  dfs(0);
  solve(0);
  for (int x : g[0]) {
    solve(x);
  }

  while (q--) {
    int v;
    cin >> v;
    --v;
    solve(v);
    cout << answ[v] << " ";
  }
}