#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;


int n, t = 0;
const int INF = 1e9;
vector<vector<int>> g, tree;
vector<int> top, tin, tou, s, p;


void dfs(int v) {
	tin[v] = t, t++;
	top.push_back(s[v]);
	for (int u : g[v])
		dfs(u);
	tou[v] = t;
}


void build(int id, int l, int r) {
	if (r - l == 1) {
		tree[id] = { top[l] };
		return;
	}
	int m = (l + r) / 2;
	build(id * 2 + 1, l, m);
	build(id * 2 + 2, m, r);
	for (int e : tree[id * 2 + 1])
		tree[id].push_back(e);
	for (int e : tree[id * 2 + 2])
		tree[id].push_back(e);
	sort(tree[id].begin(), tree[id].end());
}


int get(int id, int l, int r, int ql, int qr, int x) {
    //cout << "get " << l << ' ' << r << " || " << ql << ' ' << qr << '\n';
	if (ql <= l && r <= qr) {
		int i = lower_bound(tree[id].begin(), tree[id].end(), x) - tree[id].begin(), sz = tree[id].size();
		return sz - i;
	}
	if (qr <= l || r <= ql)
		return 0;
	int m = (l + r) / 2;
	return get(id * 2 + 1, l, m, ql, qr, x) + get(id * 2 + 2, m, r, ql, qr, x);
}


int up(int v, int par, int cnt, int mn, int mx) {
    //cout << "check " << v << ' ' << cnt << ' ' << mx << '\n';
	if (v == 0)
		return cnt - mx;
	cnt++;
	for (int u : g[v]) {
		if (u == par)
			continue;
		int res = get(0, 0, n, tin[u], tou[u], mn);
		cnt += res, mx = max(mx, res);
	}
	mn = min(mn, s[v]);
	return up(p[v], v, cnt, mn, mx);
}


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int q;
	cin >> n >> q;
	g.resize(n + 1);
	tree.resize(4 * n + 4);
	tin.resize(n + 1);
	tou.resize(n + 1);
	s.resize(n + 1);
	p.resize(n + 1, 0);
	for (int v = 2; v <= n; v++) {
		cin >> p[v];
		g[p[v]].push_back(v);
	}
	for (int i = 1; i <= n; i++)
		cin >> s[i];
    dfs(1);
    build(0, 0, n);
	int v;
	for (int i = 0; i < q; i++) {
		cin >> v;
		cout << up(p[v], v, 0, s[v], 0) << ' ';
	}
	cout << '\n';
}
