#include <bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
using ll = long long;
using ull = unsigned long long;

//tree<int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update> st;
//gp_hash_table<int, int> a;

struct segtree {
    vector<int> tr;
    int n;
    segtree(int n) : n(n), tr(2 * n) {}
    void upd(int i, int x) {
        for (tr[i += n] = x; i >= 0; tr[i >>= 1] = max(tr[i], tr[i ^ 1]));
    }
    int get(int l, int r) {
        int ans = 0;
        for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
            if (l & 1)
                ans = max(ans, tr[l++]);
            if (~r & 1)
                ans = max(ans, tr[r--]);
        }
        return ans;
    }
};

struct fenwick {
    vector<int> t;
    int n;
    fenwick(int n) : n(n), t(n + 1) {}
    void upd(int i, int x) {
        for (++i; i <= n; i += i & -i) t[i] += x;
    }
    int get(int i) {
        int x = 0;
        for (++i; i > 0; i -= i & -i) x += t[i];
        return x;
    }
};

template<class T>
bool chmin(T &a, const T &b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<class T>
bool chmax(T &a, const T &b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

mt19937 rnd(1337);

constexpr int N = 3e5;
vector<int> gr[N];

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> par(n, 0);
    for (int i = 1, p; i < n; ++i) {
        cin >> p;
        --p;
        par[i] = p;
        gr[p].push_back(i);
    }
    vector<int> s(n);
    for (int &i : s)
        cin >> i;
    vector<int> ans(n);
    set<pair<int, int>> st = {{s[0], 0}};
    int cnt = 0;
    vector<int> val(n, 0);
    auto get = [&](int v) -> int {
        vector<bool> ok(n, true);
        while (v != 0) {
            ok[v] = false;
            v = par[v];
        }
        ok[0] = false;
        int mx = 0;
        for (int i = 0; i < n; ++i)
            if (ok[i])
                mx = max(mx, val[i]);
        return mx;
    };
    auto upd = [&](int v) -> void {
        while (v != 0) {
            ++val[v];
            v = par[v];
        }
        ++val[0];
    };
    while (!st.empty()) {
        int v = st.rbegin()->second;
        st.erase({s[v], v});
        for (int u : gr[v])
            st.insert({s[u], u});
        ans[v] = cnt - get(v);
        cnt++;
        upd(v);
    }
    while (q--) {
        int i;
        cin >> i;
        --i;
        cout << ans[i] << '\n';
    }
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
    // cin >> t;
    while (t--) solve();
//    cerr << fixed << setprecision(10) << clock() * 1.0 / CLOCKS_PER_SEC << '\n';
}
