#include <bits/stdc++.h>

using namespace std;

// #define int long long
using ld = long double;
using ll = long long;
using pii = pair<int, int>;

int n, q;
vector<vector<int>> g;
vector<int> ans;
vector<int> sz;
vector<int> s;
vector<int> ti;

void sz_dfs(int v)
{
    sz[v] = 1;
    for (const auto &u : g[v])
    {
        sz_dfs(u);
        sz[v] += sz[u];
    }
}

bool cmp(int a, int b)
{
    return s[a] < s[b];
}

void dfs(int v)
{
    if (g[v].empty())
        return;
    sort(g[v].begin(), g[v].end(), cmp);
    int m = g[v].size();
    vector<int> suf(m);
    suf[m - 1] = sz[g[v][m - 1]];
    for (int i = m - 2; i >= 0; --i)
    {
        int u = g[v][i];
        suf[i] = max(sz[u], suf[i + 1]);
    }

    for (int i = 0; i < m; ++i)
    {
        int u = g[v][i];
        ans[u] = ans[v];
        int var = 0;
        if (i != m - 1)
        {
            var = suf[i + 1];
        }
        ans[u] = max(ans[u], var);
    }

    for (const auto &u : g[v])
    {
        dfs(u);
    }
}

void solve()
{
    cin >> n >> q;
    g.resize(n);
    ans.resize(n);
    sz.resize(n);
    s.resize(n);
    ti.resize(n, -1);

    for (int i = 1; i < n; ++i)
    {
        int p;
        cin >> p;
        --p;
        g[p].push_back(i);
    }
    for (int i = 0; i < n; ++i)
        cin >> s[i];

    int ct = 0;
    int cur = 0;
    set<pii> av;
    while (true)
    {
        assert(ti[cur] == -1);
        ti[cur] = ct;
        for (const auto &u : g[cur])
        {
            av.insert({s[u], u});
        }
        if (av.empty())
            break;
        auto it = av.rbegin();
        cur = it->second;
        av.erase({s[cur], cur});
        ++ct;
    }

    sz_dfs(0);
    ans[0] = 0;
    dfs(0);

    for (int qq = 0; qq < q; ++qq)
    {
        int v;
        cin >> v;
        --v;
        int res = ti[v] - ans[v];
        cout << res << ' ';
    }
    cout << '\n';
}

signed main()
{
#ifdef ROMALOCAL
    freopen("in.txt", "r", stdin);
#endif

    cin.tie(0);
    ios::sync_with_stdio(0);

    int t = 1;
    // cin >> t;
    while (t--)
    {
        solve();
    }
    return 0;
}