#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <unordered_map>
#include <set>

using namespace std;

vector<vector<int>> g;
vector<int> dp;
vector<vector<int>> w;

vector<int> merge(vector<int>& a, vector<int>& b) {
	vector<int> c;
	int cura = 0;
	int curb = 0;
	while (cura < a.size() && curb < b.size()) {
		if (a[cura] < b[curb]) {
			c.push_back(a[cura]);
			cura++;
		}
		else {
			c.push_back(b[curb]);
			curb++;
		}
	}
	while (cura < a.size()) {
		c.push_back(a[cura]);
		cura++;
	}
	while (curb < b.size()) {
		c.push_back(b[curb]);
		curb++;
	}
	return c;
}


vector<int> dfs(int v) {
	//cout << v << '\n';
	w[v].push_back(dp[v]);
	for (auto to : g[v]) {
		vector<int> c = dfs(to);
		w[v] = merge(w[v], c);
	}
	return w[v];
}

long long MM(vector<int>& a, int x) {
	long long l = -1;
	long long r = a.size();
	while (r - l > 1) {
		int mid = (r + l) / 2;
		if (a[mid] > x) {
			r = mid;
		}
		else {
			l = mid;
		}
	}
	return l + 1;
}

int main() {
	int n, q;
	cin >> n >> q;
	g.resize(n);
	vector<int> p(n);
	w.resize(n);
	for (int i = 1; i < n; i++) {
		int v;
		cin >> v;
		v--;
		p[i] = v;
		g[v].push_back(i);
	}
	vector<int> s(n);
	for (int i = 0; i < n; i++) { cin >> s[i]; s[i] = -s[i]; }
	set<pair<int, int>> s1;
	s1.insert({ s[0], 0 });
	//vector<int> dp(n);
	dp.resize(n);
	int curr = 0;
	while (!s1.empty()) {
		int v = s1.begin()->second;
		dp[v] = curr;
		curr++;
		s1.erase(s1.begin());
		for (auto to : g[v]) {
			s1.insert({ s[to], to });
		}
	}
	vector<int> CC = dfs(0);
	while (q--) {
		int va;
		cin >> va;
		va--;
		int st = dp[va];
		vector<int> b;
		long long max1 = 0;
		while (va != 0) {
			int prv = va;
			va = p[va];
			for (auto to : g[va]) {
				if (to == prv) continue;
				if (dp[to] < st) {
					max1 = max(max1, MM(w[to], st));
				}
			}
		}
		cout << st - max1 << ' ';
	}
}