#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pp = pair<int, int>;
using ld = long double;

template <typename T>
istream &operator>>(istream &s, vector<T> &a)
{
    for (T &el : a)
    {
        s >> el;
    }
    return s;
}

template <typename T>
ostream &operator<<(ostream &s, vector<T> &a)
{
    for (T el : a)
    {
        s << el << ' ';
    }
    s << '\n';
    return s;
}

void solve()
{
    int n, q;
    cin >> n >> q;
    vector<int> p(n, -1), s(n), pos(n);
    vector<vector<int>> graph(n);
    for (int i = 1; i < n; i++)
    {
        cin >> p[i];
        p[i]--;
        graph[p[i]].push_back(i);
    }
    cin >> s;
    vector<int> order;
    set<pp> choice;
    choice.emplace(s[0], 0);
    while (!choice.empty())
    {
        int v = prev(choice.end())->second;
        choice.erase(prev(choice.end()));
        order.push_back(v);
        for (int to : graph[v])
        {
            choice.emplace(s[to], to);
        }
    }
    //cout << order;
    for (int i = 0; i < n; i++)
    {
        pos[order[i]] = i;
    }
    while (q--)
    {
        int v;
        cin >> v;
        v--;
        vector<int> cnt(n);
        vector<bool> is_anc(n, false);
        for (int nd = v; nd != -1; nd = p[nd])
        {
            is_anc[nd] = true;
        }
        for (int i = pos[v]; i >= 0; i--)
        {
            int nd = order[i];
            if (is_anc[nd])
            {
                continue;
            }
            cnt[nd]++;
            for (int to : graph[nd])
            {
                cnt[nd] += cnt[to];
            }
        }
        cout << pos[v] - *max_element(cnt.begin(), cnt.end()) << ' ';
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
}