#include <bits/stdc++.h>
// #pragma GCC optimize("O3")
// #pragma GCC target("avx2")
#define LOCAL

// std::mt19937 rnd(time(0));

void solve();

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);

    #ifdef LOCAL
        std::freopen("input.txt", "r", stdin);
        std::freopen("output.txt", "w", stdout);
    #endif

    solve();

    return 0;
}

std::vector <std::vector <int>> edges;
std::vector <int> parents;
std::vector <int> s;

std::map <int, int> quest;
std::vector <int> res;
std::vector <int> weight;

class V {
 public:
    int id;
    int val;

    bool operator < (const V& other) const {
        return val < other.val;
    }
};

void solve() {
    int n, q;
    std::cin >> n >> q;

    parents.resize(n, -1);

    edges.resize(n);
    for (int i = 1; i < n; ++i) {
        int p;
        std::cin >> p;

        --p;

        edges[i].push_back(p);
        edges[p].push_back(i);

        parents[i] = p;
    }

    s.resize(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> s[i];
    }

    for (int i = 0; i < q; ++i) {
        int u;
        std::cin >> u;

        --u;

        quest[u] = i;
        res.push_back(0);
    }

    std::priority_queue <V> inProcess;
    inProcess.push({0, s[0]});

    res.resize(q);
    weight.resize(n, 0);

    std::vector <std::multiset <int>> children(n);

    std::multiset <int> heights;
    heights.insert(0);

    std::vector <int> height(n, 0);

    int curSize = 0;

    while (!inProcess.empty()) {
        V top = inProcess.top();
        inProcess.pop();

        if (height[top.id] > 1) {
            heights.erase(heights.find(height[top.id] - 1));
        }
        heights.insert(height[top.id]);

        if (quest.find(top.id) != quest.end()) {
            auto it = --heights.end();
            if (it == heights.begin()) {
                res[quest[top.id]] = curSize;
            } else {
                if (height[top.id] == *it) --it;
                res[quest[top.id]] = curSize - *it;
            }
        }


        for (auto nextV : edges[top.id]) {
            if (nextV == parents[top.id]) continue;

            height[nextV] = height[top.id] + 1;
            inProcess.push({nextV, s[nextV]});
        }

        ++curSize;
    }

    for (auto i : res) {
        std::cout << i << ' ';
    }
}
