#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#define ll long long
#define len(x) (int)x.size()
#define ld long double
#define all(x) x.begin(), x.end()
const ll mod1 = 1e9 + 7;

using namespace std;

void print(vector<int>& a) {
	for (auto x : a) {
		cout << x << ' ';
	}
	cout << '\n';
}

void print(vector<ll>& a) {
	for (auto x : a) {
		cout << x << ' ';
	}
	cout << '\n';
}

void print(vector<char>& a) {
	for (auto x : a) {
		cout << x << ' ';
	}
	cout << '\n';
}

void print(vector<string>& a) {
	for (auto x : a) {
		cout << x << ' ';
	}
	cout << '\n';
}

void print(vector<pair<int, int>>& a) {
	for (auto x : a) {
		cout << x.first << ' ' << x.second << '\n';
	}
}

void print(vector<vector<int>>& a) {
	for (auto x : a) {
		print(x);
	}
}

void print(vector<vector<ll>>& a) {
	for (auto x : a) {
		print(x);
	}
}

struct tree {

	int n;
	vector<int> add;
	vector<int> t;

	tree() {

	}

	tree(int n_) {
		n = n_;
		add.resize(4 * n);
		t.resize(4 * n);
	}

	void push(int v) {
		t[2 * v + 1] += add[v];
		t[2 * v + 2] += add[v];
		add[2 * v + 1] += add[v];
		add[2 * v + 2] += add[v];
		add[v] = 0;
	}

	void upd(int v, int vl, int vr, int ql, int qr, int x) {
		if (qr <= vl || vr <= ql) return;
		if (ql <= vl && vr <= qr) {
			add[v] += x;
			t[v] += x;
			return;
		}
		push(v);
		int mid = (vl + vr) / 2;
		upd(2 * v + 1, vl, mid, ql, qr, x);
		upd(2 * v + 2, mid, vr, ql, qr, x);
		t[v] = max(t[2 * v + 1], t[2 * v + 2]);
	}

	void upd(int l, int r, int x) {
		upd(0, 0, n, l, r, x);
	}

	int get(int v, int vl, int vr, int ql, int qr) {
		if (qr <= vl || vr <= ql) return 0;
		if (ql <= vl && vr <= qr) return t[v];
		push(v);
		int mid = (vl + vr) / 2;
		return max(get(2 * v + 1, vl, mid, ql, qr), get(2 * v + 2, mid, vr, ql, qr));
	}

	int get(int l, int r) {
		if (l >= r) return 0;
		return get(0, 0, n, l, r);
	}

};

//#define int ll
//#define mtask

tree t;
vector<vector<int>> g;
vector<int> s;
vector<int> sz;
vector<int> hldp;
vector<int> p;
vector<int> tin;
int tim = 0;

void gett(int cur) {
	sz[cur] = 1;
	for (auto x : g[cur]) {
		gett(x);
		sz[cur] += sz[x];
	}

	auto cmp = [&](int i, int j) {
		return sz[i] > sz[j];
	};

	sort(all(g[cur]), cmp);

}

void buildhld(int cur, int prst) {
	tin[cur] = tim++;
	hldp[cur] = prst;
	if (len(g[cur])) buildhld(g[cur][0], prst);
	for (int i = 1; i < len(g[cur]); ++i) {
		buildhld(g[cur][i], g[cur][i]);
	}
}

void add(int u) {
	while (u != -1) {
		t.upd(tin[hldp[u]], tin[u] + 1, 1);
		u = p[hldp[u]];
	}
}

int get(int u) {
	int ans = 0;
	int pref = len(g);
	while (u != -1) {
		ans = max(ans, t.get(tin[u] + 1, pref));
		pref = tin[hldp[u]];
		u = p[hldp[u]];
	}
	return ans;
}

void solve() {
	int n, q;
	cin >> n >> q;
	g.resize(n);
	s.resize(n);
	p.resize(n, -1);
	sz.resize(n);
	tin.resize(n);
	hldp.resize(n);
	for (int i = 1; i < n; ++i) {
		cin >> p[i];
		--p[i];
		g[p[i]].push_back(i);
	}
	for (int i = 0; i < n; ++i) {
		cin >> s[i];
	}
	gett(0);
	buildhld(0, 0);
	t = tree(n);
	set<pair<int, int>> que;
	que.insert({ s[0], 0 });
	vector<int> ans(n);
	for (int i = 0; i < n; ++i) {
		auto cur = que.rbegin()->second;
		que.erase(*que.rbegin());
		ans[cur] = t.get(0, 1) - get(cur);
		add(cur);

		for (auto x : g[cur]) {
			que.insert({ s[x], x });
		}
	}
	while (q--) {
		int x;
		cin >> x;
		cout << ans[x - 1] << ' ';
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef LOCAL
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#endif
#ifdef mtask
	int tt;
	cin >> tt;
	while (tt--)
#endif
		solve();
}