#include <bits/stdc++.h>

#ifndef  WILEYNE
#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3")
#pragma GCC target("avx2")
#endif

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
//using namespace __gnu_pbds;
using ordered_set = __gnu_pbds::tree<int, __gnu_pbds::null_type, std::less<int>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;


using ll = long long;
using ld = long double;

using namespace std;

const int MAX_N = (int) 3e5 + 100;
const double eps = acos(-1);
const int INT_INF = (int) 2e9 + 10;
const int MOD = (int) 1e9 + 7;
auto seet = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 rng(seet);
int n, q;
int deep[MAX_N];
vector<int> graph[MAX_N];
int s[MAX_N];
int tin[MAX_N];
int tout[MAX_N];
int par[MAX_N];
vector<int>res;
vector<int>euler;
int timer;
void dfs(int v){
    tin[v] = (int)euler.size();
    euler.push_back(res[v]);
    for(auto c:graph[v]){
        dfs(c);
    }
    tout[v] = (int)euler.size();
}

vector<int> calc_del(int v) {
    int mem = s[v];
    s[v] = 0;
    vector<int> res(n + 1, -1);
    set<pair<int, int>> cur_per;
    for (auto c: graph[1]) {
        cur_per.insert({s[c], c});
    }
    int cur_root = 1;
    for (int i = 0; i < n; ++i) {
        res[cur_root] = i;
        if (i == n - 1) {
            break;
        }
        auto it = cur_per.end();
        --it;
        cur_root = it->second;
        cur_per.erase(it);

        for (auto c: graph[cur_root]) {
            cur_per.insert({s[c], c});
        }
    }
    s[v] = mem;
    return res;
}

bool cmp(int a, int b){
    return deep[a]<deep[b];
}

vector<int>tree[4*MAX_N];
void build(int v, int l, int r){
    if(l+1==r){
        tree[v].push_back(euler[l]);
        return;
    }
    int mid = (l+r)>>1;
    build(v*2+1,l,mid);
    build(v*2+2,mid,r);
    tree[v].resize(r-l);
    merge(tree[v*2+1].begin(),tree[v*2+1].end(),tree[v*2+2].begin(),tree[v*2+2].end(),tree[v].begin());
}

int get(int v, int l, int r, int lq, int rq, int k){
    if(l>=lq && r<=rq){
        return upper_bound(tree[v].begin(),tree[v].end(),k) - tree[v].begin();
    }
    if(l>=rq || r<=lq){
        return 0;
    }
    int mid = (l+r)>>1;
    return get(v*2+1,l,mid,lq,rq,k)+ get(v*2+2,mid,r,lq,rq,k);
}

int calc(int v){
    int k = res[v];
    int rs = 0;
    while(v!=1){
        for(auto c:graph[v]){
            int l = tin[c];
            int r= tout[c];
            rs = max(rs,get(0,0,n,l,r,k));
        }
        v = par[v];
    }
    return k-rs;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef WILEYNE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin >> n >> q;
    for (int i = 2; i <= n; ++i) {
        int p;
        cin >> p;
        graph[p].push_back(i);
        par[i]= p;
    }
    for (int i = 0; i < n; ++i) cin >> s[i + 1];
    res = calc_del(0);
    dfs(1);
    build(0,0,n);
    while(q--){
        int v;
        cin>>v;
        cout<<calc(v)<<" ";
    }
    return 0;
}
