#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

struct segtree {
    ll n;
    vector<ll> t;

    segtree() {}

    segtree(vector<ll>& in) {
        n = in.size();
        t.resize(4 * n);
        build(0, 0, n - 1, in);
    }

    void build(ll v, ll tl, ll tr, vector<ll>& in) {
        if (tl == tr) {
            t[v] = in[tl];
            return;
        }
        ll tm = (tl + tr) / 2;
        build(2 * v + 1, tl, tm, in);
        build(2 * v + 2, tm + 1, tr, in);
        t[v] = t[2 * v + 1] + t[2 * v + 2];
    }

    ll get(ll v, ll tl, ll tr, ll l, ll r) {
        if (l <= tl && tr <= r) {
            return t[v];
        }
        if (tr < l || r < tl) {
            return 0;
        }
        ll tm = (tl + tr) / 2;
        return get(2 * v + 1, tl, tm, l, r) + get(2 * v + 2, tm + 1, tr, l, r);
    }

    void upd(ll val, ll idx, ll v, ll tl, ll tr) {
        if (tl == idx && idx == tr) {
            t[v] = val;
            return;
        }
        if (tr < idx || idx < tl) {
            return;
        }
        ll tm = (tl + tr) / 2;
        upd(val, idx, 2 * v + 1, tl, tm);
        upd(val, idx, 2 * v + 2, tm + 1, tr);
        t[v] = t[2 * v + 1] + t[2 * v + 2];
    }

    ll get(ll l, ll r) {
        return get(0, 0, n - 1, l, r);
    }

    void upd(ll val, ll idx) {
        upd(val, idx, 0, 0, n - 1);
    }
};

// B
//ll m, n; cin >> m >> n;
//vector<ll> a(n + 1);
//for (int i = 0; i < n; i++) cin >> a[i];
//reverse(a.begin(),a.end());
//vector<vector<ll>> dp(n + 1, vector<ll> (m + 1, -INF));
//dp[0][0] = 0;
//for (int i = 0; i < n; i++) {
//for (int j = 0; j <= m; j++) {
//if (dp[i][j] == -INF) continue;
//if (j > 0) {
//dp[i + 1][j - 1] = max(dp[i + 1][j - 1], dp[i][j] - a[i + 1]);
//}
//if (j < m) {
//dp[i + 1][j + 1] = max(dp[i + 1][j + 1], dp[i][j] + a[i + 1]);
//}
//}
//}
//ll ans = -INF;
//for (int j = 0; j <= m; j++) {
//ans = max(ans, dp[n][j]);
//}
//cout << ans << '\n';

// C
//const ll INF = 1e18;
//const ll N = 3e5 + 5;
//
//vector<ll> g[N];
//ll par[N], s[N], die[N];
//
//ll sz[N], ans[N];
//
//void solve() {
//    ll n, q; cin >> n >> q;
//    for (int i = 1; i < n; i++) {
//        ll p; cin >> p; p--;
//        par[i] = p;
//        g[p].push_back(i);
//    }
//    for (int i = 0; i < n; i++) cin >> s[i];
//
//    set<pair<ll, ll>> cur;
//    cur.insert({s[0], 0});
//    vector<ll> ord;
//    while (!cur.empty()) {
//        auto v = (*cur.rbegin()).second;
//        cur.erase({s[v], v});
//        ord.push_back(v);
//        for (auto to : g[v]) {
//            cur.insert({s[to], to});
//        }
//    }
//    for (int i = 0; i < n; i++) {
//        die[ord[i]] = i;
//    }
//
//    multiset<ll> curSz;
//    vector<ll> ps;
//    for (int i = 0; i < n; i++) {
//        ll v = ord[i];
//
//        ll goV = v;
//        while (true) {
//            ps.push_back(goV);
//            if (sz[goV] != 0) {
//                curSz.erase(curSz.find(sz[goV]));
//            }
//            sz[goV]++;
//            curSz.insert(sz[goV]);
//            if (goV == 0) break;
//            goV = par[goV];
//        }
//        for (auto p : ps) {
//            curSz.erase(curSz.find(sz[p]));
//        }
//
//        ans[v] = i;
//        if (!curSz.empty()) {
//            ans[v] = i - *curSz.rbegin();
//        }
//
//        for (auto p : ps) {
//            curSz.insert(sz[p]);
//        }
//
//        ps.clear();
//    }
//
//    while (q--) {
//        ll v; cin >> v; v--;
//        cout << ans[v] << " ";
//    }
//    cout << '\n';
//
//
//}
//
//int main() {
//    ios_base::sync_with_stdio(false); cin.tie(0);
//
//    ll tst = 1;
//    while (tst--) {
//        solve();
//    }
//}

const ll INF = 1e18;
const ll N = 3e5 + 5;

vector<ll> g[N];
ll par[N], s[N], die[N];

ll sz[N], ans[N];

void solve() {
    ll n, q; cin >> n >> q;
    for (int i = 1; i < n; i++) {
        ll p; cin >> p; p--;
        par[i] = p;
        g[p].push_back(i);
    }
    for (int i = 0; i < n; i++) cin >> s[i];

    vector<ll> chef(n);
    for (int i = 1; i < n; i++) {
        if (par[i] == 0) {
            chef[i] = i;
        } else {
            chef[i] = chef[par[i]];
        }
    }

    set<pair<ll, ll>> cur;
    cur.insert({s[0], 0});
    vector<ll> ord;
    while (!cur.empty()) {
        auto v = (*cur.rbegin()).second;
        cur.erase({s[v], v});
        ord.push_back(v);
        for (auto to : g[v]) {
            cur.insert({s[to], to});
        }
    }
    for (int i = 0; i < n; i++) {
        die[ord[i]] = i;
    }

    set<pair<ll, ll>> curSz;
    for (int i = 1; i < n; i++) {
        ll v = ord[i];
        if (sz[chef[v]] != 0) {
            curSz.erase({sz[chef[v]], chef[v]});
        }
        sz[chef[v]]++;
        curSz.insert({sz[chef[v]], chef[v]});

        if (curSz.size() == 1) {
            ans[v] = i;
        } else {
            auto mx1 = *curSz.rbegin();
            auto it = curSz.end(); it--; it--;
            auto mx2 = *it;

            if (mx1.second == chef[v]) {
                ans[v] = i - mx2.first;
            } else {
                ans[v] = i - mx1.first;
            }
        }
    }
    while (q--) {
        ll v; cin >> v; v--;
        cout << ans[v] << " ";
    }
    cout << '\n';

}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);

    ll tst = 1;
    while (tst--) {
        solve();
    }
}