#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
// #include <bits/stdc++.h>

using namespace std;

mt19937 rng(chrono::steady_clock().now().time_since_epoch().count());

using ll = long long;
using ld = long double;

const int N = 3e5;
int s[N + 1];
int p[N + 1];
vector <int> sons[N + 1];
int dp[N + 1];

int dfs(int v, int x) {
    int res = (dp[v] < x);
    for (int u : sons[v]) {
        res += dfs(u, x);
    }
    return res;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q;
    cin >> n >> q;
    for (int i=1; i < n; ++i) {
        cin >> p[i + 1];
        sons[p[i + 1]].push_back(i + 1);
    }
    for (int i=1; i <= n; ++i) {
        cin >> s[i];
    }
    set <pair <int, int>> ord;
    ord.emplace(-s[1], 1);
    int day = 0;
    while (!ord.empty()) {
        int v = ord.begin() -> second;
        ord.erase(ord.begin());
        dp[v] = day++;
        for (int u : sons[v]) {
            ord.emplace(-s[u], u);
        }
    }
    while (q--) {
        int v;
        cin >> v;
        int x = dp[v];
        int maxi = 0;
        while (v > 1) {
            for (int bro : sons[p[v]]) if (bro != v) {
                maxi = max(maxi, dfs(bro, x));
            }
            v = p[v];
        }
        cout << x - maxi << "\n";
    }
    return 0;
}
