#include <iostream>
#include <unordered_map>
#include <unordered_set>
#include <set>
#include <vector>
#include <map>
#include <cmath>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

template<typename T>
istream& operator>>(istream& in, vector<T>& arr) {
    for (ll i = 0; i < (ll)arr.size(); ++i) {
        in >> arr[i];
    }
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, vector<T>& arr) {
    for (auto el : arr) {
        out << el;
    }
    return out;
}

vector<vector<ll>> g;
vector<bool> used;
vector<ll> dist, tin, tout;
ll t = 0;

void dfs(ll v) {
    tin[v] = ++t;
    used[v] = true;
    for (auto u : g[v]) {
        if (!used[u]) {
            dist[u] = dist[v] + 1;
            dfs(u);
        }
    }
    tout[v] = ++t;
}

bool isAnc(ll v, ll u) { // v - anc u
    return tin[v] <= tin[u] && tout[u] <= tout[v];
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    ll n, q;
    cin >> n >> q;
    g.resize(n);
    used.resize(n);
    tin.resize(n);
    tout.resize(n);
    dist.resize(n);
    for (ll i = 1; i < n; ++i) {
        ll v;
        cin >> v;
        g[--v].push_back(i);
        g[i].push_back(v);
    }
    vector<ll> arr(n);
    cin >> arr;
    dfs(0);
    while (q--) {
        ll v;
        cin >> v;
        --v;
        cout << dist[v] << '\n';
    }
}