#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <climits>
#include <cmath>
#include <iomanip>

using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<ll, ll>;

#define all(v) v.begin(), v.end()
#define len(v) (ll)v.size()

mt19937 rnd(525252);

const ll INF = 1e18, SZ = 1e6, MOD = 1e9 + 7;
const ld eps = 1e-8, pi = acosl(-1);

ll f(vector<vector<ll>>g, vector<ll>&s, ll u){
    ll cur_par = 0;
    ll ans = 0;
//    cout << cur_par << '\n';
    while (cur_par != u){
        pii best = {-1, -1};
        for (auto &v : g[cur_par]) best = max(best, {s[v], v});
        ll nw = best.second;
        for (auto &v : g[cur_par]) if (v != nw) g[nw].push_back(v);
        ans++;
        cur_par = nw;
    }
    return ans;
}

void solve() {
    ll n, q; cin >> n >> q;
    vector<vector<ll>>g(n);
    for (ll i = 1; i < n; ++i) {
        ll p; cin >> p;
        g[p - 1].push_back(i);
    }
    vector<ll>s(n);
    for (auto &i : s) cin >> i;
    while (q--){
        ll v; cin >> v;
        v--;
        ll best = INF;
        for (ll i = 0; i < n; ++i){
            if (i == v) continue;
            ll pr = s[i];
            s[i] = 0;
            best = min(best, f(g, s, v));
            s[i] = pr;
        }
        cout << best << ' ';
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cout.precision(20);
    ll t = 1;

//	freopen("in.txt", "r", stdin);
//	freopen("out.txt", "w", stdout);
//    cin >> t;

    while (t--) {
        solve();
        cout << '\n';
    }
}
