#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

vector<vector<int>> gr;
vector<int> s;

set<pair<int, int>> st;
vector<int> ord;
vector<int> pos;

void upd(int v) {
    pos[v] = ord.size();
    ord.push_back(v);
    st.erase({s[v], v});
    for (auto u : gr[v]) {
        st.insert({s[u], u});
    }
}

vector<int> col;

void dfs(int v, int c) {
    col[v] = c;
    for (auto u : gr[v]) {
        if (v == 0) {
            dfs(u, u);
        } else {
            dfs(u, c);
        }
    }
}

int main()
{
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);
    int n, q;
    cin >> n >> q;
    gr.resize(n);
    ord.reserve(n);
    vector<int> pr(n, -1);
    for (int i = 0; i < n - 1; i++) {
        int p;
        cin >> p;
        p--;
        gr[p].push_back(i + 1);
        pr[i + 1] = p;
    }
    s.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    pos.resize(n);
    st.insert({s[0], 0});
    for (int i = 0; i < n; i++) {
        auto [x, v] = *(st.rbegin());
        upd(v);
    }
    col.resize(n);
    dfs(0, -1);
    vector<int> ans(n);
    ans[ord[0]] = 0;
    multiset<int> mst;
    vector<int> szs(n, 0);
    for (int i = 0; i < n; i++) {
        mst.insert(0);
    }
    for (int i = 1; i < n; i++) {
        int sz = szs[col[ord[i]]];
        mst.erase(mst.find(sz));
        int x = 0;
        if (mst.size() != 0) {
            x = *(mst.rbegin());
        }
        ans[ord[i]] = i - x;
        szs[col[ord[i]]]++;
        mst.insert(sz + 1);
    }
    for (int i = 0; i < q; i++) {
        int x;
        cin >> x;
        cout << ans[x - 1] << " ";
    }
    return 0;
}