#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

vector<vector<int>> gr;
vector<int> s;

set<pair<int, int>> st;
vector<int> ord;
vector<int> pos;

void upd(int v) {
    pos[v] = ord.size();
    ord.push_back(v);
    st.erase({s[v], v});
    for (auto u : gr[v]) {
        st.insert({s[u], u});
    }
}

vector<int> szs;

void dfs(int v, int x) {
    if (pos[v] > x) {
        return;
    }
    szs[v] = 1;
    for (auto u : gr[v]) {
        dfs(u, x);
        szs[v] += szs[u];
    }
}

int main()
{
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);
    int n, q;
    cin >> n >> q;
    gr.resize(n);
    ord.reserve(n);
    vector<int> pr(n, -1);
    for (int i = 0; i < n - 1; i++) {
        int p;
        cin >> p;
        p--;
        gr[p].push_back(i + 1);
        pr[i + 1] = p;
    }
    s.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    pos.resize(n);
    st.insert({s[0], 0});
    for (int i = 0; i < n; i++) {
        auto [x, v] = *(st.rbegin());
        upd(v);
    }

    szs.resize(n);
    for (int i = 0; i < q; i++) {
        int x;
        cin >> x;
        x--;
        szs.assign(n, 0);
        dfs(0, pos[x]);
        int t = x;
        int mx = 0;
        while (pr[t] != -1) {
            for (auto u : gr[pr[t]]) {
                if (u != t) {
                    mx = max(mx, szs[u]);
                }
            }
            t = pr[t];
        }
        cout << szs[0] - mx - 1 << " ";
    }

    return 0;
}