#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define int ll

const int inf = 1e9 + 7;

int N = 300'001, n;
vector<int> p(N);
vector<int> s(N);
vector<vector<int>> g(N);
vector<int> ans(N, inf);
vector<int> add(N);
vector<int> head(N);
vector<int> sz(N);
vector<int> tin(N);
vector<int> tout(N);
int tcnt = 0;


void dfs(int v) {
    sz[v] = 1;
    for (auto u : g[v]) {
        dfs(u);
        sz[v] += sz[u];
    }
    sort(g[v].begin(), g[v].end(), [&](int a, int b) {
        return sz[a] > sz[b];
        });
}

void build(int v) {
    tin[v] = tcnt++;
    if (!head[v])
        head[v] = v;
    for (int i = 0; i < g[v].size(); i++) {
        if (i == 0)
            head[g[v][i]] = head[v];
        build(g[v][i]);
    }
    tout[v] = tcnt;
}

struct segtree {
    int n;
    vector<int> val;
    vector<int> op;
    vector<int> mx;

    segtree() {}
    segtree(int m) {
        n = m;
        val.resize(n * 4);
        op.resize(n * 4);
        mx.resize(n * 4);
    }

    void push(int v, int l, int r) {
        if (!op[v])
            return;
        val[v] += op[v];
        if (r - l != 1) {
            op[v * 2 + 1] += op[v];
            op[v * 2 + 2] += op[v];
        }
        op[v] = 0;
        upd(v, 1);
    }

    void upd(int v, bool flag = false) {
        mx[v] = max(mx[v], val[v]);
        val[v] = max(val[v * 2 + 1], val[v * 2 + 2]);
        if (flag) {
            val[v] = max(val[v], mx[v]);
        }
        mx[v] = max(mx[v], val[v]);
    }

    void add(int v, int l, int r, int ql, int qr, int x) {
        push(v, l, r);
        if (l >= qr || r <= ql)
            return;
        if (l >= ql && r <= qr) {
            op[v] += x;
            push(v, l, r);
            return;
        }
        add(v * 2 + 1, l, (l + r) / 2, ql, qr, x);
        add(v * 2 + 2, (l + r) / 2, r, ql, qr, x);
        upd(v, 1);
    }

    void add(int l, int r, int x) {
        add(0, 0, n, l, r, x);
    }

    void set0(int v, int l, int r, int ql, int qr) {
        push(v, l, r); 
        if (l >= qr || r <= ql)
            return;
        if (l >= ql && r <= qr) {
            val[v] = 0;
            return;
        }
        set0(v * 2 + 1, l, (l + r) / 2, ql, qr);
        set0(v * 2 + 2, (l + r) / 2, r, ql, qr);
        upd(v);
    }

    void set0(int l, int r) {
        set0(0, 0, n, l, r);
    }
};

segtree st;

void addto(int v, int x) {
    while (head[v] != 1) {
        st.add(tin[head[v]], tin[v] + 1, x);
        v = p[head[v]];
    }
    st.add(tin[1], tin[v] + 1, x);
}

void set0to(int v) {
    while (head[v] != 1) {
        st.set0(tin[head[v]], tin[v] + 1);
        v = p[head[v]];
    }
    st.set0(tin[1], tin[v] + 1);
}

void kek() {
    st = n;
    int day = 0;
    set<pair<int, int>> tmp;
    tmp.emplace(s[1], 1);
    multiset<int> added;
    while (!tmp.empty()) {
        auto [_, v] = *tmp.rbegin();
        tmp.erase(--tmp.end());
        addto(v, 1);
        set0to(v);
        ans[v] = day - st.val[0];
        if (!added.empty()) {
            ans[v] = day - *added.rbegin();
        }
        addto(v, 0);
        for (auto u : g[v]) {
            tmp.emplace(s[u], u);
        }
        day++;
    }
}

void solve() {
    int q;
    cin >> n >> q;
    p[1] = 1;
    for (int i = 2; i <= n; i++) {
        cin >> p[i];
        g[p[i]].push_back(i);
    }
    for (int i = 1; i <= n; i++) {
        cin >> s[i];
    }
    dfs(1);
    build(1);
    kek();
    for (int i = 0, v; i < q; i++) {
        cin >> v;
        cout << ans[v] << " ";
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    while (t--)
        solve();
}