// #pragma GCC optimize("Ofast")
// #pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>
// #include <ext/pb_ds/assoc_container.hpp>
// #pragma GCC target("avx2")

using namespace std;
// using namespace __gnu_pbds;

// #define int long long
// #define ordered_set tree<int, null_type, less<int>, tree_order_statistics_node_update, rb_tree_tag>

struct SegTree {
    int sz;
    vector<int> tr, ps;

    SegTree(int n) {
        sz = (1 << ((int)log2(n))) * 2;
        tr.resize(2 * sz);
        ps.resize(2 * sz);
    }

    void push(int v) {
        tr[v] += ps[v];
        if (2 * v + 2 < 2 * sz) {
            ps[2 * v + 1] += ps[v];
            ps[2 * v + 2] += ps[v];
        }
        ps[v] = 0;
    }

    void update(int v, int l, int r, int ql, int qr, int x) {
        push(v);
        if (l >= qr || r <= ql) return;
        if (l >= ql && r <= qr) {
            ps[v] += x;
            push(v);
            return;
        }
        int m = (l + r) / 2;
        update(2 * v + 1, l, m, ql, qr, x);
        update(2 * v + 2, m, r, ql, qr, x);
        tr[v] = max(tr[2 * v + 1], tr[2 * v + 2]);
    }

    void update(int l, int r, int x) {
        update(0, 0, sz, l, r, x);
    }

    int get(int v, int l, int r, int ql, int qr) {
        push(v);
        if (l >= qr || r <= ql) return 0;
        if (l >= ql && r <= qr) return tr[v];
        int m = (l + r) / 2;
        return max(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
    }

    int get(int l, int r) {
        return get(0, 0, sz, l, r);
    }
};

struct HLD {
    vector<int> uppest, ord, backord, p, sz;
    vector<vector<int>> gr;

    void dfs(int v) {
        backord[v] = ord.size();
        ord.push_back(v);
        if (gr[v].size() == 0) return;
        sort(gr[v].begin(), gr[v].end(), [&](int i, int j) {
            return sz[i] > sz[j];
        });
        uppest[gr[v][0]] = uppest[v];
        for (auto e : gr[v]) {
            dfs(e);
        }
    }

    HLD(vector<int> p) : p(p) {
        int n = p.size();
        gr.resize(n);
        for (int i = 1; i < n; ++i) gr[p[i]].push_back(i);
        uppest.resize(n);
        iota(uppest.begin(), uppest.end(), 0);
        backord.resize(n);
        sz.resize(n);
        for (int i = n - 1; i >= 0; --i) {
            sz[i]++;
            if (i > 0) sz[p[i]] += sz[i];
        }
        dfs(0);
    }
    
    vector<pair<int, int>> get(int v) {
        vector<pair<int, int>> ans;
        while (1) {
            if (uppest[v] == 0) {
                ans.push_back({0, backord[v] + 1});
                break;
            }
            ans.push_back({backord[uppest[v]], backord[v] + 1});
            v = p[uppest[v]];
        }
        // sort(ans.begin(), ans.end());
        reverse(ans.begin(), ans.end());
        return ans;
    }
};

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> p(n);
    for (int i = 1; i < n; ++i) cin >> p[i];
    for (auto &e : p) --e;
    vector<int> s(n);
    for (int i = 0; i < n; ++i) cin >> s[i];
    HLD lol(p);
    SegTree lol1(n + 1);
    vector<int> ans(n);
    set<pair<int, int>> cur;
    vector<vector<int>> gr(n);
    for (int i = 1; i < n; ++i) gr[p[i]].push_back(i);
    for (auto e : gr[0]) {
        cur.insert({s[e], e});
    }
    for (int t = 1; t < n; ++t) {
        pair<int, int> curkek = (*--cur.end());
        int v = curkek.second;
        // cout << t << ' ' << v << '\n';
        cur.erase(curkek);
        for (auto e : gr[v]) {
            cur.insert({s[e], e});
        }
        vector<pair<int, int>> segs = lol.get(v);
        segs.push_back({n, n});
        ans[v] = t;
        for (int i = 0; i < segs.size() - 1; ++i) {
            ans[v] = min(ans[v], t - lol1.get(segs[i].second, segs[i + 1].first));
            // cout << lol1.get(segs[i].second, segs[i + 1].first) << ' ' << segs[i].second << ' ' << segs[i + 1].first << '\n';
        }
        for (int i = 0; i < segs.size() - 1; ++i) {
            lol1.update(segs[i].first, segs[i].second, 1);
        }
    }

    for (int i = 0; i < q; ++i) {
        int x;
        cin >> x;
        cout << ans[x - 1] << ' ';
    }
}

signed main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    solve();
}