#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <random>
#include <deque>
#include <stack>
#include <cmath>
#include <iomanip>

using namespace std;
using ll = long long;
using ld = long double;
using str = string;

//mt19937 rnd(288);

const int INF = 1e9 + 239;
const int EPS = 1e-9;

void fastw() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
}

const int MAXN = 3e5 + 239;
vector<vector<int>> g(MAXN);
vector<int> p(MAXN);
vector<int> s(MAXN);

vector<bool> used(MAXN, false);

void dfs(int v, int k) {
	used[v] = true;
	for (int u : g[v]) {
		if (!used[u] && s[u] > k) {
			dfs(u, k);
		}
	}
}

vector<int> cnt(MAXN, 0);

void dfs_cnt(int v) {
	if (used[v]) {
		cnt[v] = 1;
		for (int u : g[v]) {
			dfs_cnt(u);
			cnt[v] += cnt[u];
		}
	}
}

void solve() {
	int n, q;
	cin >> n >> q;
	p[1] = 0;
	for (int i = 2; i <= n; i++) {
		cin >> p[i];
		g[p[i]].push_back(i);
	}
	for (int i = 1; i <= n; i++) {
		cin >> s[i];
	}
	while (q--) {
		int v;
		cin >> v;
		int v1 = v;
		int k = s[v1];
		v = p[v1];
		used[v1] = true;
		int son = -1;
		if (p[v1] == 1) {
			son = v1;
		}
		while (v != 0) {
			dfs(v, k);
			k = min(k, s[v]);
			if (p[v] == 1) {
				son = v;
			}
			v = p[v];
		}
		dfs_cnt(1);
		if (v1 == 1) {
			cout << 0;
		}
		else {
			int ans = cnt[1] - 2;
			for (int u : g[1]) {
				if (u != son) {
					ans = min(ans, cnt[1] - 1 - cnt[u]);
				}
			}
			cout << ans;
		}
		cout << ' ';
		for (int i = 1; i <= n; i++) {
			cnt[i] = 0;
			used[i] = false;
		}
	}
}

int main() {
	fastw();
	int tt = 1;
	//cin >> tt;
	while (tt--) {
		solve();
		cout << '\n';
	}
}