#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <bitset>
#include <unordered_map>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <random>

#define all(v) v.begin(), v.end()
#define len(v) (int)v.size()

//using namespace __gnu_pbds;
using namespace std;
using ll = long long;
using ld = long double;
//using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

vector<int> pr;
vector<vector<int>> g;
vector<int> s;
vector<int> dp;
vector<int> euler;
vector<int> tin;
vector<int> tout;
const int INF = 2e9;
int tcnt = 0;

struct Seg_tree
{
    vector<vector<int>> tree;
    vector<int> a;
    int n;
    Seg_tree() {}
    Seg_tree(vector<int> &b)
    {
        a = b;
        n = len(a);
        tree.resize(4 * n);
        build(0, 0, n);
    }
    vector<int> merg(vector<int> &a, vector<int> &b)
    {
        vector<int> c;
        int i1 = 0, i2 = 0;
        while (i1 < len(a) || i2 < len(b))
        {
            int c1 = INF;
            if (i1 < len(a))
            {
                c1 = a[i1];
            }
            int c2 = INF;
            if (i2 < len(b))
            {
                c2 = b[i2];
            }
            if (c1 <= c2)
            {
                c.push_back(c1);
                ++i1;
            } else
            {
                c.push_back(c2);
                ++i2;
            }
        }
        return c;
    }
    void build(int v, int l, int r)
    {
        if (r - l == 1)
        {
            tree[v] = {s[a[l]]};
            return;
        }
        int m = (l + r) / 2;
        build(2 * v + 1, l, m);
        build(2 * v + 2, m, r);
        tree[v] = merg(tree[2 * v + 1], tree[2 * v + 2]);
    }
    ll get_cnt(int v, int l, int r, int ql, int qr, int c)
    {
        if (l >= qr || r <= ql) return 0;
        if (l >= ql && r <= qr)
        {
            return tree[v].end() - upper_bound(all(tree[v]), c);
        }
        int m = (l + r) / 2;
        return get_cnt(2 * v + 1, l, m, ql, qr, c) + get_cnt(2 * v + 2, m, r, ql, qr, c);
    }
};

Seg_tree tree;

void dfseuler(int v)
{
    tin[v] = tcnt++;
    euler.push_back(v);
    for (int u : g[v])
    {
        dfseuler(u);
    }
    tout[v] = tcnt;
}

int dfs1(int v, int c)
{
    //return 0;
    //cout << v << ' ' << c << ' ' << tree.get_cnt(0, 0, len(euler), tin[v], tout[v], c) << '\n';
    //return tree.get_cnt(0, 0, len(euler), tin[v], tout[v], c);
    if (s[v] < c) return 0;
    int cnt = 1;
    for (int u : g[v])
    {
        cnt += dfs1(u, c);
    }
    return cnt;
}

void dfs(int v, int p)
{
    if (p != -1)
    {
        int lt = v;
        int cur = p;
        int sum = 0;
        int mx = 0;
        int len = 0;
        int mns = s[v];
        while (cur != -1)
        {
            ++len;
            for (int u : g[cur])
            {
                if (u == lt) continue;
                int add = dfs1(u, mns);
                sum += add;
                mx = max(mx, add);
            }
            mns = min(mns, s[cur]);
            lt = cur;
            cur = pr[cur];
        }
        dp[v] = sum - mx + len;
        //cout << v + 1 << ' ' << dp[v] << ' ' << sum << ' ' << mx << ' ' <<
    } else
    {
        dp[v] = 0;
    }
    for (int u : g[v])
    {
        dfs(u, v);
    }
}

int main()
{
    cin.tie(0)->sync_with_stdio(0);
    int n, q;
    cin >> n >> q;
    pr.resize(n);
    g.resize(n);
    s.resize(n);
    dp.resize(n);
    tin.resize(n);
    tout.resize(n);
    pr[0] = -1;
    for (int i = 1; i < n; ++i)
    {
        cin >> pr[i];
        --pr[i];
        g[pr[i]].push_back(i);
    }
    for (int i = 0; i < n; ++i)
    {
        cin >> s[i];
    }
    dfseuler(0);
    /*for (int x : euler) cout << x << ' ';
    cout << '\n';
    for (int i = 0; i < n; ++i)
    {

        cout << i << ' ' << tin[i] << ' ' << tout[i] << '\n';
    }*/
    tree = Seg_tree(euler);
    dfs(0, -1);
    for (int i = 0; i < q; ++i)
    {
        int v;
        cin >> v;
        --v;
        cout << dp[v] << ' ';
    }

    return 0;
}

