#ifndef LOCAL
  #pragma GCC optimize("Ofast,unroll-loops")
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#ifndef LOCAL
  #pragma GCC target("avx,avx2,fma")
#endif

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

constexpr int buffer_size = 1 << 20;
constexpr char my_flush = '@';

char read_char() {
  static char cache[buffer_size];
  static int pos = 0;
  static int sz = 0;
  if (pos == sz) {
    sz = fread(cache, 1, buffer_size, stdin);
    pos = 0;
  }
  if (pos == sz) {
    return EOF;
  }
  return cache[pos++];
}

void write_char(char c) {
  static char cache[buffer_size];
  static int pos = 0;
  if (pos == buffer_size || c == my_flush) {
    fwrite(cache, 1, pos, stdout);
    pos = 0;
  }
  if (c != my_flush) {
    cache[pos++] = c;
  }
}

template<typename T>
void write_num(T x) {
  char st[64];
  int pos = 0;
  if (x < 0) {
    write_char('-');
    x = -x;
  }
  do {
    st[pos++] = char('0' + x % 10);
    x /= 10;
  } while (x > 0);
  while (pos > 0) {
    write_char(st[--pos]);
  }
}

template<typename T>
T read_num() {
  bool sign = false;
  char c;
  T res = 0;
  for (;;) {
    c = read_char();
    if (c == '-') {
      sign = true;
    }
    if (!isdigit(c)) {
      break;
    }
    res = res * 10 + (c - '0');
  }
  return res;
}

string read_str() {
  string ans;
  char c;
  for (;;) {
    c = read_char();
    if (isalnum(c) || isgraph(c)) {
      ans.push_back(c);
    } else {
      break;
    }
  }
  return move(ans);
}

void print_str(const string& s) {
  for (auto c : s) {
    write_char(c);
  }
}

const int maxn = 3e5 + 1;

vector<int> g[maxn];
int p[maxn], tin[maxn], tout[maxn], s[maxn], ans[maxn], cnt[maxn];
int n, q;
int tt = 0;

void dfs(int u = 1) {
  tin[u] = tt++;
  for (int v : g[u]) {
    dfs(v);
  }
  tout[u] = tt;
}

bool is_par(int u, int v) {
  return tin[u] <= tin[v] && tout[v] <= tout[u];
}

void solve() {
  // cin >> n >> q;
  n = read_num<int>();
  q = read_num<int>();
  for (int i = 2; i <= n; ++i) {
    // cin >> p[i];
    p[i] = read_num<int>();
    g[p[i]].push_back(i);
  }
  for (int i = 1; i <= n; ++i) {
    // cin >> s[i];
    s[i] = read_num<int>();
  }
  dfs();
  vector<int> h;
  set<pair<int, int>, greater<>> val;
  val.emplace(s[1], 1);
  while (!val.empty()) {
    int u = val.begin()->second;
    h.push_back(u);
    val.erase(val.begin());
    for (int v : g[u]) {
      val.emplace(s[v], v);
    }
  }
  set<pair<int, int>, greater<>> mx;
  mx.emplace(0, 0);
  for (int i = 0; i < n; ++i) {
    for (int j = h[i]; j; j = p[j]) {
      mx.erase({cnt[j], j});
    }
    ans[h[i]] = i - mx.begin()->first;
    for (int j = h[i]; j; j = p[j]) {
      mx.insert({++cnt[j], j});
    }
  }
  for (int i = 0; i < q; ++i) {
    int u;
    // cin >> u;
    u = read_num<int>();
    // cout << ans[u] << ' ';
    write_num(ans[u]);
    write_char(' ');
  }
  // cout << '\n';
  write_char('\n');
}

signed main() {
  cin.tie(0)->sync_with_stdio(0);
  int t = 1;
  // cin >> t;
  for (int i = 0; i < t; ++i) {
    solve();
  }
  write_char(my_flush);
}