#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

#define len(x) (int)x.size()
#define all(x) x.begin(), x.end()
const ll INF = 1e18;
const int INFi = 1e9;

#ifndef LOCAL
const int N = 3e5 + 10;
#else
const int N = 5;
#endif

struct fen {
    int n;
    vector<vector<int>> t;

    fen() {}
    fen(int _n) {
        n = _n;
        t.resize(n+1);
    }

    void add(int i, int x) {
        ++i;
        while(i <= n) {
            t[i].push_back(x);
            i += i & -i;
        }
    }

    int get(int i, int x) {
        ++i;
        int res = 0;
        while(i > 0) {
            res += (upper_bound(all(t[i]), x) - t[i].begin());
            i -= i & -i;
        }
        return res;
    }
};

vector<int> g[N];
int st[N], s[N], tin[N], tout[N];

int tim = 0;
void dfs(int v) {
    tin[v] = tim++;
    for (int to: g[v]) {
        dfs(to);
    }
    tout[v] = tim++;
}

bool an(int v, int u) {
    return tin[v] <= tin[u] && tout[u] <= tout[v];
}

fen T;

int check_dfs(int v, int from) {
    if (!an(v, from)) {
        int cnt = T.get(tout[v], st[from]) - T.get(tin[v] - 1, st[from]);
        return cnt;
    }
    if (v == from) return 0;
    int ans = 0;
    for (int to: g[v]) {
        ans = max(ans, check_dfs(to, from));
    }
    return ans;
}

void solve() {
    int n, Q;
    cin >> n >> Q;
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        --p;
        g[p].push_back(i);
    }

    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }

    dfs(0);

    T = fen(3*n);

    priority_queue<pair<int,int>> q;
    q.emplace(s[0], 0);
    int tmp = 0;
    while(!q.empty()) {
        auto [val, v] = q.top();
        q.pop();
        T.add(tin[v], tmp);
        st[v] = tmp++;

        for (int to: g[v]) {
            q.emplace(s[to], to);
        }
    }

    for (int j = 0; j < Q; ++j) {
        int v;
        cin >> v;
        --v;
        if (!v) {
            cout << "0 ";
        } else {
            int ans = check_dfs(0, v);
            cout << st[v] - ans << ' ';
        }
    }

    cout << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt","w", stdout);
#endif

    int t = 1;
//    cin >> t;
    while(t--) {
        solve();
    }

    return 0;
}