#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define yes() cout << "YES\n"
#define no() cout << "NO\n"
using ll = long long;
using ld = long double;
using namespace std;
using namespace __gnu_pbds;

template<typename K>
using oset = tree<K, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

struct segTree {
    vector<int> t;
    int n;

    void build(int v, int l, int r, vector<int>& a) {
        if (r - l == 1) {
            t[v] = a[l];
            return;
        }

        int m = (l + r) / 2;

        build(2 * v, l, m, a);
        build(2 * v + 1, m, r, a);

        t[v] = t[2 * v] + t[2 * v + 1];
    }

    segTree(vector<int>& a) {
        n = a.size();
        t.resize(4 * n);

        build(1, 0, n, a);
    }

    int get(int v, int l, int r, int ql, int qr) {
        if (l >= qr || r <= ql) {
            return 0;
        }

        if (ql <= l && r <= qr) {
            return t[v];
        }

        int m = (l + r) / 2;

        return get(2 * v, l, m, ql, qr) + get(2 * v + 1, m, r, ql, qr);
    }

    int get(int ql, int qr) {
        return get(1, 0, n, ql, qr);
    }

    void upd(int v, int l, int r, int idx, int val) {
        if (r - l == 1) {
            t[v] = val;
            return;
        }

        int m = (l + r) / 2;

        if (idx < m) {
            upd(2 * v, l, m, idx, val);
        } else {
            upd(2 * v + 1, m, r, idx, val);
        }

        t[v] = t[2 * v] + t[2 * v + 1];
    }

    void upd(int idx, int val) {
        upd(1, 0, n, idx, val);
    }
};

vector<set<int>> g;
vector<int> sv;

void solve() {
    int n, q;
    cin >> n >> q;

    g.resize(n);
    sv.resize(n);

    for (int i = 2; i <= n; i++) {
        int u;
        cin >> u;

        u--;

        g[u].insert(i - 1);
        g[i - 1].insert(u);
    }

    for (int& i : sv) cin >> i;

    while (q--) {
        int v;
        cin >> v;

        v--;
        int mx = 1e18;

        for (auto& i : g[0]) {
            vector<int> sv1 = sv;
            sv1[i] = 0;

            vector<set<int>> g1 = g;
            int root = 0;
            int cnt = 0;

            while (root != v) {
                int idx = -1;
                for (auto& u : g1[root]) {
                    if (idx == -1 || sv1[idx] < sv1[u]) {
                        idx = u;
                    }
                }

                for (auto& u : g1[root]) {
                    if (idx == u) {
                        g1[u].erase(root);
                    } else {
                        g1[u].erase(root);
                        g1[u].insert(idx);
                        g1[idx].insert(u);
                    }
                }

                g1[root].clear();
                cnt++;
                root = idx;
            }

            mx = min(mx, cnt);
        }

        cout << mx << " ";
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }
}