#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <random>
#include <string>

using namespace std;
#define int long long
using ll = long long;
using ld = long double;

#define dbg(x) cerr << #x << ": " << x << "\n"

vector<vector<int>> g;
vector<int> s, dp, leader, height, used, par;
int cnt = 0;

void precalc(int v, int par = -1) {
	if (par != -1) {
		height[v] = height[par] + 1;
		if (par == 0) leader[v] = v;
		else leader[v] = leader[par];
	}
	dp[v] = s[v];
	for (int u : g[v]) {
		dp[u] = min(dp[u], dp[v]);
		precalc(u, v);
	}
}

void dfs(int v, int our) {
	cnt++;
	for (int u : g[v]) {
		if (s[u] > our) dfs(u, our);
	}
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	int n, q;
	cin >> n >> q;
	g.resize(n);
	s.resize(n);
	par.resize(n);
	par[0] = -1;
	for (int v = 1; v < n; v++) {
		int p;
		cin >> p;
		p--;
		g[p].push_back(v);
		par[v] = p;
	}
	for (int i = 0; i < n; i++) cin >> s[i];
	dp = vector<int> (n);
	leader = vector<int> (n);
	height = vector<int> (n);
	precalc(0);
	while (q--) {
		int v;
		cin >> v;
		v--;
		if (v == 0) {
			cout << "0 ";
			continue;
		}
		vector<int> path = { par[v] };
		while (path.back() != 0) {
			path.push_back(par[path.back()]);
		}
		int our = s[v];
		int biggest = 0;
		int sum = height[v];
		for (auto level : path) {
			for (int u : g[level]) {
				if (leader[v] == leader[u]) continue;
				if (s[u] > our) {
					cnt = 0;
					dfs(u, our);
					biggest = max(biggest, cnt);
					sum += cnt;
				}
			}
			our = min(our, s[level]);
			sum -= biggest;
		}
		cout << sum << ' ';
	}
}
