#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#pragma GCC optimize("Ofast, unroll-loops, fast-math, no-stack-protector, inline")
#pragma GCC target("avx2")

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using ull = unsigned long long;
#define int long long

const ll INF = 1e18 + 228;
const ll mod = 1e9 + 7;
const ld eps = 1e-8;

random_device rd;
mt19937 rnd(rd() + 228 + 57 - 179);

vector<vector<int>> g;
vector<int> s, tin, tout, w, eil, in, ogo, cmp;
int mx = 0;

void dfs(int v, int f) {
    tin[v] = eil.size();
    eil.push_back(v);
    cmp[v] = f;
    for (auto i : g[v]) {
        dfs(i, f);
    }
    tout[v] = eil.size();
}

struct seg_tree{
    vector<int> t;
    seg_tree(int n) {
        t.resize(4 * n);
    }
    void upd(int v, int l, int r, int pos, int x) {
        if (l + 1 == r) {
            t[v] += x;
            return;
        }
        int m = (l + r) / 2;
        if (pos < m) upd(v * 2, l, m, pos, x);
        else upd(v * 2 + 1, m, r, pos, x);
        t[v] = t[v * 2] + t[v * 2 + 1];
    }
    int get(int v, int l, int r, int L, int R) {
        if (L <= l && r <= R) return t[v];
        if (R <= l || r <= L) return 0;
        int m = (l + r) / 2;
        return get(v * 2, l, m, L, R) + get(v * 2 + 1, m, r, L, R);
    }
};

bool anc(int a, int b) {
    return tin[a] <= tin[b] && tout[b] <= tout[a];
}

void cnt_dfs(int v, int st) {
    in[v] = ogo[v];
    for (auto i : g[v]) {
        cnt_dfs(i, st);
        in[v] += in[i];
    }
    if (!anc(v, st)) mx = max(mx, in[v]);
}

void solve() {
    int n, q;
    cin >> n >> q;
    g.resize(n);
    s.resize(n);
    tin.resize(n);
    tout.resize(n);
    w.resize(n);
    in.resize(n);
    ogo.resize(n);
    cmp.resize(n);
    vector<int> p(n);
    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        --p[i];
        g[p[i]].push_back(i);
    }
    p[0] = -1;
    for (int i = 0; i < n; ++i) cin >> s[i];
    vector<int> pos(n);
    set<pair<int, int>> st;
    st.emplace(0, 0);
    for (int i = 0; i < n; ++i) {
        auto [lvl, v] = *st.begin();
        st.erase(st.begin());
        w[i] = v;
        pos[v] = i;
        for (auto j : g[v]) {
            st.emplace(-s[j], j);
        }
    }
    tin[0] = 0;
    tout[0] = n;
    eil.push_back(0);
    for (auto i : g[0]) dfs(i, i);

    vector<int> qq(q);
    vector<int> was(n);
    for (int i = 0; i < q; ++i) {
        cin >> qq[i];
        --qq[i];
        was[qq[i]] = 1;
    }
    vector<int> cnt(n, 0);
    set<pair<int, int>> zlp;

    vector<int> ans(n);
    //seg_tree t(n);
    for (int i = 0; i < n; ++i) {
        int cur_d = i;
        mx = 0;
        if (was[w[i]]) {
            if (zlp.size()) {
                auto [f1, v1] = *zlp.begin();
                if (v1 != cmp[w[i]]) {
                    mx = -f1;
                } else {
                    zlp.erase(zlp.begin());
                    if (zlp.size()) {
                        auto [f2, v2] = *zlp.begin();
                        mx = -f2;
                    }
                    zlp.emplace(f1, v1);
                }
            }
        }
        ans[w[i]] = cur_d - mx;
        zlp.erase({-cnt[cmp[w[i]]], cmp[w[i]]});
        ++cnt[cmp[w[i]]];
        zlp.emplace(-cnt[cmp[w[i]]], cmp[w[i]]);
    }
    for (int i = 0; i < q; ++i) {
        cout << ans[qq[i]] << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int tt = 1;
    //cin >> tt;
    while (tt--) solve();
    return 0;
}
