#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#ifndef DEBUG
//#pragma GCC optimize("O3")
//#pragma GCC target("avx2")
#endif

using namespace __gnu_pbds;

template<typename T>
using oset = tree<T, null_type, std::less<T>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using pll = std::pair<ll, ll>;
using ld = long double;
using i128 = __int128;

#define lv(v) v + 1
#define rv(v) v + 2 * (m - l)

std::mt19937 rnd(std::chrono::steady_clock::now().time_since_epoch().count());

struct ST {
    std::vector<ll> t, add;

    void resize(ll n) {
        t.resize(2 * n);
        add.resize(2 * n);
    }

    void apply(ll v, ll x) {
        t[v] += x;
        add[v] += x;
    }

    void push(ll v, ll l, ll r) {
        if (add[v] == 0) {
            return;
        }
        ll m = (l + r) / 2;
        apply(lv(v), add[v]);
        apply(rv(v), add[v]);
        add[v] = 0;
    }

    void upd(ll v, ll l, ll r, ll ql, ll qr, ll x) {
        if (l >= qr || ql >= r) {
            return;
        }
        if (ql <= l && r <= qr) {
            apply(v, x);
            return;
        }
        push(v, l, r);
        ll m = (l + r) / 2;
        upd(lv(v), l, m, ql, qr, x);
        upd(rv(v), m, r, ql, qr, x);
        t[v] = std::max(t[lv(v)], t[rv(v)]);
    }

    ll get() {
        return t[0];
    }
};

ST hl;

std::vector<ll> p, s;
std::vector<std::vector<ll>> G;
std::vector<ll> obh;
std::vector<ll> prr;
std::vector<ll> tin, tout, depth, sz, up;
ll timer = 0;

void bfs() {
    std::priority_queue<pll, std::vector<pll>> g;
    g.push({s[0], 0});
    while (!g.empty()) {
        auto [el, v] = g.top();
        g.pop();
        obh.push_back(v);
        for (auto u: G[v]) {
            g.push({s[u], u});
        }
    }
}

void dfs1(ll v, ll dep = 0) {
    depth[v] = dep;
    sz[v] = 1;
    for (int i = 0; i < G[v].size(); ++i) {
        ll u = G[v][i];
        dfs1(u, dep + 1);
        sz[v] += sz[u];
        if (sz[G[v][0]] < sz[G[v][i]]) {
            std::swap(G[v][i], G[v][0]);
        }
    }
}

void dfsHLD(ll v, ll u) {
    tin[v] = timer++;
    up[v] = u;
    if (G[v].size()) {
        dfsHLD(G[v][0], u);
    }
    for (int i = 1; i < G[v].size(); ++i) {
        dfsHLD(G[v][i], G[v][i]);
    }
    tout[v] = timer;
}

bool isAnc(ll v, ll u) {
    if (tin[v] <= tin[u] && tout[u] <= tout[v]) {
        return true;
    }
    return false;
} // v -> u

ll n;

ll getHLD() {
    return hl.get();
}

ll updHLD(ll v, ll x) {
    while (v != -1) {
        ll u = up[v];
        ll l = tin[v];
        ll r = tin[u];
        if (r < l) {
            std::swap(l, r);
        }
        hl.upd(0, 0, n, l, r + 1, x);
        v = p[u];
    }
}

void solve() {
    ll q;
    std::cin >> n >> q;
    hl.resize(n);
    p.resize(n, -1);
    s.resize(n);
    G.resize(n);
    tin.resize(n);
    tout.resize(n);
    depth.resize(n);
    sz.resize(n);
    up.resize(n);
    for (int i = 1; i < n; ++i) {
        std::cin >> p[i];
        --p[i];
        G[p[i]].push_back(i);
    }
    for (int i = 0; i < n; ++i) {
        std::cin >> s[i];
    }
    bfs();
    dfs1(0);
    dfsHLD(0, 0);
    std::vector<ll> ord(n);
    for (int i = 0; i < n; ++i) {
        ord[obh[i]] = i;
    }
    std::vector<ll> ans(n);
    for (int i = 0; i < n; ++i) {
        ll mx = 0;
        updHLD(obh[i], -1e9);
        mx = std::max(mx, getHLD());
        updHLD(obh[i], 1e9 + 1);
        ans[obh[i]] = i - mx;
    }
    for (int i = 0; i < q; ++i) {
        ll v;
        std::cin >> v;
        --v;
//        std::vector<ll> cnt(n);
//        ll mx = 0;
//        for (int j = 0; j < ord[v]; ++j) {
//            ll u = obh[j];
//            while (u != -1){
//                ++cnt[u];
//                u = p[u];
//            }
//        }
//        for (int j = 0; j < n; ++j) {
//            if (isAnc(j, v)){
//                cnt[j] -= 1e9;
//            }
//        }
//        mx = std::max(mx, *std::max_element(cnt.begin(), cnt.end()));
//        std::cout << ord[v] - mx <<' ';
        std::cout << ans[v] << ' ';
    }
}

int main() {
#ifdef DEBUG
    std::freopen("/home/olymp/CLionProjects/untitled/input.txt", "r", stdin);
#endif
    std::cin.tie(0)->std::ios::sync_with_stdio(0);
    int tt = 1;
//    std::cin >> tt;
    while (tt--) {
        solve();
    }
}
