#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct SegmentTree {
    vector<ll> tree;
    ll n;

    SegmentTree(ll n) : n(n) {
        tree.assign(4 * n, 0);
    }

    void update(ll v, ll l, ll r, ll ind, ll val) {
        if (ind < l || r <= ind) {
            return;
        }
        if (l == r - 1) {
            tree[v] += val;
            return;
        }
        ll m = (l + r) / 2;
        update(2 * v + 1, l, m, ind, val);
        update(2 * v + 2, m, r, ind, val);
        tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
    }

    void update(ll ind, ll val) {
        update(0, 0, n, ind, val);
    }

    ll get(ll v, ll l, ll r, ll ql, ll qr) {
        if (qr <= l || r <= ql) {
            return 0;
        }
        if (ql <= l && r <= qr) {
            return tree[v];
        }
        ll m = (l + r) / 2;
        return max(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
    }

    ll get(ll ql, ll qr) {
        if (ql == qr) {
            return 0;
        }
        return get(0, 0, n, ql, qr);
    }
};

vector<vector<ll>> g;
vector<ll> a;
vector<ll> pos;

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll n, q;
    cin >> n >> q;
    g.assign(n, {});
    vector<ll> p(n, -1);
    for (ll i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        g[p[i]].push_back(i);
    }
    a.assign(n, 0);
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
    }
    priority_queue<pair<ll, ll>, vector<pair<ll, ll>>> pq;
    pq.emplace(a[0], 0);
    vector<ll> gg;
    while (!pq.empty()) {
        ll v = pq.top().second;
        pq.pop();
        gg.push_back(v);
        for (auto &to: g[v]) {
            pq.emplace(a[to], to);
        }
    }
    pos.assign(n, 0);
    for (ll i = 0; i < n; i++) {
        pos[gg[i]] = i;
    }
    vector<ll> group(n, -1);
    ll c = 0;
    for (auto &to: g[0]) {
        group[to] = c++;
    }
    for (ll i = 1; i < n; i++) {
        if (group[i] == -1) {
            group[i] = group[p[i]];
        }
    }
    SegmentTree tree(c);
    vector<ll> ans(n);
    ans[0] = 0;
    for (ll i = 1; i < n; i++) {
        ll mx = max(tree.get(0, group[gg[i]]), tree.get(group[gg[i]] + 1, c));
        ans[gg[i]] = i - mx;
        tree.update(group[gg[i]], 1);
    }
    while (q--) {
        ll v;
        cin >> v;
        v--;
        cout << ans[v] << ' ';
    }
}
