#include <bits/stdc++.h>
using namespace std;

const int NMAX = 300000;
int n, q;

static int tout[NMAX+1];
static int headStack[NMAX+1];
static int nextStack[NMAX+1];
static int eulerArr[NMAX+1];
static int pntArr[NMAX+1];
static int bitArr[NMAX+2];
static int comp[NMAX+1];
static int posArr[NMAX+1];
static int invPos[NMAX+2];
static int tin[NMAX+1];
static int eulerTime = 0;
static int outResult[NMAX+1];
static int queryOrderIndex[NMAX+1];
static vector<int> children[NMAX+1];

struct FI {
    static const int BUFSIZE = 1<<20;
    int idx, size;
    char buf[BUFSIZE];
    FI(): idx(0), size(0) {}
    inline char read() {
        if(idx >= size) {
            size = fread(buf, 1, BUFSIZE, stdin);
            idx = 0;
            if(size == 0) return 0;
        }
        return buf[idx++];
    }
    template<typename T>
    bool readInt(T &out) {
        char c;
        T sign = 1;
        T num = 0;
        do {
            c = read();
            if(!c) return false;
        } while(c!='-' && (c<'0' || c>'9'));
        if(c=='-') {
            sign = -1;
            c = read();
        }
        for(; c>='0' && c<='9'; c = read()) {
            num = num*10 + (c - '0');
        }
        out = num * sign;
        return true;
    }
} In;


inline int bitSum(int i) {
    ++i;
    int s = 0;
    while(i > 0) {
        s += bitArr[i];
        i -= i & -i;
    }
    return s;
}

inline int bitRangeSum(int l, int r) {
    if(r < l) return 0;
    int res = bitSum(r);
    if(l > 0) res -= bitSum(l-1);
    return res;
}

inline void bitUpdate(int i, int val) {
    ++i;
    while(i <= n) {
        bitArr[i] += val;
        i += i & -i;
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    if(!In.readInt(n)) {
        return 0;
    }
    In.readInt(q);

    pntArr[1] = 0;
    for(int i = 2; i <= n; ++i) {
        In.readInt(pntArr[i]);
        children[pntArr[i]].push_back(i);
    }
    for(int i = 1; i <= n; ++i) {
        In.readInt(comp[i]);
    }
    vector<int> queries(q);
    for(int k = 0; k < q; ++k) {
        In.readInt(queries[k]);
    }

    struct NodeCmp {
        bool operator()(int a, int b) const {
            return comp[a] < comp[b];
        }
    };
    priority_queue<int, vector<int>, NodeCmp> pq;

    for(int c : children[1]) {
        pq.push(c);
    }

    int day = 1;
    posArr[1] = day++;
    while(!pq.empty()) {
        int u = pq.top();
        pq.pop();
        posArr[u] = day++;

        for(int c : children[u]) {
            pq.push(c);
        }
    }

    for(int i = 1; i <= n; ++i) {
        invPos[posArr[i]] = i;
    }

    int top = 0;
    headStack[top] = 1;
    nextStack[top] = 0;
    eulerTime = 0;
    while(top >= 0) {
        int node = headStack[top];
        int &childIndex = nextStack[top];
        if(childIndex == 0) {
            tin[node] = eulerTime;
            eulerArr[eulerTime++] = node;
        }
        if(childIndex < (int)children[node].size()) {

            int child = children[node][childIndex++];

            headStack[++top] = child;
            nextStack[top] = 0;
        } else {
            tout[node] = eulerTime - 1;
            top--;
        }
    }
    

    vector<pair<int,int>> sortedQueries;
    sortedQueries.reserve(q);
    for(int i = 0; i < q; ++i) {
        int v = queries[i];
        sortedQueries.emplace_back(posArr[v], i);
    }
    sort(sortedQueries.begin(), sortedQueries.end());


    int j = 1;
    for(auto &pr : sortedQueries) {
        int p = pr.first;
        int qi = pr.second;
        int x = queries[qi];

        while(j < p) {
            int u = invPos[j++];
            bitUpdate(tin[u], 1);
        }

        int bestCount = 0;
        int curr = x;

        while(curr != 1) {
            int P = pntArr[curr];

            for(int c : children[P]) {
                if(c == curr) continue;

                int cnt = bitRangeSum(tin[c], tout[c]);
                if(cnt > bestCount) {
                    bestCount = cnt;
                }
            }
            curr = P;
        }

        outResult[qi] = (posArr[x] - 1) - bestCount;
    }

    std::ostringstream out;
    for(int i = 0; i < q; ++i) {
        out << outResult[i];
        if(i < q-1) out << '\n';
    }
    cout << out.str();
    return 0;
}