#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>

#define out(x) std::cout << x << ' ';
#define oute(x) std::cout << x << '\n';
#define enter std::cout << '\n';
#define debout(x) std::cout << #x << x << '\n';
#define debvout(x) std::cout << #x << " : "; for (auto i: x) std::cout << x << ' '; std::cout << '\n';
#define all(x) x.begin(), x.end()
using ll = int;

ll N;

class Wise_Tree {
    std::vector<ll> tree, d;

    ll F(ll num1, ll num2) { return std::max(num1, num2); }

    void push(ll v) {
        tree[v * 2 + 1] += d[v], tree[v * 2 + 2] += d[v], d[v * 2 + 1] += d[v], d[v * 2 + 2] += d[v];
        d[v] = 0;
    }

public:
    void WT(const std::vector<ll>& a) {
        N = a.size(), tree.resize(N * 4), d.resize(N * 4);
    }

    void upd(ll x, ll ql, ll qr, ll v = 0, ll l = 0, ll r = N) {
        if (r <= ql || qr <= l) return;
        if (ql <= l && r <= qr) {
            tree[v] += x, d[v] += x;
            return;
        }
        push(v);
        upd(x, ql, qr, v * 2 + 1, l, (l + r) >> 1), upd(x, ql, qr, v * 2 + 2, (l + r) >> 1, r);
        tree[v] = F(tree[v * 2 + 1], tree[v * 2 + 2]);
    }

    ll get(ll ql, ll qr, ll v = 0, ll l = 0, ll r = N) {
        if (r <= ql || qr <= l) return -inf;
        if (ql <= l && r <= qr) return tree[v];
        push(v);
        get(ql, qr, v * 2 + 1, l, (l + r) >> 1), get(ql, qr, v * 2 + 2, (l + r) >> 1, r);
        tree[v] = F(tree[v * 2 + 1], tree[v * 2 + 2]);
    }
};

class HLD {
    void build1(const std::vector<std::vector<ll>> &gg, ll v = 0, ll pr = -1) {
        tin[v] = ord.size(), ord.push_back(v), pred[v] = pr;
        for (auto to : gg[v]) {
            if (to == pr) continue;
            g[v].push_back(to);
            build1(gg, to, v);
            sz[v] += sz[to];
        }
        sz[v]++;
        for (ll i = 1; i < g[v].size(); i++) {
            if (sz[g[v][i]] > sz[g[v][0]]) std::swap(g[v][i], g[v][0]);
        }
    }

    void build2(ll v = 0) {
        for (auto to : g[v]) {
            head[to] = (to == g[v][0] ? head[v] : to);
            build2(to);
        }
    }

    const ll inf = 1e9;
    std::vector<ll> sz, tin, head, pred, ord;
    std::vector<std::vector<ll>> g;
    Wise_Tree tree;

public:
    HLD(const std::vector<std::vector<ll>> &gg) {
        ll n = gg.size();
        sz.resize(n), tin.resize(n), head.resize(n), pred.resize(n), g.resize(n);
        build1(gg), build2();
        tree.WT(ord);
    }

    void upd(ll v, ll x) {
        while (head[v] != 0) {
            tree.upd(x, tin[head[v]], tin[v] + 1);
            v = pred[head[v]];
        }
        tree.upd(x, 0, tin[v] + 1);
    }

    ll get(ll v) {
        upd(v, -inf);
        ll ans = tree.get(0, N);
        upd(v, inf);
        return ans;
    }
};

std::vector<std::vector<ll>> g;

void s1nmeee() {
    ll n, q;
    std::cin >> n >> q;
    std::vector<ll> a(n);
    g.resize(n);
    for (ll i = 1, x; i < n; i++) {
        std::cin >> x;
        x--;
        g[x].push_back(i);
    }
    for (ll& i : a) std::cin >> i;
    std::vector<ll> z;
    std::set<std::pair<ll, ll>> st = { {a[0], 0}};
    std::vector<ll> inds(n);
    while (!st.empty()) {
        ll v = (*(--st.end())).second;
        st.erase(--st.end());
        inds[v] = z.size(), z.push_back(v);
        for (auto u : g[v]) st.emplace(a[u], u);
    }
    std::vector<ll> ans(q);
    std::vector<std::pair<ll, std::pair<ll, ll>>> que(q);
    for (ll i = 0; i < q; i++) {
        std::cin >> que[i].second.first;
        que[i].second.first--;
        que[i].second.second = i;
        que[i].first = inds[que[i].second.first];
    }
    std::sort(all(que));
    ll l = 0;
    HLD hld(g);
    for (ll i = 0; i < q; i++) {
        while (l <= que[i].first) {
            hld.upd(z[l], 1);
            l++;
        }
        ll p = hld.get(que[i].second.first);
        ans[que[i].second.second] = inds[que[i].second.first] - std::max(0ll, p);
    }
    for (auto i: ans) out(i)
}

signed main() {
    std::cin.tie(nullptr), std::ios::sync_with_stdio(false);
    ll TT = 1;
    // std::cin >> TT;
    while (TT--) {
        s1nmeee();
        std::cout << '\n';
    }
}