//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
template<class T> using ordered_set = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
//using ld = long double;

#define all(x) begin(x), end(x)
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

struct MST {
    vector<vector<ll>> t;
    vector<ll> a;
    ll n;

    void build(ll v, ll l, ll r) {
        if (r - l == 1) {
            t[v] = {a[l]};
            return;
        }
        ll m = (r + l) / 2;
        build(v * 2, l, m);
        build(v * 2 + 1, m, r);
        t[v].resize(t[v * 2].size() + t[v * 2 + 1].size());
        merge(all(t[v * 2]), all(t[v * 2 + 1]), t[v].begin());
    }

    ll get(ll v, ll l, ll r, ll L, ll R, ll x) {
        if (L <= l && r <= R) {
            ll l1 = -1, r1 = t[v].size();
            while (r1 - l1 > 1) {
                ll m = (r1 + l1) / 2;
                if (t[v][m] <= x) l1 = m;
                else r1 = m;
            }
            return t[v].size() - 1 - l1;
        }
        if (L >= r || l >= R) return 0;
        ll m = (r + l) / 2;
        return get(v * 2, l, m, L, R, x) + get(v * 2 + 1, m, r, L, R, x);
    }

    ll get(ll l, ll r, ll x) {
        return get(1, 0, n, l, r, x) / 2;
    }

    MST(vector<ll> &a_) {
        a = a_;
        n = a.size();
        t.resize(n * 4);
        build(1, 0, n);
    }
};

vector<ll> euler;
vector<pair<ll, ll>> gr;
vector<ll> coeff;

void dfs(ll v, ll h, ordered_set<ll> &krus, vector<vector<ll>> &g, vector<ll> &s, ll p = -1) {
    krus.insert(s[v]);
    coeff[v] = h - (krus.size() - krus.order_of_key(s[v]) - 1);
    gr[v].first = euler.size();
    euler.push_back(s[v]);
    for (auto &x: g[v]) if (p != x) dfs(x, h + 1, krus, g, s, p);
    krus.erase(s[v]);
    euler.push_back(s[v]);
    gr[v].second = euler.size();
}

void solve() {
    ll n, q;
    cin >> n >> q;
    coeff.resize(n);
    vector<ll> p(n);
    vector<vector<ll>> g(n);
    gr.resize(n);
    for (ll i = 0; i < n - 1; ++i) {
        ll x;
        cin >> x;
        --x;
        g[x].push_back(i + 1);
        p[i + 1] = x;
    }
    vector<ll> s(n);
    for (auto &x: s) cin >> x;
    ordered_set<ll> krus;
    dfs(0, 0, krus, g, s, -1);
    MST mst(euler);
    while (q--) {
        ll x;
        cin >> x;
        --x;
        cout << max(0ll, (n - s[x] - mst.get(gr[x].first, gr[x].second, s[x])) + coeff[x] - 1) << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ll t = 1;
//    cin >> t;
    while (t--) solve(), cout << '\n';
    return 0;
}
