#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define ld long double
#define F first
#define S second
mt19937 rnd1(chrono::high_resolution_clock::now().time_since_epoch().count());
mt19937 rnd(100);

vector<vector<ll>> g;
vector<ll> pred;

void dfs(ll u, ll pre) {
    pred[u] = pre;
    for (ll v: g[u])
        dfs(v, pre);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    ll n, q;
    cin >> n >> q;
    vector<bool> req(n);
    vector<ll> p(n), s(n), v(q), ans(n), cnt(n);
    pred.resize(n);
    g.resize(n);
    vector<pair<pair<ll, ll>, pair<ll, ll>>> sons(n, {{-1, -1},
                                                      {-1, -1}});
    for (int i = 1; i < n; ++i) {
        cin >> p[i], p[i]--;
        g[p[i]].emplace_back(i);
    }

    for (ll v: g[0])
        dfs(v, v);

    p[0] = -1;

    for (ll &i: s)
        cin >> i;

    for (ll &i: v)
        cin >> i, i--, req[i] = 1;

    ll now = 1;
    map<ll, ll> comp;
    for (ll v: g[0])
        comp[s[v]] = v;

    while (!comp.empty()) {
        auto pa = *prev(comp.end());
        if (req[pa.second])
            ans[pa.second] = now;

        comp.erase(pa.first);
        if (req[pa.second]) {
            ll pos = 0;
            ll last = pred[pa.second];
            if (sons[pos].first.second != last)
                ans[pa.second] = min(ans[pa.second], now - sons[pos].first.first);
            else
                ans[pa.second] = min(ans[pa.second], now - sons[pos].second.first);
        }

        ll pos = pred[pa.second];
        cnt[pos]++;
        if (pos != sons[p[pos]].first.second && pos != sons[p[pos]].second.second &&
            cnt[pos] > sons[p[pos]].second.first)
            sons[p[pos]].second = {cnt[pos] - 1, pos};

        if (sons[p[pos]].first.second == pos)
            sons[p[pos]].first.first++;
        else if (sons[p[pos]].second.second == pos) {
            sons[p[pos]].second.first++;
            if (sons[p[pos]].second.first > sons[p[pos]].first.first)
                swap(sons[p[pos]].first, sons[p[pos]].second);
        }

        for (ll v: g[pa.second])
            comp[s[v]] = v;

        now++;
    }

    for (ll i: v)
        cout << ans[i] << ' ';

    return 0;
}

/*
5 4
1 2 2 1
3 5 1 2 4
5 3 1 4

5 5
1 2 1 4
5 4 3 2 1
1 2 3 4 5

*/
/*
В идеале найти ответ для каждого.
Отменять будут только соседей прямого пути от текущей вершины до корня.

Для каждого можно действуя жадно найти то, когда текущий сотрудник станет директором.
Помимо этого нужно узнать размер максимального количества взятых сотрудников из поддерева не содержащего наш элемент.

Для каждой вершины есть набор лучших чем она сотрудников в отсортированном порядке, достижимых через аналогичных лучших сотрудников
 в поддереве.

Если рассматривать таких людей отдельно, получится правильное дерево, где начальник всегда более компетентен.
У вершин веса могут быть больше 1.

Сортим потомков по силе.
Идем ДФСом, поддерживая максимальное по размеру поддерево слева.

Осталось рассмотреть случаи когда мы удаляем какое-то из поддеревьев начиная с крутых людей.
Если мы делаем так, значит наш клиент - один из тех крутых людей.

А надо ли все разделять?

Идем по людям в правильном порядке.
Для каждой вершины поддерживаем сколько людей рассмотренных до этого момента мы убьем если заигнорим эту вершину.
Значение в вершине не меньше всех ее потомков.
Когда доходим до вершины, ее ответом будет максимум на дереве среди не ее предков.

Две операции.
Прибавление 1 от вершины до корня.
Максимум на дереве среди не предков.

Этот максимум будет среди прямых потомков предков.


*/
/*


*/
/*


*/
/*


*/