#ifdef _DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <iomanip>
#include <string>
#include <limits>
#include <stack>
#include <queue>
#include <deque>
#include <vector>
#include <numeric>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <chrono>
#include <random>
#include <assert.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ui = unsigned int;
using ld = long double;
using pii = pair<int, int>;
using pli = pair<long long, int>;
using pil = pair<int, long long>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

struct segtree {
	struct node {
		int cnt = 0;
		ll sum = 0;
	};

	vector<node> tree;
	vector<int> c;
	int sz;

	segtree() {}

	segtree(const vector<int> &_c) {
		c = _c;
		sz = c.size();
		tree.resize(4 * sz);
	}

	void pull(int v) {
		int l = 2 * v + 1, r = 2 * v + 2;
		tree[v].cnt = tree[l].cnt + tree[r].cnt;
		tree[v].sum = tree[l].sum + tree[r].sum;
	}

	void add(int i, int v, int tl, int tr) {
		if (tr - tl == 1) {
			tree[v].cnt++;
			tree[v].sum += c[tl];
			return;
		}
		int m = (tl + tr) / 2;
		if (i < m)
			add(i, 2 * v + 1, tl, m);
		else
			add(i, 2 * v + 2, m, tr);
		pull(v);
	}

	void add(int i) {
		add(i, 0, 0, sz);
	}

	ll kth(int k, int v, int tl, int tr) {
		if (tree[v].cnt == k)
			return tree[v].sum;
		if (tr - tl == 1)
			return 1ll * k * c[tl];
		int m = (tl + tr) / 2;
		if (tree[2 * v + 2].cnt >= k)
			return kth(k, 2 * v + 2, m, tr);
		return tree[2 * v + 2].sum + kth(k - tree[2 * v + 2].cnt, 2 * v + 1, tl, m);
	}

	ll kth(int k) {
		if (!k)
			return 0;
		return kth(k, 0, 0, sz);
	}
};

mt19937 rnd(1337);

inline void solve(int test_id) {
	int n, k;
	cin >> n >> k;
	vector<ll> a(n);
	vector<int> c(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		c[i] = a[i];
	}
	sort(all(c));
	c.resize(unique(all(c)) - c.begin());
	ll ans = 0;
	segtree st(c);
	for (int i = 0; i < n; i++) {
		a[i] = lower_bound(all(c), a[i]) - c.begin();
		if (i >= k - 1) {
			ll sum = c[a[i]] + st.kth(k - 1);
			ans = max(ans, sum + i + 1);
		}
		st.add(a[i]);
	}
	cout << ans << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("01.dat", "r", stdin);
#endif
	int tt = 1;
#ifdef _DEBUG
	cin >> tt;
#endif
	for (int test_id = 1; test_id <= tt; test_id++) {
#ifdef _DEBUG
		cout << "TESTCASE# " << test_id << '\n';
#endif
		solve(test_id);
	}
	return 0;
}
