#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

// #define int long long

template <typename T>
using ordered_set =
    tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int)((x).size()))

using ll = long long;
using ld = long double;

const ll INF = 1e9;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

struct S {
    int n;
    vector<int> a;
    vector<pair<int, int>> t;
    vector<int> pu;
    S() {}
    S(vector<int> a) : a(a), n(sz(a)), t(4 * n), pu(4 * n) {
        build(1, 0, n - 1);
    }
    void build(int node, int l, int r) {
        if (l == r) {
            t[node] = {a[l], l};
            return;
        }
        int m = (l + r) >> 1;
        build(2 * node, l, m);
        build(2 * node + 1, m + 1, r);
        t[node] = max(t[2 * node], t[2 * node + 1]);
    }
    void push(int node, int l, int r) {
        if (pu[node]) {
            t[node].first += pu[node];
            if (l != r) {
                pu[2 * node] += pu[node];
                pu[2 * node + 1] += pu[node];
            }
            pu[node] = 0;
        }
    }
    void upd(int node, int l, int r, int ql, int qr, int val) {
        push(node, l, r);
        if (max(ql, l) > min(r, qr))
            return;
        if (ql <= l && r <= qr) {
            pu[node] += val;
            push(node, l, r);
            return;
        }
        int m = (l + r) >> 1;
        upd(2 * node, l, m, ql, qr, val);
        upd(2 * node + 1, m + 1, r, ql, qr, val);
        t[node] = max(t[2 * node], t[2 * node + 1]);
    }
    void upd(int ql, int qr, int val) { upd(1, 0, n - 1, ql, qr, val); }
    void set(int node, int l, int r, int idx, pair<int, int> val) {
        push(node, l, r);
        if (l > idx || r < idx)
            return;
        if (l == r) {
            t[node] = val;
            return;
        }
        int m = (l + r) >> 1;
        set(2 * node, l, m, idx, val);
        set(2 * node + 1, m + 1, r, idx, val);
        t[node] = max(t[2 * node], t[2 * node + 1]);
    }
    void set(int idx, pair<int, int> val) { set(1, 0, n - 1, idx, val); }
    int getv(int node, int l, int r, int idx) {
        push(node, l, r);
        if (l == r) {
            return t[node].first;
        }
        int m = (l + r) >> 1;
        if (idx <= m)
            return getv(2 * node, l, m, idx);
        return getv(2 * node + 1, m + 1, r, idx);
    }
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n), b(n);
    // set<array<int, 3>> bst;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        b[i] = a[i];
        a[i] += i + 1;
        // bst.insert({a[i], 1, i});
    }
    vector<int> per(n);
    vector<int> who(n, -1);
    // vector<bool> used(n);
    S s(a);
    for (int i = 0; i < k; ++i) {
        auto [val, idx] = s.t[1];
        // used[idx] = true;
        s.set(idx, {-INF, -INF});
        if (who[idx] != -1) {
            per[who[idx]]--;
            who[idx] = idx;
            per[idx]++;
            // bst.erase({val, free, idx});
            continue;
        }
        // free=1
        int t;
        for (int j = idx; ~j && who[j] == -1; --j) {
            who[j] = idx;
            per[idx]++;
            // bst.erase({a[j], 1, j});
            t = j;
        }
        for (int j = t; j <= idx; ++j) {
            if (j != n - 1) {
                s.upd(j + 1, n - 1, -1);
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        if (per[i]) {
            ans += b[i] + per[i];
        }
    }
    cout << ans << '\n';
}

signed main() {
#ifdef LOCALEGOR
    freopen("INPUT.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
#endif
    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
}