// Created by rost on 06.03.25.

#include <bits/stdc++.h>

using ll = long long;
using ld = long double;
using namespace std;

const ll INF = (ll) 1e13;

const int MAX_N = 5e5;
int a[MAX_N + 1];

int n;

pair<ll, int> solve(ll penalty) {
    vector<pair<ll, int>> dp(n + 1);
    ll prefMax = 0;
    int cnt = 0;
    for (int i = 1; i <= n; ++i) {
        dp[i] = {a[i] + i - penalty + prefMax, cnt + 1};

        if (dp[i].first - i > prefMax ||
            (dp[i].first - i == prefMax && dp[i].second < cnt)) {
            prefMax = dp[i].first - i;
            cnt = dp[i].second;
        }
    }

    int resI = 0;
    for (int i = 1; i <= n; ++i) {
        if (dp[i].first > dp[resI].first ||
            (dp[i].first == dp[resI].first && dp[i].second < dp[resI].second))
            resI = i;

    }
    return dp[resI];
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("in.in", "r", stdin);
    freopen("out.out", "w", stdout);
#endif

    int k;
    cin >> n >> k;
    for (int i = 1; i <= n; ++i)
        cin >> a[i];

    vector<vector<ll>> dp(k + 1, vector<ll>(n + 1, -INF));
    for (int i = 1; i <= k; ++i) {
        ll prefMax = (i == 1 ? 0 : -INF);
        for (int j = 1; j <= n; ++j) {
            dp[i][j] = a[j] + j + prefMax;

            prefMax = max(prefMax, dp[i - 1][j] - j);
        }
    }

    ll res = 0;
    int sufMax = 0;
    for (int i = n; i > 0; --i) {
        if (a[i] + i >= sufMax) {
            res = max(res, dp[k][i]);
        }
        sufMax = max(sufMax, a[i] + i);
    }
    cout << res << '\n';

    /*ll l = 0, r = INF, lambda;
    while (r - l > 1) {
        lambda = l + (r - l) / 2;

        auto res = solve(lambda);

        if (res.second < k) {
            r = lambda;
        } else {
            l = lambda;
        }
    }
    auto res = solve(l);
    cout << res.first + l * k << '\n';*/
}
