#include "bits/extc++.h"

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

template<typename T>
istream &operator>>(istream &is, vector<T> &a);

template<typename T>
ostream &operator<<(ostream &os, vector<T> &a);


using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    ll n, k;
    cin >> n >> k;

    vector<ll> a(n);
    cin >> a;

    function<ll(vector<ll>, ll)> solve = [&](vector<ll> a, ll k){
        ll best = 0;
        for (ll mask = 0; mask < (1 << a.size()); ++mask) {
            vector<ll> na;
            ll sum = 0;
            ll cnt = 0;
            for (ll i = 0; i < a.size(); ++i) {
                if ((mask >> i) & 1) {
                    cnt++;
                    sum = max(sum, a[i] + cnt);
                } else {
                    na.push_back(a[i]);
                }
            }

            if (k > 1) best = max(best, sum + solve(na, k-1));
            if (k == 1) best = max(best, sum);
        }
        return best;
    };

    cout << solve(a,k) << "\n";
}

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &v: a) is >> v;
    return is;
}

template<typename T>
ostream &operator<<(ostream &os, vector<T> &a) {
    for (auto v: a) os << v << " ";
    return (os << "\n");
}
