#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <fstream>
#include <unordered_map>
#include <algorithm>
#include <queue>
using namespace std;

using ll = long long;

const int maxn = 5e5;
const ll inf = 1e16 + 239;

ll solve1(vector<ll>& a, int n) {
  int sz = a.size();
  vector<ll> b = a;
  sort(b.begin(), b.end());
  ll med = b[(sz + 1) / 2];

  vector<int> p(sz, 0);
  priority_queue<pair<ll, ll>, vector<pair<ll, ll>>, greater<pair<ll, ll>>> q;
  ll ans = 0;
  for (int i = sz - 1; i >= 0; i--) {
    if (q.empty()) {
      q.push({ a[i], -i });
      continue;
    }
    if (a[i] >= med) {
      q.push({ a[i], -i });
    }
    else {
      ans += +q.top().first - a[i];
      p[i] = -q.top().second;
      p[-q.top().second] = i;
      q.pop();
    }
  }
  q = {};
  for (int i = sz - 1; i >= 0; i--) {
    if (p[i] != -1) continue;
    if (q.empty()) {
      q.push({ a[i], -i });
      continue;
    }
    if (a[i] >= 0 && q.empty()) {
      break;
    }
    ans += -q.top().first + a[i];
    p[i] = -q.top().second;
    p[-q.top().second] = i;
    q.pop();
  }
  vector<ll> rem(0);
  for (int i = 0; i < sz; i++) {
    if (p[i] == -1) {
      rem.push_back(a[i]);
    }
  }
  if (rem.size() <= n) {
    for (ll x : rem) {
      ans += x;
    }
    return ans;
  }
  return ans + solve1(rem, n);

}


void next(vector<int>& a, int n) {
  for (int i = 0; i < a.size(); i++) {
    if (a[i] < n - 1) {
      a[i]++;
      return;
    } else {
      a[i] = 0;
    }
  }
}

void solve() {
  int n, k;
  cin >> n >> k;
  vector<ll> a(n);
  for (int i = 0; i < n; i++) {
    cin >> a[i];
  }
  ll w = 1;
  for (int i = 0; i < n; i++) {
    w *= k;
  }
  ll res = 0;
  vector<int> pos(n, 0);
  for (int _ = 0; _ < w; _++) {
    vector<ll> ans(k, 0);
    vector<ll> sz(k, 0);
    for (int i = 0; i < n; i++) {
      sz[pos[i]]++;
      ans[pos[i]] = max(ans[pos[i]], a[i] + sz[pos[i]]);
    }
    bool ok = true;
    ll sum = 0;
    for (int i = 0; i < k; i++) {
      sum += ans[i];
      if (ans[i] == 0) {
        ok = false;
      }
    }
    if (ok) {
      res = max(res, sum);
    }
    next(pos, k);
  }
  cout << res << '\n';
}

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  int t = 1;
  //cin >> t;
  while (t--) {
    solve();
  }
}
