#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <fstream>
#include <unordered_map>
#include <algorithm>
#include <queue>
using namespace std;

using ll = long long;

const int maxn = 5e5;
const int k = 456;
const ll inf = 1e16 + 239;

vector<ll> maxx(maxn, -inf);

vector<ll> sum(maxn, -inf);

vector<ll> maxdp(maxn, -inf);
vector<ll> c(maxn, inf);

vector<ll> maxi(maxn, 0);


void upd(int l, int r, ll x, vector<ll>& dp, vector<ll>& cnt) {
  int n = dp.size();
  if (l % k != 0) {
    int bl = l / k;
    int left = k * (l / k);
    sum[bl] = -inf;
    c[bl] = inf;
    for (int i = left; i < l; i++) {
      if (sum[bl] < maxx[bl] + dp[i] || (sum[bl] == maxx[bl] + dp[i] && c[bl] > cnt[i])) {
        sum[bl] = max(sum[bl], maxx[bl] + dp[i]);
        c[bl] = cnt[i];
      }
      maxi[i] = maxx[bl];
    }
    for (int i = l; i % k != 0 && i < n; i++) {
      if (sum[bl] < x + dp[i] || (sum[bl] == x + dp[i] && c[bl] > cnt[i])) {
        sum[bl] = max(sum[bl], x + dp[i]);
        c[bl] = cnt[i];
      }
      maxi[i] = x;
    }
    maxx[bl] = -1;
  }
  if (r % k != 1) {
    int bl = r / k;
    int left = k * (r / k);
    sum[bl] = -inf;
    for (int i = r; i < n && i % k != 0; i++) {
      if (sum[bl] < maxx[bl] + dp[i] || (sum[bl] == maxx[bl] + dp[i] && c[bl] > cnt[i])) {
        sum[bl] = max(sum[bl], maxx[bl] + dp[i]);
        c[bl] = cnt[i];
      }
      maxi[i] = maxx[bl];
    }
    for (int i = left; i < r; i++) {
      if (sum[bl] < x + dp[i] || (sum[bl] == x + dp[i] && c[bl] > cnt[i])) {
        sum[bl] = max(sum[bl], x + dp[i]);
        c[bl] = cnt[i];
      }
      maxi[i] = x;
    }
    maxx[bl] = -1;
  }
  int i = k * ((l + k - 1) / k);
  while (i < r) {
    if (i % k == 0 && i + k <= r) {
      maxx[i / k] = x;
      sum[i / k] = maxx[i / k] + maxdp[i / k];
      i += k;
    }
    else {
      break;
    }
  }
}


void pt(int i, vector<ll>& dp, vector<ll>& cnt) {
  int bl = i / k;
  ll add = maxi[i];
  if (maxx[bl] != -1) {
    add = maxx[bl];
  }
  if (sum[bl] < add + dp[i] || (sum[bl] == add + dp[i] && c[bl] > cnt[i])) {
    sum[bl] = add + dp[i];
    c[bl] = cnt[i];
  }
  maxdp[bl] = max(maxdp[bl], dp[i]);
}

pair<ll, ll> get(int l, int r, vector<ll>& dp, vector<ll>& cnt) {
  ll ans = -inf;
  ll count = -1;
  while (l < r) {
    if (l % k == 0 && l + k <= r) {
      if (ans < sum[l / k] || (ans == sum[l / k] && count > c[l / k])) {
        ans = max(ans, sum[l / k]);
        count = cnt[l / k];
      }
      l += k;
    } else {
      ll add = maxi[l];
      if (maxx[l / k] != -1) {
        add = maxx[l / k];
      }
      if (ans < add + dp[l] || (ans == add + dp[l] && cnt[l] < count)) {
        ans = max(ans, add + dp[l]);
        count = cnt[l];
      }
      l++;
    }
  }
  return { ans, count + 1 };
}


pair<ll, ll> solve1(int n, vector<ll>& a, ll pr) {
  vector<ll> dp(n + 1);
  vector<ll> cnt(n + 1, 0);
  dp[0] = 0;
  cnt[0] = 0;
  maxi[0] = 0;
  pt(0, dp, cnt);
  vector<pair<ll, ll>> mx(0);
  for (int i = 1; i <= n; i++) {
    while (mx.size() > 0 && mx.back().first <= a[i - 1] + i + 1) {
      mx.pop_back();
    }
    int left = 0;
    if (mx.size() > 0) {
      left = mx.back().second + 1;
    }
    mx.push_back({ a[i - 1] + i + 1, i - 1 });
    upd(left, i + 1, a[i - 1] + i + 1, dp, cnt);
    auto res = get(0, i, dp, cnt);
    cnt[i] = res.second;
    dp[i] = res.first - i - pr;
    pt(i, dp, cnt);
  }
  return { dp[n - 1], cnt[n - 1] };
}

void sanitize(int n) {
  for (int i = 0; i <= n / k; i++) {
    maxdp[i] = -inf;
    sum[i] = -inf;
    maxx[i] = -inf;
    c[i] = inf;
  }
  for (int i = 0; i < n; i++) {
    maxi[i] = -inf;
  }
}

void solve() {
  int n, kk;
  cin >> n >> kk;
  vector<ll> a(n);
  for (int i = 0; i < n; i++) {
    cin >> a[i];
  }
  ll l = -inf, r = inf;
  while (r - l > 1) {
    ll m = (r + l) / 2;
    auto res = solve1(n, a, m);
    if (res.second >= kk) {
      l = m;
    }
    else {
      r = m;
    }
    sanitize(n);
  }
  auto res = solve1(n, a, l);
  cout << res.first + l * kk + kk << '\n';
}

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  int t = 1;
  //cin >> t;
  while (t--) {
    solve();
  }
}
