#include <bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
using ll = long long;
using ull = unsigned long long;

//tree<int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update> st;
//gp_hash_table<int, int> a;

struct segtree {
    vector<int> tr;
    int n;
    segtree(int n) : n(n), tr(2 * n) {}
    void upd(int i, int x) {
        for (tr[i += n] = x; i >= 0; tr[i >>= 1] = max(tr[i], tr[i ^ 1]));
    }
    int get(int l, int r) {
        int ans = 0;
        for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
            if (l & 1)
                ans = max(ans, tr[l++]);
            if (~r & 1)
                ans = max(ans, tr[r--]);
        }
        return ans;
    }
};

struct fenwick {
    vector<int> t;
    int n;
    fenwick(int n) : n(n), t(n + 1) {}
    void upd(int i, int x) {
        for (++i; i <= n; i += i & -i) t[i] += x;
    }
    int get(int i) {
        int x = 0;
        for (++i; i > 0; i -= i & -i) x += t[i];
        return x;
    }
};

template<class T>
bool chmin(T &a, const T &b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<class T>
bool chmax(T &a, const T &b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

mt19937 rnd(1337);

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int &i : a)
        cin >> i;
    map<int, int> cnt;
    int sum = 0;
    vector<int> pr(n, -1);
    for (int i = 0; i < n; ++i) {
        ++cnt[a[i] + 1];
        sum += a[i] + 1;
        if (i >= k - 1) {
            sum -= cnt.begin()->first;
            --cnt[cnt.begin()->first];
            if (cnt.begin()->second == 0)
                cnt.erase(cnt.begin());
        }
        if (i + 1 >= k - 1)
            pr[i] = sum;
    }
    int ans = -1e18;
    for (int i = k - 1; i < n; ++i) {
        ans = max(ans, (i - 1 == -1 ? 0 : pr[i - 1]) + a[i] + (i - (k - 1)) + 1);
    }
    cout << ans;
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
    // cin >> t;
    while (t--) solve();
//    cerr << fixed << setprecision(10) << clock() * 1.0 / CLOCKS_PER_SEC << '\n';
}
