#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

struct segtree {
    ll n;
    vector<ll> t;

    segtree() {}

    segtree(vector<ll>& in) {
        n = in.size();
        t.resize(4 * n);
        build(0, 0, n - 1, in);
    }

    void build(ll v, ll tl, ll tr, vector<ll>& in) {
        if (tl == tr) {
            t[v] = in[tl];
            return;
        }
        ll tm = (tl + tr) / 2;
        build(2 * v + 1, tl, tm, in);
        build(2 * v + 2, tm + 1, tr, in);
        t[v] = t[2 * v + 1] + t[2 * v + 2];
    }

    ll get(ll v, ll tl, ll tr, ll l, ll r) {
        if (l <= tl && tr <= r) {
            return t[v];
        }
        if (tr < l || r < tl) {
            return 0;
        }
        ll tm = (tl + tr) / 2;
        return get(2 * v + 1, tl, tm, l, r) + get(2 * v + 2, tm + 1, tr, l, r);
    }

    void upd(ll val, ll idx, ll v, ll tl, ll tr) {
        if (tl == idx && idx == tr) {
            t[v] = val;
            return;
        }
        if (tr < idx || idx < tl) {
            return;
        }
        ll tm = (tl + tr) / 2;
        upd(val, idx, 2 * v + 1, tl, tm);
        upd(val, idx, 2 * v + 2, tm + 1, tr);
        t[v] = t[2 * v + 1] + t[2 * v + 2];
    }

    ll get(ll l, ll r) {
        return get(0, 0, n - 1, l, r);
    }

    void upd(ll val, ll idx) {
        upd(val, idx, 0, 0, n - 1);
    }
};

void solve() {
    ll n, k; cin >> n >> k;
    vector<ll> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    multiset<ll> cur;
    ll ans = 0;
    ll sum = 0;
    for (int i = 0; i < n; i++) {
        if (cur.size() == k - 1) {
            ans = max(ans, sum + a[i] + (i + 1));
        }

        cur.insert(a[i]);
        sum += a[i];
        if (cur.size() >= k) {
            sum -= *cur.begin();
            cur.erase(cur.begin());
        }
    }
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);

    solve();
}
