#ifndef LOCAL
#pragma GCC optimize("Ofast")
#endif

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define X first
#define Y second

template <typename T>
struct SparseTable {
    vector<vector<T>> t;

    SparseTable() { }

    T f(T x, T y)
    {
        return max(x, y);
    }

    SparseTable(vector<T>& a)
    {
        int n = a.size();
        int L = __lg(n);
        t.resize(L + 1, vector<T>(n));
        for (int i = 0; i < n; i++)
            t[0][i] = a[i];
        for (int l = 1; l <= L; l++)
            for (int i = 0; i <= (n - (1 << l)); i++)
                t[l][i] = f(t[l - 1][i], t[l - 1][i + (1 << (l - 1))]);
    }

    T get(int l, int r)
    {
        if (l == r)
            return INT64_MIN;
        if (r < l)
            swap(l, r);
        int k = __lg(r - l);
        return f(t[k][l], t[k][r - (1 << k)]);
    }
};

void solve()
{
    int n, k;
    cin >> n >> k;
    set<pair<ll, ll>, greater<>> st;
    vector<ll> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        st.insert({ a[i], i });
    }
    vector<ll> kmx(k - 1);
    for (int i = 0; i < k - 1; i++) {
        kmx[i] = st.begin()->Y;
        st.erase(st.begin());
    }
    sort(kmx.begin(), kmx.end());
    int cur = -1;
    if (k != 1)
        cur = 0;
    vector<ll> b;
    for (int i = 0; i < n; i++)
        if (cur == -1 || i != kmx[cur]) {
            b.push_back(a[i]);
        } else {
            cur++;
            if (cur >= k - 1)
                cur = -1;
        }
    for (int i = 0; i < b.size(); i++)
        b[i] += i;
    SparseTable sp(b);
    ll ans = 0;
    for (int i = k - 2; i >= 0; i--)
        ans += a[kmx[i]] + 1;
    ans += sp.get(0, b.size()) + 1;
    cout << ans << '\n';
}

signed main()
{
#ifdef LOCAL
    freopen("TEST", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int ttt = 1;
    // cin >> ttt;
    while (ttt--)
        solve();
}
