#ifndef LOCAL
#pragma GCC optimize("Ofast")
#endif

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define X first
#define Y second

template <typename T>
struct SparseTable {
    vector<vector<T>> t;

    SparseTable() { }

    T f(T x, T y)
    {
        return max(x, y);
    }

    SparseTable(vector<T>& a)
    {
        int n = a.size();
        int L = __lg(n);
        t.resize(L + 1, vector<T>(n));
        for (int i = 0; i < n; i++)
            t[0][i] = { a[i].X, -a[i].Y };
        for (int l = 1; l <= L; l++)
            for (int i = 0; i <= (n - (1 << l)); i++)
                t[l][i] = f(t[l - 1][i], t[l - 1][i + (1 << (l - 1))]);
    }

    T get(int l, int r)
    {
        if (l == r)
            return { INT64_MIN, INT64_MIN };
        if (r < l)
            swap(l, r);
        int k = __lg(r - l);
        auto res = f(t[k][l], t[k][r - (1 << k)]);
        return { res.X, -res.Y };
    }
};

template <typename T>
struct ST {
    size_t offset;
    bool mass;
    vector<T> t, lazy;
    T NEUTRAL;

    ST() { }

    T merge(T x, T y)
    {
        return max(x, y);
    }

    void init(size_t n, bool mss)
    {
        NEUTRAL = { INT64_MIN, INT64_MIN };
        mass = mss;
        offset = 1;
        while (offset < n)
            offset <<= 1;
        t.resize(offset << 1, NEUTRAL);
        if (mass)
            lazy.resize(offset << 1, NEUTRAL);
    }

    ST(size_t n, bool mss = false)
    {
        init(n, mss);
    }

    ST(vector<T>& a, bool mss = false)
    {
        int n = a.size();
        init(n, mss);
        for (int i = 0; i < n; i++)
            t[offset + i] = a[i];
        for (int i = offset - 1; i > 0; i--)
            t[i] = merge(t[i << 1], t[i << 1 | 1]);
    }

    T get(int l, int r)
    {
        T res = NEUTRAL;
        for (l += offset, r += offset; l < r; l >>= 1, r >>= 1) {
            if (l & 1)
                res = merge(res, t[l++]);
            if (r & 1)
                res = merge(res, t[--r]);
        }
        return res;
    }

    void upd(int i, T x)
    {
        t[i += offset] = x;
        for (i >>= 1; i > 0; i >>= 1)
            t[i] = merge(t[i << 1], t[i << 1 | 1]);
    }
};

void solve()
{
    int n, k;
    cin >> n >> k;
    set<pair<ll, ll>, greater<>> st;
    vector<ll> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        st.insert({ a[i], i });
    }
    vector<ll> kmx(k - 1);
    for (int i = 0; i < k - 1; i++) {
        kmx[i] = st.begin()->Y;
        st.erase(st.begin());
    }
    sort(kmx.begin(), kmx.end());
    int cur = -1;
    if (k != 1)
        cur = 0;
    vector<pair<ll, ll>> b;
    for (int i = 0; i < n; i++)
        b.push_back({ a[i], i });
    for (int i = 0; i < b.size(); i++)
        b[i].X += i;
    vector<pair<ll, ll>> c(n);
    for (int i = 0; i < n; i++)
        c[i] = { a[i], i };
    SparseTable rgh(b);
    ST lft(c);
    ll ans = 0;
    int r = 0;
    for (int i = 0; i < k; i++) {
        if (r == n) {
            pair<ll, ll> mx2 = lft.get(0, r);
            ans += mx2.X;
            lft.upd(mx2.Y, { INT64_MIN, INT64_MIN });
            continue;
        }
        pair<ll, ll> mx1 = rgh.get(r, n);
        mx1.X -= r;
        if (r == 0) {
            ans += a[mx1.Y];
            r = mx1.Y + 1;
            lft.upd(mx1.Y, { INT64_MIN, INT64_MIN });
        } else {
            pair<ll, ll> mx2 = lft.get(0, r);
            if (mx1 > mx2) {
                r = mx1.Y + 1;
                ans += a[mx1.Y];
                lft.upd(mx1.Y, { INT64_MIN, INT64_MIN });
            } else {
                ans += mx2.X;
                lft.upd(mx2.Y, { INT64_MIN, INT64_MIN });
            }
        }
    }
    cout << ans + r << '\n';
}

signed main()
{
#ifdef LOCAL
    freopen("TEST", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int ttt = 1;
    // cin >> ttt;
    while (ttt--)
        solve();
}
