
// #pragma GCC optmize("Ofast")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) (int)x.size()

typedef long long ll;
typedef long double ld;

template <typename T>
void sort(T &s) {
    sort(all(s));
}

const int inf = 2e9 + 2000;
const ll infll = 2e18 + 2000;
const int R = (1 << 20);
mt19937 rnd(26);

template <typename T>
struct point {
    T x, y;
    point(T x, T y) : x(x), y(y) {}
    point(point a, point b) : x(b.x - a.x), y(b.y - a.y) {}

    point operator + (point &o) const {
        return {x + o.x, y + o.y};
    }

    point operator * (const T k) const {
        return {x * k, y * k};
    }

    T operator * (const point &o) const {
        return x * o.x + y * o.y;
    }

    T operator % (const point &o) const {
        return x * o.y - y * o.x;
    }

    T len2() {
        return x * x + y * y;
    }

    ld len() {
        return sqrt(x * x + y * y);
    }
};



ll solve(int n, int k, vector<ll> &a) {
    vector<pair<ll, int> > pa;
    for (int i = 0; i < n; ++i) {
        pa.emplace_back(a[i], i);
    }
    sort(rall(pa));

    int le = -1;
    ll res = 0;
    for (int i = 0; i < k - 1; ++i) {
        res += pa[i].first;
        le = max(le, pa[i].second);
    }

    if (le == n - 1) {
        res += pa[k - 1].first;
        res += n;
    } else {
        ll p1 = pa[k - 1].first + le + 1;
        ll p2 = le + 1;
        ll ma = -inf;
        for (ll i = le + 1; i < n; ++i) {
            ma = max(ma, a[i] + i - le);
        }
        p2 += ma;
        res += max(p1, p2);
    }

    return res;
}


ll solve2(int n, int k, vector<ll> &a) {
    if (k == 2) {
        ll ans = 0;
        for (int mask = 1; mask < (1 << n) - 1; ++mask) {
            vector<int> a1, a2;
            for (int i = 0; i < n; ++i) {
                if ((mask & (1 << i))) {
                    a1.push_back(a[i]);
                } else {
                    a2.push_back(a[i]);
                }
            }

            ll res = 0;
            int ma = 0;
            for (int i = 0; i < a1.size(); ++i) {
                ma = max(ma, a1[i] + i + 1);
            }
            res += ma;
            ma = 0;
            for (int i = 0; i < a2.size(); ++i) {
                ma = max(ma, a2[i] + i + 1);
            }
            res += ma;
            ans = max(ans, res);
        }

        return ans;
    } else {
        return -1;
    }
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);

    // int n = 5, k = 2;
    // vector<ll> a = {5, 4, 5, 2, 2};
    // cout << solve(n, k, a);

    // while (true) {
    //     int n = 5;
    //     int k = 2;
    //     vector<ll> a(n);
    //     for (int i = 0; i < n; ++i) {
    //         a[i] = rnd() % 5 + 1;
    //     }
    //     auto r1 = solve(n, k, a);
    //     auto r2 = solve2(n, k, a);
    //     if (r1 != r2) {
    //         cout << r1 << ' ' << r2 << "\n";
    //         for (auto i : a) {
    //             cout << i << ' ';
    //         }
    //         break;
    //     }
    // }

    int n, k;
    cin >> n >> k;

    vector<ll> a(n);
    for (auto &i : a) {
        cin >> i;
    }

    cout << solve(n, k, a);
}
