#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <random>
#include <deque>
#include <stack>
#include <cmath>
#include <iomanip>

using namespace std;
using ll = long long;
using ld = long double;
using str = string;

//mt19937 rnd(288);

const int INF = 1e9 + 239;
const int EPS = 1e-9;

void fastw() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
}

void solve() {
	int n, k;
	cin >> n >> k;
	vector<ll> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	if (k == 1) {
		ll ans = 0;
		for (int i = 0; i < n; i++) {
			ans = max(ans, a[i] + i + 1);
		}
		cout << ans;
		return;
	}
	ll ans = 0;
	priority_queue<ll> q;
	ll now = 0;
	for (int i = 0; i < k - 1; i++) {
		now += a[i];
		q.push(-a[i]);
	}
	for (int i = k - 1; i < n; i++) {
		ans = max(ans, now + a[i] + i + 1);
		if (abs(q.top()) < a[i]) {
			now -= abs(q.top());
			now += a[i];
			q.pop();
			q.push(-a[i]);
		}
	}
	cout << ans;
}

int main() {
	fastw();
	int tt = 1;
	//cin >> tt;
	while (tt--) {
		solve();
		cout << '\n';
	}
}