#ifndef LOCAL
  #pragma GCC optimize("Ofast,unroll-loops")
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#ifndef LOCAL
  #pragma GCC target("avx,avx2,fma")
#endif

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

const int group_size = 710;

struct sqrt_dec {
  vector<ll> a, add, mx;

  sqrt_dec(const vector<ll>& b) {
    a = b;
    const int n = a.size();
    add.assign((n + group_size - 1) / group_size, 0);
    mx.assign((n + group_size - 1) / group_size, 0);
    for (int i = 0; i < n; ++i) {
      a[i] += i + 1;
      mx[i / group_size] = max(mx[i / group_size], a[i]);
    }
  }

  int group_begin(int g) {
    return g * group_size;
  }

  int group_end(int g) {
    return min((int)a.size(), group_begin(g + 1));
  }

  void calc(int g) {
    mx[g] = 0;
    for (int i = group_begin(g); i < group_end(g); ++i) mx[g] = max(mx[g], a[i] + add[g]);
  }

  void update(int l, int r, int v) {
    --r;
    const int lg = l / group_size;
    const int rg = r / group_size;
    if (lg == rg) {
      for (int i = l; i <= r; ++i) a[i] += v;
      calc(lg);
    } else {
      for (int i = l; i < group_end(lg); ++i) a[i] += v;
      calc(lg);
      for (int g = lg + 1; g < rg; ++g) {
        add[g] += v;
        mx[g] += v;
      }
      for (int i = group_begin(rg); i <= r; ++i) a[i] += v;
      calc(rg);
    }
  }

  ll get(int l, int r) {
    --r;
    const int lg = l / group_size;
    const int rg = r / group_size;
    ll ans = 0;
    if (lg == rg) {
      for (int i = l; i <= r; ++i) ans = max(ans, a[i] + add[lg]);
    } else {
      for (int i = l; i < group_end(lg); ++i) ans = max(ans, a[i] + add[lg]);
      for (int g = lg + 1; g < rg; ++g) ans = max(ans, mx[g]);
      for (int i = group_begin(rg); i <= r; ++i) ans = max(ans, a[i] + add[rg]);
    }
    return ans;
  }
};

void solve() {
  int n, k;
  cin >> n >> k;
  vector<ll> a(n);
  for (auto& it : a) cin >> it;
  sqrt_dec sd(a);
  ll ans = 0;
  for (int i = 0; i < n - 1; ++i) {
    sd.update(i + 1, n, -1);
    ans = max(ans, a[i] + i + 1 + sd.get(i + 1, n));
  }
  cout << ans << '\n';
}

signed main() {
  // freopen("in", "r", stdin);
  cin.tie(0)->sync_with_stdio(0);
  int t = 1;
  // cin >> t;
  for (int i = 0; i < t; ++i) {
    solve();
  }
}