#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define yes() cout << "YES\n"
#define no() cout << "NO\n"
using ll = long long;
using ld = long double;
using namespace std;
using namespace __gnu_pbds;

template<typename K>
using oset = tree<K, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

struct segTree {
    vector<int> t;
    int n;

    void build(int v, int l, int r, vector<int>& a) {
        if (r - l == 1) {
            t[v] = a[l];
            return;
        }

        int m = (l + r) / 2;

        build(2 * v, l, m, a);
        build(2 * v + 1, m, r, a);

        t[v] = t[2 * v] + t[2 * v + 1];
    }

    segTree(vector<int>& a) {
        n = a.size();
        t.resize(4 * n);

        build(1, 0, n, a);
    }

    int get(int v, int l, int r, int ql, int qr) {
        if (l >= qr || r <= ql) {
            return 0;
        }

        if (ql <= l && r <= qr) {
            return t[v];
        }

        int m = (l + r) / 2;

        return get(2 * v, l, m, ql, qr) + get(2 * v + 1, m, r, ql, qr);
    }

    int get(int ql, int qr) {
        return get(1, 0, n, ql, qr);
    }

    void upd(int v, int l, int r, int idx, int val) {
        if (r - l == 1) {
            t[v] = val;
            return;
        }

        int m = (l + r) / 2;

        if (idx < m) {
            upd(2 * v, l, m, idx, val);
        } else {
            upd(2 * v + 1, m, r, idx, val);
        }

        t[v] = t[2 * v] + t[2 * v + 1];
    }

    void upd(int idx, int val) {
        upd(1, 0, n, idx, val);
    }
};

void solve() {
    int n, k;
    cin >> n >> k;

    vector<int> a1(n);
    for (int& i : a1) cin >> i;
    int ans = 0;

    for (int mask = 0; mask < pow(k, n); mask++) {
        int x = mask;
        vector<int> a;

        while (x != 0) {
            a.push_back(x % k);
            x /= k;
        }

        while (a.size() != n) {
            a.push_back(0);
        }

        vector<int> list(k);

        for (int i = 0; i < n; i++) {
            list[a[i]] = 1;
        }

        if (accumulate(all(list), 0ll) != k) continue;
        vector<int> prime(k, 1);
        vector<int> mx(k);

        for (int i = 0; i < n; i++) {
            mx[a[i]] = max(mx[a[i]], a1[i] + prime[a[i]]);
            prime[a[i]]++;
        }

        ans = max(ans, accumulate(all(mx), 0ll));
    }

    cout << ans << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;

    while (t--) {
        solve();
    }
}