#include <iostream>
#include <chrono>
#include <climits>
#include <cmath>
#include <random>
#include <algorithm>
#include <vector>
#include <string>

#pragma GCC optimize("O3")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

typedef long long ll;
typedef unsigned long long ull;

using namespace std;

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

ll gen(const int i, const int n, const int k, vector<vector<ll> > &ki, vector<ll> &a) {
    if (i >= n) {
        ll ans = 0;
        for (int x = 0; x < k; x++) {
            if (ki[x].empty()) return LLONG_MIN;
            ll tmp = 0;
            for (int j = 0; j < ki[x].size(); j++) {
                tmp = max(j + 1 + ki[x][j], tmp);
            }
            ans += tmp;
        }
        return ans;
    }
    ll ans = LLONG_MIN;
    for (int x = 0; x < k; x++) {
        ki[x].push_back(a[i]);
        ans = max(ans, gen(i + 1, n, k, ki, a));
        ki[x].pop_back();
    }
    return ans;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll n, k;
    cin >> n >> k;
    vector<ll> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    vector<vector<ll> > ki(k);

    cout << gen(0, n, k, ki, a);

    return 0;
}
