#include <bits/stdc++.h>
using namespace std;


using ll = long long;
const int inf = 1e9 + 10;

const int mod = 1e9 + 7;

int add(int a, int b) {
    return a + b >= mod ? a + b - mod : a + b;
}
int sub(int a, int b) {
    return a >= b ? a - b : a + mod - b;
}
int mul(int a, int b) {
    return 1ll * a * b % mod;
}

int solve(vector<vector<int>> g) {
    int n = g.size();
    vector<vector<int>> in(n);
    for (int i = 0; i < n; ++i) {
        for (auto j : g[i]) in[j].push_back(i);
    }
    vector<bool> used(n);
    vector<vector<bool>> adj(n, vector<bool>(n, false));
    auto dfs = [&](auto dfs, int u) -> void {
        used[u] = true;
        adj[u][u] = true;
        for (auto to : g[u]) {
            if (!used[to]) dfs(dfs, to);
            for (int k = 0; k < n; ++k) {
                if (adj[to][k]) adj[u][k] = true;
            }
        }
    };
    for (int i = 0; i < n; ++i) {
        if (!used[i]) dfs(dfs, i);
    }
    int mn = 0;
    for (int i = 0; i < n; ++i) {
        for (auto j : in[i]) {
            bool ok = true;
            for (auto k : in[i]) {
                if (j == k) continue;
                ok &= !adj[j][k];
            }
            if (ok) {
                mn++;
            }
        }
    }
    return mn;
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int n, m, group;
    cin >> n >> m >> group;
    vector<pair<int, int>> edges;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        v--, u--;
        edges.emplace_back(u, v);
    }
    int mx = 0;
    for (int mask = 0; mask < 1 << m; ++mask) {
        int cnt = 0;
        for (int sub = mask; ; sub = (sub - 1) & mask) {
            vector<vector<int>> adj(n, vector<int>(n));
            for (int i = 0; i < m; ++i) {
                auto [u, v] = edges[i];
                if ((mask >> i & 1) ^ (sub >> i & 1)) swap(u, v);
                adj[u][v] = true;
            }
            for (int i = 0; i < n; ++i) adj[i][i] = true;
            for (int k = 0; k < n; ++k) {
                for (int i = 0; i < n; ++i) {
                    for (int j = 0; j < n; ++j) {
                        if (adj[i][k] && adj[k][j]) adj[i][j] = true;
                    }
                }
            }
            bool ok = true;
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < n; ++j) {
                    ok &= adj[i][j];
                }
            }
            cnt += ok;
            if (sub == 0) break;
        }
        if (cnt > 1) {
            mx = max(mx, __builtin_popcount(mask));
        }
    }
    cout << mx << endl << 1;
}