#include <bits/stdc++.h>
using namespace std;

void dfs(vector<vector<int>>& g, int x, int y, int z, vector<bool>& used) {
    if (used[x]) {
        return;
    }
    used[x] = true;
    for (auto i : g[x]) {
        if ((x != y) || (i != z)) {
            dfs(g, i, y, z, used);
        }
    }
}

bool dfs2(vector<vector<int>>& g3, int x, int y, vector<vector<bool>>& used) {
    if (x == y) {
        return true;
    }
    for (int i = 0; i < g3[x].size(); i++) {
        if (!used[x][i]) {
            used[x][i] = true;
            if (dfs2(g3, g3[x][i], y, used)) {
                return true;
            }
            used[x][i] = false;
        }
    }
    return false;
}

int main() {
    int n, m, G, q, r;
    cin >> n >> m >> G;
    if ((G < 3) || (G > 4)) {
        return 0;
    }
    vector<vector<int>> g(n, vector<int>(0));
    for (int i = 0; i < m; i++) {
        cin >> q >> r;
        q--;
        r--;
        g[q].push_back(r);
    }
    vector<vector<bool>> is_bridge(n);
    vector<vector<bool>> is_connected(n, vector<bool>(n, true));
    vector<bool> used;
    for (int i = 0; i < n; i++) {
        is_bridge[i].assign(g[i].size(), false);
        for (int j = 0; j < g[i].size(); j++) {
            used.assign(n, false);
            dfs(g, i, i, g[i][j], used);
            if (!used[g[i][j]]) {
                is_bridge[i][j] = true;
            }
        }
        used.assign(n, false);
        dfs(g, i, -1, -1, used);
        for (int j = 0; j < n; j++) {
            if (!used[j]) {
                is_connected[i][j] = false;
                is_connected[j][i] = false;
            }
        }
    }
    vector<int> sccs(n, -1);
    for (int i = 0; i < n; i++) {
        if (sccs[i] == -1) {
            for (int j = 0; j < n; j++) {
                if (is_connected[i][j]) {
                    sccs[j] = i;
                }
            }
        }
    }
    int not_bridges(0);
    vector<vector<int>> g1(n, vector<int>(0));
    vector<vector<int>> g2(n, vector<int>(0));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < g[i].size(); j++) {
            if ((!is_bridge[i][j]) && (sccs[i] != sccs[g[i][j]])) {
                not_bridges++;
            } else if ((is_bridge[i][j]) && (sccs[i] == sccs[g[i][j]])) {
                g2[i].push_back(g[i][j]);
            } else if ((!is_bridge[i][j]) && (sccs[i] == sccs[g[i][j]])) {
                g1[i].push_back(g[i][j]);
            }
        }
    }
    vector<vector<bool>> is_connected_2(n, vector<bool>(n, true));
    for (int i = 0; i < n; i++) {
        used.assign(n, false);
        dfs(g1, i, -1, -1, used);
        for (int j = 0; j < n; j++) {
            if (!used[j]) {
                is_connected_2[i][j] = false;
                is_connected_2[j][i] = false;
            }
        }
    }
    vector<int> sccs2(n, -1);
    for (int i = 0; i < n; i++) {
        if (sccs2[i] == -1) {
            for (int j = 0; j < n; j++) {
                if (is_connected_2[i][j]) {
                    sccs2[j] = i;
                }
            }
        }
    }
    vector<vector<int>> g3(n, vector<int>(0));
    vector<vector<bool>> used2(n, vector<bool>(0));
    vector<vector<bool>> useds(n, vector<bool>(0));
    vector<vector<int>> usedcyc{};
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < g2[i].size(); j++) {
            g3[sccs2[i]].push_back(sccs2[g2[i][j]]);
            used2[sccs[i]].push_back(false);
            useds[sccs[i]].push_back(false);
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < g3[i].size(); j++) {
            if (!useds[i][j]) {
                if (dfs2(g3, g3[i][j], i, used2)) {
                    int t(0);
                    used2[i][j] = true;
                    vector<int> cyc{};
                    for (int k = 0; k < n; k++) {
                        for (int l = 0; l < g3[k].size(); l++) {
                            if (used2[k][l]) {
                                cyc.push_back(t);
                                useds[k][l] = true;
                            }
                            t++;
                        }
                    }
                    usedcyc.push_back(cyc);
                }
            }
        }
    }
    cout << not_bridges << endl;
    cout << 1 << endl;
}
