#ifdef _DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <iomanip>
#include <string>
#include <limits>
#include <array>
#include <stack>
#include <queue>
#include <deque>
#include <vector>
#include <numeric>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <chrono>
#include <random>
#include <assert.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ui = unsigned int;
using ld = long double;
using pii = pair<int, int>;
using pli = pair<long long, int>;
using pil = pair<int, long long>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

const int mod = 1e9 + 7;

struct mint {
	int val = 0;

	mint(int val = 0) : val(val) {}

	mint operator+=(const mint& other) {
		val += other.val;
		if (val >= mod)
			val -= mod;
		return *this;
	}

	mint operator-=(const mint& other) {
		val -= other.val;
		if (val < 0)
			val += mod;
		return *this;
	}

	mint operator*=(const mint& other) {
		val = (1ll * val * other.val) % mod;
		return *this;
	}

	mint power(ll k) const {
		mint a(*this);
		mint b = 1;
		for (; k; k >>= 1, a *= a)
			if (k & 1)
				b *= a;
		return b;
	}

	mint inv() const {
		return power(mod - 2);
	}

	mint operator/=(const mint& other) {
		val = (1ll * val * other.inv().val) % mod;
		return *this;
	}

	friend mint operator+(const mint& a, const mint& b) {
		return mint(a) += b;
	}

	friend mint operator-(const mint& a, const mint& b) {
		return mint(a) -= b;
	}

	friend mint operator*(const mint& a, const mint& b) {
		return mint(a) *= b;
	}

	friend mint operator/(const mint& a, const mint& b) {
		return mint(a) /= b;
	}

	friend istream& operator>>(istream& in, mint& a) {
		in >> a.val;
		return in;
	}

	friend ostream& operator<<(ostream& out, const mint& a) {
		out << a.val;
		return out;
	}
};

const int N = 2000;
vector<int> g[N], tg[N];
pii edges[N];
int SCC[N];
int used[N];
vector<int> ord;
int n, m;

void dfs1(int v) {
	used[v] = 1;
	for (int u : g[v])
		if (!used[u])
			dfs1(u);
	ord.push_back(v);
}

void dfs2(int v) {
	used[v] = 1;
	for (int u : tg[v])
		if (!used[u]) {
			SCC[u] = SCC[v];
			dfs2(u);
		}
}

void findSCC() {
	for (int i = 0; i < n; i++) {
		used[i] = 0;
		tg[i].clear();
	}
	for (int i = 0; i < n; i++)
		for (int j : g[i])
			tg[j].push_back(i);
	ord.clear();
	for (int i = 0; i < n; i++)
		if (!used[i])
			dfs1(i);
	reverse(all(ord));
	int id = 0;
	for (int i = 0; i < n; i++)
		used[i] = 0;
	for (int v : ord)
		if (!used[v]) {
			SCC[v] = id++;
			dfs2(v);
		}
	map<int, int> to;
	id = 0;
	for (int v = 0; v < n; v++) {
		if (to.count(SCC[v]))
			SCC[v] = to[SCC[v]];
		else {
			to[SCC[v]] = id++;
			SCC[v] = id;
		}
	}
}

int initSCC[N];

vector<int> seq;

bool check() {
	findSCC();
	for (int i = 0; i < n; i++)
		if (initSCC[i] != SCC[i])
			return false;
	return true;
}

bool rec(int i, bool dif = false) {
	if (i == (int)seq.size()) {
		if (!dif)
			return true;
		return !check();
	}
	int v = edges[seq[i]].first, u = edges[seq[i]].second;
	g[v].push_back(u);
	if (!rec(i + 1, dif))
		return false;
	g[v].pop_back();
	g[u].push_back(v);
	if (!rec(i + 1, 1))
		return false;
	g[u].pop_back();
	return true;
}

inline void solve() {
	int USELESS;
	cin >> n >> m >> USELESS;
	for (int i = 0; i < m; i++) {
		int v, u;
		cin >> v >> u;
		v--;
		u--;
		edges[i] = { v, u };
		g[v].push_back(u);
	}
	findSCC();
	for (int i = 0; i < n; i++)
		initSCC[i] = SCC[i];
	int ans = 0;
	int ways = 1;
	for (int mask = 0; mask < (1 << m); mask++) {
		for (int i = 0; i < n; i++)
			g[i].clear();
		seq.clear();
		for (int i = 0; i < m; i++) {
			if ((mask >> i) & 1)
				seq.push_back(i);
			else
				g[edges[i].first].push_back(edges[i].second);
		}
		if (rec(0)) {
			if (ans < seq.size()) {
				ans = seq.size();
				ways = 1;
			}
			else if (ans == seq.size())
				ways++;
		}
	}
	cout << ans << ' ' << ways << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("01.dat", "r", stdin);
#endif
	int tt = 1;
#ifdef _DEBUG
	cin >> tt;
#endif
	for (int test_id = 1; test_id <= tt; test_id++) {
#ifdef _DEBUG
		cout << "TESTCASE# " << test_id << '\n';
#endif
		solve();
	}
	return 0;
}
