#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cmath>
#include <random>
#include <map>
#include <queue>

using namespace std;
using ll = long long;

const int maxn = 2e3;

vector<int> gr[maxn];
int us[maxn][maxn];

void dfs(int v, int p) {
	us[p][v] = 1;
	for (auto u : gr[v]) {
		if (!us[p][u]) {
			dfs(u, p);
		}
	}
}

vector<int> get(int n) {
	for (int i = 0; i < n; ++i) {
		dfs(i, i);
	}
	vector<int> cl(n);
	int cr = 1;
	for (int i = 0; i < n; ++i) {
		if (cl[i]) continue;
		for (int j = i; j < n; ++j) {
			if (us[i][j] && us[j][i]) {
				cl[j] = cr;
			}
		}
		++cr;
	}
	for (int i = 0; i < n; ++i) {
		gr[i].clear();
		fill(us[i], us[i] + n, 0);
	}
	return cl;
}

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	int n, m, g;
	cin >> n >> m >> g;
	vector<int> u(m), v(m);
	for (int i = 0; i < m; ++i) {
		cin >> u[i] >> v[i];
		--u[i];
		--v[i];
	}
	int rs = 0, cnt = 1;
	for (int mask = 0; mask  + 1< (1 << m); ++mask) {
		int cn = 0;
		for (int i = 0; i < m; ++i) {
			if (((mask >> i) & 1) == 0) {
				++cn;
			}
		}
		if (cn < rs) continue;
		vector<int> vc;
		bool fl = 1;
		for (int pr = 0; pr < (1 << cn); ++pr) {
			int cr = 0;
			for (int j = 0; j < m; ++j) {
				if ((mask >> j) & 1) {
					gr[u[j]].push_back(v[j]);
				}
				else {
					if ((pr >> cr) & 1) {
						gr[v[j]].push_back(u[j]);
					}
					else {
						gr[u[j]].push_back(v[j]);
					}
					++cr;
				}
			}
			auto tt = get(n);
			if (vc.empty()) {
				vc = tt;
			}
			else {
				fl = fl && tt != vc;
			}
			if (!fl) break;
		}
		if (!fl) continue;
		if (cn == rs) {
			++cnt;
		}
		else {
			cnt = 1;
			rs = cn;
		}
	}

	cout << rs << '\n' << cnt;

	return 0;
}
