#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cmath>
#include <random>
#include <map>
#include <queue>

using namespace std;
using ll = long long;

const int maxn = 2e3;

vector<int> gr[maxn];
int us[maxn][maxn];

void dfs(int v, int p) {
	us[p][v] = 1;
	for (auto u : gr[v]) {
		if (!us[p][u]) {
			dfs(u, p);
		}
	}
}

vector<int> get(int n) {
	for (int i = 0; i < n; ++i) {
		dfs(i, i);
	}
	vector<int> cl(n);
	int cr = 1;
	for (int i = 0; i < n; ++i) {
		if (cl[i]) continue;
		for (int j = i; j < n; ++j) {
			if (us[i][j] && us[j][i]) {
				cl[j] = cr;
			}
		}
		++cr;
	}
	for (int i = 0; i < n; ++i) {
		gr[i].clear();
		fill(us[i], us[i] + n, 0);
	}
	return cl;
}

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	int n, m, g;
	cin >> n >> m >> g;
	vector<int> u(m), v(m);
	for (int i = 0; i < m; ++i) {
		cin >> u[i] >> v[i];
		--u[i];
		--v[i];
		gr[u[i]].push_back(v[i]);
	}
	vector<int> tt = get(n);
	vector<int> ch(1 << m);
	for (int mask = 1; mask < (1 << m); ++mask) {
		for (int j = 0; j < m; ++j) {
			if ((mask >> j) & 1) {
				gr[v[j]].push_back(u[j]);
			}
			else {
				gr[u[j]].push_back(v[j]);
			}
		}
		ch[mask] = tt == get(n);
	}

	for (int i = 0; i < m; ++i) {
		for (int j = 0; j < (1 << m); ++j) {
			if ((j >> i) & 1) {
				ch[j] += ch[j ^ (1 << i)];
			}
		}
	}
	int rs = 0, cnt = 1;
	for (int i = 0; i < (1 << m); ++i) {
		int cn = 0;
		for (int j = 0; j < m; ++j) {
			if ((i >> j) & 1) {
				++cn;
			}
		}
		if (ch[i] != 0) continue;
		if (cn > rs) {
			rs = cn;
			cnt = 1;
		}
		else if (cn == rs) {
			++cnt;
		}
	}

	cout << rs << '\n' << cnt;

	return 0;
}
