#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cmath>
#include <random>
#include <map>
#include <queue>

using namespace std;
using ll = long long;

const int maxn = 2e3;

vector<int> gr[maxn], ogr[maxn];
int us[maxn];

int ti = 1;
vector<int> tp;

void dfs(int v) {
	us[v] = ti;
	for (auto u : gr[v]) {
		if (us[u] != ti) {
			dfs(u);
		}
	}
	tp.push_back(v);
}


void sfd(int v, int cv, vector<int>& cl) {
	us[v] = ti;
	cl[v] = cv;
	for (auto u : ogr[v]) {
		if (us[u] != ti) {
			sfd(u, cv, cl);
		}
	}
}

vector<int> get(int n) {
	vector<int> sc(n + 1), nw(n + 1), cl(n);
	for (int i = 0; i < n; ++i) {
		for (auto u : gr[i]) {
			ogr[u].push_back(i);
		}
	}
	for (int i = 0; i < n; ++i) {
		if (us[i] == ti) continue;
		dfs(i);
	}
	int cr = 0;
	++ti;
	for (int i = n-1; i >=0; --i) {
		if (us[tp[i]] != ti) {
			++cr;
			sfd(tp[i], cr, cl);
		}
	}
	cr = 0;
	for (int i = 0; i < n; ++i) {
		if (!sc[cl[i]]) {
			++cr;
			nw[cl[i]] = cr;
			sc[cl[i]] = 1;
		}
		cl[i] = nw[cl[i]];
	}
	++ti;
	for (int i = 0; i < n; ++i) {
		gr[i].clear();
		ogr[i].clear();
	}
	tp.clear();
	return cl;
}

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	int n, m, g;
	cin >> n >> m >> g;
	vector<int> u(m), v(m);
	for (int i = 0; i < m; ++i) {
		cin >> u[i] >> v[i];
		--u[i];
		--v[i];
		gr[u[i]].push_back(v[i]);
	}
	vector<int> tt = get(n);
	vector<int> ch(1 << m);
	for (int mask = 1; mask < (1 << m); ++mask) {
		for (int j = 0; j < m; ++j) {
			if ((mask >> j) & 1) {
				gr[v[j]].push_back(u[j]);
			}
			else {
				gr[u[j]].push_back(v[j]);
			}
		}
		ch[mask] = tt == get(n);
	}

	for (int i = 0; i < m; ++i) {
		for (int j = 0; j < (1 << m); ++j) {
			if ((j >> i) & 1) {
				ch[j] += ch[j ^ (1 << i)];
			}
		}
	}
	int rs = 0, cnt = 1;
	for (int i = 0; i < (1 << m); ++i) {
		int cn = 0;
		for (int j = 0; j < m; ++j) {
			if ((i >> j) & 1) {
				++cn;
			}
		}
		if (ch[i] != 0) continue;
		if (cn > rs) {
			rs = cn;
			cnt = 1;
		}
		else if (cn == rs) {
			++cnt;
		}
	}

	cout << rs << '\n' << cnt;

	return 0;
}
