#include <bits/stdc++.h>

#pragma GCC target("popcnt")
#pragma GCC optimize("O3")


using namespace std;
const int MAXN = 21;
vector<pair<int, int>> g[MAXN], t[MAXN];
pair<int, int> E[MAXN];

void topsort(int u, vector<char> &used, vector<int> &order) {
    used[u] = 1;
    for (auto [v, _]: g[u]) {
        if (!used[v]) {
            topsort(v, used, order);
        }
    }
    order.push_back(u);
}

void dfs(int u, int c, vector<char> &used, vector<int> &color) {
    used[u] = 1;
    color[u] = c;
    for (auto [v, _]: t[u]) {
        if (!used[v]) {
            dfs(v, c, used, color);
        }
    }
}

vector<int> find_colors(int n) {
    vector<char> used(n + 1);
    vector<int> order, color(n + 1);
    for (int i = 1; i <= n; i++) {
        if (!used[i]) {
            topsort(i, used, order);
        }
    }
    used.assign(n + 1, false);
    reverse(order.begin(), order.end());
    int cnt = 1;
    for (int i: order) {
        if (!used[i]) {
            dfs(i, cnt, used, color);
            cnt++;
        }
    }
    unordered_map<int, int> repl;
    for (int i = 1; i <= n; i++) {
        if (!repl.contains(color[i])) repl[color[i]] = repl.size();
        color[i] = repl[color[i]];
    }
    return color;
}


int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m, _T;
    cin >> n >> m >> _T;
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        E[i] = {u, v};
        g[u].emplace_back(v, i);
        t[v].emplace_back(u, i);
    }
    vector<int> color = find_colors(n);
    vector<char> can_drop(m, 1);
    for (int i = 0; i < m; i++) {
        auto [u, v] = E[i];
        g[u].erase(find(g[u].begin(), g[u].end(), make_pair(v, i)));
        t[v].erase(find(t[v].begin(), t[v].end(), make_pair(u, i)));
        g[v].emplace_back(u, i);
        t[u].emplace_back(v, i);
        if (find_colors(n) == color) {
            can_drop[i] = 0;
        }
        g[v].erase(find(g[v].begin(), g[v].end(), make_pair(u, i)));
        t[u].erase(find(t[u].begin(), t[u].end(), make_pair(v, i)));
        g[u].emplace_back(v, i);
        t[v].emplace_back(u, i);
    }
    vector<char> is_bad(1 << m);
    for (int mask2 = 1; mask2 < (1 << m); mask2++) {
        bool abc = false;
        for (int i = 0; i < m; i++) {
            if ((mask2 >> i) & 1) {
                if (!can_drop[i]) {
                    abc = true;
                    break;
                }
            }
        }
        if (abc) {
            is_bad[mask2] = 1;
            continue;
        }
        for (int i = 1; i <= n; i++) {
            g[i].clear(), t[i].clear();
        }
        for (int i = 0; i < m; i++) {
            auto [u, v] = E[i];
            if ((mask2 >> i) & 1) {
                t[u].emplace_back(v, 0);
                g[v].emplace_back(u, 0);
            } else {
                g[u].emplace_back(v, 0);
                t[v].emplace_back(u, 0);
            }
        }
        if (find_colors(n) == color) {
            is_bad[mask2] = 1;
        }
    }

    int mx = -1, cntmx = 0;
    for (int mask = 0; mask < (1 << m); mask++) {
        for (int i = 0; i < m; i++) {
            if ((mask >> i) & 1) {
                is_bad[mask] |= is_bad[mask ^ (1 << i)];
            }
        }
        if (!is_bad[mask]) {
            int cur = __builtin_popcount(mask);

            if (cur == mx) {
                cntmx++;
            } else {
                mx = cur;
                cntmx = 1;
            }
        }
    }
    cout << mx << "\n" << cntmx;
    return 0;
}