#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int N = 2e3 + 1;
const int mod = 1e9 + 7;

int add(int a, int b) {
    return a + b >= mod ? a + b - mod : a + b;
}
int sub(int a, int b) {
    return a - b < 0 ? a - b + mod : a - b;
}
int mult(int a, int b) {
    return a * 1ll * b % mod;
}
int bpow(int a, int b) {
    int ans = 1;
    while (b) {
        if (b & 1) ans = mult(ans, a);
        a = mult(a, a);
        b >>= 1;
    }
    return ans;
}

bool can[N][N];

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);

    int n, m, G;
    cin >> n >> m >> G;

    int cc = 0;
    
    vector<int> bamboo;
    vector<pair<int, int>> edge;
    vector<vector<int>> g(n + 1);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);

        if (u != v - 1) {
            cc++;
        }

        if (u == v - 1) {
            bamboo.push_back(u);
        }
        edge.push_back({u, v});
    }

    for (int i = 1; i <= n; ++i) {
        sort(g[i].begin(), g[i].end());
    }
    sort(bamboo.begin(), bamboo.end());

    if (G == 5) {
        for (int i = 1; i <= n; ++i) {
            queue<int> q;
            can[i][i] = 1;
            q.push(i);

            while (!q.empty()) {
                int v = q.front();
                q.pop();
                for (auto& u: g[v]) {
                    if (!can[i][u]) {
                        can[i][u] = 1;
                        q.push(u);
                    }
                }
            }
        }

        int ans = 0;
        for (auto& e: edge) {
            int v = e.first, u = e.second;
            if (v + 1 != u) continue;
            
            for (int i = 1; i <= n; ++i) {
                if (i == v || i == u) continue;
                if (can[v][i] && can[i][u]) {
                    ans++;
                    break;
                }
            }
        }

        cout << ans << "\n";
        cout << 1 << "\n";
    } else {
        return 0;
    }

    return 0;
}
