#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const int inf = 1e9 + 10;

vector<vector<int>> g;
vector<vector<int>> rg;

vector<int> topsorted, used;

void dfs(int u) {
    used[u] = true;
    for (auto v : g[u]) {
        if (!used[v]) {
            dfs(v);
        }
    }
    topsorted.push_back(u);
}

vector<int> comp;

void col(int u, int c) {
    comp[u] = c;
    for (auto v : rg[u]) {
        if (comp[v] == -1) {
            col(v, c);
        }
    }
}

vector<int> scc() {
    int n = g.size();
    topsorted.clear();
    used.assign(n, 0);
    rg.assign(n, {});
    for (int i = 0; i < n; i++) {
        for (auto v : g[i]) {
            rg[v].push_back(i);
        }
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i);
        }
    }
    reverse(topsorted.begin(), topsorted.end());
    comp.assign(n, -1);
    int comps = 0;
    for (auto v : topsorted) {
        if (comp[v] == -1) {
            col(v, comps);
            comps++;
        }
    }
    return comp;
}

void solve() {
    int n, m, gr;
    cin >> n >> m >> gr;
    vector<array<int, 2>> edges;
    g.assign(n, {});
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        edges.push_back({u, v});
        g[u].push_back(v);
    }
    auto base = scc();
    vector<int> bad(1 << m);
    /*
    for (auto e : base) {
        cout << e << ' ';
    }
    cout << '\n';
    */
    for (int i = 1; i < (1 << m); i++) {
        g.assign(n, {});
        for (int j = 0; j < m; j++) {
            auto [u, v] = edges[j];
            if ((i >> j) & 1) {
                g[v].push_back(u);
            } else {
                g[u].push_back(v);
            }
        }
        auto now = scc();
        bool good = true;
        for (int j = 0; j < n; j++) {
            for (int k = j + 1; k < n; k++) {
                if (base[j] == base[k] && now[j] != now[k]) {
                    good = false;
                }
                if (base[j] != base[k] && now[j] == now[k]) {
                    good = false;
                }
                if (!good) break;
            }
            if (!good) break;
        }
        if (good) {
            bad[i] = 1;
        }
    }
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < (1 << m); j++) {
            if ((j >> i) & 1) {
                bad[j] += bad[j ^ (1 << i)];
            }
        }
    }
    int sz = -1, ans = 0;
    for (int i = 0; i < (1 << m); i++) {
        if (bad[i]) continue;
        int now = __builtin_popcount(i);
        if (now > sz) {
            sz = now;
            ans = 0;
        }
        if (now == sz) {
            ans++;
        }
    }
    cout << sz << '\n';
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    for (int i = 0; i < t; i++) solve();
}
