#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll inf = 1e18;
const ll mod = 1e9 + 7;

ll n, m, gg;
vector<vector<ll>> g1;
vector<vector<ll>> g2;
vector<vector<ll>> g;
vector<ll> was;
vector<ll> c;
vector<ll> res;
vector<ll> n1;
ll col = 0;

void dfs1(ll v) {
    was[v] = 1;
    if (g[v].size() != 0) col++;
    for(ll to : g1[v]) {
        if (was[to] == 0) {
            dfs1(to);
        }
    }
    res.push_back(v);
}

vector<ll> p;
vector<ll> sz;

ll get(ll v) {
    if (p[v] == v) return v;
    return p[v] = get(p[v]);
}

ll merge(ll a, ll b) {
    ll a1 = get(a), b1 = get(b);
    if (sz[a1] < sz[b1]) swap(a1, b1);
    if (a1 != b1) {
        p[b1] = a1;
        sz[a1] += sz[b1];
        return 1;
    }
    return 0;
}

void dfs2(ll v, ll c1) {
    was[v] = 1;
    c[v] = c1;
    for(ll to : g2[v]) {
        if (was[to] == 0) {
            dfs2(to, c1);
        }
    }
}

void solve() {
    cin >> n >> m >> gg;
    g.assign(n, {});
    g1.assign(n, {});
    g2.assign(n, {});
    was.assign(n, 0);
    c.assign(n, 0);
    p.assign(n, 0);
    sz.assign(n, 1);
    n1.assign(n, 0);
    for(int i = 0; i < n; i++) p[i] = i;
    vector<pair<ll, ll>> z(m);
    for(int i = 0; i < m; i++) {
        ll a, b; cin >> a >> b;
        a--; b--;
        g1[a].push_back(b);
        g2[b].push_back(a);
        g[a].push_back(b);
        g[b].push_back(a);
        z[i] = {a, b};
    }
    for(int i = 0; i < n; i++) {
        if (was[i] == 0) {
            dfs1(i);
        }
    }
    reverse(res.begin(), res.end());
    fill(was.begin(), was.end(), 0);
    res.clear();
    ll c1 = 1;
    for(int i = 0; i < n; i++) {
        ll v = res[i];
        if (was[v] == 0) {
            dfs2(v, c1);
            c1++;
        }
    }
    cout << m - col << " " << 1 << "\n";
}

int main() {
#ifdef KABANDJAN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll ttt = 1;
//    cin >> ttt;
    while(ttt--) {
        solve();
    }
    return 0;
}
