// #pragma GCC optimize("O3")
// #pragma GCC optimize("Ofast")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

// #pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

#ifdef LOCAL
    #define debug(x) cout << #x << ": " << x << endl;
#else
    #define debug(x)
#endif
#define mt_seed chrono::high_resolution_clock::now().time_since_epoch().count()
#define time_now chrono::high_resolution_clock::now()
#define time_res(s, f) chrono::duration_cast<chrono::nanoseconds>(f - s).count()
#define time_out(s) cout << fixed << setprecision(10) << endl << "Used: " << (ld)time_res(s, time_now) / 1e6 << " ms" << endl;
#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define file_in freopen("input.txt", "r", stdin);
#define file_out freopen("output.txt", "w", stdout);
#define all(a) a.begin(), a.end()
#define sz(a) (int)(a.size())
#define pb push_back
#define ff first
#define sc second
#define int ll

using namespace std;
using namespace __gnu_pbds;

using ld = long double;
using ll = long long;
using ull = unsigned long long;
using str = string;
using pii = pair<int, int>;
using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T1, typename T2> istream& operator>>(istream &in, pair<T1, T2> &a) { in >> a.ff >> a.sc; return in; }
#ifdef LOCAL
    template<typename T1, typename T2> ostream& operator<<(ostream &out, const pair<T1, T2> &a) { out << "{" << a.ff << ' ' << a.sc << "}"; return out; }
#else
    template<typename T1, typename T2> ostream& operator<<(ostream &out, const pair<T1, T2> &a) { out << a.ff << ' ' << a.sc; return out; }
#endif
template<typename T> istream& operator>>(istream &in, vector<T> &a) { for (auto &el : a) in >> el; return in; }
template<typename T> ostream& operator<<(ostream &out, const vector<T> &a) { for (auto &el : a) out << el << " "; return out; }
template<typename T> ostream& operator<<(ostream &out, const set<T> &a) { for (auto &el : a) out << el << " "; return out; }
template<typename T> ostream& operator<<(ostream &out, const multiset<T> &a) { for (auto &el : a) out << el << " "; return out; }
template<typename T, typename comp> ostream& operator<<(ostream &out, const unordered_set<T, comp> &a) { for (auto &el : a) out << el << " "; return out; }
template<typename T> T max(T a, T b, T c) { return max(a, max(b, c)); }
template<typename T> T max(T a, T b, T c, T d) { return max(max(a, b), max(c, d)); }
template<typename T> T min(T a, T b, T c) { return min(a, min(b, c)); }
template<typename T> T min(T a, T b, T c, T d) { return min(min(a, b), min(c, d)); }
const ll LOL = mt_seed;
mt19937_64 genom(LOL); ll randint(ll l, ll r) { uniform_int_distribution<ll> random_distrib_2_0(l, r); return random_distrib_2_0(genom); }
const ll RANDOM = genom(); struct chash { ll operator()(ll x) { return x ^ RANDOM; } };

const int mod = 1e9 + 7;

int n, m, G;
vector<vector<int>> g;

vector<int> used;

bool dfs(int v) {
    used[v] = 1;
    for (auto to : g[v])
        if (used[to] == 1 || used[to] == 0 && dfs(to))
            return 1;
    used[v] = 2;
    return 0;
}

bool isCycle() {
    used.assign(n, 0);
    for (int i = 0; i < n; ++i)
        if (!used[i] && dfs(i))
            return 1;
    return 0;
}

bool isFullCycle() {
    used.assign(n, 0);
    dfs(0);
    for (auto el : used)
        if (el != 2)
            return 0;
    return 1;
}

signed main() {
    fast
#ifdef LOCAL
    file_in
#endif

    cin >> n >> m >> G;

    g.resize(n);

    vector<pii> edges;

    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        --v; --u;
        g[v].pb(u);
        edges.pb({v, u});
    }

    int cnt = 0;

    vector<pii> seg;
    for (int i = 0; i < n; ++i) {
        seg.clear();
        for (auto [v, u] : edges) {
            if (u == v + 1 || u < v) continue;
            seg.pb({v, u - 1});
        }
        sort(all(seg), [&](pii x, pii y){ return x.sc < y.sc; });

        int cur = 0, last = -1;
        for (auto [l, r] : seg) {
            if (last < l) {
                last = r;
                ++cur;
            }
        }
        cnt = max(cnt, n - 1 - cur);

        for (auto &[v, u] : edges) {
            ++v; ++u;
            if (v == n) v = 0;
            if (u == n) u = 0;
        }
    }

    // for (int i = 0; i < m; ++i) {
    //     swap(edges[i].ff, edges[i].sc);
    //     for (int j = 0; j < n; ++j)
    //         g[j].clear();

    //     for (auto [v, u] : edges)
    //         g[v].pb(u);
        
    //     cnt += !isFullCycle();

    //     swap(edges[i].ff, edges[i].sc);
    // }

    cout << cnt << ' ' << 1 << '\n';

    return 0;
}
