#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <iomanip>
#include <string>
#include <numeric>
#include <random>
#include <cmath>
using namespace std;
using ll = long long;
using ld = long double;
const ll INF = 1e18;
const int MOD = 1e9 + 7;

vector<vector<int>> gr, g_rev;
vector<int> tout;
vector<bool> vis;
vector<int> comp;
int curc = 0;
int curt = 0;

void dfs(int u) {
	vis[u] = true;
	for (int v : gr[u]) {
		if (!vis[v])
			dfs(v);
	}
	tout[u] = curt; curt++;
}
void dfs2(int u) {
	vis[u] = true;
	comp[u] = curc;
	for (int v : g_rev[u]) {
		if (!vis[v]) 
			dfs2(v);
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, m, g;
	cin >> n >> m >> g;
	gr.resize(n); g_rev.resize(n);
	vector<pair<int, int>> edges;
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		u--; v--;
		edges.push_back({ u, v });
		gr[u].push_back(v);
		g_rev[v].push_back(u);
	}
	tout.resize(n);
	vis.resize(n, false);
	for (int u = 0; u < n; ++u) {
		if (!vis[u]) {
			dfs(u);
		}
	}
	vector<pair<int, int>> ver(n);
	for (int u = 0; u < n; ++u) {
		ver[u] = { -tout[u], u };
	}
	sort(ver.begin(), ver.end());
	vis.assign(n, false);
	comp.resize(n);
	for (auto el : ver) {
		int u = el.second;
		if (!vis[u]) {
			dfs2(u);
			curc++;
		}
	}
	set<int> se0;
	vector<int> num_comp(curc, 0);
	for (int u = 0; u < n; ++u) {
		num_comp[comp[u]] |= (1 << u);
	}
	for (int i = 0; i < curc; ++i) {
		se0.insert(num_comp[i]);
	}
	int curc0 = curc;
	vector<int> vars;
	for (int mask = 0; mask < (1 << m); ++mask) {
		gr.clear(); g_rev.clear();
		gr.resize(n); g_rev.resize(n);
		for (int i = 0; i < m; ++i) {
			int u = edges[i].first, v = edges[i].second;
			if ((mask >> i) & 1) {
				gr[u].push_back(v);
				g_rev[v].push_back(u);
			}
			else {
				gr[v].push_back(u);
				g_rev[u].push_back(v);
			}
		}
		curt = 0;
		vis.assign(n, false);
		for (int u = 0; u < n; ++u) {
			if (!vis[u]) {
				dfs(u);
			}
		}
		vector<pair<int, int>> ver(n);
		for (int u = 0; u < n; ++u) {
			ver[u] = { -tout[u], u };
		}
		sort(ver.begin(), ver.end());
		vis.assign(n, false);
		comp.resize(n);
		curc = 0;
		for (auto el: ver) {
			int u = el.second;
			if (!vis[u]) {
				dfs2(u);
				curc++;
			}
		}
		vector<int> num_comp(curc, 0);
		for (int u = 0; u < n; ++u) {
			num_comp[comp[u]] |= (1 << u);
		}
		if (curc == curc0) {
			bool flag = true;
			for (int i = 0; i < curc; ++i) {
				if (se0.find(num_comp[i]) == se0.end()) {
					flag = false;
					break;
				}
			}
			if (flag) {
				vars.push_back(mask);
			}
		}
	}
	
	vector<int> dp((1 << m), 0);
	for (int mask : vars) {
		for (int submask = mask; submask > 0; submask = (submask - 1) & mask) {
			dp[submask]++;
		}
		dp[0]++;
	}
	int cnt = 0;
	int max1 = 0;
	for (int mask = 0; mask < (1 << m); ++mask) {
		if (dp[mask] == 1) {
			
			int cur = 0;
			for (int i = 0; i < m; ++i) {
				cur += ((mask >> i) & 1);
			}
			cur = m - cur;
			if (cur == max1) cnt++;
			else if (cur > max1) {
				max1 = cur;
				cnt = 1;
			}
		}
	}

	cout << max1 << "\n" << cnt % MOD;

	return 0;
}
