#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;

auto seed = std::chrono::steady_clock::now().time_since_epoch().count();
mt19937 rnd(seed);

using ll = long long;

//#define int ll

using vi = vector<int>;
using pii = pair<int, int>;
using vp = vector<pair<int, int>>;
using vv = vector<vector<int>>;

template<class T>
using ordered_set = __gnu_pbds::tree<T, __gnu_pbds::null_type, less<T>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;
const int maxn = 2000;
vi g[maxn];
vi rev[maxn];

vi used(maxn);
vi ts;

void dfs(int v) {
    used[v] = 1;
    for (int u: g[v]) {
        if (!used[u]) {
            dfs(u);
        }
    }
    ts.push_back(v);
}

vi c(maxn, -1);
vi root(maxn);

vi sz(maxn);

void dfs2(int v, int clr) {
    c[v] = clr;
    sz[clr]++;
    root[clr] = v;
    for (int u: rev[v]) {
        if (c[u] == -1) {
            dfs2(u, clr);
        }
    }
}

vi hup(maxn, 1e9);
vi cnt(maxn, 1e9);
vi h(maxn, -1);
vi child(maxn, 1);

vi tin(maxn), tout(maxn);
int timer = 1;
vi pr(maxn);

void dfs3(int v, int p) {
    pr[v] = p;
    hup[v] = v;
    tin[v] = timer++;
    for (int u: g[v]) {
        if (h[u] == -1 && c[u] == c[v]) {
            h[u] = h[v] + 1;
            child[v] = 0;
            dfs3(u, v);
            if (h[u] < h[hup[v]]) {
                hup[v] = u;
            }
        } else if (h[u] < h[hup[v]] & c[u] == c[v]) {
            hup[v] = u;
        }
    }
    tout[v] = timer++;
}

bool is_par(int v, int u) {
    return tin[v] <= tin[u] && tout[u] <= tout[v];
}

int n, m, gr;

vi used_leaf(maxn);


int get(int clr) {
    h[root[clr]] = 0;
    dfs3(root[clr], root[clr]);
    int an = 0;
    vi need;
    for (int v = 0; v < n; ++v) {
        if (c[v] != clr)continue;
        if (v != root[clr])need.push_back(v);
    }
    while (!need.empty()) {
        int lowest = need[0];
        for (auto v: need) {
            if (h[v] > h[lowest]) {
                lowest = v;
            }
        }
        int v = lowest;
        an++;
        while (v != hup[lowest]) {
            used_leaf[v] = 1;
            v = pr[v];
        }
        for (int i = 0; i < need.size(); ++i) {
            if (used_leaf[need[i]]) {
                swap(need[i], need.back());
                i--;
                need.pop_back();
            }
        }
    }
    an += sz[clr] - 1;
    return an;
}

void solve() {
    cin >> n >> m >> gr;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> v >> u;
        v--, u--;
        g[v].push_back(u);
        g[u].push_back(v);
        rev[u].push_back(v);
    }
    int comp = 0;
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs(i);
            comp++;
        }
    }
    cout << m - (n - comp) << '\n' << 1;
}

signed main() {
#ifdef LOCAL
    freopen("C:\\work\\untitled\\input.txt", "r", stdin);
    freopen("C:\\work\\untitled\\output.txt", "w", stdout);
    auto start = std::chrono::steady_clock::now();
#else
    cin.tie();
    cout.tie();
    ios_base::sync_with_stdio(0);
#endif
    int t_ = 1;
    //cin>>t;
    while (t_--) {
        solve();
    }

#ifdef LOCAL
    auto end = std::chrono::steady_clock::now();
    cout << "\n======\n";
    cout << chrono::duration_cast<chrono::milliseconds>(end - start);
#endif
}
