#include <iostream>
#include <vector>
#include <set>
#include <cmath>
#include <unordered_set>
#include <algorithm>

using namespace std;

using ll = long long;

#pragma GCC optimaze("Ofast");

vector<unordered_set<int>> gr, grr;

vector<int> us;
vector<int> top;
ll n, m, t;

void dfs(int v) {
	us[v] = 1;
	for (int u : gr[v]) {
		if (us[u]) continue;
		dfs(u);
	}
	top.push_back(v);
}

void dfs2(int v, int T) {
	us[v] = T;
	for (int u : grr[v]) {
		if (us[u]) continue;
		dfs2(u, T);
	}
}

vector<int> css() {
	int T = 1;
	for (int i = 0; i < n; i++) us[i] = 0;
	for (int i = n - 1; i > -1; i--) {
		if (us[top[i]]) continue;
		dfs2(top[i], T);
		T++;
	}
	return us;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cin >> n >> m >> t;
	gr.resize(n);
	grr.resize(n);
	us.resize(n);
	vector<pair<int, int>> e;
	vector<int> use(m);
	for (int i = 0; i < m; i++) {
		int A, B;
		cin >> A >> B;
		A--;
		B--;
		gr[A].insert(B);
		grr[B].insert(A);
		e.push_back({ A, B });
	}
	for (int i = 0; i < n; i++) {
		if (us[i]) continue;
		dfs(i);
	}
	vector<int> ok = css();
	for (int i = 0; i < m; i++) {
		grr[e[i].first].insert(e[i].second);
		grr[e[i].second].erase(e[i].first);
		vector<int> x = css();
		if (ok == x) {
			use[i] = 1;
		}
		else {
			grr[e[i].first].erase(e[i].second);
		}
		grr[e[i].second].insert(e[i].first);
	}
	int cnt = 0;
	for (int x : use) cnt += x;
	cout << cnt << "\n";
	cout << 1;
}



