#include <bits/stdc++.h>
using namespace std;
using ll = long long;
//using ll = int;
using ld = long double;
using ull = unsigned long long;
#define pb push_back
#define all(vec) vec.begin(), vec.end()
#define eb emplace_back
#ifdef LOCAL
#define deb(x) cout << #x << " = " << x << '\n'
#else
#define deb(x) 52
#endif
const ll inf = 1e9 + 11;
const long long INF = (long long)2e18 + 11;
const ll P = 73;
const ll MOD = 1e9 + 7;


vector<ll> get_css(vector<vector<ll>> graph) {
    ll n = (ll)graph.size();
    vector<bool> used(n);
    vector<ll> topsort;
    auto dfs1 = [&](auto &dfs1, ll v) -> void {
        used[v] = true;
        for (ll u : graph[v]) {
            if (!used[u]) {
                dfs1(dfs1, u);
            }
        }
        topsort.pb(v);
    };
    for (ll i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs1(dfs1, i);
        }
    }
    reverse(all(topsort));
    vector<vector<ll>> rg(n);
    for (ll i = 0; i < n; ++i) {
        for (ll j : graph[i]) {
            rg[j].pb(i);
        }
    }
    vector<ll> col(n, -1);
    ll cur_col = 0;
    auto dfs2 = [&](auto &dfs2, ll v) -> void {
        col[v] = cur_col;
        for (ll u : rg[v]) {
            if (col[u] == -1) {
                dfs2(dfs2, u);
            }
        }
    };
    for (ll v : topsort) {
        if (col[v] == -1) {
            dfs2(dfs2, v);
            ++cur_col;
        }
    }
    vector<ll> mp(n, -1);
    ll cur = 0;
    vector<ll> ans(n);
    for (ll i = 0; i < n; ++i) {
        if (mp[col[i]] == -1) {
            mp[col[i]] = cur++;
        }
        ans[i] = mp[col[i]];
    }
    return ans;
}


bool check(ll n, vector<pair<ll, ll>> edges, ll mask, vector<ll> good_css) {
    ll m = (ll)edges.size();
    ll z = __builtin_popcount(mask);
    vector<pair<ll, ll>> bad;
    for (ll i = 0; i < m; ++i) {
        if (1 & (mask >> i)) {
            bad.pb(edges[i]);
        }
    }
    ll c = 0;
    for (ll mask2 = 0; mask2 < (1 << z); ++mask2) {
        vector<vector<ll>> graph(n);
        for (ll i = 0; i < m; ++i) {
            if (!(1 & (mask >> i))) {
                graph[edges[i].first].pb(edges[i].second);
            }
        }
        for (ll i = 0; i < z; ++i) {
            if (1 & (mask2 >> i)) {
                graph[bad[i].first].pb(bad[i].second);
            } else {
                graph[bad[i].second].pb(bad[i].first);
            }
        }
        c += get_css(graph) == good_css;
        if (c > 1) {
            return false;
        }
    }
    return true;
}


void solve() {
    ll n, m, g;
    cin >> n >> m >> g;
    vector<pair<ll, ll>> edges;
    ll x, y;
    vector<vector<ll>> graph(n);
    for (ll i = 0; i < m; ++i) {
        cin >> x >> y;
        --x, --y;
        graph[x].pb(y);
        edges.eb(x, y);
    }
    vector<ll> good_css = get_css(graph);
    ll ansv = 0, ansc = 0;
    for (ll mask = 1; mask < (1 << m); ++mask) {
        ll z = __builtin_popcount(mask);
        if (z < ansv) {
            continue;
        }
        if (check(n, edges, mask, good_css)) {
            if (z > ansv) {
                ansv = z;
                ansc = 1;
            } else if (z == ansv) {
                ++ansc;
            }
        }
    }
    cout << ansv << '\n' << ansc;
}


int main() {
#ifdef LOCAL
    freopen("C:/work/untitled/input.txt", "r", stdin);
    freopen("C:/work/untitled/output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll cfmode = 0;
    ll tc = 1;
    if (cfmode) {
        cin >> tc;
    }
    while (tc--) {
        solve();
        if (tc) {
            cout << '\n';
        }
    }
}