#ifdef ONPC
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using i128 = __int128_t;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937_64 rng(chrono::steady_clock().now().time_since_epoch().count());


vector<vector<int>> g, cg;

void topsort(int v, vector<int>& used, vector<int>& ts, vector<vector<int>>& g) {
    used[v] = 1;
    for (auto u : g[v]) {
        if (used[u]) continue;
        topsort(u, used, ts, g);
    }
    ts.push_back(v);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m, group;
    cin >> n >> m >> group;
    g.resize(n);
    cg.resize(n);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        cg[u].push_back(v);
    }

    vector<int> used(n);
    vector<int> ts;
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            topsort(i, used, ts, cg);
        }
    }
    reverse(ts.begin(), ts.end());

    vector<int> d(n);
    for (int i = n - 1; i >= 0; i--) {
        int v = ts[i];
        d[v] = 0;
        for (auto u : cg[v]) d[v] = max(d[v], d[u] + 1);
    }

    int bad = 0;
    vector<bitset<2000>> can(n);
    for (int i = n - 1; i >= 0; i--) {
        int v = ts[i];
        can[v][v] = 1;

        sort(cg[v].begin(), cg[v].end(), [&](int x, int y) {return d[x] > d[y];});
        for (auto u : cg[v]) {
            if (!can[v][u]) {
                bad++;
                can[v] |= can[u];
            }
        }
    }

    cout << m - bad << '\n';
    cout << 1 << '\n';

    return 0;
}
