#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <numeric>

#include <ext/pb_ds/assoc_container.hpp>

#define all(a) a.begin(), a.end()
#define int long long

// #pragma GCC optimize("O3")

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

using oset = tree<pll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>; 

constexpr ll inf = 1e18;

void solve() {
    int n, m, g;
    cin >> n >> m >> g;
    vector<pii> edges(m);
    for (int i = 0; i < m; ++i) {
        cin >> edges[i].first >> edges[i].second;
        edges[i].first--;
        edges[i].second--;
    }

    vector<vector<int>> perfect(n, vector<int>(n));
    for (pii const &p : edges) {
        perfect[p.first][p.second] = 1;
    }

    for (int k = 0; k < n; ++k) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                perfect[i][j] = perfect[i][j] or perfect[i][k] and perfect[k][j];
            }
        }
    }

    int MASK = 1 << m;
    pii ans{0, 1};
    vector<int> dp(MASK);
    dp[0] = 0;
    for (int mask = 1; mask < MASK; ++mask) {
        vector<vector<int>> g(n, vector<int>(n));
        for (int i = 0; i < m; ++i) {
            if ((mask >> i) & 1) {
                g[edges[i].second][edges[i].first] = 1;
            } else {
                g[edges[i].first][edges[i].second] = 1;
            }
        }

        for (int k = 0; k < n; ++k) {
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < n; ++j) {
                    g[i][j] = g[i][j] or g[i][k] and g[k][j];
                }
            }
        }

        bool f = false;
        for (int i = 0; i < n and !f; ++i) {
            for (int j = 0; j < n and !f; ++j) {
                if (g[i][j] and g[j][i] xor perfect[i][j] and perfect[j][i]) {
                    f = true;
                }
            }
        }

        dp[mask] = not f;
    }

    for (int mask = 0; mask < MASK; ++mask) {
        if (dp[mask] == 0) {
            int cnt = __builtin_popcount(mask);
            if (cnt == ans.first) ans.second++;
            if (cnt > ans.first) ans = {cnt, 1};
        } else {
            for (int i = 0; i < m; ++i) {
                if (((mask >> i) & 1) == 0) {
                    dp[mask + (1 << i)] = 1;
                }
            }
        }
    }
    
    cout << ans.first << ' ' << ans.second;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}