#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define debug(x) cerr << __LINE__ << ": " << (#x) << " = " << (x) << endl
#else
#define debug(...) 42
#endif

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
// #pragma GCC target("avx,avx2,fma")

#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef __int128 LL;
#define all(x) (x).begin(), (x).end()
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

template<typename T>
istream &operator >>(istream &in, vector<T> &a) {
    for (auto &elem : a) {
        in >> elem;
    }
    return in;
}

template<typename T>
ostream &operator <<(ostream &out, const vector<T> &a) {
    for (const auto &elem : a) {
        out << elem << ' ';
    }
    return out;
}

int n, m;
vector<pair<int, int>> edges;
vector<vector<int>> g, rg;

void top_sort(int v, vector<bool> &used, vector<int> &order) {
    used[v] = true;
    for (int u : g[v]) {
        if (!used[u]) {
            top_sort(u, used, order);
        }
    }
    order.push_back(v);
}

void css(int v, vector<int> &color) {
    for (int u : rg[v]) {
        if (!color[u]) {
            color[u] = color[v];
            css(u, color);
        }
    }
}

vector<int> get(const int &mask) {
    g.assign(n + 1, vector<int>());
    rg.assign(n + 1, vector<int>());
    for (int i = 0; i < m; ++i) {
        const auto &[u, v] = edges[i];
        if (!(mask & (1 << i))) {
            g[u].push_back(v);
            rg[v].push_back(u);
        } else {
            g[v].push_back(u);
            rg[u].push_back(v);
        }
    }
    vector<bool> used(n + 1);
    vector<int> order;
    for (int v = 1; v <= n; ++v) {
        if (!used[v]) {
            top_sort(v, used, order);
        }
    }
    ranges::reverse(order);
    vector<int> color(n + 1);
    int cur_color = 1;
    for (int v : order) {
        if (!color[v]) {
            color[v] = cur_color++;
            css(v, color);
        }
    }
    return color;
}

void solve() {
    int res = n - 1;
    vector<bool> used(n + 1);
    used[n] = true;
    for (const auto &[u, v] : edges) {
        if (used[u]) { continue; }
        used[u] = true;
        res--;
    }
    cout << res << " 1\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int trash;
    cin >> n >> m >> trash;
    edges.resize(m);
    for (auto &[u, v] : edges) {
        cin >> u >> v;
    }
    solve();
//    while (true) {
//        n = 6, m = 7;
//        edges.clear();
//        for (int v = 1; v < n; ++v) {
//            edges.emplace_back(v, v + 1);
//        }
//        for (int t = 0; t < 2; ++t) {
//            while (true) {
//                int u = rng() % (n - 1) + 1;
//                int v = rng() % (n - u) + u + 1;
//                if (u + 1 != v && (u != edges.back().first || v != edges.back().second)) {
//                    edges.emplace_back(u, v);
//                    break;
//                }
//            }
//        }
//        auto [res, cnt] = solve();
//        if (res != m - n + 1 || cnt != 1) {
//            cout << n << ' ' << m << '\n';
//            for (auto &[u, v] : edges) {
//                cout << u << ' ' << v << '\n';
//            }
//            cout << "! " << res << ' ' << cnt << '\n';
//            exit(0);
//        }
//    }
}