#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int MOD = 1e9 + 7;

pair<int, int> solveSCC(int n, vector<vector<int>> adj) {
    return {0, 1};
}

vector<int> findSCC(int n, vector<vector<int>> adj, vector<array<int, 2>> e) {
    vector<int> tin(n, -1), col(n, -1), fup(n), stk;
    int timer = 0, color = 0;
    auto tarjan = [&](auto self, int v) -> void {
        tin[v] = fup[v] = timer++;
        stk.push_back(v);
        for (int j : adj[v]) {
            if (v != e[j][0]) {
                continue;
            }
            int to = e[j][1];
            if (col[to] != -1) {
                continue;
            }
            if (tin[to] == -1) {
                self(self, to);
                fup[v] = min(fup[v], fup[to]);
            } else {
                fup[v] = min(fup[v], tin[to]);
            }
        }
        if (tin[v] == fup[v]) {
            int u;
            do {
                u = stk.back();
                stk.pop_back();
                col[u] = color;
            } while (u != v);
            color += 1;
        }
    };
    vector<int> app(n);
    int id = 0;
    for (int i = 0; i < n; ++i) {
        if (tin[i] == -1) {
            tarjan(tarjan, i);
        }
    }
    for (int x : col) {
        if (app[x] == false) {
            app[x] = ++id;
        }
    }
    for (int i = 0; i < n; ++i) {
        col[i] = app[col[i]] - 1;
    }
    return col;
}

struct DSU {
    vector<int> fa;
    void init(int n) {
        fa.assign(n, 0);
        iota(fa.begin(), fa.end(), 0);
    }
    int find(int x) {
        return x == fa[x] ? x : fa[x] = find(fa[x]);
    }
    bool unite(int x, int y) {
        x = find(x), y = find(y);
        if (x == y) {
            return false;
        }
        fa[y] = x;
        return true;
    }
};

void solve() {
    int n, m, group;
    cin >> n >> m >> group;

    vector<vector<int>> adj(n);
    vector<array<int, 2>> e(m);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        e[i] = {a, b};
        adj[a].push_back(i);
        adj[b].push_back(i);
    }

    auto init_colors = findSCC(n, adj, e);
//    for (int x : init_colors) {
//        cout << x << " ";
//    }
//    cout << endl;
    vector<int> banned(m);
    int ans = 0;
    vector<int> oth;
    map<pair<int, int>, int> was;
    vector<int> skip(m);
    vector<pair<int, int>> ee(m);
    for (int i = 0; i < m; ++i) {
        if (init_colors[e[i][0]] != init_colors[e[i][1]]) {
            int x = init_colors[e[i][0]];
            int y = init_colors[e[i][1]];
            ee[i] = {x, y};
            if (was.count({x, y})) {
                skip[i] = true;
                was[{x, y}] += 1;
                ans += 1;
            } else {
                was[{x, y}] = 0;
            }
        }
//        cout << ee[i].first << "-" << ee[i].second << " ";
    }
//    cout << endl;
    for (int i = 0; i < m; ++i) {
        if (skip[i]) {
            continue;
        }
//        cout << "process: " << i << " : " << e[i][0] << " " << e[i][1] << endl;
        vector<int> swapped;
        bool yay = ee[i].first != ee[i].second;
        for (int j = 0; j < m; ++j) {
            if (i == j || yay && ee[j] == ee[i]) {
                swapped.push_back(j);
                swap(e[j][0], e[j][1]);
//                cout << "swap " << j << " ";
            }
        }
//        cout << endl;
//        swap(e[i][0], e[i][1]);
        auto cur_colors = findSCC(n, adj, e);
//        for (int x : cur_colors) {
//            cout << x << " ";
//        }
//        cout << endl;
        auto [x, y] = pair(init_colors[e[i][0]], init_colors[e[i][1]]);
        if (x != y) {
            if (x > y) {
                swap(x, y);
            }
        }
        if (cur_colors == init_colors) {
            // I don't have the privilege to NOT specify this
        } else {
            ans += 1;
//            cout << "did the job lol" << endl;
            if (init_colors[e[i][0]] == init_colors[e[i][1]]) {
                oth.push_back(i);
            }
        }
        for (int j : swapped) {
            swap(e[j][0], e[j][1]);
        }
//        swap(e[i][0], e[i][1]);
    }
    auto save = e;
    for (int i : oth) {
        e[i][0] = e[i][1] = -1;
    }
    DSU dsu;
    dsu.init(n);
    auto res = findSCC(n, adj, e);
    for (int x : res) {

    }
    for (int i : oth) {
        e[i] = save[i];
        if (!dsu.unite(res[e[i][0]], res[e[i][1]])) {
            ans -= 1;
        }
    }
    cout << ans << " " << 0 << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int test = 1;
//    cin >> test;
    while (test--) {
        solve();
    }

    return 0;
}