#pragma GCC optimize("O3,unroll-loops")
#include<bits/stdc++.h>
#pragma GCC target("avx,avx2,bmi,bmi2")

using namespace std;

#define all(x) (x).begin(),x.end()

#ifdef DBG
#define debug(x) cout << #x << " = " << x << endl
#else
#define debug(x) 
#endif

using ll = long long;

const int INF = 1e9;

mt19937 rnd(42);

struct Graph {
    int n;
    vector<vector<int>> g;
    vector<vector<int>> rg;

    void rev() {
        for (int v = 0; v < n; ++v) {
            for (int u : g[v]) {
                rg[u].push_back(v);
            }
        }
    }

    
    vector<int> w, wsz;
    vector<int> inn, innsz;
    vector<int> zn;
    void comp_dfs(int v, int t, vector<int>& cp) {
        debug(v << " " << t);
        cp[v] = t;
        innsz[t]++;
        for (int u : rg[v]) {
            if (cp[u] == -1) {
                comp_dfs(u, t, cp);
                inn[t]++;
            } else if (cp[u] != t) {
                w[zn[v]]++;
            } else {
                inn[t]++;
            }
        }
    }

    void top_sort() {
        vector<bool> used(n, 0);

        for (int i = 0; i < n; ++i) {
            if (!used[i]) {
                dfs(i, used);
            }
        }

        int zt = 0;
        zn.assign(n, -1);
        for (int i = 0; i < n; ++i) {
            if (zn[i] == -1) {
                zn_dfs(i, zt++);
            }
        }
        

        w.assign(zt, 0);
        wsz.assign(zt, 0);

        
        reverse(all(tm));
        
        vector<int> cmp(n, -1);
        int timer = 0;
        for (int u : tm) {
            if (cmp[u] != -1) continue;
            inn.push_back(0);
            innsz.push_back(0);
            comp_dfs(u, timer++, cmp);
        }
        vector<bool> f(inn.size(), 1);
        for (int i = 0; i < n; ++i) {
            if (f[cmp[i]]) {
                f[cmp[i]] = 0;
                wsz[zn[i]]++;
            }
        }
    }  

    Graph(vector<vector<int>> g_): g(g_) {
        n = g_.size();
        rg.assign(n, vector<int>());
        rev();

        top_sort();

        int sum = 0;
        debug(w.size());
        debug(inn.size());
        for (int i = 0; i < w.size(); ++i) {
            sum += w[i] - wsz[i] + 1;
        }
        debug(sum);

        // for (int i = 0; i < inn.size(); ++i) {
        //     sum += inn[i] - innsz[i] + 1;
        //     debug(inn[i] << " " << innsz[i]);
        // }

        cout << sum << '\n';
        cout << 1 << '\n';
    }

    vector<int> tm;

    void zn_dfs(int v, int zone) {
        zn[v] = zone;
        for (int u : g[v]) {
            if (zn[u] != -1) continue;
            zn_dfs(u, zone);
        }
        for (int u : rg[v]) {
            if (zn[u] != -1) continue;
            zn_dfs(u, zone);
        }
    }

    void dfs(int v, vector<bool>& used) {
        used[v] = 1;
        for (int u : g[v]) {
            if (used[u]) continue;
            dfs(u, used);
        }
        tm.push_back(v);
    }  
};

inline void solve() {
    int n, m, _;
    cin >> n >> m >> _;
    vector<vector<int>> g(n);

    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
    }
    
    Graph gr(g);
} 


int main() {
    int t = 1;
    #ifdef DBG
    cin >> t;
    #endif
    for (int i = 0; i < t; ++i) {
        solve();
        #ifdef DBG
        cout << '\n';
        #endif
    }
}