#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;

using namespace std;

#define int long long
#define double long double

typedef tree<int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef tree<int, null_type, less_equal <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_multi_set;

int inf = (int)1000 * 1000 * 1000 * 1000 * 1000 * 1000;

struct st //+=, sum
{
    vector <int> t;
    vector <int> p;

    void build(int n)
    {
        t.resize(4 * n, 0);
        p.resize(4 * n, 0);
    }

    void push(int v, int l, int r)
    {
        if (p[v] != 0)
        {
            p[v * 2 + 1] += p[v];
            p[v * 2 + 2] += p[v];
            int m = (l + r) / 2;
            t[v * 2 + 1] += (m - l + 1) * p[v];
            t[v * 2 + 2] += (r - m) * p[v];
            p[v] = 0;
        }
    }

    int get(int v, int l, int r, int ll, int rr)
    {
        if (ll > rr)
        {
            return 0;
        }
        if (l == ll && r == rr)
        {
            return t[v];
        }

        int m = (l + r) / 2;
        push(v, l, r);
        return get(v * 2 + 1, l, m, ll, min(m, rr)) +
               get(v * 2 + 2, m + 1, r, max(m + 1, ll), rr);
    }

    void update(int v, int l, int r, int ll, int rr, int x)
    {
        if (ll > rr)
        {
            return;
        }
        if (l == ll && r == rr)
        {
            t[v] += x * (r - l + 1);
            p[v] += x;
            return;
        }
        int m = (l + r) / 2;
        push(v, l, r);
        update(v * 2 + 1, l, m, ll, min(m, rr), x);
        update(v * 2 + 2, m + 1, r, max(m + 1, ll), rr, x);
        t[v] = t[v * 2 + 1] + t[v * 2 + 2];
    }
};

int mod = 1000 * 1000 * 1000 + 7;

int bin_pow(int a, int x)
{
    if (x == 0)
    {
        return 1;
    }
    if (x % 2 == 0)
    {
        return bin_pow((a * a) % mod, x / 2);
    }
    return (a * bin_pow((a * a) % mod, x / 2)) % mod;
}

int add(int a, int b)
{
    if (a + b >= mod)
    {
        return a + b - mod;
    }
    return a + b;
}

int umn(int a, int b)
{
    return (a * b) % mod;
}

int del(int a, int b)
{
    return umn(a, bin_pow(b, mod - 2));
}

vector <bool> dp;

void dfs(int v, vector <bool> &used, vector <vector <int>> &g)
{
    used[v] = true;
    for (auto u : g[v])
    {
        if (!used[u])
        {
            dfs(u, used, g);
        }
    }
}

void solve()
{
    vector <vector <int>> g;
    int n, m, _;
    cin >> n >> m >> _;
    g.resize(n);
    for (int i = 0; i < m; i ++)
    {
        int a, b;
        cin >> a >> b;
        a --;
        b --;
        g[a].push_back(b);
    }

    vector <vector <bool>> dost(n);
    for (int i = 0; i < n; i ++)
    {
        vector <bool> used(n, false);
        dfs(i, used, g);
        dost[i] = used;
    }

    vector <vector <bool>> dost2(n, vector <bool> (n, false));
    for (int i = 0; i < n; i ++)
    {
        for (int j = i + 1; j < n; j ++)
        {
            if (dost[i][j] && dost[j][i])
            {
                dost2[i][j] = true;
                dost2[j][i] = true;
            }
        }
    }

    dp.resize(1 << m);

    for (int i = 0; i < (1 << m); i ++)
    {
        vector <vector <int>> g2(n);
        int cnt = 0;
        for (int v = 0; v < n; v ++)
        {
            for (auto u : g[v])
            {
                if (i & (1 << cnt))
                {
                    g2[u].push_back(v);
                }
                else
                {
                    g2[v].push_back(u);
                }
                cnt ++;
            }
        }

        bool flag = true;
        vector <vector <bool>> dost3(n, vector <bool> (n, false));
        for (int v = 0; v < n; v ++)
        {
            vector <bool> used(n, false);
            dfs(v, used, g2);

            dost3[v] = used;
        }

        vector <vector <bool>> dost4(n, vector <bool> (n, false));
        for (int ii = 0; ii < n; ii ++)
        {
            for (int j = ii + 1; j < n; j ++)
            {
                if (dost3[ii][j] && dost3[j][ii])
                {
                    dost4[ii][j] = true;
                    dost4[j][ii] = true;
                }
            }
        }

        if (dost2 != dost4)
        {
            flag = false;
        }

        if (flag)
        {
            dp[i] = true;
        }
        else
        {
            dp[i] = false;
        }
    }

    vector <bool> dp2(1 << m, true);
    for (int i = 1; i < (1 << m); i ++)
    {
        if (dp[i])
        {
            dp2[i] = false;
        }
    }

    for (int i = 0; i < (1 << m); i ++)
    {
        if (dp2[i])
        {
            for (int j = 0; j < m; j ++)
            {
                if (i & (1 << j))
                {
                    dp2[i] = dp2[i] && dp2[i ^ (1 << j)];
                }
            }
        }
    }

    int mx = 0;
    for (int i = 0; i < (1 << m); i ++)
    {
        if (dp2[i])
        {
            int cnt = 0;
            for (int j = 0; j < m; j ++)
            {
                if (i & (1 << j))
                {
                    cnt ++;
                }
            }
            mx = max(mx, cnt);
        }
    }
    cout << mx << '\n';
    cout << 1 << '\n';

    /*
    for (int i = 0; i < (1 << m); i ++)
    {
        cout << dp[i] << " ";
    }
    */
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    int _ = 1;
    //cin >> _;
    while (_ --)
    {
        solve();
    }
}
