#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

template<typename T>
istream& operator>>(istream& in, vector<T>& v);
template<typename T>
ostream& operator<<(ostream& out, vector<T>& v);
template<typename T1, typename T2>
istream& operator>>(istream& in, pair<T1, T2>& p);
template<typename T1, typename T2>
ostream& operator<<(ostream& out, pair<T1, T2>& p);

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (T& x : v) in >> x;
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, vector<T>& v) {
    for (T& x : v) out << x << " ";
    return out;
}

template<typename T1, typename T2>
istream& operator>>(istream& in, pair<T1, T2>& p) {
    in >> p.first >> p.second;
    return in;
}

template<typename T1, typename T2>
ostream& operator<<(ostream& out, pair<T1, T2>& p) {
    out << p.first << " " << p.second;
    return out;
}

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
using ll = long long;
using ld = long double;

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

int n, m;
vector<vector<pair<int, int>>> g;
vector<int> est, inv, c;

void dfs1(vector<int>& used, vector<int>& ord, int v) {
    used[v] = 1;
    for (auto [to, i] : g[v]) {
        if (!used[to] && ((est[i] == v) ^ inv[i])) dfs1(used, ord, to);
    }
    ord.push_back(v);
}

void dfs2(vector<int>& res, int v, int cl) {
    res[v] = cl;
    for (auto [to, i] : g[v]) {
        if (res[to] == -1 && ((est[i] == v) ^ inv[i]) == 0) dfs2(res, to, cl);
    }
}

vector<int> calc() {
    vector<int> res(n, -1), used(n), ord;
    for (int i = 0; i < n; i++) {
        if (!used[i]) dfs1(used, ord, i);
    }
//    cout << "here\n";
    reverse(all(ord));
    int cl = 0;
    for (int x : ord) {
        if (res[x] == -1) dfs2(res, x, cl++);
    }
    return res;
}

void solve() {
    vector<bool> is(1 << m);
    for (int mask = 0; mask < (1 << m); mask++) {
        for (int i = 0; i < m; i++) {
            inv[i] = (mask >> i) & 1;
//            cout << ((mask >> i) & 1);
        }
//        cout << ": ";
        vector<int> res = calc();
        if (*max_element(all(c)) == *max_element(all(res))) {
            vector<int> eq(*max_element(all(c)) + 1, -1);
            is[mask] = true;
            for (int i = 0; i < n; i++) {
                if (eq[res[i]] == -1) eq[res[i]] = c[i];
                else if (eq[res[i]] != c[i]) is[mask] = false;
            }
        }

//        for (int x : res) cout << x << " ";
//        cout << ": " << is[mask] << "\n";
    }

//    for (int x : c) cout << x << " ";
//    cout << "\n";

    int mx = 0, cnt = 0;
    for (int mask = 0; mask < (1 << m); mask++) {
        int gd = 1;
        for (int sub = ((1 << m) - 1) & mask; sub > 0; sub = (sub - 1) & mask) {
//            cout << mask << ": " << sub << "\n";
            if (is[sub]) {
                gd = 0;
                break;
            }
        }
//        cout << mask << ": " << gd << "\n";
        if (gd == 1) {
            int len = __builtin_popcount(mask);
            if (len > mx) {
                mx = len, cnt = 1;
            } else if (len == mx) cnt++;
        }
    }

    cout << mx << " " << cnt;
}

signed main() {
#ifndef LOCAL
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
#endif

    int G;
    cin >> n >> m >> G;
    g.resize(n);
    inv.resize(m);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        g[a - 1].emplace_back(b - 1, i);
        g[b - 1].emplace_back(a - 1, i);
        est.push_back(a - 1);
    }

    c = calc();

    if (G <= 2) {
        solve();
        return 0;
    }
}