#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define int long long
#define db long double

using namespace std;
//using namespace __gnu_pbds;
//using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

vector<int> tin, used, color;
vector<vector<int>> g;

void dfs1(int idx) {
    used[idx] = true;

    for (int to : g[idx]) {
        if (!used[to]) {
            dfs1(to);
        }
    }

    tin.push_back(idx);
}

void dfs2(int idx, int col) {
    color[idx] = col;

    for (int to : g[idx]) {
        if (!color[to]) {
            dfs2(to, col);
        }
    }
}

vector<int> kss(vector<pair<int, int>> &edges, int n) {
    g.assign(n + 1, {});

    for (auto [u, v] : edges) {
        g[u].push_back(v);
    }

    used.assign(n + 1, 0);

    int t = 0;
    for (int i = 1; i <= n; ++i) {
        if (!used[i]) {
            dfs1(i);
        }
    }

    g.assign(n + 1, {});
    for (auto [u, v] : edges) {
        g[v].push_back(u);
    }

    color.assign(n + 1, 0);

    reverse(tin.begin(), tin.end());
    for (int i : tin) {
        if (!color[i]) {
            dfs2(i, ++t);
        }
    }

    vector<int> val(t + 1, 0);

    t = 1;
    for (int i = 1; i <= n; ++i) {
        if (!val[color[i]]) {
            val[color[i]] = ++t;
        }
        color[i] = val[color[i]];
    }

    return color;
}

void solve() {
    int n, m, tp; cin >> n >> m >> tp;

    vector<pair<int, int>> edges;
    for (int i = 0; i < m; ++i) {
        int u, v; cin >> u >> v;
        edges.emplace_back(u, v);
    }

    vector<int> owr = kss(edges, n);

    map<int, int> mp;
    for (int mask = 0; mask < (1 << m); ++mask) {
        vector<pair<int, int>> cur;
        for (int i = 0; i < m; ++i) {
            if ((mask >> i) % 2) {
                cur.push_back(edges[i]);
            }
        }

        bool flag = true;
        for (int sub_mask = 1; sub_mask < (1 << cur.size()); ++sub_mask) {
            vector<pair<int, int>> edge;

            for (int i = 0; i < m; ++i) {
                if ((mask >> i) % 2 == 0) {
                    edge.push_back(edges[i]);
                }
            }

            for (int i = 0; i < cur.size(); ++i) {
                if ((sub_mask >> i) % 2) {
                    edge.emplace_back(cur[i].second, cur[i].first);
                } else {
                    edge.push_back(cur[i]);
                }
            }

            vector<int> res = kss(edge, n);
            if (res == owr) {
                flag = false;
                break;
            }
        }

        if (flag) {
            mp[cur.size()]++;
        }
    }

    cout << mp.rbegin()->first << "\n" << mp.rbegin()->second;
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int tt = 1;
    while (tt--) {
        solve();
        cout << "\n";
    }
}