// #pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

// #pragma GCC target("sse4.2,bmi,bmi2,popcnt,lzcnt,avx2")

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef __int128_t d128;
typedef int dgt;
typedef pair<dgt, dgt> pdd;
const dgt MOD = 1e9 + 7;
const dgt INF = 1e9 + 1;
const ll INFLL = 1e18 + 1;
const ld EPS = 1e-9;

// typedef tree<dgt, null_type, less<dgt>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define all(x) x.begin(), x.end()

template<typename T1, typename T2>
istream& operator >> (istream&, pair<T1, T2>&);

template<typename T1, typename T2>
ostream& operator << (ostream&, const pair<T1, T2>&);

template<typename T>
istream& operator >> (istream& is, vector<T>& arr) {
    for (T& el: arr)
        is >> el;
    return is;
}

template<typename T>
ostream& operator << (ostream& os, const vector<T>& arr) {
    for (const T& el: arr)
        os << el << ' ';
    return os;
}

template<typename T1, typename T2>
istream& operator >> (istream& is, pair<T1, T2>& pr) {
    return is >> pr.first >> pr.second;
}

template<typename T1, typename T2>
ostream& operator << (ostream& os, const pair<T1, T2>& pr) {
    return os << pr.first << ' ' << pr.second;
}

vector<vector<pdd>> g;
vector<pdd> edges;
bitset<2000> used, ban;

mt19937_64 gen(4535);
uniform_int_distribution<ull> dist(0, UINT64_MAX);
array<ull, 2000> hh;
ull h_curr;

void dfs(dgt v) {
    h_curr ^= hh[v];
    used[v] = true;
    for (auto[u, num]: g[v])
        if (!used[u] && !ban[num])
            dfs(u);
}

void solve() {
    g.clear();
    edges.clear();
    dgt n, m, gr;
    cin >> n >> m >> gr;
    g.resize(n);
    ull h_all = 0;
    for (dgt i = 0; i < n; ++i)
        h_all ^= hh[i];
    for (dgt i = 0; i < m; ++i) {
        dgt u, v;
        cin >> u >>  v;
        --u, --v;
        g[u].emplace_back(v, i);
        edges.emplace_back(u, v);
    }
    dgt ans = 0;
    unordered_set<ull> st;
    for (dgt i = 0; i < m; ++i) {
        used.reset();
        ban[i] = true;
        h_curr = 0;
        dfs(edges[i].first);
        ban[i] = false;
        if (!used[edges[i].second]) {
            if (st.count(h_all ^ h_curr) == 0) {
                ++ans;
            }
        }
        st.insert(h_curr);
    }
    cout << ans << "\n1\n";
}

signed main() {
    for (dgt i = 0; i < 2000; ++i)
        hh[i] = dist(gen);
    ios::sync_with_stdio(0);
    cin.tie(0);
    int reps = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> reps;
#endif

    for (int i = 0; i < reps; ++i) {
#ifdef LOCAL
        cout << "Test case #" << i << " ===========================\n";
#endif
        solve();
#ifdef LOCAL
        cout << "End test ===============================\n";
#endif
    }

    return 0;
}

// g++ -std=c++23 -Wall -Wextra -Wshadow -O2 -DLOCAL -D_GLIBCXX_DEBUG -D_GLIBCXX_DEBUG_PEDANTIC -fsanitize=address,undefined
