#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <array>
#include <queue>

using namespace std;
typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
const ll N = 2001, MOD = 1e9 + 7;
ll n, m, group;
void calcDAGdfs(ll u, ll nch, vector<vector<ll>>& g, vector<vector<char>>& p, vector<ll>& us) {
	p[nch][u] = 1;
	us[u] = nch;
	for (ll v : g[u]) {
		if (us[v] < nch) {
			calcDAGdfs(v, nch, g, p, us);
		}
	}
}
ll calcDAG(vector<vector<ll>>& g) {
	ll n = g.size();
	vector<vector<char>> p(n, vector<char>(n, 0));
	vector<ll> us(n, -1);
	for (ll u = 0; u < n; u++) {
		calcDAGdfs(u, u, g, p, us);
		p[u][u] = 0;
	}
	ll res = 0;
	for (ll u = 0; u < n; u++) {
		for (ll v : g[u]) {
			char is = 1;
			for (ll k = 0; k < n; k++) {
				is &= !(p[u][k] && p[k][v]);
			}
			res += is;
		}
	}
	return res;
}
ll binpow(ll a, ll n) {
	ll ans = 1;
	while (n > 0) {
		if (n % 1) ans = (ans * a) % MOD;
		a = (a * a) % MOD;
		n /= 2;
	}
	return ans;
}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> m >> group;
	vector<vector<ll>> g(n);
	vector<ll> ra(2*n, 0), rb(2 * n, 0);
	for (ll i = 0; i < m; i++) {
		ll u, v;
		cin >> u >> v;
		u--; v--;
		g[u].push_back(v);
		if ((u + 1) % n != v) {
			ra[u] = 1;
			ra[n + u] = 1;
			rb[v] = 1;
			rb[n + v] = 1;
		}
	}
	ll nra = 2 * n, nrb = 2 * n;
	ll cnt = 0, ans = 1;
	for (ll i = 2 * n - 1; i >= 0; i--) {
		if (i < n && ra[i]) {
			if (nra >= nrb) {
				cnt++;
				ans = (ans * (nrb - i)) % MOD;
			}
		}
		if (ra[i]) nra = i;
		if (rb[i]) nrb = i;
	}
	if (cnt == 0) {
		cnt = 1;
		ans = n;
	}
	cout << n - cnt << "\n" << ans << "\n";
	return 0;
}