#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <array>
#include <queue>

using namespace std;
typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
const ll N = 2001, MOD = 1e9 + 7;
ll n, m, group;
void calcDAGdfs(ll u, ll nch, vector<vector<ll>>& g, vector<vector<char>>& p, vector<ll>& us) {
	p[nch][u] = 1;
	us[u] = nch;
	for (ll v : g[u]) {
		if (us[v] < nch) {
			calcDAGdfs(v, nch, g, p, us);
		}
	}
}
ll calcDAG(vector<vector<ll>>& g) {
	ll n = g.size();
	vector<vector<char>> p(n, vector<char>(n, 0));
	vector<ll> us(n, -1);
	for (ll u = 0; u < n; u++) {
		calcDAGdfs(u, u, g, p, us);
		p[u][u] = 0;
	}
	ll res = 0;
	for (ll u = 0; u < n; u++) {
		for (ll v : g[u]) {
			char is = 1;
			for (ll k = 0; k < n; k++) {
				is &= !(p[u][k] && p[k][v]);
			}
			res += is;
		}
	}
	return res;
}
ll binpow(ll a, ll n) {
	ll ans = 1;
	while (n > 0) {
		if (n % 1) ans = (ans * a) % MOD;
		a = (a * a) % MOD;
		n /= 2;
	}
	return ans;
}
bool dost(ll v, vector<vector<ll>>& g, vector<ll>& us, ll usnow, ll zapv, ll zapu) {
	if (v == zapu) return 1;
	us[v] = usnow;
	for (ll u : g[v]) {
		if (v == zapv && u == zapu) continue;
		if (us[u] < usnow) {
			if (dost(u, g, us, usnow, zapv, zapu)) return 1;
		}
	}
	return 0;
}
ll calcCOMPdfs(ll v, vector<vector<ll>>& g, vector<ll>& us, ll usnow) {
	ll cnt = 0;
	us[v] = usnow;
	for (ll u : g[v]) {
		cnt++;
		if (us[u] < usnow) {
			cnt += calcCOMPdfs(u, g, us, usnow);
		}
	}
	return cnt;
}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> m >> group;
	vector<vector<ll>> g(n);
	for (ll i = 0; i < m; i++) {
		ll u, v;
		cin >> u >> v;
		u--; v--;
		g[u].push_back(v);
	}
	vector<vector<ll>> ng(n);
	vector<ll> us(n, -1);
	ll usnow = 0;
	for (ll u = 0; u < n; u++) {
		for (ll v : g[u]) {
			if (dost(u, g, us, usnow, u, v)) {
				ng[u].push_back(v);
				ng[v].push_back(u);
			}
			usnow++;
		}
	}
	us.assign(n, -1);
	ll res = 0, ans = 1;
	for (ll i = 0; i < n; i++) {
		if (us[i] == -1) {
			ll cnt = calcCOMPdfs(i, ng, us, i);
			if (cnt > 0) {
				res++;
				ans = (ans * cnt) % MOD;
			}
		}
	}
	cout << res << "\n" << ans << "\n";
	return 0;
}