#ifdef ONLINE_JUDGE
#pragma GCC optimize("O3")
#endif

#include <bits/stdc++.h>
#include <random>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;

template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

//int new_tnode(ll x, int tl, int tr, int l = 0, int r = 0);

template<class T>
struct TNode {
    T x;
    int tl, tr;
    int l = 0;
    int r = 0;
    T def;
    function<T(T, T)> sum;

    TNode(T x, T def, function<T(T, T)> sum, int tl, int tr, int l = 0, int r = 0) :
            x(x), def(def), sum(sum), tl(tl), tr(tr), l(l), r(r) {

    }
    // TNode() = default;
    TNode get_l() const {
        return l ? l : TNode<T>(def, tl, (tl + tr) / 2);
    }
    TNode get_r() const {
        return r ? r : TNode<T>(def, (tl + tr) / 2, tr);
    }

    T get(int ll, int rr) {
        if (tr <= ll || rr <= tl) return def;
        if (ll <= tl && tr <= rr) return x;
        return sum(get_l().get(ll, rr), get_r().get(ll, rr));
    }

    void insert(int i, T y) {
        if (tl == i && i + 1 == tr) {
            x = y;
        }
        int tm = (tl + tr) / 2;
        if (i < tm) {
            get_l().insert(i, y);
        } else {
            get_r().insert(i, y);
        }
        x = sum(get_l().x, get_r().x);
    }

};

//vector<TNode> tn(1);

//int new_tnode(ll x, int tl, int tr, int l, int r) {
//    tn.emplace_back(x, tl, tr, l, r);
//    return (int) tn.size() - 1;
//}

//template<class T>
//struct Tree {
//    TNode<T> root;
//    int n, N;
//    T def;
//    function<T(T, T)> sum;
//    Tree(int n, T def, function<T(T, T)> sum): n(n), def(def), sum(sum) {
//        int st = 0;
//        while ((1 << st) < n) ++st;
//        N = (1 << st);
//        root = TNode<T>(def, sum, 0, N);
//    }
//};

#define int long long

int n;
vector<vector<int>> g, gf, gr;
vector<vector<bool>> can;
vector<int> used;

int c = 1;

int dfs(int v) {
    used[v] = c;
    int res = 0;
    for (int u: g[v]) {
        if (can[v][u] && used[u] == c) {
            res++;
        }
        if (can[v][u] && !used[u]) {
            res += dfs(u);
        }
    }
    return res;
}

void solve() {
    int m, _;
    cin >> n >> m >> _;
    g.resize(n);
    gr.resize(n);
    gf.resize(n);
    used.resize(n);
    can = vector<vector<bool>>(n, vector<bool>(n));
    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        --v; --u;
        g[v].push_back(u);
        gf[v].push_back(u);
        gf[u].push_back(v);
        gr[u].push_back(v);
    }
    for (int i = 0; i < n; ++i) {
        if (g[i].size() == 1) {
            can[i][g[i][0]] = true;
        }
        if (gr[i].size() == 1) {
            can[gr[i][0]][i] = true;
        }
    }
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cnt += can[i][j];
        }
    }
    for (int i = 0; i < n; ++i) {
        ++c;
        if (!used[i]) {
            int df = dfs(i);
            cnt -= df;
        }
    }
    cout << cnt << ' ' << 1;
}

signed main() {
#ifdef ONLINE_JUDGE
    ios::sync_with_stdio(false);
cin.tie(nullptr);
#endif
    int t = 1;
//    cin >> t;
    for (int test = 0; test < t; ++test) {
        solve();
        cout << '\n';
    }
    cerr << clock() / 1000.0;
    return 0;
}
