#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;
using Int = long long;
using Uint = unsigned long long;
using Real = long double;
using Int128 = __int128;
using Uint128 = __uint128_t;
// #define _KOSHKA56692
#ifdef _KOSHKA56692
const int MAX = 1e8;
char mem[MAX];
int mempos = 0;
void *operator new(size_t sz) {
    void *res = mem + mempos;
    mempos += sz;
    return res;
}
void operator delete(void *) {}
void operator delete(void *, size_t) {}
#endif
template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T> using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;
istream &operator>>(istream &in, Int128 &num) { Int R; in >> R; num = R; return in; }
ostream &operator<<(ostream &out, const Int128 &num) { out << Int(num); return out; }
istream &operator>>(istream &in, Uint128 &num) { Uint R; in >> R; num = R; return in; }
ostream &operator<<(ostream &out, const Uint128 &num) { out << Uint(num); return out; }

int n, m;
vector<int> tsort;
int use[15], col[15];

void dfs(int v, const vector<vector<int>> &gr) {
    use[v] = true;
    for (auto to : gr[v]) {
        if (!use[to]) {
            dfs(to, gr);
        }
    }
    tsort.push_back(v);
};

void mark(int v, const vector<vector<int>> &gr, int compnum) {
    use[v] = true;
    col[v] = compnum;
    for (auto to : gr[v]) {
        if (!use[to]) {
            mark(to, gr, compnum);
        }
    }
}

vector<vector<int>> get_scc(const vector<pair<int, int>> &edges) {
    tsort.clear();
    vector<vector<int>> gr(n), gr_t(n);
    for (auto [v, to] : edges) {
        gr[v].push_back(to);
        gr_t[to].push_back(v);
    }
    for (int i = 0; i < n; ++i) {
        use[i] = false;
        col[i] = 0;
    }
    for (int v = 0; v < n; ++v) {
        if (!use[v]) {
            dfs(v, gr);
        }
    }
    reverse(tsort.begin(), tsort.end());
    for (int i = 0; i < n; ++i) {
        use[i] = false;
    }
    int compnum = 0;
    for (auto v : tsort) {
        if (!use[v]) {
            mark(v, gr_t, compnum);
            ++compnum;
        }
    }
    vector<vector<int>> scc(compnum);
    for (int v = 0; v < n; ++v) {
        scc[col[v]].push_back(v);
    }
    sort(scc.begin(), scc.end());
    return scc;
}

signed main() {
    ios::sync_with_stdio(false), cin.tie(0);
    cout.setf(ios::fixed), cout.precision(20);
    int G;
    cin >> n >> m >> G;
    vector<pair<int, int>> edges(m);
    for (auto &[v, to] : edges) {
        cin >> v >> to;
        --v, --to;
    }
    auto need = get_scc(edges);
    /*
    for (int col = 0; col < res.size(); ++col) {
        cout << "col: " << col << ": ";
        for (auto el : res[col]) {
            cout << el + 1 << ' ';
        }
        cout << '\n';
    }
    */
    /*
    edges = {{1, 0}, {4, 0}, {2, 4}, {1, 2}, {2, 3}, {3, 1}};
    auto res = get_scc(edges);
    for (int col = 0; col < res.size(); ++col) {
        cout << "col: " << col << ": ";
        for (auto el : res[col]) {
            cout << el + 1 << ' ';
        }
        cout << '\n';
    }
    */
    vector<int> askcnt(20);
    int answ = 0;
    for (int mask = 0; mask < (1 << m); ++mask) {
        int cnt_ok = 0;
        for (int submask = mask; submask > 0; submask = (mask & (submask - 1))) {
            // a!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
            for (int i = 0; i < m; ++i) {
                if ((submask >> i) & 1) {
                    swap(edges[i].first, edges[i].second);
                }
            }
            cnt_ok += (get_scc(edges) == need);
            for (int i = 0; i < m; ++i) {
                 if ((submask >> i) & 1) {
                    swap(edges[i].first, edges[i].second);
                }
            }
            if (cnt_ok) {
                break;
            }
        }
        if (cnt_ok == 0) {
            askcnt[__builtin_popcount(mask)]++;
            answ = max(answ, __builtin_popcount(mask));
            /*
            if (answ == 5) {
                for (int ee = 0; ee < m; ++ee) {
                    if ((mask >> ee) & 1) {
                        cout << edges[ee].first + 1 << ' ' << edges[ee].second + 1 << '\n';
                    }
                }
                return 0;
            }
            */
        }
    }
    cout << answ << '\n' << askcnt[answ] << '\n';
    return 0;
}
