#include <iostream>
#include <set>
#include <vector>
#include <algorithm>
#include <map>
#define ll long long
#define len(x) (int)x.size()
#define ld long double
#define all(x) x.begin(), x.end()
const ll mod1 = 1e9 + 7;

using namespace std;

void print(vector<int>& a) {
    for (auto x : a) {
        cout << x << ' ';
    }
    cout << '\n';
}

void print(vector<ll>& a) {
    for (auto x : a) {
        cout << x << ' ';
    }
    cout << '\n';
}

void print(vector<char>& a) {
    for (auto x : a) {
        cout << x << ' ';
    }
    cout << '\n';
}

void print(vector<string>& a) {
    for (auto x : a) {
        cout << x << ' ';
    }
    cout << '\n';
}

void print(vector<pair<int, int>>& a) {
    for (auto x : a) {
        cout << x.first << ' ' << x.second << '\n';
    }
}

void print(vector<vector<int>>& a) {
    for (auto x : a) {
        print(x);
    }
}

void print(vector<vector<ll>>& a) {
    for (auto x : a) {
        print(x);
    }
}

//#define int ll
//#define mtask

vector<vector<int>> g;
vector<bool> used;
vector<int> tour;
vector<int> col;

void dfs(int cur) {
    used[cur] = true;
    for(int i = 0; i < len(g[cur]); ++i){
        if(g[cur][i] && !used[i]){
            dfs(i);
        }
    }
    tour.push_back(cur);
}

void dfscol(int cur, int cl) {
    col[cur] = cl;
    for(int i = 0; i < len(g[cur]); ++i){
        if(g[i][cur] && col[i] == -1){
            dfscol(i, cl);
        }
    }
}

void solve() {
    int n, m, grp;
    cin >> n >> m >> grp;
    g.resize(n, vector<int>(n));
    vector<pair<int, int>> ed(m);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        ed[i] = { u, v };
        g[u][v] = 1;
    }

    auto getcol = [&] {
        used.assign(n, false);
        col.assign(n, -1);
        tour.clear();
        for (int i = 0; i < n; ++i) {
            if (!used[i]) {
                dfs(i);
            }
        }
        reverse(all(tour));
        int cnt = 0;
        for (int i = 0; i < n; ++i) {
            int cur = tour[i];
            if (col[cur] == -1) {
                dfscol(cur, cnt++);
            }
        }
        return col;
    };

    vector<int> colst = getcol();
    vector<int> dp(1 << m, true);
    int ans = 0;
    int cntans = 1;
    for(int j = 0; j < m; ++j){

        g[ed[j].first][ed[j].second] ^= 1;
        g[ed[j].second][ed[j].first] ^= 1;

        auto curcol = getcol();
        map<int, int> mp;
        bool fl = false;
        for (int i = 0; i < n; ++i) {
            if (mp.find(curcol[i]) != mp.end()) {
                if (colst[i] != mp[curcol[i]]) {
                    fl = true;
                    break;
                }
            }
            else {
                mp[curcol[i]] = colst[i];
            }
        }
        mp.clear();
        for (int i = 0; i < n; ++i) {
            if (mp.find(colst[i]) != mp.end()) {
                if (curcol[i] != mp[colst[i]]) {
                    fl = true;
                    break;
                }
            }
            else {
                mp[colst[i]] = curcol[i];
            }
        }
        if(fl){
            ++ans;
        }

        g[ed[j].first][ed[j].second] ^= 1;
        g[ed[j].second][ed[j].first] ^= 1;
    }
    cout << ans << '\n' << cntans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
#ifdef mtask
    int tt;
	cin >> tt;
	while (tt--)
#endif
    solve();
}