//#define _GLIBCXX_DEBUG 1

//#pragma GCC optimize("O3")
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("inline")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef tree<int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int inf = 2e9;
const ll INF = 9e18;
const int MOD = 1e9 + 7;
const int FFT_MOD = 998244353;
const ld PI = acos(-1);
const ld EPS = 1e-12;

mt19937 rng(42239777);

template <typename T>
istream& operator >> (istream &in, pair<T, T> &a){
    in >> a.first >> a.second;
    return in;
}

template <typename T>
ostream& operator << (ostream &out, pair<T, T> a){
    out << a.first << " " << a.second << " ";
    return out;
}

template <typename T>
istream& operator >> (istream &in, vector<T> &a){
    for (int i = 0; i < a.size(); ++i){
        in >> a[i];
    }
    return in;
}

template <typename T>
ostream& operator << (ostream &out, vector<T> a){
    for (int i = 0; i < a.size(); ++i){
        out << a[i] << " ";
    }
    return out;
}

template <typename T>
ostream& operator << (ostream &out, vector<vector<T>> a){
    for (int i = 0; i < a.size(); ++i){
        out << i << ": " << a[i] << "\n";
    }
    return out;
}

struct segment_tree {
    int n;
    vector<int> tree, add;

    segment_tree() = default;

    segment_tree(int n) : n(n) {
        tree.resize(4 * n);
        add.resize(4 * n);
    }

    segment_tree(vector<int> &a){
        n = a.size();
        tree.resize(4 * n);
        add.resize(4 * n);
        build(1, 0, n, a);
    }

    void build(int v, int l, int r, vector<int> &a){
        if (l + 1 == r){
            tree[v] = a[l];
            return;
        }
        int m = (r + l) / 2;
        build(2 * v, l, m, a);
        build(2 * v + 1, m, r, a);
        tree[v] = tree[2 * v] + tree[2 * v + 1];
    }

    void push(int v, int l, int r){
        int m = (r + l) / 2;
        add[2 * v] += add[v];
        add[2 * v + 1] += add[v];
        tree[2 * v] += add[v] * (m - l);
        tree[2 * v + 1] += add[v] * (r - m);
        add[v] = 0;
    }

    void update(int v, int l, int r, int ql, int qr, int val){
        if (r <= ql || qr <= l){
            return;
        }
        if (ql <= l && r <= qr){
            tree[v] += (r - l) * val;
            add[v] += val;
            return;
        }
        push(v, l, r);
        int m = (r + l) / 2;
        update(2 * v, l, m, ql, qr, val);
        update(2 * v + 1, m, r, ql, qr, val);
        tree[v] = tree[2 * v] + tree[2 * v + 1];
    }

    void update(int ql, int qr, int val){
        update(1, 0, n, ql, qr + 1, val);
    }

    int query(int v, int l, int r, int ql, int qr){
        if (r <= ql || qr <= l){
            return 0;
        }
        if (ql <= l && r <= qr){
            return tree[v];
        }
        push(v, l, r);
        int m = (r + l) / 2;
        return query(2 * v, l, m, ql, qr) + query(2 * v + 1, m, r, ql, qr);
    }

    int query(int ql, int qr){
        return query(1, 0, n, ql, qr + 1);
    }

};

struct Sparse_table {
    int n, logn;
    vector<vector<pair<int, int>>> mn;

    Sparse_table(vector<int> &a){
        n = a.size();
        logn = __lg(n) + 1;
        mn.resize(logn, vector<pair<int, int>>(n, {inf, -1}));
        for (int i = 0; i < n; ++i){
            mn[0][i] = {a[i], i};
        }
        for (int l = 0; l + 1 < logn; ++l){
            for (int i = 0; i + (1 << l) < n; ++i){
                mn[l + 1][i] = min(mn[l][i], mn[l][i + (1 << l)]);
            }
        }
    }

    pair<int, int> rmq(int l, int r){
        int t = __lg(r - l);
        return min(mn[t][l], mn[t][r - (1 << t)]);
    }
};

struct Fenwick_tree {
    int n;
    vector<int> tree;

    Fenwick_tree() = default;

    Fenwick_tree(int n) : n(n){
        tree.resize(n + 1);
    }

    Fenwick_tree(vector<int> &a){
        n = a.size();
        tree.resize(n + 1);
        for (int i = 0; i < n; ++i){
            add(i + 1, a[i]);
        }
    }

    void add(int k, int val){
        for (; k <= n; k += k & -k){
            tree[k] += val;
        }
    }

    int sum(int r){
        int ans = 0;
        for (; r > 0; r -= r & -r){
            ans += tree[r];
        }
        return ans;
    }

    int sum(int l, int r){
        return sum(r) - sum(l - 1);
    }
};

struct Mass_Fenwick {
    int n;
    Fenwick_tree fenw_diff, fenw_magic;

    Mass_Fenwick() = default;

    Mass_Fenwick(int n) : n(n){
        fenw_diff = Fenwick_tree(n);
        fenw_magic = Fenwick_tree(n);
    }

    void update(int l, int r, int x){
        fenw_diff.add(l, x);
        fenw_diff.add(r + 1, -x);
        fenw_magic.add(l, -(l - 1) * x);
        fenw_magic.add(r + 1, r * x);
    }

    int query(int r){
        return r * fenw_diff.sum(r) + fenw_magic.sum(r);
    }

    int query(int l, int r){
        return query(r) - query(l - 1);
    }
};

struct pair_hash {
    template<class T1, class T2>
    size_t operator () (pair<T1, T2> &a){
        size_t h1 = hash<T1>{}(a.first);
        size_t h2 = hash<T2>{}(a.second);
        return (h1 + 53463413) ^ ((h2 >> 2) + (h2 << 6));
    }
};

void stress(){
    while (true){

    }
}

struct MST {
    int n;
    vector<vector<int>> tree;

    MST(vector<int> &a){
        n = a.size();
        tree.resize(4 * n);
        build(1, 0, n, a);
    }

    void build(int v, int l, int r, vector<int> &a){
        if (l + 1 == r){
            tree[v] = {a[l]};
            return;
        }
        int m = (r + l) / 2;
        build(2 * v, l, m, a);
        build(2 * v + 1, m, r, a);
        merge(all(tree[2 * v]), all(tree[2 * v + 1]), back_inserter(tree[v]));
    }

    int query(int v, int l, int r, int ql, int qr, int val){
        if (r <= ql || qr <= l){
            return 0;
        }
        if (ql <= l && r <= qr){
            return std::lower_bound(tree[v].begin(), tree[v].end(), val) - tree[v].begin();
        }
        int m = (r + l) / 2;
        return query(2 * v, l, m, ql, qr, val) + query(2 * v + 1, m, r, ql, qr, val);
    }

    int query(int ql, int qr, int val){
        return query(1, 0, n, ql, qr + 1, val);
    }

};



int n, m, tmp;
vector<vector<int>> g, gt;
vector<pair<int, int>> edges;
vector<bool> used;
int ans = 0, ans_cnt = 1;
vector<int> order;
vector<int> comp;

void dfs1(int v){
    used[v] = true;
    for (int u : g[v]){
        if (!used[u]){
            dfs1(u);
        }
    }
    order.push_back(v);
}

void dfs2(int v, int cur_comp){
    used[v] = true;
    comp[v] = cur_comp;
    for (int u : gt[v]){
        if (!used[u]){
            dfs2(u, cur_comp);
        }
    }
}

void make_comp(){
    comp.assign(n, 0);
    used.assign(n, false);
    order = {};
    for (int v = 0; v < n; ++v){
        if (!used[v]){
            dfs1(v);
        }
    }
    reverse(all(order));
    used.assign(n, false);
    int cur_comp = 0;
    for (int v : order){
        if (!used[v]){
            dfs2(v, cur_comp);
            cur_comp++;
        }
    }
}

bool equal(vector<int> &a, vector<int> &b){
    for (int i = 0; i < a.size(); ++i){
        for (int j = i + 1; j < a.size(); ++j){
            if (a[i] == a[j] && b[i] != b[j]){
                return false;
            }
            if (a[i] != a[j] && b[i] == b[j]){
                return false;
            }
        }
    }
    return true;
}

void dfs3(int v, int cur_comp){
    comp[v] = cur_comp;
    for (int u : g[v]){
        if (u == v + 1){
            dfs3(u, cur_comp);
        }
    }
}

void solve(){
    cin >> n >> m >> tmp;
    used.resize(n);
    edges.resize(m);
    g.resize(n);
    gt.resize(n);
    for (int i = 0; i < m; ++i){
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        edges[i] = {v, u};
        g[v].push_back(u);
        gt[u].push_back(v);
    }

    comp.resize(n);
    int cur_comp = 1;
    for (int v = 0; v < n; ++v){
        if (!comp[v]){
            dfs3(v, cur_comp);
            cur_comp++;
        }
    }

    vector<bool> to_del(n);
    for (int i = 0; i < m; ++i){
        if (comp[edges[i].second] == comp[edges[i].first]){
            to_del[i] = true;
        }
    }

    for (int i = 0; i < m; ++i){
        for (int j = 0; j < m; ++j){
            if (comp[edges[j].first] == comp[edges[i].first] && comp[edges[j].second] == comp[edges[i].second]){
                if (edges[j].first <= edges[i].first && edges[i].second <= edges[j].second){
                    to_del[j] = true;
                }
            }
        }
    }

    for (int i = 0; i < m; ++i){
        if (edges[i].first + 1 == edges[i].second){
            to_del[i] = false;
        }
        ans += to_del[i];
    }
    //cout << to_del << "\n";


    cout << ans << " " << ans_cnt << "\n";
}

int32_t main(){
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    //cin >> t;
    while (t--){
        solve();
    }

    return 0;
}

/*
5 6 0
1 2
1 5
2 3
3 4
3 5
4 2

5 4 0
1 2
2 3
4 5
1 3

6 9 0
1 2
2 3
3 4
4 5
5 6
6 1
2 4
4 6
6 2


*/