#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
int n;
vector<vector<int>>adj,inv_adj;
vector<bool>vis;
vector<int>color;
vector<int>toposort;
int cur_color=1;
void dfs1(int x)
{
    if(vis[x])return;
    vis[x]=true;
    for(auto &y:adj[x])dfs1(y);
    toposort.push_back(x);
}
void dfs2(int x)
{
    if(color[x])return;
    color[x]=cur_color;
    for(auto &y:inv_adj[x])dfs2(y);
}
vector<int>condense(vector<pair<int,int>>edges)
{
    adj.resize(n),inv_adj.resize(n),vis.resize(n),color.resize(n),toposort.clear();
    for(int i=0;i<n;i++)adj[i].clear(),inv_adj[i].clear(),vis[i]=color[i]=0;
    for(auto &x:edges)adj[x.first].push_back(x.second),inv_adj[x.second].push_back(x.first);
    for(int i=0;i<n;i++)dfs1(i);
    reverse(toposort.begin(),toposort.end());
    cur_color=1;
    for(auto &x:toposort)dfs2(x),cur_color++;
    vector<int>idx(n+1,-1);
    int cur_it=0;
    vector<int>rs(n);
    for(int i=0;i<n;i++)
    {
        if(idx[color[i]]==-1)idx[color[i]]=cur_it++;
        rs[i]=idx[color[i]];
    }
    return rs;
}
int main()
{
  int m,g;
  cin>>n>>m>>g;
  vector<pair<int,int>>edges(m);
  for(auto &x:edges)cin>>x.first>>x.second,x.first--,x.second--;
  vector<int>col=condense(edges);
  vector<bool>is_bad(1<<m);
  for(int mask=1;mask<(1<<m);mask++)
  {
     vector<pair<int,int>>nw_edges;
     for(int j=0;j<m;j++)
     {
         if(!(mask&(1<<j)))nw_edges.push_back(edges[j]);
         else nw_edges.push_back({edges[j].second,edges[j].first});
     }
     is_bad[mask]=col==condense(nw_edges);
  }
  for(int i=0;i<m;i++)
    for(int j=0;j<(1<<m);j++)
    if(is_bad[j]&&!(j&(1<<i)))is_bad[j+(1<<i)]=true;
  vector<int>max_v(m+1);
  for(int i=0;i<(1<<m);i++)if(!is_bad[i])max_v[__builtin_popcount(i)]++;
  for(int i=m;i>=0;i--)
  {
      if(max_v[i])
      {
          cout<<i<<" "<<max_v[i]<<endl;
          return 0;
      }
  }
}
