#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

#define int long long
const int MOD = 1e9 + 7;

bool get_bit(int x, int d) {
	return x >> d & 1;
}

struct DSU {
	vector <int> p;
	vector <int> sz;
	int n;

	DSU(int n) {
		this->n = n;
		p.resize(n);
		for (int i = 0; i < n; i++) {
			p[i] = i;
		}
		sz.resize(n, 1);
	}

	int get(int x) {
		if (p[x] == x) return x;
		return p[x] = get(p[x]);
	}

	bool merge(int x, int y) {
		x = get(x);
		y = get(y);
		if (x == y) return 0;
		if (sz[x] > sz[y]) {
			swap(x, y);
		}
		p[x] = y;
		sz[y] += sz[x];
		return 1;
	}

	DSU() {}
};

DSU dsu;

int n, m, G;
vector <vector <int>> g;
vector <vector <int>> cg;
vector <pair <int, int>> eds;

int T;
vector <int> used;

bool dfs(int v, int target, int a, int b) {
	if (v == target) return 1;
	if (used[v] == T) return 0;
	used[v] = T;
	for (auto u : g[v]) {
		if (v == a && u == b) continue;
		if (dfs(u, target, a, b)) return 1;
	}
	return 0;
}

bool check(int v, int u, int a, int b) {
	T++;
	return dfs(v, u, a, b);
}

signed main() {
	cin >> n >> m >> G;
	g.resize(n);
	cg.resize(n);
	used.resize(n);
	T = 1;
	vector <vector <bool>> can(n, vector <bool>(n));
	vector <vector <int>> rg(n);
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--; b--;
		g[a].push_back(b);
		rg[b].push_back(a);
		eds.push_back({ a, b });
	}
	bool fl = 1;
	for (int i = 0; i < n; i++) {
		if (g[i].size() != 1 || rg[i].size() != 1) {
			fl = 0;
		}
	}
	if (fl) {
		cout << n - 1 << '\n' << n;
		return 0;
	}
	int cnt = 0;
	int prod = 1;
	int streak = 0;
	for (int ci = 0; ci < 2 * n; ci++) {
		int i = ci % n;
		if (rg[i].size() == 1 && g[i].size() == 1) {
			streak++;
		}
		else {
			streak++;
			if (streak >= 2) {
				if (ci >= n) {
					cnt += streak - 1;
					prod *= streak;
					prod %= MOD;
				}
			}
			streak = 0;
		}
	}

	cout << cnt << '\n' << prod;
}