#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <random>
#include <deque>
#include <stack>
#include <cmath>
#include <iomanip>

using namespace std;
using ll = long long;
using ld = long double;
using str = string;

//mt19937 rnd(288);

const int INF = 1e9 + 239;
const int EPS = 1e-9;

void fastw() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
}

const ll MOD = 1e9 + 7;

const int MAXN = 2239;
vector<vector<int>> g(MAXN);
vector<vector<int>> t(MAXN);

void solve() {
	int n, m, gg;
	cin >> n >> m >> gg;
	for (int i = 0; i < m; i++) {
		int v, u;
		cin >> v >> u;
		g[v].push_back(u);
		t[u].push_back(v);
	}
	vector<pair<ll, ll>> dp(n + 1);
	dp[1] = { 0, 1 };
	for (int i = 2; i <= n; i++) {
		for (int u : t[i]) {
			if (dp[i].first > dp[u].first + 1) {
				dp[i] = { dp[u].first, 0 };
			}
			if (dp[i].first == dp[u].first + 1) {
				dp[i].second += dp[u].second;
			}
		}
	}
}

int main() {
	fastw();
	int tt = 1;
	//cin >> tt;
	while (tt--) {
		solve();
		cout << '\n';
	}
}