#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <algorithm>
using namespace std;

template<typename T1,typename T2>
istream&operator>>(istream&in,pair<T1,T2>&a){
    return in>>a.first>>a.second;
}
template<typename T1,typename T2>
ostream&operator<<(ostream&out,const pair<T1,T2>&a){
    return out<<a.first<<' '<<a.second<<'\n';
}
template<typename T>
istream&operator>>(istream&in,vector<T>&a){
    for (auto &i:a)in>>i;
    return in;
}
template<typename T>
ostream&operator<<(ostream&out,const vector<T>&a){
    for (const auto &i:a)out<<i<<' ';
    return out;
}
template<typename T>
ostream&operator<<(ostream&out,const vector<vector<T>>&a){
    for (const auto &i:a)out<<i<<'\n';
    return out;
}
typedef long long ll;
const int inf =1e9+7;
namespace Min{
    enum Query{
        Add,
        Set
    };
    template<typename T>
    struct Data{
        T mn{};
        int ind{};
        T d{0};
        Query q{Add};
        Data(int mn={}, int ind={}):mn(mn),ind(ind){}
        Data (const vector<T>&a, int tl):Data(a[tl],tl){}
        Data operator+(const Data&other)const {
            if (mn<=other.mn)return *this;
            return other;
        }
    };
    template<typename T>
    struct SgTree{
        int n;
        vector<Data<T>> d;
        SgTree(int n={}):n(n){
            d.resize(4*n);
        }
        SgTree(const vector<T>&a):SgTree(a.size()){
            build(0,0,n,a);
        }
        Data<T>&build(int v, int tl, int tr, const vector<T>&a){
            if (tl+1==tr)return d[v]={a,tl};
            int tm=(tl+tr)/2;
            return d[v]=build(2*v+1,tl,tm,a)+build(2*v+2,tm,tr,a);
        }
        Data<T> get(int ql, int qr){
            return get(0,0,n,ql,qr);
        }
        Data<T> get(int t, int tl, int tr, int ql, int qr){
            push(t,tl,tr);
            if (tl==ql && tr==qr)return d[t];
            int tm=(tl+tr)/2;
            if (qr<=tm)return get(2*t+1,tl,tm,ql,qr);
            if (ql>=tm)return get(2*t+2,tm,tr,ql,qr);
            return get(2*t+1,tl,tm,ql,tm)+get(2*t+2,tm,tr,tm,qr);
        }
        void push(int t, int tl, int tr){
        }
        void update(int ql, int qr, T d, Query q){
            update(0,0,n,ql,qr,d,q);
        }
        void update(int t, int tl, int tr, int ql,int qr, T d, Query q){
            push(t, tl, tr);
            if (qr<=tl || tr<=ql)return;
            if (tl<=ql && qr<=tr){
                switch (q){
                    case(Set):
                        d[t].d=d;
                        d[t].q=Set;
                        break;
                    case (Add):
                        d[t].d+=d;
                }
                push(t,tl,tr);
                return;
            }
        }
    };
}

void print(bool x){
    if (x)cout<<"First\n";
    else cout<<"Second\n";
}
struct Query{
    int m{};
    int x{};
    int ind{};
    Query(int m={}, int x={}, int ind={}):m(m),x(x),ind(ind){}
    bool operator <(const Query&other)const{
        if (m!=other.m)return m<other.m;
        if (x!=other.x)return x<other.x;
        return ind<other.ind;
    }
};
struct solve{
    int n,m;
    vector<vector<int>>g;
    vector<pair<int,int>>a;
    vector<vector<int>>comps;
    vector<vector<int>>new_comps;
    int time=0;
    int get_bits(int x){
        int res=0;
        for (int i=0;i<m;i++){
            if ((1<<i)&x)res++;
        }
        return res;
    }
    void dfs(int v, int start){
        new_comps[start][v]=time;
        for (auto u:g[v]){
            if (new_comps[start][u]!=time)dfs(u,start);
        }
    }
    void dfsnorm(int v, int start){
        comps[start][v]=time;
        for (auto u:g[v]){
            if (comps[start][u]!=time)dfsnorm(u,start);
        }
    }
    bool get1(int i, int j){
        return (new_comps[i][j]==new_comps[j][i] && new_comps[i][j]==time);
    }
    bool get2(int i, int j){
        return (comps[i][j]==comps[j][i] && comps[i][j]==0);
    }
    bool check(int x){
        for (auto &u:g)u.clear();
        vector<int>b;
        for (int i=0;i<m;i++){
            if ((1<<i)&x)b.push_back(i);
            else g[a[i].first].push_back(a[i].second);
        }
        int t=1<<b.size();
        int res=0;
        for (int y=0;y<t;y++){
            for (int i=0;i<b.size();i++){
                auto [u,v]=a[b[i]];
                if ((1<<i)&y)g[u].push_back(v);
                else g[v].push_back(u);
            }
            time++;
            for (int i=0;i<n;i++){
                dfs(i, i);
            }
            bool flag=true;
            for (int i=0;i<n;i++){
                for (int j=0;j<n;j++){
                    if (get1(i,j)!=get2(i,j))flag=false;
                }
            }
            if (flag)res++;
            if (res>=2)return false;
            for (int i=0;i<b.size();i++){
                auto [u,v]=a[b[i]];
                if ((1<<i)&y)g[u].pop_back();
                else g[v].pop_back();
            }
        }
        return res==1;

    }

    solve(){
        int tt;
        cin>>n>>m>>tt;
        g.resize(n);
        a.resize(m);
        comps.resize(n,vector<int>(n,-1));
        new_comps.resize(n,vector<int>(n,-1));
        for (int i=0;i<m;i++){
            int u,v;
            cin>>u>>v;
            u--;
            v--;
            a[i]={u,v};
            g[u].push_back(v);
        }
        for (int i=0;i<n;i++){
            dfsnorm(i, i);
        }


        int t=1<<m;
        int ans=-1;
        int cnt=0;
        for (int x=0;x<t;x++){
            if (check(x)){
                int res=get_bits(x);
                if (ans==res)cnt++;
                else if (res>ans){
                    ans=res;
                    cnt=1;
                }
            }
        }
        cout<<ans<<' '<<cnt<<'\n';

    }
};
int main()
{
    int t=1;
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    while(t--)solve();
}
