#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

#define len(x) (int)x.size()
#define all(x) x.begin(), x.end()
const ll INF = 1e18;
const int INFi = 1e9;

void dfs(int v, vector<int> &used, vector<vector<int>> &g, vector<int> &t) {
    used[v] = 1;
    for (int to: g[v]) if (!used[to]) {
        dfs(to, used, g, t);
    }
    t.push_back(v);
}

int on_comp(vector<vector<int>> &g, vector<vector<int>> &gr) {
    int n = len(g);
    vector<int> used(n);
    vector<int> t;
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs(i, used,g, t);
        }
    }
    reverse(all(t));
    used.assign(n, 0);
    vector<int> comp(n);
    int cur = 0;
    for (int i: t) {
        if (!used[i]) {
            vector<int> c;
            dfs(i, used,gr, c);
            for (auto v: c) {
                comp[v] = cur;
            }
            ++cur;
        }
    }
    return cur;
}

void solve() {
    int n, m, ggg;
    cin >> n >> m >> ggg;

    vector<vector<int>> g(n), gr(n);

    vector<pair<int, int>> edges;
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a;
        --b;
        g[a].push_back(b);
        gr[b].push_back(a);
        edges.emplace_back(a, b);
    }

    int ans = 0;
    for (int i = 0; i < m; ++i) {
        auto [v, u] = edges[i];
        g[v].erase(find(all(g[v]), u));
        gr[u].erase(find(all(gr[u]), v));

        g[u].push_back(v);
        gr[v].push_back(u);

        if (on_comp(g, gr) != 1) {
            ++ans;
        } else {
            gr[v].pop_back(); g[u].pop_back();
            g[v].push_back(u); gr[u].push_back(v);
        }
    }

    cout << ans << '\n' << 1 << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt","w", stdout);
#endif

    int t = 1;
//    cin >> t;
    while(t--) {
        solve();
    }

    return 0;
}