#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <string>
#include <queue>

#define len(v) (int)((v).size())
#define ss second
#define ff first


typedef long long ll;

using namespace std;

const ll inf = 1e12 + 7;

const int N = 2005;
vector<int> g[N];

const int M = 1e9 + 7;

int fac[N];

int fp(int x, int y) {
	if (y == 0) return 1;
	int p = fp(x, y / 2);
	p = (p * 1ll * p) % M;
	if ((y & 1) == 0) return p;
	p = (p * 1ll * x) % M;
	return p;
}

int inv(int x) {
	return fp(x, M - 2);
}

int c(int n, int k) {
	return (fac[n] * 1ll * inv(fac[k])) % M * 1ll * inv(fac[n - k]) % M;
}

int n, m, gr;
int calc(bool fl) {
	int res = 0;

	for (int v = 0; v < n; ++v) {
		for (int u : g[v]) {
			g[u].push_back(v);
			vector<bool> us(n);
			us[v] = true;
			queue<int> q;
			q.push(v);
			while (!q.empty()) {
				int qv = q.front();
				q.pop();

				for (int qu : g[qv]) {
					if (qv == v && qu == u) continue;
					if (us[qu]) continue;

					us[qu] = true;
					q.push(qu);
				}
			}
			if (fl || us[u]) g[u].pop_back();
			if (!us[u]) {
				++res;
			}
		}
	}
	return res;
}

void solve() {

	cin >> n >> m >> gr;

	for (int i = 0; i < m; ++i) {
		int x, y;
		cin >> x >> y;
		g[--x].push_back(--y);
	}

	int k = calc(true);
	int n = calc(false);

	cout << k << '\n' << c(n, k) << '\n';
}

signed main() {
	fac[0] = 1;
	for (int i = 1; i < N; ++i) {
		fac[i] = (fac[i - 1] * 1ll * i) % M;
	}

	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cout.precision(30);

	int t = 1;
	//	cin >> t;
	while (t--) solve();
}



