#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <string>
#include <queue>

#define len(v) (int)((v).size())
#define ss second
#define ff first


typedef long long ll;

using namespace std;

const ll inf = 1e12 + 7;

const int N = 2005;
vector<int> g[N];
vector<int> ng[N];
const int M = 1e9 + 7;

bool used[N];

vector<int> ord;

void dfs(int v) {
	used[v] = true;
	for (int u : g[v]) {
		if (!used[u]) dfs(u);
	}
	ord.push_back(v);
}

int c[N], ctr[N];
vector<int> rg[N];

void dfs(int v, int cl) {
	c[v] = cl;
	for (int u : g[v]) {
		if (c[u] == -1) {
			dfs(u, cl);
		}
	}
}


void solve() {
	int n, m, gr;
	cin >> n >> m >> gr;


	for (int i = 0; i < n; ++i) {
		c[i] = -1;
	}

	for (int i = 0; i < m; ++i) {
		int x, y;
		cin >> x >> y;
		g[--x].push_back(--y);
		rg[y].push_back(x);
	}

	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			dfs(i);
		}
	}

	int cnt = 0;
	for (int i = 0; i < n; ++i) {
		if (c[ord[i]] == -1) {
			bool fl = false;
			for (int j : rg[i]) {
				if (c[j] == -1) {
					fl = true;
					dfs(ord[i], cnt);
				}
			}
			cnt += fl;
		}
	}

	reverse(ord.begin(), ord.end());

	map<int, int> tr;
	for (int i = 0; i < n; ++i) {
		tr[ord[i]] = i;
	}

	for (int i = 0; i < n; ++i) {
		for (int j : g[i]) {
			ng[tr[i]].push_back(tr[j]);
		}
	}

	for (int i = 0; i < n; ++i) {
		ctr[tr[i]] = c[i];
	}

	int res1 = 0, res2 = 0;
	vector<vector<int>> cmps(n);
	vector<map<int, int>> ng(n);

	for (int v = 0; v < n; ++v) {
		cmps[c[v]].push_back(v);
		for (int u : g[v]) {
			if (c[u] != c[v]) {
				ng[c[v]][c[u]]++;
			}
		}
	}

	vector<vector<int>> dp(cnt, vector<int>(cnt, 0));
	for (int i = 0; i < cnt; ++i) {
		dp[i][i] = 1;
	}

	for (int v = 0; v < cnt; ++v) {
		for (pair<int, int> u : ng[v]) {
			for (int j = 0; j <= u.first; ++j) {
				dp[v][j] = min(dp[v][j] + dp[u.first][j], 2);
			}
		}

		for (pair<int, int> u : ng[v]) {
			if (dp[v][u.first] > 1) {
				res1 += u.second;
			}
		}
	}

	for (int v = 0; v < n; ++v) {
		for (int u : g[v]) {
			if (c[u] != c[v]) {
				continue;
			}
			g[u].push_back(v);
			vector<bool> us(n);
			us[v] = true;
			queue<int> q;
			q.push(v);
			while (!q.empty()) {
				int qv = q.front();
				q.pop();

				for (int qu : g[qv]) {
					if (qv == v && qu == u) continue;
					if (us[qu]) continue;

					us[qu] = true;
					q.push(qu);
				}
			}
			if (us[u])
				g[u].pop_back();
			if (!us[u]) {
				++res2;
			}
		}
	}


	cout << res1 + res2 << '\n';
	cout << 1 << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cout.precision(30);

	int t = 1;
	//	cin >> t;
	while (t--) solve();
}




