#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define all(x) x.begin(), x.end()

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pr = pair<ll, ll>;
const int MOD = 1e9 + 7;
const int INF = 1e9 + 1;
const ll INFLL = 1e18 + 1;
int reps = 1;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> oset;

template<typename T>
inline void print(const vector<T> &a, string sep=" ") {
    for (auto &x : a) cout << x << sep;
    cout << "\n";
}

template<typename T>
inline void print(const set<T> &a, string sep=" ") {
    for (auto &x : a) cout << x << sep;
    cout << "\n";
}

template<typename T>
inline void rr(vector<T> &a, int n) {
    a.clear();
    a.resize(n);
}

//====================================

vector<vector<int>> g, rg;
vector<int> used, color, ord, h, p;

void dfs(int v) {
    used[v] = 1;
    for (auto u : g[v]) {
        if (used[u]) continue;
        dfs(u);
    }
    ord.push_back(v);
}

void dfs2(int v, int cc) {
    color[v] = cc;
    for (auto u : rg[v]) {
        if (color[u] != -1) continue;
        dfs2(u, cc);
    }
}

struct DSU
{
    int n;
    vector<int> p, sz, asz, mn;
    DSU () {}
    DSU (int _n) : n(_n), p(n), sz(n, 1), asz(n, 1), mn(n) {
        iota(all(p), 0);
        iota(all(mn), 0);
    }
    int root(int x) {
        if (x == p[x]) return x;
        return p[x] = root(p[x]);
    }
    bool unite(int x, int y) {
        x = root(x);
        y = root(y);
        if (x == y) return false;
        if (sz[x] < sz[y]) swap(x, y);
        sz[x] += sz[y];
        asz[x] += asz[y] + 1;
        p[y] = x;
        if (h[mn[y]] < h[mn[x]]) mn[x] = mn[y];
        return true;
    }
};

DSU s;

int add = 0;

void dfs3(int v) {
    used[v] = 1;
    for (auto u : g[v]) {
        if (color[u] != color[v]) continue;
        if (used[u] == 1) {
            int k = v;
            while (h[k] > h[u]) {
                int nv = p[s.mn[s.root(k)]];
                s.unite(k, v);
                k = nv;
            }
        } else if (used[u] == 2) {
            add++;
            continue;
        } else {
            h[u] = h[v] + 1;
            p[u] = v;
            dfs3(u);
        }
    }
    used[v] = 2;
}

void solve() {
    int n, m, gg; cin >> n >> m >> gg;
    rr(g, n); rr(rg, n); rr(used, n); rr(h, n);
    ord.clear();
    color.clear();
    color.resize(n, -1);
    for (int i = 0; i < m; i++) {
        int u, v; cin >> u >> v; u--; v--;
        g[u].push_back(v);
        rg[v].push_back(u);
    }
    for (int v = 0; v < n; v++) {
        if (!used[v]) dfs(v);
    }
    reverse(all(ord));
    int cc = 0;
    for (auto v : ord) {
        if (color[v] == -1) {
            dfs2(v, cc);
            cc++;
        }
    }
    // print(color);
    rr(used, n); rr(p, n); rr(h, n); 
    s = DSU(n);
    for (int v = 0; v < n; v++) {
        if (!used[v]) dfs3(v);
    }
    ll res = add;
    ll ans = 1;
    for (int v = 0; v < n; v++) {
        // cout << s.root(v) << " ";
        if (s.p[v] == v && s.sz[v] > 1) {
            res += s.asz[v] - 1;
            ans = (ans * (s.asz[v])) % MOD; 
        }
    }
    // cout << "\n";
    cout << res << " \n" << ans << "\n";
}

//====================================

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL 
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> reps;
#endif
    for (int i = 0; i < reps; i++) {
#ifdef LOCAL 
        cout << "Test case #" << i + 1 << " ==============\n";
#endif
        solve();
#ifdef LOCAL 
        cout << "End test ==============\n";
#endif
    }
    return 0;
}

// g++ -std=c++23 -Wall -Wextra -Wshadow -DLOCAL -D_GLIBCXX_DEBUG -fsanitize=address,undefined -O2 A.cpp -o A
