//#pragma GCC optimize("O3,unroint-loops")
#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr ll INF = 1e18;

void dfs1(int v, vector<vector<int>> &g, vector<bool> &used, vector<int> &ord) {
    used[v] = true;
    for (int to : g[v]) {
        if (!used[to]) {
            dfs1(to, g, used, ord);
        }
    }
    ord.push_back(v);
}

void dfs2(int v, vector<vector<int>> &g, vector<int> &colour, int cur_colour) {
    colour[v] = cur_colour;
    for (int to : g[v]) {
        if (colour[to] == -1) {
            dfs2(to, g, colour, cur_colour);
        }
    }
}

inline void calc_comp(int n, vector<vector<int>> &g, vector<int> &colour, int &k) {
    vector<int> ord;
    vector<bool> used(n, false);
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs1(i, g, used, ord);
        }
    }
    reverse(ord.begin(), ord.end());

    vector<vector<int>> rev(n);
    for (int i = 0; i < n; ++i) {
        for (int to : g[i]) {
            rev[to].push_back(i);
        }
    }
    k = 0;
    colour.resize(n, -1);
    for (int i = 0; i < n; ++i) {
        if (colour[ord[i]] == -1) {
            dfs2(ord[i], rev, colour, k++);
        }
    }
}

inline bool check_comp(int n, int k1, vector<int> &c1, int k2, vector<int> &c2) {
    if (k1 != k2) {
        return false;
    }

    vector<int> paraint(k1, -1);
    for (int i = 0; i < n; ++i) {
        if (paraint[c1[i]] == -1) {
            paraint[c1[i]] = c2[i];
        } else if (c2[i] != paraint[c1[i]]) {
            return false;
        }
    }
    return true;
}

inline bool check_lol(int n, int k1, vector<int> &c1, vector<vector<int>> &g, vector<pair<int, int>> &v1, vector<pair<int, int>> &v2) {
    int cnt = 0;
    for (int i = 0; i < (1 << v1.size()); ++i) {
        int i1 = i;
        for (int j = 0; j < v1.size(); ++j) {
            if (i1 & 1) {
                g[v1[j].first].push_back(v1[j].second);
            } else {
                g[v2[j].first].push_back(v2[j].second);
            }
            i1 >>= 1;
        }

        vector<int> c2;
        int k2;
        calc_comp(n, g, c2, k2);
        if (check_comp(n, k1, c1, k2, c2)) {
            cnt++;
        }

        i1 = i;
        for (int j = 0; j < v1.size(); ++j) {
            if (i1 & 1) {
                g[v1[j].first].pop_back();
            } else {
                g[v2[j].first].pop_back();
            }
            i1 >>= 1;
        }
    }

    if (cnt == 1) {
        return true;
    }
    return false;
}

void solve() {
    int n, m, group;
    cin >> n >> m >> group;
    vector<vector<int>> g(n);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
    }

    vector<int> c1;
    int k1;
    calc_comp(n, g, c1, k1);

    int ans = -1, cnt = 0;
    for (int i = 0; i < (1 << m); ++i) {
        vector<vector<int>> g1(n);
        vector<pair<int, int>> venom1, venom2;
        int i1 = i, cur = 0;
        for (int j = 0; j < n; ++j) {
            for (int jj : g[j]) {
                if (i1 & 1) {
                    g1[j].push_back(jj);
                } else {
                    venom1.emplace_back(j, jj);
                    venom2.emplace_back(jj, j);
                    cur++;
                }
                i1 >>= 1;
            }
        }

        if (check_lol(n, k1, c1, g1, venom1, venom2)) {
            if (ans == cur) {
                cnt++;
            } else if (ans < cur) {
                ans = cur;
                cnt = 1;
            }
        }
    }

    cout << ans << ' ' << cnt << '\n';
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}
