#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>

using namespace std;

typedef long long ll;
typedef long double ld;

#define int long long
#define ff first
#define ss second
#define endl '\n'
#define all(a) (a).begin, (a).end()

const int INF = 1e18 + 123;

void dfs(int v, vector<vector<pair<int, int>>>& g, vector<int>& used) {
    used[v] = 1;
    for (auto u : g[v]) {
        if (u.ss == 1 && !used[u.ff]) {
            dfs(u.ff, g, used);
        }
    }
}

void solve() {
    int n, m, ggg;
    cin >> n >> m >> ggg;
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        x--, y--;
        g[x].push_back({y, 1});
    }

    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < g[i].size(); ++j) {
            g[i][j].ss = 0;
            vector<int> used(n);
            dfs(i, g, used);
            g[i][j].ss = 1;
            if (used[g[i][j].ff]) {
                ans++;
            }
        }
    }
    cout << ans << " " << 1 << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int qq = 1;
//    cin >> qq;
    while (qq--) {
        solve();
    }
}
