#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template<class T>
using kekset = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

#define int int64_t
#define endl '\n'

void solve() {
    int n, m, group;
    cin >> n >> m >> group;
    vector<pair<int, int>> lst(m);
    vector<vector<int>> g(n);
    vector<vector<int>> t(n);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        g[--u].push_back(--v);
        lst[i] = {u, v};
    }
    for (int i = 0; i < n; ++i) {
        for (int to : g[i]) {
            t[to].push_back(i);
        }
    }

    vector<int> ts;
    vector<char> used(n);
    vector<int> comp(n);
    int k = 0;

    auto dfs_ts = [&](auto&& self, int v) -> void {
        used[v] = true;
        for (int to : g[v]) {
            if (!used[to]) {
                self(self, to);
            }
        }
        ts.push_back(v);
    };

    for (int v = 0; v < n; ++v) {
        if (!used[v]) {
            dfs_ts(dfs_ts, v);
        }
    }

    auto dfs_kss = [&](auto&& self, int v) -> void {
        comp[v] = k;
        for (int to : t[v]) {
            if (!comp[to]) {
                self(self, to);
            }
        }
    };

    reverse(ts.begin(), ts.end());

    for (int v : ts) {
        if (!comp[v]) {
            ++k;
            dfs_kss(dfs_kss, v);
        }
    }

    auto check = [](int n, const vector<pair<int, int>>& l) -> vector<int> {
        vector<vector<int>> g(n);
        vector<vector<int>> t(n);
        for (auto& [u, v] : l) {
            g[u].push_back(v);
        }
        for (int i = 0; i < n; ++i) {
            for (int to : g[i]) {
                t[to].push_back(i);
            }
        }

        vector<int> ts;
        vector<char> used(n);
        vector<int> comp(n);
        int k = 0;

        auto dfs_ts = [&](auto&& self, int v) -> void {
            used[v] = true;
            for (int to : g[v]) {
                if (!used[to]) {
                    self(self, to);
                }
            }
            ts.push_back(v);
        };

        for (int v = 0; v < n; ++v) {
            if (!used[v]) {
                dfs_ts(dfs_ts, v);
            }
        }

        auto dfs_kss = [&](auto&& self, int v) -> void {
            comp[v] = k;
            for (int to : t[v]) {
                if (!comp[to]) {
                    self(self, to);
                }
            }
        };

        reverse(ts.begin(), ts.end());
        for (int v : ts) {
            if (!comp[v]) {
                ++k;
                dfs_kss(dfs_kss, v);
            }
        }

        return comp;
    };

    int ans = 0;

    for (int mask = 0; mask < 1 << m; ++mask) {
        vector<pair<int, int>> l;
        for (int i = 0; i < m; ++i) {
            if (mask >> i & 1) l.push_back(lst[i]);
            else l.push_back({lst[i].second, lst[i].first});
        }
        if (check(n, l) == comp) ans = max(ans, m - int(popcount(unsigned(mask))));
    }

    cout << ans << endl;
    //cout << 73 << endl;
    //cerr << "ULYANOVSK" << endl;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int test = 1;
    //cin >> test;

    while (test--) {
        solve();
    }

    return 0;
}