#include <iostream>
#include <algorithm>
#include <vector>
#include <bitset>
#include <cmath>
#include <set>

const int maxn = 2000;
std::vector<std::bitset<maxn>> near, can;
std::vector<std::vector<int>> g, s, g2;
std::vector<int> used, used2, cl, tp;
int color = 0, tim = 1;
int ans = 0;
void dfs(int i) {
	used[i] = 1;
	for (int to : s[i]) {
		if (!used[to]) {
			dfs(to);
		}
	}
	tp.push_back(i);
}
void dfs2(int i) {
	cl[i] = color;
	for (int to : g[i]) {
		if (cl[to] == -1) {
			dfs2(to);
		}
	}
}
void dfs3(int i) {
	used2[i] = 1;
	std::bitset<maxn> p;
	for (int to : g2[i]) {
		if (!used2[to]) {
			dfs3(to);
		}
		can[i][to] = 1;
		can[i] |= can[to];
		p |= (can[to] & near[i]);
	}
	ans += p.count();
}
void solve() {
	int n, m, t;
	std::cin >> n >> m >> t;
	g.resize(n);
	s.resize(n);
	near.resize(n);
	can.resize(n);
	used.resize(n);
	cl.resize(n, -1);
	for (int i = 0; i < m; ++i) {
		int u, v;
		std::cin >> u >> v;
		--u;
		--v;
		g[u].push_back(v);
		s[v].push_back(u);
	}
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			dfs(i);
		}
	}
	for (int i = n - 1; i >= 0; --i) {
		if (cl[tp[i]] == -1) {
			dfs2(i);
			++color;
		}
	}
	g2.resize(color);
	used2.resize(color);
	near.resize(color);
	can.resize(color);
	for (int i = 0; i < n; ++i) {
		for (int j : g[i]) {
			if (cl[i] != cl[j]) {
				near[cl[i]][cl[j]] = 1;
			}
		}
	}
	for (int i = 0; i < color; ++i) {
		for (int j = 0; j < i; ++j) {
			if (near[i][j]) {
				g2[i].push_back(j);
			}
		}
	}
	for (int i = 0; i < color; ++i) {
		if (!used2[i]) {
			dfs3(i);
		}
	}
	std::cout << ans << '\n' << 1 << '\n';
}
int main() {
	int t = 1;
	//std::cin >> t;
	while (t--) {
		solve();
	}
}