#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

#define all(x) begin(x), end(x)
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

ll ran(ll l = LLONG_MIN, ll r = LLONG_MAX) {
    return uniform_int_distribution<ll>(l, r)(rnd);
}
vector<ll> css, topsort, main_css;
vector<ll> mincss;

void dfs(ll v, vector<vector<ll>> &g, vector<ll> &u){
    u[v] = 1;
    for (auto &x: g[v]) if (!u[x]) dfs(x, g, u);
    topsort.push_back(v);
}

void rdfs(ll v, ll c, vector<vector<ll>> &rg, vector<ll> &ru){
    ru[v] = 1;
    css[v] = c;
    for (auto &x: rg[v]) if (!ru[x]) rdfs(x, c, rg, ru);
}

void find_css(vector<ll> &denied, vector<pair<ll,ll>> &ed, ll n){
    vector<vector<ll>> g(n), rg(n);
    vector<ll> u(n), ru(n);
    topsort.clear();
    for (int i=0; i<ed.size(); ++i) {
        if (!denied[i]) g[ed[i].first].push_back(ed[i].second), rg[ed[i].second].push_back(ed[i].first);
        else g[ed[i].second].push_back(ed[i].first), rg[ed[i].first].push_back(ed[i].second);
    }
    for (int i=0; i<n; ++i)
        if (!u[i])
            dfs(i, g, u);
    reverse(all(topsort));
    ll cnt = 0;
    for (auto &x: topsort) {
        if (!ru[x])
            mincss[x] = 1, rdfs(x, ++cnt, rg, ru);
        else
            mincss[x] = 0;
    }
}

bool check(vector<ll> &numb_denied, vector<pair<ll,ll>> &ed, ll n){
    for (int awd=0; awd<500; ++awd){
        vector<ll> denied(ed.size(), 0);
        for (auto &x: numb_denied) denied[x] = ran(0, 1);
        if (denied == vector<ll> (ed.size(), 0)) continue;
        find_css(denied, ed, n);
        ll fl = 1;
        for (int i=0; i<n; ++i)
            if (mincss[i])
                for (int j=0; j<n; ++j)
                    if (css[i] == css[j] && main_css[i] != main_css[j] || main_css[i] == main_css[j] && css[i] != css[j])
                        fl = 0;
        if (fl) return false;
    }
    return true;
}

void solve() {
    int n, m, adwdasd;
    cin >> n >> m >> adwdasd;
    css.resize(n);
    mincss.resize(n);
    vector<pair<ll,ll>> ed(m);
    for (auto &x: ed) cin >> x.first >> x.second, --x.first, --x.second;
    vector<ll> asdasd(m, 0);
    find_css(asdasd, ed, n);
    main_css = css;
    ll ma_ans = 0;
    ll cnt_ma_ans = 0;
    for (int i=1; i<(1 << m)-1; ++i){
        vector<ll> numb;
        for (int j=0; j<m; ++j) if ((i >> j) & 1) numb.push_back(j);
        if (check(numb, ed, n)){
            if (numb.size() > ma_ans){
                ma_ans = numb.size();
                cnt_ma_ans = 1;
            }else if (numb.size() == ma_ans){
                ++cnt_ma_ans;
            }
        }
    }
    cout << ma_ans << '\n' << cnt_ma_ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ll t = 1;
//    cin >> t;
    while (t--) solve(), cout << '\n';
    return 0;
}