#include <bits/stdc++.h>

using namespace std;
#define int long long

struct line {
    int k, b, ind;

    line() : k(0), b(0), ind(0) {};

    line(int _k, int _b, int _ind) : k(_k), b(_b), ind(_ind) {};

    int get(int x) {
        return k * x + b;
    }
};

deque<line> st;
int sz = 0;

long double interSect(line a, line b) {
    return (long double) (b.b - a.b) / (long double) (a.k - b.k);
}

void push(line k) {
    while (sz >= 2 && interSect(st[0], st[1]) <= interSect(st[0], k))
        st.pop_front(), sz--;
    st.push_front(k), sz++;
}

int get(int x) {
    int l = 0, r = sz;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        if (interSect(st[mid - 1], st[mid]) <= x)
            l = mid;
        else
            r = mid;
    }
    return st[l].get(x);
}

int solve(vector<int> &a, vector<int> &b, int T) {
    st.clear(), sz = 0;
    int n = (int) a.size(), res = 0;
    vector<int> p(n);
    for (int i = 0; i < (int) a.size(); i++) p[i] = (i > 0 ? p[i - 1] : 0) + a[i];
    bool used[n];
    for (int i = 0; i < n; i++) used[i] = false;
    for (int i = 0; i < (int) b.size(); i++) used[b[i]] = true;
    deque<int> good;
    for (int i = 0; i < n; i++) {
        if (used[i]) {
            good.emplace_back(i);
            int ind = i;
            push(line(-ind, (ind > 0 ? p[ind - 1] : 0), i));
        }
        while (!good.empty() && (good[0] > 0 ? p[good[0] - 1] : 0) < (i > 0 ? p[i - 1] : 0) - T) {
            if (sz > 0 && st.back().ind == good[0]) st.pop_back(), sz--;
            good.pop_front();
        }
        if (sz > 0) {
            int val = get(a[i]);
            int new_val = (T - (i > 0 ? p[i - 1] : 0) + val);
            if (new_val >= 0) new_val /= a[i];
            else {
                if (new_val % a[i] == 0) new_val /= a[i];
                else new_val = new_val / a[i] - 1;
            }
            res = max(res, i + new_val);
        }
    }
    return res;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m, T, res = 0;
    cin >> n >> m >> T;
    vector<int> a(n), b(m);
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < m; i++) cin >> b[i], b[i]--;
    res = max(res, solve(a, b, T));
    reverse(a.begin(), a.end());
    for (int i = 0; i < m; i++) b[i] = n - b[i] - 1;
    res = max(res, solve(a, b, T));
    cout << res;
    return 0;
}