#include<iostream>
#include<algorithm>
#include<vector>

using namespace std;

#define ll long long

const ll maxn = 5 * 1e5;
pair<ll, ll> t[4 * maxn];
vector<ll> a;

void build(ll v, ll l, ll r) {
    if (l == r - 1) {
        t[v] = {a[l], l};
        return;
    }
    ll m = (l + r) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    t[v] = min(t[2 * v + 1], t[2 * v + 2]);
}

pair<ll, ll> min1(ll v, ll l, ll r, ll l1, ll r1) {
    if (l >= r1 || r <= l1) {
        return {1e18, 1e18};
    }
    if (l >= l1 && r <= r1) {
        return t[v];
    }
    ll m = (l + r) / 2;
    pair<ll, ll> p1 = min1(2 * v + 1, l, m, l1, r1);
    pair<ll, ll> p2 = min1(2 * v + 2, m, r, l1, r1);
    return min(p1, p2);
}

vector<ll> pref;

ll sum(ll l, ll r) {
    if (l > r) {
        return 0;
    }
    if (l == 0) {
        return pref[r];
    }
    return pref[r] - pref[l - 1];
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll n, m, t;
    cin >> n >> m >> t;
    a.resize(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
    }
    build(0, 0, n);
    vector<ll> b(m);
    for (ll i = 0; i < m; i++) {
        cin >> b[i];
        b[i]--;
    }
    pref.resize(n);
    pref[0] = a[0];
    for (ll i = 1; i < n; i++) {
        pref[i] = pref[i - 1] + a[i];
    }
    ll answer1 = 0;
    for (ll i = 0; i < m; i++) {
        ll l = i;
        ll r = n - (m - i);
        pair<ll, ll> p1 = min1(0, 0, n, l, r + 1);
        if (p1.second == b[i]) {
            answer1 = max(answer1, t / a[b[i]]);
            continue;
        }
        if (p1.second < b[i]) {
            ll sum1 = sum(p1.second + 1, b[i]);
            if (sum1 <= t) {
                ll answer = b[i] - p1.second;
                answer += (t - sum1) / a[p1.second];
                answer1 = max(answer1, answer);
            } else {
                ll l1 = p1.second;
                ll r1 = b[i] + 1;
                while (r1 - l1 > 1) {
                    ll m1 = (l1 + r1) / 2;
                    if (sum(m1, b[i]) <= t) {
                        r1 = m1;
                    } else {
                        l1 = m1;
                    }
                }
                answer1 = max(answer1, b[i] - r1 + 1);
            }
        } else {
            ll sum1 = sum(b[i], p1.second - 1);
            if (sum1 <= t) {
                ll answer = p1.second - b[i];
                answer += (t - sum1) / a[p1.second];
                answer1 = max(answer1, answer);
            } else {
                ll l1 = b[i] - 1;
                ll r1 = p1.second;
                while (r1 - l1 > 1) {
                    ll m1 = (l1 + r1) / 2;
                    if (sum(b[i], m1) <= t) {
                        l1 = m1;
                    } else {
                        r1 = m1;
                    }
                }
                answer1 = max(answer1, l1 - b[i] + 1);
            }
        }
    }
    cout << answer1;
}