#ifdef ONPC
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using i128 = __int128_t;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;


mt19937_64 rng(chrono::steady_clock().now().time_since_epoch().count());

ll solve(int n, int m, int T, vector<int> a, vector<int> b) {
    vector<int> ok(n + 1);
    for (int i = 1; i <= m; i++) ok[b[i]] = 1;

    vector<ll> pref(n + 1);
    for (int i = 1; i <= n; i++) pref[i] = a[i] + pref[i - 1];

    ll ans = 0;
    for (int i = 1; i <= n; i++) {
        int mx = upper_bound(pref.begin(), pref.end(), pref[i] + T) - pref.begin();
        for (int j = i; j < mx; j++) {
            if (ok[j]) {
                ans = max(ans, j - i + (T - pref[j] + pref[i]) / a[i]);
            }
        }
    }

    return ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    ll t;
    cin >> n >> m >> t;
    vector<int> a(n + 1), b(m + 1);
    for (int i = 1; i <= n; i++) cin >> a[i];
    for (int i = 1; i <= m; i++) cin >> b[i];

    ll ans = 0;
    ans = max(ans, solve(n, m, t, a, b));
    reverse(a.begin() + 1, a.end());
    reverse(b.begin() + 1, b.end());
    for (int i = 1; i <= m; i++) b[i] = n + 1 - b[i];
    ans = max(ans, solve(n, m, t, a, b));

    cout << ans << '\n';

    return 0;
}
