#include <iostream>
#include <random>
#include <numeric>
#include <algorithm>
#include <vector>
#include <map>
#include <set>

using namespace std;
using ll = long long;
using ull = unsigned long long;

constexpr int maxn = 3e5 + 10;

int n, m, T;
int lens[maxn], starts[maxn];
ll pf[maxn];

void solve() {
    cin >> n >> m >> T;
    for (int i = 0; i < n; ++i) cin >> lens[i];
    for (int i = 0; i < m; ++i) cin >> starts[i], --starts[i];
    for (int i = 0; i < n; ++i) pf[i + 1] = pf[i] + lens[i];
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        auto i1 = lower_bound(starts, starts + m, i) - starts;
        if (i1 < m) {
            ll len_to = pf[starts[i1] + 1] - pf[i + 1];
            int cnt_to = starts[i1] - i;
            if (len_to <= T) ans = std::max<int>(ans, cnt_to + (T - len_to) / lens[i]);
        }
        if (i1) {
            ll len_to = pf[i] - pf[starts[i1 - 1]];
            int cnt_to = i - starts[i1 - 1];
            if (len_to <= T) ans = std::max<int>(ans, cnt_to + (T - len_to) / lens[i]);
        }
    }
    cout << ans << "\n";
}

int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);
    int t = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> t;
#else
#ifdef TEST
    freopen("input.txt", "r", stdin);
#else
#endif
#endif
    while (t--) {
        solve();
        cout << "\n";
    }
    return 0;
}
