#include "bits/stdc++.h"
using namespace std;
# define int long long
# define all(a) a.begin(), a.end()

//inline void solve(){
//
//}
//#pragma packed
struct node{
    bool d;
    int32_t l, r;
    double k, b;
    node() : d(true), l(-1), r(-1) {}
};
//#pragma unpacked
const int MAXSZ = 2e5;
node t[MAXSZ];
int it = 0;
inline int makeNode(){
    return it++;
}

double zn(const pair<double, double> &a,  int x){
//    double ans = ;
    return x * a.first + a.second;
}
double cross(const pair<double, double> &a, const pair<double, double> &b){
    return (a.second - b.second) / (b.first - a.first);
}
const int MAXT = 6e6 + 10;
constexpr double INF = 1e18;
struct LiChao{
    int32_t root;
    LiChao(){
        root = makeNode();
    }
    void upd(int ql, int qr, pair<double, double> nl, int v, int l, int r){
        if(ql == l && qr == r){
            if(t[v].d){
                t[v].k  = nl.first;
                t[v].b = nl.second;
                t[v].d = false;
                return;
            }
            int m = (r + l) / 2;
            if(zn(nl, m) > zn({t[v].k, t[v].b}, m)){
                swap(nl.first, t[v].k);
                swap(nl.second, t[v].b);
            }
            if(nl.first == t[v].k){
                return;
            }
            double x = cross(nl, {t[v].k, t[v].b});
            if(x < m){
                if(t[v].l == -1){
                    t[v].l = makeNode();
                }
                upd(ql, m, nl, t[v].l, l, m);
            } else {
                if(t[v].r == -1){
                    t[v].r = makeNode();
                }
                upd(m, qr, nl, t[v].r, m, r);
            }
            return;
        }
        int m = (r + l) / 2;
        if(qr <= m){
            if(t[v].l == -1){
                t[v].l = makeNode();
            }
            upd(ql, qr, nl, t[v].l, l, m);
        } else if(ql >= m){
            if(t[v].r == -1){
                t[v].r = makeNode();
            }
            upd(ql, qr, nl, t[v].r, m, r);
        } else {
            if(t[v].l == -1){
                t[v].l = makeNode();
            }
            if(t[v].r == -1){
                t[v].r = makeNode();
            }
            upd(ql, m, nl, t[v].l, l, m);
            upd(m, qr, nl, t[v].r, m, r);
        }
    }
    void upd(int ql, int qr, pair<double, double> nl){
        upd(ql, qr, nl, root, 0, MAXT);
    }
    double get(int x, int v, int l, int r){
        if(v == -1){
            return -INF;
        }
        if(r - l == 1){
            return zn({t[v].k, t[v].b}, x);
        }
        int m = (r + l) / 2;
        if(x < m){
//            if(t[v].l == -1){
//                t[v].l = makeNode();
//            }
            if(t[v].d){
                return get(x, t[v].l, l, m);
            } else {
                return max(zn({t[v].k, t[v].b}, x), get(x, t[v].l, l, m));
            }
        } else {
            if(t[v].d){
                return get(x, t[v].r, m, r);
            } else {
                return max(zn({t[v].k, t[v].b}, x), get(x, t[v].r, m, r));
            }
        }
    }
    double get(int x){
        return get(x, root, 0, MAXT);
    }
};

signed main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
//    cerr << sizeof(node);
    int n, m, T;
    cin >> n >> m >> T;
    vector<int> a(n);
    for(auto &i : a) cin >> i;
    vector<int> p(n + 1);
    for(int i = 0; i < n; ++i){
        p[i + 1] = p[i] + a[i];
    }
    vector<int> ans(n);
    LiChao tr;
    for(int i = 0; i < n; ++i){
//        pair<double, double> tmp = ;
//        cerr << tmp.first << ' ' << tmp.second << '\n';
        tr.upd(0, T + p[i] + 1, {-(1.0 / a[i]), -i + (T + p[i]) * 1.0 / a[i]});
        ans[i] = max(ans[i], (int)(i + 1 + tr.get(p[i + 1])));
    }
    fill(t, t + MAXSZ, node());
    it = 1;
    t[0] = node();
    for(int i = n - 1; i >= 0; --i){
//        pair<double, double> tmp = ;
        tr.upd(max(0ll, p[i + 1] - T), MAXT, {(1.0 / a[i]), i + (T - p[i + 1]) * 1.0 / a[i]});
        ans[i] = max(ans[i],  (int)(-i + 1 + tr.get(p[i])));
    }
    int res = 0;
    for(int i = 0; i < m; ++i){
        int s;
        cin >> s;
        --s;
        res = max(res, ans[s]);
    }
    cout << res << '\n';
    return 0;
}