// #pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

// #pragma GCC target("sse4.2,bmi,bmi2,popcnt,lzcnt,avx2")

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef __int128_t d128;
typedef ll dgt;
typedef pair<dgt, dgt> pdd;
const dgt MOD = 1e9 + 7;
const dgt INF = 1e9 + 1;
const ll INFLL = 1e18 + 1;
const ld EPS = 1e-9;

// typedef tree<dgt, null_type, less<dgt>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define all(x) x.begin(), x.end()

template<typename T1, typename T2>
istream& operator >> (istream&, pair<T1, T2>&);

template<typename T1, typename T2>
ostream& operator << (ostream&, const pair<T1, T2>&);

template<typename T>
istream& operator >> (istream& is, vector<T>& arr) {
    for (T& el: arr)
        is >> el;
    return is;
}

template<typename T>
ostream& operator << (ostream& os, const vector<T>& arr) {
    for (const T& el: arr)
        os << el << ' ';
    return os;
}

template<typename T1, typename T2>
istream& operator >> (istream& is, pair<T1, T2>& pr) {
    return is >> pr.first >> pr.second;
}

template<typename T1, typename T2>
ostream& operator << (ostream& os, const pair<T1, T2>& pr) {
    return os << pr.first << ' ' << pr.second;
}

struct LiChao {
    struct line {
        ld k, b;
    };
    
    line DEFAULT = {0, -INFLL};

    vector<line> tree;
    vector<dgt> num;
    dgt size;

    ld calc(line l, dgt x) {
        return l.k * x + l.b;
    }

    LiChao(dgt n) {
        build(n);
    }

    void build(dgt n) {
        for (size = 1; size < n; size *= 2);
        tree.assign(2 * size - 1, DEFAULT);
        num.assign(2 * size - 1, -1);
    }

    void _add(dgt v, dgt l, dgt r, line ln, dgt i) {
        if (l + 1 == r) {
            if (calc(ln, l) > calc(tree[v], l)) {
                tree[v] = ln, num[v] = i;
            }
            return;
        }
        dgt m = (l + r) / 2;
        if (calc(ln, m) > calc(tree[v], m)) {
            swap(ln, tree[v]);
            swap(i, num[v]);
        }
        if (calc(ln, l) > calc(tree[v], l))
            _add(2 * v + 1, l, m, ln, i);
        else if (calc(ln, r - 1) > calc(tree[v], r - 1))
            _add(2 * v + 2, m, r, ln, i);
    }

    void add(ld k, ld b, dgt i) {
        return _add(0, 0, size, {k, b}, i);
    }

    dgt get(dgt pos) {
        dgt ind = -1;
        ld val = -INFLL;
        dgt v = 0, l = 0, r = size;
        while(v < tree.size()) {
            ld new_val = calc(tree[v], pos);
            if (new_val > val) {
                ind = num[v];
                val = new_val;
            }
            dgt m = (l + r) / 2;
            if (pos < m)
                v = 2 * v + 1, r = m;
            else
                v = 2 * v + 2, l = m;
        }
        return ind;
    }
};

void solve() {
    dgt m, n, t;
    cin >> n >> m >> t;
    vector<dgt> a(n);
    vector<array<dgt, 21>> near_l(n), near_r(n);
    {
        array<dgt, 21> curr;
        fill(all(curr), -1);
        for (dgt i = 0; i < n; ++i) {
            curr[a[i]] = i;
            near_l[i] = curr;
        }
        fill(all(curr), -1);
        for (dgt i = n - 1; i >= 0; --i) {
            curr[a[i]] = i;
            near_r[i] = curr;
        }
    }
    cin >> a;
    bitset<300000> is;
    is.reset();
    vector<dgt> prefa(n + 1, 0);
    for (dgt i = 1; i <= n; ++i) {
        prefa[i] = prefa[i - 1] + a[i - 1];
    }
    for (dgt i = 0; i < m; ++i) {
        dgt b;
        cin >> b;
        --b;
        is[b] = true;
    }
    dgt ans = 0;
    for (dgt i = 0; i < n; ++i) {
        for (dgt c = 1; c <= 20; ++c) {
            dgt ind = near_l[i][c];
            if (ind == -1)
                continue;
            if (prefa[i + 1] - prefa[ind + 1] <= t) {
                dgt k = i - ind + (t - (prefa[i + 1] - prefa[ind + 1])) / a[ind];
                ans = max(ans, k);
            }
        }
        for (dgt c = 1; c <= 20; ++c) {
            dgt ind = near_r[i][c];
            if (ind == -1)
                continue;
            if (prefa[ind] - prefa[i] <= t) {
                dgt k = ind - i + (t - (prefa[ind] - prefa[i])) / a[ind];
                ans = max(ans, k);
            }
        }
    }
    // LiChao consist(n);
    // for (dgt i = 0; i < n; ++i) {
    //     consist.add(1.0l / a[i], prefa[i + 1] - i * a[i], i);
    //     if (!is[i])
    //         continue;
    //     dgt ind = consist.get(i);
    //     if (prefa[i + 1] - prefa[ind + 1] <= t) {
    //         dgt k = i - ind + (t - (prefa[i + 1] - prefa[ind + 1])) / a[ind];
    //         ans = max(ans, k);
    //     }
    // }
    // consist.build(n);
    // for (dgt i = n - 1; i >= 0; --i) {
    //     consist.add(-1.0l / a[i], i * a[i] - prefa[i + 1], i);
    //     if (!is[i])
    //         continue;
    //     dgt ind = consist.get(i);
    //     if (prefa[ind] - prefa[i] <= t) {
    //         dgt k = ind - i + (t - (prefa[ind] - prefa[i])) / a[ind];
    //         ans = max(ans, k);
    //     }
    // }
    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int reps = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> reps;
#endif

    for (int i = 0; i < reps; ++i) {
#ifdef LOCAL
        cout << "Test case #" << i << " ===========================\n";
#endif
        solve();
#ifdef LOCAL
        cout << "End test ===============================\n";
#endif
    }

    return 0;
}

// g++ -std=c++23 -Wall -Wextra -Wshadow -O2 -DLOCAL -D_GLIBCXX_DEBUG -D_GLIBCXX_DEBUG_PEDANTIC -fsanitize=address,undefined
