// semenInRussia 2025
#pragma GCC optimize("Ofast,unroll-loops")
#include <algorithm>
#include <cassert>
#include <cstdint>
#include <iostream>
#include <vector>
using namespace std;

const int inf = 1e9 + 5;
using pii = pair<int, int>;

// previous that less

// const int N = 6e5;
// int lg[N];

struct st {
  const int L = 20;
  vector<vector<int>> t;
  st(vector<int> &a) {
    int n = (int)a.size();
    t.resize(L);
    for (auto &row : t) {
      row.resize(n);
    }
    t[0] = a;
    for (int l = 0; l + 1 < L; l++) {
      for (int j = 0; j + (2 << l) <= n; j++) {
        t[l + 1][j] = min(t[l][j], t[l][j + (1 << l)]);
      }
    }
  }

  int qry(int l, int r) {
    if (r - l <= 0) {
      return +inf;
    }
    int k = __lg(r - l);
    return min(t[k][l], t[k][r - (1 << k)]);
  }

  int prv(int j, int v) {
    // find min m; that min(m, j) <= v
    int l = -1;
    int r = j;
    while (r - l > 1) {
      int m = (l + r) / 2;
      if (qry(m, j) < v) {
        r = m;
      } else {
        l = m;
      }
    }
    if (r == j) {
      r = -1;
    }
    return r;
  }

  int nxt(int j, int v) {
    // first on [j; n]
    int l = j;
    int r = (int)t[0].size();
    while (r - l > 1) {
      int m = (l + r) / 2;
      if (qry(j, m + 1) < v) {
        r = m;
      } else {
        l = m;
      }
    }
    return r;
  }
};

int main() {
  cin.tie(nullptr)->sync_with_stdio(false);
  int n, m, T;
  cin >> n >> m >> T;

  vector<int> a(n), b(m);

  for (int &x : a) {
    cin >> x;
  }

  for (int &x : b) {
    cin >> x;
    --x;
  }

  vector<int64_t> pref(n + 1);

  for (int i = 0; i < n; i++) {
    pref[i + 1] = pref[i] + a[i];
  }

  int64_t ans = 0;

  int lef = -1;
  st s(a);

  sort(b.begin(), b.end());

  for (int j : b) {
    int v = a[j];

    // cerr << j << "i: ";

    for (int i = j; i != -1 && i >= lef; i = s.prv(i, v)) {
      // cerr << i << ", ";
      auto sum = pref[j + 1] - pref[i + 1];
      if (i > j) {
        sum = pref[i] - pref[j];
      }
      auto r = T - sum;
      if (r >= 0) {
        ans = max(ans, (r / a[i]) + abs(i - j));
      }
    }

    // cerr << ";\n";

    lef = j;
  }

  reverse(b.begin(), b.end());

  int rig = n;

  for (auto j : b) {
    int v = a[j];
    // cerr << j << ": ";
    for (int i = j; i < n && i != -1 && i < rig; i = s.nxt(i, v)) {
      // cerr << i << ", ";
      auto sum = pref[j + 1] - pref[i + 1];
      if (i > j) {
        sum = pref[i] - pref[j];
      }
      auto r = T - sum;
      if (r >= 0) {
        ans = max(ans, (r / a[i]) + abs(i - j));
      }
      // cerr << ";\n";
    }
    rig = j;
  }
  cout << ans;
}
