//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
using namespace std;
#define int long long
using ll = long long;
using ld = long double;
template <typename t>
ostream& operator<<(ostream& out, const vector<t> &v){
    for(auto x: v)out<<x<<" ";
    return out;
}
template <typename t>
istream& operator>>(istream& in,  vector<t> &v){
    for(auto &x: v)in>>x;
    return in;
}
template <typename t, typename u>
ostream& operator<<(ostream& out, const pair<t, u> p){
    out<<p.first<<" "<<p.second<<"\n";
    return out;
}
template <typename t, typename u>
istream& operator>>(istream& in,  pair<t, u> &p){
    in>>p.first>>p.second;
    return in;
}
__int128_t one = 1;

struct line{
    ll k,  b;
    line(ll x = 0, ll y = -1e10){
        k = x, b = y;
    }
    ll get(ll x){
        return k*x+b;
    }
};
struct LiTree{
    vector<line> t;
    ll sz;
    LiTree(ll n){
        sz = n+1;
        t.assign(4*sz, line(0, (ll)-1e10));
    }
    ll get(ll idx){
        //cout<<idx<<"a\n";
        return _get(1, 0, sz, idx);
    }
    ll _get(ll v, ll tl, ll tr, ll idx){
        //cout<<v<<"b\n";
        ll tm = (tr+tl)/2;
        ll c = 0;
        if(tl+1==tr){
            return t[v].get(idx);
        }
        if(tm>idx){
            c =  _get(2*v, tl, tm, idx);
        }
        else {
            c =  _get(2*v+1, tm, tr, idx);
        }
        return max(c, t[v].get(idx));
    }
    void add(line l){
        _update(1, 0, sz, l);
    }
    void _update(ll v, ll tl, ll tr, line l){
        ll tm = (tr+tl)/2;
        line l1 = t[v];
        if(l1.k<l.k){
            swap(l, l1);
        }
        if(tl+1==tr){
            if(l1.get(tl)>l.get(tm)){
                t[v]=l1;
            }
            else{
                t[v]=l;
            }
            return;
        }
        if(l1.get(tm)>l.get(tm)){
            t[v]=l;
            _update(2*v+1, tm, tr, l1);
        }
        else{
            t[v]=l1;
            _update(2*v, tl, tm, l);
        }
    }
};
LiTree* merge(LiTree* l, LiTree* l1){
    LiTree* ans = new LiTree(l->sz+l1->sz);
    for(auto lin: l->t){
        ans->add(lin);
    }
    for(auto lin: l1->t){
        ans->add(lin);
    }
    return ans;
}
struct SegTreeL{
    vector<LiTree* > t;
    vector<line> a;
    ll sz;
    SegTreeL(vector<line> v){
        sz = v.size();
        t.resize(4*sz);
        a = v;
        build(1, 0, sz);
    }
    void build(ll v, ll l, ll r){
        if(l+1==r){
            t[v]=new LiTree(1);
            t[v]->add(a[l]);
        }
        else{
            ll m =  (r+l)/2;
            build(2*v, l, m);
            build(2*v+1, m, r);
            t[v]=merge(t[2*v], t[2*v+1]);
        }
    }
    ll get(ll l, ll r, ll k){
        return _get(1, 0, sz, l, r, k);
    }
    ll _get(ll v, ll tl, ll tr, ll l, ll r, ll k){
        if(l<=tl&&tr<=r){
            return t[v]->get(k);
        }
        ll tm = (tr+tl)/2;
        if(tm>=r){
            return _get(2*v, tl, tm, l, r, k);
        }
        if(tm<=l){
            return _get(2*v+1, tm, tr, l, r, k);
        }
        return max(_get(2*v, tl, tm, l, tm, k), _get(2*v+1, tm, tr, tm, r, k));
    }
};
ll solve2(ll n, ll m, ll t, vector<ll> v, vector<ll> v1){
    vector<ll> pref(n+1);
    for(int i = 0; i<n; i++){
        pref[i+1]=pref[i]+v[i];
    }
    ll le = 0, re = t+1;
    while(re-le>1){
        ll mid = (re+le)/2;
        vector<ll> mx(n);
        vector<line> l(n+1);
        for(int i = 0; i<n; i++){
            l[i]=line(v[i], pref[i]-mid*v[i]-i*v[i]);
        }
        SegTreeL sg = SegTreeL(l);
        //cout<<re<<" "<<le<<"\n";
        for(int i = 0; i<n; i++){
            ll ind = lower_bound(pref.begin(), pref.end(), pref[i+1]-t)-pref.begin();
            mx[i]=sg.get(ind, i+1, i+1);
            mx[i]+=t-pref[i+1];
        }
        //cout<<mx<<"\n";
        ll r1 = re;
        re = mid;
        for(auto ind: v1){
            if(mx[ind-1]>=0){
                re = r1;
                le = mid;
                break;
            }
        }
    }
    return le;
}
void solve () {
    ll n, m, t;
    cin>>n>>m>>t;
    vector<ll> v(n), v1(m);
    cin>>v>>v1;
    ll ans = solve2(n, m, t, v, v1);
    reverse(v.begin(), v.end());
    for(int i = 0; i<m; i++){
        v1[i]=n+1-v1[i];
    }
    cout<<max(ans, solve2(n, m, t, v, v1))<<"\n";
}
signed main () {
    // ios_base::sync_with_stdio(0);
    // cin.tie(0);
    cout<<fixed<<setprecision(18);
    ll AnyaSamsonovaGoSex = 1;
    //cin>>AnyaSamsonovaGoSex;
    while(AnyaSamsonovaGoSex--) solve();
}