//#pragma GCC optimize("O3,unroll-loops,inline")

#include <bits/allocator.h>

//#pragma GCC target("avx2,popcnt")

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
using ll = long long;
using ull = unsigned long long;

struct segtree {
    vector<int> tr;
    int n;
    segtree(int n) : n(n), tr(2 * n) {}
    void upd(int i, int x) {
        for (tr[i += n] = x; i >= 0; tr[i >>= 1] = max(tr[i], tr[i ^ 1]));
    }
    int get(int l, int r) {
        int ans = 0;
        for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
            if (l & 1)
                ans = max(ans, tr[l++]);
            if (~r & 1)
                ans = max(ans, tr[r--]);
        }
        return ans;
    }
};

struct fenwick {
    vector<int> t;
    int n;
    fenwick(int n) : n(n), t(n + 1) {}
    void upd(int i, int x) {
        for (++i; i <= n; i += i & -i) t[i] += x;
    }
    int get(int i) {
        int x = 0;
        for (++i; i > 0; i -= i & -i) x += t[i];
        return x;
    }
};

template<class T>
bool chmin(T &a, const T &b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<class T>
bool chmax(T &a, const T &b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

mt19937 rnd(228);

void solve() {
    int n, m, t;
    cin >> n >> m >> t;
    vector<int> a(n);
    for (int &i : a)
        cin >> i;
    vector<int> pref(n + 1);
    pref[0] = 0;
    for (int i = 1; i <= n; ++i)
        pref[i] = pref[i - 1] + a[i - 1];
    set<int> b;
    while (m--) {
        int x;
        cin >> x;
        --x;
        b.insert(x);
    }
    auto get = [&](int l, int r) -> int {
        return pref[r + 1] - pref[l];
    };
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        auto it = b.lower_bound(i);
        if (it != b.end()) {
            int need = get(i, *it);
            if (t >= need)
                ans = max(ans, (t - need) / a[i] + (*it - i + 1));
        }
        if (it != b.begin()) {
            --it;
            int need = get(*it, i);
            if (t >= need)
                ans = max(ans, (t - need) / a[i] + (i - *it + 1));
        }
    }
    cout << ans << '\n';
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
//     cin >> t;
    while (t--) solve();
//    cerr << fixed << setprecision(10) << clock() * 1.0 / CLOCKS_PER_SEC << '\n';
}
