// #pragma GCC optimize("O3")
// #pragma GCC optimize("Ofast")
// #pragma GCC optimize("inline")
// #pragma GCC optimize("unroll-loops")
// #include<ext/pb_ds/assoc_container.hpp>
// #include<ext/pb_ds/tree_policy.hpp>
// #pragma GCC target("avx2")
#include<bits/stdc++.h>
// using namespace __gnu_pbds;
using namespace std;
using ll = long long;
using ld = long double;
// using ordered_map = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;
// using hash_map = gp_hash_table<int, int>;
#define watch(x) cout << #x << ": " << x << '\n';
#define watch_arr(arr) cout << #arr << ": "; \
for (int i = 0; i < (int)arr.size(); ++i) { \
    cout << arr[i] << ' '; \
} \
cout << '\n';
#define all(arr) arr.begin(), arr.end()

random_device rd;
mt19937 rnd(rd());

const ll INF = 1e18;

struct line {
    ld k, b;
    line (ld _k = 0, ld _b = -INF) : k(_k), b(_b) {}

    ld eval(ll x) {
        return k * x + b;
    }

    // line operator=(line& l) {
    //     return l;
    // }
};

struct li_chao_tree {
    vector<line> tree;
    vector<ll> coord;
    vector<pair<line&, line>> changes;
    ll sz;

    li_chao_tree(vector<ll> _coord) {
        coord = _coord;
        sz = coord.size();
        tree.resize(4 * sz);
    }

    void rollback(int version) {
        while (changes.size() > version) {
            changes.back().first = changes.back().second;
            changes.pop_back();
        }
    }

    void add_line(int v, int tl, int tr, line l) {
        if (tr - tl == 1) {
            if (tree[v].eval(coord[tl]) < l.eval(coord[tl])) {
                changes.emplace_back(tree[v], tree[v]);
                tree[v] = l;
            }
            return;
        }

        int tm = (tl + tr) / 2;
        if (tree[v].eval(coord[tm]) < l.eval(coord[tm])) {
            changes.emplace_back(tree[v], tree[v]);
            swap(tree[v], l);
        }
        if (tree[v].k > l.k) {
            add_line(v * 2 + 1, tl, tm, l);
        } else {
            add_line(v * 2 + 2, tm, tr, l);
        }
    }

    ld get(int v, int tl, int tr, int pos) {
        if (tr - tl == 1) {
            return tree[v].eval(coord[pos]);
        }

        int tm = (tl + tr) / 2;
        if (pos < tm) {
            return max(tree[v].eval(coord[pos]), get(v * 2 + 1, tl, tm, pos));
        } else {
            return max(tree[v].eval(coord[pos]), get(v * 2 + 2, tm, tr, pos));
        }
    }

    void add_line(line l) {
        add_line(0, 0, sz, l);
    }

    ld get(int pos) {
        return get(0, 0, sz, pos);
    }
};


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    ll n, m, t;
    cin >> n >> m >> t;
    vector<ll> a(n), pref(n + 1);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        pref[i + 1] = pref[i] + a[i];
    }

    li_chao_tree tree1(pref), tree2(pref);
    vector<int> v(n);
    for (int i = n - 1; i >= 0; --i) {
        v[i] = tree1.changes.size();
        tree1.add_line(line(1.0 / a[i], i + 1.0 * (t - pref[i]) / a[i]));
    }

    vector<ll> ans(n);
    for (int i = 0; i < n; ++i) {
        ans[i] = max(tree1.get(i) - i, tree2.get(i + 1) + i);
        tree2.add_line(line(-1.0 / a[i], -i + 1.0 * (t + pref[i + 1]) / a[i]));
        tree1.rollback(v[i]);
    }

    ll res = -INF;
    for (int i = 0; i < m; ++i) {
        int b;
        cin >> b;
        res = max(ans[b - 1], res);
    }
    cout << res;

    return 0;
}
