#include <iostream>
#include <unordered_map>
#include <unordered_set>
#include <set>
#include <vector>
#include <map>
#include <cmath>
#include <assert.h>
#include <algorithm>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

template<typename T>
istream& operator>>(istream& in, vector<T>& arr) {
    for (ll i = 0; i < (ll)arr.size(); ++i) {
        in >> arr[i];
    }
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, vector<T>& arr) {
    for (auto el : arr) {
        out << el;
    }
    return out;
}
const ll INF = 1e18;

struct el {
    ll mn = INF;
    ll id = -1;
};

struct segmentTree {
    vector<el> tree;

    el merge(el left, el right) {
        if (left.mn < right.mn) {
            return {left};
        }
        return right;
    }

    void build(ll v, ll l, ll r, vector<ll>& arr) {
        if (l + 1 == r) {
            tree[v] = {arr[l], l};
            return;
        }
        ll mid = (l + r) / 2;
        build(2 * v, l, mid, arr);
        build(2 * v + 1, mid, r, arr);
        tree[v] = merge(tree[2 * v], tree[2 * v + 1]);
    }

    segmentTree(vector<ll>& arr) {
        ll n = arr.size();
        tree.resize(4 * n);
        build(1, 0, n, arr);
    }

    el get(ll v, ll l, ll r, ll ql, ll qr) {
        if (r <= ql || qr <= l) {
            return {};
        }
        if (ql <= l && r <= qr) {
            return tree[v];
        }
        ll mid = (l + r) / 2;
        return merge(get(2 * v, l, mid, ql, qr), get(2 * v + 1, mid, r, ql, qr));
    }
};

ll f1(vector<ll>& pref, vector<ll>& arr, ll t, ll a, ll b) {
    ll sum = pref[b + 1] - pref[a];
    ll cnt = max(0ll, t - sum) / arr[a];
    if (t - sum >= 0) {
        return cnt + (b - a + 1);
    }
    return 0;
}

ll f2(vector<ll>& pref, vector<ll>& arr, ll t, ll a, ll b) {
    ll sum = pref[b + 1] - pref[a];
    ll cnt = max(0ll, t - sum) / arr[b];
    if (t - sum >= 0) {
        return cnt + (b - a + 1);
    }
    return 0;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    ll n, m, t;
    cin >> n >> m >> t;
    vector<ll> arr(n), brr(m);
    cin >> arr >> brr;
    vector<ll> pref(1, 0);
    for (auto el : arr) {
        pref.push_back(pref.back() + el);
    }
    for (auto &el : brr) {
        --el;
    }
    vector<ll> crr;
    for (auto el : brr) {
        crr.push_back(el);
    }
    ll ans = 0;
    for (ll i = 0; i < n; ++i) {
        auto id = lower_bound(crr.begin(), crr.end(), i) - crr.begin();
        ll a = -1, b = -1;
        if (id < m) {
            b = crr[id];
        }
        if (id > 0) {
            a = crr[id - 1];
        }
        if (a >= 0) {
            ans = max(ans, f2(pref, arr, t, a, i));
        }
        if (b >= 0) {
            ans = max(ans, f1(pref, arr, t, i, b));
        }
    }
    cout << ans;
}