#include <iostream>
#include <vector>
#include <stack>

using namespace std;

vector<long long> pref;

long long get(int l, int r) {
    if (r < l) {
        swap(l, r);
    }
    return pref[r + 1] - pref[l];
}

int main()
{
    int n, m, t;
    cin >> n >> m >> t;
    vector<long long> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    pref.resize(n + 1);
    pref[0] = 0;
    for (int i = 0; i < n; i++) {
        pref[i + 1] = pref[i] + v[i];
    }
    stack<int> st;

    vector<int> pr(n, -1);
    for (int i = 0; i < n; i++) {
        while (st.size() > 0 && v[i] <= v[st.top()]) {
            st.pop();
        }
        if (st.size() != 0) {
            pr[i] = st.top();
        }
        st.push(i);
    }
    vector<bool> fl(n);
    for (int i = 0; i < n; i++) {
        if (i == 0 && v[i] < v[i + 1]) {
            fl[i] = true;
        } else if (i == n - 1 && v[i] < v[i - 1]) {
            fl[i] = true;
        } else if (i != 0 && i != n - 1 && v[i] < v[i - 1] && v[i] < v[i + 1]) {
            fl[i] = true;
        }
    }

    for (int i = 1; i < n; i++) {
        if (pr[i] != -1 && !fl[pr[i]]) {
            pr[i] = pr[pr[i]];
        }
    }

    while (st.size() != 0) {
        st.pop();
    }
    vector<int> nxt(n, -1);
    for (int i = n - 1; i >= 0; i--) {
        while (st.size() > 0 && v[i] <= v[st.top()]) {
            st.pop();
        }
        if (st.size() != 0) {
            nxt[i] = st.top();
        }
        st.push(i);
    }
    for (int i = n - 2; i >= 0; i--) {
        if (nxt[i] != -1 && !fl[nxt[i]]) {
            nxt[i] = nxt[nxt[i]];
        }
    }
    long long mx = 0;
    for (int i = 0; i < m; i++) {
        int b;
        cin >> b;
        b--;
        for (int j = 0; j < n; j++) {
            long long rm = t - get(j, b);
            long long cnt = abs(j - b) + 1;
            if (rm >= 0) {
                mx = max(mx, cnt + rm / v[j]);
            }
        }
    }
    cout << mx;
    return 0;
}