#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <bitset>
#include <unordered_map>
#include <random>

#define all(v) v.begin(), v.end()
#define len(v) (int)v.size()
#define coutd cout << fixed << setprecision(20)

using namespace std;
using ll = long long;
using ld = long double;

const ll INF = 1e18;

vector<ll> ps;

ll get_sum(int l, int r)
{
    if (l > r) swap(l, r);
    ++r;
    return ps[r] - ps[l];
}

int main()
{
    cin.tie(0)->sync_with_stdio(0);
    int n, m;
    ll T;
    cin >> n >> m >> T;
    vector<ll> a(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i];
    }
    vector<int> b(m);
    for (int i = 0; i < m; ++i)
    {
        cin >> b[i];
        --b[i];
    }
    /// a[i] <= a[i + 1]
    /*ll cur = 0;
    ll ans = 0;
    int i = b[0];
    while (true)
    {
        if (cur + a[i] <= T)
        {
            cur += a[i];
            --i;
            ++ans;
            if (i == -1) break;
        } else
        {
            cur = T;
            break;
        }
    }
    ans += ((T - cur) / a[0]);
    cout << ans;*/
    /// O(nt)
    /*vector<vector<ll>> dp(n, vector<ll>(T + 1, -INF));
    for (int i = 0; i < m; ++i)
    {
        dp[b[i]][0] = 0;
    }
    ll ans = 0;
    for (int t = 0; t <= T; ++t)
    {
        for (int i = 0; i < n; ++i)
        {
            ans = max(ans, dp[i][t]);
            int nt = t + a[i];
            if (nt > T || dp[i][t] == -INF) continue;
            dp[i][nt] = max(dp[i][nt], dp[i][t] + 1);
            if (i > 0)
            {
                dp[i - 1][nt] = max(dp[i - 1][nt], dp[i][t] + 1);
            }
            if (i + 1 < n)
            {
                dp[i + 1][nt] = max(dp[i + 1][nt], dp[i][t] + 1);
            }
        }
    }
    cout << ans;*/
    ll ans = 0;
    ps.resize(n + 1, 0);
    for (int i = 1; i <= n; ++i)
    {
        ps[i] = ps[i - 1] + a[i - 1];
    }
    for (int i = 0; i < m; ++i)
    {
        int l = 0;
        if (i > 0)
        {
            l = b[i - 1] + 1;
        }
        int r = n;
        if (i + 1 < m)
        {
            r = b[i + 1];
        }
        for (int j = l; j < r; ++j)
        {
            ll st = b[i], en = j;
            ll curT = get_sum(st, en);
            if (curT > T) continue;
            ll cur = abs(st - en) + 1 + (T - curT) / a[en];
            ans = max(ans, cur);
        }
    }
    cout << ans;

    return 0;
}
