#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <math.h>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>

using namespace std;
using ll = long long;
using ld = long double;
#define all(x) x.begin(),x.end()
//#pragma GCC optimize("Ofast")
const ll INF = 1e9 + 7;
template<typename T>
void input(vector<T>& arr, size_t size) {
	arr.resize(size);
	for (T& i : arr) {
		cin >> i;
	}
}
template<typename T>
void print(vector<T>& arr) {
	for (T& i : arr) {
		cout << i << ' ';
	}
	cout << '\n';
}
int merge(int a, int b) {
	return a + b;
}
vector<int> tr;
void build(vector<int>& a) {
	int n = a.size() * 2;
	tr.resize(n * 2);
	for (size_t i = 0; i < n; i++)
	{
		tr[i + n] = a[i];
	}
	for (int i = n - 1; i >= 0; i--)
	{
		tr[i] = merge(tr[i << i], tr[i << 1 | 1]);
	}
}
void upd(int pos, int val, int n) {
	pos += n;
	tr[pos] = val;
	pos >>= 1;
	for (; pos > 0; pos >>= 1) {
		tr[pos] = merge(tr[pos << 1], tr[pos << 1 | 1]);
	}
}
int get(int l, int r, int n) {
	int res = 0;
	for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
		if (l & 1) {
			res = merge(res, tr[l++]);
		}
		if (r & 1) {
			res = merge(res, tr[--r]);
		}
	}
	return res;
}

void solve() {
	ll n, m, t;
	cin >> n >> m >> t;
	vector<ll> a, b, p(n + 1,0);
	input(a, n);
	input(b, m);
	for (size_t i = 0; i < m; i++)
	{
		b[i]--;
	}
	for (size_t i = 1; i <= n; i++)
	{
		p[i] = p[i - 1] + a[i - 1];
	}

	ll ans = 0;
	for (int i = 0; i < n; i++)
	{
		int r = lower_bound(all(b), i) - b.begin(), l = r - 1;
		if (r < b.size()) {
			r = b[r];
			ll ot = (t - (p[r + 1] - p[i + 1])) / a[i] + (r - i);
			ans = max(ans, ot);
		}
		if (l >= 0) {
			l = b[l];
			ll s = (t - (p[i] - p[l])) / a[i] + (i - l);
			ans = max(ans, s);
		}
	}
	cout << ans;
}

int main() {
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
#endif // _DEBUG
	ios::sync_with_stdio(0);
	cin.tie(0);
	int tt = 1;
#ifdef _DEBUG
	cin >> tt;
#endif // _DEBUG
	while (tt--)
	{
		solve();
#ifdef _DEBUG
		cout << "\n================\n";
#endif // _DEBUG
	}
}