#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define all(x) x.begin(), x.end()

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pr = pair<ll, ll>;
const int MOD = 1e9 + 7;
const int INF = 1e9 + 1;
const ll INFLL = 1000000000000000001;
int reps = 1;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> oset;

template<typename T>
inline void print(const vector<T> &a, string sep=" ") {
    for (auto &x : a) cout << x << sep;
    cout << "\n";
}

template<typename T>
inline void print(const set<T> &a, string sep=" ") {
    for (auto &x : a) cout << x << sep;
    cout << "\n";
}

//====================================

struct line
{
    ll a = -INFLL, k = 1, b = -INFLL;
    line () {}
    line (ll _a, ll _k, ll _b) : a(_a), k(_k), b(_b) {}
    ll operator() (ll x) const {
        return (a + x) / k + b; 
    } 
};

struct LiChao
{
    struct Node
    {
        line cl;
        int l = 0, r = 0;
        Node () {}
        Node (ll a, ll k, ll b) : cl(a, k, b)  {}
        ll get(ll x) {
            return cl(x);
        }
    };
    int getl(int v) {
        if (!st[v].l) {
            st[v].l = st.size();
            st.push_back(Node());
        }
        return st[v].l;
    }
    int getr(int v) {
        if (!st[v].r) {
            st[v].r = st.size();
            st.push_back(Node());
        }
        return st[v].r;
    }
    ll ql = -INFLL, qr = INFLL;
    vector<Node> st;
    LiChao () : st(1) {}
    void add(int v, ll l, ll r, Node nv) {
        // cout << "add at " << v << " " << l << " " << r << "\n";
        // cerr << "";
        ll m = (l + r) / 2;
        if (nv.get(m) > st[v].get(m)) {
            swap(nv.l, st[v].l);
        }
        if (r - l == 1) return;
        // cout << "go further\n";
        // cerr << "";
        if (nv.get(l) > st[v].get(l)) add(getl(v), l, m, nv);
        else if (nv.get(r - 1) > st[v].get(r - 1)) add(getr(v), m, r, nv);
    }
    void add(ll a, ll k, ll b) {
        // cout << "add " << a << " " << k << " " << b << "\n";
        // cerr << "";
        if ((int)st.size() < 2) {
            st.push_back(Node(a, k, b));
            return;
        }
        add(1, ql, qr, Node(a, k, b));
    }
    ll get(int v, ll l, ll r, ll x) {
        ll cur = st[v].get(x);
        if (r - l == 1) return cur;
        ll m = (l + r) / 2;
        if (x < m) {
            if (st[v].l) cur = max(cur, get(getl(v), l, m, x));
        } else {
            if (st[v].r) cur = max(cur, get(getr(v), m, r, x));
        }
        return cur;
    }
    ll get(ll x) {
        if ((int)st.size() < 2) return -INFLL;
        return get(1, ql, qr, x);
    }
};

void solve() {
    ll n, m, t; cin >> n >> m >> t;
    vector<ll> a(n), b(m);
    for (auto &x : a) cin >> x;
    for (auto &x : b) cin >> x, x--;
    vector<ll> pref(n + 1);
    for (int i = 0; i < n; i++) {
        pref[i + 1] = pref[i] + a[i];
    } 
    ll ans = 0;
    vector<int> canst(n);
    for (int i = 0; i < m; i++) {
        canst[b[i]] = 1;
        ans = max(ans, t / a[b[i]]);
    }

    LiChao sl, sr;
    for (int i = 0; i < n; i++) {
        if (canst[i]) {
            ans = max(ans, i + sl.get(-pref[i + 1]));
        }
        sl.add(t + pref[i + 1], a[i], -i);
    }
    for (int i = n-1; i >= 0; i--) {
        if (canst[i]) {
            ans = max(ans, -i + sr.get(pref[i]));
        }
        sr.add(t - pref[i], a[i], i);
    }

    // for (int i = 0; i < m; i++) {
    //     ll cmax = 0;
    //     int pos = b[i];
    //     for (int j = 0; j < pos; j++) {
    //         if (t < (pref[pos + 1] - pref[j + 1])) break;
    //         ll cur = pos - j + (t - (pref[pos + 1] - pref[j + 1])) / a[j];
    //         cmax = max(cmax, cur);
    //     }
    //     cmax = max(cmax, t / a[pos]);
    //     for (int j = pos + 1; j < n; j++) {
    //         if (t < (pref[j + 1] - pref[pos + 1])) break;
    //         ll cur = j - pos + (t - (pref[j] - pref[pos])) / a[j];
    //         cmax = max(cmax, cur);
    //     }
    //     ans = max(ans, cmax);
    // }
    cout << ans << "\n";
}

//====================================

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL 
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> reps;
#endif
    for (int i = 0; i < reps; i++) {
#ifdef LOCAL 
        cout << "Test case #" << i + 1 << " ==============\n";
#endif
        solve();
#ifdef LOCAL 
        cout << "End test ==============\n";
#endif
    }
    return 0;
}

// g++ -std=c++23 -Wall -Wextra -Wshadow -DLOCAL -D_GLIBCXX_DEBUG -fsanitize=address,undefined -O2 A.cpp -o A
