#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define all(x) x.begin(), x.end()

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pr = pair<ll, ll>;
const int MOD = 1e9 + 7;
const int INF = 1e9 + 1;
const ll INFLL = 1e18 + 1;
int reps = 1;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> oset;

template<typename T>
inline void print(const vector<T> &a, string sep=" ") {
    for (auto &x : a) cout << x << sep;
    cout << "\n";
}

template<typename T>
inline void print(const set<T> &a, string sep=" ") {
    for (auto &x : a) cout << x << sep;
    cout << "\n";
}

//====================================

struct line
{
    ld a = -INFLL, k = 1, b = -INFLL;
    line () {}
    line (ll _a, ll _k, ll _b) : a(_a), k(_k), b(_b) {}
    ll operator() (ll x) const {
        return (a + x) / k + b; 
    } 
    ll get(ll x) {
        return (ll(a + x)) / (ll(k)) + (ll(b));
    }
    bool operator<(const line &o) const {
        return a < o.a;
    }
};

ld cross(line l1, line l2) {
    return (l1.a*l2.k - l2.a*l1.k + l1.k*l2.k*(l1.b - l2.b)) / (l1.k - l2.k);
}

struct KHT
{
    deque<ld> x;
    deque<line> a;
    KHT () {}
    void add(line l) {
        while (!a.empty() && l(x.back()) >= a.back()(x.back())) a.pop_back(), x.pop_back();
        a.push_back(l);
        if (a.empty()) x.push_back(-INFLL);
        else {
            ld cur = cross(l, a.back());
            x.push_back(cur);
        }
    }
    ll get(ll val) {
        int pos = upper_bound(all(x), val) - x.begin() - 1;
        return a[pos].get(val);
    }
    void del(ll val) {
        while (!a.empty() && a.front().a + val < 0) a.pop_front(), x.pop_front();
        if (!a.empty()) x.front() = -INFLL;
    }
};

void solve() {
    int n, m, t; cin >> n >> m >> t;
    vector<ll> a(n), b(m);
    for (auto &x : a) cin >> x;
    for (auto &x : b) cin >> x, x--;
    vector<ll> pref(n + 1);
    for (int i = 0; i < n; i++) {
        pref[i + 1] = pref[i] + a[i];
    } 
    ll ans = 0;
    vector<int> can(n);
    for (int i = 0; i < m; i++) {
        can[b[i]] = 1;
        ans = max(ans, t / a[b[i]]);
    }
    // vector<ll> cur;
    KHT cur;
    for (int i = 0; i < n; i++) {
        cur.add(line(t + pref[i + 1], a[i], -i));
        if (!can[i]) continue;
        // cur.del(-pref[i + 1]);
        ans = max(ans, i + cur.get(-pref[i + 1]));
    }
    cur = KHT();
    for (int i = n-1; i >= 0; i--) {
        cur.add(line(t - pref[i], a[i], i));
        if (!can[i]) continue;
        // cur.del(pref[i]);
        ans = max(ans, -i + cur.get(pref[i]));
    }
    cout << ans << "\n";
}

//====================================

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL 
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> reps;
#endif
    for (int i = 0; i < reps; i++) {
#ifdef LOCAL 
        cout << "Test case #" << i + 1 << " ==============\n";
#endif
        solve();
#ifdef LOCAL 
        cout << "End test ==============\n";
#endif
    }
    return 0;
}

// g++ -std=c++23 -Wall -Wextra -Wshadow -DLOCAL -D_GLIBCXX_DEBUG -fsanitize=address,undefined -O2 A.cpp -o A
