#define LOCAL
//#define SUKA
#ifdef SUKA
#pragma GCC optimize("O3")
#define GCC optimize("unroll-loops")
#endif
#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define debug(x) cerr << #x << " = " << x << "\n";
#else
#define debug(x)
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using oset = tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

struct segtree {
    vector<ll> t;

    segtree(const vector<ll>& a) {
        t.resize(a.size()*4);
        build(1, 0, a.size(), a);
    }

    void build (ll v, ll tl, ll tr, const vector<ll>& a) {
        if (tr - tl == 1) {
            t[v] = a[tl];
            return;
        }
        ll tm = (tl + tr) / 2;
        build(v*2, tl, tm, a);
        build(v*2+1, tm, tr, a);
        t[v] = t[v*2] + t[v*2+1];
    }

    ll get(ll v, ll tl, ll tr, ll ql, ll qr) {
        if (tr <= ql || tl >= qr) {
            return 0;
        }
        if (tl >= ql && tr <= qr) {
            return t[v];
        }
        ll tm = (tl + tr) / 2;
        return get(v*2, tl, tm, ql, qr) + get(v*2+1, tm, tr, ql, qr);
    }

    void update(ll v, ll tl, ll tr, ll pos, ll x) {
        if (tr - tl == 1) {
            t[v] = x;
        }
        ll tm = (tl + tr) / 2;
        if (pos > tm) {
            update(v*2, tl, tm, pos, x);
        }
        else {
            update(v*2+1, tm, tr, pos, x);
        }
        t[v] = t[v*2] + t[v*2+1];
    }
};

void solve() {
    ll n, m, t;
    cin >> n >> m >> t;
    vector<ll> a(n), b(m);
    for (ll i = 0;i<n;i++) {
        cin >> a[i];
    }
    for (ll i =0; i < m;i++) {
        cin >> b[i];
    }
    ll ans = 0;
    for (auto x : b) {
        --x;
        ll res = 0, sum = 0;
        for (ll i = x;i >= 0;i--) {
            sum += a[i];
            if (sum > t) break;
            res++;
            ans = max(ans, res + (t - sum) / a[i]);
        }
        res = 0, sum = 0;
        for (ll i = x;i < n;i++) {
            sum += a[i];
            if (sum > t) break;
            res++;
            ans = max(ans, res + (t - sum) / a[i]);
        }
    }
    cout << ans;
}


signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll t = 1;
    //x`cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }
    //cout << res({1,2,3},1);
}
