#include <iostream>
#include <chrono>
#include <climits>
#include <cmath>
#include <random>
#include <algorithm>
#include <vector>
#include <string>

#pragma GCC optimize("O3")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

typedef long long ll;
typedef unsigned long long ull;

using namespace std;

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, m, T;
    cin >> n >> m >> T;
    vector<ll> a(n), b(m), d(n, 0);
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < m; i++) cin >> b[i];
    int left = 0;
    ll sum = 0;
    for (int right = 0; right < n; right++) {
        sum += a[right];
        while (sum > T) {
            sum -= a[left];
            left++;
        }
        d[right] = T / a[right];
        ll tmp = sum;
        for (int i = left; i <= right; i++) {
            d[i] = max(d[i], (T - tmp) / a[right] + right - i + 1);
            tmp -= a[i];
        }
    }
    int right = n - 1;
    sum = 0;
    for (left = n - 1; left >= 0; left--) {
        sum += a[left];
        while (sum > T) {
            sum -= a[right];
            right--;
        }
        d[left] = max(d[left], T / a[left]);
        ll tmp = sum;
        for (int i = right; i >= left; i--) {
            d[i] = max(d[i], (T - tmp) / a[left] + right - i + 1);
            tmp -= a[i];
        }
    }
    ll ans = -1;
    for (const auto x: b) ans = max(ans, d[x - 1]);
    cout << ans;
    return 0;
}
