#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <ctime>
#include <climits>
#include <iomanip>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <string>
#include <queue>
#include <random>

#define int long long

#pragma GCC optimize("03,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

using ll = long long;
using ld = long double;
using namespace std;

const ll INF = 1e18;

int get_sum(int l, int r, vector<int>& pref) {
	if (l == -1 || r == -1) {
		return INF;
	}
	if (l > r) {
		return 0;
	}
	int ans = pref[r];
	if (l != 0) {
		ans -= pref[l - 1];
	}
	return ans;
}

vector<int> left_less(vector<int> a) {
	int n = (int)a.size();
	vector<int> l(n, -1);
	vector<pair<int, int>> cur;
	for (int i = 0; i < n; i++) {
		while (!cur.empty() && cur.back().first >= a[i]) {
			cur.pop_back();
		}
		if (!cur.empty()) {
			l[i] = cur.back().second;
		}
		cur.push_back({ a[i], i });
	}
	return l;
}

vector<int> right_less(vector<int> a) {
	int n = (int)a.size();
	vector<int> r(n, -1);
	vector<pair<int, int>> cur;
	for (int i = n - 1; i >= 0; i--) {
		while (!cur.empty() && cur.back().first >= a[i]) {
			cur.pop_back();
		}
		if (!cur.empty()) {
			r[i] = cur.back().second;
		}
		cur.push_back({ a[i], i });
	}
	return r;
}



void solve() {
	int n, m, t;
	cin >> n >> m >> t;
	vector<int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	vector<int> pref(n);
	pref[0] = a[0];
	for (int i = 1; i < n; i++) {
		pref[i] = pref[i - 1] + a[i];
	}
	vector<int> b(m);
	for (int i = 0; i < m; i++) {
		cin >> b[i];
		b[i]--;
	}
	int mx = 0;
	for (int i = 0; i < n; i++) {
		auto it = lower_bound(b.begin(), b.end(), i);
		int l = -1;
		int r = -1;
		if (it != b.end()) {
			r = *it;
		}
		if (it != b.begin()) {
			it--;
			l = *it;
		}
		int d1 = get_sum(l, i - 1, pref);
		int d2 = get_sum(i + 1, r, pref);
		int v1 = 0;
		int v2 = 0;
		if (t >= d1) {
			v1 = i - l;
			v1 += (t - d1) / a[i];
		}
		if (t >= d2) {
			v2 = r - i;
			v2 += (t - d2) / a[i];
		}
		mx = max(mx, v1);
		mx = max(mx, v2);
	}
	cout << mx;
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	solve();
	return 0;
}