#include <bits/stdc++.h>

using namespace std;
using ll = long long;
ll INF = 1e14;

#define lv(v) v + 1
#define rv(v) v + 2 * (m - l)

struct SegmentTree {
    vector<ll> t;
    vector<ll> a;

    SegmentTree(vector<ll> s) {
        a = s;
        t.resize(2 * s.size());
        build(0, 0, s.size());
    }

    void build(ll v, ll l, ll r) {
        if(r - l == 1) {
            t[v] = a[l];
            return;
        }
        ll m = (r + l) / 2;
        build(lv(v), l, m);
        build(rv(v), m, r);
        t[v] = min(t[lv(v)], t[rv(v)]);
    }

    ll get(ll v, ll l, ll r, ll ql, ll qr) {
        if(ql >= r || l >= qr) {
            return INF;
        }
        if(ql <= l && r <= qr) {
            return t[v];
        }
        ll m = (r + l) / 2;
        return min(get(lv(v), l, m, ql, qr), get(rv(v), m, r, ql, qr));
    }
};

void viperr() {
    ll n, m, t;
    cin >> n >> m >> t;
    vector<ll> a(n);
    vector<ll> b(m);
    for(auto &i : a) cin >> i;
    for(auto &i : b) cin >> i;
    vector<ll> pref(n + 1);
    SegmentTree tree(a);
    for(ll i = 1;i <= n;i++) {
        pref[i] = pref[i - 1] + a[i - 1];
    }
    ll ans = 0;
    for(auto i : b) {
        i--;
        ll l = 1, r = n + 1;
        while(r - l > 1) {
            ll m = (r + l) / 2;
            if(i + m <= n && pref[i + m] - pref[i] <= t) l = m;
            else r = m;
        }
        ll mn = tree.get(0, 0, n, i, i + l);
        ans = max(ans, (t - (pref[i + l] - pref[i])) / mn + l);
        l = 0, r = n + 1;
        while(r - l > 1) {
            ll m = (r + l) / 2;
            if(i - m >= 0 && pref[i + 1] - pref[i - m] <= t) l = m;
            else r = m;
        }
        mn = tree.get(0, 0, n, i - l, i + 1);
        ans = max(ans, (t - (pref[i + 1] - pref[i - l])) / mn + l + 1);
    }
    cout << ans;
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll tt = 1;
    // cin >> tt;
    while(tt--) {
        viperr();
        cout << '\n';
    }
    return 0;
}