#include <bits/stdc++.h>

using namespace std;
using ll = __int128_t;
ll INF = 1e14;

#define lv(v) v + 1
#define rv(v) v + 2 * (m - l)

struct SegmentTree {
    vector<pair<ll,ll>> t;
    vector<int> a;

    SegmentTree(vector<int> s) {
        a = s;
        t.resize(2 * s.size());
        build(0, 0, s.size());
    }

    pair<ll,ll> merge(pair<ll,ll> a, pair<ll,ll> b) {
        if(a.first == b.first) return {a.first, min(a.second, b.second)};
        else if(a.first < b.first) return a;
        else return b;
    }

    void build(ll v, ll l, ll r) {
        if(r - l == 1) {
            t[v] = {a[l], l};
            return;
        }
        ll m = (r + l) / 2;
        build(lv(v), l, m);
        build(rv(v), m, r);
        t[v] = merge(t[lv(v)], t[rv(v)]);
    }

    pair<ll,ll> get(ll v, ll l, ll r, ll ql, ll qr) {
        if(ql >= r || l >= qr) {
            return {INF, INF};
        }
        if(ql <= l && r <= qr) {
            return t[v];
        }
        ll m = (r + l) / 2;
        return merge(get(lv(v), l, m, ql, qr), get(rv(v), m, r, ql, qr));
    }
};

struct SegmentTree1 {
    vector<pair<ll,ll>> t;
    vector<ll> a;

    SegmentTree1(vector<ll> s) {
        a = s;
        t.resize(2 * s.size());
        build(0, 0, s.size());
    }

    pair<ll,ll> merge(pair<ll,ll> a, pair<ll,ll> b) {
        if(a.first == b.first) return {a.first, max(a.second, b.second)};
        else if(a.first < b.first) return a;
        else return b;
    }

    void build(ll v, ll l, ll r) {
        if(r - l == 1) {
            t[v] = {a[l], l};
            return;
        }
        ll m = (r + l) / 2;
        build(lv(v), l, m);
        build(rv(v), m, r);
        t[v] = merge(t[lv(v)], t[rv(v)]);
    }

    pair<ll,ll> get(ll v, ll l, ll r, ll ql, ll qr) {
        if(ql >= r || l >= qr) {
            return {INF, 0};
        }
        if(ql <= l && r <= qr) {
            return t[v];
        }
        ll m = (r + l) / 2;
        return merge(get(lv(v), l, m, ql, qr), get(rv(v), m, r, ql, qr));
    }
};

void viperr() {
    int n, m, t;
    cin >> n >> m >> t;
    vector<int> a(n);
    vector<int> b(m);
    for(auto &i : a) cin >> i;
    for(auto &i : b) cin >> i;
    vector<ll> pref(n + 1);
    SegmentTree tree(a);
    SegmentTree tree1(a);
    for(ll i = 1;i <= n;i++) {
        pref[i] = pref[i - 1] + a[i - 1];
    }
    ll ans = 0;
    for(auto i : b) {
        i--;
        ll l = 1, r = n - i + 1;
        while(r - l > 1) {
            ll mm = (r + l) / 2;
            if(pref[i + mm] - pref[i] <= t) l = mm;
            else r = mm;
        }
        auto [mn, pos] = tree.get(0, 0, n, i, i + l);
        if((pref[pos + 1] - pref[i]) <= t) ans = max(ans, (t - (pref[pos + 1] - pref[i])) / mn + (pos - i + 1));
        l = 0, r = i + 1;
        while(r - l > 1) {
            ll mm = (r + l) / 2;
            if(pref[i + 1] - pref[i - mm] <= t) l = mm;
            else r = mm;
        }
        auto [mn1, pos1] = tree1.get(0, 0, n, i - l, i + 1);
        if((pref[i + 1] - pref[pos1]) <= t) ans = max(ans, (t - (pref[i + 1] - pref[pos1])) / mn1 + (i - pos1 + 1));
    }
    cout << (long long) ans;
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll tt = 1;
    // cin >> tt;
    while(tt--) {
        viperr();
        cout << '\n';
    }
    return 0;
}