#ifdef _DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <iomanip>
#include <string>
#include <limits>
#include <array>
#include <stack>
#include <queue>
#include <deque>
#include <vector>
#include <numeric>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <chrono>
#include <random>
#include <assert.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ui = unsigned int;
using ld = long double;
using pii = pair<int, int>;
using pli = pair<long long, int>;
using pil = pair<int, long long>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

struct seg {
	int l, r, i;
};

bool operator<(const seg& a, const seg& b) {
	return a.l < b.l;
}

inline void solve() {
	int n, m;
	cin >> n >> m;
	vector<int> a(n), b(n), c(m);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		a[i]--;
	}
	for (int i = 0; i < n; i++) {
		cin >> b[i];
		b[i]--;
	}
	for (int i = 0; i < m; i++) {
		cin >> c[i];
		c[i]--;
	}
	vector<pii> ord(2 * n + m);
	for (int i = 0; i < n; i++) {
		ord[a[i]] = { i, 0 };
		ord[b[i]] = { i, 1 };
	}
	for (int i = 0; i < m; i++)
		ord[c[i]] = { i, 2 };
	vector<bool> used(n);
	auto gen = [&](auto self, int v) -> bool {
		if (v == 2 * n + m)
			return false;
		if (ord[v].second == 2)
			return !self(self, v + 1);
		int i = ord[v].first;
		if (ord[v].second == 1) {
			if (a[i] > b[i])
				return self(self, v + 1);
			if (!used[i])
				return self(self, v + 1);
			else
				return !self(self, v + 1);
		}
		if (a[i] > b[i])
			return true;
		bool res = false;
		if (!self(self, v + 1))
			return true;
		used[i] = 1;
		if (!self(self, v + 1))
			return true;
		used[i] = 0;
		return false;
	};
	if (gen(gen, 0))
		cout << "First\n";
	else
		cout << "Second\n";
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("01.dat", "r", stdin);
#endif
	int tt = 1;
#ifdef _DEBUG
	cin >> tt;
#endif
	for (int test_id = 1; test_id <= tt; test_id++) {
#ifdef _DEBUG
		cout << "TESTCASE# " << test_id << '\n';
#endif
		solve();
	}
	return 0;
}
