#ifdef _DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <iomanip>
#include <string>
#include <limits>
#include <array>
#include <stack>
#include <queue>
#include <deque>
#include <vector>
#include <numeric>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <chrono>
#include <random>
#include <assert.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ui = unsigned int;
using ld = long double;
using pii = pair<int, int>;
using pli = pair<long long, int>;
using pil = pair<int, long long>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

struct seg {
	int l, r, i;
};

bool operator<(const seg& a, const seg& b) {
	return a.l < b.l;
}

bool slow(int n, int m, const vector<int> &a, const vector<int> &b, const vector<pii> ord) {
	vector<bool> used(n);
	auto gen = [&](auto self, int v) -> bool {
		if (v == 2 * n + m)
			return false;
		if (ord[v].second == 2)
			return !self(self, v + 1);
		int i = ord[v].first;
		if (ord[v].second == 1) {
			if (a[i] > b[i])
				return self(self, v + 1);
			if (!used[i])
				return self(self, v + 1);
			else
				return !self(self, v + 1);
		}
		if (a[i] > b[i])
			return true;
		bool res = false;
		if (!self(self, v + 1))
			return true;
		used[i] = 1;
		if (!self(self, v + 1)) {
			used[i] = 0;
			return true;
		}
		used[i] = 0;
		return false;
	};
	return gen(gen, 0);
}

mt19937 rnd(1337);

inline void solve() {
	int n, m;
	cin >> n >> m;
	//n = rnd() % 5 + 1;
	//m = rnd() % 5 + 1;
	vector<int> cols(2 * n + m);
	for (int i = 0; i < n; i++)
		cols[i] = 0;
	for (int i = n; i < 2 * n; i++)
		cols[i] = 1;
	for (int i = 2 * n; i < 2 * n + m; i++)
		cols[i] = 2;
	vector<int> a(n), b(n), c(m);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		a[i]--;
	}
	for (int i = 0; i < n; i++) {
		cin >> b[i];
		b[i]--;
	}
	for (int i = 0; i < m; i++) {
		cin >> c[i];
		c[i]--;
	}
	/*shuffle(all(cols), rnd);
	vector<int> a, b, c;
	for (int i = 0; i < 2 * n + m; i++) {
		if (cols[i] == 0)
			a.push_back(i);
		if (cols[i] == 1)
			b.push_back(i);
		if (cols[i] == 2)
			c.push_back(i);
	}
	shuffle(all(a), rnd);
	shuffle(all(b), rnd);
	shuffle(all(c), rnd);*/
	vector<pii> ord(2 * n + m);
	for (int i = 0; i < n; i++) {
		ord[a[i]] = { i, 0 };
		ord[b[i]] = { i, 1 };
	}
	for (int i = 0; i < m; i++)
		ord[c[i]] = { i, 2 };
	int e = -1;
	for (int i = 0; i < n; i++)
		if (a[i] > b[i] && (e == -1 || a[i] < a[e]))
			e = i;
	if (e == -1) {
		for (int i = 0; i < n; i++)
			if (e == -1 || a[e] < a[i])
				e = i;
	}
	vector<int> ord1(2 * n + m, 2);
	for (int i = 0; i < n; i++)
		ord1[b[i]] = 1;
	ord1[a[e]] = 0;
	ord1[b[e]] = 1;
	for (int v = a[e] - 1; v > -1; v--) {
		if (ord[v].second != 0)
			continue;
		int i = ord[v].first;
		if (b[i] > a[e])
			continue;
		e = i;
		ord1[a[e]] = 0;
		ord1[b[e]] = 1;
	}
	int turn = 0;
	bool res = false;
	for (int v = 0; v < 2 * n + m; v++) {
		if (ord1[v] == 2) {
			turn ^= 1;
			continue;
		}
		if (ord1[v] == 1)
			continue;
		if (!turn)
			res = true;// cout << "First\n";
		else
			res = false;// cout << "Second\n";
		break;
	}
	if (res)
		cout << "First\n";
	else
		cout << "Second\n";
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("01.dat", "r", stdin);
#endif
	int tt = 1;
	//cin >> tt;
	for (int test_id = 1; test_id <= tt; test_id++) {
#ifdef _DEBUG
		cout << "TESTCASE# " << test_id << '\n';
#endif
		solve();
	}
	return 0;
}
