#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;

const ll inf = 1e18;
const ll mod = 1e9 + 7;
const ll c1 = 239;

ll n, m;
vector<ll> a;
vector<ll> b;
vector<ll> c;
gp_hash_table<ll, ll> was;

ll hash1(multiset<pair<ll, ll>> s1, ll ind) {
    ll k = 0;
    for(pair<ll, ll> el : s1) {
        k = ((k * c1) + el.first) % mod;
    }
    k = ((k * c1) + ind) % mod;
    return k;
}

ll dfs1(multiset<pair<ll, ll>> s1, ll ind) {
    if (was.find(hash1(s1, ind)) != was.end()) return was[hash1(s1, ind)];
    if (s1.size() == 0 && ind == c.size()) return 0;
    if (s1.size() == 0) {
        ll ans = (m - ind + 1) % 2;
        was[hash1(s1, ind)] = ans;
        return ans;
    } else if (ind == c.size()) {
        pair<ll, ll> p = *s1.begin();
        ll ans = 0;
        if (p.first == a[p.second]) {
            multiset<pair<ll, ll>> s2 = s1;
            s2.erase(s2.begin());
            ll ans1 = dfs1(s2, ind);
            if (ans1 == 0) ans = 1;
        } else {
            ans = 1;
        }
        was[hash1(s1, ind)] = ans;
        return ans;
    }
    pair<ll, ll> p = *s1.begin();
    if (p.first < c[ind]) {
        ll ans = 0;
        if (p.first == a[p.second]) {
            multiset<pair<ll, ll>> s2 = s1;
            s2.erase(s2.begin());
            ll ans1 = dfs1(s2, ind);
            if (ans1 == 0) ans = 1;
        } else {
            ans = 1;
        }
        was[hash1(s1, ind)] = ans;
        return ans;
    } else {
        ll l = ind, r = c.size();
        while(r - l > 1) {
            ll m1 = (l + r) / 2;
            if (c[m1] < p.first) {
                l = m1;
            } else {
                r = m1;
            }
        }
        if (c[l] > p.first) l--;
        ll ans = ((dfs1(s1, l + 1))) ^ ((l - ind + 1) % 2);
        was[hash1(s1, ind)] = ans;
        return ans;
    }
}

void solve() {
    cin >> n >> m;
    a.assign(n, 0);
    b.assign(n, 0);
    c.assign(m, 0);
    for(int i = 0; i < n; i++) cin >> a[i];
    for(int i = 0; i < n; i++) cin >> b[i];
    for(int i = 0; i < m; i++) cin >> c[i];
    sort(c.begin(), c.end());
    multiset<pair<ll, ll>> s;
    for(int i = 0; i < n; i++) {
        s.insert({a[i], i});
    }
    if (dfs1(s, 0) == 0) {
        cout << "Second\n";
    } else {
        cout << "First\n";
    }
}

int main() {
#ifdef KABANDJAN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll ttt = 1;
//    cin >> ttt;
    while(ttt--) {
        solve();
    }
    return 0;
}
