//
// created by Vadim in 12/34/56
//

#include <bits/stdc++.h>
using ll = long long;

using namespace std;

int n, m;

struct node {
    int a = 0, b = 0;
};

struct spl {
    node card;
    spl *r = nullptr;
    spl *l = nullptr;
    spl *p = nullptr;
    int ch = 0;

    void upd() {
        ch = 1;
        if (l) {
            ch += l->ch;
        }
        if (r) {
            ch += r->ch;
        }
    }

};

spl *root;

void rotate(spl *x) {
    spl *p = x->p;
    spl *g = p->p;
    if (g) {
        if (g->l == p) {
            g->l = x;
        }
        else {
            g->r = x;
        }
    }
    if (p->l == x) {
        x->p = p->p;
        p->p = x;
        if (x->r) x->r->p = p;
        p->l = x->r;
        x->r = p;
    }
    else {
        x->p = p->p;
        p->p = x;
        if (x->l) x->l->p = p;
        p->r = x->l;
        x->l = p;
    }
    p->upd();
    x->upd();
}

void splay(spl *x, spl *roof = nullptr) {
    while (x->p != roof) {
        spl *p = x->p;
        spl *g = p->p;
        if (g == roof) {
            rotate(x);
            continue;
        }
        if ((g->l == p) == (p->l == x)) {
            rotate(p);
            rotate(x);
        }
        else {
            rotate(x);
            rotate(x);
        }
    }
    if (roof == nullptr) root = x;
}

node find(int pos, spl *x = root) {
    pos += 2;
    while (pos) {
        if (x->l && x->l->ch + 1 == pos) return x->card;
        if (!x->l && pos == 1) return x->card;
        if (x->l && x->l->ch + 1 < pos) {
            pos -= x->l->ch + 1;
            x = x->r;
        }
        else if (x->l && x->l->ch >= pos) x = x->l;
        else {
            pos -= 1;
            x = x->r;
        }
    }
    auto ans = x->card;
    splay(x);
    return ans;
}

spl* add_node(node y, spl *x = root) {
    if (!x) {
        spl * x1 = new spl;
        x1->card = y;
        x1->upd();
        return x1;
    }
    if (x->card.a < y.a) {
        if (!x->r) {
            x->r = add_node(y, x->r);
            x->r->p = x;
            x->upd();
            return x->r;
        }
        auto tmp = add_node(y, x->r);
        x->upd();
        return tmp;
    }
    if (!x->l) {
        x->l = add_node(y, x->l);
        x->l->p = x;
        x->upd();
        return x->l;
    }
    auto tmp = add_node(y, x->l);
    x->upd();
    return tmp;
}

void add(node y) {
    splay(add_node(y));
}

spl* find_b(node y, spl* x = root) {
    if (y.a >= x->card.a) {
        if (!x->r) return x;
        return find_b(y, x->r);
    }
    else {
        if (!x->l) return x;
        auto tmp= find_b(y, x->l);
        if (tmp->card.a > y.a) return tmp;
        return x;
    }
}

spl* find_s(node y, spl* x = root) {
    if (y.a <= x->card.a) {
        if (!x->l) return x;
        return find_s(y, x->l);
    }
    else {
        if (!x->r) return x;
        auto tmp= find_s(y, x->r);
        if (tmp->card.a < y.a) return tmp;
        return x;
    }
}

void del(node y) {
    splay(find_b(y));
    splay(find_s(y), root);
    root->l->r = nullptr;
    root->l->upd();
    root->upd();
}

bool operator<(node a1, node b1) {
    return a1.a < b1.a;
}

vector<vector<vector<int>>> mp;

bool rec(int i = 0, bool x = 0) {
    if (i == n + m) {
        return x ^ 1;
    }
    auto a = find(0);
    bool flip = a.b > 0;
    if (mp[x][flip][i]) {
        return mp[x][flip][i] - 1;
    }
    if (mp[x ^ 1][flip][i]) {
        return (mp[x ^ 1][flip][i] - 1) ^ 1;
    }
    if (a.b) {
        bool ans1, ans2;
        del(a);
        ans1 = rec(i + 1, x ^ 1);
        add(a);
        mp[x][0][i] = ans1 + 1;
        if (ans1 == x) {
            mp[x][flip][i] = ans1 + 1;
            return ans1;
        }
        del(a);
        add(node{a.b, 0});
        ans2 = rec(i, x ^ 1);
        del(node{a.b, 0});
        add(a);
        if (ans2 == x) {
            mp[x][flip][i] = ans2 + 1;
            return ans2;
        }
        mp[x][flip][i] = x ^ 1 + 1;
        return x ^ 1;
    }
    else {
        del(a);
        bool ans = rec(i + 1, x ^ 1);
        add(a);
        mp[x][flip][i] = ans + 1;
        return ans;
    }
}

void solve() {
    cin >> n >> m;
    add(node{-10000000, 0});
    add(node{10000000, 0});
    mp.resize(2);
    mp[0].resize(2);
    mp[1].resize(2);
    mp[0][0].resize(n + m);
    mp[0][1].resize(n + m);
    mp[1][0].resize(n + m);
    mp[1][1].resize(n + m);
    vector<node> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].a;
    }
    for (int i = 0; i < n; i++) {
        cin >> a[i].b;
        add(a[i]);
    }
    for (int i = 0; i < m; ++i) {
        int x; cin >> x;
        add(node{x, 0});
    }
    if (rec()) {
        cout << "Second";
    }
    else {
        cout << "First";
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}
