#include <bits/stdc++.h>

#ifndef LOCAL
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2")
#endif

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;
using ll = long long;

const int mod = 10;

struct Modular {
    int x;

    Modular(int x = 0): x(x) {}

    friend Modular operator+(Modular a, Modular b) {
        int res = a.x + b.x;
        return res - (res >= mod ? mod : 0);
    }

    friend Modular operator-(Modular a, Modular b) {
        int res = a.x - b.x;
        return res + (res < 0 ? mod : 0);
    }

    friend Modular operator*(Modular a, Modular b) {
        return ll(a.x) * b.x % mod;
    }
};

const int maxn = 20;
const int maxm = 10;

bool dp[1 << maxn][2 * maxn + maxm];

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n), b(n), c(m);
    for(int i = 0; i < n; ++i){
        cin >> a[i];
    }
    for(int i = 0; i < n; ++i){
        cin >> b[i];
        b[i] = max(a[i], b[i]);
    }
    for(int i = 0; i < m; ++i){
        cin >> c[i];
    }
    vector<tuple<int, int, int>> sup;
    for(int i = 0; i < n; ++i) {
        sup.emplace_back(a[i], i, -1);
        sup.emplace_back(b[i], i, 1);
    }
    for(int i = 0; i < m; ++i) {
        sup.emplace_back(c[i], i, 0);
    }
    sort(all(sup));
    int last = 2 * n + m;
    for(int i = 2 * n + m - 1; i >= 0; --i) {
        auto [x, ind, type] = sup[i];
        if (type == -1 && b[ind] < last) {
            last = a[i];
        }
    }
    if (last % 2 == 0) {
        cout << "First";
    } else {
        cout << "Second";
    }
    return;
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#else
    freopen("C:\\Users\\User\\aboab\\input.txt", "r", stdin);
#endif
    solve();
}