#include "bits/extc++.h"

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

template<typename T>
istream &operator>>(istream &is, vector<T> &a);

template<typename T>
ostream &operator<<(ostream &os, vector<T> &a);


using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

struct Card {
    int a, b, changed;
};

struct Comp {
    bool operator()(Card L, Card R) const {
        return L.a < R.b;
    }
};

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int n, m;
    cin >> n >> m;

    set<Card, Comp> st;
    vector<int> a(n);
    vector<int> b(n);
    cin >> a >> b;
    for (int i = 0; i < n; ++i) {
        st.insert({a[i], b[i], false});
    }
    for (int i = 0; i < n; ++i) {
        int c;
        cin >> c;

        st.insert({c, 0, true});
    }

    int curr = 0;
    while (!st.empty()) {
        Card card = *st.begin();
        st.erase(st.begin());

        if (!card.changed) {
            if (st.size() % 2 == 0) {
                st.insert({card.b, card.a, true});
            }
        }
        curr++;
    }
    cout << (curr % 2 == 1 ? "First" : "Second") << "\n";
}

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &v: a) is >> v;
    return is;
}

template<typename T>
ostream &operator<<(ostream &os, vector<T> &a) {
    for (auto v: a) os << v << " ";
    return (os << "\n");
}