#include "bits/extc++.h"

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

template<typename T>
istream &operator>>(istream &is, vector<T> &a);

template<typename T>
ostream &operator<<(ostream &os, vector<T> &a);


using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int n, m;
    cin >> n >> m;

    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first;
    }
    for (int i = 0; i < n; ++i) {
        cin >> a[i].second;
    }
    vector<pair<int, int>> ga(n);
    for (int i = 0; i < n; ++i) {
        ga[i] = minmax(a[i].first, a[i].second);
    }

    vector<int> ind(n);
    std::iota(ind.begin(), ind.end(), 0ll);
    std::sort(ind.begin(), ind.end(), [&](int L, int R) {
        return minmax(a[L].first, a[L].second) < minmax(a[R].first, a[R].second);
    });

    vector<int> c(m);
    cin >> c;

    std::sort(a.begin(), a.end());
    int l = 0, r = n + 1;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        bool flag = true;
        for (int i = 1; i < mid; ++i) {

            if (ga[ind[i - 1]].first < ga[ind[i]].first && ga[ind[i]].second < ga[ind[i - 1]].second) continue;
            else flag = false;
        }
        if (flag) l = mid;
        else r = mid;
    }

    vector<int> vals;
    for (int i = 0; i < l; ++i) {
        if (a[i].first < a[i].second)
            vals.push_back(a[ind[i]].first);
    }
    for (int i = 0; i < m; ++i) {
        if (c[i] < vals[l - 1])vals.push_back(c[i]);
    }

    std::sort(vals.begin(), vals.end());

    cout << (vals.size() % 2 == 1 ? "First" : "Second") << "\n";
}

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &v: a) is >> v;
    return is;
}

template<typename T>
ostream &operator<<(ostream &os, vector<T> &a) {
    for (auto v: a) os << v << " ";
    return (os << "\n");
}
