#include "bits/extc++.h"

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

template<typename T>
istream &operator>>(istream &is, vector<T> &a);

template<typename T>
ostream &operator<<(ostream &os, vector<T> &a);


using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

struct Card {
    int a, b, changed, id;
};

struct Comp {
    bool operator()(Card L, Card R) const {
        return L.a < R.b;
    }
};


signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int n, m;
    cin >> n >> m;

    vector<pair<int, int>> a(n);
    vector<int> c(m);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first;
    }
    for (int i = 0; i < n; ++i) {
        cin >> a[i].second;
    }
    cin >> c;

    for (int i = 0; i < n; ++i) {
        a[i].first--;
        a[i].second--;
    }
    for (int i = 0; i < m; ++i) {
        c[i]--;
    }

    vector<int> pref(2 * n + m + 1);
    for (int i = 0; i < m; ++i) {
        pref[c[i] + 1]++;
    }
    for (int i = 0; i < 2 * n + m; ++i) {
        pref[i + 1] += pref[i];
    }

    vector<vector<int>> tm((1 << n), vector<int>(n));
    for (int mask = 0; mask < (1 << n); ++mask) {
        set<Card, Comp> avals;
        for (int i = 0; i < n; ++i) {
            avals.insert({
                                 a[i].first,
                                 a[i].second,
                                 !((mask >> i) & 1),
                                 i
                         });
        }

        int l = 0;
        int timer = 0;
        while (!avals.empty()) {
            if (l < avals.begin()->a) {
                int r = avals.begin()->a;
                timer += pref[r] - pref[l];
                l = r;
            } else {
                if (avals.begin()->changed) {
                    if ((mask >> avals.begin()->id) & 1) {
                        avals.erase(avals.begin());
                        timer++;
                    } else {
                        tm[mask][avals.begin()->id] = timer;
                        avals.erase(avals.begin());
                        timer++;
                    }
                    continue;
                } else {
                    Card cd = *avals.begin();
                    avals.erase(avals.begin());
                    swap(cd.a, cd.b);
                    cd.changed = true;
                    tm[mask][cd.id] = timer;
                    avals.insert(cd);
                    timer++;
                }
            }
        }
    }

    auto get = [&](int mask, int k) -> int {
        if (std::find(tm[mask].begin(), tm[mask].end(), k) != tm[mask].end()) {
            return std::find(tm[mask].begin(), tm[mask].end(), k) - tm[mask].begin();
        } else {
            return -1;
        }
    };

    vector<vector<int>> dp((1 << n), vector<int>(n + 1));
    for (int i = n - 1; i >= 0; --i) {
        for (int mask = 0; mask < (1 << n); ++mask) {
            vector<int> vals;
            int id = get(mask, i);
            if (id == -1)vals.push_back(dp[mask][i + 1]);
            else {
                vals.push_back(dp[mask][i + 1]);
                vals.push_back(dp[mask | (1 << id)][i + 1]);
            }
            std::sort(vals.begin(), vals.end());
            int mex = 0;
            for (auto v: vals) mex += (v == mex);

            dp[mask][i] = mex;
        }
    }
    if (dp[0][0] == 0) cout << "First";
    else cout << "Second" << "\n";
}

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &v: a) is >> v;
    return is;
}

template<typename T>
ostream &operator<<(ostream &os, vector<T> &a) {
    for (auto v: a) os << v << " ";
    return (os << "\n");
}