#include "bits/extc++.h"

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

template<typename T>
istream &operator>>(istream &is, vector<T> &a);

template<typename T>
ostream &operator<<(ostream &os, vector<T> &a);


using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

struct Card {
    int a, b, changed, id;
};


bool comp(Card L, Card R) {
    return L.a < R.b;
}


signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int n, m;
    cin >> n >> m;

    vector<pair<int, int>> a(n);
    vector<int> c(m);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first;
    }
    for (int i = 0; i < n; ++i) {
        cin >> a[i].second;
    }
    cin >> c;

    for (int i = 0; i < n; ++i) {
        a[i].first--;
        a[i].second--;
    }
    for (int i = 0; i < m; ++i) {
        c[i]--;
    }

    vector<int> pref(2 * n + m + 1);
    for (int i = 0; i < m; ++i) {
        pref[c[i] + 1]++;
    }
    for (int i = 0; i < 2 * n + m; ++i) {
        pref[i + 1] += pref[i];
    }

    vector<vector<int>> tm((1 << n), vector<int>(2 * n + m + 1, -1));
    for (int mask = 0; mask < (1 << n); ++mask) {
        vector<Card> avals;
        for (int i = 0; i < n; ++i) {
            if ((mask >> i) & 1) {
                avals.push_back({
                                        a[i].first,
                                        a[i].second,
                                        true,
                                        i
                                });
            }
        }
        for (int i = 0; i < m; ++i) {
            avals.push_back({
                                    c[i],
                                    -1,
                                    true,
                                    -1
                            });
        }

        int timer = 0;
        while (!avals.empty()) {
            std::sort(avals.begin(), avals.end(), comp);
            Card card = avals.front();
            avals.erase(avals.begin());
            tm[mask][timer++] = card.id;
            if (card.changed) continue;
            else {
                swap(card.a, card.b);
                card.changed = true;
                card.id = -1;
                avals.push_back(card);
            }
        }
    }

    vector<vector<int>> dp((1 << n), vector<int>(2 * n + m + 1));
    for (int i = 2 * n + m - 1; i >= 0; --i) {
        for (int mask = 0; mask < (1 << n); ++mask) {
            vector<int> vals;
            int id = tm[mask][i];
            if (id == -1)vals.push_back(dp[mask][i + 1]);
            else {
                vals.push_back(dp[mask][i + 1]);
                vals.push_back(dp[mask | (1 << id)][i + 1]);
            }
            std::sort(vals.begin(), vals.end());
            int mex = 0;
            for (auto v: vals) mex += (v == mex);

            dp[mask][i] = mex;
        }
    }
    // cout << dp;

    if (dp[0][0]) cout << "First" << "\n";
    else cout << "Second" << "\n";
}

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &v: a) is >> v;
    return is;
}

template<typename T>
ostream &operator<<(ostream &os, vector<T> &a) {
    for (auto v: a) os << v << " ";
    return (os << "\n");
}