#include "bits/stdc++.h"

using namespace std;

template<class T>
istream &operator>>(istream &is, vector<T> &vec) {
      for (auto &elem: vec) is >> elem;
      return is;
}

template<class T>
ostream &operator<<(ostream &os, const vector<T> &vec) {
      for (auto &elem: vec) os << elem << ' ';
      os << '\n';
      return os;
}
#pragma optimize("Ofast")
#pragma optimize("unroll-loops")
#pragma optimize("avx, avx2")

using ull = unsigned long long;
using H = pair<ull, ull>;

const ull mod = 1e9 + 7, p = 333333;

vector<ull> mpw(1, 1), pw(1, 1);
struct Hash {
      vector<ull> h, mh;

      Hash(int n) {
            while (mpw.size() <= n) {
                  mpw.push_back(mpw.back() * p % mod);
                  pw.push_back(pw.back() * p);
            }
      }

      Hash(const vector<ull> &s): Hash(s.size()) {
            h.push_back(0);
            mh.push_back(0);
            for (int i = 0; i < s.size(); ++i) {
                  h.push_back(h[i] * p + s[i]);
                  mh.push_back((mh[i] * p % mod + s[i]) % mod);
            }
      }

      H get(int l, int r) {
            ull mres = mh[r] - mh[l] * mpw[r - l] % mod;
            if (mres < 0) mres += mod;
            ull res = h[r] - h[l] * pw[r - l];
            return {mres, res};
      }
};
signed main() {
#ifdef LOCAL
      freopen("input.txt", "r", stdin);
      freopen("output.txt", "w", stdout);
#else
      ios_base::sync_with_stdio(false);
      cin.tie(nullptr);
#endif
      int n, m;
      cin >> n >> m;
      vector<int> a(n), c(n), b(m);
      cin >> a >> c >> b;

      set<pair<int, int>> now;
      for (int i = 0; i < n; ++i) now.insert({a[i], i});
      for (int i = 0; i < m; ++i) now.insert({b[i], -1});
      map<H, int> map1;
      function<bool()> rec = [&]() {
            if (now.empty()) return 1;
            vector<int> h;
            for(auto [x,y]: now) h.push_back(x);
            H t = Hash(h).get(0, now.size());
            if (map1.count(t)) return map1[t];

            auto mem = *now.begin();
            now.erase(mem);
            if (rec()) {
                  now.insert(mem);
                  map1[t] = 0;
                  return 0;
            }
            now.insert(mem);

            if (mem.second >= 0) {
                  int id = mem.second;
                  now.erase(mem);
                  now.insert({c[id], -1});
                  if (rec()) {
                        now.erase({c[id], -1});
                        now.insert(mem);
                        map1[t] = 0;
                        return 0;
                  }
                  now.erase({c[id], id});
                  now.insert(mem);
            }
            map1[t] = 1;
            return 1;
      };

      if (rec()) {
            cout << "Second";
      } else {
            cout << "First";
      }
}