#include "bits/stdc++.h"

using namespace std;

template<class T>
istream& operator>>(istream &is, vector<T> &vec) {
      for (auto &elem: vec) is >> elem;
      return is;
}
template<class T>
ostream& operator<<(ostream &os, const vector<T> &vec) {
      for (auto &elem: vec) os << elem << ' ';
      os << '\n';
      return os;
}

struct event {
            int pos, type, id;
      };

signed main() {
#ifdef LOCAL
      freopen("input.txt", "r", stdin);
      freopen("output.txt", "w", stdout);
#else
      ios_base::sync_with_stdio(false);
      cin.tie(nullptr);
#endif
      int n, m;
      cin >> n >> m;
      vector<int> a(n), b(n), c(m);
      cin >> a >> b >> c;

      vector<event> es;
      for (int i = 0; i < n; ++i) {
            es.push_back({a[i], 1, i});
            es.push_back({b[i], -1, i});
      }
      std::sort(es.begin(), es.end(), [&](auto x, auto y) {
            return x.pos < y.pos;
      });

      vector<pair<int, int>> t;
      int last = -1;
      vector<int> used(n);
      for (auto [pos, type, id]: es) {
            if (type == 1) {
                  last = id;
            } else {
                  if (last == id) {
                        t.push_back({a[id], id});
                        used[id] = 1;
                        last = -1;
                  }
            }
      }

      for (int i = 0; i < n; ++i) {
            if (!used[i]) {
                  t.push_back({a[i], -1});
            }
      }
      for (int j = 0; j < m; ++j) {
            t.push_back({c[j], -1});
      }

      sort(t.rbegin(), t.rend());

      int now = 0;
      for (int i = 0; i < t.size(); ++i) {
            if (t[i].second == -1) now ^= 1;
            else now = 1;
      }

      if (now) cout << "First";
      else cout << "Second";
}