#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <numeric>

#include <ext/pb_ds/assoc_container.hpp>

#define all(a) a.begin(), a.end()
#define int long long

// #pragma GCC optimize("O3")

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

using oset = tree<pll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>; 

constexpr ll inf = 1e18;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<pii> z(n + m);
    int t;
    for (int i = 0; i < n; ++i) cin >> z[i].first;
    for (int i = 0; i < n; ++i) {
        cin >> z[i].second;
    }
    for (int i = n; i < n + m; ++i) {
        cin >> z[i].first;
        z[i].second = -1;
    }
    sort(all(z));

    vector<int> dp(n + m);
    dp.back() = 1;
    for (int i = n + m - 2; i >= 0; --i) {
        dp[i] = 1 - dp[i + 1];
        if (dp[i] == 0 and z[i].second != -1) dp[i] = 1;
    }
    if (dp[0]) cout << "First";
    else cout << "Second";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}