#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <numeric>

#include <ext/pb_ds/assoc_container.hpp>

#define all(a) a.begin(), a.end()
#define int long long

// #pragma GCC optimize("O3")

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

using oset = tree<pll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>; 

constexpr ll inf = 1e18;

set<pii> q;

bool f() {
    if (q.empty()) {
        return false;
    }
    auto cur = *q.begin();
    q.erase(q.begin());
    if (!f()) {
        q.insert(cur);
        return true;
    }
    if (cur.second != -1) {
        q.emplace(cur.second, -1);
        if (!f()) {
            q.erase({cur.second, -1});
            q.insert(cur);
            return true;
        }
        q.erase({cur.second, -1});
    }

    q.insert(cur);
    return false;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<pii> z(n);
    int t;
    for (int i = 0; i < n; ++i) cin >> z[i].first;
    for (int i = 0; i < n; ++i) {
        cin >> z[i].second;
        q.insert(z[i]);
    }
    for (int i = 0; i < m; ++i) {
        cin >> t;
        q.emplace(t, -1);
    }

    z.clear();

    auto it = q.begin();
    while (it != q.end() and next(it) != q.end()) {
        if (it->second == -1 and next(it)->second == -1 and it->first + 1 == next(it)->first) {
            ++it;
            ++it;
        } else {
            z.push_back(*it);
            ++it;
        }
    }
    z.push_back(*it);
    
    if (z.empty()) {
        cout << "Second";
        return;
    }
    vector<int> dp(z.size());
    dp.back() = 1;
    for (int i = (int) z.size() - 2; i >= 0; --i) {
        dp[i] = 1 - dp[i + 1];
        if (dp[i] == 0 and z[i].second != -1) dp[i] = 1;
    }
    if (dp[0]) cout << "First";
    else cout << "Second";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}