#ifndef LOCAL
#include <bits/allocator.h>
#pragma GCC optimize("O3,unroll-loops,no-stack-protector")
#pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt,tune=native")
#else
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using i128 = __int128_t;

#define all(x) (x).begin(), (x).end()

void solve() {
    int n, m;
    cin >> n >> m;
    vector<pair<int, int>> cards(n + m);
    vector<bool> starts(n + m);
    for (int i = 0; i < n; ++i) {
        cin >> cards[i].first;
        starts[cards[i].first - 1] = true;
    }
    for (int i = 0; i < n; ++i) {
        cin >> cards[i].second;
    }
    for (int i = 0; i < m; ++i) {
        cin >> cards[i + n].first;
        cards[i + n].second = 0;
    }
    vector<bool> is_terminating(n + m);
    vector<bool> parity(n + m);
    for (auto &[a, b] : cards) {
        --a, --b;
    }
    for (int i = 0; i < n; ++i) {
        auto [a, b] = cards[i];
        if (a > b) swap(a, b);
        bool is_bad = false;
        for (int j = a + 1; j < b; ++j) {
            if (starts[j]) {
                is_bad = true;
                break;
            }
            parity[a] = !parity[a];
        }
        if (!is_bad) {
            is_terminating[a] = true;
        }
    }
    sort(all(cards));
    bool turn = false;
    for (int i = 0; i < n + m; ++i) {
        turn = !turn;
        if (cards[i].second == -1) {
            continue;
        }
        if (is_terminating[cards[i].first]) {
            turn ^= parity[cards[i].first];
            break;
        }
    }
    if (turn) {
        cout << "First\n";
    } else {
        cout << "Second\n";
    }
}

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}