#ifndef LOCAL
#include <bits/allocator.h>
#pragma GCC optimize("O3,unroll-loops,no-stack-protector")
#pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt,tune=native")
#else
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using i128 = __int128_t;

#define all(x) (x).begin(), (x).end()

void solve() {
    int n, m;
    cin >> n >> m;
    vector<pair<int, int>> cards(n + m);
    vector<bool> ends(n * 2 + m);
    vector<bool> start(n * 2 + m);
    for (int i = 0; i < n; ++i) {
        cin >> cards[i].first;
    }
    for (int i = 0; i < n; ++i) {
        cin >> cards[i].second;
        ends[cards[i].first - 1] = true;
        ends[cards[i].second - 1] = true;
        start[cards[i].first - 1] = true;
    }
    for (int i = 0; i < m; ++i) {
        cin >> cards[i + n].first;
        cards[i + n].second = 0;
        start[cards[i + n].first - 1] = true;
    }
    for (auto &[a, b] : cards) {
        --a, --b;
    }
    vector<int> winners(n * 2 + m, -1);
    for (int i = 0; i < n; ++i) {
        auto [a, b] = cards[i];
        winners[max(a, b)] = a;
    }
    sort(all(cards));
    bool turn = true;
    vector<int> whose_turn(n * 2 + m, -1);
    vector<int> other_end(n * 2 + m, -1);
    for (int i = 0; i < n + m; ++i) {
        auto [a, b] = cards[i];
        if (b == -1) {
            other_end[a] = a;
        } else {
            other_end[a] = b;
            other_end[b] = a;
        }
    }
    for (int i = 0; i < n * 2 + m; ++i) {
        whose_turn[i] = turn;
        if (other_end[i] >= i) {
            turn = !turn;
            continue;
        }
        if (winners[i] != -1) {
            if (whose_turn[winners[i]]) {
                cout << "First\n";
            } else {
                cout << "Second\n";
            }
            return;
        }
        if (start[i]) {
            turn = !turn;
        }
    }
    assert(false);
}

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}