#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;

using namespace std;

#define int long long
#define double long double

typedef tree<int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef tree<int, null_type, less_equal <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_multi_set;

int inf = (int)1000 * 1000 * 1000 * 1000 * 1000 * 1000;

struct st //+=, sum
{
    vector <int> t;
    vector <int> p;

    void build(int n)
    {
        t.resize(4 * n, 0);
        p.resize(4 * n, 0);
    }

    void push(int v, int l, int r)
    {
        if (p[v] != 0)
        {
            p[v * 2 + 1] += p[v];
            p[v * 2 + 2] += p[v];
            int m = (l + r) / 2;
            t[v * 2 + 1] += (m - l + 1) * p[v];
            t[v * 2 + 2] += (r - m) * p[v];
            p[v] = 0;
        }
    }

    int get(int v, int l, int r, int ll, int rr)
    {
        if (ll > rr)
        {
            return 0;
        }
        if (l == ll && r == rr)
        {
            return t[v];
        }

        int m = (l + r) / 2;
        push(v, l, r);
        return get(v * 2 + 1, l, m, ll, min(m, rr)) +
               get(v * 2 + 2, m + 1, r, max(m + 1, ll), rr);
    }

    void update(int v, int l, int r, int ll, int rr, int x)
    {
        if (ll > rr)
        {
            return;
        }
        if (l == ll && r == rr)
        {
            t[v] += x * (r - l + 1);
            p[v] += x;
            return;
        }
        int m = (l + r) / 2;
        push(v, l, r);
        update(v * 2 + 1, l, m, ll, min(m, rr), x);
        update(v * 2 + 2, m + 1, r, max(m + 1, ll), rr, x);
        t[v] = t[v * 2 + 1] + t[v * 2 + 2];
    }
};

int mod = 1000 * 1000 * 1000 + 7;

int bin_pow(int a, int x)
{
    if (x == 0)
    {
        return 1;
    }
    if (x % 2 == 0)
    {
        return bin_pow((a * a) % mod, x / 2);
    }
    return (a * bin_pow((a * a) % mod, x / 2)) % mod;
}

int add(int a, int b)
{
    if (a + b >= mod)
    {
        return a + b - mod;
    }
    return a + b;
}

int umn(int a, int b)
{
    return (a * b) % mod;
}

int del(int a, int b)
{
    return umn(a, bin_pow(b, mod - 2));
}

void solve()
{
    int n, m;
    cin >> n >> m;
    vector <int> a(n);
    for (int i = 0; i < n; i ++)
    {
        cin >> a[i];
    }
    vector <int> b(n);
    for (int i = 0; i < n; i ++)
    {
        cin >> b[i];
    }

    vector <int> c(m);
    for (int i = 0; i < m; i ++)
    {
        cin >> c[i];
    }

    vector <pair <int, int>> t; //-1 / ind

    for (int i = 0; i < n; i ++)
    {
        t.push_back({a[i], i});
        t.push_back({b[i], -1});
    }

    std::sort(t.begin(), t.end());

    int ind = -1;
    for (int i = 0; i < t.size() - 1; i ++)
    {
        if ((t[i].second != -1 && t[i + 1].second == -1) || (t[i].second == -1 && t[i + 1].second != -1))
        {
            ind = max(t[i].second, t[i + 1].second);
            break;
        }
    }

    vector <pair <int, int>> t2;
    for (int i = 0; i < n; i ++)
    {
        t2.push_back({a[i], i});
    }
    for (int i = 0; i < m; i ++)
    {
        t2.push_back({c[i], -1});
    }
    std::sort(t2.begin(), t2.end());
    for (int i = 0; i < t2.size(); i ++)
    {
        if (t2[i].second == ind)
        {
            if (i % 2 == 0)
            {
                cout << "First" << '\n';
            }
            else
            {
                cout << "Second" << '\n';
            }
            return;
        }
    }
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    int _ = 1;
    //cin >> _;
    while (_ --)
    {
        solve();
    }
}
