#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

template<typename T>
istream& operator>>(istream& in, vector<T>& v);
template<typename T>
ostream& operator<<(ostream& out, vector<T>& v);
template<typename T1, typename T2>
istream& operator>>(istream& in, pair<T1, T2>& p);
template<typename T1, typename T2>
ostream& operator<<(ostream& out, pair<T1, T2>& p);

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (T& x : v) in >> x;
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, vector<T>& v) {
    for (T& x : v) out << x << " ";
    return out;
}

template<typename T1, typename T2>
istream& operator>>(istream& in, pair<T1, T2>& p) {
    in >> p.first >> p.second;
    return in;
}

template<typename T1, typename T2>
ostream& operator<<(ostream& out, pair<T1, T2>& p) {
    out << p.first << " " << p.second;
    return out;
}

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
using ll = long long;
using ld = long double;

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n), b(n), c(m);
    cin >> a >> b >> c;

    vector<int> ord(2 * n + m);
    iota(all(ord), 0);
    sort(all(ord), [&](int i, int j) {
        int vi = (i < n ? a[i] : (i < 2 * n ? b[i - n] : c[i - 2 * n]));
        int vj = (j < n ? a[j] : (j < 2 * n ? b[j - n] : c[j - 2 * n]));
        return vi < vj;
    });

    bool gd = true;
    for (int i = 0; i < n; i++) {
        if (a[i] < b[i]) gd = false;
    }

    if (gd) {
        bool a1 = true, a2 = false;
        for (int i = 2 * n + m - 2; i >= 0; i--) {
            if (ord[i] < n) {
                bool n1 = a1 || a2, n2 = a1 && a2;
                a1 = n1, a2 = n2;
            } else if (ord[i] < 2 * n) {
                continue;
            } else {
                swap(a1, a2);
            }
        }
        if (a1) cout << "First";
        else cout << "Second";
        return;
    }

    vector<bool> a1(1 << n), a2(1 << n);
    a2[0] = 1;
    for (int i = 2 * n + m - 1; i >= 0; i--) {
        int x = ord[i];
        if (x < n) {
            if (a[x] < b[x]) {
                vector<bool> n1(1 << n), n2(1 << n);
                for (int mask = 0; mask < (1 << n); mask++) {
                    if ((mask >> (x - n)) & 1) {
                        if (a2[mask]) n1[mask] = 1;
                        if (a1[mask] && a1[mask ^ (1 << x)]) n2[mask] = 1;
                    } else {
                        if (a2[mask]) n1[mask] = 1;
                        if (a1[mask] && a1[mask ^ (1 << x)]) n2[mask] = 1;
                    }
                }
                a1 = n1, a2 = n2;
            } else {
                vector<bool> n1(1 << n), n2(1 << n);
                for (int i = 0; i < a1.size(); i++) n1[i] = a1[i] || a2[i];
                for (int i = 0; i < a1.size(); i++) n2[i] = a1[i] && a2[i];
                a1 = n1, a2 = n2;
            }
        } else if (x < 2 * n) {
            if (a[x - n] < b[x - n]) {
                vector<bool> n1 = a1, n2 = a2;
                for (int mask = 0; mask < (1 << n); mask++) {
                    if ((mask >> (x - n)) & 1) {
                        if (a2[mask ^ (1 << (x - n))]) n1[mask] = 1;
                        if (a1[mask ^ (1 << (x - n))]) n2[mask] = 1;
                    }
                }
                a1 = n1, a2 = n2;
            } else {
                continue;
            }
        } else {
            a1.swap(a2);
        }
    }

    bool is = false;
    for (int i = 0; i < a1.size(); i++) is |= a1[i];
    if (is) cout << "First";
    else cout << "Second";
}

signed main() {
#ifndef LOCAL
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
#endif

    int t = 1;
//    cin >> t;
    while (t--) solve();
}