#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

template<typename T>
istream& operator>>(istream& in, vector<T>& v);
template<typename T>
ostream& operator<<(ostream& out, vector<T>& v);
template<typename T1, typename T2>
istream& operator>>(istream& in, pair<T1, T2>& p);
template<typename T1, typename T2>
ostream& operator<<(ostream& out, pair<T1, T2>& p);

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (T& x : v) in >> x;
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, vector<T>& v) {
    for (T& x : v) out << x << " ";
    return out;
}

template<typename T1, typename T2>
istream& operator>>(istream& in, pair<T1, T2>& p) {
    in >> p.first >> p.second;
    return in;
}

template<typename T1, typename T2>
ostream& operator<<(ostream& out, pair<T1, T2>& p) {
    out << p.first << " " << p.second;
    return out;
}

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
using ll = long long;
using ld = long double;

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n), b(n), c(m);
    cin >> a >> b >> c;

    vector<int> ord(2 * n + m);
    iota(all(ord), 0);
    sort(all(ord), [&](int i, int j) {
        int vi = (i < n ? a[i] : (i < 2 * n ? b[i - n] : c[i - 2 * n]));
        int vj = (j < n ? a[j] : (j < 2 * n ? b[j - n] : c[j - 2 * n]));
        return vi < vj;
    });

    vector<bool> a1(n + 2), a2(n + 2);
    a2[0] = true;
    for (int i = 2 * n + m - 1; i >= 0; i--) {
        int x = ord[i];
        if (x < n) {
            if (a[x] < b[x]) {
                vector<bool> n1(n + 2), n2(n + 2);
                for (int j = n; j >= 0; j--) {
                    if (a2[j] || a2[j + 1]) n1[j] = true;
                    if (a1[j] && a1[j + 1]) n2[j] = true;
                }
                a1 = n1, a2 = n2;
            } else {
                vector<bool> n1(n + 2), n2(n + 2);
                for (int j = n + 1; j >= 0; j--) {
                    n1[j] = a1[j] || a2[j];
                    n2[j] = a1[j] && a2[j];
                }
                a1 = n1, a2 = n2;
            }
        } else if (x < 2 * n) {
            if (a[x - n] < b[x - n]) {
                vector<bool> n1(n + 2), n2(n + 2);
                n1[0] = a1[0], n2[0] = a2[0];
                for (int j = n + 1; j > 0; j--) {
                    if (a1[j] || a2[j - 1]) n1[j] = true;
                    if (a2[j] && a1[j - 1]) n2[j] = true; //?
                }
                a1 = n1, a2 = n2;
            } else {
                continue;
            }
        } else {
            a1.swap(a2);
        }
    }

    if (a1[0]) cout << "First";
    else cout << "Second";
}

signed main() {
#ifndef LOCAL
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
#endif

    int t = 1;
//    cin >> t;
    while (t--) solve();
}