#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

template<typename T>
istream& operator>>(istream& in, vector<T>& v);
template<typename T>
ostream& operator<<(ostream& out, vector<T>& v);
template<typename T1, typename T2>
istream& operator>>(istream& in, pair<T1, T2>& p);
template<typename T1, typename T2>
ostream& operator<<(ostream& out, pair<T1, T2>& p);

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (T& x : v) in >> x;
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, vector<T>& v) {
    for (T& x : v) out << x << " ";
    return out;
}

template<typename T1, typename T2>
istream& operator>>(istream& in, pair<T1, T2>& p) {
    in >> p.first >> p.second;
    return in;
}

template<typename T1, typename T2>
ostream& operator<<(ostream& out, pair<T1, T2>& p) {
    out << p.first << " " << p.second;
    return out;
}

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
using ll = long long;
using ld = long double;

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n), b(n), c(m);
    cin >> a >> b >> c;

    vector<int> ord(2 * n + m);
    iota(all(ord), 0);
    sort(all(ord), [&](int i, int j) {
        int vi = (i < n ? a[i] : (i < 2 * n ? b[i - n] : c[i - 2 * n]));
        int vj = (j < n ? a[j] : (j < 2 * n ? b[j - n] : c[j - 2 * n]));
        return vi < vj;
    });

    vector<bool> dp(n + 1);
    int cnt = 0;
    for (int i = 2 * n + m - 1; i >= 0; i--) {
        int x = ord[i];
        if (x < n) {
            if (a[x] < b[x]) {
                vector<bool> ndp(n + 1);
                ndp[n] = dp[n];
                for (int j = 0; j + 1 <= n; j++) {
                    ndp[j] = (!dp[j]) && (!dp[j + 1]);
                }
                dp = ndp;
            } else {
                fill(all(dp), false);
                for (int j = 0; j <= cnt; j++) dp[j] = true;
            }
        } else if (x < 2 * n) {
            if (a[x - n] < b[x - n]) {
                vector<bool> ndp(n + 1);
                ndp[0] = dp[0];
                for (int j = 1; j <= n; j++) {
                    ndp[j] = (!dp[j]) && (!dp[j - 1]);
                }
                dp = ndp;
                cnt++;
            } else {
                continue;
            }
        } else {
            for (int i = 0; i <= n; i++) dp[i] = !dp[i];
        }
    }

    if (dp[0]) cout << "First";
    else cout << "Second";
}

signed main() {
#ifndef LOCAL
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
#endif

    int t = 1;
//    cin >> t;
    while (t--) solve();
}