#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

template<typename T>
istream& operator>>(istream& in, vector<T>& v);
template<typename T>
ostream& operator<<(ostream& out, vector<T>& v);
template<typename T1, typename T2>
istream& operator>>(istream& in, pair<T1, T2>& p);
template<typename T1, typename T2>
ostream& operator<<(ostream& out, pair<T1, T2>& p);

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (T& x : v) in >> x;
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, vector<T>& v) {
    for (T& x : v) out << x << " ";
    return out;
}

template<typename T1, typename T2>
istream& operator>>(istream& in, pair<T1, T2>& p) {
    in >> p.first >> p.second;
    return in;
}

template<typename T1, typename T2>
ostream& operator<<(ostream& out, pair<T1, T2>& p) {
    out << p.first << " " << p.second;
    return out;
}

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
using ll = long long;
using ld = long double;

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

pair<bool, bool> merge(pair<bool, bool> a, pair<bool, bool> b) {
    pair<bool, bool> res;
    if (a.first && !b.first) res.first = true;
    if (a.second && b.first) res.first = true;
    if (a.first && b.second) res.second = true;
    if (a.second && !b.second) res.second = true;
    return res;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n), b(n), c(m);
    cin >> a >> b >> c;

    vector<int> ord(2 * n + m);
    iota(all(ord), 0);
    sort(all(ord), [&](int i, int j) {
        int vi = (i < n ? a[i] : (i < 2 * n ? b[i - n] : c[i - 2 * n]));
        int vj = (j < n ? a[j] : (j < 2 * n ? b[j - n] : c[j - 2 * n]));
        return vi < vj;
    });

    int sz = 2 * n + m;
    vector<pair<bool, bool>> dp(sz);
    dp[sz] = {false, true};
    for (int i = sz - 1; i >= 0; i--) {
        int x = ord[i];
        if (x < n) {
            if (a[x] < b[x]) {
                pair<bool, bool> t = {false, true};
                for (int j = b[x] - 2; j > i; j--) {
                    int x = ord[j];
                    if (x < n) {
                        t = {true, true};
                    } else if (x < 2 * n) {
                        t = t;
                    } else {
                        t = {!t.first, !t.second};
                    }
                }
                dp[i].first = !dp[i + 1].first || !merge(t, {!dp[b[x]].first, !dp[b[x]].second}).first;
                dp[i].second = !dp[i + 1].second || !merge(t, {!dp[b[x]].first, !dp[b[x]].second}).second;
            } else {
               dp[i] = {true, true};
            }
        } else if (x < 2 * n) {
            dp[i] = dp[i + 1];
        } else {
            dp[i] = {!dp[i + 1].first, !dp[i + 1].second};
        }
    }
    
    
//    vector<vector<pair<bool, bool>>> dp(2 * n + m + 1, vector<pair<bool, bool>>(2 * n + m + 1, {false, true}));
//    for (int l = sz - 1; l >= 0; l--) {
//        for (int r = l; r <= sz; r++) {
//            int x = ord[l];
//            if (x < n) {
//                if (a[x] < b[x]) {
//                    if (b[x] - 1 <= r) {
//                        dp[l][r].first = !dp[l + 1][r].first || !merge(dp[l + 1][b[x] - 2], {!dp[b[x]][r].first, !dp[b[x]][r].second}).first;
//                        dp[l][r].second = !dp[l + 1][r].second || !merge(dp[l + 1][b[x] - 2], {!dp[b[x]][r].first, !dp[b[x]][r].second}).second;
//                    }
//                } else {
//                    if (l < r) dp[l][r] = {true, true};
//                    else dp[l][r] = {true, true};
//                }
//            } else if (x < 2 * n) {
//                if (l < r) dp[l][r] = dp[l + 1][r];
//            } else {
//                if (l < r) dp[l][r] = {!dp[l + 1][r].first, !dp[l + 1][r].second};
//                else dp[l][r] = {true, false};
//            }
////            cout << l << " " << r << ": " << dp[l][r] << "\n";
//        }
//    }

    if (dp[0].first) cout << "First";
    else cout << "Second";
}

signed main() {
#ifndef LOCAL
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
#endif

    int t = 1;
//    cin >> t;
    while (t--) solve();
}