#include <iostream>
#include <random>
#include <numeric>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;
using ll = long long;
using ull = unsigned long long;
template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

constexpr int maxn = 5e5 + 10;

//int osds[maxn];
//ordered_set<int> rev_tsds;
//set<pair<int, int>> tsds;
pair<int, int> raw_tsds[maxn];
set<pair<int, int>> cards;
int n, m;

bool rec_sol() {
    if (cards.empty()) return false;
    auto tc = *cards.begin();
    cards.erase(cards.begin());
    if (!rec_sol()) {
        cards.insert(tc);
        return true;
    }
    if (tc.second != -1) {
        cards.emplace(tc.second, -1);
        if (!rec_sol()) {
            cards.erase(make_pair(tc.second, -1));
            cards.insert(tc);
            return true;
        }
        cards.erase(make_pair(tc.second, -1));
    }
    cards.insert(tc);
    return false;
}

void solve() {
    cin >> n >> m;
    for (int i = 0; i < n; ++i) cin >> raw_tsds[i].first;
    for (int i = 0; i < n; ++i) cin >> raw_tsds[i].second;
    cards.clear();
    cards.insert(raw_tsds, raw_tsds + n);
    for (int i = 0, t; i < m; ++i) cin >> t, cards.emplace(t, -1);
    if (rec_sol()) cout << "First\n";
    else cout << "Second\n";
}

int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);
    int t = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> t;
#else
#ifdef TEST
    freopen("input.txt", "r", stdin);
#else
#endif
#endif
    while (t--) {
        solve();
        cout << "\n";
    }
    return 0;
}
