#include <iostream>
#include <random>
#include <numeric>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;
using ll = long long;
using ull = unsigned long long;
template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

constexpr int maxn = 5e5 + 10;

int osds[maxn];
ordered_set<int> rev_tsds;
set<pair<int, int>> tsds;
pair<int, int> raw_tsds[maxn];
//set<pair<int, int>> cards;
int n, m;

int cards_cnt(int a, int b) { //[a, b)
    return (lower_bound(osds, osds + m, b) - lower_bound(osds, osds + m, a))
           + (rev_tsds.order_of_key(b) - rev_tsds.order_of_key(a));
}

bool rec_sol() {
    if (tsds.size() == 1) return true;
    auto tc = *tsds.begin();
    if (tc.second < tc.first) return true;
    tsds.erase(tsds.begin());
    int next_card = tsds.empty() ? 2 * n + m + 1 : tsds.begin()->first;
    bool inv = cards_cnt(tc.first + 1, next_card) & 1;
    if (!(inv ^ rec_sol())) {
        tsds.insert(tc);
        return true;
    }
    rev_tsds.insert(tc.second);
    inv = cards_cnt(tc.first + 1, next_card) & 1;
    if (!(inv ^ rec_sol())) {
        tsds.insert(tc);
        rev_tsds.erase(tc.second);
        return true;
    }
    tsds.insert(tc);
    rev_tsds.erase(tc.second);
    return false;
}

void solve() {
    cin >> n >> m;
    for (int i = 0; i < n; ++i) cin >> raw_tsds[i].first;
    for (int i = 0; i < n; ++i) cin >> raw_tsds[i].second;
    tsds.clear();
    tsds.insert(raw_tsds, raw_tsds + n);
    for (int i = 0; i < m; ++i) cin >> osds[i];
    sort(osds, osds + m);
    int next_card = tsds.empty() ? 2 * n + m + 1 : tsds.begin()->first;
    bool inv = cards_cnt(0, next_card) & 1;
    if (inv ^ rec_sol()) cout << "First\n";
    else cout << "Second\n";
}

int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);
    int t = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> t;
#else
#ifdef TEST
    freopen("input.txt", "r", stdin);
#else
#endif
#endif
    while (t--) {
        solve();
        cout << "\n";
    }
    return 0;
}
