#include <iostream>
#include <random>
#include <numeric>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;
using ll = long long;
using ull = unsigned long long;
template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

constexpr int maxn = 5e5 + 10;

int n, m;

void solve() {
    cin >> n >> m;
    int maxa = 0;
    vector<int> vals(n + m);
    for (int i = 0; i < n; ++i) cin >> vals[i], maxa = max(maxa, vals[i]);
    for (int i = 0, t; i < n; ++i) cin >> t;
    for (int i = 0; i < m; ++i) cin >> vals[i + n];
    sort(vals.begin(), vals.end());
    int pos = lower_bound(vals.begin(), vals.end(), maxa) - vals.begin();
    if (pos & 1) cout << "First\n";
    else cout << "Second\n";
}

int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);
    int t = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> t;
#else
#ifdef TEST
    freopen("input.txt", "r", stdin);
#else
#endif
#endif
    while (t--) {
        solve();
        cout << "\n";
    }
    return 0;
}
