#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using vii = vector<pair<int, int>>;
using vc = vector<char>;
using vb = vector<bool>;
template<typename T>
using ve = vector<T>;
template<typename T1, typename T2>
using pr = pair<T1, T2>;

const int INF = 1e9 + 1;
const long long INFLL = 1e18 + 1;
const int MOD = 1e9 + 7;

inline void fchmin(int &a, int &b) { a = min(a, b); }
inline void fchmax(int &a, int &b) { a = max(a, b); }

template<typename T>
inline bool chmin(T &a, T &b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
inline bool chmax(T &a, T &b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

// #include<ext/pb_ds/assoc_container.hpp>
// using namespace __gnu_pbds;
// using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

int reps = 1;

struct FenwickTree {
    int maxn;
    vi ft;

    FenwickTree() {}
    FenwickTree(int n) : maxn(n) {
        ft.resize(maxn);
    }
    FenwickTree(vi &a) : maxn(a.size()) {
        ft.resize(maxn);
        vi pref(maxn + 1);
        for (int i = 1; i <= maxn; i++) pref[i] = pref[i - 1] + a[i - 1];
        for (int i = maxn - 1; i >= 0; i--) {
            ft[i] = pref[i + 1] - pref[i & (i + 1)];
        }
    }

    void update(int pos, int x) {
        for (int i = pos; i < maxn; i |= (i + 1)) ft[i] += x;
    }

    int get(int ql, int qr) {
        return get(qr - 1) - get(ql - 1);
    } 

    int get(int r) {
        int res = 0;
        for (int i = r; i >= 0; i = (i & (i + 1)) - 1) res += ft[i];
        return res;
    }
};

int count(vi &a, int x) {
    int l = 0, r = a.size();
    while (r - l > 1) {
        int mid = (r + l) / 2;
        if (a[mid] < x) l = mid;
        else r = mid;
    }
    if (a[l] >= x) return 0;
    return r;
}

void solve() {
    int n, m; cin >> n >> m;
    vi a(n), b(n), c(m);
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < n; i++) cin >> b[i];
    for (int i = 0; i < m; i++) cin >> c[i];
    vi inds(n);
    iota(all(inds), 0);
    sort(all(inds), [ & ](int i, int j){
        return a[i] < a[j];
    });
    sort(all(c));
    for (int mask = 0; mask < (1LL << n); mask++) {
        vi cur;
        int cnt = m;
        for (int i = 0; i < n; i++) {
            if ((1LL << i) & mask) cnt += 2;
            else cnt++;
        }
        FenwickTree fenw(n + m + 2);
        bool flag = true;
        // cout << mask << " aboba\n";
        if (cnt & 1) {
            for (int i = 0; i < n; i++) {
                int ind = count(c, a[inds[i]]) + fenw.get(0, a[inds[i]]);
                // cout << count(c, a[i]) << ' ' << fenw.get(0, a[i]) << ' ' << ind << '\n';
                if (ind % 2 == 1) {
                    flag = false;
                    break;
                }
                fenw.update(a[inds[i]], 1);
                if ((1LL << i) & mask) {
                    fenw.update(b[inds[i]], 1);
                }
            }
            // cout << mask << ' ' << flag << '\n';
            if (flag) { cout << "First\n"; return; }
        } else {
            for (int i = 0; i < n; i++) {
                int ind = count(c, a[inds[i]]) + fenw.get(0, a[inds[i]]);
                if (ind % 2 == 0) {
                    flag = false;
                    break;
                }
                fenw.update(a[inds[i]], 1);
                if ((1LL << i) & mask) {
                    fenw.update(b[inds[i]], 1);
                }
            }
            // cout << mask << ' ' << flag << '\n';
            if (flag) { cout << "Second\n"; return; }
        }
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> reps;
    #endif

    for (int i = 1; i <= reps; i++) {
        #ifdef LOCAL
        cout << "===== Test #" << i << " ========\n";
        #endif
        solve();
        #ifdef LOCAL
        cout << "==== End test =====\n\n";
        #endif
    }
}