#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;
using Int = long long;
using Uint = unsigned long long;
using Real = long double;
using Int128 = __int128;
using Uint128 = __uint128_t;
// #define _KOSHKA56692
#ifdef _KOSHKA56692
const int MAX = 1e8;
char mem[MAX];
int mempos = 0;
void *operator new(size_t sz) {
    void *res = mem + mempos;
    mempos += sz;
    return res;
}
void operator delete(void *) {}
void operator delete(void *, size_t) {}
#endif
template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T> using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;
istream &operator>>(istream &in, Int128 &num) { Int R; in >> R; num = R; return in; }
ostream &operator<<(ostream &out, const Int128 &num) { out << Int(num); return out; }
istream &operator>>(istream &in, Uint128 &num) { Uint R; in >> R; num = R; return in; }
ostream &operator<<(ostream &out, const Uint128 &num) { out << Uint(num); return out; }

struct card {
    int cur, to;
    card() : cur(-1), to(-1) {}
    card(int cur) : cur(cur), to(-1) {}
    card(int cur, int to) : cur(cur), to(to) {}
};

bool operator<(const card &lhs, const card &rhs) {
    if (lhs.cur != rhs.cur) {
        return lhs.cur < rhs.cur;
    }
    return lhs.to < rhs.to;
}

bool operator==(const card &lhs, const card &rhs) {
    return (lhs.cur == rhs.cur && lhs.to == rhs.to);
}

signed main() {
    ios::sync_with_stdio(false), cin.tie(0);
    cout.setf(ios::fixed), cout.precision(20);
    int n, m;
    cin >> n >> m;
    vector<int> a(n), b(n), c(m);
    for (auto &el : a) {
        cin >> el;
    }
    for (auto &el : b) {
        cin >> el;
    }
    for (auto &el : c) {
        cin >> el;
    }
    map<vector<card>, bool> has;
    map<vector<card>, bool> val;
    auto recur = [&](auto &&recur, vector<card> cards) -> bool {
        if (!cards.size()) {
            return false;
        }
        sort(cards.begin(), cards.end());
        if (has[cards]) {
            return val[cards];
        }
        has[cards] = true;
        auto pre = cards;
        int mn = 2e9;
        card save;
        for (auto &el : cards) {
            if (el.cur < mn) {
                mn = el.cur;
                save = el;
            }
        }
        if (save.to == -1) {
            cards.erase(find(cards.begin(), cards.end(), save));
            return (val[pre] = !recur(recur, cards));
        }
        cards.erase(find(cards.begin(), cards.end(), save));
        bool fl1 = !recur(recur, cards);
        if (fl1) {
            return (val[pre] = fl1);
        }
        cards.push_back(card(save.to));
        return (val[pre] = !recur(recur, cards));
    };
    vector<card> koshka;
    for (int i = 0; i < n; ++i) {
        koshka.push_back(card(a[i], b[i]));
    }
    for (int i = 0; i < m; ++i) {
        koshka.push_back(card(c[i]));
    }
    cout << (recur(recur, koshka) ? "First" : "Second") << '\n';
    return 0;
}
