// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")
#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
// #include <ext/pb_ds/assoc_container.hpp>
// #include <ext/pb_ds/tree_policy.hpp>
#define int long long
// #define ll __int128
using namespace std;
// using namespace __gnu_pbds;
// #define unordered_map gp_hash_table
// #define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

const int INF = 1e13 + 7;

struct node {
    int val, id;
    bool is_main;
    bool is_even;

    node() {}

    node (int val, int id, bool is_main, bool is_even)
        : val(val), id(id), is_main(is_main), is_even(is_even) {}
};

struct card {
    int id;
    bool is_main;
    bool is_even;

    card() {}

    card(int id, bool is_main, bool is_even)
        : id(id), is_main(is_main), is_even(is_even) {}
};

bool operator<(const node &a, const node &b) {
    if (a.val != b.val) {
        return a.val < b.val;
    }
    if (a.id != b.id) {
        return a.id < b.id;
    }
    if (a.is_main != b.is_main) {
        return a.is_main < b.is_main;
    }
    return a.is_even < b.is_even;
}

vector<node> cards;
vector<card> a;

bool dp[101][1 << 20] = {};
bool is_calc[101][1 << 20] = {};

bool get_dp(int n, int mask) {
    bool res = false;
    if (is_calc[n][mask]) {
        return dp[n][mask];
    }

    if (n == (int)a.size()) {
        res = false;
    } else if (cards[n].id == -1) {
        if (cards[n].is_even) {
            res |= (!get_dp(n + 1, mask));
        } else {
            res |= (get_dp(n + 1, mask));
        }
    } else {
        if (!cards[n].is_main) {
            if ((mask >> cards[n].id) & 1) {
                res |= !get_dp(n + 1, mask);
            } else {
                res |= get_dp(n + 1, mask);
            }
        } else {
            int new_mask = mask ^ (1 << cards[n].id);
            res |= !get_dp(n + 1, new_mask);
            res |= get_dp(n + 1, mask);
        }
    }
    
    is_calc[n][mask] = true;
    dp[n][mask] = res;
    return res;
}

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        cards.push_back(node(x, i, true, false));
    }
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        cards.push_back(node(x, i, false, false));
    }
    for (int i = 0; i < m; i++) {
        int x;
        cin >> x;
        cards.push_back(node(x, -1, false, false));
    }
    sort(cards.begin(), cards.end());
    n = (int)cards.size();
    int l = 0;
    while (l < n) {
        if (cards[l].id != -1) {
            a.push_back(card(cards[l].id, cards[l].is_main, cards[l].is_even));
            l++;
            continue;
        }
        int r = l;
        while (r < n && cards[r].id == -1) {
            r++;
        }
        int len = r - l;
        l = r;
        a.push_back(card(-1, false, len & 1));
    }
    assert((int)a.size() <= 100);
    bool res = get_dp(0, 0);
    if (res) {
        cout << "First\n";
    } else {
        cout << "Second\n";
    }
}

signed main() {
    // cout << fixed << setprecision(20);
    #ifdef LOCAL
    freopen("C:\\work\\input.txt", "r", stdin);
    #else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    #endif
    solve();
}