#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

//#define int long long
using ll = long long;

typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
const int inf = 1e9 + 7;
const ll inf_ = 1e18 + 7;
const int mod = 1e9 + 7;

struct Hash {
    int mod2 = 1e9 + 7, p2 = 239;

    int sum(int a, int b) {
        a += b;
        if (a >= mod2) a -= mod2;
        return a;
    }

    int sub(int a, int b) {
        a -= b;
        if (a < 0) a += mod2;
        return a;
    }

    int mul(int a, int b) {
        return a * 1ll * b % mod2;
    }

    vector<int> h, pr;

    Hash(string s) {
        int n = s.size();
        h.resize(n);
        pr.resize(n + 1);
        h[0] = s[0];
        pr[0] = 1;
        for (int i = 1; i < n; i++)
            h[i] = sum(s[i], mul(h[i - 1], p2));
        for (int i = 1; i <= n; i++)
            pr[i] = mul(pr[i], p2);
    }

    int get(int l, int r) {
        return sub(h[r], (l ? mul(h[l - 1], pr[r - l + 1]) : 0));
    }
};

struct Fast {
    vector<vector<int>> g, gr;
    vector<int> ts, col;
    vector<bool> used;

    void fts(int v) {
        used[v] = 1;
        for (auto u: g[v]) {
            if (used[u]) continue;
            fts(u);
        }
        ts.push_back(v);
    }

    vector<int> cnt;

    void paint(int v, int cl) {
        used[v] = 1;
        col[v] = cl;
        for (auto u: gr[v]) {
            if (used[u]) continue;
            paint(u, cl);
        }
    }

    void solve() {
        int n, m;
        cin >> n >> m;
        int mx_a = 0;
        vector<int> a(n), b(n), c(m);
        vector<int> t;
        vector<int> pr(2 * n + m + 1, -1);
        for (auto &i: a) {
            cin >> i;
            t.push_back(i);
            mx_a = max(mx_a, i);
        }
        int j = 0;
        for (auto &i: b) {
            cin >> i;
            pr[a[j]] = i;
            j++;
        }
        for (auto &i: c) {
            cin >> i;
            if (i < mx_a) t.push_back(i);
        }
        sort(t.begin(), t.end());
        n = t.size();
        vector<int> type(n);
        int k = 1;
        type.back() = 1;
        vector<int> e;
        for (int i = 0; i < n - 1; i++) {
            if (pr[t[i]] > t.back() || pr[t[i]] == -1) type[i] = 0;
            else type[i] = 1, k++, e.push_back(t[i]);
        }
        e.push_back(mx_a);
        vector<vector<int>> dp(n, vector<int>(1 << k, -1));
        dp[n - 1][0] = 1;
        int l = 1;
        for (int i = n - 2; i >= 0; i--) {
            for (int mask = 0; mask < (1 << l); mask++) {
                if (!dp[i + 1][mask ^ (1 << (l - 1))]) dp[i][mask] = 1;
                else if (dp[i + 1][mask ^ (1 << (l - 1))] == 1) dp[i][mask] = 0;
                else if (type[i] == 1) {
                    int msk = mask ^ (1 << (l - 1));
                    int w = pr[t[i]];
                    int q = lower_bound(e.begin(), e.end(), w) - e.begin();
                    int s = lower_bound(e.begin(), e.end(), t[i]) - e.begin();
                    q = max(q, s);
                    q = (int) e.size() - q - 1;
                    msk ^= (1 << q);
                    if (!dp[i + 1][msk]) dp[i][mask] = 1;
                    else if (dp[i + 1][msk] == 1) dp[i][mask] = 0;
                }
            }
        }
        int ans = 0;
        for (int mask = 0; mask < (1 << l); mask++)
            ans = max(ans, dp[0][mask]);
        if (ans) cout << "First";
        else cout << "Second";
    }
};

signed main() {
    int __ = 1;
    //cin >> __;
    while (__--) {
        Fast().solve();
        cout << '\n';
    }
    return 0;
}
