#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
using ll = long long;

typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
const int inf = 1e9 + 7;
const ll inf_ = 1e18 + 7;
const int mod = 1e9 + 7;

struct Hash {
    int mod2 = 1e9 + 7, p2 = 239;

    int sum(int a, int b) {
        a += b;
        if (a >= mod2) a -= mod2;
        return a;
    }

    int sub(int a, int b) {
        a -= b;
        if (a < 0) a += mod2;
        return a;
    }

    int mul(int a, int b) {
        return a * 1ll * b % mod2;
    }

    vector<int> h, pr;

    Hash(string s) {
        int n = s.size();
        h.resize(n);
        pr.resize(n + 1);
        h[0] = s[0];
        pr[0] = 1;
        for (int i = 1; i < n; i++)
            h[i] = sum(s[i], mul(h[i - 1], p2));
        for (int i = 1; i <= n; i++)
            pr[i] = mul(pr[i], p2);
    }

    int get(int l, int r) {
        return sub(h[r], (l ? mul(h[l - 1], pr[r - l + 1]) : 0));
    }
};

struct Fast {
    vector<vector<int>> g, gr;
    vector<int> ts, col;
    vector<bool> used;

    void fts(int v) {
        used[v] = 1;
        for (auto u: g[v]) {
            if (used[u]) continue;
            fts(u);
        }
        ts.push_back(v);
    }

    vector<int> cnt;

    void paint(int v, int cl) {
        used[v] = 1;
        col[v] = cl;
        for (auto u: gr[v]) {
            if (used[u]) continue;
            paint(u, cl);
        }
    }

    void solve() {
        int n, m;
        cin >> n >> m;
        int mx_a = 0;
        vector<int> a(n), b(n), c(m);
        for (auto &i: a) {
            cin >> i;
            mx_a = min(mx_a, i);
        }
        for (auto &i: b) {
            cin >> i;
        }
        set<int> s;
        for (auto i: a) s.insert(i);
        vector<vector<int>> t;
        for (int i = 0; i < n; i++) {
            t.push_back({min(a[i], b[i]), max(a[i], b[i]), a[i], b[i]});
        }
        sort(t.begin(), t.end());
        vector<pair<int, int>> st;
        for (auto x: t) {
            while (!st.empty() && max(st.back().second, st.back().first) > x[1])
                st.pop_back();
            st.emplace_back(x[2], x[3]);
        }
        a.clear();
        b.clear();
        for (auto [x, y]: st) {
            a.push_back(x);
            b.push_back(y);
            s.erase(x);
        }
        if (s.contains(mx_a)) {
            s.erase(mx_a);
            a.push_back(mx_a);
        }
        n = a.size();
        int k = 0;
        for (auto &i: c) {
            cin >> i;
            if (i < mx_a) k++;
        }
        for (auto x: s)
            if (x < mx_a) k++;
        if (k % 2) cout << "Second";
        else cout << "First";
    }
};

signed main() {
    int __ = 1;
    //cin >> __;
    while (__--) {
        Fast().solve();
        cout << '\n';
    }
    return 0;
}
