#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <tuple>
#include <random>
#include <queue>
#include <cmath>

using namespace std;
using ll = long long;

constexpr int INF = 1e9 + 7;
constexpr ll LINF = 1e18 + 7;

vector<int>nxt;
map<ll, int>res;
int dfs(ll mask) {
    if (mask == 0) return 0;
    //cout << mask << "\n";
    if (res.find(mask) != res.end()) return res[mask];
    int fst = 0;
    for (int i = 0; i < 50; ++i) {
        if ((mask >> i) & 1) {
            fst = i;
            break;
        }
    }
    if (!dfs(mask - (1ll << fst))) return res[mask] = 1;
    if (nxt[fst] != -1 && !dfs(mask - (1ll << fst) + (1ll << nxt[fst]))) return res[mask] = 1;
    return res[mask] = 0;
}

int main()
{
    cin.tie(0)->sync_with_stdio(0);
    int n, m;
    cin >> n >> m;
    vector<int>a(n);
    vector<int>b(n);
    vector<int>c(m);
    nxt.resize(2 * n + m, -1);
    ll mask = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
        mask += (1ll << a[i]);
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
        --b[i];
        nxt[a[i]] = b[i];
    }
    for (int i = 0; i < m; ++i) {
        cin >> c[i];
        --c[i];
        mask += (1ll << c[i]);
    }
    if (dfs(mask)) {
        cout <<"First\n";
    }
    else {
        cout << "Second\n";
    }

}
