#include <bits/stdc++.h>

using namespace std;

#define ll int
#define ve vector
#define pb push_back
ll const inf = 1e9 + 3;
ll const INF = 1e18;
#pragma GCC ("O2")

struct Node {
    ll val = 0;
    ll added = 0;
    bool is_added = false;
};

ve<Node> tree;

void build(ll v, ll tl, ll tr) {
    if (tr - tl == 1) {

        return;
    }
    ll m = (tl + tr) / 2;
    build(2 * v, tl, m);
    build(2 * v + 1, m, tr);
}

void add_to_Node(ll v, ll tl, ll tr, ll val) {
    tree[v].val += (tr - tl) * val;
    tree[v].added += val;
    tree[v].is_added = true;
}

void push(ll v, ll tl, ll tr) {
    if (tree[v].is_added) {
        ll m = (tl + tr) / 2;
        add_to_Node(2 * v, tl, m, tree[v].added);
        add_to_Node(2 * v + 1, m, tr, tree[v].added);
        tree[v].added = 0;
        tree[v].is_added = false;
    }
}

void Add(ll v, ll tl, ll tr, ll ql, ll qr, ll val) {
    if (tl >= qr || tr <= ql)
        return;
    if (tr == qr && tl == ql) {
        add_to_Node(v, tl, tr, val);
        return;
    }
    ll m = (tl + tr) / 2;
    push(v, tl, tr);
    Add(2 * v, tl, m, ql, min(m, qr), val);
    Add(2 * v + 1, m, tr, max(m, ql), qr, val);
    tree[v].is_added = 0;
    tree[v].val = tree[2 * v].val + tree[2 * v + 1].val;
}

ll get_sum(ll v, ll tl, ll tr, ll ql, ll qr) {
    if (tr == qr && tl == ql) {
        return tree[v].val;
    }
    push(v, tl, tr);
    ll m = (tl + tr) / 2;
    ll s1 = get_sum(2 * v, tl, m, ql, min(qr, m));
    ll s2 = get_sum(2 * v + 1, m, tr, max(m, qr), ql);
    return s1 + s2;
}

ve<ve<ll>> edges;
ve<ll> depth;

struct solanka {
    ll tp; // 1 - верх  2 - низ  3 - односторонняя
    ll x;
    ll ind;
};

bool cmp(solanka a, solanka b) {
    if (a.x < b.x)
        return true;
    if (a.x > b.x)
        return false;
    return true;
}

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll n, m;
    cin >> n >> m;
    ll i, j;
    ve<ll> a(n);
    ve<ll> b(n);
    ve<ll> c(n);
    ve<solanka> sol(2 * n + m);
    for (i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (i = 0; i < n; i++) {
        cin >> b[i];
    }
    for (i = 0; i < m; i++) {
        cin >> c[i];
    }

    for (i = 0; i < n; i++) {
        sol[2 * i] = {1, a[i], i};
        sol[2 * i + 1] = {2, b[i], i};
    }
    for (i = 0; i < m; i++) {
        sol[2 * n + i] = {3, c[i], i};
    }
    a.clear();
    b.clear();
    c.clear();
    sort(sol.begin(), sol.end(), cmp);
    ve<pair<ll, ll>> card(n);
    ll k = 2 * n + m;
    for (i = 0; i < k; i++) {
        if (sol[i].tp == 1) {
            card[sol[i].ind].first = i;
        }
        if (sol[i].tp == 2) {
            card[sol[i].ind].second = i;
        }
    }
    ll reality = k - 1;
    for (i = 0; i < k; i++) {
        if (sol[i].tp == 1) {
            if (card[sol[i].ind].first > card[sol[i].ind].second) {
                reality = i;
                break;
            }
        }
    }
    for (i = reality - 1; i >= 0; i--) {
        if (sol[i].tp == 1) {
            if (card[sol[i].ind].second < reality) {
                reality = i;
                continue;
            }
        }
    }
    ll cnt = 0;
    for (i = 0; i < reality; i++) {
        if (sol[i].tp == 3)
            cnt++;
        if (sol[i].tp == 1)
            cnt++;
    }
    if (cnt % 2 == 0)
        cout << "First";
    else
        cout << "Second";
}
