#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using ll = long long;
using pii = pair<int, int>;
using ld = long double;

const int INF = 1e18;
const int MOD = 1e9 + 7;

int divup(int a, int b) {
    if (a % b == 0) return a / b;
    return a / b + 1;
}

void wr(vector<int> a) {
    for (int i : a) cout << i << ' ';
    cout << '\n';
}
void wr(vector<pii> a) {
    for (pii i : a) cout << "{" << i.first << ", " << i.second << "} ";
    cout << '\n';
}


struct fenv {
    int n;
    vector<int> v;
    fenv (int n): n(n) {
        v.resize(n + 1, 0);
    }
    void add(int ind, int x) {
        for (int i = ind + 1; i <= n; i += i&-i) v[i] += x;
    }
    int pref(int r) {
        int res = 0;
        for (int i = r; i > 0; i -= i&-i) res += v[i];
        return res;
    }
};




void solve() {
    int n, m; cin >> n >> m;
    vector<int> a(n), b(n), c(m);
    for (int &i : a) cin >> i;
    for (int &i : b) cin >> i;
    for (int &i : c) cin >> i;
    vector<pii> p(n + m);
    for (int i = 0; i < n; i++) {
        p[i] = {a[i], 1};
    }
    for (int i = 0; i < m; i++) {
        p[i + n] = {c[i], 0};
    }
    sort(all(p));
    int cnt = 0;
    for (int i = 0; i < n + m; i++) {
        cnt++;
        if (p[i].second == 1) break;
    }
    if (cnt % 2 == 1) cout << "First";
    else cout << "Second";
}


signed main() {
    //ios_base::sync_with_stdio(0);
    //cin.tie(0);
    int tt = 1; //cin >> tt;
    while (tt--) {
        solve();
    }
}