#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using ll = long long;
using pii = pair<int, int>;
using ld = long double;

const int INF = 1e18;
const int MOD = 1e9 + 7;

int divup(int a, int b) {
    if (a % b == 0) return a / b;
    return a / b + 1;
}

void wr(vector<int> a) {
    for (int i : a) cout << i << ' ';
    cout << '\n';
}
void wr(vector<pii> a) {
    for (pii i : a) cout << "{" << i.first << ", " << i.second << "} ";
    cout << '\n';
}


struct fenv {
    int n;
    vector<int> v;
    fenv (int n): n(n) {
        v.resize(n + 1, 0);
    }
    void add(int ind, int x) {
        for (int i = ind + 1; i <= n; i += i&-i) v[i] += x;
    }
    int pref(int r) {
        int res = 0;
        for (int i = r; i > 0; i -= i&-i) res += v[i];
        return res;
    }
};


void print(bool f) {
    if (f) cout << "First";
    else cout << "Second";
}

void solve() {
    int n, m; cin >> n >> m;
    vector<int> a(n), b(n), c(m);
    for (int &i : a) cin >> i;
    for (int &i : b) cin >> i;
    for (int &i : c) cin >> i;
    vector<pii> p(n);
    for (int i = 0; i < n; i++) {
        p[i] = {a[i], b[i]};
    }
    sort(all(p));
    for (int i = 0; i < n; i++) {
        a[i] = p[i].first, b[i] = p[i].second;
    }
    if (n == 0) {
        print(m % 2);
        return;
    }
    int lst = (n + m) * 2 + 1;
    for (int i = n - 1; i >= 0; i--) {
        if (b[i] < lst) {
            lst = a[i];
        }
    }
    vector<int> buf(n + m);
    for (int i = 0; i < n; i++) buf[i] = a[i];
    for (int i = 0; i < m; i++) buf[i + n] = c[i];
    sort(all(buf));
    int cnt = 0;
    for (int i = 0; i < n + m; i++) {
        cnt++;
        if (buf[i] == lst) break;
    }
    //cout << lst << '\n';
    //wr(buf);
    print(cnt % 2 == 1);
}


signed main() {
    //ios_base::sync_with_stdio(0);
    //cin.tie(0);
    int tt = 1; //cin >> tt;
    while (tt--) {
        solve();
    }
}