#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <bitset>
#include <unordered_map>
#include <random>

#define all(v) v.begin(), v.end()
#define len(v) (int)v.size()
#define coutd cout << fixed << setprecision(20)

using namespace std;
using ll = long long;
using ld = long double;

int n, m;
vector<int> a;
vector<int> b;
vector<int> c;

void ans(int x)
{
    if (x == 1)
    {
        cout << "First";
    } else
    {
        cout << "Second";
    }
    exit(0);
}

int solve(vector<pair<int, int>> &vs, int left)
{
    vector<int> nvs;
    for (auto y : vs)
    {
        nvs.push_back(y.first);
    }
    int st = -1;
    int k = len(vs);
    vector<bool> dp(k, 0);
    for (int i = k - 1; i >= 0; --i)
    {
        if (vs[i].second != -1)
        {
            dp[i] = 1;
            st = i;
            break;
        }
    }
    for (int i = st - 1; i >= left; --i)
    {
        dp[i] = 0;
        if (vs[i].second == -1)
        {
            dp[i] = 1 - dp[i + 1];
            continue;
        }
        if (dp[i + 1] == 0)
        {
            dp[i] = 1;
            continue;
        }
        int id = vs[i].second;
        int nw = -1;
        if (b[id] < a[id])
        {
            dp[i] = 1;
            continue;
        }
        int j = upper_bound(all(nvs), b[id]) - 1 - nvs.begin();
        auto gt = vs;
        gt.push_back({b[id], -1});
        gt[i].second = -1;
        sort(all(gt));
        if (solve(gt, i))
        {
            dp[i] = 1;
        } else
        {
            dp[i] = 0;
        }
    }
    return dp[left];
}

int main()
{
    cin.tie(0)->sync_with_stdio(0);
    cin >> n >> m;
    a.resize(n);
    b.resize(n);
    c.resize(m);
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i)
    {
        cin >> b[i];
    }
    for (int i = 0; i < m; ++i)
    {
        cin >> c[i];
    }
    if (n == 0)
    {
        if (m % 2 == 1)
        {
            ans(1);
        } else
        {
            ans(2);
        }
    }
    vector<pair<int, int>> vs;
    vector<int> dist(n);
    for (int i = 0; i < n; ++i)
    {
        vs.push_back({a[i], i});
    }
    for (int i = 0; i < m; ++i)
    {
        vs.push_back({c[i], -1});
    }
    sort(all(vs));
    vector<pair<int, int>> nvs;
    for (int i = 0; i < len(vs); ++i)
    {
        int j = len(nvs) - 1;
        if (j >= 0 && nvs[j].second == -1 && vs[i].second == -1)
        {
            nvs.pop_back();
            continue;
        }
        nvs.push_back(vs[i]);
    }
    int fr = solve(nvs, 0);
    if (fr)
    {
        ans(1);
    } else
    {
        ans(0);
    }

    return 0;
}

