#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>


using namespace __gnu_pbds;
using namespace std;

template <class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
//less_equal

//#pragma GCC optimize("O3")
//#pragma GCC target("avx,avx2,bmi2,fma,popcnt")

#define int long long
#define x first
#define y second

int inf = 1'000'000'000'000'000'000;

mt19937 mt(42);
int merge(int a, int b) {
    return a + b;
}

struct SegTree {
    vector<int> v;
    vector<int> push;


    void build2(int ind, int l, int r, vector<int>& ve) {
        if (l + 1 == r) {
            v[ind] = ve[l];
            return;
        }
        int mid = (l + r) / 2;
        build2(2 * ind + 1, l, mid, ve);
        build2(2 * ind + 2, mid, r, ve);
        v[ind] = merge(v[2 * ind + 1], v[2 * ind + 2]);
    }

    void build(vector<int>& ve) {
        int n = ve.size();

        v.resize(4 * n);
        push.resize(4 * n, 0);
        build2(0, 0, n, ve);
    }

    void pushh(int ind, int l, int r) {
        if (l + 1 != r) {
            push[2 * ind + 1] += push[ind];
            push[2 * ind + 2] += push[ind];
        }
        v[ind] += push[ind];
        push[ind] = 0;
    }

    void update(int ind, int l, int r, int ql, int qr, int k) {
        pushh(ind, l, r);
        if (ql <= l && r <= qr) {
            push[ind] += k;
            pushh(ind, l, r);
            return;
        }
        if (qr <= l || r <= ql) {
            return;
        }
        int mid = (l + r) / 2;
        update(2 * ind + 1, l, mid, ql, qr, k);
        update(2 * ind + 2, mid, r, ql, qr, k);
        v[ind] = merge(v[2 * ind + 1], v[2 * ind + 2]);
    }

    int getmax(int ind, int l, int r, int ql, int qr) {
        if (ql <= l && r <= qr) {
            return v[ind];
        }
        if (qr <= l || r <= ql) {
            return -inf;
        }
        int mid = (l + r) / 2;
        return merge(getmax(2 * ind + 1, l, mid, ql, qr),
                     getmax(2 * ind + 2, mid, r, ql, qr));
    }
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<pair<int, int>> a(n);
    vector<int> c(2 * n + m);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first; a[i].first--;
    }
    for (int i = 0; i < n; i++) {
        cin >> a[i].second; a[i].second--;
    }
    for (int i = 0; i < m; i++) {
        int g;
        cin >> g; g--;
        c[g] = 1;
    }
    std::sort(a.begin(), a.end());
    SegTree t;
    t.build(c);
    SegTree se;
    int next = 1;
    for (int i = n - 2; i >= 0; i--) {
        if (next) {
            if (a[i].second < a[i + 1].x
            || t.getmax(0, 0, c.size(), a[i].x, a[i + 1].x) % 2 == 1) {
                next = 1;
            }else {
                next = 0;
            }
        }else {
            if (a[i].second < a[i + 1].x
                || t.getmax(0, 0, c.size(), a[i].x, a[i + 1].x) % 2 == 0) {
                next = 1;
            }else {
                next = 0;
            }
        }
    }
    if (next) {
        if (t.getmax(0, 0, c.size(), 0, a[0].x) % 2 == 1) {
            next = 1;
        }else {
            next = 0;
        }
    }else {
        if (t.getmax(0, 0, c.size(), 0, a[0].x) % 2 == 0) {
            next = 1;
        }else {
            next = 0;
        }
    }
    if (next) {
        cout << "First";
    }else {
        cout << "Second";
    }
}

signed main() {
#ifdef lisie_bimbi
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    //cin.tie(nullptr);
    //ios_base::sync_with_stdio(false);
#endif
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
}