#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#define all(v) v.begin(), v.end()
#define fi first
#define se second

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<long long, long long> pii;

struct SegTree {
	ll n;
	vector<ll> a, t, ot;
	SegTree(vector<ll> _a) {
		a = _a;
		n = a.size();
		t.resize(4 * n);
		ot.resize(4 * n);
		build(1, 0, n);
	}
	void update(ll v) {
		t[v] = t[2 * v] + t[2 * v + 1];
	}

	void build(ll v, ll l, ll r) {
		if (r - l == 1) {
			t[v] = a[l];
			return;
		}
		ll m = (l + r) / 2, vl = 2 * v, vr = vl + 1;
		build(vl, l, m);
		build(vr, m, r);
		update(v);
	}
	void push(ll v, ll l, ll r) {
		if (ot[v]) {
			t[v] += (r - l) * ot[v];
			if (r - l > 1) {
				ot[2 * v] += ot[v];
				ot[2 * v + 1] += ot[v];
				return;
			}
			ot[v] = 0;
		}
	}
	ll get(ll v, ll l, ll r, ll al, ll ar) {
		push(v, l, r);
		if (l >= ar || r <= al) return 0;
		if (l >= al && r <= ar) return t[v];
		ll m = (l + r) / 2, vl = 2 * v, vr = vl + 1;
		return get(vl, l, m, al, ar) + get(vr, m, r, al, ar);
	}
	void add(ll v, ll l, ll r, ll al, ll ar, ll x) {
		push(v, l, r);
		if (l >= ar || r <= al) return;
		if (l >= al && r <= ar) {
			ot[v] += x;
			push(v, l, r);
			return;
		}
		ll m = (l + r) / 2, vl = 2 * v, vr = vl + 1;
		add(vl, l, m, al, ar, x);
		add(vr, m, r, al, ar, x);
		update(v);
		return;
	}
};

struct Point {
	ll x, y;
};

istream& operator >> (istream& in, Point& p) {
	in >> p.x >> p.y;
	return in;
}

ostream& operator << (ostream& out, Point& p) {
	out << p.x << ' ' << p.y << '\n';
	return out;
}

ll operator * (Point& p1, Point& p2) {
	return p1.x * p2.y - p1.y * p2.x;
}

ll operator % (Point& p1, Point& p2) {
	return p1.x * p2.x + p1.y * p2.y;
}

Point operator + (Point& p1, Point& p2) {
	return { p1.x + p2.x, p1.y + p2.y };
}

void solve() {
	ll n, m;
	cin >> n >> m;
	vector<ll> a(n), b(n), c(m);
	for (ll i = 0; i < n; i++) cin >> a[i];
	for (ll i = 0; i < n; i++) cin >> b[i];
	for (ll i = 0; i < m; i++) cin >> c[i];
	vector<pii> temp;
	for (ll i = 0; i < n; i++) temp.push_back({ a[i], 1 });
	for (ll i = 0; i < m; i++) temp.push_back({ c[i], 0 });
	sort(all(temp));
	bool f = false;
	for (ll i = 0; i < n + m; i++) {
		if (temp[i].se) {
			if (i % 2) {
				f = true;
			}
			else {
				f = false;
			}
			return;
		}
	}
	if (f) {
		cout << "Second\n";
	}
	else {
		cout << "First\n";
	}
}

int main() {
	ll t = 1;
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	cin >> t;
#else
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#endif
	while (t--) solve();
}