#include <bits/stdc++.h>
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

typedef long long ll;

using namespace std;

void fio() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
}

const int MOD = 1'000'000'000 + 7;
const int UNDEF = -1;

void dfs(int curV, vector<int> &order, vector<bool> &visited, const vector<vector<int>> &edges) {
    visited[curV] = true;
    for (int nextV : edges[curV]) {
        if (!visited[nextV]) {
            dfs(nextV, order, visited, edges);
        }
    }
    order.push_back(curV);
}

void dfs(int curV, int c, vector<int> &comp, const vector<vector<int>> &edges) {
    comp[curV] = c;
    for (int nextV : edges[curV]) {
        if (comp[nextV] == UNDEF) {
            dfs(nextV, c, comp, edges);
        }
    }
}

void solveA() {
    int nV, nE, g;
    cin >> nV >> nE >> g;
    vector<vector<int>> edges(nV);
    vector<vector<int>> revEdges(nV);
    int fromV, toV;
    for (int i = 0; i < nE; i++) {
        cin >> fromV >> toV;
        fromV--;
        toV--;
        edges[fromV].push_back(toV);
        revEdges[toV].push_back(fromV);
    }
    vector<int> order;
    vector<bool> visited(nV, false);
    for (int v = 0; v < nV; v++) {
        if (!visited[v]) {
            dfs(v, order, visited, edges);
        }
    }
    reverse(order.begin(), order.end());
    vector<int> comp(nV, UNDEF);
    int c = 0;
    for (int nextV : order) {
        if (comp[nextV] == UNDEF) {
            dfs(nextV, c, comp, revEdges);
            c++;
        }
    }
    int maxA = 0;

    for (int next : comp) {
        cout << next << ' ';
    }
}

void solveC() {
    int n, m;
    cin >> n >> m;
    vector<char> order(2 * n + m, UNDEF);
    vector<int> a(n);
    int val;
    for (int i = 0; i < n; i++) {
        cin >> val;
        val--;
        order[val] = 0;
        a[i] = val;
    }
    int minA = 2 * n + m - 1;
    for (int i = 0; i < n; i++) {
        cin >> val;
        val--;
        if (val < a[i]) {
            minA = min(minA, a[i]);
        } else {
            order[val] = 1;
        }
    }
    for (int i = 0; i < m; i++) {
        cin >> val;
        order[val - 1] = 0;
    }
    vector<bool> res(minA + 1, false);
    res[minA] = true;
    bool flag = true;
    bool isFlag = false;
    for (int i = minA - 1; i >= 0; i--) {
        if (order[i] == UNDEF) {
            res[i] = res[i + 1];
        } else if (order[i] == 0) {
            res[i] = !(res[i + 1] && flag);
            flag = true;
            isFlag = false;
        } else {
            if (!isFlag) {
                flag = res[i + 1];
                isFlag = true;
                res[i] = !res[i + 1];
            } else {
                res[i] = true;
            }
        }
    }
    random_device rnd;
    mt19937 gen(rnd());
    vector<int> g = {0, 0, 0, 1};
    shuffle(g.begin(), g.end(), gen);
    int r = a[0];
    if (r == 0) {
        cout << "First";
    } else {
        cout << "Second";
    }
}

int main() {
    fio();
    solveC();
    return 0;
}
/*
2 1
5 3
1 2
4
 */
