#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

using ll = long long;

ll sz = 0;

ll lesgo(vector<pair<ll, ll>>& vec) {
	vector<bool> start(sz);
	for (auto p : vec) start[p.first] = true;
	vector<ll> pref(1, 0);
	for (auto p : start) pref.push_back(pref.back() + p);
	ll terminal_start = 1e18;
	for (auto p : vec) {
		ll cnt = pref[p.second + 1] - pref[p.first] - 1;
		if (cnt == 0) terminal_start = min(terminal_start, p.first);
	}
	vector<pair<ll, ll>> nvec;
	for (auto p : vec) {
		if (p.second < terminal_start) nvec.push_back(p);
	}
	swap(vec, nvec);
	return terminal_start;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll n, m; cin >> n >> m;
	sz = n * 2 + m + 5;
	vector<pair<int, int>> as;
	vector<int> aa(n), bb(n);
	for (int i = 0; i < n; i++) cin >> aa[i];
	for (int i = 0; i < n; i++) {
		cin >> bb[i];
		bb[i] = max(bb[i], aa[i]);
	}
	vector<pair<ll, ll>> segments;
	for (int i = 0; i < n; i++) {
		segments.push_back({ aa[i], bb[i] });
	}

	ll id = -1;
	while (segments.size() > 0) {
		id = lesgo(segments);
	}

	vector<ll> nums;
	for (auto p : aa) nums.push_back(p);
	for (int i = 0; i < m; i++) {
		ll x; cin >> x;
		nums.push_back(x);
	}
	sort(nums.begin(), nums.end());
	ll pos = 0;
	for (int i = 0; i < nums.size(); i++) {
		if (nums[i] == id) pos = i;
	}
	if (pos % 2) {
		cout << "Second" << endl;
	}
	else {
		cout << "First" << endl;
	}
}