#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

using ll = long long;

ll sz = 0;

ll find_terminal(vector<pair<ll, ll>>& vec) {
	ll lstart = 1e18;
	for (int i = vec.size() - 1; i >= 0; i--) {
		if (vec[i].second < lstart) return vec[i].first;
		lstart = min(lstart, vec[i].first);
	}
	return -1;
}

ll lesgo(vector<pair<ll, ll>>& vec) {
	ll terminal_start = find_terminal(vec);
	while (!vec.empty() && vec.back().second >= terminal_start) vec.pop_back();
	return terminal_start;
}

bool cmp(pair<ll, ll> a, pair<ll, ll> b) {
	return a.second < b.second;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll n, m; cin >> n >> m;
	sz = n * 2 + m + 5;
	vector<pair<int, int>> as;
	vector<int> aa(n), bb(n);
	for (int i = 0; i < n; i++) cin >> aa[i];
	for (int i = 0; i < n; i++) {
		cin >> bb[i];
		bb[i] = max(bb[i], aa[i]);
	}
	vector<pair<ll, ll>> segments;
	for (int i = 0; i < n; i++) {
		segments.push_back({ aa[i], bb[i] });
	}
	
	sort(segments.begin(), segments.end(), cmp);

	ll id = -1;
	while (segments.size() > 0) {
		id = lesgo(segments);
	}

	vector<ll> nums;
	for (auto p : aa) nums.push_back(p);
	for (int i = 0; i < m; i++) {
		ll x; cin >> x;
		nums.push_back(x);
	}
	sort(nums.begin(), nums.end());
	ll pos = 0;
	for (int i = 0; i < nums.size(); i++) {
		if (nums[i] == id) pos = i;
	}
	if (pos % 2) {
		cout << "Second" << endl;
	}
	else {
		cout << "First" << endl;
	}
}