#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define all(x) x.begin(), x.end()

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pr = pair<ll, ll>;
const int MOD = 1e9 + 7;
const int INF = 1e9 + 1;
const ll INFLL = 1e18 + 1;
int reps = 1;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> oset;

template<typename T>
inline void print(const vector<T> &a, string sep=" ") {
    for (auto &x : a) cout << x << sep;
    cout << "\n";
}

template<typename T>
inline void print(const set<T> &a, string sep=" ") {
    for (auto &x : a) cout << x << sep;
    cout << "\n";
}

//====================================

struct SegTree
{
    struct Node
    {
        ll x = -1, push = -1;
        Node () {}
        Node (ll val) : x(val) {}
        void update(ll val, ll l, ll r) {
            x = val;
            push = val;
        }
    };
    Node merge(const Node &l, const Node &r) {
        Node res;
        res.x = l.x + r.x;
        return res;
    }
    int n;
    vector<Node> st;
    SegTree() {}
    SegTree(int _n) : n(_n), st(4*n) {}
    SegTree(const vector<ll> &a) : n(a.size()), st(4*n) {
        build(1, 0, n, a);
    }
    void build(int v, int l, int r, const vector<ll> &a) {
        if (r - l == 1) {
            st[v] = Node(a[l]);
            return;
        }
        int m = (l + r) / 2;
        build(2*v, l, m, a);
        build(2*v + 1, m, r, a);
        st[v] = merge(st[2*v], st[2*v + 1]);
    }
    void push(int v, int l, int m, int r) {
        if (st[v].push == -1) return;
        st[2*v].update(st[v].push, l, m);
        st[2*v + 1].update(st[v].push, m, r);
        st[v].push = -1;
    }
    void update(int v, int l, int r, int ql, int qr, ll val) {
        if (l >= qr || r <= ql) return;
        if (l >= ql && r <= qr) {
            st[v].update(val, l, r);
            return;
        }
        int m = (l + r) / 2;
        push(v, l, m, r);
        update(2*v, l, m, ql, qr, val);
        update(2*v + 1, m, r, ql, qr, val);
        st[v] = merge(st[2*v], st[2*v + 1]);
    }
    void update(int ql, int qr, ll val) {
        update(1, 0, n, ql, qr, val);
    }
    Node get(int v, int l, int r, int ql, int qr) {
        if (l >= qr || r <= ql) return Node();
        if (l >= ql && r <= qr) return st[v];
        int m = (l + r) / 2;
        push(v, l, m, r);
        return merge(get(2*v, l, m, ql, qr), get(2*v + 1, m, r, ql, qr));
    }
    Node get(int ql, int qr) {
        return get(1, 0, n, ql, qr);
    }
};



void solve() {
    int n, m; cin >> n >> m;
    vector<pii> a(n);
    vector<int> c(m);
    for (auto &[x, y] : a) cin >> x;
    for (auto &[x, y] : a) cin >> y;
    for (auto &x : c) cin >> x;
    sort(all(a));
    sort(all(c));
    int mnf = INF, mns = INF;
    vector<pii> cur;
    for (auto [x, y] : a) cur.push_back({x, y});
    for (auto x : c) cur.push_back({x, INF});
    sort(all(cur));


    vector<ll> cc(2*n + m + 1, -1);
    SegTree st(cc);
    for (int i = 0; i < 2*n + m; i++) {
        auto [x, y] = cur[i];
        if (y == -1) continue;
        int cd = st.get(i, i + 1).x;
        if (cd == -1) cd = i % 2;
        st.update(y, 2*n + m + 1, cd);
    }
    if (st.get(a[n-1].first, a[n-1].first + 1).x == 0)  cout << "First\n";
    else cout << "Second\n";

    // while (i < m) {
    //     auto [x, y] = cur[i];
    //     if (y == -1) {
    //         i++;
    //         continue;
    //     }
    //     int cd = i % 2;
    //     int pos = 0;
    //     while (pos < n && a[pos].first != x) pos++;
    //     if (pos < n && cc[pos] != -1) cd = cc[pos];

    //     for (int j = 0; j < n; j++) {
    //         if (a[j].first > y) cc[j] = cd;
    //     }
    //     i++;
    // }
    // if (cc[n-1] == 0) cout << "First\n";
    // else cout << "Second\n";
}

//====================================

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL 
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> reps;
#endif
    for (int i = 0; i < reps; i++) {
#ifdef LOCAL 
        cout << "Test case #" << i + 1 << " ==============\n";
#endif
        solve();
#ifdef LOCAL 
        cout << "End test ==============\n";
#endif
    }
    return 0;
}

// g++ -std=c++23 -Wall -Wextra -Wshadow -DLOCAL -D_GLIBCXX_DEBUG -fsanitize=address,undefined -O2 A.cpp -o A
