#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct SparseTable {
    vector<vector<ll>> mn;
    vector<ll> lg;

    explicit SparseTable(vector<ll> &a) {
        ll n = ll(a.size());
        ll k = 0;
        while ((1 << k) <= n) {
            k++;
        }
        mn.assign(k, vector<ll>(n));
        for (ll i = 0; i < n; i++) {
            mn[0][i] = a[i];
        }
        for (ll i = 1; i < k; i++) {
            for (ll j = 0; j + (1 << i) <= n; j++) {
                mn[i][j] = min(mn[i - 1][j], mn[i - 1][j + (1 << (i - 1))]);
            }
        }
        lg.assign(n + 1, 0);
        for (ll i = 2; i <= n; i++) {
            lg[i] = lg[i / 2] + 1;
        }
    }

    ll get(ll l, ll r) {
        if (l == r) {
            return INT64_MAX;
        }
        ll x = lg[r - l];
        return min(mn[x][l], mn[x][r - (1 << x)]);
    }
};

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll n, m;
    cin >> n >> m;
    vector<pair<ll, ll>> a1(n);
    for (ll i = 0; i < n; i++) {
        cin >> a1[i].first;
    }
    for (ll i = 0; i < n; i++) {
        cin >> a1[i].second;
    }
    sort(a1.begin(), a1.end());
    vector<ll> a(n), b(n);
    for (ll i = 0; i < n; i++) {
        a[i] = a1[i].first;
        b[i] = a1[i].second;
    }
    vector<ll> c(m);
    for (ll i = 0; i < m; i++) {
        cin >> c[i];
    }
    SparseTable st(b);
    ll imb = n - 1;
    while (true) {
        ll l = -1, r = imb;
        while (r - l > 1) {
            ll mid = (l + r) / 2;
            if (st.get(mid, imb) < a[imb]) {
                l = mid;
            } else {
                r = mid;
            }
        }
        if (l == -1) {
            break;
        }
        imb = l;
    }
    vector<pair<ll, ll>> v;
    for (ll i = 0; i < n; i++) {
        v.emplace_back(a[i], i);
    }
    for (ll i = 0; i < m; i++) {
        v.emplace_back(c[i], -1);
    }
    sort(v.begin(), v.end());
    ll pos = -1;
    for (ll i = 0; i < v.size(); i++) {
        if (v[i].second == imb) {
            pos = i;
            break;
        }
    }
    if (pos % 2 == 0) {
        cout << "First";
    } else {
        cout << "Second";
    }
}