#include <iostream>
#include <chrono>
#include <climits>
#include <cmath>
#include <random>
#include <algorithm>
#include <vector>
#include <string>

#pragma GCC optimize("O3")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

typedef long long ll;
typedef unsigned long long ull;

using namespace std;

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, m;
    cin >> n >> m;
    vector<int> a(n), b(n), c(m);
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < n; i++) cin >> b[i];
    for (int i = 0; i < m; i++) cin >> c[i];
    vector<pair<pair<int, int>, pair<int, int> > > l(n);
    for (int i = 0; i < n; i++) {
        l[i] = make_pair(
            make_pair(max(a[i], b[i]), min(a[i], b[i])),
            make_pair(a[i], b[i])
        );
    }
    sort(l.begin(), l.end());
    auto am = l[0].second.first;
    for (int i = 1; i < n; i++) {
        if (l[0].first.first < l[i].first.second) continue;
        if (l[i].first.second < l[0].first.second) {
            am = l[0].second.first;
            break;
        }
        if (l[0].first.second == l[0].second.second) {
            am = l[0].second.first;
            break;
        }
        if (l[i].first.second == l[i].second.first) {
            am = max(am, l[i].first.second);
        }
    }
    int cnt = 0;
    for (auto x: c) cnt += x < am;
    for (auto x: a) cnt += x < am;
    if (cnt % 2 == 0) cout << "First";
    else cout << "Second";

    return 0;
}
