#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <ctime>
#include <climits>
#include <iomanip>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <string>
#include <queue>
#include <random>

#define int long long

#pragma GCC optimize("03,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

using ll = long long;
using ld = long double;
using namespace std;

const ll INF = 1e18;

vector<int> a;
vector<int> b;
vector<int> c;

map<pair<vector<vector<int>>, vector<int>>, int> dp;

int get_val(vector<vector<int>> fir, vector<int> sec) {
	int sz1 = (int)fir.size();
	int sz2 = (int)sec.size();
	if (sz1 + sz2 == 0) {
		return 0;
	}
	if (sz1 == 0) {
		if (sz2 % 2 == 1) {
			return 1;
		}
		return 0;
	}
	vector<int> t2;
	int ind = sz2;
	for (int i = 0; i < sz2; i++) {
		if (sec[i] > fir[0][0]) {
			ind = i;
			break;
		}
	}
	for (int i = ind; i < sz2; i++) {
		t2.push_back(sec[i]);
	}
	vector<vector<int>> v1;
	vector<vector<int>> v2;
	if (ind % 2 == 0) {
		int mn = 1;
		if (fir[0][2] == 0) {
			v1 = fir;
			swap(v1[0][0], v1[0][1]);
			v1[0][2] = 1;
			mn = min(mn, get_val(v1, t2));
		}
		for (int i = 1; i < sz1; i++) {
			v2.push_back(fir[i]);
		}
		mn = min(mn, get_val(v2, t2));
		dp[{fir, sec}] = 1 - mn;
		return 1 - mn;
	}
	else {
		int mn = 1;
		if (fir[0][2] == 0) {
			v1 = fir;
			swap(v1[0][0], v1[0][1]);
			v1[0][2] = 1;
			mn = min(mn, get_val(v1, t2));
		}
		for (int i = 1; i < sz1; i++) {
			v2.push_back(fir[i]);
		}
		mn = min(mn, get_val(v2, t2));
		dp[{fir, sec}] = mn;
		return mn;
	}
}

void solve() {
	int n, m;
	cin >> n >> m;
	a.resize(n);
	b.resize(n);
	c.resize(m);
	vector<vector<int>> fir;
	vector<int> sec;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> b[i];
		fir.push_back({ a[i], b[i], 0 });
	}
	for (int i = 0; i < m; i++) {
		cin >> c[i];
		sec.push_back(c[i]);
	}
	sort(fir.begin(), fir.end());
	sort(sec.begin(), sec.end());
	int ans = get_val(fir, sec);
	if (ans == 0) {
		cout << "Second";
	}
	else {
		cout << "First";
	}
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	solve();
	return 0;
}