#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

template<class T>
using order_set = tree<T, nullptr_t, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using ld = long double;
using mll = map<ll, ll>;
using pll = pair<ll, ll>;
using vll = vector<ll>;

const ll inf = 1e16;
const ll mod = 1e9 + 7;
const ld eps = 1e-9;

const ll nmax = 5e5 + 1;
ll a[nmax], b[nmax], c[nmax];

struct segtree {
    ll n, nlog = 0;
    vector<ll> tree;

    segtree(ll size) {
        for (n = 1; n < size; n <<= 1)
            nlog++;
        tree.resize(n << 1);
    }

    void upd(ll i) {
        tree[i += n] = 1;
        while (i >>= 1)
            tree[i] = tree[i << 1] + tree[i << 1 | 1];
    }

    ll get(ll ql, ll qr) {
        ql += n, qr += n;
        ll res = 0;
        while (ql < qr) {
            if (ql & 1)
                res += tree[ql++];
            if (qr & 1)
                res += tree[--qr];
            ql >>= 1, qr >>= 1;
        }
        return res;
    }
};

segtree st(3 * nmax);

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    ll n, m;
    cin >> n >> m;
    vector<ll> p;
    for (ll i = 0; i < n; i++)
        p.push_back(i);
    for (ll i = 0; i < n; i++)
        cin >> a[i];
    for (ll i = 0; i < n; i++)
        cin >> b[i];
    for (ll i = 0; i < m; i++) {
        cin >> c[i];
        st.upd(c[i]);
    }
    sort(p.begin(), p.end(), [](ll i, ll j) { return a[i] < a[j]; });

    bool flag = false;
    for (ll mask = 0; mask < (1 << n); mask++) {
        ll k = 0;
        ll pred = 0;
        for (ll i = 0; i < n; i++) {
            k += st.get(pred, a[p[i]]);
            if (mask >> i & 1) {
                st.upd(b[p[i]]);
                continue;
            }
            k++;
            if (k % 2 == 0)
                flag = true;
            pred = a[p[i]];
        }
    }
    cout << (flag ? "Second" : "First") << '\n';
}