#include <bits/stdc++.h>

using namespace std;

template<typename T>
istream& operator>>(istream& is, vector<T>& a) {
    for (auto& x : a) is >> x;
    return is;
}
template<typename T>
ostream& operator<<(ostream& is, vector<T>& a) {
    for (auto& x : a) is << x << ' ';
    cout << '\n';
    return is;
}

template<typename T1, typename T2>
istream& operator>>(istream& is, vector<pair<T1, T2>>& a) {
    for (auto& x : a) is >> x.first >> x.second;
    return is;
}

template<typename T1, typename T2>
ostream& operator<<(ostream& is, vector<pair<T1, T2>>& a) {
    for (auto& x : a) is << x.first << ' ' << x.second << '\n';
    return is;
}


template<typename T1, typename T2>
void amax(T1& a, T2 b) {
    a = max(a, b);
}
template<typename T1, typename T2>
void amin(T1& a, T2 b) {
    a = min(a, b);
}
#ifdef OTKR
bool local = true;
#else
bool local = false;
#endif // OTKR

#define int long long
#define sz(x) (int)(x.size())
#define all(x) x.begin(), x.end()
#define ff first
#define ss second
#define pb emplace_back
#define push emplace

void solve();
void stress();
void precalc();

using vi = vector<int>;
using pi = pair<int, int>;
using vpi = vector<pi>;
using vvi = vector<vi>;
using vvpi = vector<vpi>;

const int ma = 3e5;
const int INF = 1e18;
const int mod = 1e9 + 7;

struct Mint{
    int x;
    Mint() : x(0) {}
    Mint(int x) : x(x) {}
    Mint operator+(const Mint& b) const {
        int res = x + b.x;
        if (res >= mod) res -= mod;
        return {res};
    }
    Mint operator-(const Mint& b) const {
        int res = x - b.x;
        if (res < 0) res += mod;
        return {res};
    }
    Mint operator*(const Mint& b) const {
        return {x * b.x % mod};
    }
    Mint operator==(const Mint& b) const {
        return x == b.x;
    }
};

struct Segtree{
    struct Node{
        int su;
        int mi;
        int indmi;
        Node operator+(const Node& b) const {
            Node res;

            return res;
        }
    };
    Node Make(int x, int i) {
        Node res;

        return res;
    }
    Node N;
    vector<Node> t;
    void build(int v, int l, int r,const vi& a) {
        if (l + 1 == r) {
            t[v] = Make(a[l], l);
        }
        int m = (l + r) / 2;
        build(v * 2, l, m, a);
        build(v * 2 + 1, m, r, a);
        t[v] = t[v * 2] + t[v * 2 + 1];
    }
    Segtree(const vi& a) : t(4 * sz(a)) {
        build(1, 0, sz(a), a);
    }
    void upd(int v, int l, int r, int i, int x) {
        if (l + 1 == r) {
            t[v] = Make(x, l);
        }
        int m = (l + r) / 2;
        if (i < m) {
            upd(v * 2, l, m, i, x);
        } else {
            upd(v * 2 + 1, m, r, i, x);
        }
        t[v] = t[v * 2] + t[v * 2 + 1];
    }
    Node get(int v, int nl, int nr, int ql, int qr) {
        if (nl >= qr || nr <= ql) return N;
        if (ql <= nl && nr <= qr) return t[v];
        int m = (nl + nr) / 2;
        return get(v * 2, nl, m, ql, qr) + get(v * 2 + 1, m, nr, ql, qr);
    }
};

signed main() {
    if (local) {
        freopen("input.txt", "r", stdin);
    }
    int t = 1; //cin >> t;
    while (t--) {
        solve();
    }
}

int brut(int n, int m, int T, vi& a, vi& b) {
    int ans = 0;
    for (auto v : b) {
        int x = v - 1;
        int cu = 0, res = 0;
        for (int i = x; i < n; i++) {
            cu += a[i];
            if (cu >= T) break;
            int cnt = i - x + 1;
            int ost = (T - cu) / a[i];
            amax(res, cnt + ost);
        }
        cu = 0;
        for (int i = x; i >= 0; i--) {
            cu += a[i];
            if (cu >= T) break;
            int cnt = x - i + 1;
            int ost = (T - cu) / a[i];
            amax(res, cnt + ost);
        }
        cout << x << " " << res << '\n';
        amax(ans, res);
    }
    return ans;
}

int brut2(int n, int m, int T, vi& a, vi& b) {
    vi pref(n + 1);
    for (int i = 0; i < n; i++) {
        pref[i + 1] = pref[i] + a[i];
    }
    int ans = 0;
    for (auto x : b) {
        int v = x - 1;
        int l = 0, r  = x, res = 0;
        //позицию бинарим
        while (r - l > 2) {
            int mi1 = l + (r - l) / 3;
            int mi2 = r - (r - l) / 3;
            int su1 = pref[v + 1] - pref[mi1],
            su2 = pref[v + 1] - pref[mi2];
            if (su2 >= T) {
                l = mi2;
                continue;
            }
            if (su1 >= T) {
                l = mi1;
                continue;
            }
            int ans1 = v - mi1 + 1 + (T - su1) / a[mi1];
            int ans2 = v - mi2 + 1 + (T - su2) / a[mi2];
            amax(res, ans1);
            amax(res, ans2);
            if (ans1 > ans2) {
                r = mi2;
            } else {
                l = mi1;
            }
        }
        for (int f = max(0LL,l - 5); f <= min(v,r + 5); f++) {
            int su = pref[v + 1] - pref[f];
            if (su >= T) continue;
            int t = v - f + 1 + (T - su) / a[f];
            amax(res, t);
        }
        l = v, r = n - 1;
        while (r - l > 2) {
            int mi1 = l + (r - l) / 3;
            int mi2 = r - (r - l) / 3;
            int su1 = pref[mi1 + 1] - pref[v],
            su2 = pref[mi2 + 1] - pref[v];
            if (su2 >= T) {
                l = mi2;
                continue;
            }
            if (su1 >= T) {
                l = mi1;
                continue;
            }
            int ans1 = mi1 - v + 1 + (T - su1) / a[mi1];
            int ans2 = mi2 - v + 1 + (T - su2) / a[mi2];
            amax(res, ans1);
            amax(res, ans2);
            if (ans1 > ans2) {
                r = mi1;
            } else {
                l = mi2;
            }
        }
        for (int f = max(v,l - 5); f <= min(n - 1,r + 5); f++) {
            int su = pref[f + 1] - pref[v];
            if (su >= T) continue;
            int t = f - v + 1 + (T - su) / a[f];
            amax(res, t);
        }
        //cout << l << ' ' << r << ' ' << res << '\n';
        amax(ans, res);
    }
    return ans;
}

mt19937 mt(226);

void stress() {
    for (int we = 0; we <= 1e6; we++) {


        int n = mt() % 10 + 1;
        int m = mt() % n + 1;
        int t = mt() % 20 + 5;
        vi a(n);
        for (auto& x : a) {
            x = mt() % 5 + 1;
        }
        vi b(m);
        for (int i = 0; i < m; i++) {
            b[i] = mt() % n + 1;
        }
        int f = brut(n, m, t, a, b);
        int s = brut2(n, m, t, a, b);
        if (f != s) {
            cout << n << ' ' << m << ' ' << t << '\n';
            cout << a << b;
            cout << "need : " << f << '\n';
            cout << "yest : " << s << '\n';
            return;
        }

    }
    cout << "GOOOOOOOOOOOOL" << endl;
}

void solve() {
    //stress();
    cout << "First";

}









