#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

#define pb push_back
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
#define int ll

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

struct node {
    int cnt, sm, mn, mx;
};

node operator+(const node&a, const node&b) {
    node nw = {a.cnt + b.cnt, a.sm + b.sm, min(a.mn, b.mn), max(a.mx, b.mx)};
    return nw;
}

struct segtree {
    int n;
    vector<int> a;
    vector<node> t;
    segtree() = default;
    segtree(int n_, vector<int> a_) {
        a = a_;
        n = n_;
        t.assign(4 * n, {0, 0, (int)1e9 + 1, (int)-1e9 - 1});
    }

    void add_numb(int pos) {
        int v = 1, tl = 0, tr = n;
        while (tl + 1 < tr) {
            int tm = (tl + tr) / 2;
            if (pos < tm) {
                v <<= 1; tr = tm;
            } else {
                v = v << 1 | 1; tl = tm;
            }
        }
        t[v].cnt++; t[v].sm += a[pos];
        t[v].mx = max(t[v].mx, a[pos]);
        t[v].mn = a[pos];
        v >>= 1;
        while (v) {
            t[v] = t[v << 1] + t[v << 1 | 1];
            v >>= 1;
        }
    }

    void del_numb(int pos) {
        int v = 1, tl = 0, tr = n;
        while (tl + 1 < tr) {
            int tm = (tl + tr) >> 1;
            if (pos < tm) {
                v <<= 1; tr = tm;
            } else {
                v = v << 1 | 1; tl = tm;
            }
        }
        t[v].cnt--; t[v].sm -= a[pos];
        if (t[v].cnt == 0) {
            t[v].mx = -1e9 - 1;
            t[v].mn = 1e9 + 1;
        }
        v >>= 1;
        while (v) {
            t[v] = t[v << 1] + t[v << 1 | 1];
            v >>= 1;
        }
    }

    pair<int, int> biggest(int v, int tl, int tr, int k) {
        if (k == t[v].cnt) {
            return {t[v].mn, t[v].sm};
        }
        if (tl + 1 == tr) {
            return {t[v].mn, t[v].mn * k};
        }
        if (tl + 1 == tr) return;
        int tm = (tl + tr) / 2;
        if (t[v << 1 | 1].cnt >= k) {
            return biggest(v << 1 | 1, tm, tr, k);
        }
        int smright = t[v << 1 | 1].sm;
        auto lol = biggest(v << 1, tl, tm, k - t[v << 1 | 1].cnt);
        lol.second += smright;
        return lol;
    }
};

void solve() {
    int n, m0, k0, q; cin >> n >> m0 >> k0 >> q;
    vector<int> a(n);
    for (int&u : a) cin >> u;

    vector<int> aa = a;
    sort(all(aa));
    int rest = m0 * k0;
    vector<int> suff(n);
    suff[n - 1] = aa[n - 1];
    for (int i = n - 2; i >= 0; i--) suff[i] = suff[i + 1] + aa[i];
    vector<int> vls;
    vector<int> pref(n + 1);
    for (int i = 0; i < n; i++) pref[i + 1] = pref[i] + aa[i];
    for (int i = 0; i < n; i++) {
        if (i + 1 < n) {
            int L = -1, R = min(rest, m0);
            while (R - L > 1) {
                int M = (L + R) / 2;
                int l1 = i, r1 = n;
                while (r1 - l1 > 1) {
                    int m1 = (l1 + r1) / 2;
                    if (aa[m1] - aa[i] + M <= m0) l1 = m1;
                    else r1 = m1;
                }
                int S = M + pref[l1 + 1] - pref[i + 1] - (aa[i] - M) * (l1 - i) + (n - l1 - 1) * m0;
                if (S >= rest) R = M;
                else L = M; 
            }
            rest -= R;
            vls.pb(aa[i] - R);
        }
    }
    vls.pb(aa[n - 1] - rest);
    for (int u : vls) cout << u << ' ';
    cout << '\n';

    vector<vector<int>> qrs;
    vector<int> allvls = a;
    for (int i = 0; i < q; i++) {
        int t; cin >> t;
        if (t == 1) {
            int m, k, x; cin >> m >> k >> x;
            qrs.pb({1, m, k, x});
        } else {
            int p, v; cin >> p >> v; p--;
            qrs.pb({2, p, v});
            allvls.pb(v);
        }
    }
    sort(all(allvls));
    allvls.resize(unique(all(allvls)) - allvls.begin());
    map<int, int> pos;
    for (int i = 0; i < sz(allvls); i++) pos[allvls[i]] = i;

    segtree sg(sz(allvls), allvls);
    for (int i = 0; i < n; i++) sg.add_numb(pos[a[i]]);
    for (int i = 0; i < q; i++) {
        if (qrs[i][0] == 2) {
            sg.del_numb(pos[a[qrs[i][1]]]);
            a[qrs[i][1]] = qrs[i][2];
            sg.add_numb(pos[a[qrs[i][1]]]);
        } else {
            int m = qrs[i][1], k = qrs[i][2], pos = qrs[i][3] - 1;
            int L = -1, R = n;
            while (R - L > 1) {
                int M = (L + R) / 2;
                auto haha = sg.biggest(1, 0, sz(allvls), n - M);
                if (haha.second - haha.first * (n - M) <= m) R = M;
                else L = M;
            }
            auto lol = sg.biggest(1, 0, sz(allvls), n - R);
            int spent = lol.second - lol.first * (n - R);
            int dop_sure = (m - spent) / (n - R);
            int restt = (m - spent) % (n - R);

            if (pos < R) {
                auto XDD = sg.biggest(1, 0, sz(allvls), n - pos);
                cout << XDD.first << '\n';
            } else {
                cout << (pos - R < restt ? lol.first - dop_sure - 1 : lol.first - dop_sure) << '\n';
            }
        }
    }
}

signed main() {
    int tt = 1;
    #ifdef LOCAL
        freopen("in.txt", "r", stdin);
        freopen("out.txt", "w", stdout);
        cin >> tt;
    #else
        cin.tie(0)->sync_with_stdio(false);
    #endif  

    while (tt--) {
        solve();
    }

    return 0;
}