#include <bits/stdc++.h>
#define int long long

using namespace std;

constexpr long long INF = (long long)1e18 + 7;

mt19937 rnd(57);

struct Node {
    int val;
    int sz;
    int pr;
    int sum;
    int mn;
    Node *l, *r;

    Node(int _val) {
        val = _val;
        sz = 1;
        pr = rnd();
        sum = val;
        mn = val;
        l = r = nullptr;
    }
};

int sz(Node *root) {
    if (!root) {
        return 0;
    }
    return root->sz;
}

int sum(Node *root) {
    if (!root) {
        return 0;
    }
    return root->sum;
}

int mn(Node *root) {
    if (!root) {
        return INF;
    }
    return root->mn;
}

void relax(Node *root) {
    root->sz = sz(root->l) + 1 + sz(root->r);
    root->sum = sum(root->l) + root->val + sum(root->r);
    root->mn = min(mn(root->l), root->val);
}

Node *merge(Node *root1, Node *root2) {
    if (!root1) {
        return root2;
    }
    if (!root2) {
        return root1;
    }
    if (root1->pr > root2->pr) {
        root1->r = merge(root1->r, root2);
        relax(root1);
        return root1;
    } else {
        root2->l = merge(root1, root2->l);
        relax(root2);
        return root2;
    }
}

pair<Node*, Node*> split_by_sz(Node *root, int sz_left) {
    if (!root) {
        return make_pair(nullptr, nullptr);
    }
    if (sz(root->l) >= sz_left) {
        auto [res1, res2] = split_by_sz(root->l, sz_left);
        root->l = res2;
        relax(root);
        return make_pair(res1, root);
    } else {
        auto [res1, res2] = split_by_sz(root->r, sz_left - sz(root->l) - 1);
        root->r = res1;
        relax(root);
        return make_pair(root, res2);
    }
}

pair<Node*, Node*> split_by_key(Node *root, int key) {
    if (!root) {
        return make_pair(nullptr, nullptr);
    }
    if (root->val >= key) {
        auto [res1, res2] = split_by_key(root->l, key);
        root->l = res2;
        relax(root);
        return make_pair(res1, root);
    } else {
        auto [res1, res2] = split_by_key(root->r, key);
        root->r = res1;
        relax(root);
        return make_pair(root, res2);
    }
}

int get_cnt_eq_rec(Node *root, int m, int cnt_r, long long sum_r) {
    if (!root) {
        return cnt_r;
    }
    int val = root->val;
    int used = root->val + sum(root->r) + sum_r - val * (cnt_r + sz(root->r) + 1);
    if (used <= m) {
        return get_cnt_eq_rec(root->l, m, cnt_r + sz(root->r) + 1, sum_r + sum(root->r) + root->val);
    }
    return get_cnt_eq_rec(root->r, m, cnt_r, sum_r);
}

void solve() {
    int n, m0, k0, q;
    cin >> n >> m0 >> k0 >> q;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    Node *root = nullptr;
    for (int i = 0; i < n; ++i) {
        auto [res1, res2] = split_by_key(root, a[i]);
        root = merge(res1, merge(new Node(a[i]), res2));
    }
    auto get_ai = [&](int i) -> int {
        auto [res1, res2] = split_by_sz(root, i);
        auto [res3, res4] = split_by_sz(res2, 1);
        int ans = res3->val;
        root = merge(res1, merge(res3, res4));
        return ans;
    };
    auto get_suff = [&](int len) -> int {
        auto [res1, res2] = split_by_sz(root, n - len);
        int ans = sum(res2);
        root = merge(res1, res2);
        return ans;
    };
    auto get_cnt_eq = [&](int m) -> int {
        return get_cnt_eq_rec(root, m, 0, 0);
        // int l = 1, r = n + 1;
        // while (l < r - 1) {
        //     int md = (l + r) / 2;
        //     int val = get_ai(n - md);
        //     if (get_suff(md) - m <= val * 1LL * md) {
        //         l = md;
        //     } else {
        //         r = md;
        //     }
        // }
        // return l;
    };
    for (int i = 0; i < n; ++i) {
        int cnt_eq = get_cnt_eq(m0);
        if (i < n - cnt_eq) {
            cout << get_ai(i) << ' ';
        } else {
            int val = get_ai(n - cnt_eq);
            int used = get_suff(cnt_eq) - val * cnt_eq;
            int vl = (m0 - used) / cnt_eq;
            if (i - (n - cnt_eq) < (m0 - used) % cnt_eq) {
                cout << val - vl - 1 << ' '; 
            } else {
                cout << val - vl << ' ';
            }
        }
    }
    cout << '\n';
    while (q--) {
        int t;
        cin >> t;
        if (t == 1) {
            int m_nw, k_nw, i;
            cin >> m_nw >> k_nw >> i;
            i--;
            int cnt_eq = get_cnt_eq(m_nw);
            if (i < n - cnt_eq) {
                cout << get_ai(i) << ' ';
            } else {
                int val = get_ai(n - cnt_eq);
                int used = get_suff(cnt_eq) - val * cnt_eq;
                int vl = (m_nw - used) / cnt_eq;
                if (i - (n - cnt_eq) < (m_nw - used) % cnt_eq) {
                    cout << val - vl - 1 << '\n'; 
                } else {
                    cout << val - vl << '\n';
                }
            }
        } else if (t == 2) {
            int p, v;
            cin >> p >> v;
            p--;
            auto [res1, res2] = split_by_key(root, a[p]);
            auto [res3, res4] = split_by_sz(res2, 1);
            root = merge(res1, res4);
            a[p] = v;
            auto [res5, res6] = split_by_key(root, a[p]);
            root = merge(res5, merge(new Node(a[p]), res6));
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
