#ifdef _DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <iomanip>
#include <string>
#include <limits>
#include <array>
#include <stack>
#include <queue>
#include <deque>
#include <vector>
#include <numeric>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <chrono>
#include <random>
#include <assert.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ui = unsigned int;
using ld = long double;
using pii = pair<int, int>;
using pli = pair<long long, int>;
using pil = pair<int, long long>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

vector<int> get_array(vector<int> a, int m, int k) {
	int n = a.size();
	sort(all(a));
	int i = n - 1;
	int cur = a[i];
	while (i > 0 && a[i] == a[i - 1])
		i--;
	while (m) {
		if (i == 0) {
			int t = m / n;
			for (int j = 0; j < n; j++)
				a[j] = cur;
			for (int j = 0; j < n; j++)
				a[j] -= t;
			m %= n;
			for (int j = n - m; j < n; j++)
				a[j]--;
			m = 0;
		} else {
			int pr = a[i - 1];
			ll t = 1ll * (cur - pr) * (n - i);
			if (t >= m) {
				for (int j = i; j < n; j++)
					a[j] = cur;
				for (int j = i; j < n; j++)
					a[j] -= m / (n - i);
				m %= (n - i);
				for (int j = n - m; j < n; j++)
					a[j]--;
				m = 0;
			} else {
				m -= t;
				cur = pr;
				i--;
				while (i > 0 && a[i] == a[i - 1])
					i--;
			}
		}
	}
	sort(all(a));
	return a;
}

struct query {
	int t, m, k, x;
};

struct segtree {
	struct node {
		int cnt = 0;
		ll sum = 0;
	};

	vector<node> tree;
	vector<int> c;
	int sz;

	segtree() {}

	segtree(const vector<int>& _c) {
		c = _c;
		sz = c.size();
		tree.resize(4 * sz);
	}

	void pull(int v) {
		tree[v].cnt = tree[2 * v + 1].cnt + tree[2 * v + 2].cnt;
		tree[v].sum = tree[2 * v + 1].sum + tree[2 * v + 2].sum;
	}

	void add(int i, int x, int v, int tl, int tr) {
		if (tr - tl == 1) {
			tree[v].cnt += x;
			tree[v].sum += 1ll * c[tl] * x;
			return;
		}
		int m = (tl + tr) / 2;
		if (i < m)
			add(i, x, 2 * v + 1, tl, m);
		else
			add(i, x, 2 * v + 2, m, tr);
		pull(v);
	}

	void add(int i, int x) {
		add(i, x, 0, 0, sz);
	}

	int kth(int k, int v, int tl, int tr) {
		if (tr - tl == 1)
			return tl;
		int m = (tl + tr) / 2;
		if (tree[2 * v + 1].cnt >= k)
			return kth(k, 2 * v + 1, tl, m);
		else
			return kth(k - tree[2 * v + 1].cnt, 2 * v + 2, m, tr);
	}

	int kth(int k) {
		return kth(k, 0, 0, sz);
	}

	ll sum(int k, int v, int tl, int tr) {
		if (tree[v].cnt == k)
			return tree[v].sum;
		if (tr - tl == 1)
			return 1ll * c[tl] * k;
		int m = (tl + tr) / 2;
		if (tree[2 * v + 2].cnt >= k)
			return sum(k, 2 * v + 2, m, tr);
		return sum(k - tree[2 * v + 2].cnt, 2 * v + 1, tl, m) + tree[2 * v + 2].sum;
	}

	ll sum(int k) {
		return sum(k, 0, 0, sz);
	}
};

inline void solve() {
	int n, m0, k0, queries;
	cin >> n >> m0 >> k0 >> queries;
	vector<int> a(n);
	for (int i = 0; i < n; i++)
		cin >> a[i];
	vector<int> b = get_array(a, m0, k0);
	for (int i = 0; i < n; i++)
		cout << b[i] << ' ';
	cout << '\n';
	vector<query> q(queries);
	sort(all(a));
	vector<int> c = a;
	for (int i = 0; i < queries; i++) {
		int t;
		cin >> t;
		if (t == 1) {
			int m, k, x;
			cin >> m >> k >> x;
			q[i] = { 1, m, k, x };
		}
		else if (t == 2) {
			int pos, val;
			cin >> pos >> val;
			pos--;
			c.push_back(val);
			q[i] = { 2, pos, val, -1 };
		}
	}
	sort(all(c));
	c.resize(unique(all(c)) - c.begin());
	for (int& i : a)
		i = lower_bound(all(c), i) - c.begin();
	segtree st(c);
	for (int i = 0; i < n; i++)
		st.add(a[i], 1);
	for (int i = 0; i < queries; i++) {
		if (q[i].t == 1) {
			int m = q[i].m, k = q[i].k, x = q[i].x;
			if (m == 0) {
				cout << c[st.kth(x)] << '\n';
				continue;
			}
			int lo = -1, hi = n - 1;
			while (hi - lo > 1) {
				int mid = (lo + hi) / 2;
				int val = c[st.kth(mid + 1)];
				ll sum = st.sum(n - mid - 1);
				sum -= 1ll * val * (n - mid - 1);
				if (sum >= m)
					lo = mid;
				else
					hi = mid;
			}
			int len = n - lo - 1;
			x = n + 1 - x;
			if (x > len) {
				cout << c[st.kth(n + 1 - x)] << '\n';
				continue;
			}
			int val = c[st.kth(lo + 2)];
			ll sum = st.sum(n - lo - 1);
			sum -= m;
			int sub = 0;
			ll mn;
			if (sum < 0) {
				if ((-sum) % len == 0)
					mn = sum / len;
				else
					mn = -((-sum) / len) - 1;
			} else {
				mn = sum / len;
			}
			if (sum > mn * len)
				sub = sum - mn * len;
			if (sub == 0) {
				cout << mn << '\n';
				continue;
			}
			if (x <= sub)
				cout << mn + 1 << '\n';
			else
				cout << mn << '\n';
		} else {
			int pos = q[i].m;
			int val = q[i].k;
			val = lower_bound(all(c), val) - c.begin();
			st.add(a[pos], -1);
			a[pos] = val;
			st.add(a[pos], 1);
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("01.dat", "r", stdin);
#endif
	int tt = 1;
#ifdef _DEBUG
	cin >> tt;
#endif
	for (int test_id = 1; test_id <= tt; test_id++) {
#ifdef _DEBUG
		cout << "TESTCASE# " << test_id << '\n';
#endif
		solve();
	}
	return 0;
}
