#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cmath>
#include <random>
#include <map>
#include <queue>

using namespace std;
using ll = long long;

bool ch(ll x, vector<ll>& a, ll m0, ll k0) {
	ll cn = 0;
	for (auto i : a) {
		cn += max(0ll, min(m0, i - x));
	}
	return cn >= m0 * k0;
}

void ans(vector<ll> a, ll m0, ll k0) {
	int n = a.size();
	ll lt = -2e9, rt = 2e9;
	while (rt - lt > 1) {
		ll md = (lt + rt) / 2;
		if (ch(md, a, m0, k0)) {
			lt = md;
		}
		else {
			rt = md;
		}
	}
	ll cn = k0 * m0;
	for (int i = 0; i < n; ++i) {
		if (a[i] <= lt) {
			continue;
		}
		if (a[i] - m0 > lt + 1) {
			cn -= m0;
			a[i] -= m0;
		}
		else {
			cn -= a[i] - (lt + 1);
			a[i] = lt + 1;
		}
	}
	for (int i = 0; i < n; ++i) {
		if (cn == 0) break;
		if (a[i] == lt + 1) {
			--a[i];
			--cn;
		}
	}
	sort(a.begin(), a.end());
	for (auto i : a) {
		cout << i << ' ';
	}
	cout << '\n';
}

const int maxn = 1 << 20;

ll cn[maxn], sm[maxn];
vector<ll> vc;
int cnt;

void upd(int v, int l, int r, int id, int c) {
	if (r - l == 1) {
		cn[v] += c;
		sm[v] += c * vc[l];
		return;
	}
	int m = (l + r) / 2;
	if (id < m) {
		upd(2 * v, l, m, id, c);
	}
	else {
		upd(2 * v + 1, m, r, id, c);
	}
	cn[v] = cn[2 * v] + cn[2 * v + 1];
	sm[v] = sm[2 * v] + sm[2 * v + 1];
}

int get_cnt(int v, int l, int r, int tl, int tr) {
	if (l >= tr || tl >= r) return 0;
	if (l >= tl && r <= tr) return cn[v];
	int m = (l + r) / 2;
	return get_cnt(2 * v, l, m, tl, tr) + get_cnt(2 * v + 1, m, r, tl, tr);
}

ll get_sum(int v, int l, int r, int tl, int tr) {
	if (l >= tr || tl >= r) return 0;
	if (l >= tl && r <= tr) return sm[v];
	int m = (l + r) / 2;
	return get_sum(2 * v, l, m, tl, tr) + get_sum(2 * v + 1, m, r, tl, tr);
}

bool cc(ll x, ll m, ll k) {
	auto id1 = lower_bound(vc.begin(), vc.end(), x) - vc.begin();
	auto id2 = lower_bound(vc.begin(), vc.end(), x + m) - vc.begin();
	return m * k <= get_sum(1, 0, cnt, id1, id2) - get_cnt(1, 0, cnt, id1, id2) * x + m * get_cnt(1, 0, cnt, id2, cnt);
}

int g_id(int v, int l, int r, int ct) {
	if (r - l == 1) return l;
	int m = (l + r) / 2;
	if (cn[2 * v] >= ct) {
		return g_id(2 * v, l, m, ct);
	}
	return g_id(2 * v + 1, m, r, ct - cn[2 * v]);
}

ll smf(ll cp) {
	int id3 = g_id(1, 0, cnt, cp);
	return get_sum(1, 0, cnt, 0, id3) + (cp - get_cnt(1, 0, cnt, 0, id3)) * vc[id3];
}


ll get(ll m, ll k, int l, int r) {
	ll lt = -2e9, rt = 2e9;
	while (rt - lt > 1) {
		ll md = (lt + rt) / 2;
		if (cc(md, m, k)) {
			lt = md;
		}
		else {
			rt = md;
		}
	}
	int id1 = lower_bound(vc.begin(), vc.end(), lt + 1) - vc.begin();
	int id2 = lower_bound(vc.begin(), vc.end(), lt + 2 + m) - vc.begin();
	int c1 = get_cnt(1, 0, cnt, 0, id1);
	int c2 = get_cnt(1, 0, cnt, id1, id2);
	int c3 = get_cnt(1, 0, cnt, id2, cnt);
	ll cn = m * k - c3 * m - (get_sum(1, 0, cnt, id1, id2) - (lt + 1) * c2);
	ll p2 = smf(min(r, c1));
	p2 += max(0, min(r - c1, c2)) * (lt + 1);
	p2 -= max(0, min(r - c1, (int)cn));
	if (r > c1 + c2) {
		p2 += smf(r) - smf(c1 + c2) -m * max(0, r - c1 - c2);
	}
	--l;
	ll p1 = smf(min(l, c1));
	p1 += max(0, min(l - c1, c2)) * (lt + 1);
	p1 -= max(0, min(l - c1, (int)cn));
	if (l > c1 + c2) {
		p1 += smf(l) - smf(c1 + c2) - m * max(0, l - c1 - c2);
	}
	return p2 - p1;
}

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	ll n, m0, k0, q;
	cin >> n >> m0 >> k0 >> q;
	vector<ll> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		vc.push_back(a[i]);
	}
	ans(a, m0, k0);
	vector<ll> t(q), m(q), k(q), x(q), p(q), v(q), l(q), r(q);

	for (int i = 0; i < q; ++i) {
		cin >> t[i];
		if (t[i] == 1) {
			cin >> m[i] >> k[i] >> x[i];
		}
		else if (t[i] == 2) {
			cin >> p[i] >> v[i];
			--p[i];
			vc.push_back(v[i]);
		}
		else {
			cin >> m[i] >> k[i] >> l[i] >> r[i];
		}
	}
	sort(vc.begin(), vc.end());
	vc.resize(unique(vc.begin(), vc.end()) - vc.begin());
	cnt = vc.size();
	for (int i = 0; i < n; ++i) {
		upd(1, 0, cnt, lower_bound(vc.begin(), vc.end(), a[i]) - vc.begin(), 1);
	}
	for (int i = 0; i < q; ++i) {
		if (t[i] == 1) {
			cout << get(m[i], k[i], x[i], x[i]) << '\n';
		}
		else if (t[i] == 2) {
			upd(1, 0, cnt, lower_bound(vc.begin(), vc.end(), a[p[i]]) - vc.begin(), -1);
			a[p[i]] = v[i];
			upd(1, 0, cnt, lower_bound(vc.begin(), vc.end(), a[p[i]]) - vc.begin(), 1);
		}
		else {
			cout << get(m[i], k[i], l[i], r[i]) << '\n';
		}
	}

	return 0;
}
