#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <iomanip>
#include <string>
#include <numeric>
#include <random>
#include <cmath>
using namespace std;
using ll = long long;
using ld = long double;
const ll INF = 1e18;

struct elem {
	int type, p, v;
	ll m; int k, x; 
};

struct node {
	ll val; int cnt; ll pref;
};
struct segTree {
	int size;
	vector<node> tree;
	vector<ll> push_pref;

	void init(int n) {
		size = 1;
		while (size < n)
			size *= 2;
		tree.resize(2 * size - 1, { 0, 0, 0 });
		push_pref.resize(2 * size - 1, 0);
	}
	void build(int x, int lx, int rx, const vector<ll>& a) {
		if (lx + 1 == rx) {
			if (lx < a.size()) {
				tree[x] = { a[lx], 0, 0 };
			}
			return;
		}
		int m = (lx + rx) / 2;
		build(2 * x + 1, lx, m, a);
		build(2 * x + 2, m, rx, a);
		tree[x].cnt = tree[2 * x + 1].cnt + tree[2 * x + 2].cnt;
	}
	void make_push(int x) {
		if (push_pref[x] == 0) return;
		push_pref[2 * x + 1] += push_pref[x];
		push_pref[2 * x + 2] += push_pref[x];
		tree[2 * x + 1].pref += push_pref[x];
		tree[2 * x + 2].pref += push_pref[x];
		push_pref[x] = 0;
	}
	void add(int x, int lx, int rx, int l, int r, ll add_pref) {
		if (lx >= l && rx <= r) {
			tree[x].pref += add_pref;
			push_pref[x] += add_pref;
			return;
		}
		if (lx >= r || rx <= l)
			return;
		int m = (lx + rx) / 2;
		make_push(x);
		add(2 * x + 1, lx, m, l, r, add_pref);
		add(2 * x + 2, m, rx, l, r, add_pref);
	}
	void upd(int x, int lx, int rx, int pos, int val) {
		if (lx + 1 == rx) {
			tree[x].cnt = val;
			return;
		}
		int m = (lx + rx) / 2;
		make_push(x);
		if (pos < m)
			upd(2 * x + 1, lx, m, pos, val);
		else
			upd(2 * x + 2, m, rx, pos, val);
		tree[x].cnt = tree[2 * x + 1].cnt + tree[2 * x + 2].cnt;
	}
	pair<ll, ll> get_k(int x, int lx, int rx, int k) {
		if (lx + 1 == rx) {
			return { tree[x].val, tree[x].pref };
		}
		int m = (lx + rx) / 2;
		make_push(x);
		if (tree[2 * x + 1].cnt >= k)
			return get_k(2 * x + 1, lx, m, k);
		else
			return get_k(2 * x + 2, m, rx, k - tree[2 * x + 1].cnt);
	}
};


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, k0, q; ll m0;
	cin >> n >> m0 >> k0 >> q;
	vector<ll> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	sort(a.begin(), a.end());
	reverse(a.begin(), a.end());
	vector<ll> dp(n, 0);
	ll pref = a[0];
	for (int i = 1; i < n; ++i) {
		dp[i] = pref - a[i] * i;
		pref += a[i];
	}
	int pos = distance(dp.begin(), prev(upper_bound(dp.begin(), dp.end(), m0)));
	ll ost = m0 - dp[pos];
	ll add = ost / (pos + 1);
	int pref_cnt = ost % (pos + 1);
	vector<ll> ans(n);
	for (int i = 0; i < pref_cnt; ++i)
		ans[i] = a[pos] - add - 1;
	for (int i = pref_cnt; i <= pos; ++i)
		ans[i] = a[pos] - add;
	for (int i = pos + 1; i < n; ++i)
		ans[i] = a[i];
	sort(ans.begin(), ans.end());
	for (auto el : ans) cout << el << " ";
	cout << "\n";

	vector<ll> all_val;
	for (int i = 0; i < n; ++i) {
		all_val.push_back(a[i]);
	}
	vector<elem> ques(q);
	for (int i = 0; i < q; ++i) {
		int type;
		cin >> type;
		if (type == 2) {
			int p, val;
			cin >> p >> val;
			p--;
			all_val.push_back(val);
			ques[i] = { type, p, val, 0, 0, 0 };
		}
		else {
			int k, x; ll m;
			cin >> m >> k >> x;
			ques[i] = { type, 0, 0, m, k, x };
		}
	}
	sort(all_val.begin(), all_val.end());
	reverse(all_val.begin(), all_val.end());
	unordered_map<int, unordered_set<int>> dict_ost, dict_busy;
	for (int i = 0; i < all_val.size(); ++i) {
		dict_ost[all_val[i]].insert(i);
	}
	segTree tr;
	int sz = all_val.size();
	tr.init(sz);
	tr.build(0, 0, tr.size, all_val);
	for (int i = 0; i < n; ++i) {
		int pos = *dict_ost[a[i]].begin();
		dict_ost[a[i]].erase(pos);
		dict_busy[a[i]].insert(pos);
		tr.add(0, 0, tr.size, pos + 1, sz, a[i]);
		tr.upd(0, 0, tr.size, pos, 1);
	}
	for (auto el : all_val) cout << el << " ";
	cout << "\n";

	for (int i = 0; i < q; ++i) {
		int type = ques[i].type;
		if (type == 2) {
			int p = ques[i].p, val = ques[i].v;
			int pos = *dict_busy[a[p]].begin();
			dict_busy[a[p]].erase(pos);
			dict_ost[a[p]].insert(pos);
			tr.add(0, 0, tr.size, pos + 1, sz, -a[p]);
			tr.upd(0, 0, tr.size, pos, 0);
			pos = *dict_ost[val].begin();
			dict_busy[val].insert(pos);
			dict_ost[val].erase(pos);
			tr.add(0, 0, tr.size, pos + 1, sz, val);
			tr.upd(0, 0, tr.size, pos, 1);
			a[p] = val;
		}
		else {
			int k = ques[i].k, x = ques[i].x; ll m = ques[i].m;
			int left = -1, right = n;
			while (left + 1 < right) {
				int mid = left + (right - left) / 2;
				
				auto el = tr.get_k(0, 0, tr.size, mid + 1);
				ll val = el.first, pref = el.second;

				if (pref - val * mid <= m)
					left = mid;
				else
					right = mid;
			}
			int pos = left;
			auto el = tr.get_k(0, 0, tr.size, pos + 1);
			ll val = el.first, pref = el.second;
			ll ost = m - (pref - val * pos);
			ll add = ost / (pos + 1);
			int pref_cnt = ost % (pos + 1);
			if (x <= n - pos - 1) {
				cout << tr.get_k(0, 0, tr.size, n - x + 1).first << "\n";
			}
			else if (x <= n - pos - 1 + pref_cnt) {
				cout << val - add - 1 << "\n";
			}
			else {
				cout << val - add << "\n";
			}
		}
	}

	return 0;
}
