#include <bits/extc++.h>

#define int long long

using namespace std;

mt19937 rnd_(chrono::high_resolution_clock::now().time_since_epoch().count());

struct node {
    pair<int, int> x = {0, 0};
    unsigned y = rnd_();
    int sum = 0;
    int l = -1;
    int r = -1;
    int sz = 1;
    explicit node(pair<int, int> x_) {
        x = x_;
        sum = x_.first;
    }
};

vector<node> t;

int new_node(pair<int, int> x) {
    t.emplace_back(x);
    return (int)t.size() - 1;
}

int sum(int v) {
    return v == -1 ? 0 : t[v].sum;
}

int sz(int v) {
    return v == -1 ? 0 : t[v].sz;
}

void upd(int v) {
    t[v].sum = t[v].x.first + sum(t[v].l) + sum(t[v].r);
    t[v].sz = 1 + sz(t[v].l) + sz(t[v].r);
}

int merge(int a, int b) {
    if (a == -1) {
        return b;
    }
    if (b == -1) {
        return a;
    }
    if (t[a].y > t[b].y) {
        t[a].r = merge(t[a].r, b);
        upd(a);
        return a;
    }
    t[b].l = merge(a, t[b].l);
    upd(b);
    return b;
}

pair<int, int> split(int v, pair<int, int> k) {
    if (v == -1) {
        return {-1, -1};
    }
    if (t[v].x <= k) {
        auto [a, b] = split(t[v].r, k);
        t[v].r = a;
        upd(v);
        return {v, b};
    }
    auto [a, b] = split(t[v].l, k);
    t[v].l = b;
    upd(v);
    return {a, v};
}

pair<int, int> get(int v, int x) {
    auto [a, b] = split(v, {x, -1});
    auto ans = make_pair(sum(b), sz(b));
    merge(a, b);
    return ans;
}

int timer = 1e9;

int insert(int T, int x) {
    int v = new_node({x, ++timer});
    auto [a, b] = split(T, t[v].x);
    return merge(merge(a, v), b);
}

int erase_one(int v) {
    return merge(t[v].l, t[v].r);
}

int erase(int T, int x) {
    auto [a, b] = split(T, {x, 1e14});
    auto [c, d] = split(a, {x - 1, 1e14});
    d = erase_one(d);
    return merge(merge(c, d), b);
}

int repl(int T, int x, int y) {
    T = erase(T, x);
    T = insert(T, y);
    return T;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m0, k0, q;
    cin >> n >> m0 >> k0 >> q;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    auto A = a;
    sort(A.begin(), A.end());
    sort(a.begin(), a.end());
    if (m0 == 0) {
        for (int i = 0; i < n; i++) {
            cout << a[i] << " \n"[i == n - 1];
        }
        return 0;
    }
    int T = -1;
    for (int i = 0; i < n; i++) {
        T = merge(T, new_node({a[i], i}));
    }
    auto f = [&](int x) {
        return get(T, x);
    };
    auto ans = [&](int m) -> tuple<int, int, int> {
        int lx = -1e12, rx = 1e12;
        while (rx - lx > 1) {
            int x = (lx + rx) >> 1;
            int kill = f(x).first;
            if (kill <= m0) {
                rx = x;
            } else {
                lx = x;
            }
        }
        m -= f(rx).first;
        return {rx, m, f(rx).second};
    };
    {
        auto [rx, more, _] = ans(m0);
        for (int &x : a) {
            x = min(x, rx);
        }
        int i = n - 1;
        while (more--) {
            a[i]--;
            i--;
        }
    }
    sort(a.begin(), a.end());
    for (int i = 0; i < n; i++) {
        cout << a[i] << " \n"[i == n - 1];
    }
    while (q--) {
        int o, m, k, x;
        cin >> o >> m >> k >> x;
        auto [mx, more, cnt] = ans(m);
        if (x <= n - cnt) {
            cout << A[x - 1] << '\n';
        } else {
            if (x <= n - cnt + more) {
                cout << mx - 1 << '\n';
            } else {
                cout << mx << '\n';
            }
        }
    }
    return 0;
}
