#include <bits/extc++.h>

#define int long long

using namespace __gnu_pbds;
using namespace std;

template<class T>
        using ordered_set = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937 rnd_(chrono::high_resolution_clock::now().time_since_epoch().count());

struct node {
    pair<int, int> x = {0, 0};
    unsigned y = rnd_();
    int sum = 0;
    int l = -1;
    int r = -1;
    int sz = 1;
    explicit node(pair<int, int> x_) {
        x = x_;
        sum = x_.first;
        sz = 1;
    }
};

vector<node> t;

int new_node(pair<int, int> x) {
    t.emplace_back(x);
    return (int)t.size() - 1;
}

int sum(int v) {
    return v == -1 ? 0 : t[v].sum;
}

int sz(int v) {
    return v == -1 ? 0 : t[v].sz;
}

void upd(int v) {
    t[v].sum = t[v].x.first + sum(t[v].l) + sum(t[v].r);
    t[v].sz = 1 + sz(t[v].l) + sz(t[v].r);
}

int merge(int a, int b) {
    if (a == -1) {
        return b;
    }
    if (b == -1) {
        return a;
    }
    if (t[a].y > t[b].y) {
        t[a].r = merge(t[a].r, b);
        upd(a);
        return a;
    }
    t[b].l = merge(a, t[b].l);
    upd(b);
    return b;
}

pair<int, int> split(int v, pair<int, int> k) {
    if (v == -1) {
        return {-1, -1};
    }
    if (t[v].x <= k) {
        auto [a, b] = split(t[v].r, k);
        t[v].r = a;
        upd(v);
        return {v, b};
    }
    auto [a, b] = split(t[v].l, k);
    t[v].l = b;
    upd(v);
    return {a, v};
}

pair<int, int> get(int v, int x) {
    auto [a, b] = split(v, {x - 1, 1e14});
    auto ans = make_pair(sum(b), sz(b));
    merge(a, b);
    return ans;
}

int timer = 0;

int insert(int T, int x) {
    int v = new_node({x, ++timer});
    auto [a, b] = split(T, t[v].x);
    return merge(merge(a, v), b);
}

int erase_one(int v) {
    return merge(t[v].l, t[v].r);
}

int erase(int T, int x) {
    auto [a, b] = split(T, {x, 1e14});
    auto [c, d] = split(a, {x - 1, 1e14});
    d = erase_one(d);
    return merge(merge(c, d), b);
}

int repl(int T, int x, int y) {
    T = erase(T, x);
    T = insert(T, y);
    return T;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m0, k0, q;
    cin >> n >> m0 >> k0 >> q;
    vector<int> a(n);
    ordered_set<pair<int, int>> kek;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        kek.insert({a[i], i});
    }
    auto A = a;
    sort(a.begin(), a.end());
    auto aa = a;
//    if (m0 == 0) {
//        for (int i = 0; i < n; i++) {
//            cout << a[i] << " \n"[i == n - 1];
//        }
//    }
    int T = -1;
    for (int i = 0; i < n; i++) {
        T = insert(T, a[i]);
    }
    auto f = [&](int x) {
        return get(T, x);
    };
    auto ans = [&](int m) -> tuple<int, int, int> {
        int lx = -1e12, rx = 1e12;
        while (rx - lx > 1) {
            int x = (lx + rx) >> 1;
            auto [aaa, bb] = f(x);
            //cerr << "!!! " << x << "   " << aa << ' ' << bb << '\n';
            int kill = aaa - bb * x;
            if (kill <= m) {
                rx = x;
            } else {
                lx = x;
            }
        }
        auto [aaa, bb] = f(rx);
        int kill = aaa - bb * rx;
        //cerr << "?????? " << rx << ' ' << m << ' ' << f(rx).second << '\n';
        return {rx, m - kill, f(rx).second};
    };
    {
        auto [rx, more, _] = ans(m0);
        cerr << "!! " << rx << ' ' << more << ' ' << _ << '\n';
        for (int &x : a) {
            x = min(x, rx);
        }
        int i = n - 1;
        while (more--) {
            a[i]--;
            i--;
        }
        sort(a.begin(), a.end());
        for (int ii = 0; ii < n; ii++) {
            cout << a[ii] << " \n"[ii == n - 1];
        }
    }
    while (q--) {
        int o;
        cin >> o;
        if (o == 1) {
            int m, k, x;
            cin >> m >> k >> x;
            auto [mx, more, cnt] = ans(m);
//        cerr << "!! " << m << ' ' << k << ' ' << x << '\n';
//        cerr << "!! " << mx << ' ' << more << ' ' << cnt << '\n';
            if (x <= n - cnt) {
                cout << kek.find_by_order(x - 1)->first << '\n';
            } else {
                if (x <= n - cnt + more) {
                    cout << mx - 1 << '\n';
                } else {
                    cout << mx << '\n';
                }
            }
        } else {
            int p, v;
            cin >> p >> v, p--;
            T = repl(T, A[p], v);
            kek.erase({A[p], p});
            A[p] = v;
            kek.insert({A[p], p});
        }
    }
    return 0;
}
/*

5 0 1 1
1 2 3 4 5
1 15 1 4

5 11 1 1
1 2 3 4 5
1 0 1 4



 */