#include <iostream>
#include <vector>
#include <stack>
#include <deque>
#include <queue>
#include <set>
#include <bitset>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <cmath>
#include <iomanip>
#include <algorithm>
#include <random>

using namespace std;

random_device rd;
mt19937 rnd(rd());

#define int long long

struct pref_sum {
    vector<int> pr;
    pref_sum(vector<int> a) {
        pr = {0};
        for (int i : a) {
            pr.push_back(pr.back() + i);
        }
    }
    int get(int l, int r) {
        return pr[r] - pr[l];
    }
};

void solve() {
    int n, m0, k, q; cin >> n >> m0 >> k >> q;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    sort(a.begin(), a.end());
    pref_sum pr(a);
    auto calc_f = [&] (int m, int id) -> int {
        int bl = 0, br = n;
        while (br - bl > 1) {
            int bm = (bl + br) / 2;
            if (pr.get(bm + 1, n) - a[bm] * (n - bm - 1) <= m) {
                br = bm;
            } else {
                bl = bm;
            }
        }
        if (id < br) {
            return a[id];
        }
        int val = pr.get(br, n) - a[br] * (n - br);
        m -= val;
        int x = a[br] - m / (n - br);
        if (id < br + m % (n - br)) {
            x--;
        }
        return x;
    };
    for (int i = 0; i < n; i++) {
        cout << calc_f(m0, i) << " ";
    }
    cout << '\n';
}

/*
3 1 1 0
7 6 6

3 4 1 0
1 3 6
 */

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}
