#include <iostream>
#include <vector>
#include <stack>
#include <deque>
#include <queue>
#include <set>
#include <bitset>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <cmath>
#include <iomanip>
#include <algorithm>
#include <random>

using namespace std;

random_device rd;
mt19937 rnd(rd());

#define int long long
using pii = pair<int, int>;

struct pref_sum {
    vector<int> pr;
    pref_sum(vector<int> a) {
        pr = {0};
        for (int i : a) {
            pr.push_back(pr.back() + i);
        }
    }
    int get(int l, int r) {
        return pr[r] - pr[l];
    }
};

struct segment_tree {
    vector<int> a;
    int n;
    segment_tree(int n_) {
        n = n_;
        a.resize(n, 0);
    }
    void upd(int pos, int val) {
        a[pos] = val;
    }
    int get(int l, int r) {
        int res = 0;
        for (int i = l; i < r; i++) {
            res += a[l];
        }
        return res;
    }
    int get_kth(int k) {
        for (int i = 0; i < n; i++) {
            k -= a[i];
            if (k == 0) {
                return i;
            }
        }
    }
};

struct el {
    int t, x, val;
    explicit el(int t_ = 0, int x_ = 0, int val_ = 0) {
        t = t_, x = x_, val = val_;
    }
};

void solve() {
    int n, m0, k, q; cin >> n >> m0 >> k >> q;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    sort(a.begin(), a.end());
    pref_sum pr(a);
    auto calc_f = [&] (int m, int id) -> int {
        int bl = -1, br = n;
        while (br - bl > 1) {
            int bm = (bl + br) / 2;
            if (pr.get(bm + 1, n) - a[bm] * (n - bm - 1) <= m) {
                br = bm;
            } else {
                bl = bm;
            }
        }
        if (id < br) {
            return a[id];
        }
        int val = pr.get(br, n) - a[br] * (n - br);
        m -= val;
        int x = a[br] - m / (n - br);
        if (id < br + m % (n - br)) {
            x--;
        }
        return x;
    };
    for (int i = 0; i < n; i++) {
        cout << calc_f(m0, i) << " ";
    }
    cout << '\n';
    vector<pii> ba;
    for (int i = 0; i < n; i++) {
        ba.emplace_back(a[i], i);
    }
    vector<el> vq;
    for (int op = 0; op < q; op++) {
        int t; cin >> t;
        if (t == 1) {
            int m, x; cin >> m >> k >> x;
            x--;
            vq.emplace_back(t, x, m);
        } else {
            int pos, val; cin >> pos >> val;
            pos--;
            ba.emplace_back(val, ba.size());
            vq.emplace_back(t, pos, val);
        }
    }
    std::sort(ba.begin(), ba.end());
    int sz = ba.size();
    segment_tree t_sum(sz), t_cnt(sz);
    vector<int> v_pos(sz);
    for (int i = 0; i < sz; i++) {
        v_pos[ba[i].second] = i;
    }
    for (int i = 0; i < n; i++) {
        t_cnt.upd(v_pos[i], 1);
        t_sum.upd(v_pos[i], a[i]);
    }
    auto calc_q_f = [&] (int m, int id) -> int {
        int bl = -1, br = n;
        while (br - bl > 1) {
            int bm = (bl + br) / 2;
            int temp = t_cnt.get_kth(bm + 1);
            if (t_sum.get(temp + 1, sz) - a[bm] * (n - bm - 1) <= m) {
                br = bm;
            } else {
                bl = bm;
            }
        }
        if (id < br) {
            id = t_cnt.get_kth(id + 1);
            return t_sum.get(id, id + 1);
        }
        int val = pr.get(br, n) - a[br] * (n - br);
        m -= val;
        int val_br = t_cnt.get_kth(br + 1);
        val_br = t_sum.get(val_br, val_br + 1);
        int x = val_br - m / (n - br);
        if (id < br + m % (n - br)) {
            x--;
        }
        return x;
    };
    calc_q_f(0, 0);
    vector<int> cur(n);
    for (int i = 0; i < n; i++) {
        cur[i] = i;
    }
    int temp_sz = n;
    for (auto el : vq) {
        if (el.t == 1) {
            cout << calc_q_f(el.val, el.x) << '\n';
        } else {
            t_cnt.upd(v_pos[cur[el.x]], 0);
            t_sum.upd(v_pos[cur[el.x]], 0);
            a[el.x] = el.val;
            cur[el.x] = temp_sz;
            temp_sz++;
            t_cnt.upd(v_pos[cur[el.x]], 1);
            t_sum.upd(v_pos[cur[el.x]], a[el.x]);
        }
    }
}

/*
3 1 1 0
7 6 6

3 4 1 0
1 3 6
 */

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}
