#include <iostream>
#include <vector>
#include <stack>
#include <deque>
#include <queue>
#include <set>
#include <bitset>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <cmath>
#include <iomanip>
#include <algorithm>
#include <random>

using namespace std;

random_device rd;
mt19937 rnd(rd());

#define int long long
using pii = pair<int, int>;

struct pref_sum {
    vector<int> pr;
    pref_sum(vector<int> a) {
        pr = {0};
        for (int i : a) {
            pr.push_back(pr.back() + i);
        }
    }
    int get(int l, int r) {
        return pr[r] - pr[l];
    }
};
/*
struct segment_tree {
    vector<int> a;
    int n;
    segment_tree(int n_) {
        n = n_;
        a.resize(n, 0);
    }
    void upd(int pos, int val) {
        a[pos] = val;
    }
    int get(int l, int r) {
        int res = 0;
        for (int i = l; i < r; i++) {
            res += a[l];
        }
        return res;
    }
    int get_kth(int k) {
        for (int i = 0; i < n; i++) {
            k -= a[i];
            if (k == 0) {
                return i;
            }
        }
    }
};
*/
struct el {
    int t, x, val;
    explicit el(int t_ = 0, int x_ = 0, int val_ = 0) {
        t = t_, x = x_, val = val_;
    }
};

struct node {
    int sum;
    explicit node(int sum_ = 0) {
        sum = sum_;
    }
};

struct segment_tree {
    vector<int> tree;
    vector<int> a;
    int n;
    segment_tree(int n_) {
        n = n_;
        a.resize(n, 0);
        tree.resize(4 * n + 5, 0);
    }
    int merge(int l, int r) {
        return l + r;
    }
    void build(int v, int l, int r) {
        if (r - l == 1) {
            tree[v] = a[l];
            return;
        }
        int m = (l + r) / 2;
        build(2 * v + 1, l, m);
        build(2 * v + 2, m, r);
        tree[v] = merge(tree[2 * v + 1], tree[2 * v + 2]);
    }
    int t_get(int v, int l, int r, int ql, int qr) {
        if (ql <= l && r <= qr) {
            return tree[v];
        }
        if (qr <= l || r <= ql) {
            return 0;
        }
        int m = (l + r) / 2;
        return merge(t_get(2 * v + 1, l, m, ql, qr), t_get(2 * v + 2, m, r, ql, qr));
    }
    int get(int l, int r) {
        return t_get(0, 0, n, l, r);
    }
    void t_upd(int v, int l, int r, int pos, int val) {
        if (r - l == 1) {
            tree[v] = val;
            return;
        }
        int m = (l + r) / 2;
        if (pos < m) {
            t_upd(2 * v + 1, l, m, pos, val);
        } else {
            t_upd(2 * v + 2, m, r, pos, val);
        }
        tree[v] = merge(tree[2 * v + 1], tree[2 * v + 2]);
    }
    void upd(int pos, int val) {
        t_upd(0, 0, n, pos, val);
    }
    int kth(int v, int l, int r, int x) {
        if (r - l == 1) {
            return l;
        }
        int m = (l + r) / 2;
        if (tree[2 * v + 1] >= x) {
            return kth(2 * v + 1, l, m, x);
        }
        return kth(2 * v + 2, m, r, x - tree[2 * v + 1]);
    }
    int get_kth(int k) {
        return kth(0, 0, n, k);
    }
};

void solve() {
    int n, m0, k, q; cin >> n >> m0 >> k >> q;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    sort(a.begin(), a.end());
    pref_sum pr(a);
    auto calc_f = [&] (int m, int id) -> int {
        int bl = -1, br = n;
        while (br - bl > 1) {
            int bm = (bl + br) / 2;
            if (pr.get(bm + 1, n) - a[bm] * (n - bm - 1) <= m) {
                br = bm;
            } else {
                bl = bm;
            }
        }
        if (id < br) {
            return a[id];
        }
        int val = pr.get(br, n) - a[br] * (n - br);
        m -= val;
        int x = a[br] - m / (n - br);
        if (id < br + m % (n - br)) {
            x--;
        }
        return x;
    };
    for (int i = 0; i < n; i++) {
        cout << calc_f(m0, i) << " ";
    }
    cout << '\n';
    vector<pii> ba;
    for (int i = 0; i < n; i++) {
        ba.emplace_back(a[i], i);
    }
    vector<el> vq;
    for (int op = 0; op < q; op++) {
        int t; cin >> t;
        if (t == 1) {
            int m, x; cin >> m >> k >> x;
            x--;
            vq.emplace_back(t, x, m);
        } else {
            int pos, val; cin >> pos >> val;
            pos--;
            ba.emplace_back(val, ba.size());
            vq.emplace_back(t, pos, val);
        }
    }
    std::sort(ba.begin(), ba.end());
    int sz = ba.size();
    segment_tree t_sum(sz), t_cnt(sz);
    vector<int> v_pos(sz);
    for (int i = 0; i < sz; i++) {
        v_pos[ba[i].second] = i;
    }
    for (int i = 0; i < n; i++) {
        t_cnt.upd(v_pos[i], 1);
        t_sum.upd(v_pos[i], a[i]);
        // cout << v_pos[i] << " ";
    }
  //  cout << endl;
    auto val_in_pos = [&] (int pos) -> int {
        pos = t_cnt.get_kth(pos + 1);
        return t_sum.get(pos, pos + 1);
    };
    auto calc_q_f = [&] (int m, int id) -> int {
        int bl = -1, br = n;
        while (br - bl > 1) {
            int bm = (bl + br) / 2;
            int temp = t_cnt.get_kth(bm + 1);
            if (t_sum.get(temp + 1, sz) - val_in_pos(bm) * (n - bm - 1) <= m) {
                br = bm;
            } else {
                bl = bm;
            }
        }
        if (id < br) {
            return val_in_pos(id);
        }
        int val_br = t_cnt.get_kth(br + 1);
        int val = t_sum.get(val_br, sz) - t_sum.get(val_br, val_br + 1) * (n - br);
        m -= val;
        val_br = t_sum.get(val_br, val_br + 1);
        int x = val_br - m / (n - br);
        if (id < br + m % (n - br)) {
            x--;
        }
        return x;
    };
    vector<int> cur(n);
    for (int i = 0; i < n; i++) {
        cur[i] = i;
    }
    int temp_sz = n;
    for (auto el : vq) {
        if (el.t == 1) {
            cout << calc_q_f(el.val, el.x) << '\n';
        } else {
            t_cnt.upd(v_pos[cur[el.x]], 0);
            t_sum.upd(v_pos[cur[el.x]], 0);
            a[el.x] = el.val;
            cur[el.x] = temp_sz;
            temp_sz++;
            t_cnt.upd(v_pos[cur[el.x]], 1);
            t_sum.upd(v_pos[cur[el.x]], a[el.x]);
        }
    }
}

/*
3 1 1 0
7 6 6

3 4 1 2
1 3 6
2 3 3
1 6 1 3
 */

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}
