#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")

using namespace std;
using ll = long long;
using ld = long double;

#define int long long

// insert - добавить число
// get - k порядковая
// cnt_less(x) - количество чисел < x
// sum_less(x) - сумма чисел < x
// pref(x) - сумма первых x наименьших чисел
// erase - удалить число

mt19937 rnd(1389712);

int n;

struct Treap {
	struct Node {
		int sum;
		int sz;
		int prior;
		pair<int, int> val;
		Node *l, *r;
		Node(pair<int, int> _val) {
			val = _val;
			sum = val.first;
			prior = rnd();
			sz = 1;
			l = nullptr;
			r = nullptr;
		}
	} *root = nullptr;
	int get_sz(Node *&node) {
		return (node ? node->sz : 0);
	}
	int get_sum(Node *&node) {
		return (node ? node->sum : 0);
	}
	void upd(Node *&node) {
		if (node) {
			node->sum = (node->val).first + get_sum(node->l) + get_sum(node->r);
			node->sz = 1 + get_sz(node->l) + get_sz(node->r);
		}
	}
	Node* merge(Node *less, Node *greater) {
		if (!less) return greater;
		if (!greater) return less;
		if (less->prior > greater->prior) {
			less->r = merge(less->r, greater);
			upd(less);
			return less;
		} else {
			greater->l = merge(less, greater->l);
			upd(greater);
			return greater;
		}
	}
	void split(Node *node, pair<int, int> key, Node *&less, Node *&greater) {
		if (!node) {
			less = nullptr;
			greater = nullptr;
			return;
		}
		if (node->val <= key) {
			split(node->r, key, node->r, greater);
			upd(node);
			less = node;
		} else {
			split(node->l, key, less, node->l);
			upd(node);
			greater = node;
		}
	}
	void insert(pair<int, int> tt) {
		int val = tt.first;
		int i = tt.second;
		Node *A, *B, *C;
		pair<int, int> key = {val, i};
		pair<int, int> key2 = {val, i - 1};
		split(root, key, B, C);
		split(B, key2, A, B);
		assert(!B);
		B = new Node(key);
		root = merge(merge(A, B), C);
	}
	void erase(pair<int, int> tt) {
		int val = tt.first;
		int i = tt.second;
		Node *A, *B, *C;
		pair<int, int> key = {val, i};
		pair<int, int> key2 = {val, i - 1};
		split(root, key, B, C);
		split(B, key2, A, B);
		assert(B);
		root = merge(A, C);
	}
	int cnt_less(int x) {
		pair<int, int> key = {x, -1e18};
		Node *a, *b;
		split(root, key, a, b);
		int ans = get_sz(a);
		root = merge(a, b);
		return ans;
	}
	int sum_less(int x) {
		pair<int, int> key = {x, -1e18};
		Node *a, *b;
		split(root, key, a, b);
		int ans = get_sum(a);
		root = merge(a, b);
		return ans;
	}
	pair<int, int> get(Node *node, int k) {
		if (get_sz(node->l) + 1 == k) {
			return node->val;
		}
		if (get_sz(node->l) >= k) {
			return get(node->l, k);
		}
		return get(node->r, k - get_sz(node->l) - 1);
	}
	int get(int k) {
		k = n - 1 - k;
		k++;
		// найти k порядковую статистику
		return get(root, k).first;
	}
	int pref(Node *node, int k) {
		int ans = 0;
		if (!node) return 0;
		if (get_sz(node->l) + 1 == k) {
			return get_sum(node->l) + (node->val).first;
		}
		if (get_sz(node->l) >= k) {
			return pref(node->l, k);
		}
		return pref(node->r, k - get_sz(node->l) - 1) + (node->val).first + get_sum(node->l);
	}
	int pref(int k) {
		return pref(root, k);
	}
	pair<int, int> get_cnt_sum(int x) {
		pair<int, int> key = {x, -1e18};
		Node *a, *b;
		split(root, key, a, b);
		pair<int, int> ans = {get_sz(a), get_sum(a)};
		root = merge(a, b);
		return ans;
	}
};

int m, k, q;
const int N = (int)2e5 + 5;
int a[N];
Treap st;
int all_sum = 0;

int get_cnt(int x) {
	// number of elemnts >= x
	return n - st.cnt_less(x);
}
int get_sum(int x) {
	// sum of elements >= x
	return all_sum - st.sum_less(x);
}
int get_pref(int x) {
	return all_sum - st.pref(n - (x + 1));
}
pair<int, int> get_cnt_sum(int x) {
	pair<int, int> it = st.get_cnt_sum(x);
	return make_pair(n - it.first, all_sum - it.second);
}
int get(int m, int k, int pos) {
	pos = n - 1 - pos;
	auto check = [&](int x) -> int {
		int need_sum = 0;
		pair<int, int> it = get_cnt_sum(x + m);
		pair<int, int> get2_cnt_sum = get_cnt_sum(x);
		need_sum += m * 1ll * it.first;
		need_sum += get2_cnt_sum.second - it.second;
		need_sum -= x * 1ll * (get2_cnt_sum.first - it.first);
		return need_sum;
	};
	int l = -1e10, r = st.get(0);
	while (l + 1 < r) {
		int mid = (l + r) >> 1;
		if (check(mid) <= m * k) {
			r = mid;
		} else {
			l = mid;
		}
	}
	int x = r;
	int temp = st.get(pos);
	if (temp <= x - 1) {
		return temp;
	}
	if (temp >= x + m) {
		return temp - m;
	}
	int ord = m * k - check(x);
	int t5 = get_cnt(x + m + 1);
	pos -= t5;
	int all_cnt = get_cnt(x) - t5;
	if (all_cnt - ord >= pos + 1) {
		return x;
	} else {
		return x - 1;
	}
}
int get_suf_sum(int m, int k, int lim, int r) {
	auto check = [&](int x) -> int {
		int need_sum = 0;
		pair<int, int> it = get_cnt_sum(x + m);
		pair<int, int> get2_cnt_sum = get_cnt_sum(x);
		need_sum += m * 1ll * it.first;
		need_sum += get2_cnt_sum.second - it.second;
		need_sum -= x * 1ll * (get2_cnt_sum.first - it.first);
		return need_sum;
	};
	lim = n - 1 - lim;
	int x = r;
	int pos1 = get_cnt(x + m + 1), pos2 = get_cnt(x);
	int ans = 0;
	if (pos1 > 0) {
		if (pos1 - 1 <= lim) {
			ans += get_pref(pos1 - 1) - m * pos1;
		} else {
			ans += get_pref(lim) - m * (lim + 1);
		}
	}
	if (pos2 <= lim) {
		ans += get_pref(lim) - (pos2 == 0 ? 0 : get_pref(pos2 - 1));
	}
	int ord = m * k - check(x);
	if (pos1 <= pos2 - 1 && pos1 <= lim) {
		int all = pos2 - pos1;
		int s = std::min(lim, pos2 - 1);
		int f = pos2 - 1 - ord + 1;
		ans += (s - pos1 + 1) * x;
		if (f <= s) {
			ans -= s - f + 1;
		}
	}
	return ans;
}
int get_sum_sub(int m, int k, int l, int r) {
	auto check = [&](int x) -> int {
		int need_sum = 0;
		pair<int, int> it = get_cnt_sum(x + m);
		pair<int, int> get2_cnt_sum = get_cnt_sum(x);
		need_sum += m * 1ll * it.first;
		need_sum += get2_cnt_sum.second - it.second;
		need_sum -= x * 1ll * (get2_cnt_sum.first - it.first);
		return need_sum;
	};
	int lx = -1e10, rx = st.get(0);
	while (lx + 1 < rx) {
		int mid = (lx + rx) >> 1;
		if (check(mid) <= m * k) {
			rx = mid;
		} else {
			lx = mid;
		}
	}
	return get_suf_sum(m, k, l, rx) - (r == n - 1 ? 0 : get_suf_sum(m, k, r + 1, rx));
}

signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0);

	cin >> n >> m >> k >> q;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	
	for (int i = 0; i < n; ++i) {
		st.insert({a[i], i});
		all_sum += a[i];
	}
	for (int i = 0; i < n; ++i) {
		cout << get(m, k, i) << ' ';
	}
	cout << '\n';
	while (q--) {
		int type;
		cin >> type;
		if (type == 1) {
			int m, k, x;
			cin >> m >> k >> x;
			x--;
			cout << get(m, k, x) << '\n';
		} else if (type == 3) {
			int m, k, l, r;
			cin >> m >> k >> l >> r;
			l--; r--;
			cout << get_sum_sub(m, k, l, r) << '\n';
		} else {
			int p, v;
			cin >> p >> v;
			p--;
			st.erase({a[p], p});
			st.insert({v, p});
			all_sum -= a[p];
			all_sum += v;
			a[p] = v;
		}
	}
}
