#include <bits/stdc++.h>
using namespace std;
using ll = long long;
//using ll = int;
using ld = long double;
using ull = unsigned long long;
#define pb push_back
#define all(vec) vec.begin(), vec.end()
#define eb emplace_back
#ifdef LOCAL
#define deb(x) cout << #x << " = " << x << '\n'
#else
#define deb(x) 52
#endif
const ll inf = 1e9 + 11;
const long long INF = (long long)2e18 + 11;
const ll P = 73;
const ll MOD = 1e9 + 7;


mt19937 gen(52);


struct Treap {
    struct Node {
        ll x, y, sz, sm;
        Node *l, *r;

        Node(ll x = 0) : x(x) {
            y = gen();
            sm = x;
            sz = 1;
            l = nullptr, r = nullptr;
        }
    };

    typedef pair<Node*, Node*> Pair;

    ll vsize(Node *v) {
        return (v ? v->sz : 0);
    }

    ll vsum(Node *v) {
        return (v ? v->sm : 0);
    }

    void upd(Node *v) {
        v->sz = vsize(v->r) + vsize(v->l) + 1;
        v->sm = vsum(v->l) + vsum(v->r) + v->x;
    }

    Node *root = nullptr;

    Node* merge(Node *l, Node *r) {
        if (!l) {
            return r;
        }
        if (!r) {
            return l;
        }
        if (l->y > r->y) {
            l->r = merge(l->r, r);
            upd(l);
            return l;
        } else {
            r->l = merge(l, r->l);
            upd(r);
            return r;
        }
    }

    Pair split(Node *v, ll k) {
        if (!v) {
            return {nullptr, nullptr};
        }
        if (vsize(v->l) + 1 <= k) {
            Pair q = split(v->r, k - vsize(v->l) - 1);
            v->r = q.first;
            upd(v);
            return {v, q.second};
        } else {
            Pair q = split(v->l, k);
            v->l = q.second;
            upd(v);
            return {q.first, v};
        }
    }

    Pair split_val(Node *v, ll k) {
        if (!v) {
            return {nullptr, nullptr};
        }
        if (v->x <= k) {
            Pair q = split_val(v->r, k);
            v->r = q.first;
            upd(v);
            return {v, q.second};
        } else {
            Pair q = split_val(v->l, k);
            v->l = q.second;
            upd(v);
            return {q.first, v};
        }
    }

    void insert(ll x) {
        Pair q = split_val(root, x);
        root = merge(merge(q.first, new Node(x)), q.second);
    }

    void erase(ll x) {
        Pair q = split_val(root, x - 1);
        Pair p = split(q.second, 1);
        root = merge(q.first, p.second);
    }

    ll get(ll k) {
        Pair q = split_val(root, k - 1);
        ll ans = vsum(q.second);
        root = merge(q.first, q.second);
        return ans;
    }

    ll cnt_less(ll k) {
        Pair q = split_val(root, k - 1);
        ll ans = vsize(q.first);
        root = merge(q.first, q.second);
        return ans;
    }

    ll get_kth(Node *v, ll k) {
        if (k == vsize(v->l) + 1) {
            return v->x;
        } else if (k < vsize(v->l) + 1) {
            return get_kth(v->l, k);
        } else {
            return get_kth(v->r, k - vsize(v->l) - 1);
        }
    }

    ll get_kth(ll k) {
        return get_kth(root, k);
    }
};


void solve() {
    ll n, m0, k0, q;
    cin >> n >> m0 >> k0 >> q;
    vector<ll> a(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    Treap treap;
    for (ll i : a) {
        treap.insert(i);
    }
    auto get_f = [&](ll m, ll x) -> ll {
        ll l = (ll)-1e11, r = (ll)1e11;
        auto f = [&](ll x) -> ll {
            ll cnt_more = n - treap.cnt_less(x);
            ll sum_more = treap.get(x);
            return sum_more - cnt_more * x;
        };
        while (r - l > 1) {
            ll mid = (r + l) >> 1;
            if (f(mid) <= m) {
                r = mid;
            } else {
                l = mid;
            }
        }
        ll need = m - f(r);
        ll cnt0 = treap.cnt_less(r);
        if (x <= cnt0) {
            return treap.get_kth(x);
        }
        if (x - cnt0 <= need) {
            return r - 1;
        } else {
            return r;
        }
    };
    for (ll i = 1; i <= n; ++i) {
        cout << get_f(m0, i) << ' ';
    }
    cout << '\n';
    while (q--) {
        ll t;
        cin >> t;
        if (t == 1) {
            ll m, k, x;
            cin >> m >> k >> x;
            cout << get_f(m, x) << '\n';
        } else {
            ll p, v;
            cin >> p >> v;
            --p;
            treap.erase(a[p]);
            a[p] = v;
            treap.insert(a[p]);
        }
    }//5252525
}


int main() {
#ifdef LOCAL
    freopen("C:/work/untitled/input.txt", "r", stdin);
    freopen("C:/work/untitled/output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll cfmode = 0;
    ll tc = 1;
    if (cfmode) {
        cin >> tc;
    }
    while (tc--) {
        solve();
        if (tc) {
            cout << '\n';
        }
    }
}