#include "bits/extc++.h"

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

template<typename T>
istream &operator>>(istream &is, vector<T> &a);

template<typename T>
ostream &operator<<(ostream &os, vector<T> &a);


using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

struct Query {
    int m, k, x, id;
};

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int n, m0, k0, q;
    cin >> n >> m0 >> k0 >> q;

    vector<int> a(n);
    cin >> a;

    vector<Query> ques(q);
    for (int i = 0; i < q; ++i) {
        int t;
        cin >> t;

        cin >> ques[i].m >> ques[i].k >> ques[i].x;
        ques[i].id = i;
    }
    ques.push_back({m0, k0, -1, -1});

    std::sort(ques.begin(), ques.end(), [&](Query L, Query R) {
        return L.m < R.m;
    });

    std::sort(a.begin(), a.end());

    vector<pair<int, int>> vals;
    for (int i = 0; i < n; ++i) {
        vals.push_back({a[i], i + 1});
    }

    int time = 0;
    for (auto query: ques) {
        while (vals.size() >= 2) {
            int can = (query.m - time) / (vals.back().second - vals[vals.size() - 2].second);
            if (can >= vals.back().first - vals[vals.size() - 2].first) {
                time += (vals.back().first - vals[vals.size() - 2].first) *
                        (vals.back().second - vals[vals.size() - 2].second);
                vals[vals.size() - 2].second = vals.back().second;
                vals.pop_back();
            } else {
                break;
            }
        }
        int can = (query.m - time) / vals.back().second;
        time += can * vals.back().second;
        vals.back().first -= can;

        int ost = query.m - time;
        if (ost != 0) {
            auto pr = vals.back();
            int sz = pr.second - (vals.size() == 1 ? 0 : vals[vals.size() - 2].second);
            vals.pop_back();
            vals.push_back({pr.first - 1, (vals.empty() ? 0 : vals.back().second) + ost});
            vals.push_back({pr.first, vals.back().second + (sz - ost)});

            if (query.id == -1) {
                int last = 0;
                for (auto [v, cn]: vals) {
                    for (int i = 0; i < cn - last; ++i) {
                        cout << v << " ";
                    }
                    last = cn;
                }
            }

            vals.pop_back();
            vals.pop_back();
            vals.push_back(pr);
        } else {
            if (query.id == -1) {
                int last = 0;
                for (auto [v, cn]: vals) {
                    for (int i = 0; i < cn - last; ++i) {
                        cout << v << " ";
                    }
                    last = cn;
                }
            }
        }
    }
}

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &v: a) is >> v;
    return is;
}

template<typename T>
ostream &operator<<(ostream &os, vector<T> &a) {
    for (auto v: a) os << v << " ";
    return (os << "\n");
}
