#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <numeric>

#include <ext/pb_ds/assoc_container.hpp>

#define all(a) a.begin(), a.end()
#define int long long

// #pragma GCC optimize("O3")

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

using oset = tree<pll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>; 

constexpr ll inf = 1e18;

int n;
vector<ll> a;
vector<ll> b;

void operation(ll k) {
    vector<pll> z(n);
    for (int i = 0; i < n; ++i) {
        z[i] = {-b[i], i};
    }
    sort(all(z));
    for (int i = 0; i < k; ++i) {
        b[z[i].second]--;
    }
}

ll cnt_f(ll m, ll k, ll x) {
    b = a;

    for (int i = 0; i < m; ++i) {
        operation(k);
    }

    sort(all(b));
    return b[x - 1];
}

ll cnt_s(ll m, ll k, ll l, ll r) {
    b = a;

    for (int i = 0; i < m; ++i) {
        operation(k);
    }

    sort(all(b));

    ll res = 0;
    for (int i = l - 1; i < r; ++i) res += b[i];
    return res;
}

void solve() {
    int m, k, q, x, y;
    cin >> n >> m >> k >> q;
    a.resize(n);
    for (ll &e : a) cin >> e;

    cnt_f(m, k, 0);
    for (int i = 0; i < n; ++i) cout << b[i] << ' ';
    cout << '\n';

    int t;
    while (q--) {
        cin >> t;
        if (t == 1) {
            cin >> m >> k >> x;
            cout << cnt_f(m, k, x) << '\n';
        } else if (t == 2) {
            cin >> x >> y;
            a[x - 1] = y;
        } else {
            cin >> m >> k >> x >> y;
            cout << cnt_s(m, k, x, y) << '\n';
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}