#ifdef LOCAL
// #define _GLIBCXX_DEBUG
#define debug(x) cerr << __LINE__ << ": " << (#x) << " = " << (x) << endl
#else
#define debug(...) 42
#endif

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
// #pragma GCC target("avx,avx2,fma")

#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef __int128 LL;
#define all(x) (x).begin(), (x).end()
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

template<typename T>
istream &operator >>(istream &in, vector<T> &a) {
    for (auto &elem : a) {
        in >> elem;
    }
    return in;
}

template<typename T>
ostream &operator <<(ostream &out, const vector<T> &a) {
    for (const auto &elem : a) {
        out << elem << ' ';
    }
    return out;
}

int n, m, k, q;
vector<int> a;

vector<ll> solve() {
    assert(q == 0);
    ll left = -1e17, right = 1e17;
    while (right - left > 1) {
        ll mid = (left + right) / 2;
        ll rem = 1ll * m * k;
        for (int num : a) {
            if (num - mid > m) {
                rem = -1;
                break;
            }
            rem -= max(num - mid, 0ll);
            if (rem < 0) { break; }
        }
        rem < 0 ? left = mid : right = mid;
    }
    vector<ll> res;
    ll rem = 1ll * m * k, cur = right;
    multiset<int> s;
    sort(all(a));
    int i = n;
    while (i > 0 && a[i - 1] >= cur) {
        rem -= a[i - 1] - cur;
        s.insert(a[i - 1]);
        i--;
    }
    while (res.size() < n) {
        // cout << "! " << cur << ' ' << s.size() << ' ' << rem << ' ' << i << endl;
        if (rem < s.size() || (!s.empty() && *s.rbegin() - cur + 1 > m)) {
            res.push_back(cur);
            s.erase(--s.end());
        } else {
            rem -= s.size();
            cur--;
            while (i > 0 && a[i - 1] == cur) {
                s.insert(a[i - 1]);
                i--;
            }
        }
    }
    ranges::reverse(res);
    return res;
}

vector<ll> slow() {
    vector<ll> cur(n);
    for (int i = 0; i < n; ++i) {
        cur[i] = a[i];
    }
    for (int t = 0; t < m; ++t) {
        sort(all(cur));
        for (int i = 0; i < k; ++i) {
            cur[n - i - 1]--;
        }
    }
    sort(all(cur));
    return cur;
}

void stress() {
    n = rng() % 10 + 1;
    m = rng() % 20;
    k = rng() % n + 1;
    a.resize(n);
    for (int &num : a) {
        num = rng() % 100;
    }
    if (solve() != slow()) {
        cout << n << ' ' << m << ' ' << k << " 0\n";
        cout << a << '\n';
        cout << solve() << '\n';
        cout << slow() << '\n';
        exit(0);
    }
}
int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m >> k >> q;
    a.resize(n);
    cin >> a;
    cout << solve();
//    while (true) {
//        stress();
//    }
}