#ifdef LOCAL
// #define _GLIBCXX_DEBUG
#define debug(x) cerr << __LINE__ << ": " << (#x) << " = " << (x) << endl
#else
#define debug(...) 42
#endif

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
// #pragma GCC target("avx,avx2,fma")

#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef __int128 LL;
#define all(x) (x).begin(), (x).end()
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

template<typename T>
istream &operator >>(istream &in, vector<T> &a) {
    for (auto &elem : a) {
        in >> elem;
    }
    return in;
}

template<typename T>
ostream &operator <<(ostream &out, const vector<T> &a) {
    for (const auto &elem : a) {
        out << elem << ' ';
    }
    return out;
}

int n, m, k, q;
vector<int> a;

vector<ll> solve2() {
    sort(all(a));
    vector<ll> res;
    ll rem = 1ll * m * k;
    ll cur = a.back(), cnt = 1;
    int i = n - 1;
    while (i > 0 && a[i - 1] == cur) {
        cnt++;
        i--;
    }
    while (res.size() < n) {
        if (i == 0) {
            cur -= rem / cnt;
            rem %= cnt;
            for (int j = 0; j < cnt - rem; ++j) {
                res.push_back(cur);
            }
            for (int j = 0; j < rem; ++j) {
                res.push_back(cur - 1);
            }
            break;
        }
        if (rem >= cnt * (cur - a[i - 1])) {
            rem -= cnt * (cur - a[i - 1]);
            cur = a[i - 1];
            while (i > 0 && a[i - 1] == cur) {
                cnt++;
                i--;
            }
        } else {
            cur -= rem / cnt;
            rem %= cnt;
            for (int j = 0; j < cnt - rem; ++j) {
                res.push_back(cur);
            }
            cnt = rem;
        }
    }
    ranges::reverse(res);
    return res;
}

vector<ll> solve() {
    ll left = -1e17, right = 1e17;
    while (right - left > 1) {
        ll mid = (left + right) / 2;
        ll rem = 1ll * m * k;
        for (int num : a) {
            if (num - mid > m) {
                rem = -1;
                break;
            }
            rem -= max(num - mid, 0ll);
            if (rem < 0) { break; }
        }
        rem < 0 ? left = mid : right = mid;
    }
    vector<ll> res;
    ll rem = 1ll * m * k, cur = right;
    multiset<int> s;
    sort(all(a));
    int i = n;
    while (i > 0 && a[i - 1] >= cur) {
        rem -= a[i - 1] - cur;
        s.insert(a[i - 1]);
        i--;
    }
    while (res.size() < n) {
        // cout << "! " << cur << ' ' << s.size() << ' ' << rem << ' ' << i << endl;
        if (s.empty()) {
            cur = a[i - 1];
            while (i > 0 && a[i - 1] == cur) {
                s.insert(a[i - 1]);
                i--;
            }
        } else if (rem >= (cur - a[i - 1]) * s.size()) {
            if (*s.rbegin() - a[i - 1] > m) {
                rem -= (cur - *s.rbegin() + m) * s.size();
                cur = *s.rbegin() - m;
                res.push_back(cur);
                s.erase(--s.end());
            } else {
                rem -= (cur - a[i - 1]) * s.size();
                cur = a[i - 1];
                while (i > 0 && a[i - 1] == cur) {
                    s.insert(a[i - 1]);
                    i--;
                }
            }
        } else {
            ll new_cur = cur - rem / s.size();
            if (*s.rbegin() - new_cur > m) {
                new_cur = *s.rbegin() - m;
            }
            rem -= (cur - new_cur) * s.size();
            cur = new_cur;
            res.push_back(cur);
            s.erase(--s.end());
        }
    }
    ranges::reverse(res);
    return res;
}

vector<ll> slow() {
    vector<ll> cur(n);
    for (int i = 0; i < n; ++i) {
        cur[i] = a[i];
    }
    for (int t = 0; t < m; ++t) {
        sort(all(cur));
        for (int i = 0; i < k; ++i) {
            cur[n - i - 1]--;
        }
    }
    sort(all(cur));
    return cur;
}

void stress() {
    cout << "start\n";
    n = rng() % 10 + 1;
    m = rng() % 30;
    k = 1;
    a.resize(n);
    for (int &num : a) {
        num = rng() % 100;
    }
    cout << n << ' ' << m << ' ' << k << " 0\n";
    cout << a << endl;
    if (solve2() != slow()) {
        cout << solve2() << '\n';
        cout << slow() << '\n';
        exit(0);
    }
    cout << "end\n";
}

void solve3() {
    vector<ll> cnt(n + 1);
    for (int i = 2; i <= n; ++i) {
        cnt[i] = cnt[i - 1] + (i - 1) * (a[n - i + 1] - a[n - i]);
    }
    while (q--) {
        ll cur_m, trash, x;
        cin >> trash >> cur_m >> trash >> x;
        int id = upper_bound(all(cnt), cur_m) - cnt.begin() - 1;
        cur_m -= cnt[id];
        if (id == n) {
            ll num = a[0] - cur_m / n;
            cur_m %= n;
            cout << (num - (x <= cur_m)) << '\n';
        } else if (x <= n - id) {
            cout << a[x - 1] << '\n';
        } else {
            ll num = a[n - id] - cur_m / id;
            cur_m %= id;
            cout << (num - (x <= cur_m)) << '\n';
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m >> k >> q;
    a.resize(n);
    cin >> a;
    cout << (k == 1 ? solve2() : solve());
    solve3();
//    while (true) {
//        stress();
//    }
}