#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;

using namespace std;

#define int long long
#define double long double

typedef tree<int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef tree<int, null_type, less_equal <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_multi_set;

int inf = (int)1000 * 1000 * 1000 * 1000 * 1000 * 1000;

struct st //+=, sum
{
    vector <int> t;
    vector <int> p;

    void build(int n)
    {
        t.resize(4 * n, 0);
        p.resize(4 * n, 0);
    }

    void push(int v, int l, int r)
    {
        if (p[v] != 0)
        {
            p[v * 2 + 1] += p[v];
            p[v * 2 + 2] += p[v];
            int m = (l + r) / 2;
            t[v * 2 + 1] += (m - l + 1) * p[v];
            t[v * 2 + 2] += (r - m) * p[v];
            p[v] = 0;
        }
    }

    int get(int v, int l, int r, int ll, int rr)
    {
        if (ll > rr)
        {
            return 0;
        }
        if (l == ll && r == rr)
        {
            return t[v];
        }

        int m = (l + r) / 2;
        push(v, l, r);
        return get(v * 2 + 1, l, m, ll, min(m, rr)) +
               get(v * 2 + 2, m + 1, r, max(m + 1, ll), rr);
    }

    void update(int v, int l, int r, int ll, int rr, int x)
    {
        if (ll > rr)
        {
            return;
        }
        if (l == ll && r == rr)
        {
            t[v] += x * (r - l + 1);
            p[v] += x;
            return;
        }
        int m = (l + r) / 2;
        push(v, l, r);
        update(v * 2 + 1, l, m, ll, min(m, rr), x);
        update(v * 2 + 2, m + 1, r, max(m + 1, ll), rr, x);
        t[v] = t[v * 2 + 1] + t[v * 2 + 2];
    }
};

int mod = 1000 * 1000 * 1000 + 7;

int bin_pow(int a, int x)
{
    if (x == 0)
    {
        return 1;
    }
    if (x % 2 == 0)
    {
        return bin_pow((a * a) % mod, x / 2);
    }
    return (a * bin_pow((a * a) % mod, x / 2)) % mod;
}

int add(int a, int b)
{
    if (a + b >= mod)
    {
        return a + b - mod;
    }
    return a + b;
}

int umn(int a, int b)
{
    return (a * b) % mod;
}

int del(int a, int b)
{
    return umn(a, bin_pow(b, mod - 2));
}

vector <int> get2(int n, vector <int> &a, int m, int k)
{
    multiset <int> s;
    for (int i = 0; i < n; i ++)
    {
        s.insert(a[i]);
    }

    for (int _ = 0; _ < m; _ ++)
    {
        vector <int> b;
        for (int j = 0; j < k; j ++)
        {
            auto i = s.end();
            i --;
            int x = *i;
            s.erase(i);
            b.push_back(x - 1);
        }
        for (int j = 0; j < k; j ++)
        {
            s.insert(b[j]);
        }
    }

    vector <int> ans;
    for (auto x : s)
    {
        ans.push_back(x);
    }
    return ans;
}

vector <int> get(int n, vector <int> &a, int m, int k)
{
    vector <int> ans = a;
    std::sort(ans.begin(), ans.end());
    for (int i = n - 1; i >= 1; i --)
    {
        if (ans[i] != ans[i - 1])
        {
            int len = n - i;
            if (m >= len * (ans[i] - ans[i - 1]))
            {
                m -= len * (ans[i] - ans[i - 1]);
            }
            else
            {
                int delta = m / len;
                m -= delta * len;
                for (int j = n - 1; j >= i; j --)
                {
                    ans[j] = ans[i] - delta;
                }
                return get2(n, ans, m, k);
            }
        }
    }
    int delta = m / n;
    for (int j = n - 1; j >= 0; j --)
    {
        ans[j] = ans[0] - delta;
    }
    m -= delta * n;
    return get2(n, ans, m, k);
}

void solve()
{
    int n, m, k, q;
    cin >> n >> m >> k >> q;

    vector <int> a(n);
    for (int i = 0; i < n; i ++)
    {
        cin >> a[i];
    }

    auto ans = get(n, a, m, k);

    for (int i = 0; i < n; i ++)
    {
        cout << ans[i] << " ";
    }
    cout << '\n';

    for (int i = 0; i < q; i ++)
    {
        int ind;
        cin >> ind;
        ind --;
        cout << ans[ind] << '\n';
    }
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    int _ = 1;
    //cin >> _;
    while (_ --)
    {
        solve();
    }
}
