#include <iostream>
#include <random>
#include <numeric>
#include <algorithm>
#include <vector>
#include <map>
#include <set>

using namespace std;
using ll = long long;
using ull = unsigned long long;

constexpr ll maxn = 2e5 + 10, inf = 1e9 + 10;

ll n, m0, k0, q;
ll arr[maxn];
ll pf[maxn];

ll sum_if_max_d(ll d) {
    ll pos = lower_bound(arr, arr + n, d) - arr;
    return pf[pos] + 1ll * d * (n - pos);
}

void solve() {
    cin >> n >> m0 >> k0 >> q;
    if (q) return;
    for (ll i = 0; i < n; ++i) cin >> arr[i];
    sort(arr, arr + n);
    for (ll i = 0; i < n; ++i) pf[i + 1] = pf[i] + arr[i];
    ll l = -inf, r = arr[n - 1];
    while (r - l != 1) {
        ll mid = (l + r) >> 1;
        if (sum_if_max_d(mid) >= pf[n] - 1ll * m0 * k0) r = mid;
        else l = mid;
    }
    ll eq_pos_1 = lower_bound(arr, arr + n, r) - arr;
    ll eq_pos_2 = n - (sum_if_max_d(r) - (pf[n] - 1ll * m0 * k0));
    for (ll i = 0; i < n; ++i) {
        if (i < eq_pos_1) cout << arr[i] << " ";
        else if (i - eq_pos_1 < n - eq_pos_2) cout << r - 1 << " ";
        else cout << r << " ";
    }
}

int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);
    int t = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> t;
#else
#ifdef TEST
    freopen("input.txt", "r", stdin);
#else
#endif
#endif
    while (t--) {
        solve();
        cout << "\n";
    }
    return 0;
}

//    for (int i = 0; i < n; ++i) {
//        for (int j = 0; j < n; ++j) dists[j] = 0;
//        dfs(i, 0);
//        dfs2(i);
//    }
//    int cnt = 0;
//    for (int i = 0; i < m; ++i) cnt += need[i];
//    cout << 0 << "\n";