#include <iostream>
#include <random>
#include <numeric>
#include <algorithm>
#include <vector>
#include <map>
#include <set>

using namespace std;
using ll = long long;
using ull = unsigned long long;

constexpr ll maxn = 2e5 + 10, inf = 1e12;

ll n;
ll arr[maxn];
ll pf[maxn];

ll sum_if_max_d(ll d) {
    ll pos = lower_bound(arr, arr + n, d) - arr;
    return pf[pos] + 1ll * d * (n - pos);
}

struct Pans {
    ll eqp1, eqp2, rv;
};

Pans get_eq_poss(ll m, ll k) {
    ll l = -inf, r = arr[n - 1];
    while (r - l != 1) {
        ll mid = (l + r) >> 1;
        if (sum_if_max_d(mid) >= pf[n] - 1ll * m * k) r = mid;
        else l = mid;
    }
    ll eq_pos_1 = lower_bound(arr, arr + n, r) - arr;
    ll eq_pos_2 = n - (sum_if_max_d(r) - (pf[n] - 1ll * m * k));
    return {eq_pos_1, eq_pos_2, r};
}

ll get_val(ll i, Pans pps) {
    if (i < pps.eqp1) return arr[i];
    if (i - pps.eqp1 < n - pps.eqp2) return pps.rv - 1;
    return pps.rv;
}

void solve() {
    ll m0, k0, q;
    cin >> n >> m0 >> k0 >> q;
    for (ll i = 0; i < n; ++i) cin >> arr[i];
    sort(arr, arr + n);
    for (ll i = 0; i < n; ++i) pf[i + 1] = pf[i] + arr[i];
    auto f0 = get_eq_poss(m0, k0);
    for (ll i = 0; i < n; ++i) cout << get_val(i, f0) << " ";
    for (int _ = 0, t; _ < q; ++_) {
        cin >> t;
        if (t == 1) {
            int m, k, x;
            cin >> m >> k >> x;
            cout << get_val(x - 1, get_eq_poss(m, k)) << "\n";
        }
    }
}

int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);
    int t = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> t;
#else
#ifdef TEST
    freopen("input.txt", "r", stdin);
#else
#endif
#endif
    while (t--) {
        solve();
        cout << "\n";
    }
    return 0;
}

//    for (int i = 0; i < n; ++i) {
//        for (int j = 0; j < n; ++j) dists[j] = 0;
//        dfs(i, 0);
//        dfs2(i);
//    }
//    int cnt = 0;
//    for (int i = 0; i < m; ++i) cnt += need[i];
//    cout << 0 << "\n";