#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <numeric>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <stack>
#include <queue>
#include <deque>
#include <map>
#include <set>
#include <chrono>
#include <random>
#include <unordered_map>
#include <unordered_set>
using namespace std;
using ll = long long;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const int N = 2e5 + 5;
ll t[4 * N], a[N];
ll n;

void build(int v, int l, int r) {
    if (r - l == 1) {
        t[v] = a[l];
        return;
    }
    int m = (l + r) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    t[v] = t[2 * v + 1] + t[2 * v + 2];
}

void upd(int v, int l, int r, int ind) {
    if (r - l == 1) {
        t[v] = a[l];
        return;
    }
    int m = (l + r) / 2;
    if (ind < m)
        upd(2 * v + 1, l, m, ind);
    else
        upd(2 * v + 2, m, r, ind);
    t[v] = t[2 * v + 1] + t[2 * v + 2];
}

ll get(int v, int l, int r, int ql, int qr) {
    if (ql >= r || l >= qr)
        return 0;
    if (ql <= l && r <= qr)
        return t[v];
    int m = (l + r) / 2;
    return get(2 * v + 1, l, m, ql, qr) + get(2 * v + 2, m, r, ql, qr);
}

ll f(ll val, ll x) {
    ll l = 0, r = n + 1;
    while (r - l > 1) {
        ll m = (l + r) / 2;
        if (get(0, 0, n + 1, m, n + 1) - (n - m + 1) * a[m - 1] >= val)
            l = m;
        else
            r = m;
    }
    val -= (get(0, 0, n + 1, r, n + 1) - (n - r + 1) * a[r - 1]);
    if (x < l)
        return a[x];
    ll ans = val / (n - l + 1);
    if (x < l + val % (n - l + 1))
        return a[l] - ans - 1;
    return a[l] - ans;
}


int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    int m0, k0, q;
    cin >> n >> m0 >> k0 >> q;
    a[0] = -2e9;
    for (int i = 1; i <= n; ++i)
        cin >> a[i];
    sort(a, a + n + 1);
    build(0, 0, n + 1);
    for (int x = 1; x <= n; ++x) {
        cout << f(m0, x) << " ";
    }
    while (q--) {
        int type;
        cin >> type;
        if (type == 1) {
            int m, k, x;
            cin >> m >> k >> x;
            cout << f(m, x) << " ";
        }
        else {
            int p, u;
            cin >> p >> u;
            a[p] = u;
            upd(0, 0, n + 1, p);
        }
    }
}
