#ifndef LOCAL
#include <bits/stdc++.h>
#endif
using namespace std;
#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector")
#pragma GCC target("avx2")

#define int int64_t
const int inf=1e18;

#ifdef LOCAL
#include "algo/debug.h"
#else
template <typename... Args>
void dummy(Args&&... args){}
#define ps dummy
#endif

#define f first
#define s second
template<class T> using V = vector<T>; 
using vi = V<int>;
using vb = V<bool>;
using vs = V<string>;

#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x) 
#define len(x) (int)((x).size())
#define rsz resize
#define ins insert
#define ft front()
#define bk back()
#define pb push_back
#define eb emplace_back
#define pf push_front
#define lb lower_bound
#define ub upper_bound
#define ai2 array<int,2>
#define ai3 array<int,3>
#define ai4 array<int,4>
#define ai5 array<int,5>
template<class T> int lwb(const V<T>& a, const T& b) { return lb(all(a),b)-begin(a); }
template<class T> int upb(const V<T>& a, const T& b) { return ub(all(a),b)-begin(a); }
template<class T> bool ckmin(T& a, const T& b) { return a > b ? a=b, true : false; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a=b, true : false; }
#define pct __builtin_popcountll
#define ctz __builtin_ctzll
#define clz __builtin_clzll
constexpr int p2(int x) { return (int)1 << x; }
constexpr int bits(int x) { return x == 0 ? 0 : 63-clz(x); } // floor(log2(x)) 
template<class T>void UNIQUE(V<T>& v) { sort(all(v)); v.erase(unique(all(v)),end(v)); }
template<class T,class U>void erase(T& t, const U& u) { auto it = t.find(u); assert(it != end(t)); t.erase(it); }
template<class F> struct y_combinator_result {
    F f;
    template<class T> explicit y_combinator_result(T &&f): f(std::forward<T>(f)) {}
    template<class ...Args> decltype(auto) operator()(Args &&...args) { return f(std::ref(*this), std::forward<Args>(args)...); }
};
template<class Fun> decltype(auto) yy(Fun &&fun) { return y_combinator_result<std::decay_t<Fun>>(std::forward<Fun>(fun)); }

struct Lazy {
    int kval;

    void operator+=(const Lazy oth) {
        kval += oth.kval;
    }
};

const Lazy lid = {0};


mt19937 mt(0);
using ptr = int;

struct Node {
    Lazy lazy;

    int key;
    int sz;
    int pri;
    ptr l, r;

    Node() {
        pri = mt();
        lazy = lid;
        sz = 0;
        l = r = 0;
    }

    Node(int key) : key(key) {
        pri = mt();
        lazy = lid;
        sz = 1;
        l = r = 0;
    }
};

vector<Node> mem(1);

int make_node(int key) {
    mem.emplace_back(key);
    return mem.size() - 1;
}

void push(ptr n) {
    if (mem[n].l) mem[mem[n].l].lazy += mem[n].lazy;
    if (mem[n].r) mem[mem[n].r].lazy += mem[n].lazy;
    mem[n].key += mem[n].lazy.kval;
    mem[n].lazy = lid;
}

ptr pull(ptr n) {
    if (n == 0) return 0;
    mem[n].sz = mem[mem[n].l].sz + 1 + mem[mem[n].r].sz;
    return n;
}

ptr merge(ptr l, ptr r) {
    if (!l || !r) return l ? l : r;
    push(l), push(r);
    if (mem[l].pri > mem[r].pri) return mem[l].r = merge(mem[l].r, r), pull(l);
    else return mem[r].l = merge(l, mem[r].l), pull(r);
}

// (-inf, k) and [k, inf)
pair<ptr, ptr> split(ptr n, int k) {
    if (!n) return {};
    push(n);
    if (k <= mem[n].key) {
        auto [l, r] = split(mem[n].l, k);
        mem[n].l = r;
        return {l, pull(n)};
    } else {
        auto [l, r] = split(mem[n].r, k);
        mem[n].r = l;
        return {pull(n), r};
    }
}

pair<ptr, ptr> spliti(ptr n, int i) {
    if (!n) return {0, 0};
    push(n);
    if (i <= mem[mem[n].l].sz) {
        auto [l, r] = spliti(mem[n].l, i);
        mem[n].l = r;
        return {l, pull(n)};
    } else {
        auto [l, r] = spliti(mem[n].r, i - 1 - mem[mem[n].l].sz);
        mem[n].r = l;
        return {pull(n), r};
    }
}

ptr mn(ptr n) {
    push(n);
    return mem[n].l ? mn(mem[n].l) : n;
}

// proof of complexity: https://codeforces.com/blog/entry/108601
ptr unite(ptr l, ptr r) {
    if (!l || !r) return l ? l : r;
    if (mem[l].key > mem[r].key) swap(l, r);
    ptr res = 0;
    while (r) {
        auto [lt, rt] = split(l, mem[r].key + 1);
        res = merge(res, lt);
        tie(l, r) = make_pair(r, rt);
    }
    return merge(res, l);
}

void add_to_pre(ptr n, int cnt, Lazy lazy) {
    if (!n) return;
    auto [l, r] = spliti(n, cnt);
    pull(l);
    mem[l].lazy += lazy;
    n = unite(l, r);
}

void ins(ptr& n, ptr it) {
    if (!n) { n = it; return; }
    push(n);
    if (mem[n].pri < mem[it].pri) {
        auto [l, r] = split(n, mem[it].key);
        mem[it].l = l, mem[it].r = r, n = it;
    } else if (mem[it].key <= mem[n].key) ins(mem[n].l, it);
    else ins(mem[n].r, it);
    pull(n);
}

template <typename Op>
void tour(ptr n, Op op) {
    stack<ptr> stk;
    while (n || !stk.empty()) {
        for (; n; n = mem[n].l) push(n), stk.push(n);
        n = stk.top(); stk.pop();
        op(mem[n]);
        n = mem[n].r;
    }
}

void solve() {
    int n, m0, k0, q; cin >> n >> m0 >> k0 >> q;
    vi a(n);
    for (int& i : a) cin >> i;
    V<ai5> qs(q);
    for (int i = 0; i < q; i++) {
        int typ; cin >> typ; 
        if (typ == 1) {
            int m, k, x; cin >> m >> k >> x;
            qs[i] = { 1, m, k, x, -1 };
        } else if (typ == 2) {
            int p, v; cin >> p >> v; p--;
            qs[i] = { 2, p, v, -1, -1 };
        } else {
            int m, k, l, r; cin >> m >> k >> l >> r;
            qs[i] = { 3, m, k, l, r };
        }
    }

    int root = make_node(a[0]);
    for (int i = 1; i < n; i++) {
        ins(root, make_node(a[i]));
    }
    
    auto dbg = [&]() {
        vi res;
        tour(root, [&](Node u) {
            res.pb(u.key);
        });
        return res;
    };

    for (int i = 0; i < m0; i++) {
        add_to_pre(root, k0, { 1 });
    }

    auto ans = dbg();
    for (int i = 0; i < len(ans); i++) cout << ans[i] << " \n"[i == len(ans) - 1];
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    solve();
    return 0;
}
