
#include <bits/stdc++.h>

using namespace std;

vector<int> a, ans;
int n, m, k, q;

vector<int> tree, add;

void build(int i, int l, int r) {
    if (l + 1 == r) {
        tree[i] = a[l];
    } else {
        int mid = (l + r) / 2;
        build(2 * i + 1, l, mid);
        build(2 * i + 2, mid, r);
        tree[i] = max(tree[2 * i + 1], tree[2 * i + 2]);
    }
}

void push(int i, int l, int r) {
    if (add[i] == 0 || l + 1 == r) return;
    tree[2 * i + 1] += add[i];
    tree[2 * i + 2] += add[i];
    add[2 * i + 1] += add[i];
    add[2 * i + 2] += add[i];
    add[i] = 0;
}

void change(int i, int l, int r, int lq, int rq, int x) {
    if (lq <= l && r <= rq) {
        tree[i] += x;
        add[i] += x;
        return;
    }
    if (rq <= l || r <= lq) return;
    push(i, l, r);
    int mid = (l + r) / 2;
    change(2 * i + 1, l, mid, lq, rq, x);
    change(2 * i + 2, mid, r, lq, rq, x);
    tree[i] = max(tree[2 * i + 1], tree[2 * i + 2]);
}

void change(int l, int r, int x) {
    change(0, 0, n, l, r, x);
}

int get(int i, int l, int r, int lq, int rq) {
    if (lq <= l && r <= rq) return tree[i];
    if (rq <= l || r <= lq) return -2e9;
    push(i, l, r);
    int mid = (l + r) / 2;
    return max(get(2 * i + 1, l, mid, lq, rq), get(2 * i + 2, mid, r, lq, rq));
}

int get(int l, int r) {
    return get(0, 0, n, l, r);
}

int get(int x) {
    return get(0, 0, n, x, x + 1);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m >> k >> q;
    a.resize(n);
    for (auto &elem : a) cin >> elem;
    sort(a.begin(), a.end());
    tree.resize(4 * n), add.resize(4 * n);
    build(0, 0, n);
    for (int i = 0; i < m; i++) {
        change(n - k, n, -1);
        int c1 = get(n - k - 1), c2 = get(n - k);
        if (c1 <= c2) continue;
        int left = 0, right = n - k - 1;
        while (right - left > 1) {
            int mid = (left + right) / 2;
            if (get(mid) == c1) right = mid;
            else left = mid;
        }
        int left1 = n - k, right1 = n;
        while (right1 - left1 > 1) {
            int mid = (left1 + right1) / 2;
            if (get(mid) == c2) left1 = mid;
            else right1 = mid;
        }
        int dist = min(n - k - right, left1 - (n - k - 1));
        change(right, right + dist, -1);
        change(left1 - dist + 1, left1 + 1, 1);
    }
    for (int i = 0; i < n; i++)
        cout << get(i) << ' ';
    cout << '\n';
}

