#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <random>
#include <ctime>
#include <chrono>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
#include <queue>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7;

vector<long long> calc_arr(vector<long long> v, long long m, long long k)
{
	long long n = v.size();
	vector<pair<long long, long long>> pr(n);
	for (long long i = 0; i < n; i++)
	{
		pr[i] = { v[i], -i };
	}
	for (long long _ = 0; _ < m; _++)
	{
		sort(pr.rbegin(), pr.rend());
		for (long long i = 0; i < k; i++)
		{
			pr[i].first--;
		}
	}
	for (long long i = 0; i < n; i++)
	{
		v[-pr[i].second] = pr[i].first;
	}
	return v;
}

long long get_f(vector<long long> v, long long m, long long k, long long x)
{
	vector<long long> res = calc_arr(v, m, k);
	sort(res.begin(), res.end());
	return res[x];
}

long long get_s(vector<long long> v, long long m, long long k, long long l, long long r)
{
	vector<long long> res = calc_arr(v, m, k);
	sort(res.begin(), res.end());
	long long ans = 0;
	for (long long i = l; i <= r; i++)
	{
		ans += res[i];
	}
	return ans;
}

void solve()
{
	long long n, m, k, q;
	cin >> n >> m >> k >> q;
	vector<long long> v(n);
	for (long long i = 0; i < n; i++)
	{
		cin >> v[i];
	}

	{
		vector<long long> qq = calc_arr(v, m, k);
		sort(qq.begin(), qq.end());
		for (long long i = 0; i < n; i++)
		{
			cout << qq[i] << " ";
		}
		cout << "\n";
	}

	while (q--)
	{
		long long qt;
		cin >> qt;
		if (qt == 1)
		{
			long long m, k, x;
			cin >> m >> k >> x;
			x--;
			cout << get_f(v, m, k, x) << "\n";
		}
		else if (qt == 2)
		{
			long long pos, val;
			cin >> pos >> val;
			pos--;
			v[pos] = val;
		}
		else
		{
			long long m, k, l, r;
			cin >> m >> k >> l >> r;
			l--; r--;
			cout << get_s(v, m, k, l, r) << "\n";
		}
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int t = 1;
	//cin >> t;
	while (t--)
	{
		solve();
	}

	return 0;
}

/*

























*/
