#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <random>
#include <ctime>
#include <chrono>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
#include <queue>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7;

vector<long long> calc_arr(vector<long long> v, long long m, long long k)
{
	if (!m)
	{
		return v;
	}
	long long n = v.size();
	sort(v.rbegin(), v.rend());
	vector<long long> psum(n + 1);
	for (long long i = 0; i < n; i++)
	{
		psum[i + 1] = psum[i] + v[i];
	}
	vector<long long> srt = v;
	sort(srt.begin(), srt.end());

	auto check = [&](long long mid) -> bool
	{
		long long idx = upper_bound(srt.begin(), srt.end(), mid) - srt.begin();
		long long len = n - idx;
		return psum[len] - mid * len <= m;
	};

	long long left = -2e9 - 10, right = v[0];
	while (right - left > 1)
	{
		long long mid = (left + right) / 2;
		if (check(mid))
		{
			right = mid;
		}
		else
		{
			left = mid;
		}
	}
	for (long long i = 0; i < n; i++)
	{
		if (v[i] > right)
		{
			m -= (v[i] - right);
			v[i] = right;
		}
	}
	for (long long i = 0; i < n; i++)
	{
		if (v[i] == right && m)
		{
			v[i]--;
			m--;
		}
	}
	return v;
}

long long get_f(vector<long long> v, long long m, long long k, long long x)
{
	vector<long long> res = calc_arr(v, m, k);
	sort(res.begin(), res.end());
	return res[x];
}

long long get_s(vector<long long> v, long long m, long long k, long long l, long long r)
{
	vector<long long> res = calc_arr(v, m, k);
	sort(res.begin(), res.end());
	long long ans = 0;
	for (long long i = l; i <= r; i++)
	{
		ans += res[i];
	}
	return ans;
}

void solve()
{
	long long n, m, k, q;
	cin >> n >> m >> k >> q;
	vector<long long> v(n);
	for (long long i = 0; i < n; i++)
	{
		cin >> v[i];
	}

	vector<long long> qq = calc_arr(v, m, k);
	sort(qq.begin(), qq.end());
	for (long long i = 0; i < n; i++)
	{
		cout << qq[i] << " ";
	}
	cout << "\n";

	while (q--)
	{
		long long qt;
		cin >> qt;
		long long m, k, x;
		cin >> m >> k >> x;
		x--;
		cout << qq[x] << "\n";
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int t = 1;
	//cin >> t;
	while (t--)
	{
		solve();
	}

	return 0;
}

/*

























*/
