#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>

using namespace std;
using namespace __gnu_pbds;
//-------------------------------------------//
#define int long long
//-------------------------------------------//
#pragma GCC optimize("O3")
//-------------------------------------------//
#define pii pair<int, int>
#define vector deque
#define ft first
#define sd second
#define fast                      \
    ios_base::sync_with_stdio(0); \
    cin.tie(0)
#define cout_float cout.setf(ios::fixed); cout.precision(20)
//-------------------------------------------//
typedef long long ll;
typedef long double ld;
typedef tree<int,
null_type,
less<int>,
rb_tree_tag,
tree_order_statistics_node_update> ordered_set;
//---------------------------------------------------------------------------------------//

struct Node {
    int value;
    int size;

    Node* left = nullptr;
    Node* right = nullptr;

    Node(int x): value(x), size(1) {}
};

int size(Node* N) {
    if (!N) return 0;
    return N->size;
}

void upd(Node* N) {
    N->size = size(N->left) + size(N->right);
}

Node* merge(Node* L, Node* R) {
    if (!L) return R;
    if (!R) return L;
    if (rand() % (L->size + R->size) < L->size) {
        L->right = merge(L->right, R);
        upd(L);
        return L;
    } else {
        R->left = merge(L, R->left);
        upd(R);
        return R;
    }
}

pair<Node*, Node*> splitV(Node* rt, int x) { //left - strictly less than x
    if (!rt) return {nullptr, nullptr};
    if (rt->value >= x) {
        pair<Node*, Node*> p = splitV(rt->left, x);
        rt->left = p.second;
        upd(rt);
        return {p.first, rt};
    } else {
        pair<Node*, Node*> p = splitV(rt->right, x);
        rt->right = p.first;
        upd(rt);
        return {rt, p.second};
    }
}

pair<Node*, Node*> splitI(Node* rt, int k) { //exactly k nodes in the left part
    if (!rt) return {nullptr, nullptr};
    if (size(rt->left) >= k) {
        pair<Node*, Node*> p = splitI(rt->left, k);
        rt->left = p.second;
        upd(rt);
        return {p.first, rt};
    } else {
        pair<Node*, Node*> p = splitI(rt->right, k - size(rt->left) - 1);
        rt->right = p.first;
        upd(rt);
        return {rt, p.second};
    }
}

//Node* root = nullptr;

//-----------------------------------------------------------------------------------------//

struct segtree {
    int size = 1;
    vector<int> tree;

    void init(int n) {
        while (size < n) size *= 2;
        tree.assign(2 * size - 1, 0);
    }

    void upd(int x, int lx, int rx) {
        if (rx - lx == 1) return;
        tree[x] = tree[2 * x + 1] + tree[2 * x + 2];
    }

    void build(vector<int> &a, int x, int lx, int rx) {
        if (rx - lx == 1) {
            if (lx < (int)a.size()) {
                tree[x] = a[lx];
            }
            return;
        }
        int mx = (lx + rx) / 2;
        build(a, 2 * x + 1, lx, mx);
        build(a, 2 * x + 2, mx, rx);
        upd(x, lx, rx);
    }

    void build(vector<int> &a) {
        init((int)a.size());
        build(a, 0, 0, size);
    }

    void set(int i, int v, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x] = v;
            return;
        }
        int mx = (lx + rx) / 2;
        if (i < mx) {
            set(i, v, 2 * x + 1, lx, mx);
        } else {
            set(i, v, 2 * x + 2, mx, rx);
        }
        upd(x, lx, rx);
    }

    void set(int i, int v) {
        set(i, v, 0, 0, size);
    }

    int get_sum(int l, int r, int x, int lx, int rx) {
        if (r <= lx || rx <= l) {
            return 0;
        }
        if (l <= lx && rx <= r) {
            return tree[x];
        }
        int mx = (lx + rx) / 2;
        int s1 = get_sum(l, r, 2 * x + 1, lx, mx);
        int s2 = get_sum(l, r, 2 * x + 2, mx, rx);
        return s1 + s2;
    }

    int get_sum(int l, int r) {
        return get_sum(l, r, 0, 0, size);
    }
};

//------------------------------------------------------------------//

struct node {
    int sum;

    node* left = nullptr;
    node* right = nullptr;

    node(int x): sum(x) {}
    node(): sum(0) {}
    node(node* L, node* R): sum(L->sum + R->sum), left(L), right(R) {}
};

int sz = 1;

void init(int n) {
    while (sz < n) sz *= 2;
}

node* build(vector<int> &a, int lx, int rx) {
    if (rx - lx == 1) {
        if (lx < (int)a.size()) {
            return new node(a[lx]);
        } else {
            return new node();
        }
    }
    int mx = (lx + rx) / 2;
    return new node(build(a, lx, mx), build(a, mx, rx));
}

node* build(vector<int> &a) {
    init((int)a.size());
    return build(a, 0, sz);
}

node* setT(int i, int v, int lx, int rx, node* cur) {
    if (rx - lx == 1) {
        return new node(v);
    }
    int mx = (lx + rx) / 2;
    if (i < mx) {
        return new node(setT(i, v, lx, mx, cur->left), cur->right);
    } else {
        return new node(cur->left, setT(i, v, mx, rx, cur->right));
    }
}

int get_sum(int l, int r, int lx, int rx, node* cur) {
    if (r <= lx || rx <= l) {
        return 0;
    }
    if (l <= lx && rx <= r) {
        return cur->sum;
    }
    int mx = (lx + rx) / 2;
    int s1 = get_sum(l, r, lx, mx, cur->left);
    int s2 = get_sum(l, r, mx, rx, cur->right);
    return s1 + s2;
}

//node* versions[q + 1];
//versions[0] = build(a);
//versions[i + 1] = setT(j, val, 0, sz, versions[i]);
//to get sum -> get_sum(l, r, 0, sz, versions[query]);

//-----------------------------------------------------------------------//

void get_op(vector<int> &a, int t) {
    int n = (int)a.size();
    int cur_max = a[0];
    int cur_pref = 1;
    int cur_time = t;
    while (cur_pref < n && a[cur_pref] == cur_max) ++cur_pref;
    while (cur_time > 0) {
        if (cur_pref == n) {
            int cycles = cur_time / n;
            int delta = cur_time % n;
            for (int i = 0; i < n - delta; ++i) {
                a[i] = cur_max - cycles;
            }
            for (int i = n - delta; i < n; ++i) {
                a[i] = cur_max - cycles - 1;
            }
            cur_time = 0;
            continue;
        }
        int dT = (cur_max - a[cur_pref]) * cur_pref;
        if (dT >= cur_time) {
            int cycles = cur_time / cur_pref;
            int delta = cur_time % cur_pref;
            for (int i = 0; i < cur_pref - delta; ++i) {
                a[i] = cur_max - cycles;
            }
            for (int i = cur_pref - delta; i < cur_pref; ++i) {
                a[i] = cur_max - cycles - 1;
            }
            cur_time = 0;
            continue;
        }
        cur_time -= dT;
        cur_max = a[cur_pref];
        ++cur_pref;
        while (cur_pref < n && a[cur_pref] == cur_max) ++cur_pref;
    }
}

signed main() {
    fast;
    int n, m, k, q;
    cin >> n >> m >> k >> q;
    vector<int> a(n);
    vector<int> acopy(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    sort(a.begin(), a.end());
    reverse(a.begin(), a.end());
    for (int i = 0; i < n; ++i) {
        acopy[i] = a[i];
    }
    acopy.pop_front();

    /*int cur_pref = 1;
    int cur_max = a[0];
    while (cur_pref < n && a[cur_pref] == cur_max) ++cur_pref;
    int cur_time = m;
    while (cur_time > 0) {
        if (cur_pref == n) {
            int cycles = cur_time / n;
            int delta = cur_time % n;
            for (int i = 0; i < n - delta; ++i) {
                a[i] = cur_max - cycles;
            }
            for (int i = n - delta; i < n; ++i) {
                a[i] = cur_max - cycles - 1;
            }
            cur_time = 0;
            continue;
        }
        int dT = (cur_max - a[cur_pref]) * cur_pref;
        if (dT >= cur_time) {
            int cycles = cur_time / cur_pref;
            int delta = cur_time % cur_pref;
            for (int i = 0; i < cur_pref - delta; ++i) {
                a[i] = cur_max - cycles;
            }
            for (int i = cur_pref - delta; i < cur_pref; ++i) {
                a[i] = cur_max - cycles - 1;
            }
            cur_time = 0;
            continue;
        }
        cur_time -= dT;
        cur_max = a[cur_pref];
        ++cur_pref;
        while (cur_pref < n && a[cur_pref] == cur_max) ++cur_pref;
    }
    reverse(a.begin(), a.end());
    for (int i = 0; i < n; ++i) {
        cout << a[i] << " ";
    }*/





    vector<int> times;
    vector<int> prefs;
    vector<int> starting_values;

    int cur_pref = 1;
    int cur_max = acopy[0];
    starting_values.push_back(acopy[0]);
    while (cur_pref < n && acopy[cur_pref] == cur_max) ++cur_pref;
    while (cur_pref < n) {
        int dT = (cur_max - acopy[cur_pref]) * cur_pref;
        times.push_back(dT);
        prefs.push_back(cur_pref);
        starting_values.push_back(acopy[cur_pref]);
        cur_max = acopy[cur_pref];
        ++cur_pref;
        while (cur_pref < n && acopy[cur_pref] == cur_max) ++cur_pref;
    }

    int StepCnt = (int)times.size();
    vector<int> prefsum(StepCnt + 1, 0);
    for (int i = 0; i < StepCnt; ++i) {
        prefsum[i + 1] = prefsum[i] + times[i];
    }
    prefs.push_back(n);


    if (n == 2) {
        cout << a[1] - m << " " << a[0] - m;
        return 0;
    }

    int L = -1, R = 1e9 + 100;


    while (R - L > 1) {
        int req_ans;
        int mq = (L + R) / 2;
        int x = 0;
        int full_steps = distance(prefsum.begin(), upper_bound(prefsum.begin(), prefsum.end(), mq)) - 1;
        int pref_len = prefs[full_steps];
        if (pref_len <= x) {
            req_ans = acopy[x];
        } else {
            int dT = mq - prefsum[full_steps];
            int cycles = dT / pref_len;
            int delta = dT % pref_len;
            int sV = starting_values[full_steps];
            if (pref_len - delta <= x) {
                req_ans = sV - cycles - 1;
            } else {
                req_ans =  sV - cycles;
            }
        }
        if (req_ans < a[0] - mq) {
            L = mq;
        } else {
            R = mq;
        }
    }
    //so, fast forward R steps...
    if (m < R) {
        --n;
        int cur_max = acopy[0];
        int cur_pref = 1;
        int cur_time = m;
        while (cur_pref < n && acopy[cur_pref] == cur_max) ++cur_pref;
        while (cur_time > 0) {
            if (cur_pref == n) {
                int cycles = cur_time / n;
                int delta = cur_time % n;
                for (int i = 0; i < n - delta; ++i) {
                    acopy[i] = cur_max - cycles;
                }
                for (int i = n - delta; i < n; ++i) {
                    acopy[i] = cur_max - cycles - 1;
                }
                cur_time = 0;
                continue;
            }
            int dT = (cur_max - acopy[cur_pref]) * cur_pref;
            if (dT >= cur_time) {
                int cycles = cur_time / cur_pref;
                int delta = cur_time % cur_pref;
                for (int i = 0; i < cur_pref - delta; ++i) {
                    acopy[i] = cur_max - cycles;
                }
                for (int i = cur_pref - delta; i < cur_pref; ++i) {
                    acopy[i] = cur_max - cycles - 1;
                }
                cur_time = 0;
                continue;
            }
            cur_time -= dT;
            cur_max = acopy[cur_pref];
            ++cur_pref;
            while (cur_pref < n && acopy[cur_pref] == cur_max) ++cur_pref;
        }
        ++n;
        cout << a[0] - m << " ";
        for (int i = 0; i < n - 1; ++i) {
            cout << acopy[i] << " ";
        }
        return 0;
    }
    --n;
    cur_max = acopy[0];
    cur_pref = 1;
    int cur_time = R;
    while (cur_pref < n && acopy[cur_pref] == cur_max) ++cur_pref;
    while (cur_time > 0) {
        if (cur_pref == n) {
            int cycles = cur_time / n;
            int delta = cur_time % n;
            for (int i = 0; i < n - delta; ++i) {
                acopy[i] = cur_max - cycles;
            }
            for (int i = n - delta; i < n; ++i) {
                acopy[i] = cur_max - cycles - 1;
            }
            cur_time = 0;
            continue;
        }
        int dT = (cur_max - acopy[cur_pref]) * cur_pref;
        if (dT >= cur_time) {
            int cycles = cur_time / cur_pref;
            int delta = cur_time % cur_pref;
            for (int i = 0; i < cur_pref - delta; ++i) {
                acopy[i] = cur_max - cycles;
            }
            for (int i = cur_pref - delta; i < cur_pref; ++i) {
                acopy[i] = cur_max - cycles - 1;
            }
            cur_time = 0;
            continue;
        }
        cur_time -= dT;
        cur_max = acopy[cur_pref];
        ++cur_pref;
        while (cur_pref < n && acopy[cur_pref] == cur_max) ++cur_pref;
    }
    ++n;
    acopy.push_front(a[0] - R);
    assert(acopy[1] == acopy[0]);

    int len2 = 2;
    int CM = acopy[0];
    while (len2 < n && CM == acopy[len2]) ++len2;
    int TIME = m - R;
    while (TIME > 0) {
        if (len2 == n) {
            //try to double-move
            int dCycles = TIME / n;
            int dT = TIME - n * dCycles;
            for (int i = 0; i < n; ++i) {
                acopy[i] = CM - 2 * dCycles;
            }
            if (dT * 2 <= n) {
                for (int i = n - 2 * dT; i < n; ++i) {
                    --acopy[i];
                }
            } else {
                for (int i = 0; i < n; ++i) {
                    --acopy[i];
                }
                for (int i = 2 * (n - dT); i < n; ++i) {
                    --acopy[i];
                }
            }
            TIME = 0;
            continue;
        }
        int double_cycles = (CM - a[len2]) / 2;
        int double_time = len2 * double_cycles;
        if (TIME < double_time) {
            int dCycles = TIME / len2;
            int dT = TIME - len2 * dCycles;
            for (int i = 0; i < len2; ++i) {
                acopy[i] = CM - 2 * dCycles;
            }
            if (dT * 2 <= len2) {
                for (int i = len2 - 2 * dT; i < len2; ++i) {
                    --acopy[i];
                }
            } else {
                for (int i = 0; i < len2; ++i) {
                    --acopy[i];
                }
                for (int i = 2 * (len2 - dT); i < n; ++i) {
                    --acopy[i];
                }
            }
            TIME = 0;
            continue;
        }
        CM -= 2 * double_cycles;
        TIME -= double_time;
        int single_time = len2 / 2;
        if (TIME <= single_time) {
            for (int i = 0; i < len2; ++i) {
                acopy[i] = CM;
            }
            for (int i = len2 - 2 * TIME; i < len2; ++i) {
                --acopy[i];
            }
            TIME = 0;
            continue;
        }
        CM = acopy[len2];
        int oneMore = (len2 % 2);
        ++len2;
        TIME -= single_time;
        while (len2 < n && acopy[len2] == CM) ++len2;
        if (oneMore) {
            --TIME;
            --acopy[len2 - 1];
            --len2;
            if (TIME == 0) {
                for (int i = 0; i < len2; ++i) {
                    acopy[i] = CM;
                }
            }
        }
    }
    reverse(acopy.begin(), acopy.end());
    for (int i = 0; i < n; ++i) {
        cout << acopy[i] << " ";
    }


    return 0;
}
