#include <iostream>
#include <vector>
#include <map>
#include <random>
#include <set>
#include <algorithm>
#include <assert.h>
using namespace std;

//#define int long long
#define ll long long
#define vi vector<int>
#define pi pair<int, int>
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define vpi vector<pi>
#define vvi vector<vi>

mt19937 mt;
int rnd(int mx) {
	int a = mt();
	return abs(a) % mx;
}

struct Node {
	Node* l = nullptr;
	Node* r = nullptr;
	int sz = 1;
	int x;
	int del = 0;
	int pr;
	Node(int x) : x(x), pr(rnd(1e9)) {

	}
	void upd() {
		sz = 1;
		if (l) sz += l->sz;
		if (r) sz += r->sz;
		if (del) push();
	}
	void push() {
		if (l) {
			l->x += del;
			l->del += del;
		}
		if (r) {
			r->x += del;
			r->x += del;
		}
		del = 0;
	}
};

Node* merge(Node* a, Node* b) {
	if (!a) return b;
	if (!b) return a;
	a->upd();
	b->upd();
	if (a->pr < b->pr) {
		a->r = merge(a->r, b);
		a->upd();
		return a;
	}
	else {
		b->l = merge(a, b->l);
		b->upd();
		return b;
	}
}

#define pn pair<Node*, Node*>
pn split(Node* a, int x) {
	if (!a) return { a, a };
	a->upd();
	if (!x) return { nullptr, a };
	if (a->sz <= x) return { a, nullptr };
	int szl = 0;
	if (a->l) szl = a->l->sz;
	if (x <= szl) {
		pn t = split(a->l, x);
		a->l = t.ss;
		a->upd();
		return { t.ff, a };
	}
	else {
		pn t = split(a->r, x - szl - 1);
		a->r = t.ff;
		a->upd();
		return { a, t.ss };
	}
}

pn splitx(Node* a, int x) {
	if (!a) return { nullptr, nullptr };
	a->upd();
	if (a->x <= x) {
		pn t = splitx(a->r, x);
		a->r = t.ff;
		a->upd();
		return { a, t.ss };
	}
	pn t = splitx(a->l, x);
	a->l = t.ss;
	a->upd();
	return { t.ff, a };
}

int getleft(Node* a) {
	if (!a->l) return a->x;
	return getleft(a->l);
}

vi ans;
void obh(Node* x) {
	x->upd();
	if (x->l) obh(x->l);
	ans.push_back(x->x);
	if (x->r) obh(x->r);
}

signed main() {

	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);


	int n, m, k, q;
	cin >> n >> m >> k >> q;
	vi vec(n);
	for (int i = 0; i < n; i++) {
		cin >> vec[i];
		vec[i] *= -1;
	}
	sort(all(vec));
	if (k == n) {
		for (int i = 0; i < n; i++) {
			vec[i] += m;
			vec[i] *= -1;
		}
		for (int el : vec) cout << el << ' ';
		return 0;
	}
	Node* dd = nullptr;
	for (int i = 0; i < n; i++) {
		dd = merge(dd, new Node(vec[i]));
	}
	while (m--) {
		pn a = split(dd, k);
		a.ff->del++;
		a.ff->x++;

		pn b = splitx(a.ss, getleft(a.ss));
		pn c = splitx(a.ff, b.ff->x);
		dd = merge(merge(c.ff, b.ff), merge(c.ss, b.ss));
	}
	obh(dd);
	reverse(all(ans));
	for (int el : ans) cout << -el << ' ';
}
