#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll MINC = -2'000'000'001, MAXC = 1'000'000'001;

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

struct BIT {
	vector<ll> tree;
	BIT(ll n) {
		tree.resize(n + 1, 0);
	}
	void add(ll x, ll y) {
		x++;
		for (; x < tree.size(); x += x & -x) {
			tree[x] += y;
		}
	}
	ll get(ll x) {
		ll ans = 0;
		for (; x > 0; x -= x & -x) {
			ans += tree[x];
		}
		return ans;
	}
	ll get(ll l, ll r) {
		return get(r) - get(l);
	}
};

void solve() {
	ll n, m0, k0, q;
	cin >> n >> m0 >> k0 >> q;
	vector<ll> arr(n);
	for (ll i = 0; i < n; i++) {
		cin >> arr[i];
	}
	vector<ll> sa = arr;
	sort(sa.begin(), sa.end());
	vector<ll> psa(1, 0);
	for (ll i = 0; i < n; i++) {
		psa.push_back(psa.back() + sa[i]);
	}
	ll sc = m0 * k0;
	ll l = MINC, r = MAXC;
	while (r - l > 1) {
		ll mid = (l + r) / 2;
		ll colbm = sa.end() - lower_bound(sa.begin(), sa.end(), mid + m0);
		ll colgood = sa.end() - lower_bound(sa.begin(), sa.end(), mid);
		if (psa[n - colbm] - psa[n - colgood] - mid * (colgood - colbm) + colbm * m0 > sc) {
			l = mid;
		} else {
			r = mid;
		}
	}
	ll colbm = sa.end() - lower_bound(sa.begin(), sa.end(), r + m0);
	ll colgood = sa.end() - lower_bound(sa.begin(), sa.end(), r);
	ll ost = sc - (psa[n - colbm] - psa[n - colgood] - r * (colgood - colbm) + colbm * m0);
	ll num = 0;
	for (ll i = 0; i < n; i++) {
		if (sa[i] < r) {
			cout << sa[i] << ' ';
		} else {
			if (num < ost) {
				cout << max(r - 1, sa[i] - m0) << ' ';
			} else {
				cout << max(r, sa[i] - m0) << ' ';
			}
			num++;
		}
	}
	cout << '\n';
	vector<ll> ae;
	for (auto i : arr) {
		ae.push_back(i);
	}
	vector<tuple<ll, ll, ll, ll, ll>> qs;
	for (ll i = 0; i < q; i++) {
		ll t;
		cin >> t;
		if (t == 1) {
			ll x, m, k;
			cin >> m >> k >> x;
			qs.emplace_back(t, m, k, x, 0);
		}
		if (t == 2) {
			ll p, v;
			cin >> p >> v;
			ae.push_back(p);
			qs.emplace_back(t, p, v, 0, 0);
		}
		if (t == 3) {
			ll l, r, m, k;
			cin >> m >> k >> l >> r;
			qs.emplace_back(t, m, k, l, r);
		}
	}
	sort(ae.begin(), ae.end());
	ae.resize(unique(ae.begin(), ae.end()) - ae.begin());
	BIT b(ae.size()), bs(ae.size());
	for (auto& i : arr) {
		i = lower_bound(ae.begin(), ae.end(), i) - ae.begin();
		b.add(i, 1);
		bs.add(i, ae[i]);
	}
	for (ll i = 0; i < q; i++) {
		auto[t, na, nb, nc, nd] = qs[i];
		if (t == 1) {
			ll x = nc;
			m0 = na;
			k0 = nb;
			x--;
			ll sc = m0 * k0;
			ll l = MINC, r = MAXC;
			ll lcolgood, lost, lcolbm;
			while (r - l > 1) {
				ll mid = (l + r) / 2;
				ll zm = lower_bound(ae.begin(), ae.end(), mid) - ae.begin();
				ll zmp = lower_bound(ae.begin(), ae.end(), mid + m0) - ae.begin();
				ll c1 = b.get(zm);
				ll c2 = b.get(zmp);
				ll s1 = bs.get(zm);
				ll s2 = bs.get(zmp);
				ll colbm = n - c2;
				ll colgood = n - c1;
				if (s2 - s1 - mid * (colgood - colbm) + colbm * m0 > sc) {
					l = mid;
				} else {
					lcolgood = colgood;
					lcolbm = colbm;
					lost = sc - (s2 - s1 - mid * (colgood - colbm) + colbm * m0);
					r = mid;
				}
			}
			ll si = n - lcolgood, sim = n - lcolbm;
			if (x < si) {
				ll l = MINC, r = MAXC;
				while (r - l > 1) {
					ll mid = (l + r) / 2;
					if (b.get(upper_bound(ae.begin(), ae.end(), mid) - ae.begin()) > x) {
						r = mid;
					} else {
						l = mid;
					}
				}
				cout << r << '\n';
				continue;
			}
			if (x >= sim) {
				ll l = MINC, r = MAXC;
				while (r - l > 1) {
					ll mid = (l + r) / 2;
					if (b.get(upper_bound(ae.begin(), ae.end(), mid) - ae.begin()) > x) {
						r = mid;
					} else {
						l = mid;
					}
				}
				cout << r - m0 << '\n';
				continue;
			}
			ll num = x - (n - lcolgood);
			if (num < lost) {
				cout << r - 1 << '\n';
			} else {
				cout << r << '\n';
			}
		}
		if (t == 2) {
			ll p = na, v = nb;
			p--;
			v = lower_bound(ae.begin(), ae.end(), v) - ae.begin();
			b.add(arr[p], -1);
			bs.add(arr[p], -ae[arr[p]]);
			arr[p] = v;
			b.add(arr[p], 1);
			bs.add(arr[p], ae[arr[p]]);
		}
		if (t == 3) {
			m0 = na;
			k0 = nb;
			ll nl = nc, nr = nd;
			nl--;
			ll sc = m0 * k0;
			ll l = MINC, r = MAXC;
			ll lcolgood, lost, lcolbm;
			while (r - l > 1) {
				ll mid = (l + r) / 2;
				ll zm = lower_bound(ae.begin(), ae.end(), mid) - ae.begin();
				ll zmp = lower_bound(ae.begin(), ae.end(), mid + m0) - ae.begin();
				ll c1 = b.get(zm);
				ll c2 = b.get(zmp);
				ll s1 = bs.get(zm);
				ll s2 = bs.get(zmp);
				ll colbm = n - c1 - c2;
				ll colgood = n - c1;
				if (s2 - s1 - mid * (colgood - colbm) + colbm * m0 > sc) {
					l = mid;
				} else {
					lcolgood = colgood;
					lcolbm = colbm;
					lost = sc - (s2 - s1 - mid * (colgood - colbm) + colbm * m0);
					r = mid;
				}
			}
			ll ans = 0;
			ll si = n - colgood, sim = n - colbm;
			ll tm1 = si + ost;
			//ans += psa[min(nr, si)] - psa[min(nl, si)];
			//ans += psa[max(nr, sim)] - psa[max(nl, sim)] - (max(nr, sim) - max(nl, sim)) * m0;
			ans += (min(max(nr, si), tm1) - min(max(nl, si), tm1)) * (r - 1);
			ans += (min(max(nr, tm1), sim) - min(max(nl, tm1), sim)) * r;
			cout << ans << '\n';
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
