// 4.cpp : This file contains the 'main' function. Program execution begins and ends there.
//
#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <algorithm>
#include <immintrin.h>
#include <set>
#include <map>
#include <numeric>
#include <queue>
#include <cstring>

using ll = long long;
using ld = long double;
using namespace std;

const int MAXN = (1 << 18);
ll upd[MAXN * 2 - 1];

void push(int v, int l, int r)
{
    if (r - l == 1)
        return;
    if (upd[v])
    {
        upd[2 * v + 1] += upd[v];
        upd[2 * v + 2] += upd[v];
        upd[v] = 0;
    }
}

int ql, qr;
void update(int v, int l, int r)
{
    if (qr <= l || ql >= r)
        return;
    if (ql <= l && r <= qr)
    {
        upd[v]--;
        push(v, l, r);
        return;
    }
    push(v, l, r);
    update(2 * v + 1, l, (l + r) >> 1);
    update(2 * v + 2, (l + r) >> 1, r);
}

void commit(int v, int l, int r)
{
    push(v, l, r);
    if (r - l == 1)
        return;
    commit(2 * v + 1, l, (l + r) >> 1);
    commit(2 * v + 2, (l + r) >> 1, r);
}

void confirm(int v, int l, int r)
{
    if (qr <= l || ql >= r)
        return;
    if (r - l == 1)
        return;
    push(v, l, r);
    confirm(2 * v + 1, l, (l + r) >> 1);
    confirm(2 * v + 2, (l + r) >> 1, r);
}

ll get_elem(int id)
{
    ql = id;
    qr = id + 1;
    confirm(0, 0, MAXN);
    return upd[ql + MAXN - 1];
}

void sub_segment(int l, int r)
{
    ql = l;
    qr = r;
    update(0, 0, MAXN);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n, m0, k0, q;
    cin >> n >> m0 >> k0 >> q;
    if (q != 0)
        return -1;
    if (m0 > 1e6)
        return -1;
    memset(upd, 0, sizeof(upd));
    for (size_t i = 0; i < n; i++)
    {
        cin >> upd[i + MAXN - 1];
    }
    sort(upd + MAXN - 1, upd + n + MAXN - 1);
    for (size_t i = 0; i < m0; i++)
    {
        // find with binary search element equal to a[k0 - 1]
        int j = n - k0;
        ll val = get_elem(j);
        int ql = 0, qr = j;
        while (qr - ql > 1)
        {
            int qm = (ql + qr) >> 1;
            if (get_elem(qm) == val)
                qr = qm;
            else
                ql = qm;
        }
        int fs = qr;
        ql = j;
        qr = n;
        while (qr - ql > 1)
        {
            int qm = (ql + qr) >> 1;
            if (get_elem(qm) > val)
                qr = qm;
            else
                ql = qm;
        }
        int szup = n - qr;
        sub_segment(fs, fs + k0 - szup);
        sub_segment(n - szup, n);
        commit(0, 0, MAXN);
        //sort(upd + MAXN - 1, upd + n + MAXN - 1);
        /*commit(0, 0, MAXN);
        for (size_t i = 0; i < n; i++)
        {
            cout << upd[i + MAXN - 1] << ' ';
        }
        cout << '\n';*/
    }
    commit(0, 0, MAXN);
    for (size_t i = 0; i < n; i++)
    {
        cout << upd[i + MAXN - 1] << ' ';
    }
    return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
