#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <random>
#include <queue>

using namespace std;
using ll = long long;
using ld = long double;
mt19937 rd(3231213214);
const ll INF = 1e18;

ll get_val(int i, int n, vector<ll>& a, vector<ll>& p, ll m, int k) {
	ll l = a[i] - m - 1, r = a[i];
	while (r - l > 1) {
		ll mid = (l + r) / 2;

		int ind1 = lower_bound(a.begin(), a.begin() + i, mid) - a.begin();
		int ind2 = upper_bound(a.begin() + i, a.end(), m + mid + 1) - a.begin();

		if (n - ind2 + 1 >= k) {
			l = mid;
			continue;
		}
		ll sum = (p[i] - p[ind1 - 1]) - mid * (i - ind1 + 1);
		sum += m * (n - ind2 + 1);
		sum += (p[ind2 - 1] - p[i]) - (mid + 1) * (ind2 - i - 1);

		if (sum <= m * k)
			r = mid;
		else
			l = mid;
	}
	return r;
}

void solve() {
	int n, m0, k0, t;
	cin >> n >> m0 >> k0 >> t;
	vector<ll> a(n + 1, -INF);
	vector<ll> p(n + 1, 0);
	vector<pair<ll, int>> vec(n);
	for (int i = 1; i <= n; i++)
		cin >> a[i];
	sort(a.begin(), a.end());
	for (int i = 1; i <= n; i++)
		p[i] = a[i] + p[i - 1];
	
	vector<ll> ans;
	for (int i = 0; i < t; i++) {
		int ty;
		cin >> ty;
		if (ty == 1) {
			int m1, k1, x1;
			cin >> m1 >> k1 >> x1;
			ans.push_back(get_val(x1, n, a, p, m1, k1));
		}
	}

	vector<ll> b(n + 1);
	for (int i = 1; i <= n; i++)
		b[i] = get_val(i, n, a, p, m0, k0);
	for (int i = 1; i <= n; i++)
		cout << b[i] << ' ';
	cout << '\n';
	for (auto x : ans)
		cout << x << '\n';

	return;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	solve();
}