// #pragma GCC optimize("Ofast,fast-math,unroll-loops,no-stack-protector,inline")
#include <bits/stdc++.h>

using namespace std;

#define int long long

const int mx = 1e10;
const int MXL = 1e7;
int bl1, bl2;

struct node {
    node *l, *r;
    int num = 0, sm = 0;
};

node mem[MXL];
node *npos = mem;

void merge(node *&v) {
    v->num = 0;
    v->sm = 0;
    if (v->l != nullptr) {
        v->sm += v->l->sm;
        v->num += v->num + v->l->num;
    }
    if (v->r != nullptr) {
        v->sm += v->r->sm;
        v->num += v->r->num;
    }
}

void update(node *&v, int l, int r, int ql, int qr, int cur) {
    if (r <= ql || qr <= l) {
        return;
    } else {
        if (v == nullptr) {
            v = npos++;
        }
        if (ql <= l && r <= qr) {
            v->num += cur;
            v->sm += cur * ql;
        } else {
            int m = (r + l) / 2;
            update(v->l, l, m, ql, qr, cur);
            update(v->r, m, r, ql, qr, cur);
            merge(v);
        }
    }
}

void get(node *&v, int l, int r, int ql, int qr) {
    if (v == nullptr) return;
    if (r <= ql || qr <= l) {
        return;
    } else if (ql <= l && r <= qr) {
        bl1 += v->num;
        bl2 += v->sm;
    } else {
        int m = (r + l) / 2;
        get(v->l, l, m, ql, qr);
        get(v->r, m, r, ql, qr);
    }
}

void get1(node *&v, int l, int r, int cur) {
    int m = (r + l) / 2;
    if (r - l == 1) {
        bl1 = l;
        return;
    }
    bool fl = 1;
    if (v->l != nullptr) {
        if (v->l->num >= cur) {
            fl = 0;
            get1(v->l, l, m, cur);
        } else {
            cur -= v->l->num;
        }
    }
    if (fl) {
        get1(v->r, m, r, cur);
    }
} 

signed main() {
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    freopen("input.txt", "r", stdin);
    int n, m, k, q;
    cin >> n >> m >> k >> q;
    vector<int> arr(n);
    node *root = npos++;
    for (int i = 0; i < n; i++) {
        cin >> arr[i];
        update(root, -mx, mx, arr[i], arr[i] + 1, 1);
    }
    vector<int> arr1 = arr;
    sort(arr.begin(), arr.end());
    int l = -mx, r = mx;
    while (r - l > 1) {
        int m1 = (r + l) / 2;
        bl1 = 0;
        bl2 = 0;
        get(root, -mx, mx, m1, mx);
        int sm = bl2;
        int cur = sm - m1 * bl1;
        if (cur > m) {
            l = m1;
        } else {
            r = m1;
        }
    }
    bl1 = 0;
    bl2 = 0;
    get(root, -mx, mx, r, mx);
    int sm = bl2;
    int cur = sm - r * bl1;
    int cur_ind = n - bl1;
    for (int i = cur_ind; i < n; i++) {
        arr[i] = r;
    }
    int ost = m - (sm - r * (n - cur_ind));
    for (int i = cur_ind; i < cur_ind + ost; i++) {
        arr[i]--;
    }
    for (int i = 0; i < n; i++) {
        cout << arr[i] << ' ';
    }
    arr = arr1;
    sort(arr.begin(), arr.end());
    cout << endl;
    for (int t = 0; t < q; t++) {
        l = -mx;
        r = mx;
        int a, x;
        cin >> a;
        if (a == 1) {
            cin >> m >> k >> x;
            x--;
            while (r - l > 1) {
                int m1 = (r + l) / 2;
                bl1 = 0;
                bl2 = 0;
                get(root, -mx, mx, m1, mx);
                int sm = bl2;
                int cur = sm - m1 * bl1;
                if (cur > m) {
                    l = m1;
                } else {
                    r = m1;
                }
            }
            bl1 = 0;
            bl2 = 0;
            get(root, -mx, mx, r, mx);
            cur_ind = n - bl1;
            sm = bl2;
            ost = m - (sm - r * (n - cur_ind));
            int cur_ind1 = cur_ind + ost;
            if (x < cur_ind) {
                get1(root, -mx, mx, x + 1);
                cout << bl1 << endl;
            } else if (cur_ind <= x && x < cur_ind1) {
                cout << r - 1 << endl;
            } else {
                cout << r << endl;
            }
        } else {
            int b;
            cin >> a >> b;
            a--;
            update(root, -mx, mx, arr1[a], arr1[a] + 1, -1);
            arr1[a] = b;
            update(root, -mx, mx, arr1[a], arr1[a] + 1, 1);
        }
    }
}