#include <bits/stdc++.h>
#define ln << '\n'
#define int long long
using namespace std;

const int N = 5e5 + 22;
int n, m, k, q, a[N];

struct tree {
    tree *L = NULL, *R = NULL;
    int l, r, md;
    int lvl = 0, rvl = 0, otr_push = 0;

    tree(int l, int r) : l(l), r(r), md((l + r) / 2) {
        if (l == r) {
            lvl = rvl = a[l];
        } else {
            L = new tree(l, md);
            R = new tree(md + 1, r);
            lvl = L -> lvl;
            rvl = R -> rvl;
        }
    }

    void push() {
        if (otr_push != 0) {
            if (L != NULL) L -> otr_push += otr_push;
            if (R != NULL) R -> otr_push += otr_push;
            lvl += otr_push;
            rvl += otr_push;
            otr_push = 0;
        }
    }

    int get(int ps) {
        push();
        if (l == r) return lvl;
        return (ps <= md ? L : R) -> get(ps);
    }

    void add(int _l, int _r, int x) {
        push();
        if (_l > _r || (_l < l && _r < l) || (_l > r && _r > r)) return;
        if (_l <= l && r <= _r) {
            otr_push += x;
            push();
            return;
        }

        L -> add(_l, _r, x);
        R -> add(_l, _r, x);
        lvl = L -> lvl;
        rvl = R -> rvl;
    }

    int find_leftest_ps(int x) {
        push();
        if (l == r) return l;
        return (L -> rvl >= x ? L : R) -> find_leftest_ps(x);
    }

    int find_rightest_ps(int x) {
        push();
        if (l == r) return l;
        return (R -> lvl <= x ? R : L) -> find_rightest_ps(x);
    }
};

struct treez {
    int get(int ps) {
        return a[ps];
    }

    void add(int _l, int _r, int x) {
        for (int i = _l; i <= _r; i++) a[i] += x;
    }

    int find_leftest_ps(int x) {
        for (int i = 1; i <= n; i++)
            if (a[i] == x)
                return i;
    }

    int find_rightest_ps(int x) {
        for (int i = n; i >= 1; i--)
            if (a[i] == x)
                return i;
    }
};

int32_t main() {
    srand(time(0));
    cin.tie(0); cout.tie(0); ios::sync_with_stdio(0);
    cin >> n >> m >> k >> q;
    for (int i = 1; i <= n; i++) cin >> a[i];
    // for (int i = 1; i <= n; i++) a[i] = rand() % 10000 - 500;
    sort(a + 1, a + n + 1);
    tree t(1, n);
    treez tz;
    for (int i = 1; i <= m; i++) {
        int L = n - k + 1;
        int R = n;

        int first_block = t.get(L); if (tz.get(L) != first_block) assert(0);
        int l = t.find_leftest_ps(first_block); if (tz.find_leftest_ps(first_block) != l) assert(0);
        int r = t.find_rightest_ps(first_block); if (tz.find_rightest_ps(first_block) != r) assert(0);

        int intersection = r - L + 1;
        t.add(L + intersection, R, -1);
        t.add(l, l + intersection - 1, -1);

        tz.add(L + intersection, R, -1);
        tz.add(l, l + intersection - 1, -1);
    }
    for (int i = 1; i <= n; i++) cout << t.get(i) << ' ';
    return 0;
}

/*
*/