#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <bitset>
#include <unordered_map>
#include <random>

#define all(v) v.begin(), v.end()
#define len(v) (int)v.size()
#define coutd cout << fixed << setprecision(20)

using namespace std;
using ll = long long;
using ld = long double;

const ll IINF = 2e9;

int main()
{
    cin.tie(0)->sync_with_stdio(0);
    int n, m, k, q;
    cin >> n >> m >> k >> q;
    vector<ll> a(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i];
    }
    sort(all(a));
    vector<ll> suff(n + 1, 0);
    for (int i = n - 1; i >= 0; --i)
    {
        suff[i] = suff[i + 1] + a[i];
    }
    ll l = -IINF, r = IINF;
    while (r - l > 1)
    {
        ll mid = (l + r) / 2;
        ll sum = 0;
        int j = lower_bound(all(a), mid) - a.begin();
        sum = suff[j] - mid * (n - j);
        if (sum > m)
        {
            l = mid;
        } else
        {
            r = mid;
        }
    }
    ll sum = 0;
    int j = lower_bound(all(a), r) - a.begin();
    sum = suff[j] - r * (n - j);
    int cntr = m - sum;
    for (ll x : a)
    {
        if (x < r)
        {
            cout << x << ' ';
        } else
        {
            if (cntr > 0)
            {
                cout << r - 1 << ' ';
                --cntr;
            } else
            {
                cout << r << ' ';
            }
        }
    }
    for (int i = 0; i < q; ++i)
    {
        int t;
        cin >> t;
        if (t == 1)
        {
            int m, k, ind;
            cin >> m >> k >> ind;
            --ind;
            ll l = -IINF, r = IINF;
            while (r - l > 1)
            {
                ll mid = (l + r) / 2;
                ll sum = 0;
                int j = lower_bound(all(a), mid) - a.begin();
                sum = suff[j] - mid * (n - j);
                if (sum > m)
                {
                    l = mid;
                } else
                {
                    r = mid;
                }
            }
            ll sum = 0;
            int j = lower_bound(all(a), r) - a.begin();
            sum = suff[j] - r * (n - j);
            int cntr = m - sum;
            if (a[ind] < r)
            {
                cout << a[ind] << '\n';
                continue;
            }
            if (j + cntr - 1 < ind)
            {
                cout << r << '\n';
            } else
            {
                cout << r - 1 << '\n';
            }
        }
    }

    return 0;
}
