#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <math.h>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>

using namespace std;
using ll = long long;
using ld = long double;
#define all(x) x.begin(),x.end()
//#pragma GCC optimize("Ofast")
const ll INF = 1e18 + 7;
template<typename T>
void input(vector<T>& arr, size_t size) {
	arr.resize(size);
	for (T& i : arr) {
		cin >> i;
	}
}
template<typename T>
void print(vector<T>& arr) {
	for (T& i : arr) {
		cout << i << ' ';
	}
	cout << '\n';
}
#define int long long
vector<ll> a, tr, p, mx;
void push(ll sz, int v) {
	tr[v] += p[v] * sz;
	mx[v] += p[v];
	if(sz > 1){
		p[(v << 1) + 1] += p[v];
		p[(v << 1) + 2] += p[v];
	}
	p[v] = 0;
}
void build(int l, int r, int v) {
	if (r - l == 1) {
		tr[v] = a[l];
		mx[v] = a[l];
		return;
	}
	int m = (r + l) >> 1;
	build(l, m, (v << 1) + 1);
	build(m, r, (v << 1) + 2);
	tr[v] = tr[(v << 1) + 1] + tr[(v << 1) + 2];
	mx[v] = max(mx[(v << 1) + 1], mx[(v << 1) + 2]);
}
void upd(int l, int r, int ql, int qr, ll val, int v) {
		push(r - l,v);
	if (ql >= r or l >= qr) {
		return;
	}
	if (ql <= l and r <= qr) {
		p[v] += val;
		push(r - l,v);
		return;
	}
	int m = (r + l) >> 1;
	upd(l, m, ql, qr, val, (v << 1) + 1);
	upd(m, r, ql, qr, val, (v << 1) + 2);
	tr[v] = tr[(v << 1) + 1] + tr[(v << 1) + 2];
	mx[v] = max(mx[(v << 1) + 1], mx[(v << 1) + 2]);
}
ll get(int l, int r, int ql, int qr, int v) {
	push(r - l, v);
	if (ql >= r or l >= qr) {
		return 0;
	}
	if (ql <= l and r <= qr) {
		return tr[v];
	}
	int m = (r + l) >> 1;
	return get(l, m, ql, qr, (v << 1) + 1) + get(m, r, ql, qr, (v << 1) + 2);
}
ll max(int l, int r, int ql, int qr, int v) {
	push(r - l, v);
	if (ql >= r or l >= qr) {
		return -INF;
	}
	if (ql <= l and r <= qr) {
		return mx[v];
	}
	int m = (r + l) >> 1;
	return max(max(l, m, ql, qr, (v << 1) + 1), max(m, r, ql, qr, (v << 1) + 2));
}
int spus(int l, int r, int ql, int qr,ll val, int v) {
	push(r - l, v);
	if (r - l == 1) {
		return l;
	}
	int m = (r + l) >> 1, t = max(l,m,ql,qr,(v << 1) + 1);
	if (t == val) {
		return spus(l, m, ql, qr,val, (v << 1) + 1);
	}
	else {
		return spus(m, r, ql, qr,val, (v << 1) + 2);
	}
}

void make(ll c, ll l, ll r, ll n, ll t){
	ll sz = (r - l + 1);
	upd(0, n, r + 1, n, -c, 0);
	upd(0, n, l, r + 1, -((c * t) / sz), 0);
	ll val = get(0, n, r, r + 1, 0);
	int lef = spus(0, n, l, r + 1, val, 0);
	ll sum = ((c * t) % sz);
	if (r - lef + 1 >= sum) {
		upd(0, n, lef, lef + sum, -1, 0);
	}
	else {
		upd(0, n, lef, r + 1, -1, 0);
		upd(0, n, l, l + sum - (r + 1 - lef), -1, 0);
	}
}

void dot(int n) {
#ifdef _DEBUG
	for (size_t i = 0; i < n; i++)
	{
		cout << get(0, n, i, i + 1, 0) << ' ';
	}
#endif // _DEBUG
}

void solve() {
	ll n, m, k, q;
	cin >> n >> m >> k >> q;
	input(a, n);
	tr.resize(n * 4,0);
	p.resize(n * 4,0);
	mx.resize(n * 4,0);
	
	sort(all(a));
	build(0, n, 0);
	ll l = n - k, r = n - k, t = 1;
	while (m > 0 and (l > 0 or r < n - 1))
	{
		ll tm1 = INF, tm2 = INF;
		if (l > 0) {
			ll s = get(0, n, l, r + 1, 0) - (a[l - 1] + 1) * (r - l + 1);
			if (s <= 0) {
				tm1 = 0;
			}
			else {
				tm1 = (s + t - 1) / t;
			}
		}
		if (r < n - 1) {
			ll vt = get(0, n, r + 1, r + 2, 0);
			ll s = (vt - 1) * (r - l + 1) - get(0, n, l, r + 1, 0);
			if (s <= 0) {
				tm2 = 0;
			}
			else {
				ll kol = (r - l + 1) - t;
				tm2 = (s + kol - 1) / kol;
			}
		}
		if (min(tm1, tm2) >= m) {
			break;
		}
		if (tm1 <= tm2) {
			m -= tm1;
			if (tm1 > 0) {
				make(tm1, l, r, n, t);
			}
			--l;
		}
		else {
			m -= tm2;
			if (tm2 > 0) {
			make(tm2, l, r, n, t);
			}
			++r;
			++t;
		}
#ifdef _DEBUG
		cout << l << ' ' << r << " : " ;
		for (size_t i = 0; i < n; i++)
		{
			cout << get(0, n, i, i + 1, 0) << ' ';
		}
		cout << "\n";
#endif // _DEBUG

	}
	if (m > 0) {
		make(m, l, r, n, t);
	}
	for (size_t i = 0; i < n; i++)
	{
		cout << get(0, n, i, i + 1, 0) << ' ';
	}
}

int main() {
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
#endif // _DEBUG
	ios::sync_with_stdio(0);
	cin.tie(0);
	int tt = 1;
#ifdef _DEBUG
	cin >> tt;
#endif // _DEBUG
	while (tt--)
	{
		solve();
#ifdef _DEBUG
		cout << "\n================\n";
#endif // _DEBUG
	}
}