#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>
using namespace std;
using ll = long long int;
using ull = unsigned long long int;

#define all(x) (x).begin(), (x).end()
#define rall(X) (x).rbegin(), (x).rend()

struct BIT
{
    vector<ll> tree;
    
    BIT(int n): tree(n + 1) {}

    void upd(int i, ll x)
    {
        ++i;
        while (i < tree.size())
        {
            tree[i] += x;
            i += i & -i;
        }
    }

    ll sum(int r)
    {
        ll ans = 0;
        while (r > 0)
        {
            ans += tree[r];
            r -= r & -r;
        }
        return ans;
    }

    ll sum(int l, int r)
    {
        return sum(r) - sum(l);
    }
};

void solve()
{
    int n, m0, k0, q;
    cin >> n >> m0 >> k0 >> q;

    vector<ll> a(n);
    vector<ll> keys(n);
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
        keys[i] = a[i];
    }
    vector<array<int, 3>> qs(n + q);
    for (int i = 0; i< n; i++)
        qs[i] = {1, m0, i + 1};
    for (int i = 0; i < q; i++)
    {
        int t;
        cin >> t;

        if (t == 1)
        {
            int m, k, x;
            cin >> m >> k >> x;
            qs[n + i] = {1, m, x};
        }
        else
        {
            int p, v;
            cin >> p >> v;
            --p;
            keys.push_back(v);
        }
    }

    sort(all(keys));
    keys.erase(unique(all(keys)), keys.end());
    for (int i = 0; i < n; i++)
        a[i] = lower_bound(all(keys), a[i]) - keys.begin();

    vector<int> ans(n + q);
    BIT sum(keys.size());
    BIT cnt(keys.size());

    for (int i = 0; i < n; i++)
    {
        cnt.upd(a[i], 1);
        sum.upd(a[i], keys[a[i]]);
    }
    for (int it = 0; it < n + q; it++)
    {
        if (qs[it][0] == 1)
        {
            int m = qs[it][1];
            int x = qs[it][2];
            ll l = -1e10;
            ll r = 1e10;

            while (r - l > 1)
            {
                ll mid = (l + r) / 2;
        
                int i = upper_bound(all(keys), mid) - keys.begin();
                int cnt1 = cnt.sum(i);
                ll d = max(0ll, m - (sum.sum(i, keys.size()) - (mid + 1) * (n - cnt1)));
                cnt1 += min(d, (ll)n - cnt1);

                if (cnt1 >= x)
                    r = mid;
                else
                    l = mid;
            }
            ans[it] = r;
        }
        else
        {
            int p = qs[it][1];
            int v = qs[it][2];
            v = lower_bound(all(keys), v) - keys.begin();

            cnt.upd(v, 1);
            sum.upd(v, keys[v]);
            cnt.upd(a[p], -1);
            sum.upd(a[p], -keys[a[p]]);
            a[p] = v;
        }
    }

    for (int i = 0; i < n; i++)
        cout << ans[i] << ' ';
    cout << '\n';
    for (int i = n; i < n + q; i++)
        cout << ans[i] << '\n';
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
#ifdef LOCAL
    freopen("C:/work/Day 2/in.txt", "r", stdin);
    freopen("C:/work/Day 2/out.txt", "w", stdout);
    cin >> t;
#else
    t = 1;
#endif

    while (t--)
        solve();
    return 0;
}
