#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <random>
#include <chrono>
#include <time.h>

//#pragma GCC optimize("O3")

#define out(x) std::cout << x << ' ';
#define oute(x) std::cout << x << '\n';
#define enter std::cout << '\n';
#define all(x) x.begin(), x.end()
using ll = long long;

std::mt19937 rng(std::chrono::steady_clock::now().time_since_epoch().count());

std::vector<ll> correct(ll n, ll m, ll k, std::vector<ll> a) {
    while (m--) {
        std::sort(all(a));
        for (ll i = n - 1; i > n - 1 - k; i--) a[i]--;
    }
    std::sort(all(a));
    return a;
}

std::vector<ll> wrong(ll n, ll m, ll k, std::vector<ll> a) {
    ll l = -1e12, r = 1e12, p = m * k;
    while (r - l > 1) {
        ll mid = (l + r) >> 1;
        ll sum = 0;
        for (ll i = 0; i < n; i++) {
            sum += std::max(0ll, a[i] - mid);
        }
        if (sum < p) r = mid; else l = mid;
    }
    ll mid = l;
    ll sum = 0;
    for (ll i = 0; i < n; i++) {
        sum += std::max(0ll, a[i] - mid);
    }
    p = sum - p;
    for (ll& i : a) i = std::min(i, l);
    while (p > 0) {
        for (ll i = 0; i < n && p > 0; i++, p--) if (a[i] >= l) a[i]++;
    }
    std::sort(all(a));
    return a;
}

bool generator() {
    ll mod1 = 3, mod2 = 4;
    ll n = rng() % mod1 + 1, m = rng() % mod2, k = rng() % n + 1;
    std::vector<ll> a(n);
    for (ll i = 0; i < n; i++) a[i] = (rng() % mod1) * std::pow(-1, rng() % 2);
    auto wr = wrong(n, m, k, a), cor = correct(n, m, k, a);
    if (wr != cor) {
        out(n) out(m) oute(k);
        std::cout << "a : ";
        for (ll i : a) out(i)
            enter;
        std::cout << "wrong : ";
        for (ll i : wr) out(i)
            enter;
        std::cout << "correct : ";
        for (ll i : cor) out(i)
            enter;
        return false;
    }
    else return true;
}

void s1nmeee() {
    //while (generator()) {}
    ll n, m, k, Q;
    std::cin >> n >> m >> k >> Q;
    std::vector<ll> a(n);
    for (ll& i : a) std::cin >> i;
    std::sort(all(a));
    auto dbla = a;
    ll l = -1e12, r = 1e12;
    while (r - l > 1) {
        ll mid = (l + r) >> 1;
        ll sum = 0;
        for (ll i = 0; i < n; i++) sum += std::max(0ll, a[i] - mid);
        if (m > sum) r = mid; else l = mid;
    }
    ll ind = -1;
    for (ll i = 0; i < n; i++) if (a[i] < r) ind = i; else break;
    for (ll i = ind + 1; i < n; i++) m -= std::max(0ll, a[i] - r), a[i] = r;
    while (m > 0) {
        for (ll i = n - 1; m > 0; i--, m--) a[i]--;
    }
    std::sort(all(a));
    for (ll& i : a) out(i)
        enter;
    a = dbla;
    while (Q--) {
        char t;
        ll x;
        std::cin >> t >> m >> k >> x;
        x--;
        l = -1e12, r = 1e12;
        while (r - l > 1) {
            ll mid = (l + r) >> 1;
            ll sum = 0;
            for (ll i = 0; i < n; i++) sum += std::max(0ll, a[i] - mid);
            if (m > sum) r = mid; else l = mid;
        }
        ll ind = -1;
        for (ll i = 0; i < n; i++) if (a[i] < r) ind = i; else break;
        if (x <= ind) {
            oute(a[x]);
            continue;
        }
        for (ll i = ind + 1; i < n; i++) m -= std::max(0ll, a[i] - r);
        oute((x >= n - m ? r - 1 : r))
    }
    
}

signed main() {
    std::cin.tie(nullptr), std::ios::sync_with_stdio(false);
    ll TT = 1;
    //std::cin >> TT;
    while (TT--) {
        s1nmeee();
        std::cout << '\n';
    }
}