#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <random>
#include <chrono>
#include <time.h>

//#pragma GCC optimize("O3")

#define out(x) std::cout << x << ' ';
#define oute(x) std::cout << x << '\n';
#define enter std::cout << '\n';
#define all(x) x.begin(), x.end()
using ll = long long;

std::mt19937 rng(std::chrono::steady_clock::now().time_since_epoch().count());

ll correct(ll n, ll m, ll k, ll x, std::vector<ll> a) {
    while (m--) {
        std::sort(all(a));
        for (ll i = n - 1; i > n - 1 - k; i--) a[i]--;
    }
    std::sort(all(a));
    return a[x - 1];
}

ll wrong(ll n, ll m, ll k, ll x, std::vector<ll> a) {
    x--;
    std::sort(all(a));
    ll l = -1e12, r = 1e12;
    while (r - l > 1) {
        ll mid = (l + r) >> 1;
        ll sum = 0;
        for (ll i = 0; i < n; i++) sum += std::max(0ll, a[i] - mid);
        if (m > sum) r = mid; else l = mid;
    }
    ll ind = -1;
    for (ll i = 0; i < n; i++) if (a[i] < r) ind = i; else break;
    if (x <= ind) {
        return a[x];
    }
    for (ll i = ind + 1; i < n; i++) m -= std::max(0ll, a[i] - r);
    return (x > ind + m ? r : r - 1);
}

bool generator() {
    ll mod1 = 10, mod2 = 200;
    ll n = rng() % mod1 + 1, m = rng() % mod2, k = 1, x = rng() % n + 1;
    std::vector<ll> a(n);
    for (ll i = 0; i < n; i++) a[i] = (rng() % mod1) * std::pow(-1, rng() % 2);
    auto wr = wrong(n, m, k, x, a), cor = correct(n, m, k, x, a);
    if (wr != cor) {
        out(n) out(m) out(k) oute(x);
        std::cout << "a : ";
        for (ll i : a) out(i)
            enter;
        std::cout << "wrong : " << wr << '\n';
        std::cout << "correct : " << cor << '\n';
        return false;
    }
    else return true;
}

void s1nmeee() {
    /*while (generator()) {
        oute("no")
    }
    return;*/
    ll n, m, k, Q;
    std::cin >> n >> m >> k >> Q;
    std::vector<ll> a(n);
    for (ll& i : a) std::cin >> i;
    std::sort(all(a));
    auto dbla = a;
    ll l = -1e12, r = 1e12;
    while (r - l > 1) {
        ll mid = (l + r) >> 1;
        ll sum = 0;
        for (ll i = 0; i < n; i++) sum += std::max(0ll, a[i] - mid);
        if (m > sum) r = mid; else l = mid;
    }
    ll ind = -1;
    for (ll i = 0; i < n; i++) if (a[i] < r) ind = i; else break;
    for (ll i = ind + 1; i < n; i++) m -= std::max(0ll, a[i] - r), a[i] = r;
    while (m > 0) {
        for (ll i = n - 1; m > 0; i--, m--) a[i]--;
    }
    std::sort(all(a));
    for (ll& i: a) out(i)
        enter;
    a = dbla;
    std::vector<ll> pref(n);
    pref[0] = a[0];
    for (ll i = 1; i < n; i++) pref[i] = pref[i - 1] + a[i];
    while (Q--) {
        char t;
        ll x;
        std::cin >> t >> m >> k >> x;
        x--;
        l = -1e12, r = 1e12;
        while (r - l > 1) {
            ll mid = (l + r) >> 1;
            ll sum = 0;
            ll i = std::lower_bound(all(a), mid) - a.begin();
            //for (ll i = 0; i < n; i++) sum += std::max(0ll, a[i] - mid);
            sum = pref[n - 1] - (i != 0 ? pref[i - 1] : 0) - mid * (n - i);
            if (m > sum) r = mid; else l = mid;
        }
        ll ind = std::lower_bound(all(a), r) - a.begin() - 1;
        if (x <= ind) {
            oute(a[x]);
            continue;
        }
        m -= pref[n - 1] - (ind != -1 ? pref[ind] : 0) - r * (n - ind - 1);
        //for (ll i = ind + 1; i < n; i++) m -= std::max(0ll, a[i] - r);
        oute((x > ind + m ? r : r - 1))
    }
}

signed main() {
    std::cin.tie(nullptr), std::ios::sync_with_stdio(false);
    ll TT = 1;
    //std::cin >> TT;
    while (TT--) {
        s1nmeee();
        std::cout << '\n';
    }
}