#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const __int128 INF = 1e18;
const __int128 MOD = 1e9 + 7;

mt19937 rnd(92343024);

struct node {
    __int128 x;
    __int128 y;
    __int128 val;
    __int128 sz;
    node* left;
    node* right;

    node(__int128 __x) {
        x = __x;
        y = rnd() % 1000000000;
        val = __x;
        sz = 1;
        left = nullptr;
        right = nullptr;
    }
};

__int128 get_val(node* v) {
    if (v == nullptr) {
        return 0;
    }
    return v->val;
}
__int128 get_sz(node* v) {
    if (v == nullptr) {
        return 0;
    }
    return v->sz;
}

void update(node* v) {
    if (v == nullptr) {
        return;
    }
    v->val = get_val(v->left) + get_val(v->right) + v->x;
    v->sz = get_sz(v->left) + get_sz(v->right) + 1;
}

node* merge(node* root1, node* root2) {
    if (root1 == nullptr) {
        return root2;
    }
    if (root2 == nullptr) {
        return root1;
    }
    if (root1->y > root2->y) {
        root1->right = merge(root1->right, root2);
        update(root1);
        return root1;
    } else {
        root2->left = merge(root1, root2->left);
        update(root2);
        return root2;
    }
}

pair<node*, node*> split(node* root, ll x) {
    if (root == nullptr) {
        return { nullptr, nullptr };
    }
    if (root->x >= x) {
        auto [root1, root2] = split(root->left, x);
        root->left = root2;
        update(root);
        return { root1, root };
    } else {
        auto [root1, root2] = split(root->right, x);
        root->right = root1;
        update(root);
        return { root, root2 };
    }
}

pair<node*, node*> split_k(node* root, ll k) {
    if (root == nullptr) {
        return { nullptr, nullptr };
    }
    if (get_sz(root->left) >= k) {
        auto [root1, root2] = split_k(root->left, k);
        root->left = root2;
        update(root);
        return { root1, root };
    } else {
        auto [root1, root2] = split_k(root->right, k - get_sz(root->left) - 1);
        root->right = root1;
        update(root);
        return { root, root2 };
    }
}

node* insert(node* root, __int128 x) {
    auto [root1, root3] = split(root, x);
    node* root2 = new node(x);
    return merge(root1, merge(root2, root3));
}

node* erase(node* root, __int128 x) {
    auto [root1, root23] = split(root, x);
    auto [root2, root3] = split(root23, x + 1);
    if (root2 == nullptr) {
        return merge(root1, merge(root2, root3));
    }
    auto roota = root2->left;
    auto rootb = root2->right;
    delete root2;
    return merge(root1, merge(merge(roota, rootb), root3));
}

int main(int, char**) {
#ifdef DEBUGMB
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    ll _n, _m, _k, _q;
    cin >> _n >> _m >> _k >> _q;
    __int128 n, m, k, q;
    n = _n;
    m = _m;
    k = _k;
    q = _q;
    vector<__int128> a(n);
    vector<__int128> p(n + 1, 0);
    node* root = nullptr;
    for (ll i = 0; i < n; ++i) {
        ll x;
        cin >> x;
        a[i] = x;
        root = insert(root, a[i]);
    }
    auto b = a;
    sort(b.begin(), b.end());
    for (ll i = 0; i < n; ++i) {
        p[i + 1] = p[i] + b[i];
    }
    // for (ll i = 0; i < n; ++i) {
    //     cerr << b[i] << " ";
    // }
    // cerr << endl;

    __int128 L = -1e10;
    __int128 R = 1e10;
    while (R - L > 1) {
        __int128 M = (L + R) / 2;
        __int128 cnt = 0;

        auto [root1, root23] = split(root, M);
        auto [root2, root3] = split(root23, M + m);
        cnt += m * get_sz(root3);
        cnt += get_val(root2) - M * get_sz(root2);

        root = merge(root1, merge(root2, root3));

        if (cnt >= m * k) {
            L = M;
        } else {
            R = M;
        }
    }
    // cerr << L << endl;
    __int128 cnt = 0;

    // ll it1 = lower_bound(a.begin(), a.end(), L) - a.begin();
    // ll it2 = lower_bound(a.begin(), a.end(), L + m) - a.begin();
    // cnt += m * (n - it2);
    // cnt += (p[it2] - p[it1]) - L * (it2 - it1);


    for (ll i = n - 1; i >= 0; --i) {
        if (b[i] <= L) continue;
        cnt += min((__int128)m, b[i] - L);
        b[i] -= min((__int128)m, b[i] - L);
    }
    sort(b.begin(), b.end());

    __int128 danger = lower_bound(b.begin(), b.end(), L) - b.begin();
    __int128 it = danger;
    while (cnt > m * k) {
        b[it++]++;
        cnt--;
    }
    sort(b.begin(), b.end());
    for (ll i = 0; i < n; ++i) {
        cout << (ll)b[i] << " ";
    }
    cout << endl;


    while (q--) {
        ll t;
        cin >> t;
        if (t == 2) {
            ll x, y;
            cin >> x >> y;
            x--;
            root = erase(root, a[x]);
            a[x] = y;
            root = insert(root, a[x]);
        } else if (t == 1) {
            ll _x;
            cin >> _m >> _k >> _x;
            __int128 x;
            m = _m;
            k = _k;
            x = _x;
            x--;
            __int128 L = -1e10;
            __int128 R = 1e10;
            while (R - L > 1) {
                __int128 M = (L + R) / 2;
                __int128 cnt = 0;

                auto [root1, root23] = split(root, M);
                auto [root2, root3] = split(root23, M + m);
                cnt += m * get_sz(root3);
                cnt += get_val(root2) - M * get_sz(root2);

                root = merge(root1, merge(root2, root3));

                if (cnt >= m * k) {
                    L = M;
                } else {
                    R = M;
                }
            }

            __int128 cnt = 0;
            auto [root1, root23] = split(root, L);
            auto [root2, root3] = split(root23, L + m + 1);

            cnt += m * get_sz(root3);
            cnt += get_val(root2) - L * get_sz(root2);

            __int128 last = get_sz(root1) + get_sz(root2);
            if (x < get_sz(root1)) {
                auto [roota, rootbc] = split_k(root1, x);
                auto [rootb, rootc] = split_k(rootbc, 1);
                cout << (ll)get_val(rootb) << "\n";
                root1 = merge(roota, merge(rootb, rootc));
            } else if (x < last) {
                cout << (ll)L + (x >= last - (cnt - m * k) ? 1 : 0) << "\n";
            } else {
                auto [roota, rootbc] = split_k(root1, x);
                auto [rootb, rootc] = split_k(rootbc, 1);
                cout << (ll)(get_val(rootb) - m) << "\n";
                root1 = merge(roota, merge(rootb, rootc));
            }

            root = merge(root1, merge(root2, root3));
        } else {
            ll _l, _r;
            cin >> _m >> _k >> _l >> _r;
            __int128 l, r;
            m = _m;
            k = _k;
            l = _l;
            r = _r;
            l--;
            __int128 L = -1e10;
            __int128 R = 1e10;
            while (R - L > 1) {
                __int128 M = (L + R) / 2;
                __int128 cnt = 0;

                auto [root1, root23] = split(root, M);
                auto [root2, root3] = split(root23, M + m);
                cnt += m * get_sz(root3);
                cnt += get_val(root2) - M * get_sz(root2);

                root = merge(root1, merge(root2, root3));

                if (cnt >= m * k) {
                    L = M;
                } else {
                    R = M;
                }
            }

            __int128 cnt = 0;
            auto [root1, root23] = split(root, L);
            auto [root2, root3] = split(root23, L + m + 1);

            cnt += m * get_sz(root3);
            cnt += get_val(root2) - L * get_sz(root2);

            __int128 last = get_sz(root1) + get_sz(root2);
            __int128 sz1 = get_sz(root1);
            __int128 sz2 = get_sz(root2);
            __int128 sz3 = get_sz(root3);
            __int128 ans = 0;
            if (l < get_sz(root1)) {
                auto [roota, rootbc] = split_k(root1, l);
                auto [rootb, rootc] = split_k(rootbc, min(r - l, sz1 - l));
                ans += get_val(rootb);
                root1 = merge(roota, merge(rootb, rootc));
            }
            __int128 mid = last - (cnt - m * k);
            __int128 tl = max(l, get_sz(root1)) - get_sz(root1);
            __int128 tr = min(r, mid) - get_sz(root1);
            if (tl < tr) {
                auto [roota, rootbc] = split_k(root2, tl);
                auto [rootb, rootc] = split_k(rootbc, tr - tl);
                ans += L * get_sz(rootb);
                root2 = merge(roota, merge(rootb, rootc));
            }

            tl = max(l, mid) - mid;
            tr = min(r, last) - mid;
            if (tl < tr) {
                auto [roota, rootbc] = split_k(root2, tl);
                auto [rootb, rootc] = split_k(rootbc, tr - tl);
                ans += (L + 1) * get_sz(rootb);
                root2 = merge(roota, merge(rootb, rootc));
            }

            tl = max(l, last) - last;
            tr = min(r, n) - last;
            if (tl < tr) {
                auto [roota, rootbc] = split_k(root3, tl);
                auto [rootb, rootc] = split_k(rootbc, tr - tl);
                ans += get_val(rootb) - m * get_sz(rootb);
                root3 = merge(roota, merge(rootb, rootc));
            }

            root = merge(root1, merge(root2, root3));
            cout << (ll)ans << "\n";
        }
    }


    return 0;
}
