#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void build(ll v, vector<pair<ll, ll>> &st, vector<ll> &a, ll l, ll r) {
    if (l == r) {
        st[v] = {a[l], l};
        return;
    }
    ll mid = (l + r) / 2;
    build(v * 2, st, a, l, mid);
    build(v * 2 + 1, st, a, mid + 1, r);
    st[v] = max(st[v * 2], st[v * 2 + 1]);
}

auto maxx(pair<ll, ll> &a, pair<ll, ll> &b) {
    if (a.first > b.first) return a;
    else if (a.first < b.first) return b;
    else if (a.second < b.second) return a;
    else return b;
}

auto get(ll v, vector<pair<ll, ll>> &st, ll lt, ll rt, ll lq, ll rq) {
    if (lt == lq && rt == rq) {
        return st[v];
    }
    ll mid = (lt + rt) / 2;
    if (rq <= mid) {
        return get(v * 2, st, lt, mid, lq, rq);
    }
    if (lq > mid) {
        return get(v * 2 + 1, st, mid + 1, rt, lq, rq);
    }
    auto m1 = get(v * 2, st, lt, mid, lq, mid);
    auto m2 = get(v * 2 + 1, st, mid + 1, rt, mid + 1, rq);
    return maxx(m1, m2);
}

void update(ll v, vector<pair<ll, ll>> &st, ll lt, ll rt, ll pos, ll val) {
    if (lt == rt) {
        st[v] = {val, pos};
        return;
    }
    ll mid = (lt + rt) / 2;
    if (pos <= mid) {
        update(v * 2, st, lt, mid, pos, val);
    } else {
        update(v * 2 + 1, st, mid + 1, rt, pos, val);
    }
    st[v] = maxx(st[v * 2], st[v * 2 + 1]);
}
void solve() {
    ll n, m, k, q;
    cin >> n >> m >> k >> q;
    vector<ll> a(n);
    for (ll &i : a) cin >> i;
    vector<pair<ll, ll>> st(4 * n);
    build(1, st, a, 0, n - 1);
    while (m--) {
        auto [x, pos] = st[1];
        update(1, st, 0, n - 1, pos, x - 1);
    }
    vector<ll> ans;
    for (ll i = 0; i < n; i++) {
        auto [x, pos] = st[1];
        update(1, st, 0, n - 1, pos, -1e18);
        ans.push_back(x);
    }
    sort(ans.begin(), ans.end());
    for (ll i : ans) cout << i << ' ';
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
}

