#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define ld long double
#define F first
#define S second
mt19937 rnd(100);

namespace dd {
    struct Node {
        Node *L, *R;
        ll c, y, v, sum;

        Node(ll _v) {
            L = R = nullptr;
            c = 1;
            y = rnd();
            v = sum = _v;
        }
    };

    ll sz(Node *r) {
        return r ? r->c : 0;
    }

    ll su(Node *r) {
        return r ? r->sum : 0;
    }

    void update(Node *r) {
        r->c = sz(r->L) + 1 + sz(r->R);
        r->sum = su(r->L) + r->sum + su(r->R);
    }

    pair<Node *, Node *> split(Node *r, ll k) {
        if (!r)
            return {nullptr, nullptr};

        if (sz(r->L) >= k) {
            auto p = split(r->L, k);
            r->L = p.second;
            update(r);
            return {p.first, r};
        }

        auto p = split(r->R, k - sz(r->L) - 1);
        r->R = p.first;
        update(r);
        return {r, p.second};
    }

    Node *merge(Node *r1, Node *r2) {
        if (!r1)
            return r2;

        if (!r2)
            return r1;

        if (r1->y > r2->y) {
            r1->R = merge(r1->R, r2);
            update(r1);
            return r1;
        }

        r2->L = merge(r1, r2->L);
        update(r2);
        return r2;
    }

    ll get(Node *r, ll ind) {
        auto pl = split(r, ind);
        auto pr = split(pl.second, 1);
        ll ans = pr.first->v;
        r = merge(merge(pl.first, pl.second), pr.second);
        return ans;
    }

    void insert(Node *r, ll val) {
        auto p = split(r, val);
        r = merge(merge(p.first, new Node(val)), p.second);
    }

    void cut(Node *r, ll L, ll R) {
        auto pl = split(r, L);
        auto pr = split(pl.second, R - L);
        r = merge(pl.first, pr.second);
    }
}

vector<ll> pref;

ll sum(ll l, ll r) {
    return pref[r] - pref[l];
}

const ll inf = 1'000'000'000'000ll;

vector<ll> solve(vector<ll> arr, ll k, ll m) {
    ll n = arr.size();
    sort(arr.begin(), arr.end());
    pref.resize(n + 1);
    for (int i = 0; i < n; ++i)
        pref[i + 1] = pref[i] + arr[i];

    ll l = -inf, r = inf, mid, dop, last;
    while (r - l > 1) {
        mid = (r + l) / 2;

        ll ost = k;
        ll hh = LLONG_MIN;
        vector<ll> newarr = arr;
        for (int i = n - 1; i >= 0; --i) {
            if (arr[i] - m >= mid) {
                ost--;
                continue;
            }

            if (hh == LLONG_MIN)
                hh = ost * m;

            hh -= max(0ll, arr[i] - mid);
        }

        if (ost < 0 || hh < 0)
            l = mid;
        else
            r = mid, dop = hh, last = k - ost;
    }

    for (int i = n - 1; i > n - 1 - last; --i)
        arr[i] -= m;

    for (int i = n - 1 - last; i >= 0; --i)
        arr[i] = min(arr[i], r);

    for (int i = 0; i < n && dop; ++i)
        if (arr[i] == r)
            arr[i]--, dop--;

    return arr;
}

void gen(vector<ll> &arr, ll &m, ll &k) {
    arr.resize(rnd() % 4 + 2);
    for (ll &i: arr)
        i = rnd() % 5;

    k = rnd() % 3;
    m = rnd() % 5;
    sort(arr.begin(), arr.end());
}

vector<ll> correct(vector<ll> arr, ll k, ll m) {
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < k; ++j)
            arr[arr.size() - j - 1]--;

        sort(arr.begin(), arr.end());
    }

    return arr;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    ll n, m, k, q, t, x;
    vector<ll> arr;


    cin >> n >> m >> k >> q;
    arr.resize(n);
    pref.resize(n + 1);
    for (int i = 0; i < n; ++i)
        cin >> arr[i];

    sort(arr.begin(), arr.end());
    auto arr1 = solve(arr, k, m);
    for (ll i: arr1)
        cout << i << ' ';

    cout << '\n';
    cout << '\n';
    while (q--) {
        cin >> t;
        if (t == 1) {
            cin >> m >> k >> x, x--; // Иксовая порядковая статистика при m вычитаниях по k

            ll can = m, dop;
            ll l = -inf, r = inf, mid;
            while (r - l > 1) {
                mid = (r + l) / 2;
                ll l1 = -1, r1 = n, mid1;
                while (r1 - l1 > 1) {
                    mid1 = (r1 + l1) / 2;
                    if (arr[mid1] <= mid)
                        l1 = mid1;
                    else
                        r1 = mid1;
                }

                ll need = sum(r1, n) - mid * (n - r1);
                if (need > can)
                    l = mid;
                else
                    r = mid, dop = can - need;
            }

            ll will = r;

            l = -1, r = n;
            while (r - l > 1) {
                mid = (r + l) / 2;
                if (arr[mid] <= will - 1)
                    l = mid;
                else
                    r = mid;
            }

            if (x <= l)
                cout << arr[x] << '\n';
            else
                cout << will - (x <= l + dop) << '\n';
        } else
            exit(-1);
    }

    return 0;


    ll _ = 1;
    while (cout << (_++) << endl) {
        gen(arr, m, k);

        auto my = solve(arr, k, m);
        auto need = correct(arr, k, m);
        if (my != need) {
            cout << "\n\n\n" << arr.size() << ' ' << m << ' ' << k << ' ' << 0 << '\n';
            for (ll i: arr)
                cout << i << ' ';

            cout << "\n\n\n";
            for (ll i: my)
                cout << i << ' ';

            cout << '\n';
            for (ll i: need)
                cout << i << ' ';
            cout << "\n";
            return 0;
        }
    }
}

/*
2 2 2 0
2 3



8 3 2 0
-1 -1 0 1 2 2 3 4

-1 -1 0 1 1 2 1 1

*/
/*

*/
/*
Понижаем последние k пока первый из них не станет равным числу перед ними.
Всегда есть группа первых какой-то длинны.
Совершаем минимальное количество операций чтобы либа группа первых увеличилась слева, либо справа.

*/
/*

*/
/*

*/
/*


*/
/*


*/